/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  91058 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

#define ALL	~0L
#define LAMBDA	1
#define E     	2
#define MUE_INV	4
#define RHO   	8
#define MVZ   	16
#define MAA   	32
#define MWZ   	64
#define MWSL  	128

#define STR_TREN	':'
#define SPEZ_TREN	','
#define KEY1		"Klasse"
#define KEY2		"Knoten"
#define KEY3		"lambda"
#define KEY4		"E"
#define KEY5		"1/mue"
#define KEY6		"rho"
#define KEY7		"mvz"
#define KEY8		"maa"
#define KEY9		"mwz"
#define KEY10		"mwsl"

#define BARW	30
#define BARO	25

/* wieviele ausgabedateien auf einmal im speicher halten */
#define MAX 1
/* puffergroesse fuer eine zeile einlesen */
#define BUFSIZE	512
/* trennzeichen in der ausgabedatei zwischen knotennamen und daten */
#define TRENNER '|'
/* maximale anzahl von datensets fuer xgadd */
#define MAXD 8

/* datentyp boolean 0 = false, 1 = true */
typedef int BOOL;
#define FALSE 0
#define TRUE  1

/* charakteristische netzgroessen (fuer jede auftragsklasse) */
struct char_netz {
	double	lambda;
	double	mvz;
	double	maa;
} ;

typedef struct char_netz CHNG;

/* gesamtleistungsgroessen (fuer jeden knoten, nur bei mehreren klassen) */
struct gesamtleistung {
	double	lambda;
	double	rho;
	double	maa;
} ;

typedef struct gesamtleistung GELG;

/* konkrete daten fuer einen knoten einer klasse */
struct knoten_typ {
	char	*kn_name;
	double	lambda;
	double	e;
	double	mue_inv;
	double	rho;
	double	mvz;
	double	maa;
	double	mwz;
	double	mwsl;
} ;

typedef struct knoten_typ KNOT;

/* alle daten fuer eine auftragsklasse */
struct klassen_typ {
	int	kl_nr;			/* nummer dieser klasse */
	int	knot_anz;		/* anzahl der knoten */
	KNOT	*knoten;	/* knotendaten einer klasse */
	CHNG	ch_ng;		/* char. netzgroessen */
} ;

typedef struct klassen_typ KLAS;

/* alle daten fuer eine spezielle ausgabedatei */
struct ausdat_typ {
	char	*verfahren_name;	/* name des verfahrens */
	char	*eingabe_datei;		/* name der eingabedatei */
	char	*ausgabe_datei;		/* name der ausgabedatei */
	int	klas_anz;				/* anzahl der klassen */
	KLAS	*klassen;			/* klassendaten */
	GELG	*gesamt_lg;			/* gesamtleistungsgroessen */
	BOOL	param_var;			/* flag ob parametervariation */
	double	param_wert;			/* aktueller wert bei variation */
	char	*param_string;		/* beschreibung des variierten wertes */
} ;	

typedef struct ausdat_typ DATEI;
