/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  D-91058 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

#ifndef DKONST_H
#define DKONST_H

static char *SccsDKonst_h = "@(#)PEPSY:\td_konst.h\t1.8\t95/05/22 10:47:10";

#ifndef TRUE
#define TRUE		1	/* Bool'sche Variablen		*/	
#define FALSE		0	/* 	"		"	*/	
#endif

#define NAM_LAENGE	1020	/* Laenge von Dateinamen	*/
#define LAENGE		1020	/* Laenge von Dateinamen	*/

#define	GESCHLOSSEN	01	/* Geschlossenes Netz		*/
#define	OFFEN		02	/* Offenes Netz			*/
#define	GEMISCHT	04	/* Gemischtes Netz		*/

#define	TYP1	00000001	/* Knotentyp: M/M/1-FCFS 	*/
#define	TYP2	00000002	/* Knotentyp: M/M/m-FCFS 	*/
#define	TYP3	00000004	/* Knotentyp: M/G/1-PS 		*/
#define	TYP4	00000010	/* Knotentyp: M/G/0-IS 		*/
#define	TYP5	00000020	/* Knotentyp: M/G/1-FCFS	*/
#define	TYP6	00000040	/* Knotentyp: M/G/m-FCFS	*/
#define	TYP7	00000100	/* Knotentyp: G/G/1-FCFS	*/
#define	TYP8	00000200	/* Knotentyp: G/G/m-FCFS	*/
#define	TYP9	00000400	/* Knotentyp: M/G/1-LCFS-PRE	*/
#define	TYP10	00001000	/* Knotentyp: M/M/1-FCFS-PRE 	*/
#define	TYP11	00002000	/* Knotentyp: M/M/1-FCFS-NONPRE	*/
#define	TYP12	00004000	/* Knotentyp: M/G/m-PS */
#define	TYP13	00010000	/* Knotentyp: G/G/m-PS */
#define	TYP14	00020000	/* Knotentyp: M/G/1-FCFS-PRE 	*/
#define	TYP15	00040000	/* Knotentyp: M/G/1-FCFS-NONPRE	*/
#define	TYP16	00100000	/* Knotentyp: M/M/m-FCFS-PRE	*/
#define	TYP17	00200000	/* Knotentyp: M/M/m-FCFS-NONPRE	*/
#define	TYP18	00400000	/* Knotentyp: M/G/m-FCFS-PRE	*/
#define	TYP19	01000000	/* Knotentyp: M/G/m-FCFS-NONPRE	*/
#define	TYP20	02000000	/* Knotentyp: M/M/m-FCFS-ASYM	*/
#define	TYP21	04000000	/* Knotentyp: M/G/m-FCFS-ASYM	*/

#define TYP_PF	TYP1|TYP2|TYP3|TYP4|TYP9 /* Produktform-Knotentypen	*/

#define	MM1_FCFS		1
#define	MMm_FCFS		2
#define	MG1_PS			3
#define	MG0_IS			4
#define	MG1_FCFS		5
#define	MGm_FCFS		6
#define	GG1_FCFS		7
#define	GGm_FCFS		8
#define	MG1_LCFS_PRE		9
#define	MM1_LCFS_PRE		10
#define	MM1_FCFS_NONPRE		11
#define	MGm_PS			12
#define	GGm_PS			13
#define	MG1_FCFS_PRE		14
#define	MG1_FCFS_NONPRE		15
#define	MMm_FCFS_PRE		16
#define MMm_FCFS_NONPRE		17
#define	MGm_FCFS_PRE		18
#define	MGm_FCFS_NONPRE		19
#define	MMm_FCFS_ASYM		20
#define	MGm_FCFS_ASYM		21
#define ANZAHL_KNOTENTYPEN	MGm_FCFS_ASYM

#define V_JA			0x1	/* Verfahren anwendbar		*/
#define V_NEIN			0x2	/* Verfahren nicht anwendbar	*/
#define V_VIELLEICHT		0x4	/* Verfahren vielleicht anwendbar*/


#ifdef EXTERN_KNOTENTYPEN
extern char	*knotentypen[];
#else

#define EXTERN_KNOTENTYPEN

char *knotentypen[ANZAHL_KNOTENTYPEN+1] =
{
	"???",
	"M/M/1-FCFS",
	"M/M/m-FCFS",
	"M/G/1-PS",
	"M/G/0-IS",
	"M/G/1-FCFS",
	"M/G/m-FCFS",
	"G/G/1-FCFS",
	"G/G/m-FCFS",
	"M/G/1-LCFS-PRE",
	"M/M/1-FCFS-PRE",
	"M/M/1-FCFS-NONPRE",
	"M/G/m-PS",
	"G/G/m-PS",
	"M/G/1-FCFS-PRE",
	"M/G/1-FCFS-NONPRE",
	"M/M/m-FCFS-PRE",
	"M/M/m-FCFS-NONPRE",
	"M/G/m-FCFS-PRE",
	"M/G/m-FCFS-NONPRE",
	"M/M/m-FCFS-ASYM",
	"M/G/m-FCFS-ASYM"
};
#endif
#endif





