/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#ifndef DNETZ_H
#define DNETZ_H

static char *SccsDNetz_h = "@(#)PEPSY:\td_netz.h\t1.2\t92/12/08 09:19:57";

/****************************************************************
 *  Netzgroessen fuer ein Warteschlangennetz					*
 ****************************************************************/

typedef struct 
{
	int 	typ;			/* Geschlossenes, offenes oder	    */
							/* oder gemischtes Netz  	    	*/
	int 	knot;			/* Anzahl Knoten	 	    		*/
	char    **knotname;		/* Knotennamen			    		*/
	int 	klass;			/* Anzahl Auftragskassen 	    	*/
	int 	*knotentyp;		/* Knotentyp			    		*/
	int 	*bede;			/* Anzahl Bedieneinheiten pro Knoten*/
	int 	*offen;			/* Klasse offen oder geschlossen    */
	int 	*auftr;			/* Anzahl Auftraege pro Klasse bei  */
							/* geschlossenen Netzen				*/
	double 	*ankr;			/* Ankunftsrate pro Klasse bei ge-  */
							/* mischten und offenen Netzen	    */
	double 	**bedr;			/* Bedienrate pro Knoten und Klasse */
	int		haeuf;			/* besh oder uew angegeben ?	    */
	double 	**besh; 		/* Besuchshaeufigkeiten pro Knoten  */ 
							/* und Klasse 			   			*/
	float 	***uew;			/* Uebergangswahrscheinlichkeiten   */
	double 	**quadvar;		/* Quadrierter Variationskoeffizient*/ 
	int		teilanz;		/* Anzahl der Teilnetze				*/
	int		*teilnr;		/* Zuordnung: Knoten-Teilnetz	    */
	int		*belz;			/* Belegung der Knoten mit Auftr.   */
	double	epsi;			/* Abbruchkriterium fuer Iteration  */
}
netzstruktur;

#endif
