/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

#ifndef LIBOHS_H
#define LIBOHS_H

static char *Sccslibohs_h ="@(#)PEPSY:\tlibohs.h\t1.2\t93/08/18 16:35:40";


/*
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <errno.h>
*/



#ifndef TRUE
#define TRUE  1
#define FALSE 0
#endif

#define OH_error		-1
#define OH_ok		 	0
#define OH_normal	 	1
#define OH_headline	 	2
#define OH_keyword	 	3
#define OH_bold		 	4

/* defines for aliaslist() */
#define OH_request	 	5
#define OH_add		 	6
#define OH_init			7

#define OH_more_text	8
#define OH_more_topic	9
#define OH_eohelp		10
#define OH_skip			11
/********************************************************************
*               alter these to fit your needs                       *
********************************************************************/

#define LANGUAGEENV     "PEPSYLANG"
#define HOMEPATH        "PEPSYHOME"
#define INDENTMULT      4


/********************************************************************
*					type-declarations								*
********************************************************************/



struct OH_status {
	int eohelp;	/* more help, new topic or complete end */
	int textlen;	/* Length of returned text */
	int textmode;	/* Kind of text transmitted (Keyword, Headline, */
			/* Bold, Normal,...) */
	int hldepth;	/* type of headline */
	int indent;	/* how many spaces of indent */
	int reference;	/* number of reference this part of help comes from */
};

struct OH_control {
	char c_seq;		/* Control Sequence (i.e. H, K, I, S, B or P) */
	char argument1[512];    /* Headline, Keyword, # of CR's, ... */
	char argument2[512];	/* Only used with /S */
};

struct OH_file {
	FILE *fp;
	int hl_count;
	int keyw_count;
	int max_keyw;
	long start_of_hl;
	long start_of_keyw;
	long start_of_text;
};

struct aliastype {
	char *word;
	char *alias;
	struct aliastype *next;
};

/********************************************************************
*                   function-declarations                           *
********************************************************************/

#undef	EXTERN
#ifdef	LO_OHS_ERROR_C
#define	EXTERN
#else
#define	EXTERN	extern
#endif
EXTERN	int					ohs_error_val;
EXTERN	char				*ohs_error_text;
EXTERN	char				*ohs_error( /* char* */ );
										/* additional text */

#undef	EXTERN
#ifdef	LO_INDEX_C
#define	EXTERN
#else
#define	EXTERN	extern
#endif
EXTERN	void				sortkeyw( /* char**, int */ );
										/* Keywordlist, number of entries */
EXTERN	int					getindex( /* char*, char**, struct OH_file, int */ );
										/* mask, buffer, helpfile, sort output? */


#undef	EXTERN
#ifdef	LO_TOC_C
#define	EXTERN
#else
#define	EXTERN	extern
#endif
EXTERN	int					gettoc( /* char*, char**, int *, struct OH_file, int */ );
									/* mask, buffer for hl, buffer for hldepth, helpfile, sort ? */
EXTERN	void				sorthl( /* char**, int*, int */ );
									/* headlinelist, hldepthlist, number of entries */

#undef	EXTERN
#ifdef	LO_ALIASLIST_C
#define	EXTERN
#else
#define	EXTERN	extern
#endif
EXTERN	int 				aliaslist( /* char*, char*, int */ );
										/* alias, word, mode */

#undef	EXTERN
#ifdef	LO_INITHELP_C
#define	EXTERN
#else
#define	EXTERN	extern
#endif
EXTERN	void				inithelp();

#undef	EXTERN
#ifdef	LO_GETREFERENCES_C
#define	EXTERN
#else
#define	EXTERN	extern
#endif
EXTERN	int					getreferences( /* char*, struct OH_file */ );
											 /* keyword, helpfile */

#undef	EXTERN
#ifdef	LO_OPENHELP_C
#define	EXTERN
#else
#define	EXTERN	extern
#endif
EXTERN	struct OH_file		openhelp( /* char* */ );
									/*  (helpfile) , returns handle of Helpfile */

#undef	EXTERN
#ifdef	LO_READHELP_C
#define	EXTERN
#else
#define	EXTERN	extern
#endif
EXTERN	struct OH_status	readhelp( /* char*, char*, int, int, struct OH_file */ );
										/*  (helpword, buffer, buflen, mode, helpfile)  */

#undef	EXTERN
#ifdef	LO_CLOSEHELP_C
#define	EXTERN
#else
#define	EXTERN	extern
#endif
EXTERN	int					closehelp( /* struct OH_file */ );
										/* helpfile */

#undef	EXTERN
#ifdef	LO_CONVERT_C
#define	EXTERN
#else
#define	EXTERN	extern
#endif
EXTERN	int					convert( /* char**, char* */ );
										/* list of filenames, helpfilename */

#undef	EXTERN
#ifdef	LO_LIBMISC_C
#define	EXTERN
#else
#define	EXTERN	extern
#endif
EXTERN	char				dtoupper( /* c */ );
										/* character to convert */
EXTERN	struct OH_control	get_c_seq( /* FILE* */ );
										/* file to read from */
EXTERN	int					get_until( /* FILE*, char*, char* */ );
										/* file to read from, buffer, bracket */
EXTERN	int					searchheadline( /* char*, struct OH_file */ );
											/* headline, helpfile */
EXTERN	int					searchkeyword( /* char*, struct OH_file */ );
											/* keyword, helpfile */


#undef	EXTERN
#ifdef	LO_ALIASLIST_C
#define	EXTERN
#else
#define	EXTERN	extern
#endif
EXTERN	int					aliaslist( /* char*, char*, int */ );


#endif
