/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define LE_GET_ANKR_C

static char *SccsId = "@(#)PEPSY:\tget_ankr.c\t1.5\t93/06/25 10:56:51";

#include "d_pepsy.h"
#include "d_netz.h"
#define	EXTERN_KNOTENTYPEN
#include "d_konst.h"
#include "libpepsy.h"

extern netzstruktur netz;	/* Eingabedatenstruktur			     */

/*
   get_ankr() --- aufgerufen von eingabe() (eingabe.c)                      
   Eingabe der Ankunftsraten pro Klasse                       	       	      
 */

void get_ankr()
{
	short r;


	status("get_ankr");
	werase(win3); 	/* Fenster 3 loeschen */


	/*
		Formular erstellen
	*/

	mvwaddstr(win3,2,8,spr("ankr01"));
	for (r=0;r<netz.klass;r++)
	{
  		wmove(win3,4 + r,8);
  		wprintw(win3,"%s %1d: ",spr("ankr02"),r + 1);
  		wmove(win3,4 + r,21);

  		/* Falls gemischtes Netz: geschlossene Klassen mit 0 vorbesetzen */
  		if (netz.typ == GEMISCHT)
  		{
    		if (netz.offen[r] == TRUE)
				waddstr(win3,"......");
    		else
				waddstr(win3,"   -   ");
  		}
  		else
    		waddstr(win3,"......");
	}
	wrefresh(win3);

	/*
		Eingaben einlesen
	*/

	for (r=0;r<netz.klass;r++)
	{
  		wmove(win3,4 + r,21);
  		wrefresh(win3);

	 	 /* Falls gemischtes Netz: nur bei offenen Klassen Eingabe */
  		if (netz.typ == GEMISCHT)
  		{
			if (netz.offen[r] == TRUE)
			{
				/* Der Benutzer gibt die Ankunftsraten pro Klasse ein      */

				netz.ankr[r] = l_double(netz.ankr[r],0,0.0,DOUBLE_MAX,6);
				wmove(win3,4 + r,21);
				wprintw(win3,"%6.3lf",netz.ankr[r]);
				wrefresh(win3);
			}
  		}
 		else
  		{
			/* Der Benutzer gibt die Ankunftsraten pro Klasse ein      */

 	  		netz.ankr[r] = l_double(netz.ankr[r],0,0.001,DOUBLE_MAX,6);
    		mvwprintw(win3,4 + r,21,"%6.3lf",netz.ankr[r]);
    		wrefresh(win3);
  		}
	}
} /* get_ankr(...) */
