/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define LE_GET_AUFTR_C

static char *SccsId = "@(#)PEPSY:\tget_auftr.c\t1.6\t93/06/25 10:56:52";

#include "d_pepsy.h"
#include "d_netz.h"
#define EXTERN_KNOTENTYPEN
#include "d_konst.h"
#include "libpepsy.h"

extern netzstruktur netz;	/* Eingabedatenstruktur			     */

/*
   get_auftr() --- aufgerufen von eingabe() (eingabe.c)                     
   Eingabe der Anzahl Auftraege pro Klasse                       	     
*/

void get_auftr()
{
	short r;

	status("get_auftr");
	werase(win3);				 	/* Fenster 3 loeschen */

	/*
		Formular erstellen
	*/

	mvwaddstr(win3,2,8,spr("auft01"));
	for (r=0;r<netz.klass;r++)
	{
  		mvwprintw(win3,4 + r,8,"%s %1d: ",spr("auft02"),r + 1);
  		wmove(win3,4 + r,21);
  		waddstr(win3,"..");
	}

	/*
		Eingaben einlesen
	*/

	for (r=0;r<netz.klass;r++)
	{
  		wmove(win3,4 + r,21);
  		wrefresh(win3);

  		/* Der Benutzer gibt die Anzahl Auftraege pro Klasse ein      */

  		netz.auftr[r] = l_integer(netz.auftr[r],0,0,P_INT_MAX,2);
  		mvwprintw(win3,4 + r,21,"%2d",netz.auftr[r]);

  		/* In gemischten Netzen offene und geschlossene Klassen kennzeichnen */

  		if (netz.typ == GEMISCHT )
  		{
			if( netz.auftr[r] == 0 )
			{
				netz.offen[r] = TRUE;
		  		mvwprintw(win3,4+r,21," -");
			}
			else 
			{
     			netz.offen[r] = FALSE;
 			}
		}
  		wrefresh(win3);
	}
} /* get_auftr(...) */
