/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define LE_GET_BEDR_C

static char *SccsId = "@(#)PEPSY:\tget_bedr.c\t1.4\t93/06/25 10:56:56";


#include "d_pepsy.h"
#include "d_netz.h"
#include "libpepsy.h"

extern netzstruktur netz;	/* Eingabedatenstruktur		*/

/*
   get_bedr() --- aufgerufen von eingabe() (eingabe.c)                       
 									      
   Parameter:							
 	- index : Knoten  passen nicht alle in Fenster 3, deshalb muessen   
 		  sie aufgeteilt werden. index gibt die Nummer desjenigen     
 		  Teils an, der gerade ausgegeben wird			      
                                                                            *
   Eingabe der Bedienraten				      		      
 */

void get_bedr(index)
int	index;
{
	int i,r,z;				/* Hilfsvariablen		*/

	status("get_bedr");
	werase(win3);				/* Fenster 3 loeschen */

	/*
		Formular erstellen
	*/

	mvwaddstr(win3,0,15,spr("bedr01"));

	mvwaddstr(win3,2,0,spr("bedr02"));
	for (r=0;r<netz.klass;r++)
		mvwprintw(win3,2,16 + r * 9,"%s %1d ",spr("bedr03"),r + 1);

	mvwaddstr(win3,3,0," --------------");
	for (r=0;r<netz.klass;r++)
		mvwprintw(win3,3,15 + r * 9,"----------",r + 1);

	for (z=0,i=index * MAXZEILEN + z;i<netz.knot && z < MAXZEILEN;z++,i++)
	{
		mvwprintw(win3,4 + z,2,"%-10s  |",&netz.knotname[i][0]);  
		wrefresh(win3);
	}

	for (z=0,i=index * MAXZEILEN + z;i<netz.knot && z < MAXZEILEN;z++,i++)
		for (r=0;r<netz.klass;r++)
		{
			wmove(win3,4 + z,17 + r * 9);
			waddstr(win3,".......");
			wrefresh(win3);
		}

	/* Bedienraten einlesen */

	for (z=0,i=index * MAXZEILEN + z;i<netz.knot && z < MAXZEILEN;z++,i++)
		for (r=0;r<netz.klass;r++)
		{
			wmove(win3,4 + z,17 + r * 9);
			wrefresh(win3);

			/*
				Der Benutzer gibt die Bedienraten pro Knoten und Auftragsklasse an
			*/

			while((netz.bedr[i][r] = l_double(netz.bedr[i][r],0,0.0,DOUBLE_MAX,6)) <= 0.0)
			{
				wmove(win3,4 + z,17 + r * 9);
				p_fehler(spr("bedr04"));
			}
			mvwprintw(win3,4 + z,17 + r * 9,"%7.4lf",netz.bedr[i][r]);
			wrefresh(win3);
		}
} /* get_bedr(...) */
