/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define LE_GET_BESH_C

static char *SccsId = "@(#)PEPSY:\tget_besh.c\t1.5\t93/06/25 10:56:57";


#include "d_pepsy.h"
#include "d_netz.h"
#include "libpepsy.h"

extern	netzstruktur	netz;	/* Eingabedatenstruktur		*/

/*
   get_besh() --- aufgerufen von eingabe() (eingabe.c)                       
 									      
   Parameter:								      
 	- index : Knoten  passen nicht alle in Fenster 3, deshalb muessen   
 		  sie aufgeteilt werden. index gibt die Nummer desjenigen     
 		  Teils an, der gerade ausgegeben wird			      
 									      
                                                                             
   Eingabe der Besuchshaeufigkeiten					      
 */

void get_besh(index)
int	index;
{
	int						i,r,z;	/* Hilfsvariablen		*/
	double sum;						/* Zeilensumme	*/

	status("get_besh");
	werase(win3);					/* Fenster 3 loeschen */

	/*
		Formular erstellen
	*/

	mvwaddstr(win3,0,15,spr("besh01"));

	mvwaddstr(win3,2,0,"              |");
	for (r=0;r<netz.klass;r++)
		mvwprintw(win3,2,16 + r * 9,"%s %1d ",spr("besh02"),r + 1);

	mvwaddstr(win3,3,0,"   ------------");
	for (r=0;r<netz.klass;r++)
		mvwprintw(win3,3,15 + r * 9,"---------",r + 1);

	for (z=0,i=index * MAXZEILEN + z;i<netz.knot && z < MAXZEILEN;z++,i++)
		mvwprintw(win3,4 + z, 0,"  %-10s  |",netz.knotname[i]);

	for (z=0,i=index * MAXZEILEN + z;i<netz.knot && z < MAXZEILEN;z++,i++)
		for (r=0;r<netz.klass;r++)
		{
			wmove(win3,4 + z,17 + r * 9);
			waddstr(win3,".......");
		}

	/* Beshaeufigk. einlesen */

	for (z=0,i=index * MAXZEILEN + z;i<netz.knot && z < MAXZEILEN;z++,i++)
	{
		sum = 0.0;
		for (r=0;r<netz.klass;r++)
		{
			wmove(win3,4 + z,17 + r * 9);
			wrefresh(win3);

			/*
				Der Benutzer gibt die Besuchshaeufigkeiten pro Knoten und Auftragsklasse an
			*/

			netz.besh[i][r] = l_double(netz.besh[i][r],0,0.0,DOUBLE_MAX,6);
			sum += netz.besh[i][r];
			mvwprintw(win3,4 + z,17 + r * 9,"%7.4lf",netz.besh[i][r]);
			wrefresh(win3);
		}

		if (sum == 0.0)
		{
			/* Fehlermeldung */
			werase(win4);
/*			beep();							*/
			wmove(win4,LINES-1,0);
			waddstr(win4,spr("besh03"));
			wrefresh(win4);

			/* Zeile nochmals ausfuellen */
			z -= 1;
			i -= 1;
		}
	}
} /* get_besh(...) */
