/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define LE_GET_QUADVAR_C

static char *SccsId = "@(#)PEPSY:\tget_quadvar.c\t1.4\t93/06/25 10:57:08";


#include "d_pepsy.h"
#include "d_netz.h"
#include "libpepsy.h"
#include "libein.h"


extern netzstruktur netz;	/* Eingabedatenstruktur		*/

/*
   get_quadvar() --- aufgerufen von eingabe() (eingabe.c)                    
                                                                             
   Parameter:								      
 	- index : Knoten  passen nicht alle in Fenster 3, deshalb muessen     
 		  sie aufgeteilt werden. index gibt die Nummer desjenigen     
 		  Teils an, der gerade ausgegeben wird			      
 									      
   Eingabe des quadrierten Variationskoeffizienten       		      
 */

void get_quadvar(index)
int	index;
{
	short	i,r,z;		/* Hilfsvariablen		*/


	status("get_quadvar");
	if(check_var_koeff() == TRUE) 
			/* alle Variationskoeffizienten schon besetzt */  
		return;
	werase(win3);	 /* Fenster 3 loeschen */

	/* Formular ausgeben */

	mvwaddstr(win3,0,15,spr("quad01"));

	mvwaddstr(win3,2,0,"              |");
	for (r=0;r<netz.klass;r++)
		mvwprintw(win3,2,16 + r * 9,"%s %1d ",spr("quad02"),r + 1);

	mvwaddstr(win3,3,0," --------------");
	for (r=0;r<netz.klass;r++)
		mvwprintw(win3,3,15 + r * 9,"----------",r + 1);

	for (z=0,i=index * MAXZEILEN + z;i<netz.knot && z < MAXZEILEN;z++,i++)
		mvwprintw(win3,4 + z, 1," %-10s  |",netz.knotname[i]);

	for (z=0,i=index * MAXZEILEN + z;i<netz.knot && z < MAXZEILEN;z++,i++)
		for (r=0;r<netz.klass;r++)
		{
			wmove(win3,4 + z,17 + r * 9);
			switch (netz.knotentyp[i])
			{
			case 1:	/* M/M/1-FCFS */
			case 2: /* M/M/m-FCFS */
			case 10: /* M/M/1-FCFS-PRE */
			case 11: /* M/M/1-FCFS-NONPRE */
			case 16: /* M/M/m-FCFS-PRE */
			case 17: /* M/M/m-FCFS-NONPRE */
			case 20: /* M/M/m-FCFS-ASYM */
			case 22: /* M/M/1-FESC */
				waddstr(win3," 1.0000");
				break;
			case 3: /* M/G/1-PS */
			case 4: /* M/G/0-IS */
			case 5: /* M/G/1-FCFS */
			case 6: /* M/G/m-FCFS */
			case 7: /* G/G/1-FCFS */
			case 8: /* G/G/m-FCFS */
			case 9: /* M/G/1-LCFS-PRE */
			case 12: /* M/G/m-PS(1) */
			case 13: /* M/G/m-PS(2) */
			case 14: /* M/G/1-FCFS-PRE */
			case 15: /* M/G/1-FCFS-NONPRE */
			case 18: /* M/G/m-FCFS-PRE */
			case 19: /* M/G/m-FCFS-NONPRE */
			case 21: /* M/G/m-FCFS-ASYM */
				waddstr(win3,".......");
				break;
			default:
				waddstr(win3,".......");
				break;
			}

		}

	/* Formular ausfuellen */

	for (z=0,i=index * MAXZEILEN + z;i<netz.knot && z < MAXZEILEN;z++,i++)
	{
		for (r=0;r<netz.klass;r++)
		{
			wmove(win3,4 + z,17 + r * 9);
			wrefresh(win3);

			/* Der Benutzer gibt den Variationskoeffizient pro Knoten
				und Auftragsklasse an	      */

			switch (netz.knotentyp[i])
			{
			case 1:	/* M/M/1-FCFS */
			case 2: /* M/M/m-FCFS */
			case 10: /* M/M/1-FCFS-PRE */
			case 11: /* M/M/1-FCFS-NONPRE */
			case 16: /* M/M/m-FCFS-PRE */
			case 17: /* M/M/m-FCFS-NONPRE */
			case 20: /* M/M/m-FCFS-ASYM */
			case 22: /* M/M/1-FESC */
				netz.quadvar[i][r] = 1.0;
				break;
			case 3: /* M/G/1-PS */
			case 4: /* M/G/0-IS */
			case 9: /* M/G/1-LCFS-PRE */
				netz.quadvar[i][r] = 1.0;
				break;
			case 5: /* M/G/1-FCFS */
			case 6: /* M/G/m-FCFS */
			case 7: /* G/G/1-FCFS */
			case 8: /* G/G/m-FCFS */
			case 12: /* M/G/m-PS(1) */
			case 13: /* M/G/m-PS(2) */
			case 14: /* M/G/1-FCFS-PRE */
			case 15: /* M/G/1-FCFS-NONPRE */
			case 18: /* M/G/m-FCFS-PRE */
			case 19: /* M/G/m-FCFS-NONPRE */
			case 21: /* M/G/m-FCFS-ASYM */
				netz.quadvar[i][r] = l_double(netz.quadvar[i][r],0,0.0000,DOUBLE_MAX,6);
				break;
			default:
				break;
			}
			mvwprintw(win3,4 + z,17 + r * 9,"%7.4lf",netz.quadvar[i][r]);
			wrefresh(win3);
		}
	}
} /* get_quadvar(...) */

int check_var_koeff()
{

	int i,r;
		for(i=0;i<netz.knot ; i++)
		{
			for(r=0;r<netz.klass;r++)
			{
			switch (netz.knotentyp[i])
			{
			case 1:	/* M/M/1-FCFS */
			case 2: /* M/M/m-FCFS */
			case 10: /* M/M/1-FCFS-PRE */
			case 11: /* M/M/1-FCFS-NONPRE */
			case 16: /* M/M/m-FCFS-PRE */
			case 17: /* M/M/m-FCFS-NONPRE */
			case 20: /* M/M/m-FCFS-ASYM */
			case 22: /* M/M/1-FESC */
				netz.quadvar[i][r] = 1.0;
				break;
			case 3: /* M/G/1-PS */
			case 4: /* M/G/0-IS */
			case 9: /* M/G/1-LCFS-PRE */
				netz.quadvar[i][r] = 1.0;
				break;
			default:
				return(FALSE);
				break;
			}
			}
		}
		return(TRUE);
}
