/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define LE_GET_UEW_C

static char *SccsId = "@(#)PEPSY:\tget_uew.c\t1.9\t93/06/25 10:57:10";

#include "d_pepsy.h"
#include "d_netz.h"
#define	EXTERN_KNOTENTYPEN
#include "d_konst.h"
#include "libpepsy.h"

extern netzstruktur	netz;	/* Eingabedatenstruktur					*/


/*
									
 get_teilmatrix() --- aufgerufen von get_uew() (in get_uew.c)		
									
 Parameter:								
	- x_koord : x-Koordinate der Teilmatrix				
	- y_koord : y-Koordinate der Teilmatrix				
	- klasse  : Gerade behandelte Klasse				
	- knoten  : Anzahl der Knoten					
	- sum	  : Zeilensummen-Vektor					
									
 Ausgabe und Ausfuellen des Formulars fuer die betrachtete		
 Teilmatrix								
									
*/

void get_teilmatrix(y_koord,x_koord,knoten,klasse,sum)
int	y_koord,
x_koord,
knoten,
klasse;
double	*sum;
{
	short  	x_obergrenze,		/* Obere Grenzen der x- und y-Koordina- */
	y_obergrenze;				/* ten der Teilmatrix					*/
	short	zeile,				/* Aktuelle Eingabezeile				*/
	spalte;						/* Aktuelle Spalte						*/
	short	pruef_zeile;		/* Zeile die gerade auf Summe 1 		*/
								/* geprueft wird						*/
	short	n,m;				/* Laufvariablen						*/
	double	merk;				/* Zeilensumme merken					*/

	/* Fenster 3 loeschen */

	status("get_teilmatrix");
	werase(win3);

	/* Ueberschriftzeile des Formulars (0-te Zeile)  */

	mvwaddstr(win3,0,1,spr("teil01"));
	wprintw(win3,"%s\n",spr("teil02"));
	wprintw(win3," %s ",spr("teil2a"));
	wstandout(win3);
	wprintw(win3,"%s %1d",spr("teil03"), klasse+1);
	wstandend(win3);

	/* Untere und obere Grenzen der x- und y-Koordinaten bestimmen */

	if (knoten - x_koord <= 6)
		x_obergrenze  = knoten;
	else
		x_obergrenze  = x_koord+6;

	if (knoten - y_koord <= MAXMATRIX)
		y_obergrenze  = knoten;
	else
		y_obergrenze  = y_koord+MAXMATRIX;

	/* Formular ausgeben */

	mvwaddstr(win3,3,1, spr("teil04"));
	for (n=x_koord;n<x_obergrenze;n++)
	{
		if(n==0)
		{
			wprintw(win3,spr("teil05"));
		}
		else
		{
			wprintw(win3," %-10s",netz.knotname[n-1]);
		}
	}

	mvwaddstr(win3,4,1,"-----------");
	for (n=x_koord;n<x_obergrenze;n++)
		waddstr(win3,"-----------");

	zeile = 5;
	for (m=y_koord;m<y_obergrenze;m++)
	{
		spalte = 14;
		if(m==0)
		{
			mvwprintw(win3,zeile,1,spr("teil06"));
		}
		else
		{
			mvwprintw(win3,zeile,1,"%-10s | ",netz.knotname[m-1]);
		}

		for (n=x_koord;n<x_obergrenze;n++)
		{
			wmove(win3,zeile,spalte);
			waddstr(win3,".......");
			spalte += 11;
		}
		zeile = zeile + 1;
	}
	wrefresh(win3);

	/* Formular ausfuellen */

	zeile = 5;
	for (m=y_koord;m<y_obergrenze;m++)
	{
		pruef_zeile = m % MAXMATRIX;
		merk = sum[pruef_zeile];
		spalte = 14;
		for (n=x_koord;n<x_obergrenze;n++)
		{
			if (n == knoten-1 && ( m == 0  || sum[pruef_zeile] > 0.0 ))
			{
				netz.uew[m][n][klasse] = 1-sum[pruef_zeile];
				mvwprintw(win3,zeile,spalte,"%6.4lf",netz.uew[m][n][klasse]);
				wrefresh(win3);
			}
			else
			{
				wmove(win3,zeile,spalte);
				wrefresh(win3);
				netz.uew[m][n][klasse] = l_double(0.000,1,0.0000,DOUBLE_MAX,6);
				sum[pruef_zeile] += netz.uew[m][n][klasse];

				mvwprintw(win3,zeile,spalte,"%6.4lf",netz.uew[m][n][klasse]);
				wrefresh(win3);

				if (sum[pruef_zeile] > 1.00001  )
				{
					/* Fehlermeldung */
					werase(win4);
/*					beep();						*/
					wprintw(win4,"%s %lf !",spr("teil07"),(double) sum[pruef_zeile]);
					wrefresh(win4);

					/* Die ganze Zeile noch einmal ausfuellen */
					n = x_obergrenze + 1;
					m -= 1;
					zeile -= 1;
					sum[pruef_zeile] = merk;
				}
			}
			spalte += 10+1;
		}
		zeile += 1;
	}
}




/*
   get_uew() --- aufgerufen von eingabe() (eingabe.c)                        
 									      
   Parameter:								      
 	- klasse : Gerade aktuelle Klasse				      
                                                                             
   get_uew() wird pro Klasse einmal von eingabe() aufgerufen.		      
   Wenn die Anzahl der Knoten so gross ist, dass nicht alle Werte     	      
   auf einmal angezeigt werden koennen, wird die Matrix der Uebergangs-      
   wahrscheinlichkeiten aufgeteilt.       				      
   get_uew() setzt das Formular fuer die Angabe der Uebergangswahrschein-    
   lichkeiten in das Fenster 3 je nach gerade auszufuellender Teilmatrix.    
 */

void get_uew(klasse)
int	klasse;
{
	short	knoten;				/* Anzahl der Knoten					*/
	short	div1,				/* Hilfsvariablen fuer die Bestimmung   */
	div2;						/* der aktuellen Teilmatrix				*/
	short	i,j;				/* Laufvariablen						*/
	double		sum[60];		/* Feld zur Ueberpruefung der Zeilen-   */
								/* summe auf 1							*/
	status("get_uew");
	werase(win3);	 /* Fenster 3 loeschen */

	/* Initialisierung */

	if (netz.typ == GESCHLOSSEN)
	{ /* Geschlossenes Netz */
		knoten = netz.knot+1;  /* hier ist der Knoten '0' der Bezugsknoten
			mit Besuchhaeufigkeit 1 und Bedienzeit 0 */
	}
	else
	{ /* Offenes oder gemischtes Netz */
		knoten = netz.knot+1;		/* Aussenwelt beruecksichtigen		*/
	}

	/* Anzahl der Teilmatrizen bestimmen und deren */
	/* Ausfuellen aufrufen			       */

	div1 = knoten / MAXMATRIX + 1;
	div2 = knoten / 6 + 1;

	for (i=0;i<div1;i++)
	{
		/* Zeilensumme 0 setzen */
		for (j=0;j<MAXMATRIX;j++)
			sum[j] = 0.0;

		for (j=0;j<div2;j++)
		{
			get_teilmatrix(i*MAXMATRIX,j*6,knoten,klasse,sum);   /* Teilmatrix ausfuellen */
		}
	}
}
