/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  D-91056 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define LE_SCHIRM_C

static char *SccsId = "@(#)PEPSY:\tschirm.c\t1.12\t95/05/22 11:45:06";

#include <unistd.h>

#include "d_pepsy.h"
#include "libpepsy.h"
#include "libein.h"


extern	int		atoi();
extern	char	*getenv();

extern int	dbg;
extern long eflag;



/* Globale Definition der stets verwendeten Bildschirmfenster */

WINDOW *win1;
WINDOW *win2;
WINDOW *win3;
WINDOW *win4;
WINDOW *wina;
WINDOW *winb;
WINDOW *winc;

/******************************************************************************
 *  init_schirm() --- wird von main() aufgerufen (main.c)                     *
 *																		      *	
 *  Initialisieren des Bildschirmaufbaus fuer das gesamte Programm            *
 ******************************************************************************/

void init_schirm()
{
    /* Definition von Bildschirmfenstern, die die Umrandung der stets verwendeten
       enthalten
       */

    /* Bildschirm fuer die Verwendung der curses-Funktionen initialisieren */

    signal(SIGHUP,e_schirm);  /* Bei Unterbrechung Bildschirmruecksetzfunktion
				 aufrufen */
    signal(SIGINT,e_schirm);  /* Bei Unterbrechung Bildschirmruecksetzfunktion
				 aufrufen */
    signal(SIGQUIT,male_neu); /* Bildschirm neu zeichnen */

    initscr();  /* Initialisierungsfunktion von curses */

    nonl();
    cbreak();
    noecho();  /* Bildschirmecho ausschalten */

    /* Festlegung der stets verwendeten Bildschirmfenster */

    win1 = newwin(1,COLS,0,0);
    win2 = newwin(1,COLS,2,0);
    win3 = newwin(LINES-6,COLS,4,0);
    win4 = newwin(1,COLS,LINES-1,0);

    if(dbg>50)
	{
	    fprintf(stderr,"LINES = %d, COLs = %d\n",LINES,COLS);
	}
}


/******************************************************************************
 *  w_schirm() --- aufgerufen von 					      *
 *                                main()       (main.c)                       *
 *									      *	
 *  Herstellen des stets verwendeten Bildschirmaufbaus			      *
 *  									      *
 ******************************************************************************/

void w_schirm()
{

    /* Definition von Bildschirmfenstern, die die Umrandung der stets verwendeten
       enthalten*/


    int i;


    /* Festlegung der Umrandungsfenster */

    wina = newwin(1,COLS,1,0);
    winb = newwin(1,COLS,3,0);
    winc = newwin(1,COLS,LINES-2,0);

    /* Begrenzen der Bildschirmfenster */

    if(dbg)
	{
	    for(i=0;i<1000;i++)
		{
		    waddch(win1,'1');
		    waddch(win2,'2');
		    waddch(win3,'3');
		    waddch(win4,'4');
		    waddch(wina,'a');
		    waddch(winb,'b');
		    waddch(winc,'c');
		}
	    wrefresh(win1);
	    wrefresh(win2);
	    wrefresh(win3);
	    wrefresh(wina);
	    wrefresh(win4);
	    wrefresh(winb);
	    wrefresh(winc);
	    sleep(10);
	    werase(win1);
	    werase(win2);
	    werase(win3);
	    werase(win4);
	    werase(wina);
	    werase(winb);
	    werase(winc);
	}

    for(i=0;i<COLS;i++)
	{
	    waddstr(wina,"-");
	    waddstr(winb,"-");
	    waddstr(winc,"-");
	}
}

/******************************************************************************
 *  fenster1() --- aufgerufen von main()  (main.c)			      *
 *									      *	
 * Das Fenster 1 wird geschrieben					      *
 *  									      *
 ******************************************************************************/

void fenster1()
{

    /* Fuellen der Bildschirmfenster mit Statusinformation */

    int i,spalten,laenge;

    werase(win1);
    spalten=COLS;
    if (spalten==0) spalten=atoi(getenv("COLUMNS"));
    if (spalten==0) spalten=80;
    laenge=strlen(spr("fen101"))+strlen(spr("fen102"))+strlen(spr("fen103"));
    for (i=0;i<(spalten-laenge)/2;i++,wprintw(win1," "));
    wprintw(win1,spr("fen101")); 
    wstandout(win1);
    wprintw(win1,spr("fen102"));
    wstandend(win1);
    waddstr(win1,spr("fen103"));
    wrefresh(win1);   
    wrefresh(win2);
    wrefresh(win3);
    wrefresh(win4);
    wrefresh(wina);
    wrefresh(winb);
    wrefresh(winc);
}

/******************************************************************************
 * Funktion fenster2() --- aufgerufen main() (main.c)			      *
 *                                                                            *
 * Schreibt in Fenster 2 die Ablaufposition.                                  *
 ******************************************************************************/

void fenster2(pos)
int 	pos;
{
    werase(win2);
    switch(pos)
	{
	case 0:
	    waddstr(win2,center(spr("fen201"), COLS));
	    break;
	case 1:
	    waddstr(win2,center(spr("fen202"), COLS));
	    break;
	case 2:
	    waddstr(win2,center(spr("fen203"), COLS));
	    break;
	default:
	    break;
	}
    wrefresh(win2);
}

/******************************************************************************
 *  c_schirm() --- aufgerufen von main()  (main.c)		              *
 *									      *	
 *  Funktion, die die Zeichen auf dem Bildschirm loescht und den Cursor auf   *
 *  die Anfangsposition stellt.						      *
 *  									      *
 ******************************************************************************/

void c_schirm()
{
}

/******************************************************************************
 *  e_schirm() --- aufgerufen von main(0  (main.c)			      *
 *									      *	
 *  Funktion zum Wiederherstellen des Bildschirmzustandes vor Programmaufruf  *
 *  									      *
 ******************************************************************************/

void e_schirm()
{
    werase(win1);
    werase(win2);
    werase(win3);
    werase(wina);
    werase(winb);
    werase(winc);
    move(LINES-1,0);

    endwin();
}

void male_neu()
{
    signal(SIGQUIT,male_neu);

    touchwin(win1);
    touchwin(win2);
    touchwin(win3);
    touchwin(win4);
    touchwin(wina);
    touchwin(winb);
    touchwin(winc);

    wrefresh(curscr);
}
