/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  D-91058 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define LE_SP_EIN_C

static char *SccsId = "%Z%PEPSY:\t%M%\t%R%.%L%\t%D% %T%";


#include <stdio.h>
#include "d_pepsy.h"
#define	EXTERN_KNOTENTYPEN
#include "d_netz.h"
#include "d_konst.h"
#include "d_debug.h"
#include "libpepsy.h"

#define SPT_ANZ_KNOTEN		spr("spei03")
#define SPT_ANZ_KLASSEN		spr("spei04")
#define SPT_KNOTENDEF		spr("spei06")
#define SPT_KLASSENDEF		spr("spei27")
#define SPT_AUSSEN		spr("spei36")
#define SPT_KLASSE		spr("spei31")

extern	char	*strchr();

extern	int		dbg;
extern netzstruktur netz;	/* Eingabedatenstruktur			*/



#define PADLENGTH 20

static	char	blanks[PADLENGTH]="                   ";
static	p_lang_init_done = 0;


#define PAD(p, x, f)	fputs(&blanks[((x-p)>0)?(PADLENGTH-x+p):PADLENGTH], f)

/*
   sp_ein() --- aufgerufen von eingabe() (eingabe.c)		      	      
                                                                             
   Funktion zum Abspeichern der Eingabedaten				      

   Die geschriebenen Netze koennen mit der Funktion
   get_standard() aus libpepsy.a:get_standard.c wieder 
   gelesen werden.

   25.08.92	kirschni	Entfernen eines grossen Teils der spr("...")
				Automatische erkennung des Knotentyps und
				basteln des Formatstringes aus dem Knotentypen!
 */

void sp_ein(ein,wunsch,datname)
FILE 	*ein;
int	wunsch;		/* 1 falls uew gewuenscht, 0 falls besh		*/
char *datname;
{
    short	knot;		/* Anzahl der Knoten mit Aussenwelt	*/
    short	i,j,r;		/* Laufvariable				*/
    char	buffer[64];	/* Puffer fuer den Formatstring der Knotentypn */
    char	*c, *c1;
    int		pad;


    if(!p_lang_init_done)
    {
	if(p_lang_init("sp_ein") != 0)
	{
	    fprintf(stderr, "Cannont perform p_lang_init in sp_ein()!\n");
	    exit(2);
	}

	p_lang_init_done = 1;
    }

    fprintf(ein,"%s %d\n",spr("spei01"),pepsyversion);
    fprintf(ein,"#\n#\n# %s %s\n#\n\n\n",spr("spei02"),datname);
	
    /* # Knoten und Klassen abspeichern */

    fprintf(ein,"%s %d\n",SPT_ANZ_KNOTEN,netz.knot);
    fprintf(ein,"%s %d\n",SPT_ANZ_KLASSEN,netz.klass);
    fprintf(ein,"\n");

    dbgtext(55, "sp_ein(): Knotenbeschreibung\n"); /* Knotenbeschreibung abspeichern */

    fprintf(ein,"%s\n\n",SPT_KNOTENDEF);
    fprintf(ein,"%s\n",spr("spei07"));
    fprintf(ein,"---------+--------------------+---------------------");

    for(i=0;i<netz.knot;i++)
    {
	fprintf(ein,"\n    %2d   |",i+1);

	/*	knotennamen vorne und hinten kappen */

	if (netz.knotname[i] && *(netz.knotname[i]))
	{
	    c = c1 = netz.knotname[i];

	    while (*c == ' ' || *c == '\t')
		c++;

	    if (c != c1)
	    {
		while (*c != '\0')	/*	nach vorne umkopieren	*/
		    *c1++ = *c++;

		*c1 = *c;		/* \0 umkopieren */
	    }

	    c1 = netz.knotname[i];

	    while (*c1 != '\0')
		c1++;
		
	    c1--;			/* c1 zeigt wieder auf das letzte Zeichen */


	    while ((*c1 == '\t' || *c1 == ' ') && (c1 > netz.knotname[i]))
	    {
		*c1 = '\0';		/* Abschlussbytes hinterlassen :-) */
		c1--;
	    }

	    fprintf(ein,"      %-10s    |",netz.knotname[i]);
	}
	else
	{
	    fprintf(ein,"      Knoten %d    |", i);
	}

	sprintf(buffer, "     %s     ", knotentypen[netz.knotentyp[i]]);
	c = strchr(buffer, '/');
	
	if (c)
	{
	    c++;
	    while (*c!='\0' && *c!='/')
		c++;
		
	    c++;
	    if (*c == 'm')
	    {
		/* multiple-Server-Knoten gefunden!
	       
		   m durch % ersetzen, alles ein Zeichen aufruecken und noch ein d
		   einschieben
		   */

		*c = '%';

		c++;		/*	c ist jetzt auf das erste Zeichen nach dem ex-m gesetzt! */

		c1 = c;
		while (*c1) c1++;	/* c1 zeigt auf das abschliessende null-Byte	*/

		while (c1 != c)		/* vom Ende des Strings an alles nach hinten	*/
		{			/* aufschieben und ein 'd' einfuegen			*/
		    *(c1+1)=*c1;
		    c1--;
		}

		*(c+1)	= *c;
		*c	= 'd';

		fprintf(ein, buffer, netz.bede[i]);
	    }
	    else
	    {
		fprintf(ein, buffer);
	    }
	}
	else
	{
	    fprintf(ein, buffer);
	}
    }

    fprintf(ein,"\n\n");

    /* Klassenbeschreibung abspeichern */

    dbgtext(55, "sp_ein(): Klassenbeschreibung:\n");

    fprintf(ein,"%s\n\n",SPT_KLASSENDEF);
    fprintf(ein,"%s  \n",spr("spei28"));
    fprintf(ein,"----------+----------------------------------");

    for(r=0;r<netz.klass;r++)
    {
	fprintf(ein,"\n    %2d    |",r+1);

	if (	(netz.typ == OFFEN)
	    ||	(netz.typ == GEMISCHT && netz.auftr[r] == 0 ))
	{
	    fprintf(ein,"    %.6g           -",netz.ankr[r]);
	}
	else
	{
	    fprintf(ein,"     -            %3d",netz.auftr[r]);
	}
    }

    fprintf(ein,"\n\n");

    /* Klassenspezifische Knotengroessen abspeichern */

    dbgtext(55, "sp_ein(): Klassenspezifische Knotengroessen\n");

    fprintf(ein,"%s",spr("spei30"));

    for(r=0;r<netz.klass;r++)
    {
	fprintf(ein,"\n\n%s %2d\n\n%s", SPT_KLASSE, r+1, spr("spei32"));

	if (wunsch == 1)
	    fprintf(ein,"\n");
	else
	    fprintf(ein,"%s  \n",spr("spei33"));

	fprintf(ein,"--------------------+-----------------------------------");

	if (wunsch != 1)
	    fprintf(ein,"-----------------");

	for(i=0;i<netz.knot;i++)
	{
	    fprintf(ein,"\n     %-10s     |",netz.knotname[i]);
	    pad = fprintf(ein,"  %.6g",netz.bedr[i][r]);		PAD(pad, 10, ein);

	    if (netz.quadvar[i][r] == -1)
	    {
		pad = fprintf(ein,"  %.6g", 1.0);			PAD(pad, 10, ein);
	    }
	    else
	    {
		pad = fprintf(ein,"  %.6g",netz.quadvar[i][r]);		PAD(pad, 10, ein);
	    }

	    if (wunsch != 1)
	    {
		/* Besuchshaeufigkeiten angegeben */
		fprintf(ein,"   %.6g",netz.besh[i][r]);
	    }
	} 

	fprintf(ein,"\n\n");


	/* Uebergangswahrscheinlichkeiten */

	if (wunsch == 1)
	{
	    fprintf(ein,"\n\n%s",spr("spei34"));
	    knot = netz.knot + 1;

	    fprintf(ein,"\n\n%-10s |",spr("spei35"));
	    for(i=0;i<knot;i++)
	    {
		if (i == 0)
		    fprintf(ein," %-10s", SPT_AUSSEN);
		else
		    fprintf(ein," %-10s", netz.knotname[i-1]);
	    }
	    fprintf(ein,"\n-----------+");

	    for(i=0;i<knot;i++)
		fprintf(ein,"-----------");

	    for(j=0;j<knot;j++)
	    {
		if (j == 0)
		    fprintf(ein,"\n%-10s |", SPT_AUSSEN);
		else
		    fprintf(ein,"\n%-10s |",netz.knotname[j-1]);

		for(i=0;i<knot;i++)
		{
		    pad = fprintf(ein," %7.6f",netz.uew[j][i][r]); PAD(pad, 11, ein);
		}
	    }
	}
    }
    fprintf(ein,"\n\n");
}
