/*

                                         P E P S Y
                         
        Performance and Evaluation Prediction System

        Copyright 1987, 1988

                 Universitaet Erlangen-Nuernberg,
                 Lehrstuhl fuer Betriebssysteme
                 Martensstrasse 1

             8520 Erlangen

        Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
        PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
        gefuehrt werden.
*/
#define LO_GETREFERENCES_C
static char *SccsId ="@(#)PEPSY:\tgetreferences.c\t1.4\t93/12/21 14:33:19";

#include <stdio.h>
#include <string.h>
#include "libpepsy.h"
#include "libohs.h"
#include "d_debug.h"

extern int dbg;

/************************************************************************
*                                                                       *
*       Funktion: getreferences()                                       *
*                                                                       *
*       Aufgabe:  Liefert die Anzahl d. Textstellen zu einem Keyword    *
*                                                                       *
*       Eingabe: Schluesselwort, Hilfefile                              *
*                                                                       *
*       Ausgabe: Anzahl der Textverweise oder OH_error, falls z.B. kein *
*                                                               Keyword *
************************************************************************/

int getreferences(keyword, file)
char *keyword;
struct OH_file file;
{
	long l,offset=0L;
	struct OH_control c_seq;
	char line[1024];
	int count, retval;

	if(keyword==NULL || &file==NULL)
	{
		dbgtext(0,"getreferencec(): call with NULL !!!\n");
		return(OH_error);
	}
	
	dbginfo(50, "getreferences('%s')\n", keyword);

	l = ftell(file.fp);	/* save position of fp */

	if(searchkeyword(keyword, file) == FALSE)
	{
		ohs_error_text	= strdup(keyword);
		ohs_error_val	= -9;
		retval		= OH_error;
	}
	else
	{
		rewind(file.fp);
		
		/* search correct keyword in file */
		fseek(file.fp,file.start_of_keyw,0);

		c_seq=get_c_seq(file.fp);
		while(strcmp(c_seq.argument1,keyword)!=0){
			get_until(file.fp,line,"/");
			c_seq=get_c_seq(file.fp);
		}

		/* now actually count the references 'til "-1" */	
		for(count = 0; offset != -1L; count++)
			fscanf(file.fp, "%ld", &offset);

		retval = count-1; /* don't count -1L, too ! */
	}

	fseek(file.fp,l,0);	/* restore fp-position */

	dbginfo(50, "getreferences() fertig. -> %d\n", retval);

	return(retval);
}
