/*

                                         P E P S Y
                         
        Performance and Evaluation Prediction System

        Copyright 1987, 1988

                 Universitaet Erlangen-Nuernberg,
                 Lehrstuhl fuer Betriebssysteme
                 Martensstrasse 1

             8520 Erlangen

        Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
        PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
        gefuehrt werden.
*/

#define LO_INDEX_C
static char *SccsId="@(#)PEPSY:\tindex.c\t1.10\t94/02/10 17:14:36";

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "libpepsy.h"
#include "libohs.h"
#include "d_debug.h"

extern int dbg;
extern char* malloc();
extern void	free();

int compare(a, b)
char *a, *b;
{
	int i=0,j=0;
	char *a1, *b1;

	dbgtext(95,"compare() betreten\n");

	for(;!isalpha(*a) && *a!='\0';a++);
	for(;!isalpha(*b) && *b!='\0';b++);

	a1 = a;
	b1 = b;
	
	while(a && *a)
	{
	    if(*a=='' || *a=='' || *a=='' || *a=='' || *a=='' || *a=='' || *a=='')
		i++;
		a++;
	}

	dbginfo(95,"compare: %d Umlaute in",i);
	dbginfo(95,"%s\n",a1);


	while (b && *b)
	{
	    if(*b=='' || *b=='' || *b=='' || *b=='' || *b=='' || *b=='' || *b=='')
		j++;
		b++;
	}

	dbginfo(95,"compare: %d Umlaute in",j);
	dbginfo(95,"%s\n",b1);

	a = a1;
	b = b1;

	a1 = (char *)malloc((strlen(a)+i+1)*sizeof(char));
	b1 = (char *)malloc((strlen(b)+j+1)*sizeof(char));

	for(i=0,j=0;i<=(int)strlen(a);i++)
	{
	    switch(a[i])
	    {
		case '':	a1[j++]='a'; a1[j++]='e'; break;
		case '':	a1[j++]='A'; a1[j++]='e'; break;
		case '':	a1[j++]='o'; a1[j++]='e'; break;
		case '':	a1[j++]='O'; a1[j++]='e'; break;
		case '':	a1[j++]='u'; a1[j++]='e'; break;
		case '':	a1[j++]='U'; a1[j++]='e'; break;
		case '':	a1[j++]='s'; a1[j++]='s'; break;
		default :	a1[j++]=a[i];
	    }
	}

	dbginfo(95,"convert(): arg.1 konvertiert zu %s\n",a1);
	
	for(i=0,j=0;i<=(int)strlen(b);i++)
	{
	    switch(b[i])
	    {
		case '':	b1[j++]='a'; b1[j++]='e'; break;
		case '':	b1[j++]='A'; b1[j++]='e'; break;
		case '':	b1[j++]='o'; b1[j++]='e'; break;
		case '':	b1[j++]='O'; b1[j++]='e'; break;
		case '':	b1[j++]='u'; b1[j++]='e'; break;
		case '':	b1[j++]='U'; b1[j++]='e'; break;
		case '':	b1[j++]='s'; b1[j++]='s'; break;
		default :	b1[j++]=b[i];
	    }
	}

	dbginfo(95,"convert(): arg.2 konvertiert zu %s\n",b1);

	i = strcasecmp(a1, b1);
	free(a1);
	free(b1);

	dbgtext(95,"convert() verlassen\n");
	return(i);
}

/************************************************************************
*                                                                       *
*       Funktion: sortkeyw()                                            *
*                                                                       *
*       Aufgabe: Sortiert die Schluesselwoerter alphabetisch            *
*                                                                       *
*       Eingabe: Zeiger auf d. Schluesselwortliste, Anz. v. Eintraegen  *
*                                                                       *
*       Ausgabe: keine                                                  *
*                                                                       *
************************************************************************/

void sortkeyw(value, number)
char **value;
int number;
{
	int gap,i,j;
	char *a;

	dbgtext(50, "sortkey()\n");

	for(gap=number/2 ; gap>0 ; gap/=2)
		for(i=gap ; i<number ; i++)
			for(j=i-gap ; j>=0 ; j-=gap) {
				dbginfo(95,"sortkey(): compare(%s",value[j]);
				dbginfo(95,", %s)\n",value[j+gap]);
				if(compare(value[j],value[j+gap])<=0)
					break;
				a=value[j+gap];
				value[j+gap]=value[j];
				value[j]=a;
			}

	dbgtext(50, "sortkey() fertig\n");
}

/************************************************************************
*                                                                       *
*       Funktion: getindex()                                            *
*                                                                       *
*       Aufgabe: Liefert die Liste der Schluesselwoerter                *
*                                                                       *
*       Eingabe: Filtermaske, Return-Puffer, Hilfefile, sortieren?      *
*                                                                       *
*       Ausgabe: Anzahl der zurueckgegebenen Eintraege                  *
*                                                                       *
************************************************************************/

int getindex(mask, buffer, file, sort)
char *mask;
char **buffer;
struct OH_file file;
int sort;
{
	char line[1024];
	long l;
	int i=0,j=0,k=0;
	struct OH_control seq;
	char *mask_up, *string_up;

	/* mask besteht aus einem string oder '*'. '*' bedeutet: alle
	   keywords zurueckgeben, sonst nur diejenigen, in denen
       der string vorkommt. */

	dbgtext(50, "getindex()\n");

	mask_up = strdup(mask);

	for(i=0;i<(int)strlen(mask_up);i++)
	{
		if(isascii(mask_up[i]))
			mask_up[i]=dtoupper(mask_up[i]);	/* convert mask to uppercase */
	}

	l=ftell(file.fp);				/* save fileposition */

	fseek(file.fp,file.start_of_keyw,0);	 /* jump to keywords */

	for(i=0;i<file.keyw_count;i++){		/* fill buffer with */
		seq=get_c_seq(file.fp);	  		/* keywords */

		if(strncmp("internal_",seq.argument1,9) != 0) /* add keyword only if it's not internal */
		{

			string_up = strdup(seq.argument1);
			for(k=0;k<(int)strlen(string_up);k++)
			{
				if(isascii(string_up[k]))
					string_up[k]=dtoupper(string_up[k]);	/* convert string to uppercase */
			}

			
			if(strcmp("*",mask)==0 || strstr(string_up,mask_up)!=NULL)
			{
					buffer[j]=strdup(seq.argument1);
					j++;
			}
			free(string_up);
		}
		buffer[j]=NULL;
		get_until(file.fp,line,"/");
	}


	fseek(file.fp,l,0);			/* restore filepos. */

	/* let's sort buffer for convenience of programmer if sort==TRUE */
	if(sort==TRUE) sortkeyw(buffer,j); 

	dbgtext(50, "getindex() fertig\n");
	
	free(mask_up);

	return(j);
}
