/*

                                         P E P S Y
                         
        Performance and Evaluation Prediction System

        Copyright 1987, 1988

                 Universitaet Erlangen-Nuernberg,
                 Lehrstuhl fuer Betriebssysteme
                 Martensstrasse 1

             8520 Erlangen

        Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
        PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
        gefuehrt werden.
*/
#define LO_LIBMISC_C
static char *SccsId="@(#)PEPSY:\tlibmisc.c\t1.7\t94/02/10 17:14:38";

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "libpepsy.h"
#include "libohs.h"
#include "d_debug.h"
extern int dbg;

char dtoupper(c)
char c;
{
	if(c>='a' && c<'z')
		return(c-32);

	switch(c)
	{
		case '':	return('');
		case '':	return('');
		case '':	return('');
		default:	return(c);
	}
}

/************************************************************************
*                                                                       *
*       Funktion: searchkeyword()                                       *
*                                                                       *
*       Aufgabe: Sucht, ob das uebergebene Wort Schluesselwort ist      *
*                                                                       *
*       Eingabe: Suchwort, Hilfefile                                    *
*                                                                       *
*       Ausgabe: TRUE oder FALSE                                        *
*                                                                       *
************************************************************************/

int searchkeyword(word, file)
char *word;
struct OH_file file;
{
	int	i;
	char	line[1024];
	struct OH_control c_seq;
	long	l;

	if(word==NULL || &file==NULL)
	{
		dbgtext(50,"searchkeyword: got NULL as wordpointer\n");
		return(FALSE);
	}

	dbginfo(50, "searchkeyword('%s', .)\n", word);

	l = ftell(file.fp);

	fseek(file.fp,file.start_of_keyw,0);

	for(i=0;i<file.keyw_count;i++){
		c_seq=get_c_seq(file.fp);		/* read next keyword */
		if(strcmp(word,c_seq.argument1)==0){
			dbgtext(50, "searchkeyword() fertig. ->TRUE\n");

			fseek(file.fp, l, 0);

			return(TRUE);
		} else {
			get_until(file.fp,line,"/"); 	/* skip references */
		}
	}

	dbgtext(50, "searchkeyword() fertig. -> FALSE\n");

	fseek(file.fp, l, 0);

	return(FALSE);
}

/************************************************************************
*                                                                       *
*       Funktion: searchheadline()                                      *
*                                                                       *
*       Aufgabe: Durchsucht Hilfedatei, ob hl Ueberschrift ist          *
*                                                                       *
*       Eingabe: gesuchte Ueberschrift, Hilfefile                       *
*                                                                       *
*       Ausgabe: TRUE oder FALSE                                        *
*                                                                       *
************************************************************************/

int searchheadline(hl, file)
char *hl;
struct OH_file file;
{
	int	i;
	char	line[1024];
	struct OH_control c_seq;
	long	l;
	
	if(hl==NULL || &file==NULL)
	{
		dbgtext(50,"searchkeyword: got NULL as wordpointer\n");
		return(FALSE);
	}

	dbginfo(50, "searchheadline('%s', .)\n", hl);

	l = ftell(file.fp);

	fseek(file.fp,file.start_of_hl,0);
	for(i=0;i<file.hl_count;i++){
		c_seq=get_c_seq(file.fp);		/* read next headline */
		if(strcmp(hl,c_seq.argument1)==0){
			dbgtext(50, "searchheadline() fertig. -> TRUE\n");

			fseek(file.fp, l, 0);

			return(TRUE);
		} else {
			get_until(file.fp,line,"/"); 	/* skip references */
		}
	}
	dbgtext(50, "searchheadline() fertig. ->FALSE\n");

	fseek(file.fp, l, 0);

	return(FALSE);
}

/************************************************************************
*                                                                       *
*       Funktion: get_until()                                           *
*                                                                       *
*       Aufgabe: liest bis zum naechsten Vorkommen von 'bracket' aus fp *
*                                                                       *
*       Eingabe: Filepointer, Returnpuffer, Klammerstring               *
*                                                                       *
*       Ausgabe: OH_error oder Anzahl der zurueckgelieferten Zeichen    *
*                                                                       *
************************************************************************/

int get_until(fp, buffer, bracket)
FILE *fp;
char *buffer;
char *bracket;
{
	int c=' ';
	int i;
	int retval= OH_ok;
	int done=0;

	for(i=0;i<(int)strlen(bracket)-1;i++){

		c=fgetc(fp);

		if(c==EOF){
			ohs_error_val = -7;
			ohs_error_text=strdup( "get_until");
			i=strlen(bracket);
			retval=OH_error;
		}
		else {
			buffer[i]=c;
			buffer[i+1]='\0';
		}
	}

	while(!done){
		c=fgetc(fp);

		if(c==EOF){
			done=1;
			retval=OH_error;
		}
		else {
			buffer[i]=c;
			buffer[i+1]='\0';
			i++;

			if(strstr(buffer,bracket)!=NULL){	/* found bracket */
				done=1;				/* in buffer	 */
				buffer[i-strlen(bracket)]='\0'; /* kill BRACKET at the end */
			}
		}
	}

	if (retval == OH_ok)
		retval = i;

	return(retval);
}

struct OH_control get_c_seq(fp)
FILE *fp;
{
	int c;
	int i=0;
	struct OH_control sequence;

	sequence.c_seq = '\0';
	strcpy(sequence.argument1,"");
	strcpy(sequence.argument2,"");

	c=fgetc(fp);	/* get control sequence */

	if (c!='/' && c!='H' && c!='K' && c!='S' && c!='N'
	 && c!='I' && c!='P' && c!='#' && c!='B' && c!='_') {
		sprintf(sequence.argument1,"%c",c);

		ohs_error_val = -10;
		ohs_error_text=strdup( sequence.argument1);
		sequence.c_seq='E';	/* indicate Error */
	}
	else {
		sequence.c_seq = c;

		if (sequence.c_seq != '/') {
			c=fgetc(fp);

			if(c!='(') {
				if(sequence.c_seq != 'P') {
					sprintf(sequence.argument1,"/%c%c",sequence.c_seq,c);
					ohs_error_text=strdup( sequence.argument1);
					ohs_error_val = -11;

					sequence.c_seq='E';	 /* indicate Error *//* found syntax error */
				}
				else
				{
					strcpy(sequence.argument1, "1");

					/* Now read until beginning of following text and skip white spaces */
					/* if control sequence is invisible */

					while(isspace(c=fgetc(fp)));

					fseek(fp,-1,1);	/* we've read the first char of following text */
				}
			}
			else
			{
				while((c=fgetc(fp))!=')' && c!='#' && c!=EOF){	/* build word until */
					sequence.argument1[i]=c;				/* '#' or ')' or EOF */
					i++;

					if(c=='/') {
						/* we won't need '/' */
						ohs_error_val = -11;
						ohs_error_text=strdup("Control sequence didn't end");
						sequence.c_seq='E';				/* in control-sequences, so */
						return(sequence);				/* obviously someone forgot the ')' */
					}

					if(feof(fp)!=0) {
						ohs_error_text=strdup("get_c_seq");
						ohs_error_val = -7;
						sequence.c_seq='E';		/* Control sequence */
						return(sequence);		/* didn't end */
					}
				}
				sequence.argument1[i]='\0';

				i=0;		/* We got to start at the Beginning of argument2 ! */
				if(sequence.c_seq=='S' || sequence.c_seq=='H'){
					while((c=fgetc(fp))!=')' && c!=EOF){	/* build word until ')' or EOF */
						sequence.argument2[i]=c;
						i++;

						if(c=='/') {
							ohs_error_text=strdup( "Control sequence didn't end");
							ohs_error_val = -11;				/* we won't need '/' */
							sequence.c_seq='E';				/* in control-sequences, so */
							return(sequence);				/* obviously someone forgot the ')' */
						}

						if(feof(fp)!=0) {
							ohs_error_text=strdup( "get_c_seq");
							ohs_error_val = -7;
							sequence.c_seq='E';	/* Control sequence */
							return(sequence);	/* didn't end */
						}
					 }
					sequence.argument2[i]='\0';
				}

				/* Now read until beginning of following text and skip white spaces */
				/* if control sequence is invisible */

				if(sequence.c_seq=='N' || sequence.c_seq=='I' || sequence.c_seq=='P'
				   || sequence.c_seq=='H') {
					while(isspace(c=fgetc(fp)));
					fseek(fp,-1,1);	/* we've read the first char of following text */
				}
			}
		}
	}

	return(sequence);
}
