/*

                                         P E P S Y
                         
        Performance and Evaluation Prediction System

        Copyright 1987, 1988

                 Universitaet Erlangen-Nuernberg,
                 Lehrstuhl fuer Betriebssysteme
                 Martensstrasse 1

             8520 Erlangen

        Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
        PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
        gefuehrt werden.
*/
#define LO_OHS_ERROR_C
static char *SccsId="@(#)PEPSY:\tohs_error.c\t1.1\t93/07/07 10:51:54";

#include <stdio.h>
#include "libohs.h"
#include "d_debug.h"

/* jetzt in libohs.h
int ohs_error_val;
char *ohs_error_text;
*/
extern int dbg;


/************************************************************************
*                                                                       *
*       Funktion: ohs_error()                                           *
*                                                                       *
*       Aufgabe: Gibt Auskunft ueber aufgetretene Fehler                *
*                                                                       *
*       Eingabe: Zusaetzlicher Usertext                                 *
*                                                                       *
*       Ausgabe: String mit genauer Fehlerbeschreibung                  *
*                                                                       *
************************************************************************/

char *ohs_error(usrtext)
char *usrtext;
{
	static char line[200];

	static char *errmsg[] = {
	"Alias not found: ",			/* - 1 */
	"Different alias defined: ",	/* - 2 */
	"Out of memory in ",			/* - 3 */
	"Invalid mode : ",				/* - 4 */
	"Environment not set: ",		/* - 5 */
	"Couldn't open file ",			/* - 6 */
	"Unexpected EOF in ",			/* - 7 */
	"Not a headline: ",				/* - 8 */
	"Not a keyword: ",				/* - 9 */
	"Unknown control sequence: ",	/* -10 */
	"Syntax error: ",				/* -11 */
	"Helpfile isn't up to date",	/* -12 */
	"No helpfile for language: ",	/* -13 */
	"Buffer too small",				/* -14 */
	"Invalid argument"};			/* -15 */

	dbginfo(50, "ohs_error('%s')\n", usrtext);

	if(usrtext==NULL){
		if(ohs_error_text == NULL)
			sprintf(line,"OHS internal error: %s\n",errmsg[-ohs_error_val-1]);
		else
			sprintf(line,"OHS internal error: %s%s\n",errmsg[-ohs_error_val-1],ohs_error_text);
	} else {
				if(ohs_error_text == NULL)
						sprintf(line,"OHS internal error: %s %s\n",errmsg[-ohs_error_val-1],usrtext);
				else
						sprintf(line,"OHS internal error: %s%s %s\n",errmsg[-ohs_error_val-1],ohs_error_text,usrtext);
	}

	dbginfo(50, "ohs_error() fertig. -> '%s'\n", line);

	return(line);
}
