/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  D-91058 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define BASICPROC_C

static char *SccsId = "@(#)PEPSY:\tbasicproc.c\t1.10\t95/05/26 14:22:52";

#include <stdio.h>
#include "d_debug.h"
#include "libpepsy.h"

extern	int	dbg;

/* Auslesen einer gueltigen Zeile aus der Datei 'from'

   gueltig heisst: keine Leerzeile und keine mit '#'
	   beginnende Zeile

   Rueckgabewert: Zahl der gelesenen Zeichen bzw. EOF

   Anmerkung: Zeilen groesser als 'length' werden abgeschnitten
   und der Rest weggeworfen.

*/

int nextline(from, buffer, length)
FILE *from;
char *buffer;
int length;
{
    register int i;

    do
    {
	i = getline(from,buffer,length);
    }
    while((*buffer=='\n' || *buffer=='#') && i!=EOF);

    dbginfo2(95, "nextline(): %d, '%s'\n", i, buffer);

    return(i);
}

int getline(from,buffer,length)
FILE *from;
char *buffer;
int length;
{
    int		i, c;
    char	*cp;
    int		last_was_backslash;
    int		skip_line_beginning_spaces;

    dbginfo2(95, "getline(FILE, buffer=0x%08lx, length=%d)\n", (long)buffer, length);

    i				= length-1;	/* reserve space for trailing \0 */
    cp				= buffer;
    c				= '\0';
    last_was_backslash		= 0;
    skip_line_beginning_spaces	= 0;

    /*       lesen bis Puffer voll oder 'newline' oder 'EOF'
     */
    while(i>0 && c!=EOF && c!='\n')
    {
	c=getc(from);

	if (c!=EOF)
	{
	    switch (c)
	    {
	    case '\\':
		if (last_was_backslash)
		{
		    last_was_backslash	= 0;
		    *cp			= c;
		    cp++;
		    i--;
		}
		else
		    last_was_backslash = 1;
		break;

	    case 'n':
		if (last_was_backslash)
		{
		    last_was_backslash	= 0;
		    *cp			= '\n';
		}
		else
		{
		    *cp			= 'n';
		}

		cp++;
		i--;
		
		break;

	    case '\n':
		if (last_was_backslash)
		{
		    skip_line_beginning_spaces	= 1;
		    last_was_backslash		= 0;
		    c				= '\0'; /* to go through this loop again */
		}
		else
		{
		    *cp = c;
		    cp++;
		    i--;
		}
		break;

	    case ' ':
		if (last_was_backslash)
		    skip_line_beginning_spaces	= 0;

		last_was_backslash = 0;

		if (skip_line_beginning_spaces)
		    break;

	    default:
		last_was_backslash		= 0;
		skip_line_beginning_spaces	= 0;

		*cp=c;
		cp++;
		i--;
	    }
	}
    }

    if(i==length-1 && c==EOF )
    {
	/* Dateiende erreicht
	 */
	return(EOF);
    }

    if(i<=0)
    {
	/* Puffer voll, Rest der Zeile wegputzen
	 */ 
	while((c=fgetc(from))!='\n' && c!=EOF )
	    ;
    }


    /* Normalfall
     */
    *cp = '\0';
    return(length-1-i);
}
