/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define FILE_C

static char *SccsId = "@(#)PEPSY:\tfile.c\t1.4\t93/12/21 12:08:08";

#include <stdio.h>
#include <string.h>
#include <sys/param.h>	/* fuer MAXPATHLEN  oder PATHSIZE bei SCO */
#ifndef MAXPATHLEN
#ifdef PATHSIZE
#define MAXPATHLEN PATHSIZE
#else
#define MAXPATHLEN 1024
#endif
#endif
#include "d_debug.h"
#include "libpepsy.h"

extern	int	dbg;


FILE	*Pepsy_fopen(pepsy_file_t, path, name, mode)
int		pepsy_file_t;
char	*path;
char	*name;
char	*mode;
{
	/* 
		Diese Funktion soll eine einheitliche Schnittstelle bieten um beliebige
		zum Programmsystem PEPSY gehoerige Dateien zu oeffnen. Der pepsy_file_t
		hilft den Typ der Datei festzulegen.
		Es wird ein Stream zurueckgeliefert.

		geplante Erweiterungen:

		projekt-Konzept	-	saemtliche zu einem Modell gehoerige Dateien sind
							in einem Verzeichnis p_<modname> abgelegt.
	*/
	FILE	*fp;
	char	filename[MAXPATHLEN];
	int		len;


	switch (pepsy_file_t)
	{
		default:
		PFT_MODEL:		/*	Eine Modellbeschreibung soll gelesen werden
							Der Prefix ist 'e_'. Sollte 'name' schon mit
							'e_' beginnen wird der Prefix natuerlich nicht
							davorgesetzt.
						*/
						if (path != (char*) NULL)
						{
							strcpy(filename, path);

							len = strlen(filename);

							if (!(filename[len-1] == '/'))
							{
								filename[len]	= '/';
								filename[len+1]	= '\0';
							}
						}
						else
						{
							filename[0] = '\0';
						}

						if (name != (char*) NULL)
						{
							if (!(name[0] == 'e' && name[1] == '_'))
							{
								strcat(filename, "e_");
							}

							strcat(filename, name);
						}
						else
						{
							/* no file */
						}
						
						break;
	}

	dbginfo(55, "Pepsy_fopen(): File='%s'\n", filename);

	fp = fopen(filename, mode);

	return(fp);
}
