/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  D-91058 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define GET_ASYM_C

static char *SccsId = "@(#)PEPSY:\tget_asym.c\t1.8\t95/05/22 10:48:53";

#include <stdio.h>
#include <sys/types.h> /* eingefuegt kirschni */
#include "d_netz.h"
#define EXTERN_KNOTENTYPEN
#include "d_konst.h"
#include "d_debug.h"
#include "libpepsy.h"	


extern	void		qsort();
extern	int		strncmp();

extern	int		dbg;
extern	netzstruktur	netz;



boolean fGetBedRate(fp, pdBedRate)
FILE *fp;
double *pdBedRate;
{
    extern	double	atof();
    char	buffer[512], *cp;
    boolean	status, loopend;

    loopend = FALSE;

    while(!loopend)
    {
	status = nextline(fp,buffer,512);

	if (status == EOF)
	{
	    status  = FALSE;
	    loopend = TRUE;
	}
	else
	{
	    if (strncmp("Bedienrate",buffer,6) == 0)
	    {
		cp=buffer;

		while (*cp != ':')
		    cp++;

		cp++;

		while (*cp == ' ')
		    cp++;

		*pdBedRate = atof(cp);

		dbginfo(55, "get_asym(): Bedienrate %f gelesen!\n", *pdBedRate);

		loopend = TRUE;
		status  = TRUE;
	    }
	}
    }
    return(status);
}


int fDoubleComp(d1, d2)
double *d1, *d2;
{
	if (*d1>*d2)
		return(-1);
	else
		if (*d1==*d2)
			return(0);
		else
			return(1);
}

void get_asym(fp)
FILE *fp;
{
    register	netzstruktur	*np = &netz;
    		int		gefunden;
    		int		i, j, k;
    		double		dTemp;
    		char		buffer[512];

	
    asym_data.bedrate = (double ***)calloc((size_t)(np->klass), sizeof(double **));

    for (i=0; i<np->klass; i++)
    {
	asym_data.bedrate[i] = (double **)calloc((size_t)(np->knot), sizeof(double *));
    }


    dbgtext(50, "get_asym()\n");


    /* Zusatzblock in Eingabedatei suchen */

    gefunden = FALSE;
    rewind(fp);
    while ( gefunden == FALSE && nextline(fp,buffer,512) != EOF )
    {
	if (strncmp("ASYM" ,buffer,4) == 0)
	{
	    dbginfo(55, "get_asym() : Zusatzblock %s gefunden\n", buffer);
	    gefunden = TRUE;
	}
    }


    /* Cursor auf Bedienraten positionieren      */

    nextline(fp,buffer,512);
                
    if (!gefunden)
	dbgtext(55, "get_asym(): kein Zusatzblock gefunden\n");


    for (k=0; k<np->klass; k++)
    {
	for (i=0; i<np->knot; i++)
	{
	    if (np->knotentyp[i]==TYP20 || np->knotentyp[i]==TYP21)
	    { 
		asym_data.bedrate[k][i] = (double *)
		    calloc((size_t)(np->bede[i]), sizeof(double));

		for(j=0; j<np->bede[i]; j++)
		{
		    if (gefunden)
		    {
			if (fGetBedRate(fp, &dTemp))
			{
			    asym_data.bedrate[k][i][j] = dTemp;
			}
			else
			{
			    dbgtext(0, "get_asym(): ERROR - missing entry in asymblock!\n");
			    exit(2);
			}
		    }
		    else
		    {
			asym_data.bedrate[k][i][j] = np->bedr[i][k];
		    }
		}

		if (dbg>50)
		    for(j=0; j<np->bede[i]; j++)
			fprintf(stderr, "get_asym(): Bedrate BedEinheit %d: %f\n",
				j, asym_data.bedrate[k][i][j]);

		qsort((void *)(asym_data.bedrate[k][i]),
		      (size_t)(np->bede[i]),
		      (size_t)(sizeof(double)),
		      (int (*)())(fDoubleComp));

		if (dbg>50)
		    for(j=0; j<np->bede[i]; j++)
			fprintf(stderr, "get_asym(): Bedrate BedEinheit %d: %f\n",
				j, asym_data.bedrate[k][i][j]);
	    }
	}
    }
}

