/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  D-91058 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define GET_KNOTTYP_C

static char *SccsId = "@(#)PEPSY:\tget_knottyp.c\t1.13\t95/05/22 10:48:56";

#include <stdio.h>
#include <string.h>
#include "libpepsy.h"
#include "d_debug.h"
#define	EXTERN_KNOTENTYPEN
#include "d_konst.h"

extern	int	atoi();
extern	int	dbg;

/************************************************************************/
/*									*/
/*	get_knottyp()							*/
/*									*/
/*	Aufrufparameter:						*/
/*	- string : 	Aktueller Knotentyp (z.B. M/M/1-FCFS)		*/
/*									*/
/*	Diese Funktion stellt in 'string' den Knotentyp fest und	*/
/*	und liefert interne Codierung zurueck (gesetztes Bit in Maske)	*/
/*	Dabei spielen fuehrende und abschliessende blanks und Tabs	*/
/*	keine Rolle (d.h. werden ignoriert.				*/
/*									*/
/************************************************************************/

int get_knottyp(knoten)
char	*knoten;
{
    char	*cp;
    char	*cp2;
    char	*prototype;
    int		i;


    dbginfo(55, "get_knottyp(%s)\n",knoten);

    /*
       fuehrende blanks und tabs entfernen
       */
    while(*knoten == ' ' || *knoten == '\t')
	knoten++;

    if (*knoten=='?')	/* ??? entspricht Knotentyp 0 */
	return (0);

    prototype=strdup(knoten);

    if ((i = atoi(&knoten[4])) > 1)
	prototype[4] = 'm';

	
    cp = knoten;

    while( *cp != '-' )
	cp++;


    cp2 = &prototype[5];

    while( *cp != '\0' && *cp != '\n' && *cp != ' ' && *cp != '\t' ) 
	*cp2++ = *cp++;

    *cp2   = '\0';


    dbginfo(59, "get_knottyp(): '%s'\n", prototype);
	
    for (i=1; i<=ANZAHL_KNOTENTYPEN; i++)
    {
	if (!strcmp(prototype, knotentypen[i]))
	{
	    free(prototype);
	    return(1<<(i-1));
	}

    }

    free(prototype);

    return(-1);
}








