/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define GET_MEM_C

static char *SccsId = "@(#)PEPSY:\tget_mem.c\t1.7\t94/04/25 16:44:30";

#include <stdio.h>
#include "d_netz.h"
#define	EXTERN_KNOTENTYPEN
#include "d_konst.h"
#include "d_debug.h"
#include "d_speicher.h"
#include "libpepsy.h"

extern netzstruktur netz;
extern double atof();
extern	int		strncmp();

extern	int dbg;

/* nach libpepsy.h
double **mem_ank_quadvar;
*/

static char zusatzblock[20];

void get_mem(fp)
FILE *fp;
{
	register netzstruktur *np = &netz;
	char buffer[5120], *cp;
	int gefunden, i,j;

	dbgtext(50, "get_mem()\n");

	if(np->haeuf == FALSE)
	{
		dbgtext(0, "get_mem(): ERROR - Verfahren 'mem' funktioniert nur mit Ueberganswahrscheinlichkeiten\n");
		exit(1);
	}

	if(( mem_ank_quadvar = d_2dim_alloc(np->knot,np->klass)) == (double **) 0) mall_err("get_mem");

	/*
		Zusatzblock in Eingabedatei suchen
	*/

	get_zusatzblock("mem",zusatzblock);
	gefunden = FALSE;
	rewind(fp);
	i = strlen(zusatzblock);
	while ( gefunden == FALSE && nextline(fp,buffer,5120) != EOF )
	{
		if (strncmp(zusatzblock,buffer,i) == 0)
		{
			dbginfo(55, "get_mem(): Zusatzblock %s gefunden\n", buffer);
			gefunden = TRUE;
		}
	}

	if (gefunden == TRUE)
	{
		nextline(fp,buffer,5120);
		nextline(fp,buffer,5120);
		nextline(fp,buffer,5120);
		for(i=0;i<np->knot;i++)
		{
			nextline(fp,buffer,5120);
			/* bis "|" lesen */
			cp = buffer;
			while(*cp != '\0' && *cp++ != '|')
				;

			dbginfo(60, "get_mem(): ank_quadvar %d : ", i);
			for(j=0;j<np->klass;j++)
			{
				while(*cp == ' ')
					cp++;

				dbginfo(65, "get_mem(): parse den Reststring '%s'.\n", cp);

				mem_ank_quadvar[i][j] = atof(cp);
				/*
				sscanf(cp,"%lf",&mem_ank_quadvar[i][j]);
				*/

				while(*cp != '\0' && (*cp != ' ' && *cp != '\n'))
					cp++;

				dbginfo(60, "%f ",mem_ank_quadvar[i][j]);
			}
			dbgtext(60, "\n");
		}
	}
	else
	{
		dbgtext(55, "get_mem(): kein Zusatzblock gefunden\n");

		for(i=0;i<np->knot;i++)
		{
			for(j=0;j<np->klass;j++)
			{
				mem_ank_quadvar[i][j] = 1.0;
				dbginfo(2, "get_mem: ank_quadvar[%d]", i);
				dbginfo(2, "[%d]=", j);
				dbginfo(2, "%f\n", mem_ank_quadvar[i][j]);
			}
		}
	}
}
