/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

#define GET_PREFIX_C

static char *SccsId = "@(#)PEPSY:\tget_prefix.c\t1.7\t93/06/24 12:48:27";

#include <stdio.h>
#include "d_debug.h"
#include "libpepsy.h"

extern	int strncmp();

extern	int	dbg;
static char *PEPSYHOME;
static char CODIERUNG[2048];

/*
	bestimmt aus Verfahrensname den internen Code

*/
#define BUFTEMP 5120

extern char *getenv();  /* eingefuegt kirschni */
extern int	strcat();

int get_prefix(buffer,verfahren)
char *buffer, *verfahren;
{
	FILE *fp, *fopen();
	char temp[BUFTEMP];
	int i = strlen(verfahren);

	if((PEPSYHOME = (char *)getenv("PEPSYHOME")) == (char *)NULL)
	{
		dbgtext(0, "get_prefix(): Enviroment Variable PEPSYHOME nicht definiert\n");
		exit(1);
	}

	strcpy(CODIERUNG,PEPSYHOME);
	strcat(CODIERUNG,"/infos/code.txt");

	dbginfo(50, "get_prefix(): %s ", verfahren);
	dbginfo(50, "%s\n", CODIERUNG);

	if((fp = fopen(CODIERUNG,"r")) == NULL)
		return(-2);

	while(nextline(fp,temp,BUFTEMP) != EOF)
	{
		dbginfo(55, "get_prefix: %s\n",temp);
		if(strncmp(verfahren,temp,i) == 0)
		{
			sscanf(temp,"%*s %s",buffer);
			dbginfo(56, "get_prefix: --> %s\n",buffer);
			fclose(fp);
			return(0);
		}
	}
	fclose(fp);
	return(-1);
}
		


/* 
	liest die zum Verfahren 'verfahren' gehoerige Spezifikationszeile

	Diese Funktion sollte ersetzt werden durch libpepsy.a:database.c:GetDBEntry()
*/

int get_spezi(buffer,verfahren)
char *buffer, *verfahren;
{
	FILE *fp, *fopen();
	char temp[BUFTEMP];
	int i = (int)strlen(verfahren);

	if((PEPSYHOME = getenv("PEPSYHOME")) == (char *)NULL)
	{
		dbgtext(0, "get_spezi(): Enviroment Variable PEPSYHOME nicht definiert\n");
		exit(1);
	}

	strcpy(CODIERUNG,PEPSYHOME);
	strcat(CODIERUNG,"/infos/code.txt");

	dbginfo(50, "get_spezi: %s\n",verfahren);

	if((fp = fopen(CODIERUNG,"r")) == NULL)
		return(-1);

	while(nextline(fp,temp,BUFTEMP) != EOF)
	{
		dbginfo(55, "get_spezi: %s\n",temp);

		if(strncmp(verfahren,temp,i) == 0)
		{
			dbginfo(55, "get_spezi: --> %s\n",temp);
			strcpy(buffer,temp);
			fclose(fp);
			return(0);
		}
	}
	fclose(fp);
	return(-1);
}
