/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

#define GET_SIM_C

static char *SccsId = "@(#)PEPSY:\tget_sim.c\t1.6\t93/06/24 12:48:29";

#include <stdio.h>
#include "d_netz.h"
#define	EXTERN_KNOTENTYPEN
#include "d_konst.h"
#include "d_debug.h"
#include "d_speicher.h"
#include "sim.h"
#include "libpepsy.h"

extern	double	atof();
extern	int		atoi();
extern	int		strncmp();

extern	netzstruktur netz;
extern	int	dbg;


/* nach libpepsy.h
struct prozess **general, *ankunft;
*/

static	char zusatzblock[1024];
static	char zeilenbuffer[1024];
static	int *kapazitaet;
static	int sim_dauer, deadlock, block_arrival;



void dateiende(string)
char *string;
{
	dbginfo(-1, "unerwartetes Dateiende [ %s ]\n", string);
	exit(1);
}

int get_sim(fp)
FILE *fp;
{
	register netzstruktur *np = &netz;
	char  *cp, *zbuf = &zeilenbuffer[0];
	int gefunden, i,j;

	dbgtext(50, "get_sim()\n");

	if(np->haeuf == FALSE)
	{
		dbgtext(-1, "Verfahren 'simulation' funktioniert nur mit Uebergangswahrscheinlichkeiten\n");
		exit(1);
	}
	if((kapazitaet = i_1dim_alloc(netz.knot)) == (int *) 0)
		mall_err("get_sim(1)");
	if((ankunft = (struct prozess *) calloc(np->klass , sizeof(struct prozess)))
		== (struct prozess *) 0)
		mall_err("get_sim(2)");
	if((general = (struct prozess **) calloc(np->knot , sizeof(struct prozess *)))
		== (struct prozess **) 0)
		mall_err("get_sim(3)");

	for(i=0;i<np->knot;i++)
	{
		if((general[i] = (struct prozess *) calloc(np->klass , sizeof(struct prozess )))
			== (struct prozess *) 0)
			mall_err("get_sim(3a)");
	}


	/* Zusatzblock in Eingabedatei suchen */

	get_zusatzblock("sim",zusatzblock);
	gefunden = FALSE;
	i = strlen(zusatzblock);
	rewind(fp);
	if (i!=0) /* kirschni 2.12.91 */
	{
		while ( gefunden == FALSE && nextline(fp,zbuf,1024) != EOF )
		{
			if (strncmp(zusatzblock,zbuf,i) == 0)
			{
				dbginfo(56, "get_sim(): Zusatzblock %s gefunden\n", zbuf);
				gefunden = TRUE;
			}
		}
	}

	if (gefunden == TRUE)
	{
		if(nextline(fp,zbuf,5120) == EOF) dateiende("get_sim(1)");
		if(nextline(fp,zbuf,5120) == EOF) dateiende("get_sim(2)");
		if(nextline(fp,zbuf,5120) == EOF) dateiende("get_sim(3)");
		for(i=0;i<np->klass;i++)
		{
			if(nextline(fp,zbuf,5120) == EOF) dateiende("get_sim(4a)");
			cp = zbuf ;
			while(*cp != '\0' && *cp++ != '|' ) ;
			sscanf(cp,"%d %lg %lg %lg %lg",&ankunft[i].code,
				&ankunft[i].wert1,
				&ankunft[i].wert2,
				&ankunft[i].wert3,
				&ankunft[i].wert4);

			if (dbg>56)   fprintf(stderr,"get_sim: ankunft %d  -- %d %g %g %g %g\n",
				i+1,ankunft[i].code,ankunft[i].wert1,ankunft[i].wert2,ankunft[i].wert3,ankunft[i].wert4);
		}
		if(dbg>56) fprintf(stderr,"\n");
		if(nextline(fp,zbuf,5120) == EOF) dateiende("get_sim(5)");
		for(j=0;j<np->klass;j++)
		{
			nextline(fp,zbuf,5120);
			nextline(fp,zbuf,5120);
			nextline(fp,zbuf,5120);
			for(i=0;i<np->knot;i++)
			{
				nextline(fp,zbuf,5120);
				cp = zbuf ;
				while(*cp != '\0' && *cp++ != '|' ) ;
				sscanf(cp,"%d %lg %lg %lg %lg",&general[i][j].code,
					&general[i][j].wert1,
					&general[i][j].wert2,
					&general[i][j].wert3,
					&general[i][j].wert4);

				if (dbg>56)   fprintf(stderr,"get_sim: general %d  %d  -- %d %g %g %g %g\n",
					i+1,j+1,general[i][j].code,general[i][j].wert1,general[i][j].wert2,general[i][j].wert3,general[i][j].wert4);
			}
		}
		dbgtext(56, "\n");
		nextline(fp,zbuf,5120);
		nextline(fp,zbuf,5120);
		nextline(fp,zbuf,5120);
		for(i=0;i<np->knot;i++)
		{
			nextline(fp,zbuf,5120);
			cp = zbuf ;
			while(*cp != '\0' && *cp++ != '|' ) ;
			sscanf(cp,"%d",&kapazitaet[i]);
			if(dbg>56)fprintf(stderr,"get_sim: kapazitaet %d : %d\n",i+1,kapazitaet[i]);
		}
		dbgtext(56, "\n");
		nextline(fp,zbuf,5120);
		nextline(fp,zbuf,5120);
		sim_dauer = atoi(zbuf);
		nextline(fp,zbuf,5120);
		nextline(fp,zbuf,5120);
		deadlock = atoi(zbuf);
		nextline(fp,zbuf,5120);
		block_arrival = atoi(zbuf);
		if(dbg>56)fprintf(stderr,"dauer %d, deadlock %d, block_arr %d\n",
			sim_dauer,deadlock,block_arrival);

	}
	else
	{
		for(i=0;i<np->klass;i++)
		{
			ankunft[i].code = 0;
			ankunft[i].wert1 = netz.ankr[i];
			ankunft[i].wert2 = 1.0;
			ankunft[i].wert3 = 0.0;
			ankunft[i].wert4 = 0.0;
			if (dbg>56)   fprintf(stderr,"get_sim: ankunft %d  -- %d %g %g %g %g\n",
				i+1,ankunft[i].code,ankunft[i].wert1,ankunft[i].wert2,ankunft[i].wert3,ankunft[i].wert4);
		}
		for(i=0;i<np->knot;i++)
		{
			for(j=0;j<np->klass;j++)
			{
				general[i][j].code = 0;
				general[i][j].wert1 = netz.bedr[i][j];
				general[i][j].wert2 = ( netz.quadvar[i][j] == -1.0 ? 1.0 : netz.quadvar[i][j]);
				general[i][j].wert3 = 0.0;
				general[i][j].wert4 = 0.0;
				if (dbg>56)   fprintf(stderr,"get_sim: general %d  %d  -- %d %g %g %g %g\n",
					i+1,j+1,general[i][j].code,general[i][j].wert1,general[i][j].wert2,general[i][j].wert3,general[i][j].wert4);
			}
		}
		for(i=0;i<np->knot;i++)
		{
			kapazitaet[i] = -1;
		}
		sim_dauer = 0;
		deadlock = 0;
		block_arrival = 0;
	}
	dbgtext(50, "get-sim done\n");
	return(0);
}
