/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define KTYP_INT2EXT_C

static char *SccsId = "@(#)PEPSY:\tktyp_int2ext.c\t1.8\t93/06/24 12:48:36";

#include "stdio.h"
#define	EXTERN_KNOTENTYPEN
#include "d_konst.h"
#include "d_netz.h"
#include "d_debug.h"
#include "libpepsy.h"

extern netzstruktur netz;
extern	int				dbg;

/*
* Implementierte Funktionen:
* --------------------------
*
*	int ktyp_int2ext(intern) unsigned int intern;
*
*		Der mit intern angegebene interne Knotentyp wird als externer Knotentyp zurueckgegeben
*
*  void change_knottyp();
*
*		Der Knotentyp aller Knoten der externen Struktur netzstruktur netz; wird von interner
*		zu externer Kodierung ueberfuehrt.
*		Benoetigt extern int dbg  !
*
*/


int ktyp_int2ext(intern)
unsigned int intern;
{
	int shift, maxshift;					/* momentan sind 15 verschiedene Typen bekannt */

	maxshift = sizeof(unsigned int)*8;

	for (shift=0; shift<=maxshift; shift++) {
		if (intern&1) {						/* rechtestes Bit gesetzt */
			if (intern!=1) {				/* noch weitere Bits gesetzt ... */
				dbginfo(60, "ktyp_int2ext(): 0x%x -> 0\n", intern);
				return(0);
			}
			dbginfo(60, "ktyp_int2ext(): 0x%x -> ", intern);
			dbginfo(60, "%d\n", shift+1);
			return(shift+1);
		}
		intern = intern >> 1;
	}
	dbginfo(60, "0x%x -> 0\n", intern);
	return(0);								/* Fehler: kein gesetztes Bit bis maxshift */
}

void change_knottyp()
{
	int i;

	for (i=0; i<netz.knot; i++) {
		netz.knotentyp[i] = ktyp_int2ext(netz.knotentyp[i]);
		if ((netz.knotentyp[i]==0)&&(dbg>50))
			fprintf(stderr,"change_knottyp(): ACHTUNG Knotentyp[%d] = 0!\n",i);
	}
}



unsigned int ktyp_ext2int(ext)
int	ext;
{
	int	intern=0;


	while (ext)
	{
		intern++;
		ext = ext>>1;
	}

	return(intern);
}
