/*
	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  D-91056 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.


	25.8.92	kirschni	Umgestellt auf dynamische Speicherverwaltung in verketteten Listen

	5.2.92	kirschni	Fehler behoben	wenn die Zahl der Eintraege in der textdatei zu hoch ist,
				lauft das Programm in eine Endlosschleife.
				Kosmetik		Einrueckungen, etc...
*/
#define LANGUAGE_C

static	char	*SccsId	= "@(#)PEPSY:\tlanguage.c\t1.19\t95/05/22 15:38:21";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>

#include "d_pepsy.h"
#include "d_debug.h"
#include "xxalloc.h"
#include "libpepsy.h"

typedef struct pl_e {
	struct pl_e		*next;
	char			*key;
	char			*text;
} pl_entry;
	

extern	int			dbg;

static	pl_entry	*PLDatabase;
static	char 		*progname;
static	char		textdatei[1024];
static	char		*PEPSYHOME;
static	char		INFO[2048];


int p_lang_init(datei)
char *datei;
{
    FILE 	*tfp;  						 /*  text file pointer  */
    char 	*lang;
    pl_entry	*akt_ple;
    pl_entry	*last_ple;
    char	*c;
    char	*d;
    char	*s;
    static	char		dummy[1024];


    dbginfo(50, "p_lang_init(%s)\n", datei);
    
    if((PEPSYHOME = getenv("PEPSYHOME")) == NULL)
    {
	dbgtext(-1, "p_lang_init: Enviroment Variable PEPSYHOME nicht definiert\n");
	exit(1);
    }

    strcpy(INFO,PEPSYHOME);
    strcat(INFO,"/infos");

    if((progname = strrchr(datei,'/')) == NULL)
	progname = datei;
    else
	progname++;

    lang=getenv("PEPSYLANG");
    
    strcpy(textdatei,INFO);
    strcat(textdatei,"/");
    strcat(textdatei,progname);
    strcat(textdatei,".");
    
    if (lang!=NULL)
    {
	strncat(textdatei,lang, 2);  /* append the maximum of two char's 26.02.92 kirschni */
    
	dbginfo(55, "p_lang_init(): Steuerdatei '%s'.\n", textdatei);
    }
    else
    {
	fprintf(stderr, "WARNING! $PEPSYLANG not set! Using default 'english'!");
	strncat(textdatei, "en", 2);
    }

    if((tfp=fopen(textdatei,"r")) == NULL)
    {
	dbginfo(55, "p_lang_init(): fopen '%s' failed!\n", textdatei);

	strcpy(textdatei,INFO);
	strcat(textdatei,"/");
	strcat(textdatei,progname);
	strncat(textdatei,".deutsch", 3);

	dbginfo(55, "p_lang_init(): Steuerdatei '%s'.\n", textdatei);

	if((tfp=fopen(textdatei,"r")) == NULL)
	{
	    fprintf(stderr,"%s ??\n",textdatei);
	    return(-1);
	}
    }

    last_ple	= PLDatabase;
    if (last_ple != (pl_entry *)NULL)
	while(last_ple->next)
	    last_ple = (pl_entry *)last_ple->next;

    while (nextline(tfp, dummy, 1024)!=EOF)
    {
	/* erst mal fuehrende blanks entfernen
	 */
	c=dummy;
	while (*c && isspace(*c))
	    c++;

	akt_ple	       	= (pl_entry *)malloc(sizeof(pl_entry));
	akt_ple->next	= (pl_entry *)NULL;
	akt_ple->key	= strdup(c);

	c = akt_ple->key;

	while (*c != ' ' && *c != '\t' && *c != '\0')
	    c++;

	if (*c != '\0')
	{
	    *c = '\0';
	    c++;
	}

	akt_ple->text	= c;

	/* Newline am Ende der Zeile kappen */
	c = strrchr(akt_ple->text, '\n');
			
	if (c)
	    *c = '\0';

#if 0

	/*	so, neues Feature:
		"\n" wird ersetzt durch ' \n'
		*/
	s = d = akt_ple->text;

	while(*s)
	{
	    switch(*s)
	    {
	    case '\\' :	s++;
		if (*s == 'n')
		    *d='\n';
		else
		{
		    *d='\\';
		    d++;
		    *d=*s;
		}
		break;
	    default:	*d = *s;
		break;
	    }
	    d++;
	    s++;
	}
	*d = '\0';
#endif
	if (last_ple != (pl_entry *)NULL)
	    last_ple->next = (pl_entry *)akt_ple;
	else
	{
	    PLDatabase	= akt_ple;
	}
	last_ple	= akt_ple;
    }

    if (dbg > 95)
    {
	fprintf(stderr, "PLDatabase Dump :\n");

	akt_ple = PLDatabase;

	while(akt_ple)
	{
	    fprintf(stderr, "PLEntry: '%s'-'%s'\n", akt_ple->key, akt_ple->text);
	    akt_ple = (pl_entry *)akt_ple->next;
	}
    }

    return(0);
}


char *spr(kenner)
char *kenner;
{
	pl_entry	*akt_ple;
	static char default_kenner[]="Kenner xxxxxx undefiniert"; /* 05.02.90 kirschni */

	akt_ple	= PLDatabase;

	while(akt_ple)
	{
		if (!strncmp(akt_ple->key, kenner, 6)) 
				return (akt_ple->text);

		akt_ple = (pl_entry *)akt_ple->next;
	}

	return((char *)(strncpy((char *)(default_kenner+7), kenner, 6)-7));
}


char *center(wort, spalten)
char *wort;
int	spalten;
{
	int		i;
	char	*ausgabe,
			*leerz;


	ausgabe=(char *)calloc(1,spalten+1);
	leerz  =(char *)calloc(1,spalten+1);
	for (i=0;i<(int)((spalten-strlen(wort))>>1);i++)
		strcat(leerz," ");
	strcpy(ausgabe,leerz);
	strcat(ausgabe,wort);
	free(leerz);
	return(ausgabe);
}
