/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define MEMORY_H


static char *SccsId = "@(#)PEPSY:\tmemory.c\t1.5\t93/06/24 12:48:42";


/*********************************************************************
***                                                                ***
***  Modul:     m e m o r y . c                                    ***
***                                                                ***
***----------------------------------------------------------------***
***                                                                ***
***  Inhalt:    Verweise auf entspechende Funktionen bei xxalloc   ***
***                                                                ***
**********************************************************************/

#include <stdio.h>
#include "d_debug.h"
#include "xxalloc.h"
#include "libpepsy.h"

extern	int	dbg;

float 	***f_3dim_alloc(dim1,dim2,dim3)
int 	dim1,
dim2,
dim3;
{
	return f3_alloc(0,dim1-1, 0,dim2-1, 0,dim3-1);
}

double 	***d_3dim_alloc(dim1,dim2,dim3)
int 	dim1,
dim2,
dim3;
{
        return d3_alloc(0,dim1-1, 0,dim2-1, 0,dim3-1);
}

float 	**f_2dim_alloc(dim1,dim2)
int 	dim1,
dim2;
{
        return f2_alloc(0,dim1-1, 0,dim2-1);
}

double	**d_2dim_alloc(dim1,dim2)
int 	dim1,
dim2;
{
        return d2_alloc(0,dim1-1, 0,dim2-1);
}

char	**c_2dim_alloc(dim1,dim2)
int 	dim1,
dim2;
{
        return c2_alloc(0,dim1-1, 0,dim2-1);
}

int	*i_1dim_alloc(dim1)
int 	dim1;
{
        return i1_alloc(0,dim1-1);
}

float	*f_1dim_alloc(dim1)
int 	dim1;
{
        return f1_alloc(0,dim1-1);
}

double	*d_1dim_alloc(dim1)
int	dim1;
{
        return d1_alloc(0,dim1-1);
}

void f_3dim_free(ptr,dim1,dim2,dim3)
float 	***ptr;
int   	dim1,
dim2,
dim3;
{
	f3_free(ptr, 0,dim1-1, 0,dim2-1, 0,dim3-1);
}

void d_3dim_free(ptr,dim1,dim2,dim3)
double 	***ptr;
int   	dim1,
dim2,
dim3;
{
        d3_free(ptr, 0,dim1-1, 0,dim2-1, 0,dim3-1);
}

void f_2dim_free(ptr,dim1,dim2)
float 	**ptr;
int   	dim1,
dim2;
{
        f2_free(ptr, 0,dim1-1, 0,dim2-1);
}

void d_2dim_free(ptr,dim1,dim2)
double 	**ptr;
int   	dim1,
dim2;
{
        d2_free(ptr, 0,dim1-1, 0,dim2-1);
}

void i_1dim_free(ptr,dim1)
int    	*ptr;
int	dim1;
{
        i1_free(ptr, 0,dim1-1);
}

void f_1dim_free(ptr,dim1)
float	*ptr;
int	dim1;
{
        f1_free(ptr, 0,dim1-1);
}

void d_1dim_free(ptr,dim1)
double 	*ptr;
int	dim1;
{
        d1_free(ptr, 0,dim1-1);
}

void c_2dim_free(ptr,dim1,dim2)
char	**ptr;
int   	dim1,
dim2;
{
        c2_free(ptr, 0,dim1-1, 0,dim2-1);
}

void mall_err(string)
char *string;
{
        dbgtext(-1, "\007Fehler bei 'malloc', zu wenig Speicherplatz\007\n");
        exit(1);
}

