/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define SPEICHER_C

static char *SccsId = "%Z%PEPSY:\t%M%\t%R%.%L%\t%D% %T%";

#include "d_pepsy.h"
#include "d_netz.h"
#include "d_speicher.h"
#define EXTERN_KNOTENTYPEN
#include "d_konst.h"
#include "libpepsy.h"


extern netzstruktur netz;	/* Eingabedatenstruktur		*/

int sp_alloc()
{
    netz.knotname	= c_2dim_alloc(netz.knot, NAM_LAENGE);
    netz.knotentyp	= i_1dim_alloc(netz.knot);
    netz.bede		= i_1dim_alloc(netz.knot);
    netz.offen		= i_1dim_alloc(netz.klass);
    netz.auftr		= i_1dim_alloc(netz.klass);
    netz.ankr		= d_1dim_alloc(netz.klass);
    netz.bedr		= d_2dim_alloc(netz.knot, netz.klass);
    netz.besh		= d_2dim_alloc(netz.knot, netz.klass);
    netz.quadvar	= d_2dim_alloc(netz.knot, netz.klass);

    if (netz.knotname && netz.knotentyp && netz.bede && netz.offen && netz.auftr &&
	netz.ankr && netz.bedr && netz.besh && netz.quadvar)
    {
	return(1);
    }
    else
    {
	sp_free();
	return(0);
    }
}


void sp_free()
{
	if (netz.knotname)	c_2dim_free(netz.knotname,netz.knot,NAM_LAENGE);
	if (netz.knotentyp)	i_1dim_free(netz.knotentyp,netz.knot);
	if (netz.bede)		i_1dim_free(netz.bede,netz.knot);
	if (netz.offen)		i_1dim_free(netz.offen,netz.knot);
	if (netz.auftr)		i_1dim_free(netz.auftr,netz.klass);
	if (netz.ankr)		d_1dim_free(netz.ankr,netz.klass);
	if (netz.bedr)		d_2dim_free(netz.bedr,netz.knot,netz.klass);
	if (netz.besh)		d_2dim_free(netz.besh,netz.knot,netz.klass);
	if (netz.quadvar)	d_2dim_free(netz.quadvar,netz.knot,netz.klass);
	if (netz.uew)		f_3dim_free(netz.uew, netz.knot+1, netz.knot+1, netz.klass);

	netz.knotname	= NULL;
	netz.knotentyp	= NULL;
	netz.bede	= NULL;
	netz.offen	= NULL;
	netz.auftr	= NULL;
	netz.ankr	= NULL;
	netz.bedr	= NULL;
	netz.besh	= NULL;
	netz.quadvar	= NULL;
	netz.uew	= NULL;
}
