/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define ZEICHEN_C


static char *SccsId = "@(#)PEPSY:\tzeichen.c\t1.8\t93/06/24 12:48:47";


#include <ctype.h>
#include "d_pepsy.h"
#define	EXTERN_KNOTENTYPEN
#include "d_konst.h"
#include "libpepsy.h"

extern	int		atoi();
extern	char	*strncpy();

/*
	lesen einer Zeile im Fenster 'win' der maximalen Laenge 'laenge-1'
	der Rest der Zeile wird ueberlesen
*/

static char buf[5120];



void p_fehler(fmt,arg1,arg2,arg3,arg4)
char *fmt;
int arg1,arg2,arg3,arg4;
{
	wmove(win4,0,0);
	werase(win4);
	wprintw(win4,fmt,arg1,arg2,arg3,arg4);
	wrefresh(win4);
}


void p_fill(win,x,y,c,laenge)
WINDOW *win;
char c;
int x, y, laenge;
{
	int i,j;

	getyx(win,i,j);
	while(laenge--)
		mvwaddch(win,x,y+laenge,c);
	wmove(win,x,y);
	wrefresh(win);
}


void ll_string(win,buf,laenge)
WINDOW *win;
char buf[];
int laenge;
{
	int x,y,c;
	int l = 0;

	getyx(win,y,x);

#define MIN( a, b) ( (a) < (b) ? (a) : (b) )

/*
	p_fill(win,y,x,'.',MIN(laenge, 10));
*/

	while(l < laenge-1)
	{
		switch(c = wgetch(win))
		{
			case '\b':
				if(l > 0)
				{
					buf[l--] = ' ';
					waddch(win,'\b');
					waddch(win,' ');
					waddch(win,'\b');
					wrefresh(win);
				}
				break;
			case '\r':
			case '\n':
				buf[l++] = '\0';
				return;
	/*			break;				*/
			default:
				buf[l++] = (char) c;
				waddch(win,c);
				wrefresh(win);
				break;
		}
	}
	while((c=wgetch(win)) != '\n' && c != '\r' )
		;

	buf[laenge-1] = '\0';
	return;
}
					

void l_text(buf,vor,laenge)
char *buf,*vor;
int	laenge;
{
	ll_string(win3,buf,laenge);


	if(buf[0] == '\0')
		strncpy(buf,vor,laenge);

	return;
}

int l_integer(wert,def,ug,og,laenge)
int wert, def, ug, og, laenge;
{
	int korrekt = FALSE;
	int x,y;

	getyx(win3,y,x);

	do
	{
		ll_string(win3,buf,20);
		if((wert = atoi(buf)) < ug || wert > og)
		{
			p_fehler("%d ausserhalb des zulaessigen Bereiches %d,%d",
				wert,ug,og);
			p_fill(win3,y,x,' ',20);
			wmove(win3,y,x);
		}
		else
		{
			korrekt = TRUE;
		}
	}
	while( ! korrekt);

	return(wert);
}



void d_fehler(fmt,arg1,arg2,arg3,arg4)
char *fmt;
double arg1,arg2,arg3,arg4;
{
/*	flash(); 	*/
	wmove(win4,0,0);
	werase(win4);
	wprintw(win4,fmt,arg1,arg2,arg3,arg4);
	wrefresh(win4);
}

		


double l_double(wert,def,ug,og,laenge)
double wert,ug,og;
int		def, laenge;
{
	int korrekt = FALSE;
	int x,y,j;
	int parse();
	double ergebnis;

	getyx(win3,y,x);

	do
	{
		ll_string(win3,buf,20);
		j = parse(buf,&ergebnis);
		if(ergebnis < ug || ergebnis > og || j != 0)
		{
			d_fehler("%g ausserhalb des zulaessigen Bereiches %g,%g",
				wert,ug,og);
			p_fill(win3,y,x,' ',20);
			wmove(win3,y,x);
		}
		else
		{
			korrekt = TRUE;
		}
	}
	while( ! korrekt);

	return(ergebnis);
}
