/*
	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define ZUSATZBLOCK_C

static char *SccsId = "@(#)PEPSY:\tzusatzblock.c\t1.3\t93/06/24 12:48:49";

#include <stdio.h>
#include "d_debug.h"
#include "d_file.h"
#include "database.h"
#include "libpepsy.h"

#define	MAXLINE	255

extern	int dbg;


extern	int	strncmp();


int check_zusatzblock(p, m, z)
char *p;
char *m;
char *z;
{
	/*
		testet, ob in der Modellbeschreibung des Modells m im Pfad p
		schon der zustatzblock z vorhanden ist.

		returns:
		0		der zusatzblock ist vorhanden
		1		der zusatzblock wurde nicht gefunden, oder ein Fehler trat auf
	*/
	FILE	*mfp;
	char	line[MAXLINE];
	int		found,
			zlength,
			status;


	dbginfo(50, "check_zusatzblock(%s)\n", z);

	if((mfp = Pepsy_fopen(PFT_MODEL, p, m, "r")) != (FILE *)NULL)
	{
		zlength = strlen(z);
		found	= 0;

		do
		{
			status = getline(mfp, line, MAXLINE);

			dbginfo(55, "check_zusatzblock() %d=LINE=", status);
			dbginfo(55, "%s\n", line);

			if (!strncmp(line, z, strlen(z)))
			{
				found = 1;
			}

			dbginfo(55, "check_zusatzblock() FOUND=%d\n", found);
		}
		while ((status != EOF) && !found);

		fclose(mfp);
	}
	else
	{
		perror("Pepsy_fopen()");
		exit(1);
	}

	return((found)?0:1);
}


int zusatzblock_notwendig(m, v)
char *m;
char *v;
{
	/*
		es wird untersucht, ob fuer die Anwendung des Verfahrens v
		auf das Modell m noch die eingabe eines Zusatzblockes notwendig ist.

		returns:
		0		es ist kein Zusatzblock mehr notwendig, oder alle notwendigen
				informationen sind vorhanden
		1		der Zusatzblock muss noch eingegeben werden

	*/
	pdb_entry_t	*pdbe;

	
	pdbe = GetDBEntry(v);

	if (pdbe)
	{
		dbginfo(55, "zusatzblock_notwendig(): Entry %s\n", v);

		if (strncmp(pdbe->zusatzblock, "-", 1) != 0)
			if (check_zusatzblock(NULL, m, pdbe->zusatzblock))
				return(1);
	}
	
	return(0);
}
