/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define LZ_GET_KOEFFS_C

static char *SccsId = "@(#)PEPSY:\tget_koeffs.c\t1.5\t93/06/25 12:05:20";


#include <stdio.h>
#include "d_pepsy.h"
#include "d_netz.h"
#include "d_speicher.h"
#include "libpepsy.h"
#include "libzusatz.h"

extern int dbg;
extern netzstruktur netz;	/* Eingabedatenstruktur		*/

void get_varkoeffs()
{
	netzstruktur *np = &netz;
	int i,j;
	
	werase(win3);
	mvwprintw(win3,2,10,spr("getv01"));
	mvwprintw(win3,3,10,spr("getv02"));
	mvwprintw(win3,5,10,spr("getv03"));

	for(i=0;i<np->knot;i++)
	{
		mvwprintw(win3,7+i,10,"%s %2d    ",spr("getv04"),i+1);
		for(j=0;j<np->klass;j++)
		{
			if(np->uew[0][i+1][j] != 0.0)
				mvwprintw(win3,7+i,23+9*j,"......");
			else
			{
				mvwprintw(win3,7+i,23+9*j,"-");
				varkoeffs[i][j] = 1.0;
			}
		}
	}
	wmove(win3,7,23);
	wrefresh(win3);

	for(i=0;i<np->knot;i++)
	{
		mvwprintw(win3,7+i,10,"%s %2d    ",spr("getv05"),i+1);
		for(j=0;j<np->klass;j++)
		{
			if(np->uew[0][i+1][j] != 0.0)
			{
				wmove(win3,7+i,23+9*j);
				wrefresh(win3);
				varkoeffs[i][j] = l_double(varkoeffs[i][j],0,0.0,DOUBLE_MAX,7);
				mvwprintw(win3,7+i,23+9*j,"%7.4f",varkoeffs[i][j]);
			}
			else
			{
				mvwprintw(win3,7+i,23+9*j,"-");
			}
		}
		wrefresh(win3);
	}
}
