/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define LZ_SIM_GEN_C


static char *SccsId = "@(#)PEPSY:\tsim_gen.c\t1.5\t93/06/25 12:05:22";


#include <math.h>
#include "d_netz.h"
#include "d_pepsy.h"
#define	EXTERN_KNOTENTYPEN
#include "d_konst.h"
#include "d_sonder.h"
#include "d_speicher.h"
#include "libpepsy.h"
#include "libzusatz.h"


#define MAXDOUBLE 10000.0

extern	netzstruktur	netz;

static	int				wunsch = 1;

void sim_gen()
{
	for(;;)
	{
		/* Fenster 3 loeschen */
		werase(win3);

		/* Formular ausgeben */

		mvwaddstr(win3,3,8,spr("simg01"));
		mvwaddstr(win3,4,8,spr("simg02"));
		mvwaddstr(win3,7,8,spr("simg03"));
		mvwaddstr(win3,8,8,spr("simg04"));
		mvwaddstr(win3,9,8,spr("simg05"));
		mvwaddstr(win3,10,8,spr("simg06"));
		mvwaddstr(win3,11,8,spr("simg07"));
		mvwaddstr(win3,13,8,spr("simg08"));
		wmove(win3,13,53);
		wrefresh(win3);

		/* Formular ausfuellen */

		wunsch = l_integer(wunsch,0,1,5,2);
		mvwprintw(win3,13,53,"%-2d",wunsch);
		wrefresh(win3);
		
		switch(wunsch)
		{
			case 1:
				sim_ankunft();
				break;
			case 2:
				sim_general();
				break;
			case 3:
				sim_kapazitaet();
				break;
			case 4:
				sim_dauer();
				break;
			default:
				return;
		}
	}
}

void sim_ankunft()
{
	int i;

	if((ankunft = (struct prozess *) malloc(netz.klass * sizeof(struct prozess))) == (struct prozess *) 0)
		mall_err(spr("sima01"));

	for(i=0;i<netz.klass;i++)
	{
		if(netz.ankr[i] != 0.0)
		{
			werase(win3);
			mvwaddstr(win3,3,6,spr("sima02"));
			mvwaddstr(win3,5,6,spr("sima03"));
			mvwaddstr(win3,6,6,spr("sima04")); 
			mvwaddstr(win3,7,6,spr("sima05"));
			mvwaddstr(win3,8,6,spr("sima06"));
			mvwprintw(win3,10,6,"%s %-2d   ..",spr("sima07"),i+1);
			wmove(win3,10,18);
			wrefresh(win3);

			ankunft[i].code = l_integer(ankunft[i].code,0,0,3,2);
			ankunft[i].wert1 = netz.ankr[i];
			mvwprintw(win3,12,6,spr("sima08"));
			mvwprintw(win3,13,6,spr("sima09"));
			mvwprintw(win3,15,6,"%s %-2d   ......",spr("sima10"),i+1);
			wmove(win3,15,18);
			wrefresh(win3);
			ankunft[i].wert2 = l_double(ankunft[i].wert2,0,0.0,1000.0,6);

			get_prozess(&ankunft[i]);
		}
		else
		{
			ankunft[i].code = 0;
			ankunft[i].wert1 = 0.0;
			ankunft[i].wert2 = 0.0;
			ankunft[i].wert3 = 0.0;
			ankunft[i].wert4 = 0.0;
		}
	}
}

void sim_dauer()
{

	werase(win3);

	mvwaddstr(win3,6,12,spr("sida01"));
	wmove(win3,6,52);
	wrefresh(win3);

	simulationsdauer = l_integer(simulationsdauer,0,1000,999999999,10);
	mvwprintw(win3,6,52,"%-10d      ",simulationsdauer);
	wrefresh(win3);
}


void sim_kapazitaet()
{
	int i;

	if((kapazitaet = i_1dim_alloc(netz.knot)) == (int *) 0) mall_err(spr("sida02"));

	werase(win3);
	mvwaddstr(win3,2,6,spr("sida03"));
	mvwaddstr(win3,3,6,spr("sida04"));
	for(i=0;i<netz.knot;i++)
	{
		mvwprintw(win3,5+i,6,"%s %2d      ....",spr("sida05"),i+1);
	}
	wmove(win3,5,21);
	wrefresh(win3);

	for(i=0;i<netz.knot;i++)
	{
		kapazitaet[i] = l_integer(kapazitaet[i],0,-1,1000,5);
		mvwprintw(win3,5+i,21,"%-5d",kapazitaet[i]);
		wmove(win3,5+i+1,21);
		wrefresh(win3);
	}
	werase(win3);
	mvwaddstr(win3,2,3,spr("sida06"));
	mvwaddstr(win3,3,3,spr("sida07"));
	mvwaddstr(win3,5,3,spr("sida08"));
	mvwaddstr(win3,6,3,spr("sida09"));
	mvwaddstr(win3,8,3,"..");
	wmove(win3,8,3);
	wrefresh(win3);
	deadlock = l_integer(deadlock,0,0,1,2);
	mvwprintw(win3,8,3,"%-3d",deadlock);
	wrefresh(win3);

	if(netz.typ != GESCHLOSSEN)
	{
		mvwaddstr(win3,10,3,spr("sida10"));
		mvwaddstr(win3,11,3,spr("sida11"));
		mvwaddstr(win3,13,3,spr("sida12"));
		mvwaddstr(win3,14,3,spr("sida13"));
		mvwaddstr(win3,16,3,"..");
		wmove(win3,16,3);
		wrefresh(win3);
		blockarrival = l_integer(blockarrival,0,0,1,2);
		mvwprintw(win3,16,3,"%-3d",blockarrival);
		wrefresh(win3);
	}
}

void sim_general()
{
	int i,j,k;

	if((general = (struct prozess **) malloc(netz.knot * sizeof(struct prozess))) == ( struct prozess **) 0)
		mall_err("sim_general(1)");
	for(i =0; i<netz.knot;i++)
	{
		if((general[i] = (struct prozess *) malloc(netz.klass*sizeof(struct prozess))) == (struct prozess *) 0)
			mall_err("sim_general(2)");
	}

	for(i=0;i<netz.knot;i++)
	{
		for(j=0;j<netz.klass;j++)
		{
			k = netz.knotentyp[i];
			if( k & ( TYP1|TYP2|TYP10|TYP11|TYP16|TYP17))
			{
				general[i][j].code = 0;
				general[i][j].wert1 = netz.bedr[i][j];
				general[i][j].wert2 = netz.quadvar[i][j];
				general[i][j].wert3 = 0.0;
				general[i][j].wert4 = 0.0;
			}
			else
			{
				werase(win3);
				mvwaddstr(win3,3,6,spr("sige01"));
				mvwaddstr(win3,5,6,spr("sige02"));
				mvwaddstr(win3,6,6,spr("sige03")); 
				mvwaddstr(win3,7,6,spr("sige04"));
				mvwaddstr(win3,8,6,spr("sige05"));

				mvwprintw(win3,10,6,"%s %2d  %s %-2d  .. ",spr("sige06"),i+1,spr("sige07"),j+1);
				wmove(win3,10,28);
				wrefresh(win3);

				general[i][j].code = l_integer(general[i][j].code,0,0,3,2);
				general[i][j].wert1 = netz.bedr[i][j];
				general[i][j].wert2 = netz.quadvar[i][j];
				get_prozess(&general[i][j]);
			}
		}
	}
}


	
void get_prozess(spezi)
struct prozess *spezi;
{
	double mean, var;

	switch(spezi->code)
	{
		case 0:	/* automatisch */
		case 2: /* automatisch, version 2*/
			break;
		case 1: /* Lognormal */
			break;
	}
	wrefresh(win3);
	switch(spezi->code)
	{
		case 0:	/* automatisch */
		case 2: /* automatisch, version 2*/
			spezi->wert3 = 0.0;
			spezi->wert4 = 0.0;
			break;
		case 1: /* Lognormal */
			spezi->wert1 = 1.0/spezi->wert1;
			mean = spezi->wert1;
			var = spezi->wert2 * mean * mean;
			spezi->wert2 = 0.0;
			spezi->wert3 = 10000 * mean;
			spezi->wert4 = sqrt(var);
			break;
	}
}
