/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define LZ_Z_HIER_C

static char *SccsId = "@(#)PEPSY:\tz_hier.c\t1.6\t93/06/25 12:05:25";

#include <stdio.h>
#include "d_pepsy.h"
#include "d_netz.h"
#include "d_speicher.h"
#include "d_debug.h"
#include "libein.h"
#include "libzusatz.h"


extern int dbg;
extern netzstruktur netz;
extern char datei[];
extern char verfahren[], zusatzblock[];

void z_hier()
{
	netzstruktur *np = &netz;
	int i,k;
	FILE *fpout;

	dbgtext(50, "z_hier()\n");

	/* Initialisierung des Bildschirms */
	init_schirm();
	w_schirm();
	fenster1();
	fenster2(2);


	/* Angabe der Loesungshierachie */
	k = get_hier();

	e_schirm();

	/* An das Ende der Datei gehen */

	if ((fpout = fopen(datei,"a")) == NULL)
	{
		fprintf(stderr,"%s %s %s\n",spr("zhie02"),datei,spr("zhie03"));
		exit(8);
	}

	/* Zusatzblock abspeichern */

	fprintf(fpout,"%s\n\n", zusatzblock);

	fprintf(fpout,"%s  %d\n\n",spr("zhie04"),k);
	fprintf(fpout,"%s\n\n",spr("zhie05"));
	fprintf(fpout,"%s \n",spr("zhie06"));
	fprintf(fpout,"-----------+----------------------------\n");
	for(i=0;i<np->knot;i++)
	{
		fprintf(fpout,"%s %2d  | ",spr("zhie07"),i+1);
		fprintf(fpout,"%d ",np->teilnr[i]);
		fprintf(fpout,"\n");
	}
	fprintf(fpout,"\n\n");
}
