/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define LZ_Z_MEM_C

static char *SccsId = "@(#)PEPSY:\tz_mem.c\t1.8\t93/06/25 14:44:32";

#include <stdio.h>
#include "d_pepsy.h"
#include "d_netz.h"
#define	EXTERN_KNOTENTYPEN
#include "d_konst.h"
#include "d_speicher.h"
#include "d_debug.h"
#include "libzusatz.h"
#include "libein.h"


extern int dbg;
extern netzstruktur netz;
extern char datei[];
extern char verfahren[], zusatzblock[];

void z_mem()
{
	netzstruktur *np = &netz;
	int i,j;
	FILE *fpout;

	dbgtext(50, "z_mem()\n");

	if(np->haeuf == FALSE)
	{
		fprintf(stderr,"%s %s\n",verfahren,spr("zmem02"));
		exit(6);
	}
	if (np->typ == GESCHLOSSEN && ( strcmp(verfahren,spr("zmem03")) == 0 || strcmp(verfahren,spr("zmem04")) == 0))
	{
		fprintf(stderr,"%s %s\n",verfahren,spr("zmem05"));
		exit(7);
	}
	if(np->typ == GESCHLOSSEN && strcmp(verfahren,spr("zmem06")) == 0)
	{
		fprintf(stderr,"%s %s\n",verfahren,spr("zmem07"));
		exit(7);
	}

	if(np->klass > 1 && ( strcmp(verfahren,spr("zmem08")) == 0 || strcmp(verfahren,spr("zmem09")) == 0))
	{
		fprintf(stderr,"%s %s\n",verfahren,spr("zmem10"));
		exit(8);
	}
	if((varkoeffs = d_2dim_alloc(np->knot,np->klass)) == 0) exit(1);
	/* Initialisierung des Bildschirms */
	init_schirm();
	w_schirm();
	fenster1();
	fenster2(2);


	/* Zusatzeingabe fuer EPA-Verfahren */
	get_varkoeffs();

	e_schirm();

	/* An das Ende der Datei gehen */

	if ((fpout = fopen(datei,"a")) == NULL)
	{
		fprintf(stderr,"%s %s %s\n",spr("zmem11"),datei,spr("zmem12"));
		exit(8);
	}

	/* Zusatzblock abspeichern */

	fprintf(fpout,"%s\n\n", zusatzblock);

	fprintf(fpout,"%s\n\n",spr("zmem13"));
	fprintf(fpout,"%s \n",spr("zmem14"));
	fprintf(fpout,"-----------+----------------------------\n");
	for(i=0;i<np->knot;i++)
	{
		fprintf(fpout,"%s %2d  | ",spr("zmem15"),i+1);
		for(j=0;j<np->klass;j++)
		{
			fprintf(fpout,"%10g ",varkoeffs[i][j]);
		}
		fprintf(fpout,"\n");
	}
	fprintf(fpout,"\n\n");
}
