/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/
#define LZ_Z_SIM_C

static char *SccsId = "@(#)PEPSY:\tz_sim.c\t1.7\t93/06/25 12:05:30";

#include <stdio.h>
#include "d_pepsy.h"
#include "d_netz.h"
#include "d_speicher.h"
#include "d_debug.h"
#include "libzusatz.h"
#include "libein.h"


extern	int				dbg;
extern	netzstruktur	netz;
extern	char			datei[],
						verfahren[],
						zusatzblock[];

void z_sim()
{
	int i,j;
	FILE *fpout;

	dbgtext(50, "z_sim()\n");

	/* Initialisierung des Bildschirms */

	init_schirm();
	w_schirm();
	fenster1();
	fenster2(2);


	/* Zusatzeingabe fuer SIM-Verfahren */

	sim_gen();

	e_schirm();


	/* An das Ende der Datei gehen */

	if ((fpout = fopen(datei,"a")) == NULL)
	{
		fprintf(stderr,"%s %s %s\n",spr("zsim02"),datei,spr("zsim03"));
		exit(8);
	}

	dbginfo(50, "z_sim(): Speichere in '%s'!\n", datei);


	/* Zusatzblock abspeichern */

	fprintf(fpout,"%s\n\n",	spr("zsim04"));
	fprintf(fpout,"%s\n\n",	spr("zsim05"));
	fprintf(fpout,"%s\n",	spr("zsim06"));
	fprintf(fpout,"---------+----------------------------------------\n");

	if(ankunft != (struct prozess *) 0)
	{
		for(j=0;j<netz.klass;j++)
		{
			fprintf(fpout,"%2d       |  %2d %g %g %g %g  \n",
				j+1,ankunft[j].code,ankunft[j].wert1,ankunft[j].wert2,ankunft[j].wert3,ankunft[j].wert4);
		}
	}
	else
	{
		for(j=0;j<netz.klass;j++)
		{
			fprintf(fpout,"%2d       |  0	%g 1 0 0 \n",j+1,netz.ankr[j]);
		}
	}

	fprintf(fpout,"\n");
	fprintf(fpout,"%s\n\n",spr("zsim07"));

	for(j=0;j<netz.klass;j++)
	{
		fprintf(fpout,"%s %d\n\n",spr("zsim08"),j+1);
		fprintf(fpout,"%s\n",spr("zsim09"));
		fprintf(fpout,"-----------+----------------------------------------\n");
		if(general != (struct prozess **) 0)
		{
			for(i=0;i<netz.knot;i++)
			{
				fprintf(fpout,"%10.10s | %2d   %g   %g   %g  %g  \n",
					netz.knotname[i],
					general[i][j].code,
					general[i][j].wert1,
					general[i][j].wert2,
					general[i][j].wert3,
					general[i][j].wert4);
			}
		}
		else
		{
			for(i=0;i<netz.knot;i++)
			{
				fprintf(fpout,"%10.10s | %2d   %g   %g   %g  %g  \n",
					netz.knotname[i],
					0,
					netz.bedr[i][j],
					netz.quadvar[i][j],
					0.0,
					0.0);
			}
		}
		fprintf(fpout,"\n");
	}

	fprintf(fpout,"%s\n\n",spr("zsim10"));
	fprintf(fpout,"%s\n",spr("zsim11"));
	fprintf(fpout,"-----------+--------------\n");

	if(kapazitaet != (int *) 0)
	{
		for(i=0;i<netz.knot;i++)
		{
			fprintf(fpout,"%10.10s | %d\n",netz.knotname[i],kapazitaet[i]);
		}
	}
	else
	{
		for(i=0;i<netz.knot;i++)
		{
			fprintf(fpout,"%10.10s | %d\n",netz.knotname[i],-1);
		}
	}

	fprintf(fpout,"\n%s\n\n",	spr("zsim12"));
	fprintf(fpout,"%d\n\n",		simulationsdauer);
	fprintf(fpout,"%s\n\n",		spr("zsim13"));
	fprintf(fpout,"%d\n",		deadlock);
	fprintf(fpout,"%d\n\n",		blockarrival);

	fclose(fpout);
}
