/*


	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\teingabe.c\t1.6\t94/02/04 16:26:56";

#define MAIN
#include "d_pepsy.h"
#include "d_netz.h"
#include "d_konst.h"

/*
 	eingabe -	Gibt interaktiv die Netzdaten ein und speichert diese
				anschliessend in einer Datei ab.							


	Version 1.0

	Version 1.02			kirschni	exit(0).
										Option -V eingefuehrt.

	Version 1.1	14.02.1992	kirschni	optionaler Parameter fuer Eingabe-
										dateiname eingefuehrt.
										Optionenparsing auf getopt() umge-
										stellt
										Language-Support optimiert.
										Kosmetik.
				01.03.1992	kirschni	Sccs eingefuehrt

*/


int debug=0;				/* Warum die reinmuss weiss ich nicht, aber sonst
								motzt der linker ....?????? kirschni*/
int dbg = 0;
netzstruktur	netz;		/* Eingabedatenstruktur		*/
int pepsyversion = 3.0;

main(argc,argv)
int argc;
char **argv;
{
	extern char *optarg;
	extern int	 optind;

	/*		Sccs support from SccsLogging.c			*/	
	extern int SccsRelease;
	extern int SccsLevel;

	char 	datei[MAXTEXT+3];					/* Eingabedateiname		*/
	int	c;
	int		errflg=0;
	int		index,	
			wunsch;					/* Ist 2, falls besh und 1 falls uew */
									/* bearbeitet werden sollen			*/
	FILE 	*fp;					/* Filedeskriptor fuer die Eingabedatei */

	datei[0] = '\0';

	while ((c=getopt(argc, argv, "Vd:")) != EOF)
	{
		switch(c)
		{
			case 'd':	/* Debug - Option */
						if ((dbg = atoi(optarg)) <= 0)
							dbg = 1;
						break;
			case 'V':
						fprintf(stdout, "%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
						exit(0);
						break;
			default:
						break;
		}
	}

	if (p_lang_init(argv[0]))
		exit (-2);

	if ((argc - optind > 1) || errflg )
	{
		fprintf(stderr, "%s\n%s\n", spr("usage0"), spr("usage1"));
		exit(1);
	}

	if (argc - optind == 1)
	{
		strcpy(datei, "e_");
		strcat(datei, (argv[optind]+( (*argv[optind] == 'e' && *(argv[optind]+1) == '_')?2:0 )));
	}

	init_schirm();
	w_schirm();

	fenster2(0);
	fenster1();

	get_netztyp();		/* Netztyp			*/
	get_knotklass();	/* Anzahl Knoten und Klassen 	*/

	/* Speicherplatz belegen */

	if (sp_alloc() == 0)
	{
		fprintf(stderr, spr("eing01"));
		exit(2);
	}


	/*	-------------- Knotennamen ------------------------- */

	for (index=0;index<=(netz.knot-1)/MAXZEILEN;index++)
		get_knotname(index);


	/*	-------------- Knotentyp --------------------------- */

	for(index=0;index<netz.knot;index++)
		i_get_knottyp(index);


	/* geschlossenes oder gemischtes Netz -> Anzahl Auftraege */

	if ((netz.typ == GESCHLOSSEN) || (netz.typ == GEMISCHT))
	{
		get_auftr();
	}


	/*	-- offenes Netz oder gemischtes Netz -> Ankunftsraten */

	if ((netz.typ == OFFEN) || (netz.typ == GEMISCHT))
	{
		get_ankr();
	}


	/*	-------------- Bedienraten -------------------------- */

	for (index=0;index<=(netz.knot-1)/MAXZEILEN;index++)
		get_bedr(index);


	/*	-------------- Quadrierter Variationskoeffizient ---- */

	for (index=0;index<=(netz.knot-1)/MAXZEILEN;index++)
		get_quadvar(index);


	/* Frage, ob Uebergangswahrscheinlichkeiten,  */
	/* oder Besuchshaeufigkeiten                  */

	wunsch = get_wunsch();

	if (wunsch == 1)
	{
		/* Speicherplatz fuer die Uebergangswahrscheinlichkeiten belegen */

		netz.uew = (float ***)f_3dim_alloc(netz.knot+1,netz.knot+1,netz.klass);
		if ((int) netz.uew == 0)
		{
			fprintf(stderr, spr("eing01"));
			exit(2);
		}

		/* Uebergangswahrscheinlichkeiten fuer alle Klassen */

		for(index=0;index<netz.klass;index++)
			get_uew(index);
	}
	else
	{
		/* Besuchshaeufigkeiten */

		for (index=0;index<=(netz.knot-1)/MAXZEILEN;index++)
			get_besh(index);
	}

	if (*datei == '\0')
	{
  		get_datname(datei);
	}

	/* Eingabedatei oeffnen */

	if ((fp = fopen(datei,"w")) == 0)
	{
		fprintf(stderr,"pepsy: can't open %-s",datei);
		exit(1);
	}

	/* Eingaben abspeichern */

	sp_ein(fp,wunsch,datei);

	/* Eingabedatei schliessen */

	fclose(fp);

	sp_free();

	if (wunsch == 1)
		f_3dim_free(netz.uew,netz.knot+1,netz.knot+1,netz.klass);

	e_schirm();

	exit(0);
} /* eingabe(...) */
