/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/


#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "d_netz.h"
#include "d_konst.h"
#include "d_speicher.h"

#define USAGE()	{ \
	fprintf(stderr,"%s\n",spr("zusa01")); exit(1);}

/*
								
 Regelt fuer das im Aufruf angegebene Verfahren die Zusatzeingabe    
 (interaktive Eingabe)					
								
 Aufrufoptionen:						
 -verfahren : Verfahren fuer das Zusatzeingabe erfolgen soll	
 -dateiname : Eingabedateiname				
								
*/

static char *SccsId = "@(#)PEPSY:\tzusatz.c\t1.5\t93/05/18 13:24:26";

extern	char	*spr();

int 	dbg = 0;       	/* debug - niveau			*/
int	debug = 1;
int   arguments;
char	datei[100],
		verfahren[20],
		zusatzblock[20];
netzstruktur netz;



main(argc,argv)
int	argc;
char	*argv[];
{
	extern	char *optarg;
	extern	int	optind;
	extern	int	SccsRelease;
	extern	int	SccsLevel;
				int	c,
						fehler,
						i;
				char	*verf;
				char	buffer[5120];
				int	gefunden;
				FILE	*fopen(),
						*fpin;
				netzstruktur *np = &netz;


	if (p_lang_init(argv[0])!=0)
		exit(-2);

	while(( c= getopt(argc,argv,"Vd:")) != EOF)
	{
		switch(c)
		{
			case 'V':
				fprintf(stdout, "%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
				exit(0);
				break;
			case 'd':
				if((dbg = atoi(optarg)) <= 0)
					dbg = 1;
				break;
			default:
				fprintf(stderr,"\n%s -%c !!!\n",spr("zusa02"), c);
				USAGE();
				break;
		}
	}

	if(dbg > 5)
		fprintf(stderr,"%s %d\n",spr("zusa03"),argc-optind);

	arguments = argc;

	switch(argc - optind)
	{
		case 0:
		case 1:
			USAGE();
			break;
		case 2:	/* es bleiben genau zwei Parameter uebrig: das Verfahren
						und die Eingabedatei */

			verf = argv[optind];

			if ( (*argv[optind+1] == 'e')
				&&(*(argv[optind+1]+1) == '_') )
			{
				strcpy(datei, argv[optind+1]);
			}
			else
			{
				 strcpy(datei,"e_");
				 strcat(datei,argv[optind+1]);
			}

			if ((fpin = fopen(datei,"r")) == NULL)
			{
				fprintf(stderr,"%s '%s' %s\n",spr("zusa05"),datei,spr("zusa06"));
				exit(1);
			}
			break;
	}


	switch(get_verfahren(verf,verfahren))
	{
		case -2:	
			fprintf(stderr,"%s\n",spr("zusa07"));
			exit(1);
		case -1:
			fprintf(stderr,"%s '%s'\n",spr("zusa08"),verf);
			exit(1);
	}

	if(dbg)
	{
		fprintf(stderr,"%s %d\n",spr("zusa09"),dbg);
		fprintf(stderr,"%s %s\n",spr("zusa10"),verfahren);
		fprintf(stderr,"%s %s\n",spr("zusa11"),datei);
	}

	if((i = get_zusatzblock(verfahren,zusatzblock)) < 0)
	{
		fprintf(stderr,"%s\n",spr("zusa12"));
		exit(1);
	}
	if(i == 0)
	{
	    fprintf(stderr,"%s %s %s\n",spr("zusa13"),verfahren,spr("zusa14"));
		exit(1);
	}
	if(dbg) fprintf(stderr,"%s %s\n",spr("zusa15"),zusatzblock);

	get_standard(fpin);

	i = strlen(zusatzblock);
	while(nextline(fpin,buffer,100) != EOF && gefunden == FALSE)
	{
		if(strncmp(buffer,zusatzblock,i) == 0)
			gefunden = TRUE;
	}

	if (gefunden == TRUE)
	{
		fprintf(stderr,"%s\n",spr("zusa16"));
		exit(3);
	}
	fclose(fpin);

	/* Zusatzeingaben eingeben */

	if(strncmp(zusatzblock,spr("zusa17"),strlen(spr("zusa17"))) == 0)
	{
		z_mem();
		exit(0);
	}
	if(strncmp(zusatzblock,spr("zusa18"),strlen(spr("zusa18"))) == 0)
	{ 
		z_sim();
		exit(0);
	}
	if(strncmp(zusatzblock,spr("zusa19"),strlen(spr("zusa19"))) == 0)
	{ 
		z_hier();
		exit(0);
	}
	if(strncmp(zusatzblock,spr("zusa20"),strlen(spr("zusa20"))) == 0)
	{ 
		z_hier2();
		exit(0);
	}
	if(strncmp(zusatzblock,"ASYMM",5) == 0)
	{                                                         
			z_amono();
			exit(0);
	}                                                          

} /* zusatz(...) */

