/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	Copyright (C) 1995 
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *RcsId = "@(#)PEPSY:\t$Id: boundsout.c,v 1.2 1995/06/29 15:03:49 i4pepsy Exp $";

/********************************************************************* 
***                                                                ***
***  Modul:     b o u n d s o u t . c            Ausgabefilter     ***
***                                                                ***
***----------------------------------------------------------------***
***                                                                ***
***  Datum:     30.09 87                                           ***
***  Version:   1.1                                                ***
***  Autor:     Gerhard Schmuck                                    ***
***  Inhalt:    Standartausgabefilter fuer Verfahren Bounds        ***
***								   ***
***	 05.02.92 kirschni kleinere Bug-fixes und Kosmetik	   ***
***	 06.03.92 kirschni Umstellung auf Sccs			   ***
***                                                                ***
**********************************************************************


**********************************************************************
*              Deklarationen und Definitionen                        *
*********************************************************************/
#include <stdio.h>
#include "d_para.h"
#include "stdfkt.h"
#include "memory.h"


#define DIM  50

#define PT_VERFAHREN	spr("boun02") 
#define PT_NOTKNOWN	spr("boun03")
#define PT_NOOUTPUT	spr("boun04")


int	auft_anz[DIM],
	punkte;
int	dbg = 0;
int	debug = 0;
int	COLS = 80;

float	aba_dsmax[DIM],
	aba_dsmin[DIM],
	aba_vzmin[DIM],
	aba_vzmax[DIM],
	bjb_dsmax[DIM],
	bjb_dsmin[DIM],
	bjb_vzmin[DIM],
	bjb_vzmax[DIM],
	ank_rate [DIM],
	satpunkt;

char	netztyp,
	netzbez[TLEN], 
	adatei[TLEN],
	edatei[TLEN];

/*********************************************************************
*                                                                    *
*                    Hauptprogramm BOUNDSOUT                         *
*                                                                    *
*********************************************************************/
main(argc, argv)
int  argc;
char *argv[];
{
    FILE   *fp;

    /*		Sccs support from SccsLogging.c			*/	
    extern int SccsRelease;
    extern int SccsLevel;

    int  i, r, help;
    char buffer[512];

    if ((argc > 1) && (!strcmp(argv[1], "-V")))    /* kirschni 22.11.1991 */
    {
	fprintf(stdout, "%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
	exit(0);
    }

    if (p_lang_init(argv[0]) != 0)
	exit (-2);

    EXITCTRL();

    /*-------- Verfahrens- und Dateienbestimmung -----------------*/
    if (argc < 2)
    {
	fp      = stdout;
	strcpy(netzbez, spr("boun01"));
	strcpy(edatei,	netzbez);
    }
    else
    {
#ifdef OLD_BOUNDSOUT
	if( get_prefix(buffer,"bounds") < 0)
	{
	    fprintf(stderr,"%s %s %s\n%s\n", PT_VERFAHREN, "bounds", PT_NOTKNOWN, PT_NOOUTPUT);
	    exit(3);
	}

	strcpy(netzbez,argv[1]);
	sprintf(adatei, "a_%c_%s", buffer[0], netzbez);

	if ((fp = fopen(adatei,"w")) == NULL)
	{
	    fprintf(stderr,"%s %s %s\n",spr("boun05"),adatei,spr("boun06"));
	    exit(4);
	}
#else
	fp = stdout;
	strcpy(netzbez, argv[1]);
#endif
	strcpy(edatei, "e_");
	strcat(edatei, netzbez);
    }
    /*---------- Einlesen  ----------------------------*/

    INP_DATEN ();

    /*----------  Ausgeben ----------------------------*/

    fprintf(fp, "%s",			spr("boun07"));
    fprintf(fp, "%s '%s'\n\n",		spr("boun08"), netzbez);
    fprintf(fp, "%s '%s' %s.\n\n",	spr("boun09"), edatei,spr("boun10") );
    fprintf(fp, "%s",    		spr("boun11"));
    fprintf(fp, "%s\n\n",		spr("boun12"));

    fprintf     (fp, "\n\n%s\n\n",	spr("boun13"));			/* throughput */
    WRITE_KOPF  (fp);
    WRITE_LAMBDA(fp);
    fprintf     (fp, "\n\n%s\n\n",	spr("boun14"));			/* average tournaround */
    WRITE_KOPF  (fp);
    WRITE_VZEIT (fp);
    fprintf     (fp, "\n\n%s  %.4f\n",	spr("boun15"), satpunkt);	/* point of saturation */

    fclose(fp);

    exit(0);
}
/*********************************************************************
*                        Funktion INP_DATEN                          *
**********************************************************************
Einlesen der von m_bounds berechneten Leistungsgroessen
*/
INP_DATEN()
{
    int  p;

    JUMPCOM ( stdin);
    scanf   ( "%c %d %f", &netztyp, &punkte, &satpunkt);
    if ( punkte > DIM) {
	fprintf ( stderr, "%s %d %s\n",spr("inpd01"), DIM,spr("inpd02"));
	exit    ( 7);
    }

    if ( netztyp == 'o')
    {
	JUMPCOM ( stdin);
	for ( p=0; p < punkte; p++)
	    scanf ( "%f %f %f %f %f", &ank_rate[p], &aba_dsmin[p],
		    &aba_dsmax[p], &aba_vzmin[p], &aba_vzmax[p]);
	JUMPCOM ( stdin);
	for ( p=0; p < punkte; p++)
	    scanf ( "%f %f %f %f %f", &ank_rate[p], &bjb_dsmin[p],
		    &bjb_dsmax[p], &bjb_vzmin[p], &bjb_vzmax[p]);
    }
    else
    {
	JUMPCOM ( stdin);
	for ( p=0; p < punkte; p++)
	    scanf ( "%d %f %f %f %f", &auft_anz[p], &aba_dsmin[p],
		    &aba_dsmax[p], &aba_vzmin[p], &aba_vzmax[p]);
	JUMPCOM ( stdin);
	for ( p=0; p < punkte; p++)
	    scanf ( "%d %f %f %f %f", &auft_anz[p], &bjb_dsmin[p],
		    &bjb_dsmax[p], &bjb_vzmin[p], &bjb_vzmax[p]);
    }
}
/*********************************************************************
*                        Funktion WRITE_KOPF                         *
*********************************************************************/
WRITE_KOPF (fp)
FILE *fp;
{
	fprintf(fp, "%s %c",		(netztyp == 'o')?spr("wrko01"):spr("wrko02"), TSYMB);
	fprintf(fp, "%s %c%s %c",	spr("wrko03"), TSYMB,spr("wrko04"), TSYMB);
	fprintf(fp, "%s\n",			spr("wrko05"));
	fprintf(fp, "%s %c",		(netztyp == 'o')?spr("wrko06"):spr("wrko07"), TSYMB);
	fprintf(fp, "%s %c%s %c",	spr("wrko08"),TSYMB,spr("wrko08"), TSYMB);
	fprintf(fp, "%s\n",			spr("wrko08"));
	fprintf(fp, "----------+--------------------+----------");
	fprintf(fp, "----------+--------------------\n");
}
/*********************************************************************
*                     Funktion WRITE_LAMBDA                          *
*********************************************************************/
WRITE_LAMBDA (fp)
FILE *fp;
{
	int  p;

	if (netztyp == 'o')
	{
		for (p=0; p<punkte; p++)
		{
			fprintf(fp, " %8.4f %c %8.4f  %s %c", ank_rate[p],
			    TSYMB, aba_dsmax[p], "    -   ", TSYMB);
			fprintf(fp, " %8.4f  %s %c", bjb_dsmax[p],
			    "    -   ", TSYMB);
			fprintf(fp, " %8.4f %s\n", bjb_dsmax[p], "    -   ");
		}
	}
	else
	{
		for (p=0; p<punkte; p++)
		{
			fprintf(fp, "   %4d   %c %8.4f  %8.4f %c",
			    auft_anz[p], TSYMB, aba_dsmax[p], aba_dsmin[p],
			    TSYMB);
			fprintf(fp, " %8.4f  %8.4f %c", bjb_dsmax[p],
			    bjb_dsmin[p], TSYMB);
			fprintf(fp, " %8.4f  %8.4f\n",
			    MIN(aba_dsmax[p], bjb_dsmax[p]),
			    MAX(aba_dsmin[p], bjb_dsmin[p]) );
		}
	}
}
/*
************************************************************************
*                         Funktion WRITE_VZEIT                         *
************************************************************************
*/
WRITE_VZEIT (fp)
FILE *fp;
{
	int  p;

	if (netztyp == 'o')
	{
		for (p=0; p<punkte; p++)
		{
			fprintf(fp, " %8.4f %c %8.4f  %s %c", ank_rate[p],
			    TSYMB, aba_vzmin[p], "    -   ", TSYMB);
			if ( ank_rate[p] < satpunkt) {
				fprintf(fp, " %8.4f  %8.4f %c", bjb_vzmin[p],
				    bjb_vzmax[p], TSYMB);
				fprintf(fp, " %8.4f  %8.4f\n", 
				    MAX ( aba_vzmin[p], bjb_vzmin[p]),
				    bjb_vzmax[p] );
			}
			else {
				fprintf(fp, " %s  %s %c", "    -   ",
				    "    -   ", TSYMB);
				fprintf(fp, " %s  %s\n", "    -   ", "    -   ");
			}
		}
	}
	else 
	{
		for (p=0; p<punkte; p++)
		{
			fprintf(fp, "   %4d   %c %8.4f  %8.4f %c",
			    auft_anz[p], TSYMB, aba_vzmin[p], aba_vzmax[p],
			    TSYMB);
			fprintf(fp, " %8.4f  %8.4f %c", bjb_vzmin[p],
			    bjb_vzmax[p], TSYMB);
			fprintf(fp, " %8.4f  %8.4f\n", 
			    MAX(aba_vzmin[p], bjb_vzmin[p]), 
			    MIN(aba_vzmax[p], bjb_vzmax[p]) );
		}
	}
}
