/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tput_multisum.c\t1.3\t92/08/24 11:01:10";

#include <stdio.h>
#include "d_speicher.h"
#include "d_netz.h"

#define	EXTERN_KNOTENTYPEN
#include "d_konst.h"

extern int dbg;
extern netzstruktur netz;

put_multisum(fp,fpin)             
FILE *fp,*fpin;
{
	register netzstruktur *np = &netz;
	int i,j,k,l,gefunden;
	double **A;
	double *b,*x;

	if(dbg)
		fprintf(stderr,"put_multisum\n");
	
	if(np->haeuf) 	/* Uebergangswahrscheinlichkeiten werden umgerechnet */
	{
		if((A = d_2dim_alloc(np->knot,np->knot)) == (double **) 0) mall_err("put_scat(1)");
		if((b = d_1dim_alloc(np->knot)) == (double *) 0) mall_err("put_scat(2)");
		if((x = d_1dim_alloc(np->knot)) == (double *) 0) mall_err("put_scat(3)");
		{
			for(i=0;i<np->klass;i++)
			{
				for(j=1;j<=np->knot;j++) /* rechte Seite  und Matrix aufbauen */
				{
					b[j-1] = -np->uew[0][j][i];
					for(k=1;k<=np->knot;k++) /* rechte Seite  und Matrix aufbauen */
					{
						A[j-1][k-1] = np->uew[k][j][i];
					}
					A[j-1][j-1] -= 1.0;
				}
				if(gauss(A,x,b,np->knot,1e-20) < 0)
				{
					fprintf(stderr,"Klasse %d: Matrix singulaer\n",i+1);
					exit(1);
				}
				for(j=0;j<np->knot;j++)
				{	
					np->besh[j][i] = x[j];
				}
			}
		}
		np->haeuf = 0;
	}
	fprintf(fp,"1\t%d\t%d\n\n",np->knot,np->klass); /* Knoten Klassen */
	for(i=0;i<np->klass;i++)	/* Auftraege */
	{
		fprintf(fp,"%d ",np->auftr[i]);
	}
	fprintf(fp,"\n");
	for(j=0;j<np->knot;j++)
	{
		fprintf(fp,"%d ",np->bede[j]);
	}
	fprintf(fp,"\n");
	for(j=0;j<np->knot;j++)
	{
		for(i=0;i<np->klass;i++)	/* Bedienraten */
		{	
			fprintf(fp,"%g  ",np->bedr[j][i]);
		}
		fprintf(fp,"\n");
	}
	fprintf(fp,"\n0\n");
	for(j=0;j<np->knot;j++)
	{
		for(i=0;i<np->klass;i++) 	/* Besuchshaeufigkeiten */
		{
			fprintf(fp,"%g  ",np->besh[j][i]);
		}
		fprintf(fp,"\n");
	}
	fprintf(fp,"\n");
	for(i=0;i<np->knot;i++)
	{
		fprintf(fp,"%d ",ktyp_int2ext(np->knotentyp[i]));
	}
	fprintf(fp,"\n");
	for(i=0;i<np->knot;i++)
	{
		for(j=0;j<np->klass;j++)
		{
			if(np->knotentyp[i] & (TYP5 | TYP6 | TYP7 | TYP8 | TYP14 | TYP15 | TYP18 | TYP19 | TYP21 ))
				fprintf(fp,"%lg ",np->quadvar[i][j]);
			else
				fprintf(fp,"1.0 ");
		}
	}
	fprintf(fp,"\n");
 
		
        get_amono(fpin);  
}
