/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tput_appscat.c\t1.3\t94/11/18 16:01:12";

#include <stdio.h>
#include "d_speicher.h"
#include "d_netz.h"
#define	EXTERN_KNOTENTYPEN
#include "d_konst.h"

extern int dbg;
extern netzstruktur netz;

put_appscat(fp)
FILE *fp;
{
	register netzstruktur *np = &netz;
	int i,j,k,l;
	double **A;
	double *b,*x;

	if(dbg)
		fprintf(stderr,"put_appscat\n");
	
	if(np->haeuf) 	/* Uebergangswahrscheinlichkeiten werden umgerechnet */
	{
		if((A = d_2dim_alloc(np->knot,np->knot)) == (double **) 0) mall_err("put_scat(1)");
		if((b = d_1dim_alloc(np->knot)) == (double *) 0) mall_err("put_scat(2)");
		if((x = d_1dim_alloc(np->knot)) == (double *) 0) mall_err("put_scat(3)");
		{
			for(i=0;i<np->klass;i++)
			{
				for(j=1;j<=np->knot;j++) /* rechte Seite  und Matrix aufbauen */
				{
					b[j-1] = -np->uew[0][j][i];
					for(k=1;k<=np->knot;k++) /* rechte Seite  und Matrix aufbauen */
					{
						A[j-1][k-1] = np->uew[k][j][i];
					}
					A[j-1][j-1] -= 1.0;
				}
				if(gauss(A,x,b,np->knot,1e-20) < 0)
				{
					fprintf(stderr,"Klasse %d: Matrix singulaer\n",i+1);
					exit(1);
				}
				for(j=0;j<np->knot;j++)
				{	
					np->besh[j][i] = x[j];
				}
			}
		}
		np->haeuf = 0;
	}
	fprintf(fp,"%d\t%d\n\n",np->knot,np->klass); /* Knoten Klassen */
	for(i=0;i<np->klass;i++)	/* Auftraege */
		fprintf(fp,"%d  ",np->auftr[i]);
	fprintf(fp,"\n");
	for(i=0;i<np->knot;i++)
		switch(np->knotentyp[i])
		{
			case TYP1:
				fprintf(fp,"%d ",1);
				break;
			case TYP2:
				fprintf(fp,"%d ",2);
				break;
			case TYP3:
				fprintf(fp,"%d ",3);
				break;
			case TYP4:
				fprintf(fp,"%d ",4);
				break;
			case TYP5:
				fprintf(fp,"%d ",5);
				break;
			case TYP6:
				fprintf(fp,"%d ",6);
				break;
			case TYP9:
				fprintf(fp,"%d ",9);
				break;
			case TYP12:
				fprintf(fp,"%d ",12);
				break;
			case TYP13:
				fprintf(fp,"%d ",13);
				break;
			default:
				fprintf(fp,"%d ",-1);
				break;
		}
		fprintf(fp,"\n");

	for(i=0;i<np->knot;i++) 	/* Bedieneinheiten */
		fprintf(fp,"%d  ",np->bede[i]);
	fprintf(fp,"\n");
	for(i=0;i<np->klass;i++) 	/* Besuchshaeufigkeiten */
	{
		for(j=0;j<np->knot;j++)
		{
			fprintf(fp,"%g  ",np->besh[j][i]);
		}
		fprintf(fp,"\n");
	}
	for(i=0;i<np->klass;i++)	/* Bedienraten */
	{
		for(j=0;j<np->knot;j++)
		{	
			fprintf(fp,"%g  ",1.0/np->bedr[j][i]);
		}
		fprintf(fp,"\n");
	}
	fprintf(fp,"\n");
			
	for(i=0;i<np->klass;i++)	/* quad. Varkoeff */
	{
		for(j=0;j<np->knot;j++)
		{	
			fprintf(fp,"%g  ",np->quadvar[j][i]);
		}
		fprintf(fp,"\n");
	}
	fprintf(fp,"\n");
			
}
