static char *SccsId = "@(#)PEPSY:\tgauss_eli.c\t1.2\t92/03/27 12:03:46";

#define SWAP(arg1, arg2, tmp) (tmp = arg1, arg1 = arg2, arg2 = tmp)

void gauss_elimination(n, a, b)
int n;
double **a, *b;
{
	int j, k, m, jpivot;
	double su, sumax, *pdtmp, dtmp, fabs();

	for (m = 0; m < n - 1; ++m)
	{
		sumax = 0.0;
		for (j = m; j < n; ++j)
		{
			su = 0.0;
			for (k = m; k < n; ++k)
			{
				su += fabs(a[j][k]);
			}
			su = fabs(a[j][m]) / su;
			if (su > sumax)
			{
				jpivot = j;
				sumax = su;
			}
		}
		SWAP(a[m], a[jpivot], pdtmp);
		SWAP(b[m], b[jpivot], dtmp);
		for (j = m + 1; j < n; ++j)
		{
			a[j][m] /= a[m][m];
			for (k = m + 1; k < n; ++k)
				a[j][k] -= a[j][m] * a[m][k];
			if (b)
				b[j] -= a[j][m] * b[m];
		}
	}
	if (b)
	{
		for (j = n - 1; j >= 0; --j)
		{
			for (k = j + 1; k < n; ++k)
				b[j] -= a[j][k] * b[k];
			b[j] /= a[j][j];
		}
	}
}
