static char *SccsId = "@(#)PEPSY:\toutput.c\t1.2\t92/03/27 12:03:51";

#include <stdio.h>
#include "const+type.h"

extern int ksize;

void foutput(fp, N, R, K, m, typ, csq, ptrans, e, mue, lmue, tree, hmax)
FILE *fp;
int N, R, K[RMAX], m[NMAX], typ[NMAX], hmax;
double csq[NMAX][RMAX], ptrans[RMAX][NMAX + 1][NMAX + 1];
double e[NMAX][RMAX], mue[NMAX][RMAX], *lmue[NMAX][RMAX];
struct tree *tree;
{
	int foutputdim(), fescflag;
	void foutput_e(), foutput_tcp(), foutputrest();

	fescflag = foutputdim(fp, N, R, K, m);
	if (e)
		foutput_e(fp, N, R, e);
	else
		foutput_tcp(fp, N, R, typ, csq, ptrans);
	foutputrest(fp, N, R, m, mue, lmue, fescflag, tree, hmax);
}

int foutputdim(fp, N, R, K, m)
FILE *fp;
int N, R, K[RMAX], m[NMAX];
{
	int i, r, fescflag;

	fprintf(fp, "# ANZAHL KNOTEN:\n   %d\n\n", N);
	fprintf(fp, "# ANZAHL KLASSEN:\n   %d\n\n", R);
	fprintf(fp, "# ANZAHL AUFTRAEGE:\n ");
	for (r = 0; r < R; ++r)
	{
		fprintf(fp, "  %d", K[r]);
	}
	fprintf(fp, "\n\n# ANZAHL DER PROZESSOREN: (0 fuer IS, -1 fuer FESC)\n ");
	fescflag = 0;
	for (i = 0; i < N; ++i)
	{
		if (m[i] == FESC)
			fescflag = 1;
		fprintf(fp, "  %d", m[i]);
	}
	putc('\n', fp);
	return(fescflag);
}

void foutput_e(fp, N, R, e)
FILE *fp;
int N, R;
double e[NMAX][RMAX];
{
	int i, r;

	fprintf(fp, "\n\n# BESUCHSHAEUFIGKEITEN\n\n");
	fprintf(fp, "# 	fuer alle Knoten\n");
	fprintf(fp, "#		fuer alle Klassen\n");
	fprintf(fp, "#			die Besuchshaeufigkeiten:\n\n");
	for (i = 0; i < N; ++i)
	{
		for (r = 0; r < R; ++r)
		{
			fprintf(fp, "%.16lg ", e[i][r]);
		}
		putc('\n', fp);
	}
}

void foutput_tcp(fp, N, R, typ, csq, ptrans)
FILE *fp;
int N, R, typ[NMAX];
double csq[NMAX][RMAX], ptrans[RMAX][NMAX + 1][NMAX + 1];
{
	int i, j, r;

	fprintf(fp, "\n# BEDIENSTRATEGIEN: (");
	for (i = 0; TYP[i]; ++i)
	{
		if (i)
		{
			if (i % 4 == 0)
				fprintf(fp, ",\n#                    ");
			else
				fprintf(fp, ", ");
		}
		fprintf(fp, "%s", TYP[i]);
	}
	fprintf(fp, ")\n ");
	for (i = 0; i < N; ++i)
	{
		fprintf(fp, "  %s", TYP[typ[i] + 1]);
	}
	fprintf(fp, "\n\n\n# QUADRATE DER VARIATIONSKOEFFIZIENTEN\n\n");
	fprintf(fp, "# 	fuer alle Knoten\n");
	fprintf(fp, "#		fuer alle Klassen\n");
	fprintf(fp, "#			die Quadrate der Variationskoeffizienten:\n\n");
	for (i = 0; i < N; ++i)
	{
		for (r = 0; r < R; ++r)
		{
			fprintf(fp, "%.16lg ", csq[i][r]);
		}
		putc('\n', fp);
	}
	fprintf(fp, "\n\n# UEBERGANGSWAHRSCHEINLICHKEITEN\n\n");
	fprintf(fp, "#	fuer alle Klassen\n");
	fprintf(fp, "# 		fuer alle Knoten von\n");
	fprintf(fp, "# 			fuer alle Knoten nach\n");
	fprintf(fp, "#				die Uebergangswahrscheinlichkeiten:\n");
	for (r = 0; r < R; ++r)
	{
		putc('\n', fp);
		for (i = 0; i <= N; ++i)
		{
			for (j = 0; j <= N; ++j)
			{
				fprintf(fp, "%.16lg ", ptrans[r][i][j]);
			}
			putc('\n', fp);
		}
	}
}

void foutputrest(fp, N, R, m, mue, lmue, fescflag, tree, hmax)
FILE *fp;
int N, R, m[NMAX], fescflag, hmax;
double mue[NMAX][RMAX], *lmue[NMAX][RMAX];
struct tree *tree;
{
	int i, r, kcode;
	void fputtree(), fhputtree();

	fprintf(fp, "\n\n# BEDIENRATEN\n");
	if (fescflag)
	{
		for (i = 0; i < N; ++i)
		{
			if (m[i] == FESC)
			{
				putc('\n', fp);
				fprintf(fp, "#	fuer alle Lastverteilungen > (0, ... ,0)\n");
				fprintf(fp, "#		fuer alle Klassen\n");
				fprintf(fp, "#			die Bedienraten von Knoten %d:\n\n",
					i + 1);
				for (kcode = 1; kcode < ksize; ++kcode)
				{
					for (r = 0; r < R; ++r)
					{
						fprintf(fp, "%.16lg ", lmue[i][r][kcode]);
					}
					putc('\n', fp);
				}
			}
			else
			{
				putc('\n', fp);
				fprintf(fp, "#		fuer alle Klassen\n");
				fprintf(fp, "#			die Bedienraten von Knoten %d:\n\n",
					i + 1);
				for (r = 0; r < R; ++r)
				{
					fprintf(fp, "%.16lg ", mue[i][r]);
				}
				putc('\n', fp);
			}
		}
	}
	else
	{
		putc('\n', fp);
		fprintf(fp, "# 	fuer alle Knoten\n");
		fprintf(fp, "#		fuer alle Klassen\n");
		fprintf(fp, "#			die Bedienraten:\n\n");
		for (i = 0; i < N; ++i)
		{
			for (r = 0; r < R; ++r)
			{
				fprintf(fp, "%.16lg ", mue[i][r]);
			}
			putc('\n', fp);
		}
	}
	if (tree && tree->meth[0])
	{
		fprintf(fp, "\n\n# HIERARCHISCHE STRUKTUR\n\n");
		if (hmax < 0)
			fputtree(tree, fp);
		else
			fhputtree(tree, hmax, fp);
		putc('\n', fp);
	}
}

void fputtree(tree, fp)
struct tree *tree;
FILE *fp;
{
	struct tree *ptree;

	fprintf(fp, "(%s", tree->meth);
	for (ptree = tree; ptree; ptree = ptree->pright)
	{
		putc(' ', fp);

		if (ptree->pdown)
			fputtree(ptree->pdown, fp);
		else
			fprintf(fp, "%d", ptree->i + 1);
	}
	putc(')', fp);
}

void fhputtree(tree, hmax, fp)
struct tree *tree;
int hmax;
FILE *fp;
{
	static int h, N;
	struct tree *ptree;

	if (h == 0)
	{
		N = 1;
	}
	fprintf(fp, "(%s", tree->meth);
	for (ptree = tree; ptree; ptree = ptree->pright)
	{
		putc(' ', fp);

		if (h < hmax && ptree->pdown)
		{
			++h;
			fhputtree(ptree->pdown, hmax, fp);
			--h;
		}
		else
			fprintf(fp, "%d", N++);
	}
	putc(')', fp);
}

void print_lambdaK(R, lambdaK)
int R;
double lambdaK[RMAX];
{
	int r;

	for (r = 0; r < R; ++r)
	{
		printf("%.16lg ", lambdaK[r]);
	}
	putchar('\n');
}

void print_lambda(R, lambda)
int R;
double *lambda[RMAX];
{
	int r, kcode;

	for (kcode = 1; kcode < ksize; ++kcode)
	{
		for (r = 0; r < R; ++r)
		{
			printf("%.16lg ", lambda[r][kcode]);
		}
		putchar('\n');
	}
}

void print_kmeanK(N, R, kmeanK)
int N, R;
double kmeanK[NMAX][RMAX];
{
	int i, r;

	for (i = 0; i < N; ++i)
	{
		for (r = 0; r < R; ++r)
		{
			printf("%.16lg ", kmeanK[i][r]);
		}
		putchar('\n');
	}
}

void print_kmean(N, R, kmean)
int N, R;
double *kmean[NMAX][RMAX];
{
	int i, r, kcode;

	for (i = 0; i < N; ++i)
	{
		for (kcode = 1; kcode < ksize; ++kcode)
		{
			for (r = 0; r < R; ++r)
			{
				printf("%.16lg ", kmean[i][r][kcode]);
			}
			putchar('\n');
		}
		putchar('\n');
	}
}

void print_p(N, p, psize, m)
int N, psize, m[NMAX];
double *p[NMAX];
{
	int i, pcode;

	for (i = 0; i < N; ++i)
	{
		if (m == NULL || m[i] == FESC)
		{
			for (pcode = psize - 1; pcode >= 0; --pcode)
			{
				printf("%.16lg\n", p[i][pcode]);
			}
			putchar('\n');
		}
	}
}

void set_FESC_mue(N, R, K, m, e, mue, lambda, p)
int N, R, K[RMAX], m[NMAX];
double e[NMAX][RMAX], mue[NMAX][RMAX], lambda[RMAX], *p[NMAX];
{
	int i, r, s, k[RMAX], ksum, kcode;
	double rho_i[RMAX], lambda_ir;

	for (r = 0; r < R; ++r)
		k[r] = 0;
	ksum = 0;
	for (i = 0; i < N; ++i)
	{
		if (m[i] == FESC)
		{
			for (r = 0; r < R; ++r)
				rho_i[r] = 0;
			for (kcode = 1;; ++kcode)
			{
				for (s = R - 1; s >= 0; --s)
				{
					if (++k[s] > K[s])
					{
						if (K[s] > 0)
						{
							ksum--;
							k[s] = 0;
						}
					}
					else
					{
						if (k[s] == 1)
							ksum++;
						break;
					}
				}
				if (s < 0)
					break;

				for (r = 0; r < R; ++r)
					if (k[r] > 0)
						rho_i[r] += p[i][kcode] / ksum;
			}
			for (r = 0; r < R; ++r)
			{
				lambda_ir = lambda[r] * e[i][r];
				mue[i][r] = lambda_ir == 0 ? 0 : lambda_ir / rho_i[r];
			}
		}
	}
}

void print_perfK(name, N, R, K, m, e, mue, lambda, kmean, p)
char *name;
int N, R, K[RMAX], m[NMAX];
double e[NMAX][RMAX], mue[NMAX][RMAX];
double lambda[RMAX], kmean[NMAX][RMAX];
double *p[NMAX];
{
	int i, r, s, kcode;
	double lambda_ir, s_ir, rho_ir, tmean_ir, w_ir, q_ir;

	if (p)
		set_FESC_mue(N, R, K, m, e, mue, lambda, p);
	printf("%s\n 1   %d   %d\n\n", name, N, R);
	for (r = 0; r < R; ++r)
	{
		for (i = 0; i < N; ++i)
		{
			printf("%.16lg ", lambda_ir = lambda[r] * e[i][r]);
			printf("%.16lg ", e[i][r]);
			tmean_ir = lambda_ir == 0 ? 0 : kmean[i][r] / lambda_ir;
			switch (m[i])
			{
				case FESC:
				{
					s_ir = mue[i][r] == 0 ? 0 : 1 / mue[i][r];
					rho_ir = lambda_ir * s_ir;
					w_ir = tmean_ir - s_ir;
					if (w_ir < 0)
						w_ir = 0;
					q_ir = lambda_ir * w_ir;
					break;
				}
				case IS:
				{
					s_ir = mue[i][r] == 0 ? 0 : 1 / mue[i][r];
					rho_ir = 0;
					w_ir = 0;
					q_ir = 0;
					break;
				}
				default:  /* MMm, m >= 1 */
				{
					s_ir = mue[i][r] == 0 ? 0 : 1 / mue[i][r];
					rho_ir = lambda_ir * s_ir / m[i];
					w_ir = tmean_ir - s_ir;
					if (w_ir < 0)
						w_ir = 0;
					q_ir = lambda_ir * w_ir;
				}
			}
			printf("%.16lg ", s_ir);
			printf("%.16lg ", rho_ir);
			printf("%.16lg ", tmean_ir);
			printf("%.16lg ", kmean[i][r]);
			printf("%.16lg ", w_ir);
			printf("%.16lg\n", q_ir);
		}
		putchar('\n');
	}
}
