/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tpepto.c\t1.2\t92/03/27 12:03:55";

#include <stdio.h>
#include <ctype.h>

#include "const+type.h"

#define USAGE()	{ \
	fprintf(stderr,"Korrekter Aufruf: %s [-dnum] verfahren dateinname \n",argv[0]); \
	exit(1); }

#define SIRO_APPROX 1
#define EXAKT       0

/*
	Transformiert eine PEPSY-Standarddatei in eine
	verfahrensspezifische Eingabedatei

   -d[Zahl] : 	Debug-Niveau		
   - verfahren
   - Eingabedateiname ( default stdin)			
   							
*/

int 	dbg = 0;       	/* debug - niveau			*/
int     arguments;
char *verf, verfahren[20], datei[100];

int ksize;

int N, R, K[RMAX], m[NMAX], typ[NMAX];
double csq[NMAX][RMAX], ptrans[RMAX][NMAX + 1][NMAX + 1];
double e[NMAX][RMAX], mue[NMAX][RMAX], *lmue[NMAX][RMAX];


main(argc,argv)
int	argc;
char	*argv[];
{
	/*		Sccs support from SccsLogging.c			*/	
	extern int SccsRelease;
	extern int SccsLevel;

	extern char *optarg;
	extern int optind;
	int c;
	int n;
	int i;
	char zusatz[80];

	FILE *fopen(), *fpin, *freopen();

	int fpepin();
	void foutput();

	while(( c= getopt(argc,argv,"Vd:")) != EOF)
	{
		switch(c)
		{
			case 'V':
				fprintf(stdout, "%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
				exit(0);
				break;
			case 'd':
				if((dbg = atoi(optarg)) <= 0)
					dbg = 1;
				break;
			default:
				fprintf(stderr,"\nUnbekannte Option -%c !!!\n", c);
				USAGE();
				break;
		}
	}

	if(dbg > 5)
		fprintf(stderr,"argc - optind = %d\n",argc-optind);

	arguments = argc;
	switch(argc - optind)
	{
		case 0:
		case 1:
			USAGE();
			break;
		case 2:
			verf = argv[optind];
			strcat(datei,"e_");
			strcat(datei,argv[optind+1]);
			if ((fpin = fopen(datei,"r")) == NULL)
			{
				fprintf(stderr,"pepto: Datei '%s' kann nicht geoeffnet werden !\n",datei);
				exit(1);
			}
			break;
	}

	if (!strncmp(verf, "cmva", 4))
	{
        	if (fpepin(fpin, &N, &R, K, m, typ, csq, ptrans, e, mue, EXAKT))
                	foutput(stdout, N, R, K, m, NULL, NULL, NULL, 
				e, mue, lmue, NULL);
        	else
                	foutput(stdout, N, R, K, m, typ, csq, ptrans, 
				NULL, mue, lmue, NULL);
	}
	else if (!strncmp(verf, "num_app", 7))
	{
        	if (!fpepin(fpin, &N, &R, K, m, typ, csq, ptrans, e, mue, SIRO_APPROX))
                	foutput(stdout, N, R, K, m, typ, csq, ptrans, 
				NULL, mue, lmue, NULL);
		else
		{
			fprintf(stderr,"pepto: Fuer na muessen Uebergangsw'keiten angegeben werden\n");
			exit(1);
		}
	}
	else if (!strncmp(verf, "num", 3))
	{
        	if (!fpepin(fpin, &N, &R, K, m, typ, csq, ptrans, e, mue, EXAKT))
                	foutput(stdout, N, R, K, m, typ, csq, ptrans, 
				NULL, mue, lmue, NULL);
		else
		{
			fprintf(stderr,"pepto: Fuer na muessen Uebergangsw'keiten angageben werden\n");
			exit(1);
		}
	}
	else if (!strncmp(verf, "hm", 2))
	{
        	if (fpepin(fpin, &N, &R, K, m, typ, csq, ptrans, e, mue,0))
                	foutput(stdout, N, R, K, m, NULL, NULL, NULL, 
				e, mue, lmue, NULL);
		else
                	foutput(stdout, N, R, K, m, typ, csq, ptrans, 
				NULL, mue, lmue, NULL);

		if ((fpin = freopen(datei,"r",fpin)) == NULL)
		{
			fprintf(stderr,"pepto: Datei '%s' kann nicht geoeffnet werden !\n",datei);
			exit(1);
		}

		while ((n = fscanf(fpin, " HIER2%c", &c)) != 1)
		{
			if (n == EOF)
			{
				/* erzeuge flache Hierarchie */
				printf("\n\n# HIERARCHISCHE STRUKTUR\n\n");
				printf("( cmva ");
				for(i=0;i<N;i++)
					printf("%d ",i+1);
				printf(" )\n\n");
				exit(0);
			}
			fscanf(fpin, "%*[^\n]");
		}

		do
		{
			i = 0;
			while((n = fscanf(fpin, "%c", &zusatz[i])) != 0)
			{
				if (n == EOF)
				{
					fprintf(stderr,"Angaben zur hierarchischen Struktur fehlerhaft\n");
					exit(1);
				}

				if (zusatz[i] == '\n')
				{
					zusatz[i] = '\0';
					break;
				}
				i++;
			}
		}
		while ((zusatz[0] == '\0')||(zusatz[0] == '#'));

		printf("\n\n# HIERARCHISCHE STRUKTUR\n\n");
		printf("%s \n", zusatz);

	}
	else
	{
		fprintf(stderr, "Unbekanntes Verfahren: %s\n",verf);
		exit(1);
	}
		
        exit(0);

}
