static char *SccsId = "@(#)PEPSY:\tptoe.c\t1.2\t92/03/27 12:03:57";

#include "const+type.h"
#include <stdio.h>

static void find_way_from_0_to(i, r, N, e, ptrans)
int i, r, N;
double e[NMAX][RMAX];
double ptrans[RMAX][NMAX + 1][NMAX + 1];
{
	int j;

	for (j = 1; j <= N; ++j)
	{
		if (ptrans[r][i][j] > 0 && e[j - 1][r] == 0)
		{
			e[j - 1][r] = 1;
			find_way_from_0_to(j, r, N, e, ptrans);
		}
	}
}

static void find_backway_to_0_from(i, r, N, back_e, ptrans)
int i, r, N, back_e[NMAX];
double ptrans[RMAX][NMAX + 1][NMAX + 1];
{
	int j;

	for (j = 1; j <= N; ++j)
	{
		if (ptrans[r][j][i] > 0 && back_e[j - 1] == 0)
		{
			back_e[j - 1] = 1;
			find_backway_to_0_from(j, r, N, back_e, ptrans);
		}
	}
}

static void find_e(N, R, e, ptrans)
int N, R;
double e[NMAX][RMAX];
double ptrans[RMAX][NMAX + 1][NMAX + 1];
{
	int i, r, j, errflag, back_e[NMAX];

	errflag = 0;
	for (r = 0; r < R; ++r)
	{
		for (i = 0; i < N; ++i)
			e[i][r] = back_e[i] = 0;
		find_way_from_0_to(0, r, N, e, ptrans);
		find_backway_to_0_from(0, r, N, back_e, ptrans);
		for (i = 0; i < N; ++i)
		{
			if (e[i][r] && back_e[i] == 0)
			{
				errflag = 1;
				fprintf(stderr, "Klasse %d: Knoten %d: ", r + 1, i + 1);
				fprintf(stderr, "Kein Weg nach Knoten 0\n");
			}
		}
	}
	if (errflag)
		exit(1);
}

void ptoe(N, R, e, ptrans)
int N, R;
double e[NMAX][RMAX];
double ptrans[RMAX][NMAX + 1][NMAX + 1];
{
	int i, j, r, ii, jj;
	double a[NMAX][NMAX], *pa[NMAX], b[NMAX];
	void gauss_elimination();

	find_e(N, R, e, ptrans);
	for (r = 0; r < R; ++r)
	{
		for (i = 0, ii = 0; i < N; ++i)
		{
			if (e[i][r] != 0)
			{
				pa[ii] = a[ii];
				for (j = 0, jj = 0; j < N; ++j)
				{
					if (e[j][r] != 0)
					{
						a[ii][jj] = ptrans[r][j + 1][i + 1] - (i == j);
						++jj;
					}
				}
				b[ii] = -ptrans[r][0][i + 1];
				++ii;
			}
		}
		gauss_elimination(ii, pa, b);
		for (i = 0, ii = 0; i < N; ++i)
		{
			if (e[i][r] != 0)
			{
				e[i][r] = b[ii];
				++ii;
			}
		}
	}
}
