/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988, 1994
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  91058 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tput_dekomp.c\t1.1\t94/04/25 16:50:03";

#include <stdio.h>
#include "d_speicher.h"
#include "d_netz.h"
#define EXTERN_KNOTENTYPEN
#include "d_konst.h"
#include "libpepsy.h"

extern int dbg;
extern netzstruktur netz;
extern double **mem_ank_quadvar;

int put_dekomp(fp)
FILE *fp;
{
	register netzstruktur *np = &netz;
	int i,j,k;
	double **A, *b, *x;

	if(dbg)
		fprintf(stderr,"put_dekomp\n");
	
	/* Netz-Typ */
	fprintf(fp,"%d\n", np->typ);

	/* Anzahl der Knoten */
	fprintf(fp,"%d\n",np->knot);

	/* Anzahl der Klassen */
	fprintf(fp,"%d\n",np->klass);

	/* Knoten-Typ */
	for(i=0;i<np->knot;i++)
	{
		fprintf(fp,"%d  ",np->knotentyp[i]);
	}
	fprintf(fp,"\n");

	/* Anzahl der Bedieneinheiten */
	for(i=0;i<np->knot;i++)
	{
		fprintf(fp,"%d  ",np->bede[i]);
	}
	fprintf(fp,"\n");

	/* Ankunftsraten pro Klasse */ 
	fprintf(fp,"\n");
	for(i=0;i<np->klass;i++) 	
	{
		fprintf(fp,"%g  ",np->ankr[i]);
	}
	fprintf(fp,"\n");

	/* quad. Varkoeff des Ankunftsprozesses */
	for(i=0;i<np->klass;i++) 	
	{

		for(j=0;j<np->knot;j++) 	
		{
			fprintf(fp,"%g  ",mem_ank_quadvar[j][i]);
		}
		fprintf(fp,"\n");
	}
	fprintf(fp,"\n");

	/* Bedienraten pro Klasse und Knoten */
	for(i=0;i<np->klass;i++) 	
	{
		for(j=0; j<np->knot; j++)
		{
			fprintf(fp,"%g  ",np->bedr[j][i]);
		}
		fprintf(fp,"\n");
	}
	fprintf(fp,"\n");

	/* quad. VarKoeff des Bedienprozesses */
	for(i=0;i<np->klass;i++) 	
	{
		for(j=0; j<np->knot; j++)
		{
			fprintf(fp,"%g  ",np->quadvar[j][i]);
		}
		fprintf(fp,"\n");
	}
	fprintf(fp,"\n");

	/* Uebergangswahrscheinlichkeiten pro Klasse von Knoten zu Knoten */
	for (k=0; k<np->klass; k++)
	{
		for(i=0;i<=np->knot;i++) 	/* Uebergangswahrscheinlichkeiten */
		{
			for(j=0;j<=np->knot;j++)
			{
				fprintf(fp,"%g  ",np->uew[i][j][k]);
			}
			fprintf(fp,"\n");
		}
		fprintf(fp,"\n");
	}
	fprintf(fp,"\n");

	/* Abbruchkriterium */
	fprintf(fp,"%g\n\n",1e-5);



	/* Berechnen der Besuchshaeufigkeiten */

	if((A = d_2dim_alloc(np->knot,np->knot)) == (double **) 0)
		mall_err("put_mem(1)");
	if((b = d_1dim_alloc(np->knot)) == (double *) 0)
		mall_err("put_mem(2)");
	if((x = d_1dim_alloc(np->knot)) == (double *) 0)
		mall_err("put_mem(3)");
	{
		for(i=0;i<np->klass;i++)
		{
			for(j=1;j<=np->knot;j++) /* rechte Seite  und Matrix aufbauen */
			{
				b[j-1] = -np->uew[0][j][i];
				for(k=1;k<=np->knot;k++) /* rechte Seite  und Matrix aufbauen */
				{
					A[j-1][k-1] = np->uew[k][j][i];
				}
				A[j-1][j-1] -= 1.0;
			}
			if(gauss(A,x,b,np->knot,1e-20) < 0)
			{
				fprintf(stderr,"Klasse %d: Matrix singulaer\n",i+1);
				exit(1);
			}
			for(j=0;j<np->knot;j++)
			{	
				fprintf(fp,"%g ",x[j]);
				/*
				np->besh[j][i] = x[j];
				*/
			}
			fprintf(fp,"\n");
		}
	}
	return(0);
}

