/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tput_epf.c\t1.3\t92/08/24 11:11:37";

#include <stdio.h>
#include "d_speicher.h"
#include "d_netz.h"
#define	EXTERN_KNOTENTYPEN
#include "d_konst.h"

extern int dbg;
extern netzstruktur netz;

put_epf(fp)
FILE *fp;
{
	register netzstruktur *np = &netz;
	int i,j,k,l;
	double **A;
	double *b,*x;
	double atof();

	if(dbg)
		fprintf(stderr,"put_epf\n");
	
	if(np->haeuf) 	/* Uebergangswahrscheinlichkeiten werden umgerechnet */
	{
		if((A = d_2dim_alloc(np->knot,np->knot)) == (double **) 0) mall_err("put_marie(1)");
		if((b = d_1dim_alloc(np->knot)) == (double *) 0) mall_err("put_marie(2)");
		if((x = d_1dim_alloc(np->knot)) == (double *) 0) mall_err("put_marie(3)");
		{
			for(i=0;i<np->klass;i++)
			{
				for(j=1;j<=np->knot;j++) /* rechte Seite  und Matrix aufbauen */
				{
					b[j-1] = -np->uew[0][j][i];
					for(k=1;k<=np->knot;k++) /* rechte Seite  und Matrix aufbauen */
					{
						A[j-1][k-1] = np->uew[k][j][i];
					}
					A[j-1][j-1] -= 1.0;
				}
				if(gauss(A,x,b,np->knot,1e-20) < 0)
				{
					fprintf(stderr,"Klasse %d: Matrix singulaer\n",i+1);
					exit(1);
				}
				for(j=0;j<np->knot;j++)
				{	
					np->besh[j][i] = x[j];
				}
			}
		}
		np->haeuf = 0;
	}
	fprintf(fp,"%d\n\n",np->knot); /* Knoten */
	fprintf(fp,"%d  ",np->auftr[0]);	/* Auftraege */
	fprintf(fp,"\n");

	for(j=0;j<np->knot;j++) /* Knotentyp */
	{
		switch(np->knotentyp[j])
		{
			case TYP1:
				fprintf(fp,"1  ");
				break;
			case TYP3:
				fprintf(fp,"3  ");
				break;
			case TYP5:
				fprintf(fp,"5  ");
				break;
			default:
				fprintf(fp,"0  ");
				break;
		}
	}
	for(j=0;j<np->knot;j++)		/* Bedienraten , Varkoeff*/
	{
		fprintf(fp,"%g  ",np->bedr[j][0]);
		if (np->knotentyp[j] == TYP5)
			fprintf(fp,"%g  ",np->quadvar[j][0]);
	}
	fprintf(fp,"\n");
	fprintf(fp,"\n");
	for(j=0;j<np->knot;j++)		/* Besuchhaeufigkeiten */
		fprintf(fp,"%g  ",np->besh[j][0]);
	fprintf(fp,"\n");
		
}
