/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tget_ermem.c\t1.3\t92/08/24 11:12:35";

#include <stdio.h>
#include "d_netz.h"
#include "d_speicher.h"
#define	EXTERN_KNOTENTYPEN
#include "d_konst.h"

extern int dbg;
extern netzstruktur netz;
double **mem_ank_quadvar;
char zusatzblock[20];

get_ermem(fp)
FILE *fp;
{
	register netzstruktur *np = &netz;
	char buffer[5120], *cp;
	extern double atof();
	int gefunden, i,j;

	if(dbg)
		fprintf(stderr,"get_ermem\n");

	if(np->haeuf == FALSE)
	{
		fprintf(stderr,"Verfahren 'mem' funktioniert nur mit Ueberganswahrscheinlichkeiten\n");
		exit(1);
	}

	if(( mem_ank_quadvar = d_2dim_alloc(np->knot,np->klass)) == (double **) 0) mall_err("get_mem");

	/* Zusatzblock in Eingabedatei suchen */

	get_zusatzblock("ermem",zusatzblock);
	gefunden = FALSE;
	rewind(fp);
	i = strlen(zusatzblock);
	while ( gefunden == FALSE && nextline(fp,buffer,5120) != EOF )
	{
		if (strncmp(zusatzblock,buffer,i) == 0)
		{
			if(dbg)
				fprintf(stderr,"get_mem : Zusatzblock %s gefunden\n",buffer);
			gefunden = TRUE;
		}
	}

	if (gefunden == TRUE)
	{
		nextline(fp,buffer,5120);
		nextline(fp,buffer,5120);
		nextline(fp,buffer,5120);
		for(i=0;i<np->knot;i++)
		{
			nextline(fp,buffer,5120);
			/* bis "|" lesen */
			cp = buffer;
			while(*cp != '\0' && *cp++ != '|')
				;

			if (dbg)   fprintf(stderr,"get_mem: ank_quadvar %d : ",i);
			for(j=0;j<np->klass;j++)
			{
				while(*cp == ' ')
					*cp++;
					/*
				sscanf(cp,"%lf",&mem_ank_quadvar[i][j]);
				*/
				mem_ank_quadvar[i][j] = atof(cp);
				while(*cp != '\0' && (*cp != ' ' && *cp != '\n'))
					cp++;
				if (dbg)   fprintf(stderr,"%lf ",mem_ank_quadvar[i][j]);
			}
			if(dbg) fprintf(stderr,"\n");
		}
	}
	else
	{
		if(dbg)
			fprintf(stderr,"get_mem : kein Zusatzblock gefunden\n");
		for(i=0;i<np->knot;i++)
		{
			for(j=0;j<np->klass;j++)
			{
				mem_ank_quadvar[i][j] = 1.0;
				if (dbg)   fprintf(stderr,"get_mem: ank_quadvar %d : %lf \n",i,mem_ank_quadvar[i]);
			}
		}
	}
}

