/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tprefilter.c\t1.4\t94/02/15 09:53:46";

#include <stdio.h>
#include <ctype.h>
#include "d_netz.h"
#include "d_konst.h"
#include "d_speicher.h"
#include "sim.h"

#define USAGE()	{ \
	fprintf(stderr,"Korrekter Aufruf: prefilter [-dnum] verfahren dateinname [weitere Paramter]\n"); \
	exit(1); }

/*
	Transformiert eine PEPSY-Standarddatei in eine
	verfahrensspezifische Eingabedatei

   -d[Zahl] : 	Debug-Niveau		
   - verfahren
   - Eingabedateiname ( default stdin)			
   							
*/

int 	dbg = 0;       	/* debug - niveau			*/
int     arguments;
netzstruktur netz;
char *verf, verfahren[20], datei[100];

main(argc,argv)
int	argc;
char	*argv[];
{
    /*		Sccs support from SccsLogging.c			*/	
    extern int SccsRelease;
    extern int SccsLevel;

    extern char *optarg;
    extern int optind;
    int c;
    FILE *fpin;

    while(( c= getopt(argc,argv,"Vd:")) != EOF)
    {
	switch(c)
	{
	    case 'V':
		    fprintf(stdout, "%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
		    exit(0);
		    break;
	    case 'd':
		    if((dbg = atoi(optarg)) <= 0)
			    dbg = 1;
		    break;
	    default:
		    fprintf(stderr,"\nUnbekannte Option -%c !!!\n", c);
		    USAGE();
		    break;
	}
    }

    if(dbg > 5)
	fprintf(stderr,"argc - optind = %d\n",argc-optind);

    arguments = argc;
    switch(argc - optind)
    {
	case 0:
	case 1:
		USAGE();
		break;
	case 2:
		verf = argv[optind];
		strcat(datei,"e_");
		strcat(datei,argv[optind+1]);
		if ((fpin = fopen(datei,"r")) == NULL)
		{
		    fprintf(stderr,"prefilter: Datei '%s' kann nicht geoeffnet werden !\n",datei);
		    exit(1);
		}
		break;
    }


    if(get_verfahren(verf,verfahren) < 0 )
    {
	fprintf(stderr,"Unbekanntes Verfahren '%s'\n",verf);
	exit(1);
    }

    if(dbg)
    {
	fprintf(stderr,"debug-niveau: %d\n",dbg);
	fprintf(stderr,"verfahren = %s\n",verfahren);
	fprintf(stderr,"datei = %s\n",datei);
    }

    if(get_standard(fpin) < 0) 
    {
	fprintf(stderr,"get_standard failed\n");
	exit(1);
    }

    if(get_ermem(fpin) < 0)
    {
	fprintf(stderr,"get_ermem failed\n");
	exit(1);
    }

    if(put_friedhof(stdout,verfahren) < 0)
    {
	fprintf(stderr,"put_friedhof failed\n");
	exit(1);
    }

    return(0);
}
