/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tput_ermem.c\t1.3\t92/08/24 11:12:36";

#include <stdio.h>
#include "d_speicher.h"
#include "d_netz.h"
#define	EXTERN_KNOTENTYPEN
#include "d_konst.h"

extern int dbg;
extern netzstruktur netz;
extern double **mem_ank_quadvar;

put_ermem(fp)
FILE *fp;
{
	register netzstruktur *np = &netz;
	int i,j,k,l;
	double **A, *b, *x;

	if(dbg)
		fprintf(stderr,"put_ermem\n");
	
	fprintf(fp,"%d\n",np->knot); /* Knoten  */
	fprintf(fp,"%d\n",np->klass); /* Klass  */
	fprintf(fp,"\n");

	for(j=0;j<np->knot;j++) /* Knotentyp und Bedieneinheiten*/
	{
		switch(np->knotentyp[j])
		{
				case TYP1:
						fprintf(fp,"1  ");
						break;
				case TYP2:
						fprintf(fp,"2  ");
						fprintf(fp,"%d  ", np->bede[j]);
						break;
				case TYP3:
						fprintf(fp,"3  ");
						break;
				case TYP4:
						fprintf(fp,"4  ");
						break;
				case TYP5:
						fprintf(fp,"5  ");
						break;
				case TYP6:
						fprintf(fp,"6  ");
						fprintf(fp,"%d  ", np->bede[j]);
						break;
				case TYP7:
						fprintf(fp,"7  ");
						break;
				case TYP8:
						fprintf(fp,"8  ");
						fprintf(fp,"%d  ", np->bede[j]);
						break;
				case TYP9:
						fprintf(fp,"9  ");
						break;
				default:
						fprintf(fp,"0  ");
						break;
		}
	}
	fprintf(fp,"\n");
	for(i=0;i<np->klass;i++) 	/* Ankunftsrate */
			fprintf(fp,"%g  ",np->ankr[i]);

	fprintf(fp,"\n");

	for(k=0;k<np->klass;k++) 
	{
		for(j=0;j<np->knot;j++) 	/* Bedienraten */
		{
			fprintf(fp,"%g  ",np->bedr[j][k]);
			if((np->knotentyp[j]==TYP5)     /* M/G/1-FCFS */
			   || (np->knotentyp[j]==TYP6)    /* M/G/m-FCFS */
			   || (np->knotentyp[j]==TYP7)    /* G/G/1-FCFS */
			   || (np->knotentyp[j]==TYP8)    /* G/G/m-FCFS */
			   )
				fprintf(fp,"%g  ",np->quadvar[j][k]);

		}
		fprintf(fp,"\n");

		for(i=0;i<=np->knot;i++) /* Uebergangswahrscheinlichkeiten */
		{
			for(j=0;j<=np->knot;j++)
			{
				fprintf(fp,"%g  ",np->uew[i][j][k]);
			}
			fprintf(fp,"\n");
		}
		fprintf(fp,"\n");
	}

	for(i=0;i<np->klass;i++) 	/* Varkoeff */
	{
		for(j=0;j<np->knot;j++)
		{
			fprintf(fp,"%g  ",mem_ank_quadvar[j][i]);
		}
		fprintf(fp,"\n");
	}
	fprintf(fp,"\n");

}

