/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tput_mem.c\t1.3\t92/08/24 12:45:41";

#include <stdio.h>
#include "d_speicher.h"
#include "d_netz.h"
#define EXTERN_KNOTENTYPEN
#include "d_konst.h"

extern int dbg;
extern netzstruktur netz;
extern double **mem_ank_quadvar;

put_mem(fp)
FILE *fp;
{
	register netzstruktur *np = &netz;
	int i,j,k,l;
	double **A, *b, *x;

	if(dbg)
		fprintf(stderr,"put_mem\n");
	
	fprintf(fp," %d\n",np->typ);
	fprintf(fp,"%d\n",np->knot); /* Knoten  */
	fprintf(fp,"%d\n",np->klass); /* Klass  */
	fprintf(fp,"\n");
	if(np->typ == OFFEN)
	{
		for(i=0;i<np->klass;i++) 	/* Ankunftsrate pro Knoten */
		{
			for(j=1;j<=np->knot;j++) 	
			{
				fprintf(fp,"%g  ",np->uew[0][j][i] * np->ankr[i]);
			}
			fprintf(fp,"\n");
		}
		fprintf(fp,"\n");
		for(i=0;i<np->klass;i++) 	/* Varkoeff */
		{
			for(j=0;j<np->knot;j++)
			{
				fprintf(fp,"%g  ",mem_ank_quadvar[j][i]);
			}
			fprintf(fp,"\n");
		}
		fprintf(fp,"\n");
	}
	else
	{
		for(i=0;i<np->klass;i++) 	/* Auftraege */
		{
			fprintf(fp,"%d  ",np->auftr[i]);
		}
		fprintf(fp,"\n");
	}
	for(i=0;i<np->klass;i++) 
	{
		for(j=0;j<np->knot;j++) 	/* Bedienraten */
		{
			fprintf(fp,"%g  ",np->bedr[j][i]);
		}
		fprintf(fp,"\n");
	}
	for(i=0;i<np->klass;i++) 
	{
		for(j=0;j<np->knot;j++) 	/* VarKoeff Bedienung */
		{
			fprintf(fp,"%g  ",np->quadvar[j][i]);
		}
		fprintf(fp,"\n");
	}
	if(np->typ == OFFEN)
	{
		for(k=0;k<np->klass;k++)
		{
			for(i=1;i<=np->knot;i++) 	/* Uebergangswahrscheinlichkeiten */
			{
				for(j=1;j<=np->knot;j++)
				{
					fprintf(fp,"%g  ",np->uew[i][j][k]);
				}
				fprintf(fp,"\n");
			}
			fprintf(fp,"\n");
		}
	}
	else
	{
		for(k=0;k<np->klass;k++)
		{
			for(i=1;i<=np->knot;i++) 	/* Uebergangswahrscheinlichkeiten */
			{
				if(np->uew[i][0][k] >= 0.0)
				{
					for(l=1;l<=np->knot;l++)
					{
						np->uew[i][l][k] += np->uew[i][0][k] * np->uew[0][l][k];
					}
				}
				for(j=1;j<=np->knot;j++)
				{
					fprintf(fp,"%g  ",np->uew[i][j][k]);
				}
				fprintf(fp,"\n");
				if(np->uew[i][0][k] >= 0.0)
				{
					for(l=1;l<=np->knot;l++)
					{
						np->uew[i][l][k] -= np->uew[i][0][k] * np->uew[0][l][k];
					}
				}
			}
			fprintf(fp,"\n");
		}

	}

	/* Berechnen der Besuchshaeufigkeiten */

	if((A = d_2dim_alloc(np->knot,np->knot)) == (double **) 0) mall_err("put_mem(1)");
	if((b = d_1dim_alloc(np->knot)) == (double *) 0) mall_err("put_mem(2)");
	if((x = d_1dim_alloc(np->knot)) == (double *) 0) mall_err("put_mem(3)");
	{
		for(i=0;i<np->klass;i++)
		{
			for(j=1;j<=np->knot;j++) /* rechte Seite  und Matrix aufbauen */
			{
				b[j-1] = -np->uew[0][j][i];
				for(k=1;k<=np->knot;k++) /* rechte Seite  und Matrix aufbauen */
				{
					A[j-1][k-1] = np->uew[k][j][i];
				}
				A[j-1][j-1] -= 1.0;
			}
			if(gauss(A,x,b,np->knot,1e-20) < 0)
			{
				fprintf(stderr,"Klasse %d: Matrix singulaer\n",i+1);
				exit(1);
			}
			for(j=0;j<np->knot;j++)
			{	
				fprintf(fp,"%g ",x[j]);
				/*
				np->besh[j][i] = x[j];
				*/
			}
			fprintf(fp,"\n");
		}
	}
}

