/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tput_sopenpfn.c\t1.1\t94/01/17 15:24:07";

#include <stdio.h>
#include "d_speicher.h"
#include "d_netz.h"
#define	EXTERN_KNOTENTYPEN
#include "d_konst.h"

extern int dbg;
extern netzstruktur netz;
extern int asym;

put_openpfn(fp)
FILE *fp;
{
	netzstruktur *np = &netz;
	int i,j,k,l;
	double **A;
	double *b,*x;

	if(dbg)
		fprintf(stderr,"put_sopenpfn %ld\n",np);
	
	if(netz.haeuf) 	/* Uebergangswahrscheinlichkeiten werden umgerechnet */
	{
		if((A = d_2dim_alloc(np->knot,np->knot)) == (double **) 0) mall_err("put_sopenpfn(1)");
		if((b = d_1dim_alloc(np->knot)) == (double *) 0) mall_err("put_sopenpfn(2)");
		if((x = d_1dim_alloc(np->knot)) == (double *) 0) mall_err("put_sopenpfn(3)");
		{
			for(i=0;i<np->klass;i++)
			{
				for(j=1;j<=np->knot;j++) /* rechte Seite  und Matrix aufbauen */
				{
					b[j-1] = -np->uew[0][j][i];
					for(k=1;k<=np->knot;k++) /* rechte Seite  und Matrix aufbauen */
					{
						A[j-1][k-1] = np->uew[k][j][i];
					}
					A[j-1][j-1] -= 1.0;
				}
				if(gauss(A,x,b,np->knot,1e-20) < 0)
				{
					fprintf(stderr,"Klasse %d: Matrix singulaer\n",i+1);
					exit(1);
				}
				for(j=0;j<np->knot;j++)
				{	
					np->besh[j][i] = x[j];
				}
			}
		}
		np->haeuf = 0;
	}
	fprintf(fp,"%d\n",np->haeuf);	/* Uew-Flag */
	fprintf(fp,"%d\t%d\n\n",np->knot,np->klass); /* Knoten Klassen */
	for(i=0;i<np->knot;i++)       /* Knotentypen, K.R. 14.04.92 */
		fprintf(fp,"%d  ",np->knotentyp[i]);
	fprintf(fp,"\n");
	for(i=0;i<np->klass;i++)	/* Ankuenfte */
		fprintf(fp,"%g  ",np->ankr[i]);
	fprintf(fp,"\n");
	for(i=0;i<np->knot;i++) 	/* Bedieneinheiten */
		fprintf(fp,"%d  ",np->bede[i]);
	fprintf(fp,"\n");
	for(i=0;i<np->klass;i++) 	/* Bedienraten, Besuchshaeufigkeiten */
	{
		for(j=0;j<np->knot;j++)
		{
			fprintf(fp,"%g  ",np->bedr[j][i]);
		}
		fprintf(fp,"\n");
		for(j=0;j<np->knot;j++)
		{
			fprintf(fp,"%g  ",np->besh[j][i]);
		}
		fprintf(fp,"\n");
	}
	fprintf(fp,"\n");
	for(i=0;i<np->knot;i++)       /* Bedienraten bei asymm. Knoten */
	{                                                                
	   /*
	   if (asym)
	   {  
		for(j=0;j<np->bede[i];j++)
		   fprintf(fp,"%g  ",np->amue[i][j]);
	   }
	   fprintf(fp,"\n");
	   */
	}
	 
}
