/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tputpriomva2c.c\t1.3\t92/08/24 12:51:06";

#include <stdio.h>
#include "d_speicher.h"
#include "d_netz.h"
#define EXTERN_KNOTENTYPEN
#include "d_konst.h"

extern int dbg;
extern netzstruktur netz;

put_priomva2c(fp)
FILE *fp;
{
	register netzstruktur *np = &netz;
	int i,j,k,l;
	double **A;
	double *b,*x;

	if(dbg)
		fprintf(stderr,"put_priomva2c\n");
	
	if(np->haeuf) 	/* Uebergangswahrscheinlichkeiten werden umgerechnet */
	{
		if((A = d_2dim_alloc(np->knot,np->knot)) == (double **) 0) mall_err("put_priomva(1)");
		if((b = d_1dim_alloc(np->knot)) == (double *) 0) mall_err("put_priomva(2)");
		if((x = d_1dim_alloc(np->knot)) == (double *) 0) mall_err("put_priomva(3)");
		{
			for(i=0;i<np->klass;i++)
			{
				for(j=1;j<=np->knot;j++) /* rechte Seite  und Matrix aufbauen */
				{
					b[j-1] = -np->uew[0][j][i];
					for(k=1;k<=np->knot;k++) /* rechte Seite  und Matrix aufbauen */
					{
						A[j-1][k-1] = np->uew[k][j][i];
					}
					A[j-1][j-1] -= 1.0;
				}
				if(gauss(A,x,b,np->knot,1e-20) < 0)
				{
					fprintf(stderr,"Klasse %d: Matrix singulaer\n",i+1);
					exit(1);
				}
				for(j=0;j<np->knot;j++)
				{	
					np->besh[j][i] = x[j];
				}
			}
		}
		np->haeuf = 0;
	}
	fprintf(fp,"%d\t%d\n\n",np->knot,np->klass); /* Knoten Klassen */
	for(i=0;i<np->knot;i++) 	/* Knotentyp */
	{
		switch(np->knotentyp[i])
		{
			case TYP1:
			case TYP3:
			case TYP9:
				fprintf(fp,"1  ");
				break;
			case TYP4:
				fprintf(fp,"0  ");
				break;
			case TYP10:
				fprintf(fp,"2  ");
				break;
			case TYP11:
				fprintf(fp,"3  ");
				break;
			case TYP2:
				fprintf(fp,"4 %d  ",np->bede[i]);
				break;
			default:
				fprintf(fp,"-1  ");
				break;
		}
	}
	fprintf(fp,"\n");

	for(i=0;i<np->klass;i++)	/* Auftraege */	/* Klassentyp, 0 geschlossen, 1 offen */
		if(np->auftr[i] > 0)
			fprintf(fp," 0  %d  ",np->auftr[i]);
		else
			fprintf(fp,"1  %g  ",np->ankr[i]);
	fprintf(fp,"\n");
	fprintf(fp,"0\n"); /* Flag fuer Besh */
	for(i=0;i<np->klass;i++) 	/* Bedienraten, Besh */
	{
		for(j=0;j<np->knot;j++)
		{
			fprintf(fp,"%g  %g\t",np->bedr[j][i],np->besh[j][i]);
		}
		fprintf(fp,"\n");
	}
	fprintf(fp,"\n");
		
}
