/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tput_recal.c\t1.3\t92/08/24 12:54:25";

#include <stdio.h>
#include "d_speicher.h"
#include "d_netz.h"
#define EXTERN_KNOTENTYPEN
#include "d_konst.h"

extern int dbg;
extern netzstruktur netz;

put_recal(fp)
FILE *fp;
{
	register netzstruktur *np = &netz;
	int i,j,k,l;
	double **A;
	double *b,*x;

	if(dbg)
		fprintf(stderr,"put_reacl\n");
	
	if(np->haeuf) 	/* Uebergangswahrscheinlichkeiten werden umgerechnet */
	{
		if((A = d_2dim_alloc(np->knot,np->knot)) == (double **) 0) mall_err("put_scat(1)");
		if((b = d_1dim_alloc(np->knot)) == (double *) 0) mall_err("put_scat(2)");
		if((x = d_1dim_alloc(np->knot)) == (double *) 0) mall_err("put_scat(3)");
		{
			for(i=0;i<np->klass;i++)
			{
				for(j=1;j<=np->knot;j++) /* rechte Seite  und Matrix aufbauen */
				{
					b[j-1] = -np->uew[0][j][i];
					for(k=1;k<=np->knot;k++) /* rechte Seite  und Matrix aufbauen */
					{
						A[j-1][k-1] = np->uew[k][j][i];
					}
					A[j-1][j-1] -= 1.0;
				}
				if(gauss(A,x,b,np->knot,1e-20) < 0)
				{
					fprintf(stderr,"Klasse %d: Matrix singulaer\n",i+1);
					exit(1);
				}
				for(j=0;j<np->knot;j++)
				{	
					np->besh[j][i] = x[j];
				}
			}
		}
		np->haeuf = 0;
	}
	fprintf(fp,"%d\t%d\n\n",np->knot,np->klass); /* Knoten Klassen */
	for(i=0;i<np->knot;i++)
	{
			/* Strategien */
			switch(np->knotentyp[i])
			{
				case TYP1:
					fprintf(fp,"1 \n");
					break;
				case TYP2:
					fprintf(fp,"5 %d \n",np->bede[i]);
					break;
				case TYP3:
					fprintf(fp,"2 \n");
					break;
				case TYP4:
					fprintf(fp,"3 \n");
					break;
				case TYP9:
					fprintf(fp,"4 \n");
					break;
				default:
					fprintf(fp,"-1\n");
					break;
			}
	}
	fprintf(fp,"\n");
	for(i=0;i<np->klass;i++)	/* Auftraege */
		fprintf(fp,"%d  ",np->auftr[i]);
	fprintf(fp,"\n");
	fprintf(fp,"0\n"); /* Flag fuer Besuchshaeufigkeiten */
	for(i=0;i<np->klass;i++)	/* Bedienraten */
	{	
		for(j=0;j<np->knot;j++)
		{
			fprintf(fp,"%g  %g\t",np->bedr[j][i], np->besh[j][i]);
		}
		fprintf(fp,"\n");
	}
	fprintf(fp,"\n");
}
