/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tprocs.c\t1.3\t92/05/22 10:03:18";

#include <stdio.h>
#include <d_konst.h>
#include <d_netz.h>
#include <d_asym.h>
#include <data.h>
#include	<sim.h>

extern void *calloc();

netzstruktur netz;
int			 debug, dbg;

int	random_selection;												/* aus e2s.c */

extern struct prozess **general, *ankunft;						/* aus get_sim.c	*/
extern int				  *kapazitaet;
extern int					sim_dauer, deadlock, block_arrival;

extern int					AnzWs, AnzBe, AnzKl;							/* aus e2s.c oder s2p.c	*/
extern int				  *firstWs, *firstBe;							/* ---------- " ------- */

extern asym_data_type	asym_data;										/* aus get_asym.c		*/

int GetProzessVtlg(code, quadvar)
int		code;
double	quadvar;
/*
**
*/
{
	switch(code)
	{
	case 0	:	
		if (quadvar<0.1)	return(CONST_VTLG);
		if (quadvar<1.0)	return(COX_VTLG);
		if (quadvar>1.0)	return(HYPEREXP_VTLG);
		return(EXPON_VTLG);
		break;
	case 1	:	
		return(LOGNORM_VTLG);
	case 2	:	
		if (quadvar<1.0) return(DETEXP_VTLG);
		return(GE_VTLG);
	case 3	:	
		if (quadvar>1.0)	return(COX2_VTLG);
		if (quadvar==1.0)	return(EXPON_VTLG);
		if (quadvar>=0.5)	return(HYPOEXP_VTLG);
		fprintf(stderr, "FEHLER: Prozesscode=3, C2<0.5!\n");
		exit(-1);
	default	:	
		fprintf(stderr, "FEHLER: Prozess hat unbekannten Code %d !\n", code);
		exit(-1);
	}
}

int GetAnzBe(knoten)
int knoten;
{
	if (knoten == 0)
	{
		return(1);
	}
	else
	{
		switch(netz.knotentyp[knoten-1])
		{
		case	TYP1	:
		case	TYP3	:
		case	TYP4	:
		case	TYP5	:
		case	TYP7	:
		case	TYP9	:
		case	TYP10	:
		case	TYP11	:
		case	TYP12	:
		case	TYP13	:
		case	TYP14	:
		case	TYP15	:	
			return(1);
			break;
		case	TYP2	:
		case	TYP6	:
		case	TYP8	:
		case	TYP16	:
		case	TYP17	:
		case	TYP18	:
		case	TYP19	:	
		case	TYP20	:	
		case	TYP21	:	
			return(netz.bede[knoten-1]);
			break;

		default		:	
			fprintf(stderr, "GetAnzBe: FATAL - Unbekannter Knotentyp %d Knoten %d!\n",
			    netz.knotentyp[knoten-1], knoten);
			exit(-1);
		}
	}
}

int GetAnzSE(knoten)
int knoten;
{
	if (knoten == 0)
	{
		return(1);
	}
	else
	{
		switch(netz.knotentyp[knoten-1])
		{
		case	TYP1	:
		case	TYP2	:
		case	TYP4	:
		case	TYP5	:
		case	TYP6	:
		case	TYP7	:
		case	TYP8	:
		case	TYP9	:
		case	TYP10	:
		case	TYP11	:
		case	TYP14	:
		case	TYP15	:
		case	TYP16	:
		case	TYP17	:
		case	TYP18	:
		case	TYP19	:	
		case	TYP20	:	
		case	TYP21	:	
			return(1);
			break;

		case	TYP3	:
		case	TYP12	:
		case	TYP13	:	
			return(netz.bede[knoten-1]);
			break;

		default		:	
			fprintf(stderr, "GetAnzBe: FATAL - Unbekannter Knotentyp %d Knoten %d!\n",
			    netz.knotentyp[knoten-1], knoten);
			exit(-1);
		}
	}
}

int GetAnzWs(knoten)
int knoten;
{
	if (knoten == 0)
	{
		return(1);
	}
	else
	{
		switch(netz.knotentyp[knoten-1])
		{
		case	TYP1	:
		case	TYP2	:
		case	TYP3	:
		case	TYP4	:
		case	TYP5	:
		case	TYP6	:
		case	TYP7	:
		case	TYP8	:
		case	TYP9	:						/* !!!!!!!!! */
		case	TYP12	:
		case	TYP13	:	
		case	TYP20	:	
		case	TYP21	:	
			return(1);
			break;
		case	TYP10	:
		case	TYP11	:
		case	TYP14	:
		case	TYP15	:
		case	TYP16	:
		case	TYP17	:
		case	TYP18	:
		case	TYP19	:	
			return(netz.klass);
			break;

		default		:	
			fprintf(stderr, "GetAnzWs: FATAL - Unbekannter Knotentyp %d Knoten %d!\n",
			    netz.knotentyp[knoten-1], knoten);
			exit(-1);
		}
	}
}

int GetBE_Typ(knoten)
int knoten;
/*
**	Zu einem PepsyKnoten soll der BE_Typ ermittelt werden
**
*/
{
	if (knoten == 0)
	{
		return(IS_BT);
	}
	else
	{
		switch(netz.knotentyp[knoten-1])
		{
		case	TYP1	:
		case	TYP2	:
		case	TYP5	:
		case	TYP6	:
		case	TYP7	:
		case	TYP8	:
		case	TYP9	:
		case	TYP10	:
		case	TYP11	:
		case	TYP14	:
		case	TYP15	:
		case	TYP16	:
		case	TYP17	:
		case	TYP18	:
		case	TYP19	:	
		case	TYP20	:	
		case	TYP21	:	
			return(NORMAL_BT);
			break;

		case	TYP3	:
		case	TYP12	:
		case	TYP13	:	
			return(PS_BT);
			break;

		case	TYP4	:	
			return(IS_BT);
			break;

		default		:	
			fprintf(stderr, "GetListTyp: FATAL - Unbekannter Knotentyp %d Knoten %d!\n",
			    netz.knotentyp[knoten-1], knoten);
			exit(-1);
		}
	}
}

int GetListTyp(knoten)
int knoten;
{
	if (knoten == 0)
	{
		return((random_selection)?FCFS_RS_LT:FCFS_LT);
	}
	else
	{
		switch(netz.knotentyp[knoten-1])
		{
		case	TYP1	:
		case	TYP2	:
		case	TYP4	:
		case	TYP5	:
		case	TYP6	:
		case	TYP7	:
		case	TYP8	:
		case	TYP10	:
		case	TYP11	:
		case	TYP14	:
		case	TYP15	:
		case	TYP16	:
		case	TYP17	:
		case	TYP18	:
		case	TYP19	:	
		case	TYP20	:	
		case	TYP21	:	
			return((random_selection)?FCFS_RS_LT:FCFS_LT);
			break;

		case	TYP9	:	
			return((random_selection)?LCFS_RS_LT:LCFS_LT);
			break;

		case	TYP3	:
		case	TYP12	:
		case	TYP13	:	
			return(PS_LT);
			break;

		default		:	
			fprintf(stderr, "GetListTyp: FATAL - Unbekannter Knotentyp %d Knoten %d!\n",
			    netz.knotentyp[knoten-1], knoten);
			exit(-1);
		}
	}
}

boolean TestPRE(knoten)
int knoten;
{
	if (knoten == 0)
	{
		return(FALSE);
	}
	else
	{
		switch(netz.knotentyp[knoten-1])
		{
		case	TYP1	:
		case	TYP2	:
		case	TYP3	:
		case	TYP4	:
		case	TYP5	:
		case	TYP6	:
		case	TYP7	:
		case	TYP8	:
		case	TYP11	:
		case	TYP12	:
		case	TYP13	:
		case	TYP15	:
		case	TYP17	:
		case	TYP19	:	
		case	TYP20	:	
		case	TYP21	:	
			return(FALSE);
			break;
		case	TYP9	:
		case	TYP10	:
		case	TYP14	:
		case	TYP16	:
		case	TYP18	:	
			return(TRUE);
			break;
		default		:	
			fprintf(stderr, "TestPRE: FATAL - Unbekannter Knotentyp %d Knoten %d!\n",
			    netz.knotentyp[knoten-1], knoten);
			exit(-1);
		}
	}
}

boolean TestNONPRE(knoten)
int knoten;
{
	if (knoten == 0)
	{
		return(FALSE);
	}
	else
	{
		switch(netz.knotentyp[knoten-1])
		{
		case	TYP1	:
		case	TYP2	:
		case	TYP3	:
		case	TYP4	:
		case	TYP5	:
		case	TYP6	:
		case	TYP7	:
		case	TYP8	:
		case	TYP9	:
		case	TYP10	:
		case	TYP12	:
		case	TYP13	:
		case	TYP14	:
		case	TYP16	:
		case	TYP18	:	
		case	TYP20	:	
		case	TYP21	:	
			return(FALSE);
			break;
		case	TYP11	:
		case	TYP15	:
		case	TYP17	:
		case	TYP19	:	
			return(TRUE);
			break;
		default		:	
			fprintf(stderr, "TestPRE: FATAL - Unbekannter Knotentyp %d Knoten %d!\n",
			    netz.knotentyp[knoten-1], knoten);
			exit(-1);
		}
	}
}

void fprintPRE(fp, knoten, klasse)
FILE *fp;
int	knoten,
klasse;
{
	int j;

	if (TestPRE(knoten))
	{
		if (netz.knotentyp[knoten-1] == TYP9)
		{
			for (j=0; j<AnzKl; j++)
				fprintf(fp, "1 ");
		}
		else
		{
			for (j=0; j<klasse; j++)
				fprintf(fp, "1 ");
			for (j=klasse; j<AnzKl; j++)
				fprintf(fp, "0 ");
		}
	}
	else
	{
		for (j=0; j<AnzKl; j++)
			fprintf(fp, "0 ");
	}
}

int GetBeVtlg(knoten, bedeinh, klasse, par1, par2)
int		knoten,
			bedeinh,
			klasse;
double  *par1,
		  *par2;
{
	int vtlg;

	if (knoten == 0)
	{
		if (netz.ankr[klasse]!=0.0)
		{
			vtlg = GetProzessVtlg(ankunft[klasse].code,ankunft[klasse].wert2);

			*par1 = 1.0 / ankunft[klasse].wert1;	/* den MW aus der Rate bestimmen !!! */
			*par2 = ankunft[klasse].wert2;
		}
		else
		{
			*par1 = *par2 = 0.0;

			vtlg = CONST_VTLG;
		}
	}
	else
	{
		switch(netz.knotentyp[knoten-1])
		{
		case	TYP20 :
		case  TYP21 :
			*par1 = 1.0 / ((asym_data.bedrate[klasse])[knoten-1])[bedeinh];
			break;
		default		:
			*par1 = 1.0 / general[knoten-1][klasse].wert1;	/* Mittelwert aus Rate bestimmen */
			break;
		}

		*par2 = general[knoten-1][klasse].wert2;			/* QuadVarkoeff					   */

		switch(netz.knotentyp[knoten-1])
		{
		case	TYP1	:
		case	TYP2	:
		case	TYP10	:
		case	TYP11	:
		case	TYP16	:
		case	TYP17	:	
		case	TYP20	:	
			vtlg = EXPON_VTLG;
			break;
		case	TYP3	:
		case	TYP4	:
		case	TYP5	:
		case	TYP6	:
		case	TYP7	:
		case	TYP8	:
		case	TYP9	:
		case	TYP12	:
		case	TYP13	:
		case	TYP14	:
		case	TYP15	:
		case	TYP18	:
		case	TYP19	:	
		case	TYP21	:	
			vtlg = GetProzessVtlg(general[knoten-1][klasse].code, *par2);
			break;
		default		:	
			fprintf(stderr, "GetBeVtlg: FATAL - Unbekannter Knotentyp %d Knoten %d!\n",
			    netz.knotentyp[knoten-1], knoten);
			exit(-1);
		}
	}

	return(vtlg);
}

char *GetName(knoten)
int knoten;
{
	if (knoten == 0)
	{
		return ("AUSSEN");
	}
	else
	{
		return (netz.knotname[knoten-1]);
	}
}

int GetBe(k)
int k;
{
	int r=0;

	while (k<firstBe[r])
		r++;

	return(r);
}

int GetKnoten(zielWs)
int zielWs;
/*
**	Zu einer Warteschlange des Simulators wird der zugehoerige Pepsyknoten ermittelt
**
*/
{
	register int k=0;

	while(firstWs[k+1] <= zielWs)
		k++;

	return(k);
}

int GetWs(knoten, klasse)
int knoten,
klasse;
/*
**	Zu dem Knoten der Pepsybeschreibung und der Klasse wird die SimulationsWS ermittelt
**
*/
{
	register int w=0;

	if (knoten == 0)
		return(0);
	else
	{
		switch(netz.knotentyp[knoten-1])
		{
		case	TYP1	:
		case	TYP2	:
		case	TYP3	:
		case	TYP4	:
		case	TYP5	:
		case	TYP6	:
		case	TYP7	:
		case	TYP8	:
		case	TYP12	:
		case	TYP13	:	
		case	TYP20	:	
		case	TYP21	:	
			return(firstWs[knoten]);
			break;
		case	TYP9	:
		case	TYP10	:
		case	TYP11	:
		case	TYP14	:
		case	TYP15	:
		case	TYP16	:
		case	TYP17	:
		case	TYP18	:
		case	TYP19	:	
			return(firstWs[knoten]+klasse);
			break;

		default		:	
			fprintf(stderr, "GetWs: FATAL - Unbekannter Knotentyp %d Knoten %d!\n",
			    netz.knotentyp[knoten], knoten);
			exit(-1);
		}
	}
}

char *stripblanks(s)
char *s;
{
	char *r;
	char *c;

	r = c = s;

	do
	{
		*c = *s;
		if ((*c != ' ') && (*c != '\t') && (*c != '\n'))
			c++;
		s++;
	} while (*s != '\0');
	*c = '\0';

	return (r);
}

void InitFirstXX()
{
	int i;

	AnzWs = 0;
	AnzBe = 0;

	for (i=0; i<=netz.knot; i++)
	{
		AnzWs += GetAnzWs(i);
		AnzBe += GetAnzBe(i);
	}

	AnzWs --;
	AnzBe --;
	AnzKl = netz.klass;

	firstWs = (int *)calloc((unsigned)AnzWs+2, sizeof(int)); /* kirschni 2.12.91 */
	firstBe = (int *)calloc((unsigned)AnzBe+2, sizeof(int)); /* kirschni 2.12.91 */

	firstWs[0] = 0;
	firstBe[0] = 0;
	for (i=0; i<=netz.knot; i++)
	{
		firstWs[i+1] = firstWs[i] + GetAnzWs(i);
		firstBe[i+1] = firstBe[i] + GetAnzBe(i);
	}
}
