/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tget_sim.c\t1.3\t92/08/24 13:00:14";

#include <stdio.h>
#include "d_netz.h"
#define EXTERN_KNOTENTYPEN
#include "d_konst.h"
#include "d_speicher.h"
#include "sim.h"

extern int dbg;
extern netzstruktur netz;

static char zusatzblock[1024];
char zeilenbuffer[1024];

struct prozess **general, *ankunft;
int *kapazitaet;
int sim_dauer, deadlock, block_arrival;



get_sim(fp)
FILE *fp;
{
	register netzstruktur *np = &netz;
	char  *cp, *zbuf = &zeilenbuffer[0];
	extern double atof();
	int gefunden, i,j;

	if(dbg)
		fprintf(stderr,"get_sim\n");

	if(np->haeuf == FALSE)
	{
		fprintf(stderr,"Verfahren 'simulation' funktioniert nur mit Uebergangswahrscheinlichkeiten\n");
		exit(1);
	}
	if((kapazitaet = i_1dim_alloc(netz.knot)) == (int *) 0)
		mall_err("get_sim(1)");
	if((ankunft = (struct prozess *) calloc(np->klass , sizeof(struct prozess))) == (struct prozess *) 0)
		mall_err("get_sim(2)");
	if((general = (struct prozess **) calloc(np->knot , sizeof(struct prozess *))) == (struct prozess **) 0)
		mall_err("get_sim(3)");
	for(i=0;i<np->knot;i++)
	{
		if((general[i] = (struct prozess *) calloc(np->klass , sizeof(struct prozess ))) == (struct prozess *) 0)
			mall_err("get_sim(3a)");
	}


	/* Zusatzblock in Eingabedatei suchen */

	get_zusatzblock("sim",zusatzblock);
	gefunden = FALSE;
	i = strlen(zusatzblock);
	rewind(fp);
	while ( gefunden == FALSE && nextline(fp,zbuf,1024) != EOF )
	{
		if (strncmp(zusatzblock,zbuf,i) == 0)
		{
			if(dbg>2)
				fprintf(stderr,"get_sim : Zusatzblock %s gefunden\n",zbuf);
			gefunden = TRUE;
		}
	}

	if (gefunden == TRUE)
	{
		if(nextline(fp,zbuf,5120) == EOF) dateiende("get_sim(1)");
		if(nextline(fp,zbuf,5120) == EOF) dateiende("get_sim(2)");
		if(nextline(fp,zbuf,5120) == EOF) dateiende("get_sim(3)");
		for(i=0;i<np->klass;i++)
		{
			if(nextline(fp,zbuf,5120) == EOF) dateiende("get_sim(4a)");
			cp = zbuf ;
			while(*cp != '\0' && *cp++ != '|' ) ;
			sscanf(cp,"%d %lg %lg %lg %lg",&ankunft[i].code,
				&ankunft[i].wert1,
				&ankunft[i].wert2,
				&ankunft[i].wert3,
				&ankunft[i].wert4);

			if (dbg>2)   fprintf(stderr,"get_sim: ankunft %d  -- %d %g %g %g %g\n",
				i+1,ankunft[i].code,ankunft[i].wert1,ankunft[i].wert2,ankunft[i].wert3,ankunft[i].wert4);
		}
		if(dbg>2) fprintf(stderr,"\n");
		if(nextline(fp,zbuf,5120) == EOF) dateiende("get_sim(5)");
		for(j=0;j<np->klass;j++)
		{
			nextline(fp,zbuf,5120);
			nextline(fp,zbuf,5120);
			nextline(fp,zbuf,5120);
			for(i=0;i<np->knot;i++)
			{
				nextline(fp,zbuf,5120);
				cp = zbuf ;
				while(*cp != '\0' && *cp++ != '|' ) ;
				sscanf(cp,"%d %lg %lg %lg %lg",&general[i][j].code,
					&general[i][j].wert1,
					&general[i][j].wert2,
					&general[i][j].wert3,
					&general[i][j].wert4);

				if (dbg>2)   fprintf(stderr,"get_sim: general %d  %d  -- %d %g %g %g %g\n",
					i+1,j+1,general[i][j].code,general[i][j].wert1,general[i][j].wert2,general[i][j].wert3,general[i][j].wert4);
			}
		}
		if(dbg>2) fprintf(stderr,"\n");
		nextline(fp,zbuf,5120);
		nextline(fp,zbuf,5120);
		nextline(fp,zbuf,5120);
		for(i=0;i<np->knot;i++)
		{
			nextline(fp,zbuf,5120);
			cp = zbuf ;
			while(*cp != '\0' && *cp++ != '|' ) ;
			sscanf(cp,"%d",&kapazitaet[i]);
			if(dbg>2)fprintf(stderr,"get_sim: kapazitaet %d : %d\n",i+1,kapazitaet[i]);
		}
		if(dbg>2)fprintf(stderr,"\n");
		nextline(fp,zbuf,5120);
		nextline(fp,zbuf,5120);
		sim_dauer = atoi(zbuf);
		nextline(fp,zbuf,5120);
		nextline(fp,zbuf,5120);
		deadlock = atoi(zbuf);
		nextline(fp,zbuf,5120);
		block_arrival = atoi(zbuf);
		if(dbg>2)fprintf(stderr,"dauer %d, deadlock %d, block_arr %d\n",
			sim_dauer,deadlock,block_arrival);

	}
	else
	{
		for(i=0;i<np->klass;i++)
		{
			ankunft[i].code = 0;
			ankunft[i].wert1 = netz.ankr[i];
			ankunft[i].wert2 = 1.0;
			ankunft[i].wert3 = 0.0;
			ankunft[i].wert4 = 0.0;
			if (dbg>2)   fprintf(stderr,"get_sim: ankunft %d  -- %d %g %g %g %g\n",
				i+1,ankunft[i].code,ankunft[i].wert1,ankunft[i].wert2,ankunft[i].wert3,ankunft[i].wert4);
		}
		for(i=0;i<np->knot;i++)
		{
			for(j=0;j<np->klass;j++)
			{
				general[i][j].code = 0;
				general[i][j].wert1 = netz.bedr[i][j];
				general[i][j].wert2 = ( netz.quadvar[i][j] == -1.0 ? 1.0 : netz.quadvar[i][j]);
				general[i][j].wert3 = 0.0;
				general[i][j].wert4 = 0.0;
				if (dbg>2)   fprintf(stderr,"get_sim: general %d  %d  -- %d %g %g %g %g\n",
					i+1,j+1,general[i][j].code,general[i][j].wert1,general[i][j].wert2,general[i][j].wert3,general[i][j].wert4);
			}
		}
		for(i=0;i<np->knot;i++)
		{
			kapazitaet[i] = -1;
		}
		sim_dauer = 0;
		deadlock = 0;
		block_arrival = 0;
	}
	if(dbg) fprintf(stderr,"get-sim done\n");
	return(0);
}

dateiende(string)
char *string;
{
	fprintf(stderr,"unerwartetes Dateiende [ %s ]\n",string);
	exit(1);
}

