/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tput_sum.c\t1.3\t92/08/24 13:01:33";

#include <stdio.h>
#include "d_speicher.h"
#include "d_netz.h"
#define EXTERN_KNOTENTYPEN
#include "d_konst.h"

extern int dbg;
extern netzstruktur netz;

put_sum(fp)
FILE *fp;
{
	register netzstruktur *np = &netz;
	int i,j,k,l;
	double **A;
	double *b,*x;

	if(dbg)
		fprintf(stderr,"put_sum\n");
	
	if(np->haeuf) 	/* Uebergangswahrscheinlichkeiten werden umgerechnet */
	{
		if((A = d_2dim_alloc(np->knot,np->knot)) == (double **) 0) mall_err("put_sum(1)");
		if((b = d_1dim_alloc(np->knot)) == (double *) 0) mall_err("put_sum(2)");
		if((x = d_1dim_alloc(np->knot)) == (double *) 0) mall_err("put_sum(3)");
		{
			for(i=0;i<np->klass;i++)
			{
				for(j=1;j<=np->knot;j++) /* rechte Seite  und Matrix aufbauen */
				{
					b[j-1] = -np->uew[0][j][i];
					for(k=1;k<=np->knot;k++) /* rechte Seite  und Matrix aufbauen */
					{
						A[j-1][k-1] = np->uew[k][j][i];
					}
					A[j-1][j-1] -= 1.0;
				}
				if(gauss(A,x,b,np->knot,1e-20) < 0)
				{
					fprintf(stderr,"Klasse %d: Matrix singulaer\n",i+1);
					exit(1);
				}
				for(j=0;j<np->knot;j++)
				{	
					np->besh[j][i] = x[j];
				}
			}
		}
		np->haeuf = 0;
	}
	fprintf(fp,"%d\n",np->knot); /* Knoten */
	for(i=0;i<np->klass;i++)	/* Auftraege */
		fprintf(fp,"%d  ",np->auftr[i]);
	fprintf(fp,"\n");
	for(i=0;i<np->knot;i++)	/* e m typ mu */
	{
		fprintf(fp," %g ",
			np->besh[i][0]);
		switch(np->knotentyp[i])
		{
			case TYP2:
				fprintf(fp,"%d  ",np->bede[i]);
				fprintf(fp,"1  ");
				fprintf(fp,"%g  ",np->bedr[i][0]);
				break;
			case TYP1:
			case TYP3:
				fprintf(fp,"%d  ",np->bede[i]);
				fprintf(fp,"2  ");
				fprintf(fp,"%g  ",np->bedr[i][0]);
				break;
			case TYP4:
				fprintf(fp,"%d  ",np->auftr[0]);
				fprintf(fp,"3  ");
				fprintf(fp,"%g  ",np->bedr[i][0]);
				break;
			case TYP9:
				fprintf(fp,"%d  ",np->bede[i]);
				fprintf(fp,"4  ");
				fprintf(fp,"%g  ",np->bedr[i][0]);
				break;
			case TYP5:
			case TYP7:
				fprintf(fp,"%d  ",np->bede[i]);
				fprintf(fp,"5  ");
				fprintf(fp,"%g  ",np->bedr[i][0]);
				break;
			case TYP6:
			case TYP8:
				fprintf(fp,"%d  ",np->bede[i]);
				fprintf(fp,"6  ");
				fprintf(fp,"%g  ",np->bedr[i][0]);
				break;
			default:
				fprintf(fp,"%d  ",np->bede[i]);
				fprintf(fp,"-1  ");
				fprintf(fp,"%g  ",np->bedr[i][0]);
				break;
		}
		fprintf(fp,"\n");
	}
	fprintf(fp,"\n");
		
}
