static char *SccsId = "@(#)PEPSY:\tresults.c\t1.1\t92/03/27 12:10:15";
#include <malloc.h>
#include "results.h"


#define USAGE()		fprintf(stderr,"Usage: %s [-dnum] datei\n",progname)

int 	dbg = 0;       	/* debug - niveau			*/
char *progname;
FILE *fp, *fopen();
struct header header;
struct result results;
char   buffer[BUFLEN];

main(argc,argv)
int argc;
char *argv[];
{
	char   *e_datei;
	register int i,j,k,c;

	extern int optind;
	extern char *optarg;


	/*		Sccs support from SccsLogging.c			*/	
	extern int SccsRelease;
	extern int SccsLevel;


	progname = argv[0];

	while(( c= getopt(argc,argv,"Vd:")) != EOF)
	{
		switch(c)
		{
			case 'V':
				fprintf(stdout, "%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
				exit(0);
				break;
			case 'd':
				if((dbg = atoi(optarg)) <= 0)
					dbg = 1;
				break;
			default:
				fprintf(stderr,"\nUnbekannte Option -%c !!!\n", c);
				USAGE();
				break;
		}
	}

	if(argc-optind != 1)
	{
		USAGE();
		exit(1);
	}

	e_datei = argv[argc-1];

	if(dbg)
		fprintf(stderr,"%s: e_datei %s\n",progname,e_datei);
	
	if((fp = fopen(e_datei,"r")) == NULL)
	{
		perror(progname);
		exit(1);
	}

	get_header(&header);

	alloc_results(&header,&results);

	get_results(&results,&header);

	put_results(&results,&header);
}

get_header(hp)
struct header *hp;
{
	int i = 0, now = 0;
    int flg=0;

	if(dbg)
		fprintf(stderr,"%s: get_header\n",progname);
	nextline(fp,buffer,BUFLEN); /* LEISTUNGSGROESSEn ... */
	nextline(fp,buffer,BUFLEN); /* Die Netzbeschreibung ... */
	nextline(fp,buffer,BUFLEN); /* das Netz wurde ... */

	sscanf(buffer,"%*s %*s %*s %*s %*s %*s %*s %s",hp->name);

	while(nextline(fp,buffer,BUFLEN) != EOF)
	{
        if (strncmp(buffer,"Gesamt",6) == 0)
 	       flg=1;
        if (strncmp(buffer,"charak",6) == 0)
           flg=2;
        if (!flg)
        { 
     		if(strncmp(buffer,"Auftragsklasse",14) == 0)
			{
				hp->klassen++;
			}
			if(hp->klassen == 1)
				i++;
        }
		if(dbg > 5)
			fprintf(stderr,"Klassen %d, Knoten %d\n",hp->klassen,i);
	}
	if(hp->klassen == 1 && flg==1)
		hp->knoten = i - 7;
	else
		hp->knoten = i - 3;

	if(dbg)
		fprintf(stderr,"name %s\nKnoten %d, Klassen %d\n",
			hp->name, hp->knoten,hp->klassen);

	rewind(fp);

}

alloc_results(hp,rp)
struct header *hp;
struct result *rp;
{
	register i,j;
	extern double **d_2dim_alloc();
	if(dbg)
		fprintf(stderr,"%s: alloc_results\n",progname);
	rp->r_lambda = d_2dim_alloc(hp->knoten,hp->klassen);
	rp->r_e      = d_2dim_alloc(hp->knoten,hp->klassen);
	rp->r_s      = d_2dim_alloc(hp->knoten,hp->klassen);
	rp->r_rho    = d_2dim_alloc(hp->knoten,hp->klassen);
	rp->r_mvz    = d_2dim_alloc(hp->knoten,hp->klassen);
	rp->r_maa    = d_2dim_alloc(hp->knoten,hp->klassen);
	rp->r_mwz    = d_2dim_alloc(hp->knoten,hp->klassen);
	rp->r_mwsl   = d_2dim_alloc(hp->knoten,hp->klassen);
	if(rp->r_lambda == (double **) 0 ||
	   rp->r_e      == (double **) 0 ||
	   rp->r_s      == (double **) 0 ||
	   rp->r_rho    == (double **) 0 ||
	   rp->r_mvz    == (double **) 0 ||
	   rp->r_maa    == (double **) 0 ||
	   rp->r_mwz    == (double **) 0 ||
	   rp->r_mwsl   == (double **) 0 )
	{
		fprintf(stderr,"Fehler bei Speicherplatzanforderung\n");
		exit(1);
	}
}

get_results(rp,hp)
struct result *rp;
struct header *hp;
{
	register i,j;
	double f1,f2,f3,f4,f5,f6,f7,f8;
	int k=0;
	if(dbg)
		fprintf(stderr,"%s: get_results\n",progname);
	nextline(fp,buffer,BUFLEN); /* LEISTUNGSGROESSEn ... */
	nextline(fp,buffer,BUFLEN); /* Die Netzbeschreibung ... */
	nextline(fp,buffer,BUFLEN); /* das Netz wurde ... */
	
	for(i=0;i<hp->klassen;i++)
	{
		nextline(fp,buffer,BUFLEN); /* Auftragsklasse ... */
		nextline(fp,buffer,BUFLEN); /* verfahren | lambda ... */
		nextline(fp,buffer,BUFLEN); /* ------ */
		for(j=0;j<hp->knoten;j++)
		{
			nextline(fp,buffer,BUFLEN); /* knoten xx | fff.ff ... */
			k = 0;
			while(buffer[k] != '|') 
				k++;
			sscanf(&buffer[k],"%*c %lf %lf %lf %lf %lf %lf %lf %lf",
				&rp->r_lambda[j][i],&rp->r_e[j][i],&rp->r_s[j][i],
				&rp->r_rho[j][i],&rp->r_mvz[j][i],&rp->r_maa[j][i],
				&rp->r_mwz[j][i],&rp->r_mwsl[j][i]);

		}
	}
}

put_results(rp,hp)
struct result *rp;
struct header *hp;
{
	register i,j;
	if(dbg)
		fprintf(stderr,"%s: put_results\n",progname);
	fprintf(stdout,"%s\n%d %d %d\n",hp->name,1,hp->knoten,hp->klassen);
	for(i=0;i<hp->klassen;i++)
	{
		for(j=0;j<hp->knoten;j++)
		{
			fprintf(stdout,"%lf %lf %lf %lf %lf %lf %lf %lf\n",
					rp->r_lambda[j][i],rp->r_e[j][i],rp->r_s[j][i],
					rp->r_rho[j][i],rp->r_mvz[j][i],rp->r_maa[j][i],
					rp->r_mwz[j][i],rp->r_mwsl[j][i]);
		}
		fprintf(stdout,"\n");
	}
}


