/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tmodel2.c\t1.4\t96/01/15 16:44:16";

#include <stdio.h>
#include <d_pepsy.h>
#include <d_netz.h>
#define EXTERN_KNOTENTYPEN
#include <d_konst.h>

#include "transform.h"

extern netzstruktur netz;
extern int dbg;

int model2()		/* Wandelt den Besuchshaefigkeitenvektor in ein paralleles UEW'en Feld um */
{
	int i, j, k, l;
	float tmpmin, summe, besh;

	if (dbg)	fprintf(stderr,"model2\n");

	for(i=0; i<netz.klass; i++) {

		tmpmin = 1.0;									/* Vorbesetzung besh von Knoten0 */
		for(j=0; j<netz.knot; j++) {				/* minimale besh suchen, und besh'enSumme berechnen */	
			if (netz.besh[j][i]>tmpmin)
				tmpmin=netz.besh[j][i]
			;
			summe += netz.besh[j][i];
		}

		if (tmpmin<1.0) {								/* besh normieren, alle besh>=1 */
			for(j=0; j<netz.knot; j++)
				netz.besh[j][i] /= tmpmin
			;
			summe /= tmpmin;
		}

		if (dbg>4) {
			fprintf(stderr,"Besuchshaeufigkeiten nach evtl. Korrektur:\n");
			for (j=0; j<netz.knot; j++) {
				fprintf(stderr," %6.6g",netz.besh[j][i]);
			}
			fprintf(stderr,"\n");
			fprintf(stderr,"Summe der Besh nach evtl. Korrektur: %g\n",summe);
		}

		for(j=1; j<=netz.knot; j++) {				/* Eigentliche Transformation durchfuehren */
			besh = netz.besh[j-1][i];				/* (j-1) !! weil Knoten1 hat besh[0] */		
			if (besh!=0.0) {
				if (dbg>3)
					fprintf(stderr,"Transformation von Knoten%d der Klasse %d:\n",j,i);
				netz.uew[0][j][i] = besh/summe;	
				netz.uew[j][0][i] = 1.0;
				/*
				netz.uew[j][0][i] = 1.0-(summe-1)/(summe*summe);
				for(k=1; k<=netz.knot; k++) {
					netz.uew[j][k][i] = netz.besh[k-1][i]/summe * ((summe-1.0)/summe);
				}
				*/
				if (dbg>6) {
					for (k=0; k<=netz.knot; k++) {
						fprintf(stderr,"Knoten %d :",k);
						for (l=0; l<=netz.knot; l++) {
							fprintf(stderr," %g",netz.uew[k][l][i]);
						}
						fprintf(stderr,"\n");
					}
				}
			}
		}
	}

	netz.haeuf = 1;	/* jetzt sind uew gueltig! */

	if (dbg)	fprintf(stderr,"model2 done\n");

	return(OK);
}
