/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tmodel4.c\t1.3\t92/08/24 14:13:54";

#include <stdio.h>
#include <d_pepsy.h>
#include <d_netz.h>
#define EXTERN_KNOTENTYPEN
#include <d_konst.h>

#include "transform.h"

extern netzstruktur netz;
extern int dbg;

int model4()		/* Generiert ein Central-Server Netzwerk mit Terminals */
{
	int cpu;
	int cpu_old = -1;
	int e_cpu;
	int e_sum;
	int i,j,k;
	int term;

	/* cpu muss in allen Klassen die hoechste Besuchshaeufigkeit haben */
	/* es wird angenommen, dass die Terminals der Knoten 1 sind */
	/* es wird angenommen, dass die cpu der Knoten 2 ist */

	for(k=0;k<netz.klass;k++)
	{
		term = 0;
		cpu = 1;
		e_sum = 0.0;
		e_cpu = netz.besh[cpu][k];
		for(i=2;i<netz.knot;i++)
		{
			if(i == cpu)
				continue;
			e_sum += netz.besh[i][k];
		}
		if(e_cpu != e_sum + 1.0)
		{
			fprintf(stderr,"Klasse %d: Die Summe der Besuchshaeufigkeiten der peripheren Geraete (%d+1)\n",k+1,
			    e_sum);
			fprintf(stderr,"muss %d ergeben\n",e_cpu);
			exit(1);
		}
		if(e_cpu < 1 )
		{
			fprintf(stderr,"Die Besuchshaeufigkeit der CPU (Knoten %d) muss mindestens 1 sein\n",cpu);
			exit(1);
		}
		if(netz.offen[k] == 0 && netz.besh[term][k] != 1.0)
		{
			fprintf(stderr,"Die Besuchshaeufigkeit der Terminals (Knoten %d) muss genau 1 sein\n",term);
			exit(1);
		}



		cpu++;
		term++;

		if(dbg) fprintf(stderr,"cpu = %d\n",cpu);

		/* generiere Uebergangswahrscheinlichkeiten */


		if(netz.offen[k] == 0 && netz.besh[term-1][k] > 0.0)
		{
			/* von aussen zur CPU */

			netz.uew[term][0][k] = 1.0;
			netz.uew[0][cpu][k] = 1.0;

			/* von der CPU weg */

			netz.uew[cpu][term][k] = 1.0 / netz.besh[cpu-1][k];

			for(i=2;i<=netz.knot;i++)
			{
				if(i == cpu)
					continue;
				if(netz.besh[i-1][k] == 0.0)
					continue;
				netz.uew[cpu][i][k] = netz.besh[i-1][k] / netz.besh[cpu-1][k] ;
			}

			/* von allen anderen Knoten zur CPU */

			for(i=2;i<=netz.knot;i++)
			{
				if(i == cpu)
					continue;
				if(netz.besh[i-1][k] == 0.0)
					continue;
				netz.uew[i][cpu][k] = 1.0;
			}
		}
		else
		{
			/* von aussen zur CPU */

			netz.uew[0][cpu][k] = 1.0;

			/* von der CPU weg */

			netz.uew[cpu][0][k] = 1.0 / netz.besh[cpu-1][k];

			for(i=2;i<=netz.knot;i++)
			{
				if(i == cpu)
					continue;
				if(netz.besh[i-1][k] == 0.0)
					continue;
				netz.uew[cpu][i][k] = netz.besh[i-1][k] / netz.besh[cpu-1][k] ;
			}

			/* von allen anderen Knoten zur CPU */

			for(i=2;i<=netz.knot;i++)
			{
				if(i == cpu)
					continue;
				if(netz.besh[i-1][k] == 0.0)
					continue;
				netz.uew[i][cpu][k] = 1.0;
			}
		}
	}
	return(0);
}
