/* analyse.c

   UPDATE   1.7.1991

   Netzanalyse mit der Summationsmethode (Einklassenfall !).

*/

static char *SccsId = "@(#)PEPSY:\tanalyse.c\t1.3\t92/12/08 09:43:50";

#include "summa.h"

extern unsigned int   opt;
extern int    *auftrag,
auftraege,
kn,
kl,
*typ,
*m;

extern FILE   *fd;
extern double **mue,
**amue,                                    /*24.6*/
**e;

extern unsigned int   topt();
extern double fabs(),
sum_k(),
k(),
rho_kn_kl();

int    it;          /* Iterationszaehler */
double *lambda=0,   /* Durchsatz */
*clambda=0,  /* Kopie Durchsatz */
ctest;       /* Wert von test() */

/* test()

   Austesten der neuen Naeherungswerte Lambda[].

*/

double test()
{
	int i,j;
	double h=.0,d,d1;

	for(i=0;i<kl;i++) h+=fabs(auftrag[i]-sum_k(i));
	if (opt&topt("p"))
		fprintf(stderr,"test(%d) : %g\n",it,h);
	if (opt&topt("d"))
	{
		fprintf(fd,"test(%d) : %g\n",it,h);
		for(i=0;i<kl;i++)
		{
			fprintf(fd,"\tk(x,%d) :",i);
			d=.0;
			for(j=0;j<kn;j++)
			{
				d1=k(j,i);
				fprintf(fd," %g",d1);
				d+=d1;
			}
			fprintf(fd," (%g)\n",d);
		}
	}
	return h;
}

/* Analyse()

   Netzanalyse ausfuehren.

*/

void Analyse()
{
	int w,j;
	double lu,lo,h0,h1;

	it=0;
	ctest=auftraege+EPS;
	lambda[0]=clambda[0]=null;
	lu=.0;
	lo=MAXFLOAT;
	for(j=0;j<kn;j++)
		if (e[j][0])
			if (typ[j]==4) lo=min(lo,mue[j][0]*auftrag[0]/e[j][0]);
			else
                            if (typ[j]==20 || typ[j]==21)                      /*1.7*/
                                lo=min(lo,mue[j][0]/e[j][0]);
                            else
                                lo=min(lo,mue[j][0]*m[j]/e[j][0]);             /*bis hier 24.6*/
	lambda[0]=.5*(lu+lo);
	while((h0=test())>EPS)
	{
		if (h0<ctest)
		{
			ctest=h0;
			clambda[0]=lambda[0];
		}
		if (it>=MAXIT)
		{
			fprintf(stderr,"** MAXIT erreicht ! **\n");
			if (h0>ctest)
				lambda[0]=clambda[0];
			break;
		}
		it++;
		if (sum_k(0)>auftrag[0]) lo=lambda[0];
		else lu=lambda[0];
		lambda[0]=.5*(lu+lo);
		if (opt&topt("d"))
		{
			fprintf(fd,"\tlambda() :");
			fprintf(fd," %g",lambda[0]);
			fprintf(fd,"\n");
			for(w=0;w<kn;w++)
			{
				fprintf(fd,"\trho(%d,x) :",w);
				h0=.0;
				for(j=0;j<kl;j++)
				{
					h1=rho_kn_kl(w,j);
					fprintf(fd," %g",h1);
					h0+=h1;
				}
				fprintf(fd,"\n");
			}
		}
	}
}
