static char *SccsId = "@(#)PEPSY:\tauftraege.c\t1.3\t92/12/08 09:43:51";
/* auftraege.c


   UPDATE  23.10.1991

   Formeln zur Berechnung der Auftragszahlen der jeweiligen Knoten.

*/

#include "summa.h"

extern unsigned int   opt;
extern int    *typ,
*m,
*auftrag,
auftraege,
kn,
kl;
extern double *lambda,
**e,
**mue,
**c;

extern unsigned int   topt();
extern double pow(),
fak(),
kor_fak(),
dyn_fak(),
p_wart(),
add1(),
add2(),
add3(),
rho_kn(),
rho_kn_kl(),
sig();

double sum_k(),
k();

/* sum_k(r)

   Summiert die mittleren Auftragszahlen der Klasse (r) ueber
   alle Knoten.

*/

double sum_k(r)
int r;
{
	int i;
	double h=.0;

	for(i=0;i<kn;i++)
		h+=k(i,r);      /* dyn_fak() geht bei k() ein */
	return h;
}

/* k(i,r)

   Mittlere Zahl der Auftraege Knoten (i), Klasse (r).

*/

double k(i,r)
int i,r;
{
	int t=typ[i],g;
	double h=.0,f,h1,h2,h3,h4,h5,h6,h7,h8,z1;

	if (!e[i][r]) return .0;
	if (t==4)
		h=lambda[r]*e[i][r]/mue[i][r];
	else
		if (t==1 || t==3 || t==9)
		{
			if (t!=1 || t==1 && !(opt&topt("mk")))
				h=rho_kn_kl(i,r)/(1.0-kor_fak(i,r)*rho_kn(i));
			else
				if (opt&topt("k"))
				{
					h1=rho_kn(i);
					z1=pow(h1,(double)(auftraege));
					h=h1*(1.0-(auftraege+1.0)*z1+auftraege*z1*h1);
					h/=(1.0-h1)*(1.0-z1*h1);
				}
				else
				{
					h1=.0;
					z1=1.0;
					h2=fak(auftraege);
					h3=rho_kn(i);
					for(g=0;g<=auftraege;g++)
					{
						h1+=z1*h2/fak(auftraege-g);
						z1*=h3;
					}
					h=.0;
					z1=h3;
					for(g=1;g<=auftraege;g++)
					{
						h+=g*z1*h2/fak(auftraege-g)/h1;
						z1*=h3;
					}
				}
		}
		else
			if (t==2 || t==5 || t==6 || t==20 || t==21)                    /*1.7*/  
			{
				if (t==2 || t==20) f=1.0;                              /*26.6*/ 
				else f=(c[i][r]+1.0)/2.0;                      /*VAR*/
				h1=rho_kn_kl(i,r);
				h2=rho_kn(i);
				h=m[i]*h1+(h1/(1.0-kor_fak(i,r)*h2))*f*p_wart(h2,i);
			}
			else
				if (t==11)
				{
					h3=kor_fak(i,r);
					h1=(1.0-h3*sig(i,r))*(1.0-h3*sig(i,r+1));
					h=rho_kn_kl(i,r)+lambda[r]*e[i][r]*add1(i,kl-1)/h1;
				}
				else
					if (t==10)
					{
						h2=kor_fak(i,r);
						h3=sig(i,r+1);
						h1=(1.0-h2*sig(i,r))*(1.0-h2*h3);
						h=(rho_kn_kl(i,r)*(1.0-h3)+lambda[r]*e[i][r]*add1(i,r))/h1;
					}
					else
						if (t==15)
						{
							h3=kor_fak(i,r);
							h1=(1.0-h3*sig(i,r))*(1.0-h3*sig(i,r+1));
							h=rho_kn_kl(i,r)+.5*lambda[r]*e[i][r]*add2(i,kl-1)/h1;
						}
						else
							if (t==14)
							{
								h1=kor_fak(i,r);
								h2=sig(i,r+1);
								h3=(1.0-h1*h2)*(1.0-h1*sig(i,r));
								h=(rho_kn_kl(i,r)*(1.0-h2)+.5*lambda[r]*e[i][r]*add2(i,r))/h3;
							}
							else
								if (t==16 || t==18)
								{
/* code folded from here */
	if (t==16)
	{
		h6=add1(i,r);
		h7=add1(i,r-1);
	}
	else
	{
		h6=.5*add3(i,r);
		h7=.5*add3(i,r-1);
	}
	h3=kor_fak(i,r);
	h1=sig(i,r);
	h2=sig(i,r+1);
	h4=1.0-h3*h1;
	h5=1.0-h3*h2;
	h8=rho_kn_kl(i,r);
	z1=(h4*h6*p_wart(h2,i)-h5*h7*p_wart(h1,i))/m[i];
	h=m[i]*h8+lambda[r]*e[i][r]/h8*z1/h4/h5;
/* unfolding */
								}
								else
/* code folded from here */
	if (t==17 || t==19)
	{
		if (t==17) h4=add1(i,kl-1);
		else h4=.5*add3(i,kl-1);
		h3=kor_fak(i,r);
		h1=(1.0-h3*sig(i,r))*(1.0-h3*sig(i,r+1));
		h2=rho_kn(i);
		h=m[i]*rho_kn_kl(i,r)+lambda[r]*e[i][r]*h4*p_wart(h2,i)/m[i]/h2/h1;
	}
/* unfolding */
	return (dyn_fak(i,r)*h);
}
