static char *SccsId = "@(#)PEPSY:\tausgabe.c\t1.3\t92/12/08 09:43:53";
/* ausgabe.c

   UPDATE  1.7.91

   Ausgabe der Leistungsgroessen gemaess PEPSY-Standard.
*/

#include "summa.h"

extern int    *m,
kn,
kl,
it,
*typ,
VERSION,
auftraege;
extern unsigned int   opt;
extern double *lambda,
**e,
**mue;

extern unsigned int   topt();
extern double k(),
rho_kn(),
rho_kn_kl();

/* fehler_ex(n)

   Programmabbruch mit Fehlercode (n).

*/

void fehler_ex(n)
int n;
{
	fprintf(stdout,"amonosum-Abbruch\n");
	fprintf(stdout,"1 0 0\n");
	exit(n);
}

/* mvz(i,r)

   Berechnung der mittleren Verweilzeit Knoten (i), Klasse (r).

*/

double mvz(i,r)
int i,r;
{
	if (!e[i][r]) return .0;
	if (!m[i]) return (1.0/mue[i][r]);
	return (k(i,r)/lambda[r]/e[i][r]);
}

/* mwz(i,r)

   Berechnung der mittleren Wartezeit Knoten (i), Klasse (r).

*/

double mwz(i,r)
int i,r;
{
	double h;

        if (typ[i]!=20 && typ[i]!=21)                                /*1.7*/
            {          
	     if ((h=mvz(i,r)-1.0/mue[i][r])<.0 || !m[i] || !e[i][r]) return.0;
            }
        else
             if ((h=mvz(i,r)- m[i]/mue[i][r])<.0 || !m[i] || !e[i][r]) return.0;
        return h ;                                                         /*bis hier 24.6*/
}

/* fout(w)

   Ausgabe eines double-Wertes (w) ueber die Standardausgabe.

*/

void fout(w)
double w;
{
	if (opt&topt("v")) fprintf(stdout,"%lf ",w);
	else fprintf(stdout,"%.3lf ",w);
}

/* fout_nl(w)

   Ausgabe eines double-Wertes (w) ueber die Standardausgabe.
   Abschluss der Ausgabe mit '\n'.

*/

void fout_nl(w)
double w;
{
	fout(w);
	fprintf(stdout,"\n");
}

/* ausgabe()

   Ausgabe der Leistungsgroessen.

*/

void ausgabe()
{
	int i,r,DUMMY;
	double h;

	fprintf(stdout,"amonosum\n");
	fprintf(stdout,"1 %d %d\n",kn,kl);
	for(r=0;r<kl;r++)
		for(i=0;i<kn;i++)
		{
			fout(lambda[r]*e[i][r]);
			fout(e[i][r]);
                        if (typ[i]==20 ||typ[i]==21)            /*1.7*/
                           fout (m[i]/mue[i][r]);               /*1.7*/
                        else
	   	  	   fout(1.0/mue[i][r]);                 /*bis hier 25.6*/
			fout(rho_kn_kl(i,r));
			fout(mvz(i,r));
			fout(k(i,r));
			fout((h=mwz(i,r)));
			fout_nl(h*lambda[r]*e[i][r]);
		}
	for(i=0;i<kn;i++)
		if (rho_kn(i)>1.0)
		{
			fprintf(stderr,"** System instabil **\n");
			break;
		}
	fprintf(stdout,"Anzahl Iterationen: %d\n",it);
}
