static char *SccsId = "@(#)PEPSY:\teingabe.c\t1.3\t92/12/08 09:43:55";
/* eingabe.c

   UPDATE  1.7.91

   Einlesen der Netzdaten.
*/

#include "summa.h"

extern void Blockalloc(),
Blockfree(),
Blockallocamue(),
fehler_ex();

int    *typ=0,      /* Knotentypen */
*m=0,        /* Zahl der Bedieneinheiten */
*auftrag=0,  /* Zahl der Auftraege in den Klassen */
auftraege,   /* Gesamtzahl der Auftraege */
kn,          /* Zahl der Knoten */
kl;          /* Zahl der Klassen */
double **e=0,       /* Besuchshaeufigkeiten */
**mue=0,     /* Bedienraten */
**amue=0,    /* asym. Bedienraten */                   /*20.6*/
**c=0;       /* Variationskoeffizienten */

/* eingabe()

   Einlesen der Netzdaten ueber die Standardeingabe.

*/

void eingabe()
{
	int i,j;

	fscanf(stdin,"%d",&i);
	if (i!=1)
	{
		fprintf(stderr,"Falscher Netztyp !\n");
		fehler_ex(1);
	}
	fscanf(stdin,"%d",&kn);
	fscanf(stdin,"%d",&kl);
	if (kn<1 || kl!=1)
	{
		fprintf(stderr,"Anzahl Knoten/Klassen pruefen !\n");
		if (kl>1) fprintf(stderr,"Programm 'multisum' verwenden !\n");
		fehler_ex(2);
	}
	auftraege=0;
	Blockalloc();
	for(i=0;i<kl;i++)
	{
		fscanf(stdin,"%d",&auftrag[i]);
		if (auftrag[i]<1)
		{
			fprintf(stderr,"Anzahl Auftraege Klasse %d pruefen !\n",i);
			Blockfree();
			fehler_ex(3);
		}
		auftraege+=auftrag[i];
	}
	for(i=0;i<kn;i++)
	{
		fscanf(stdin,"%d",&m[i]);
		if (m[i]<0)
		{
			fprintf(stderr,"Zahl der Bedieneinheiten Knoten %d pruefen !\n",i);
			Blockfree();
			fehler_ex(16);
		}
	}
        Blockallocamue();                  /*Eingabe versch. Bedienraten an einem Knoten  26.6. */              
	for(i=0;i<kn;i++)
		for(j=0;j<kl;j++)
		{
			fscanf(stdin,"%lf",&mue[i][j]);
			if (mue[i][j]<=.0)
			{
				fprintf(stderr,"Bedienrate Knoten %d Klasse %d pruefen !\n",i,j);
				Blockfree();
				fehler_ex(4);
			}
		}
	fscanf(stdin,"%d",&i);
	if (i)
	{
		fprintf(stderr,"keine Besuchshaeufigkeiten !\n");
		Blockfree();
		fehler_ex(5);
	}
	for(i=0;i<kn;i++)
		for(j=0;j<kl;j++)
		{
			fscanf(stdin,"%lf",&e[i][j]);
			if (e[i][j]<.0)
			{
				fprintf(stderr,"Besuchshaeufigkeit Knoten %d Klasse %d pruefen !\n",j,i);
				Blockfree();
				fehler_ex(6);
			}
		}
	for(i=0;i<kl;i++)
	{
		for(j=0;j<kn;j++)
			if (e[j][i]>.0) break;
		if (j==kn)
		{
			fprintf(stderr,"Besuchshaeufigkeiten Klasse %d pruefen !\n",i);
			Blockfree();
			fehler_ex(7);
		}
	}
	for(i=0;i<kn;i++)
	{
		fscanf(stdin,"%d",&typ[i]);
/*24.6*/
/*1.7*/		if (typ[i]<1 || typ[i]>21 || typ[i]==12 || typ[i]==13 || typ[i]>0 && (!m[i] && typ[i]!=4 || m[i] && typ[i]==4))
		{
			fprintf(stderr,"Typ Knoten %d pruefen !\n",i);
			Blockfree();
			fehler_ex(9);
		}
/*24.6*/
/*1.7*/		if (!(typ[i]==2 || typ[i]==6 || typ[i]==8 || typ[i]>15 && typ[i]<22) && m[i]>1)
		{
			fprintf(stderr,"Knoten %d ist unzulaessiger Multiple-Server !\n",i);
			Blockfree();
			fehler_ex(10);
		}
	}
	for(i=0;i<kn;i++)
	{
		for(j=0;j<kl;j++)
		{
			fscanf(stdin,"%lf",&c[i][j]);
			if (c[i][j]<.0 || c[i][j]!=1.0 && (0<typ[i] && typ[i]<5 || typ[i]>8 && typ[i]<14 || typ[i]==16 ||
			    typ[i]==17))
			{
				fprintf(stderr,"Variationskoeffizient Knoten %d Klasse %d pruefen !\n",i,j);
				Blockfree();
				fehler_ex(12);
			}
		}
		if (typ[i]==7 || typ[i]==8) typ[i]-=2; /* G/G/m-FCFS -> M/G/m-FCFS */
	}
	if (kl>1)
		for(i=0;i<kn;i++)
			if (typ[i]==1 || typ[i]==2)
				for(j=1;j<kl;j++)
					if (mue[i][0]!=mue[i][j])
					{
						fprintf(stderr,"** Achtung : Bedienraten verschieden an M/M/m-FCFS-Knoten ! **\n");
						break;
					}
      	for(i=0;i<kn;i++)                                               
	{
		j=typ[i];
		if (((j==11 || j==15) && auftraege==1) || ((j==2 || j==5 || j==6 || j>15 && j<20) && auftraege<=m[i]))
			fprintf(stderr,"** Korrekturfaktor-Warnung Knoten %d ! **\n",i);
	}                                                                       

          

/*Eingabe der Bedienraten fuer asym Knoten*/

        for(i=0;i<kn;i++)                                               /*20.6*/
        {
   /* 1.7*/     if (typ[i]==20 || typ[i]==21)                           /*1.7*/
                {
                  mue[i][0]=0;                                          /*25.6*/
/*                  fprintf(stdout,"Knoten %d :  \n",i);   */
                  for(j=0;j<m[i];j++)
                  {
                        fscanf(stdin,"%lf",&amue[i][j]);
/*                        fprintf(stdout,"         Bedienrate BE %d ",j); */
/*                        fprintf(stdout,"ist %1.1f  \n",amue[i][j]);    */
                        mue[i][0]+=amue[i][j];                          /*25.6*/
                  }
                }  
        }                                                               /*20.6*/
}
