static char *SccsId = "@(#)PEPSY:\tmemory.c\t1.4\t94/04/26 13:52:12";
/* memory.c

UPDATE 26.6.91

   Alle notwendigen Funktionen fuer die dynamische Speicherplatz-
   verwaltung.
*/

#include "summa.h"

extern FILE   *fd;
extern int    *typ,
*m,
*auftrag,
kn,
kl;
extern double *lambda,
*clambda,
**e,
**mue,
**c,                                    /*20.6*/ 
**amue;                                 /*20.6*/

extern void fehler_ex();
extern char *malloc();
extern int  free();

unsigned long MEM=0;  /* Memory-Counter */

/* block(n)

   liefert Zeiger auf Speicherblock der Groesse (n) * sizeof(char);
   gibt Fehlermeldung aus,wenn nicht genuegend Speicher vorhanden ist.
   (Programm wird dann abgebrochen !)

*/

char *block(n)
unsigned long n;
{
	void Blockfree();
	char *zg=malloc(n);

	if (zg==(char *)0)
	{
		fprintf(stderr,"\n Out of Memory !\n");
		fprintf(stderr," angefordert: %lu Byte(s)\n",n);
		Blockfree();
		fehler_ex(0);
	}
	MEM+=n;
	return zg;
}

/* Blockallocamue()

   Speicherfelder fuer Bedienraten asymmetrischer Bedienstationen

*/

void Blockallocamue()
{
        int g,f;
        
        for(f=0;f<kn;f++)
        {
                g=m[f]*sizeof(double);
                amue[f]=(double *)(block(g));
        }
}

/* Blockalloc()

   Speicherfelder reservieren

*/

void Blockalloc()
{
	int      f,g=kn*sizeof(int);                /*26.6*/ 

	typ=(int *)(block(g));
	m=(int *)(block(g));
	auftrag=(int *)(block(kl*sizeof(int)));
	g=kn*sizeof(double *);
	e=(double **)(block(g));
	mue=(double **)(block(g));
        amue=(double **)(block(g));                  /*20.6*/
	c=(double **)(block(g));
	g=kl*sizeof(double);
	lambda=(double *)(block(g));
	clambda=(double *)(block(g));
	for(f=0;f<kn;e[f]=mue[f]=c[f]        =0,f++); /*26.6*/
	for(f=0;f<kn;f++)
	{
		e[f]=(double *)(block(g));
		mue[f]=(double *)(block(g));
		c[f]=(double *)(block(g));
	}
}

/* Blockfree()

   Rueckgabe aller reservierten Speicherfelder

*/

void Blockfree()
{
	int f;

	/*
	fprintf(stderr,"Speicherbedarf: %lu Byte(s)\n",MEM);
	*/
	if (lambda) free(lambda);
	if (clambda) free(clambda);
	if (m) free(m);
	if (auftrag) free(auftrag);
	if (typ) free(typ);
	if (e)
	{
		for(f=0;f<kn;f++)
			if (e[f]) free(e[f]);
		free(e);
	}
	if (mue)
	{
		for(f=0;f<kn;f++)
			if (mue[f]) free(mue[f]);
		free(mue);
	}
	if (amue)                                   /*20.6*/
	{
		for(f=0;f<kn;f++)
			if (amue[f]) free(amue[f]);
		free(amue);
	}                                           /*20.6*/
	if (c)
	{
		for(f=0;f<kn;f++)
			if (c[f]) free(c[f]);
		free(c);
	}
	if (fd) fclose(fd);
}
