static char *SccsId = "@(#)PEPSY:\tappscat.c\t1.3\t92/12/08 09:49:10";
/********************************************************************************/
/*  Diese Datei enthaelt den Scat - Algorithmus, den Core - Algorithmus 	*/
/*  und einen Einzelschritt der Mittelwertanalyse				*/
/********************************************************************************/


#include   <stdio.h>
#include   <math.h> 		 /* Fuer die Funktion fabs() */
#include   "def.h"

static	long	hilf_iter;	 /* Hilfsgroesse fuer die Anzahl der CORE -	*/
				 /* Iterationen					*/

/********************************************************************************/
/*										*/
/*  FUNKTION									*/
/*  si_mva()									*/
/*										*/
/*  Wird aufgerufen in :		gespeichert in :			*/
/*  - core()				appscat.c				*/
/*										*/
/*  Ruft auf :				gespeichert in :			*/
/*  - tq_MM1_FCFS()			algo.c					*/
/*  - tq_MM1_FCFS_app()			algo.c					*/
/*  - tq_MG0_IS()			algo.c					*/
/*  - tq_MMm_FCFS_RW()			algo.c					*/
/*  - tq_MMm_FCFS_Pm_norm()		algo.c					*/
/*  - tq_MMm_FCFS_Pm()			algo.c					*/
/*  - tq_MMm_FCFS_app_Pm()		algo.c					*/
/*  - tq_MGm_PS()			algo.c					*/
/*  - tq_MG1_FCFS_norm()		algo.c					*/
/*  - tq_MG1_FCFS()			algo.c					*/
/*  - tq_MG1_FCFS_app()			algo.c					*/
/*  - tq_MGm_FCFS_norm()		algo.c					*/
/*  - tq_MGm_FCFS()			algo.c					*/
/*  - tq_MGm_FCFS_app()			algo.c					*/
/*  - sp_2_free()			speicher_verw.c				*/
/*  - sp_1_free()			speicher_verw.c				*/
/*										*/
/*  Diese Funktion ist eine Implementierung eines Schrittes der MWA		*/
/*										*/
/********************************************************************************/


si_mva(kq)

double **kq;			/* Feld mit den aktuellen m. Auftragszahlen 	*/

{
   int		r;		/* Laufvariable fuer die Klassen		*/
   int		i;		/* Laufvariable fuer die Knoten			*/
   int		mod;		/* Berechnungsart bei Pm			*/
   double	sum;		/* Hilfsgroesse					*/
   double	hilf_lam;	/* Hilfsgroesse fuer den Durchsatz 		*/
   double	sq_norm;	/* normierte Bedienzeit 			*/
   double	cb_norm_q;	/* normierter, quadrierter Variationskoeffizient*/


/* Fuer jeden Knoten : Berechnung der Antwortzeit */
/*------------------------------------------------*/
   for (i=0 ;i<N ; i++) 
      {
	 
      /* Berechnung der normierten Bedienzeit */
      /*--------------------------------------*/
      for (sq_norm = 0.0, hilf_lam = 0.0, r = 0 ;  r<R ; r++ ) 
         {
   	 sq_norm +=  sq[r][i] * lambda[r]*besh[r][i];
	 hilf_lam  += lambda[r] * besh[r][i];
	 }
      sq_norm /= hilf_lam;

      /* if (dbg) fprintf(stderr,"Normierte Bedienzeit = %f\n",sq_norm); */ 


      /* Berechnung des normierten Variationskoeffizienten */
      /*---------------------------------------------------*/
      for (cb_norm_q = 0.0, r = 0 ;  r<R ; r++ ) 
	 cb_norm_q += ( (1.0 + vc[r][i]) * sq[r][i] * sq[r][i] * lambda[r] * besh[r][i] ) ;
      cb_norm_q = cb_norm_q / ( sq_norm * sq_norm) - 1.0;

      /* if (dbg) fprintf(stderr,"i = %d, Normierter Variationskoeffizient = %f\n",i,cb_norm_q); */

      /* Berechnung der Antwortzeit fuer die verschiedenen Knotentypen */
      /*---------------------------------------------------------------*/
      switch (typ[i]) 
         {

	  case 1: /* M/M/1_FCFS */
	  case 3: /* M/G/1_PS */
	  case 9: /* M/G/1_LCFS_PRE */
		
		if ( app_modus == 1 )
		   tq_MM1_FCFS(i);
		else
		   tq_MM1_FCFS_app(i);

		break;

	  case 4: /* M/G/oo_IS */

		tq_MG0_IS(i);

		break;

	  case 2: /* M/M/m_FCFS */
	  case 12:/* M/G/m_PS(1) */ 
          case 20:/* M/M/m_FCFS_ASYM*/

		/* Falls das Verfahren Pmapp_2 gewaehlt wurde und der Algorithmus */
		/* nicht konvergiert , wird mit Pm_2 weitergerechnet		  */
		/*----------------------------------------------------------------*/
		if ( (R > 1) && (Pm_modus == 3) && (az_modus == 2))
		   {
      		   if ((hilf_iter + CoreIter + rtp_ci) >= 500)
		      Pm_modus = 2;
		   }

		/* Scat mit Randwahrscheinlichkeiten */
		/*-----------------------------------*/
		if (Pm_modus == 1)

		   tq_MMm_FCFS_RW(i,sq_norm);

		/* Scat mit Wartewahrscheinlichkeit Pm */
		/*-------------------------------------*/
                else 

                   {

		   if ( app_modus == 1 )
		      {
		      if (az_modus == 2) 	/* Antwortzeit ist abhaengig von genormter	*/
						/* Bedienzeit und Gesamtauslastung		*/

		         tq_MMm_FCFS_Pm_norm(i,sq_norm);

		      else 			/* az_modus = 1					*/
						/* Antwortzeit ist abhaengig von Auslastung und */
						/* Bedienzeit fuer jede Klasse getrennt		*/

                         tq_MMm_FCFS_Pm(i);
                      }
		   
		   else				/* app_modus = 2				*/
						/* Die Antworzeit wird mithilfe einer Naeher-	*/
						/* ungsformel berechnet				*/
                      tq_MMm_FCFS_app_Pm(i);
		      

 		   }

		break;

	  case 13:/* M/G/m_PS(2) */

		tq_MGm_PS(i);

		break;

	  case 5: /* M/G/1_FCFS */

		/* Antwortzeit mit Hilfe der Gesamtauslastung	*/
		/* und der genormten Bedienzeit			*/
		/*----------------------------------------------*/
		if ( app_modus == 1 )
		   {
		   if (mg1_modus == 2) 

                      tq_MG1_FCFS_norm(i,cb_norm_q,sq_norm);

		/* Antwortzeit mit Hilfe der Auslastung und 	*/
		/* Bedienzeit fuer jede Klasse getrennt		*/
		/*----------------------------------------------*/
		   else 		

		      tq_MG1_FCFS(i);
	           }

		else				/* app_modus = 2				*/
						/* Die Antworzeit wird mithilfe einer Naeher-	*/
						/* ungsformel berechnet				*/
		   tq_MG1_FCFS_app(i);


		break;

	  case 6: /* M/G/m_FCFS */
          case 21:/*M/G/m_FCFS */

		/* Falls das Verfahren nach Bolch/Akyildiz gewaehlt wurde, werden die M/M/m_FCFS - 		*/
		/* Knoten mithilfe der Randwahrscheinlichkeiten, und der M/G/m_FCFS - Knoten mit der exakten	*/
		/* Wartewahrscheinlichkeit analysiert								*/
		/*----------------------------------------------------------------------------------------------*/
		if (Pm_modus == 1) 	
		   mod = 2;
		else 
		   mod = Pm_modus;

		/* Antwortzeit ist von Gesamtauslastung und genormter Bedienzeit abhaengig */
		/*-------------------------------------------------------------------------*/
		if ( app_modus == 1 )
		   {
		   if ( az_modus == 2)

                      tq_MGm_FCFS_norm(i,cb_norm_q,sq_norm,mod);

		   /* Antwortzeit ist abhaengig von Auslastung und Bedienzeit fuer jede Klasse getrennt */
		   /*-----------------------------------------------------------------------------------*/
    		   else

		      tq_MGm_FCFS(i,mod);
		   }

		else				/* app_modus = 2				*/
						/* Die Antworzeit wird mithilfe einer Naeher-	*/
						/* ungsformel berechnet				*/
		      tq_MGm_FCFS_app(i,mod);

		break;

	  default:

		if (dbg) fprintf(stderr,"Undefinierter Knotentyp %d in Knoten %d\n", typ[i], i+1);

		/* Allokierten Speicher freigeben */
		/*--------------------------------*/
		if (flag == 1)
		   sp_2_free();
		sp_1_free();

		printf("appscat_kn_typ\n 0 0 0\n");
		exit(1);
         }
      }


/* Berechnung des Durchsatzes in jeder Klasse nach Little */
/*--------------------------------------------------------*/
   for ( r=0 ; r<R ; r++ ) 
      {
      for ( sum=0.0 , i=0 ; i<N ; i++ )
         sum +=  besh[r][i] * tq[r][i] ;
      lambda[r] = K[r]/sum;

      /* if (dbg) fprintf(stderr,"Lambda[Klasse %d] = %f\n",r, lambda[r]); */

      }


/* Berechnung der mittleren Auftragszahlen nach Little */
/*-----------------------------------------------------*/
   for (i=0 ; i<N ; i++) 
      {
      for ( r=0 ; r<R ; r++ )
         {
         kq[r][i] = besh[r][i] * tq[r][i] * lambda[r];

	 /* if (dbg) fprintf(stderr,"mittl. Auftragszahlen[Klasse %d][Knoten %d] = %f\n",r,i,kq[r][i]); */

	 }
      }
}



/************************************************************************/
/*									*/
/*  FUNKTION								*/
/*  core()								*/
/*									*/
/*  Wird aufgerufen in :		gespeichert in :		*/
/*  - scat()				appscat.c			*/
/*									*/
/*  Ruft auf :				gespeichert in :		*/
/*  - si_mva()				appscat.c			*/
/*  - fabs()				math.h				*/
/*									*/
/*  Diese Funktion ist eine Implementierung des CORE - Algorithmus	*/
/*									*/
/************************************************************************/

core(kq, r_ind)

   double 	**kq;			/* Feld mit den aktuellen mittleren Auftragszahlen 	*/
   int 		r_ind; 			/* Indikator, in welcher Klasse ein Auftrag fehlt 	*/

{
   int		i;			/* Laufvariable fuer die Knoten				*/
   int		r;			/* Laufvariable fuer die Klassen			*/
   int		s;			/* Laufvariable fuer die Klassen			*/

   double	max,			/* Hilfsgroessen zur Ermittlung des maximalen Unter-	*/
		max_r,			/* schieds bei den mittleren Auftragszahlen nach einer	*/
		diff;			/* si_mva()						*/



/* Auftragszahl in Klasse r_ind erniedrigen. 		   */
/* Falls in keiner Auftragsklasse ein Auftrag fehlen soll, */
/* wird der nicht benutzte Wert K[R] erniedrigt. 	   */
/*---------------------------------------------------------*/
   K[r_ind]--;

   hilf_iter = 0; 			/* Hilfszaehler fuer CoreIterationen 			*/

   do {
      if ((hilf_iter + CoreIter + rtp_ci) >= iteration)
	 break;
   
      hilf_iter++;

      /* Schaetzen der mittleren Auftragszahlen im Zustand (K-1r) */
      /*----------------------------------------------------------*/
      for (r=0 ; r<R ; r++)
         {
	 for (s=0 ; s<R ; s++)
            {
	    for (i=0 ; i<N ; i++) 
               {
	       if ( K[s] == 0.0)
		  kq_schaetz[r][s][i] = 0.0;
	       else
	          kq_schaetz[r][s][i]    = (K[s]- ((r == s) ? 1 : 0)) * ( kq[s][i] / K[s] + D[r][s][i]);
	       kq_alt[r][i] = kq[r][i];
	       }
	    }
         }

      /* Einzelschritt der Mittelwertanalyse */
      /*-------------------------------------*/
      si_mva(kq);

      /* Finden der maximalen Abweichung zur vorhergehenden Verteilung der Auftraege */
      /*-----------------------------------------------------------------------------*/
      for (max_r = 0.0, r=0 ; r<R ; r++ )
         {
	 for (max=0.0, i=0 ; i<N ; i++ )
            {
 	    diff = fabs( kq_alt[r][i] - kq[r][i]);
	    if ( diff > max )    max = diff ;
	    }
	 if ( K[r] == 0.0 )
	    max = 0.0;
	 else
	    max = max / K[r];
	 if (max_r < max) max_r = max;
         }
   
      } while (max_r > eps) ;

   CoreIter += hilf_iter;

/* Auftragszahl in r_ind wieder erhoehen */
/*---------------------------------------*/
   K[r_ind]++;
}





/************************************************************************/
/*									*/
/*  FUNKTION								*/
/*  scat()								*/
/*									*/
/*  Wird aufgerufen in :		gespeichert in :		*/
/*  - main()				main.c				*/
/*									*/
/*  Ruft auf :				gespeichert in :		*/
/*  - weight()				wahrsch.c			*/
/*  - core()				appscat.c			*/
/*									*/
/*  Diese Funktion ist eine Implementierung des SCAT - Algorithmus	*/
/*									*/
/************************************************************************/

scat()
{
   int	r;			/* Laufvariable fuer die Klassen 			*/
   int	s;			/* Laufvariable fuer die Klassen 			*/
   int	i;			/* Laufvariable fuer die Knoten				*/
   int	I;			/* I = 2 : Abbruch des SCAT - Algorithmus		*/

   int	KR;			/* Hilfsgroesse fuer die Gesamtzahl der Auftraege - 1	*/

   double	hilf1, hilf2;	/* Hilfsgroesse zur Berechnung von D			*/



  
/* Hilfsgroesse KR initialisieren */
/*--------------------------------*/
   for (KR = 0, r = 0; r < R; r++)
      KR += (int)K[r];
   KR-- ;

/* Befindet sich ein Knoten im Netz, der mit den Randwahrscheinlichkeiten nach Bo/Ak */
/* analysiert wird, so erfolgt der Aufruf von weight(KR), d.h. die 		     */
/* Wahrscheinlichkeitsmasse wird berechnet.					     */
/* KR wird verwendet, da die mittlere Anzahl der Auftraege im Zustand |K - 1| im     */
/* Knoten i nicht groesser als KR sein kann					     */
/*-----------------------------------------------------------------------------------*/
  if ((Pm_modus == 1)  && (ba_cn_modus == 1))
      weight(KR);

/* Anfangsverteilung: alle Auftraege gleichmaessig verteilt */
/*----------------------------------------------------------*/
   for (r=0 ; r<R ; r++) 
      {
      for (i=0 ; i<N ; i++) 
         {
         kq_K[r][i] = K[r]/(double)N;
         for (s=0 ; s<R ; s++) 
	    {
	    D[r][s][i]=0.0;
	    kq_Kminus1r[r][s][i] = (K[s] - ( (r ==s ) ? 1 : 0) )/(double)N;
	    }
	 }
      }

/* Initialisierungen fuer den Scat - Algorithmus */
/*-----------------------------------------------*/
   I = 1;

/* SCAT - Algorithmus */
/*--------------------*/
   do {

      /* CORE - Algorithmus mit Populaton K */
      /*------------------------------------*/
      core(kq_K,R);

      /* Abbruchbedingung des SCAT - Algorithmus */
      /*-----------------------------------------*/
      if (I==2) break;

      /* CORE - Algorithmus mit Population Kminus1r */
      /*--------------------------------------------*/
      for (r=0 ; r<R ; r++) 
	 core(kq_Kminus1r[r],r);


      /* Berechnung der Korrekturfaktoren D[i,r,j] */
      /*-------------------------------------------*/
      for (r=0 ; r<R ; r++) 
         {
         for (s=0 ; s<R ; s++) 
            {
	    for (i=0 ; i<N ; i++) 
	       {
	       if ( (K[s] - ((s==r) ? 1 : 0 )) == 0.0 )
		  hilf1 = 0.0;
	       else
		  hilf1 = kq_Kminus1r[r][s][i] / ( K[s] - ((s==r) ? 1 : 0));
	       if ( K[s] == 0.0)
		  hilf2 = 0.0;
	       else
	          hilf2 = kq_K[s][i] / K[s] ;
	       D[r][s][i] = hilf1 - hilf2;
	       }
	    }
	 }
      
      I++;

      } while (1);

}

