static char *SccsDef_h = "@(#)PEPSY:\tdef.h\t1.3\t92/06/22 13:43:30";
/********************************************************************************/
/*										*/
/*  Externe Deklarationen							*/
/*										*/
/********************************************************************************/


extern	int 	N;              /* Anzahl der Knoten				*/
extern	int 	R;              /* Anzahl der Klassen 				*/
extern	int	*mm;		/* Zahl der Bedieneinheiten			*/
extern	int	*typ;		/* Knotentypen					*/
extern	double	*K;		/* Anzahl der Auftraege in den Klassen 1..R	*/
extern	double	*lambda;	/* Durchsatz					*/
extern	double	**besh;		/* Besuchshaeufigkeiten				*/
extern	double	**sq;		/* mittl. Bedienzeiten				*/
extern	double	**amue;		/* Bedienraten fuer asymm. multiple server	*/
extern  double  *sumamue;       /* Summe der Bedienraten pro Knoten             */ 
extern	double	**tq;		/* Antwortzeiten				*/
extern	double	**vc;           /* quadrierte Variationskoeffizienten 		*/
extern	double	**kq_K;		/* mittl.Auftragszahlen im Zustand (K)		*/
extern	double	**kq_alt;	/* Hilfsfeld zum Herausfinden der maximalen	*/
				/* Abweichungen nach einem Einzelschritt der	*/
				/* MWA						*/
extern	double	***kq_Kminus1r; /* m. Auftragszahlen im Zustand (K-1r) 		*/
extern	double	***kq_schaetz;  /* Schaetzungen fuer die m. Auftragszahlen im 	*/
				/* Zustand (K-1r) 				*/
extern	double 	***D;         	/* Fehler bei den m. Auftragszahlen beim 	*/
				/* Uebergang vom Zustand (K) in (K-1r) 		*/
				/* Abweichung nach einem Einzelschritt der MWA 	*/

extern	int	*typ_rtp;	/* Hilfsfeld fuer die Knotentypen bei RTP,	*/
				/* typ_rtp[N]					*/
extern	double	*lambda_rtp;	/* Hilfsfeld fuer den Durchsatz bei RTP,	*/
				/* lambda_rtp[R]				*/
extern	double	**sq_alt;	/* Hilfsfeld fuer die mittl. Bedienzeiten 	*/
				/* bei RTP, sq_alt[R][N]			*/

extern	double	**durchsatz;	/* Durchsatz pro Klasse und Knoten, Leistungs- 	*/
				/* groesse, durchsatz[R][N]		       	*/
extern	double	**rho;		/* Auslastung pro Klasse und Knoten, Leistungs-	*/
				/* groesse, rho[R][N]			    	*/
extern	double	**mwz;		/* m. Wartezeit pro Klasse und Knoten, Lei-    	*/
				/* stungsgroesse, mwz[R][N]			*/
extern	double	**mws;		/* m. Warteschlangenlaenge pro Klasse und      	*/
				/* Knoten, Leistungsgroesse, mws[R][N]	       	*/

extern	double	 *P;		/* Randwahrscheinlichkeiten			*/
extern	double	**W;		/* Wahrscheinlichkeitsmasse			*/
extern	double	 *PR;		/* Skalierfunktion zur Berechnung der		*/
				/* Wahrscheinlichkeitsmasse			*/


extern	int 	Pm_modus;	/* Berechnungsart bei Pm			*/
extern	int	app_modus;	/* exakte Formel oder Naeherung fuer die	*/
				/* Antwortzeit					*/
extern	int	az_modus;	/* Berechnungsart der Antwortzeit bei M/M/m_	*/
				/* FCFS und M/G/m_FCFS - Knoten			*/
extern	int	mg1_modus;	/* Berechnungsart der Antwortzeit bei M/G/1_	*/
				/* FCFS - Knoten				*/
extern	int	ba_cn_modus; 	/* Flag fuer Randwahrscheinlichkeiten		*/
extern	int	RTP_modus;	/* Berechnungsart bei der RTP - Methode		*/

extern	double	eps;		/* Schranke fuer den CORE - Algorithmus		*/


extern	int	flag;		/* Flag, das anzeigt, ob in main() sp_2_alloc()	*/
				/* aufgerufen wird 				*/


extern	int	dbg;		/* Debug - Ausgabe bei Aufruf des Programmes	*/
				/* mit -d?					*/

extern	long	CoreIter;	/* CORE - Iterationen				*/
extern	long	rtp_ci;		/* Zaehler fuer die Core - Iterationen bei der  */
				/* RTP - Methode				*/

extern 	long	iteration;	/* maximale Anzahl an Iterationen		*/



/******************************************************************************/
/*                                                                            */
/*   Deklaration von Datenstrukturen                                          */
/*                                                                            */
/******************************************************************************/

struct Zustand                     /* Struktur fuer Zustaende im MARKOV-      */
{                                  /*                             Graph       */
   short belegt[10];               /* lfd. Nummern belegter Bedieneinheiten   */
   int anz;                        /* Anzahl belegter Bedieneinheiten         */
   double value;                   /* Zustandswahrscheinlichkeit              */
   struct Zustand* next;           /* naechster Zustand                       */
};
