static char *SccsId = "@(#)PEPSY:\tergebnis.c\t1.2\t92/03/27 11:40:18";
/************************************************************************************************/
/* In dieser Datei werden die Leistungsgroessen berechnet					*/
/************************************************************************************************/


#include	"def.h"


/************************************************************************************************/
/*  												*/
/*  FUNKTION											*/
/*  leistungsgroessen()										*/			
/*												*/
/*  Wird aufgerufen in :				gespeichert in :			*/
/*  - main()						main.c					*/
/*  - rtp()						rtp.c					*/
/*												*/
/*  Berechnung von :										*/
/*  - Antwortzeiten pro Klasse und Knoten							*/
/*  - Durchsaetze pro Klasse und Knoten								*/
/*  - Auslastungen pro Klasse und Knoten							*/
/*  - m. Wartezeiten pro Klasse und Knoten							*/
/*  - m. Warteschlangenlaenge pro Klasse und Knoten						*/
/*												*/
/************************************************************************************************/

leistungsgroessen()

{

   int	i;				/* Laufvariable fuer die Knoten				*/
   int	r;				/* Laufvariable fuer die Klassen			*/


/* fuer alle Klassen und Knoten */
/*------------------------------*/
   for (r = 0; r < R; r++)
      {
      for (i = 0; i < N; i++)
         {
         
         /* Antwortzeit und mittl. Zahl der Auftraege pro Klasse und Knoten = 0 , falls   */ 
	 /* die besh < 0 ist, ansonsten wurden sie bereits im Scat - Algorithmus berechnet*/
         /*-------------------------------------------------------------------------------*/
         if (besh[r][i] <= 0)
	    {
	    tq[r][i] = 0.0;
	    kq_K[r][i] = 0.0;
	    }

         /* Berechnung des Durchsatzes pro Klasse und Knoten */
         /*--------------------------------------------------*/
         if (besh[r][i] > 0)
            durchsatz[r][i] = besh[r][i] * lambda[r];
         else
	    durchsatz[r][i] = 0.0;

         /* Berechnung der Auslastung pro Klasse und Knoten */
	 /*-------------------------------------------------*/
	 if (mm[i] > 0 && ((1.0 / sq[r][i] ) > 0.0))
            rho[r][i]  = durchsatz[r][i] * sq[r][i] / ((double)mm[i]);
	 else
	    rho[r][i] = 0.0;
	 
	 if (typ[i] == 13)
	    rho[r][i] = rho[r][i] * ((double)mm[i]);
 
	 if (rho[r][i] > 1.0)
	    rho[r][i] = 1.0;

	 /* Berechnung der m. Wartezeit pro Klasse und Knoten */
	 /*---------------------------------------------------*/
	 if (mm[i] > 0 &&  (1.0 / sq[r][i] ) > 0.0 && tq[r][i] >= sq[r][i])
            mwz[r][i] = tq[r][i] - sq[r][i];
    	 else
	    mwz[r][i] = 0.0;

	 if (typ[i] == 13)
	    {
	    if ((1.0 / sq[r][i] ) > 0.0 && tq[r][i] >= (sq[r][i] / ((double)mm[i])))
               mwz[r][i] = tq[r][i] - sq[r][i] / ((double)mm[i]);
	    else
	       mwz[r][i] = 0.0;
	    }

	 /* Berechnung der m. Warteschlangenlaenge pro Klasse und Knoten */
	 /*--------------------------------------------------------------*/
	 mws[r][i] = durchsatz[r][i] * mwz[r][i];

         }
      }
}	/* Ende leistungsgroessen() */
	          
