/********************************************************************************/
/*  Diese Datei enthaelt das Hauptprogramm fuer die Scat - Approxima-  		*/
/*  tionen.									*/
/********************************************************************************/

static char *SccsId = "@(#)PEPSY:\tmain.c\t1.3\t92/06/22 13:43:35";

#include	<stdio.h>
#include    <string.h>


/********************************************************************************/
/*										*/
/*  globale Definitionen							*/
/*										*/
/********************************************************************************/


int 	N;              /* Anzahl der Knoten					*/
int 	R;              /* Anzahl der Klassen 					*/
int	*mm;		/* Zahl der Bedieneinheiten, mm[N]			*/
int	*typ;		/* Knotentypen, typ[N]					*/
double	*K;		/* Anzahl der Auftraege in den Klassen 1..R,		*/
			/* K[R]							*/
double	*lambda;	/* Durchsatz, lambda[R]					*/
double	**besh;		/* Besuchshaeufigkeiten, besh[R][N]			*/
double	**amue;		/* Bedienraten fuer asymm. multiple server		*/
double  *sumamue;       /* Summe der Bedienrate pro Knoten                      */
double	**sq;		/* mittl. Bedienzeiten,sq[R][N]				*/
double	**tq;		/* Antwortzeiten, tq[R][N]				*/
double	**vc;           /* quadrierte Variationskoeffizienten, vc[R][N]		*/
double	**kq_K;		/* mittl.Auftragszahlen im Zustand (K),			*/
			/* kq_K[R][N]						*/
double	**kq_alt;	/* Hilfsfeld zum Herausfinden der maximalen		*/
			/* Abweichungen nach einem Einzelschritt der		*/
			/* MWA, kq_alt[R][N]					*/
double	***kq_Kminus1r; /* m. Auftragszahlen im Zustand (K-1r), 		*/
			/* kq_Kminus1r[R][R][N]					*/
double	***kq_schaetz;  /* Schaetzungen fuer die m. Auftragszahlen im 		*/
			/* Zustand (K-1r), kq_schaetz[R][R][N] 			*/
double 	***D;         	/* Fehler bei den m. Auftragszahlen beim 		*/
			/* Uebergang vom Zustand (K) in (K-1r) 			*/
			/* Abweichung nach einem Einzelschritt der MWA,		*/
			/* D[R][R][N]						*/

int	*typ_rtp;	/* Hilfsfeld fuer die Knotentypen bei RTP,		*/
			/* typ_rtp[N]						*/
double	*lambda_rtp;	/* Hilfsfeld fuer den Durchsatz bei RTP,		*/
			/* lambda_rtp[R]					*/
double	**sq_alt;	/* Hilfsfeld fuer die mittl. Bedienzeiten 		*/
			/* bei RTP, sq_alt[R][N]				*/

double	**durchsatz;	/* Durchsatz pro Klasse und Knoten, Leistungs-  	*/
			/* groesse, durchsatz[R][N]		        	*/
double	**rho;		/* Auslastung pro Klasse und Knoten, Leistungs-		*/
			/* groesse, rho[R][N]			    		*/
double	**mwz;		/* m. Wartezeit pro Klasse und Knoten, Lei-     	*/
			/* stungsgroesse, mwz[R][N]				*/
double	**mws;		/* m. Warteschlangenlaenge pro Klasse und       	*/
			/* Knoten, Leistungsgroesse, mws[R][N]	        	*/

double	*P;		/* Randwahrscheinlichkeiten				*/
double	**W;		/* Wahrscheinlichkeitsmasse				*/
double	*PR;		/* Skalierfunktion zur Berechnung der			*/
			/* Wahrscheinlichkeitsmasse				*/


int 	Pm_modus;	/* Berechnungsart bei Pm				*/
int	app_modus;	/* Fuer die Berechnung der Antwortzeit mit Pm wird eine */
			/* Naeherungsformel verwendet				*/
int	az_modus;	/* Berechnungsart der Antwortzeit bei M/M/m_		*/
			/* FCFS und M/G/m_FCFS - Knoten				*/
int	mg1_modus;	/* Berechnungsart der Antwortzeit bei M/G/1_		*/
			/* FCFS - Knoten					*/
int	ba_cn_modus; 	/* Flag fuer Randwahrscheinlichkeiten			*/
int	RTP_modus;	/* Berechnungsart bei der RTP - Methode			*/


double	eps;		/* Schranke fuer den CORE - Algorithmus			*/


int	flag;		/* Flag, das anzeigt, ob in main() sp_2_alloc()		*/
			/* aufgerufen wird 					*/


int	dbg;		/* Debug - Ausgabe bei Aufruf des Programmes		*/
			/* mit -d?						*/


long	CoreIter;	/* CORE - Iterationen					*/
long	rtp_ci;		/* Zaehler der Core - Iterationen bei der RTP - Methode */

long	iteration = 5000;	/* maximale Anzahl der Iterationen		*/
char		*option;	/* Variable fuer die Funktion getopt()		*/


/********************************************************************************/
/*										*/
/*  FUNKTION									*/
/*  main()  (Hauptprozedur fuer alle Algorithmen)				*/
/*										*/
/*  Ruft auf :				gespeichert in :			*/
/*  - getopt()				stdio.h					*/
/*  - atoi()				stdio.h					*/
/*  - einlesen()			eingabe.c				*/
/*  - scat()				appscat.c				*/
/*  - rtp()				rtp.c					*/
/*  - sp_2_alloc()			speicher_verw.c				*/
/*  - sp_3_alloc()			speicher_verw.c				*/
/*  - leistungsgroessen()		ergebnis.c				*/
/*  - ausgabe()				ausgabe.c				*/
/*  - sp_2_free()			speicher_verw.c				*/
/*  - sp_3_free()			speicher_verw.c				*/
/*  - sp_1_free()			speicher_verw.c				*/
/*										*/
/*  Aufgabe der Hauptprozedur :							*/
/*  - Interpretation der Kommandozeile mit getopt()				*/
/*  - Aufruf von einlesen(),							*/
/*    hier werden die Variablen N, R, K[], typ[], mm[], besh[][],       	*/
/*    sq[][], vc[][] eingelesen							*/
/*  - Berechnung der Schranke fuer den Core - Algorithmus			*/
/*  - Aufruf des gewuenschten Verfahrens					*/
/*  - Berechnung der Leistungsgroessen						*/
/*  - Ausgabe der Leistungsgroessen auf stdout					*/
/*  - Freigeben des allokierten Speichers					*/
/*										*/
/********************************************************************************/

void abbruch(sig)
int sig;
{
        printf("appscat_signal_%d\n 0 0 0 \n", sig);
        exit(1);
}

main(argc,argv)

   int 	argc;
   char	*argv[];

{
   extern	char	*optarg;/* Variable fuer die Funktion getopt()		*/
   extern	int	opterr;	/* Variable fuer die Funktion getopt()		*/

   /*		Sccs support from SccsLogging.c			*/	
   extern int SccsRelease;
   extern int SccsLevel;

   int		reval;		/* Fuer den Return - Wert der Funktion getopt()	*/
   int		r,s;		/* Laufvariablen fuer die Klassen		*/
   int		i;		/* Laufvariable fuer die Knoten		*/
   int            j;     
   double 	hilf;		/* Hilfsgroesse zum Initialisieren des		*/
				/* Durchsatzes					*/
   double	sum;		/* Hilfsgroesse fuer die Berechnung der		*/
				/* Schranke eps fuer den CORE - Algorithmus	*/
   double   dummy;      /* Hilfsgroesse zum Sortieren der Bedienraten   */
				/* bei asymmetrischen MMm-Knoten                */

  /*{
        int i;
        void abbruch();

        for (i=1; i<12; i++)
                signal (i, abbruch);
  }*/


   /* Interpretation der Kommandozeile mit Hilfe der Funktion getopt() */
   /*------------------------------------------------------------------*/
   while (( reval = getopt(argc,argv,"v:i:d:V")) != EOF)
      {
      switch (reval)
         {
	 case 'V':  /* kirschni 06.03.92 */
		 fprintf(stdout, "%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
		 exit(0);
		 break;
	 case 'v':
		 option = optarg;
		 break;
	 case 'i':
		 if (( iteration = atoi(optarg)) <= 0)
                    iteration = 5000;
                 break;
	 case 'd':
		 if (( dbg = atoi(optarg)) < 0)
                    dbg = 0;
                 break;
	 default :
                 option[0] = '0';
                 break;
	 }
      }


   /* Einlesen der Variablen  N, R, K[], typ[], mm[], besh[][], sq[][], vc[][] */
   /*--------------------------------------------------------------------------*/
   einlesen();


   /* Fuer asymmetrische Knoten: sortieren der Bedienraten */
   /* in absteigender Reihenfolge                          */
   /* ---------------------------------------------------- */
      for (i = 0; i < N; i++)
      {
         if ((typ[i] == 20) || (typ[i] == 21))
	   {
	      qsort(amue[i],mm[i],sizeof(double),strcmp);
	      j = mm[i]-1;
	      while (j > ((mm[i]-1)/2))
	      {
	         dummy = amue[i][mm[i]-j-1];
		   amue[i][mm[i]-j-1] = amue[i][j];
		   amue[i][j] = dummy;
		   j--;
		}
	   }
	}


   /* Berechnung der Schranke fuer den CORE - Algorithmus */
   /*-----------------------------------------------------*/
   for (sum = 0.0,r = 0; r < R; r++)  
       sum += K[r];
   eps = 1.0 / (4000.0 + 16.0 * sum);
   /* if (dbg)   fprintf(stderr,"Eps = %f\n",eps); */


   /*--------------------------------------------------------------------------*/
   /* Hier erfolgt der Aufruf des Verfahrens, das ueber die Option gewaehlt wurde */
   /*-----------------------------------------------------------------------------*/


        /* Bei folgenden Parameterwerten, werden die folgenden Verfahren aufgerufen:

	  Pm_modus    = 1 Randwahrscheinlichkeiten nach Bolch/Akyildiz oder Chandy/Neuse
		    	    2 Wartewahrscheinlichkeit Pm exakt
		    	    3 Wartewahrscheinlichkeit Pm naeherungsweise
		    	    4 ohne alle Wahrscheinlichkeiten
			    5 Wartewahrscheinlichkeit Pm nach Baer/Fischer/Hertel, zufaellige
				Auswahl einer Bedieneinheit
			    6 Wartewahrscheinlichkeit Pm nach Baer/Fischer/Hertel, Auswahl der
				schnellsten Bedieneinheit
			    


	  app_modus	  = 1 Die Formel fuer die Antwortzeit wird aus der exakten Formel hergeleitet
	  		    2 fuer die Berechnung der Antwortzeit wird eine Naeherungsformel verwendet :
			      vor der Auslastung wird ein Korrekturfaktor eingefuehrt
	
	  az_modus        = 1 Berechnung der Antwortzeit mit Auslastung und Bedienzeit fuer jede Klasse getrennt
			    2 Berechnung der Antwortzeit mit Hilfe der Gesamtauslastung und der genormten
			      Bedienzeit
	            	    
			    fuer M/M/m_FCFS und M/G/m_FCFS - Knoten
         
	  mg1_modus       = 1 Berechnung der Antwortzeit mit Auslastung und Bedienzeit fuer jede Klasse getrennt
	  		    2 Berechnung der Antwortzeit mit Hilfe der Gesamtauslastung und der genormten
			      Bedienzeit
			    fuer M/G/1_FCFS - Knoten
         
          ba_cn_mod       = 1 Randwahrscheinlichkeiten nach Bolch/Akyildiz
			    2 Randwahrscheinlichkeiten nach Chandy/Neuse

	  RTP_modus	  = 0 die RTP - Methode wird nicht verwendet
			    1 normale RTP - Methode
			    2 approximierte RTP - Methode :
			      Bei der Umwandlung des M/G/1_FCFS - Knotens in einen M/M/1_FCFS - Knoten
			      wird fuer die Berechnung der Antwortzeiten jeweils die approximierte
			      Formel verwendet

	*/

/* Initialisierungen */
/*-------------------*/
   Pm_modus = 1;
   app_modus = 1;
   RTP_modus = 0;
   az_modus = 1;
   mg1_modus = 1;
   ba_cn_modus = 1;
   flag = 0;
   CoreIter = 0;
   rtp_ci = 0;

/* Initialisierung der Durchsaetze */
/*---------------------------------*/
   if (mm[0] != 0)
      {
      hilf = 0.5 * ((double)mm[0]) / (double)R;  
      for (r=0 ; r<R ; r++ ) 
         lambda[r] = hilf /  sq[r][0] ;
      }
   else
      {
      for ( r = 0; r < R; r++)
	 lambda[r] = 0.5;
      }

   switch (option[0])
      {
	case '0':
		ba_cn_modus = 2;
		az_modus = 2;
	 	flag = 1;		/* Flag, das anzeigt, ob sp_free2() aufgerufen 		*/
					/* werden muss						*/
	  	sp_2_alloc();		/* Dynamische Speicherbelegung fuer die Randwahrschein-	*/
					/* lichkeiten P, fuer die Wahrscheinlichkeitsmasse W und*/
					/* fuer die Skalierfunktion PR				*/
					/* hier werden W und PR nicht benoetigt, aber trotzdem	*/
					/* wegen der besseren Uebersicht allokiert		*/
		scat();	
					/* Scat mit Randwahrscheinlichkeiten nach Chandy/Neuse	*/

					/* Knoten vom Typ M/M/m_FCFS u. M/G/m_PS(1) werden mit	*/
					/* diesen Randw'keiten, Knoten vom Typ M/G/m_FCFS 	*/
					/* werden mit der Wartew'keit analysiert.		*/
					/* Die restlichen Knotentypen werden mit Scat analy-	*/
					/* siert, wobei bei dem Knoten M/G/1_FCFS die Antwort-  */
					/* zeit mithilfe der Auslastung und der Bedienzeit fuer */
					/* jede Klasse getrennt, und bei dem Knoten M/G/m_FCFS	*/
					/* mithilfe der Gesamtauslastung und normierter Bedien- */
					/* zeit berechnet wird					*/
		break;
	case '1':
        case 'e':
		az_modus = 2;
	 	flag = 1;		/* Flag, das anzeigt, ob sp_free2() aufgerufen 		*/
					/* werden muss						*/
	  	sp_2_alloc();		/* Dynamische Speicherbelegung fuer die Randwahrschein-	*/
					/* lichkeiten P, fuer die Wahrscheinlichkeitsmasse W und*/
					/* fuer die Skalierfunktion PR				*/
		scat();	
					/* Scat mit Randwahrscheinlichkeiten nach Bolch/Akyldiz	*/

					/* Knoten vom Typ M/M/m_FCFS u. M/G/m_PS(1) werden mit	*/
					/* diesen Randw'keiten, Knoten vom Typ M/G/m_FCFS 	*/
					/* werden mit der Wartew'keit analysiert.		*/
					/* Die restlichen Knotentypen werden mit Scat analy-	*/
					/* siert, wobei bei dem Knoten M/G/1_FCFS die Antwort-  */
					/* zeit mithilfe der Auslastung und der Bedienzeit fuer */
					/* jede Klasse getrennt, und bei dem Knoten M/G/m_FCFS	*/
					/* mithilfe der Gesamtauslastung und normierter Bedien- */
					/* zeit berechnet wird					*/
		break;
	case '2':
        case 'd':
		Pm_modus = 2;
		scat();	
					/* Scat mit Wartewahrscheinlichkeit Pm (exakt fuer	*/
					/* M/M/m_FCFS - Knoten )				*/

					/* Knoten vom Typ M/M/m_FCFS, M/G/m_PS(1) u. M/G/m_FCFS */
					/* werden mit diesen Wartew'keiten analysiert.		*/
					/* Die restlichen Knotentypen werden mit Scat analy-	*/
					/* siert, wobei bei den Knoten M/G/1_FCFS , M/G/m_FCFS  */
					/* M/M/m_FCFS und M/G/m_PS(1) die Antwortzeit mithilfe	*/
					/* der Auslastung und der Bedienzeit fuer jede Klasse	*/
					/* getrennt berechnet wird.				*/
		break;

      case 'f':
		    Pm_modus = 5;
		    scat();	
					/* Scat mit Wartewahrscheinlichkeit Pm (exakt   */
					/* nach Baer/Fischer/Hertel fuer zufaellige     */
					/* Auswahl einer freien Bedieneinheit)          */
					/* Knoten vom Typ M/M/m_FCFS-ASYM werden mit    */
					/* diesen Wartewahrscheinlichkeiten analysiert. */
					/* Die restlichen Knotentypen werden mit Scat   */
					/* analysiert, wobei bei den Knoten M/G/1_FCFS, */
					/* M/G/m_FCFS, M/M/m_FCFS und M/G/m_PS(1) die   */
					/* Antwortzeit mithilfe	der Auslastung und der  */
					/* Bedienzeit fuer jede Klasse getrennt berech- */
					/* net wird.				            */
		    break;

      case 'g':
		    Pm_modus = 6;
		    scat();	
					/* Scat mit Wartewahrscheinlichkeit Pm (exakt   */
					/* nach Baer/Fischer/Hertel fuer Auswahl der    */
					/* schnellsten Bedieneinheit)                   */
					/* Knoten vom Typ M/M/m_FCFS-ASYM werden mit    */
					/* diesen Wartewahrscheinlichkeiten analysiert. */
					/* Die restlichen Knotentypen werden mit Scat   */
					/* analysiert, wobei bei den Knoten M/G/1_FCFS, */
					/* M/G/m_FCFS, M/M/m_FCFS und M/G/m_PS(1) die   */
					/* Antwortzeit mithilfe	der Auslastung und der  */
					/* Bedienzeit fuer jede Klasse getrennt berech- */
					/* net wird.				            */
		    break;

	case '3':
		Pm_modus = 3;
		scat();	
					/* Scat mit Wartewahrscheinlichkeit Pm Naeherung 	*/

					/* Knoten vom Typ M/M/m_FCFS, M/G/m_PS(1) u. M/G/m_FCFS */
					/* werden mit diesen Wartew'keiten analysiert.		*/
					/* Die restlichen Knotentypen werden mit Scat analy-	*/
					/* siert, wobei bei den Knoten M/G/1_FCFS , M/G/m_FCFS  */
					/* M/M/m_FCFS und M/G/m_PS(1) die Antwortzeit mithilfe	*/
					/* der Auslastung und der Bedienzeit fuer jede Klasse	*/
					/* getrennt berechnet wird.				*/
		break;
	case '4':
		Pm_modus = 4;
		scat(); 	
					/* Scat mit Wartewahrscheinlichkeit Pm = 0 		*/

					/* Knoten vom Typ M/M/m_FCFS, M/G/m_PS(1) u. M/G/m_FCFS */
					/* werden mit diesen Wartew'keiten analysiert.		*/
					/* Die restlichen Knotentypen werden mit Scat analy-	*/
					/* siert, wobei bei dem Knoten M/G/1_FCFS 		*/
					/* die Antwortzeit mithilfe der Auslastung und der 	*/
					/* Bedienzeit fuer jede Klasse getrennt berechnet wird.	*/
		break;
	case '5':
		az_modus = 2;
		mg1_modus = 1;
	 	flag = 1;		/* Flag, das anzeigt, ob sp_free2() aufgerufen 		*/
					/* werden muss						*/
	  	sp_2_alloc();		/* Dynamische Speicherbelegung fuer die Randwahrschein-	*/
					/* lichkeiten P, fuer die Wahrscheinlichkeitsmasse W und*/
					/* fuer die Skalierfunktion PR				*/
		scat();	
					/* Scat fuer M/G/1_FCFS - Knoten :			*/
					/* Berechnung der Antwortzeit mithilfe der Auslastung   */
					/* und Bedienzeit fuer jede Klasse getrennt		*/

					/* Knoten vom Typ M/M/m_FCFS u. M/G/m_PS(1) werden mit	*/
					/* den Randw'keiten nach Bolch/Akyildiz, Knoten vom Typ */
					/* M/G/m_FCFS werden mit der Wartew'keit analysiert.	*/
					/* Die restlichen Knotentypen werden mit Scat analy-	*/
					/* siert, wobei bei dem Knoten M/G/1_FCFS die Antwort-  */
					/* zeit mithilfe der Auslastung und der Bedienzeit fuer */
					/* jede Klasse getrennt, und bei dem Knoten M/G/m_FCFS	*/
					/* mithilfe der Gesamtauslastung und normierter Bedien- */
					/* zeit berechnet wird					*/
		break;
	case '6':
		Pm_modus = 2;
		az_modus = 2;
		scat();	
					/* Scat mit Wartewahrscheinlichkeit Pm (exakt fuer	*/
					/* M/M/m_FCFS - Knoten )				*/

					/* Knoten vom Typ M/M/m_FCFS, M/G/m_PS(1) u. M/G/m_FCFS */
					/* werden mit diesen Wartew'keiten analysiert.		*/
					/* Die restlichen Knotentypen werden mit Scat analy-	*/
					/* siert, wobei bei dem Knotentyp M/G/1_FCFS 		*/
					/* die Antwortzeit mithilfe der Auslastung und		*/
					/* Bedienzeit fuer jede Klasse getrennt ,		*/
					/* und bei M/G/m_FCFS - , M/M/m_FCFS - und M/G/m_PS(1) -*/
					/* Knoten die Antwortzeit mithilfe der normierten 	*/
					/* Bedienzeit und der Gesamtauslastung berechnet wird.	*/
		break;
	case '7':
		Pm_modus = 3;
		az_modus = 2;
		scat();	
					/* Scat mit Wartewahrscheinlichkeit Pm Naeherung 	*/

					/* Knoten vom Typ M/M/m_FCFS, M/G/m_PS(1) u. M/G/m_FCFS */
					/* werden mit diesen Wartew'keiten analysiert.		*/
					/* Die restlichen Knotentypen werden mit Scat analy-	*/
					/* siert, wobei bei dem Knotentyp M/G/1_FCFS 		*/
					/* die Antwortzeit mithilfe der Auslastung und		*/
					/* Bedienzeit fuer jede Klasse getrennt ,		*/
					/* und bei M/G/m_FCFS - , M/M/m_FCFS - und M/G/m_PS(1) -*/
					/* Knoten die Antwortzeit mithilfe der normierten 	*/
					/* Bedienzeit und der Gesamtauslastung berechnet wird.	*/
		break;
	case '8':
		az_modus = 2;
		RTP_modus = 1;
		rtp();			/* normale RTP - Methode				*/
		break;

	case '9':
		az_modus = 2;
		if ( R == 1 )
		   RTP_modus = 2;
		else
		   RTP_modus = 1;
		rtp();			/* approximierte RTP - Methode				*/
		break;

	case 'a':
		/* Mittelwertapproximation nach Bard - Schweitzer	*/
		/* fuer die Knotentypen M/M/1_FCFS und M/G/0_IS		*/
		/*------------------------------------------------------*/

		/* Anfangsverteilung : alle Auftraege gleichmaessig verteilt */
		/*-----------------------------------------------------------*/
		for ( r = 0; r < R; r++)
		   {
		   for (i = 0; i < N; i++)
		      {
		      kq_K[r][i] = K[r] / (double) N;
		      for ( s = 0; s < R; s++)
			 D[r][s][i] = 0.0;
		      }	
		   }

		core(kq_K,R);	

		break;

	case 'b':
		mg1_modus = 2;
		az_modus = 2;
	 	flag = 1;		/* Flag, das anzeigt, ob sp_free2() aufgerufen 		*/
					/* werden muss						*/
	  	sp_2_alloc();		/* Dynamische Speicherbelegung fuer die Randwahrschein-	*/
					/* lichkeiten P, fuer die Wahrscheinlichkeitsmasse W und*/
					/* fuer die Skalierfunktion PR				*/
		scat();	
					/* Scat fuer M/G/1_FCFS - Knoten :			*/
					/* Berechnung der Antwortzeit mithilfe der Gesamtaus-	*/
					/* lastung und  der normierten Bedienzeit 		*/

					/* Knoten vom Typ M/M/m_FCFS u. M/G/m_PS(1) werden mit	*/
					/* den Randw'keiten nach Bolch/Akyildiz, Knoten vom Typ */
					/* M/G/m_FCFS werden mit der Wartew'keit analysiert.	*/
					/* Die restlichen Knotentypen werden mit Scat analy-	*/
					/* siert, wobei bei den Knotentypen M/G/m_FCFS und	*/
					/* M/G/1_FCFS die Antwortzeit mithilfe der Gesamtaus-	*/
					/* lastung und der normierten Bedienzeit berechnet	*/
					/* wird.						*/
		break;
	case 'c':
		az_modus = 2;
		if ( R == 1 )
		   app_modus = 2;
		else
		   app_modus = 1;
		Pm_modus = 2;
		scat();	
					/* Scat mit Wartewahrscheinlichkeit Pm (exakt fuer	*/
					/* M/M/m_FCFS - Knoten )				*/
					/* Fuer die Berechnung der Antwortzeit wird eine 	*/
					/* Naeherungsformel verwendet				*/

					/* Knoten vom Typ M/M/m_FCFS, M/G/m_PS(1) u. M/G/m_FCFS */
					/* werden mit diesen Wartew'keiten analysiert.		*/
					/* Die restlichen Knotentypen werden mit Scat analy-	*/
					/* siert, wobei bei dem Knotentyp M/G/1_FCFS 		*/
					/* die Antwortzeit mithilfe der Auslastung und		*/
					/* Bedienzeit fuer jede Klasse getrennt berechnet wird.	*/
		break;
       	default:			/* Ueber Option wurde ein falsches			*/
					/* Verfahren eingegeben					*/
   		if (dbg) fprintf(stderr,"Verfahren v%c nicht implementiert!\n",optarg[0]);

                /* Allokierten Speicher freigeben */
		/*--------------------------------*/
		if(flag == 1)
		   sp_2_free();
                sp_1_free();
                sp_3_free();

		printf("appscat_option\n 0 0 0\n");
		exit(1);
	}

/* Falls dbg > 0 : Ausgabe der Core - Iterationen */
/*------------------------------------------------*/
   if (dbg) fprintf(stderr,"Anzahl der Core - Iterationen = %ld\n",CoreIter);

/* Berechnung der Leistungsgroessen, falls scat() aufgerufen wurde, bei rtp() */
/* werden die Leistungsgroessen selbst berechnet			      */
/*----------------------------------------------------------------------------*/
   if ( RTP_modus == 0)
      leistungsgroessen();
 
/* Ausgabe der Leistungsgroessen */
/*-------------------------------*/
   ausgabe(option[0]);
 
/* Freigeben des allokierten Speichers */
/*-------------------------------------*/
   if ( flag == 1)
      sp_2_free();
   sp_1_free();
   sp_3_free();

exit(0);

}
