static char *SccsId = "@(#)PEPSY:\trtp.c\t1.3\t92/12/08 09:49:12";
/****************************************************************************************/
/*  In dieser Datei ist die RTP - Methode implementiert					*/
/****************************************************************************************/


#include <stdio.h>
#include <math.h>
#include "def.h"


/****************************************************************************************/
/*											*/
/*  FUNKTION										*/
/*  sq_berechnen()									*/
/*											*/
/*  wird aufgerufen in :		gespeichert in :				*/
/*  - rtp()				rtp.c						*/
/*											*/
/*  Berechnung der Ersatzbedienzeiten und der neuen Knotentypen 			*/
/*											*/
/****************************************************************************************/


sq_berechnen()
{
   int		r, s; 		        /* Laufvariable fuer die Klassen		*/
   int		i;			/* Laufvariable fuer die Knoten			*/
   int		t;              	/* Knotentyp 					*/
   double	tq_hilf;  		/* Hilfsgroesse 				*/
   double	nenner;  		/* Hilfsgroesse 				*/
   double	rho_hilf;   		/* Hilfsgroesse 				*/
   double	hilf_lam;           	/* Hilfsgroesse 				*/
   double	wq;           		/* Hilfsgroesse 				*/
   double	rho_r, rho_rm1;         /* Auslastung 					*/
   
   extern	double	Pm();


   for (i=0 ; i<N ; i++) 
      {

      /*  Alten Knotentyp bereitstellen und neuen mit Typ=1 vorbesetzen */
      /*----------------------------------------------------------------*/
      t      = typ_rtp[i];
      typ[i] = 1;

      switch (t) {

	   case 1: /* M/M/1_FCFS */
	   case 3: /* M/G/1_PS */
	   case 9: /* M/G/1_LCFS_PRE */
		 for (r=0 ; r<R ; r++) 
		    sq[r][i] = sq_alt[r][i];

		 break;

	   case 4: /* M/G/oo_IS */
		 for (r=0 ; r<R ; r++) 
		    sq[r][i] = sq_alt[r][i];
		 typ[i] = 4;

	         break;

	   case 2: /* M/M/m_FCFS */
	   case 12: /* M/M/m_PS(1) */

		 if ( RTP_modus == 1 ) 
		    {
		    /* Berechnung der mittleren Wartezeit */
		    /*------------------------------------*/
		    for ( wq=0.0 ,s = 0; s<R ; s++) 
		       {
		       rho_hilf    = lambda[s] * besh[s][i] * sq_alt[s][i] / ((double)mm[i]);

		       if ( (1.0 - rho_hilf) == 0.0 )
			  {
			  if (dbg)
			     {
			     fprintf(stderr,"Numerische Probleme bei der Berechnung der \n");
			     fprintf(stderr,"neuen Bedienzeiten bei der RTP - Methode\n");
			     }
			  printf("appscat_numerik\n 0 0 0\n");
			  exit(3);
			  }

		       wq   += sq_alt[s][i] * Pm(rho_hilf,i,Pm_modus) / (1.0-rho_hilf);
		       }
		    wq = wq / ((double)mm[i]);
   
		    /* Berechnung der mittleren Bedienzeit */
		    /*-------------------------------------*/
		    for (nenner=0.0, r = 0; r<R ; r++) 
		       nenner += (sq_alt[r][i] + wq) * lambda[r] * besh[r][i] ; 
		    nenner += 1.0;

		    for (r=0 ; r<R ; r++) 
		       {
		       tq_hilf = sq_alt[r][i] + wq; 
		       sq[r][i]  = tq_hilf / nenner;
		       }
		    }  

		 else					/* RTP_modus == 2, approximierte RTP - Methode: */
							/* fuer eine Auftragsklasse wird die mittlere	*/
							/* Antwortzeit am M/M/m_FCFS - Knoten mit Hilfe */
							/* einer approximierten Formel berechnet	*/

		    {
		    /* Berechnung der Antwortzeit */
		    /*----------------------------*/
		    rho_hilf = lambda[0] * besh[0][i] * sq_alt[0][i] / ((double) mm[i]);
		    if ( ( K[0] - (double) mm[i] ) == 0 )
		       nenner = 1.0 -  rho_hilf;
		    else
		       nenner = 1.0 - ((K[0] - (double) mm[i] - 1.0 ) / (K[0] - (double) mm[i])) * rho_hilf;
		    if ( nenner == 0.0 )
		       nenner = 0.01;
		    tq_hilf = sq_alt[0][i] * ((double) mm[i]  +  Pm(rho_hilf,i,Pm_modus) / nenner ) ;

		    /* Berechnung der mittleren Bedienzeit */
		    /*-------------------------------------*/
		    sq[0][i] = tq_hilf / (1.0 + lambda[0] * besh[0][i] * (K[0] - 1.0) / K[0] * tq_hilf);
		    }

		 break;

	   case 13: /* M/M/m_PS(2) */
		 for (r=0 ; r<R ; r++)
		    sq[r][i] = sq_alt[r][i] / ((double)mm[i]);

		 break;

	   case 5: /* M/G/1_FCFS */

		 if (RTP_modus == 1)			/* Normale RTP - Methode		*/
		    {
		    /* Berechnung der mittleren Wartezeit */
		    /*------------------------------------*/
		    for (wq = 0.0, s = 0 ; s<R ; s++) 
		       {
		       rho_hilf    = lambda[s] * besh[s][i] * sq_alt[s][i] ;

		       if ( (1.0 - rho_hilf) == 0.0 )
			  {
			  if (dbg)
			     {
			     fprintf(stderr,"Numerische Probleme bei der Berechnung der \n");
			     fprintf(stderr,"neuen Bedienzeiten bei der RTP - Methode\n");
			     }
			  printf("appscat_numerik\n 0 0 0\n");
			  exit(3);
			  }

		       wq   += sq_alt[s][i] * rho_hilf / (1.0 - rho_hilf) * (1.0 + vc[s][i])/2.0 ;
		       }

		    /* Berechnung der mittleren Bedienzeit */
		    /*-------------------------------------*/
		    for (nenner=0.0,r = 0; r<R ; r++) 
		       nenner += (sq_alt[r][i] + wq) * lambda[r] * besh[r][i] ; 
		    nenner += 1.0;
   
		    for (r=0 ; r<R ; r++) 
		       {
		       tq_hilf = sq_alt[r][i] + wq; 
		       sq[r][i]  = tq_hilf / nenner;
		       }
		    }

		 else					/* RTP_modus == 2, approximierte RTP - Methode: */
							/* fuer eine Auftragsklasse wird die mittlere	*/
							/* Antwortzeit am M/G/1_FCFS - Knoten mit Hilfe */
							/* einer approximierten Formel berechnet	*/

		    {
		    /* Berechnung der Antwortzeit */
		    /*----------------------------*/
		    rho_hilf = lambda[0] * besh[0][i] * sq_alt[0][i];
		    if ( ( K[0] - 1.0 ) == 0 )
		       nenner = 1.0 - rho_hilf;
		    else
		       nenner = 1.0 - (K[0] - 1.0 - (vc[0][i] + 1.0)/2.0 ) / (K[0] - 1.0) * rho_hilf;
		    if ( nenner == 0.0 )
		       nenner = 0.01;
		    tq_hilf = sq_alt[0][i] * (1.0  +  rho_hilf / nenner * (vc[0][i] + 1.0)/2.0 );

		    /* Berechnung der mittleren Bedienzeit */
		    /*-------------------------------------*/
		    sq[0][i] = tq_hilf / (1.0 + lambda[0] * besh[0][i] * (K[0] - 1.0) / K[0] * tq_hilf);
		    }

		 break;

	   case 6: /* M/G/m_FCFS */

		 if ( RTP_modus == 1)
		    {
		    /* Berechnung der mittleren Wartezeit */
		    /*------------------------------------*/
		    for (wq=0.0, s = 0 ; s<R ; s++) 
		       {
		       rho_hilf    = lambda[s] * besh[s][i] * sq_alt[s][i] / ((double)mm[i]);

		       if ( (1.0 - rho_hilf) == 0.0 )
			  {
			  if (dbg)
			     {
			     fprintf(stderr,"Numerische Probleme bei der Berechnung der \n");
			     fprintf(stderr,"neuen Bedienzeiten bei der RTP - Methode\n");
			     }
			  printf("appscat_numerik\n 0 0 0\n");
			  exit(3);
			  }

		       wq   += sq_alt[s][i] * Pm(rho_hilf,i,Pm_modus) / (1.0 - rho_hilf) * (1.0 + vc[s][i])/2.0 ;
		       }
		    wq = wq / ((double)mm[i]);

		    /* Berechnung der mittleren Bedienzeit */
		    /*-------------------------------------*/
		    for (nenner=0.0, r = 0; r<R ; r++) 
		       nenner += (sq_alt[r][i] + wq) * lambda[r] * besh[r][i] ; 
		    nenner += 1.0;

		    for (r=0 ; r<R ; r++) 
		       {
		       tq_hilf = sq_alt[r][i] + wq; 
		       sq[r][i]  = tq_hilf / nenner;
		       }
		    }

		 else					/* RTP_modus == 2, approximierte RTP - Methode: */
							/* fuer eine Auftragsklasse wird die mittlere	*/
							/* Antwortzeit am M/G/m_FCFS - Knoten mit Hilfe */
							/* einer approximierten Formel berechnet	*/

		    {
		    /* Berechnung der Antwortzeit */
		    /*----------------------------*/
		    rho_hilf = lambda[0] * besh[0][i] * sq_alt[0][i] / ((double) mm[i]);
		    if ( ( K[0] - (double)mm[i] ) == 0 )
		       nenner = 1.0 - rho_hilf; 
		    else
		       nenner = 1.0 - ((K[0] - (double) mm[i] - (vc[0][i] + 1.0)/2.0 ) / (K[0] - (double) mm[i])) * rho_hilf; 
		    if ( nenner == 0.0 )
		       nenner = 0.01;
		    tq_hilf = sq_alt[0][i] * ((double) mm[i]  +  (Pm(rho_hilf,i,Pm_modus) / nenner) * (vc[0][i] + 1.0)/2.0 );

		    /* Berechnung der mittleren Bedienzeit */
		    /*-------------------------------------*/
		    sq[0][i] = tq_hilf / (1.0 + lambda[0] * besh[0][i] * (K[0] - 1.0) / K[0] * tq_hilf);
		    }

		 break;


     /*
    	   case 14:  (M/G/1_PP verdraengende Prioritaeten)
		 (Modellierung mit IS )
		 (---------------------)
		 typ[i] = 4;


		 ( Berechnung der mittleren Bedienzeit )
		 (-------------------------------------)
		 rho_r   = 0;
		 rho_rm1 = 0;
		 wq    = 0.0;
		 for (s=0 ; s<R ; s++) 
		    {
		    rho_hilf     = lambda[s] * besh[s][i] * sq_alt[s][i] ;
		    rho_rm1 = rho_r ;
		    rho_r  += rho_hilf;
		    wq   += rho_hilf * sq_alt[s][i] * (1 + vc[s][i]);
		    sq[s][i]  = ( sq_alt[s][i] + wq / (2.0 * (1 - rho_rm1))) / ( 1 - rho_r) ; 
		    }

		 break;
     */

	   default:
		 if (dbg) fprintf(stderr,"Undefinierter Knotentyp bei RTP\n");

		 /* Allokierten Speicher freigeben */
		 /*--------------------------------*/
		 if (flag == 1)
		    sp_2_free();
		 sp_1_free();

		 printf("appscat_kn_typ\n 0 0 0\n");
		 exit(1);
	   }
      }
}



/****************************************************************************************/
/*											*/
/*  FUNKTION										*/
/*  umkopieren()									*/
/*											*/
/*  wird aufgerufen in :		gespeichert in :				*/
/*  - rtp()				rtp.c						*/
/*											*/
/*  Diese Prozedur verschiebt die alten Bedienzeiten und die alten 			*/
/*  Knotentypen auf Hilfsfelder.							*/
/*											*/
/****************************************************************************************/

umkopieren()
{
	double   **hilf_sq;
	int 	 *hilf_t;

	/*  Bedienzeiten umkopieren
	=========================*/
	hilf_sq	= sq;
	sq	= sq_alt;
	sq_alt 	= hilf_sq;

	/*  Alte Knotentypen merken
	=========================*/
	hilf_t	= typ;
	typ	= typ_rtp;
	typ_rtp	= hilf_t;
}



/****************************************************************************************/
/*											*/
/*  FUNKTION										*/
/*  rtp()										*/
/*											*/
/*  wird aufgerufen in :		gespeichert in :				*/
/*  - main()				main.c						*/
/*											*/
/*  ruft auf :				gespeichert in :				*/
/*  - umkopieren()			rtp.c						*/
/*  - sq_berechnen()			rtp.c						*/
/*  - scat()				appscat.c					*/
/*											*/
/*   RTP-Methode: Hauptprozedur								*/
/*											*/
/****************************************************************************************/

rtp()
{
   double 	epsilon;		/* Schranke 					*/
   double 	max, diff;		/* Hilfsgroessen aur Ermittlung der		*/
					/* maximalen Abweichungen der Durchsaetze	*/

   int 		r;			/* Laufvariable fuer die Klassen		*/
   int 		i;			/* Laufvariable fuer die Knoten			*/


/*  Schranke und Durchsaetze initialisieren und Bedienzeiten retten */
/*------------------------------------------------------------------*/
   epsilon = 0.001 / sq[0][0];
   for (r=0 ; r<R ; r++ )
      lambda_rtp[r] = lambda[r];

   umkopieren();

   Pm_modus = 2;   /* Fuer Prioritaeten */

   do {

      if (rtp_ci >= iteration)
	 break;

      /*  Bedienzeiten berechnen  */
      /*--------------------------*/
      sq_berechnen();

      /* Scat ausfuehren */
      /*-----------------*/
      scat();

      rtp_ci += CoreIter;
      CoreIter = 0;


      /*  Maximale Abweichung der Durchsaetze berechnen und alten Durchsatz merken */
      /*---------------------------------------------------------------------------*/
      max	= 0.0;
      for (r=0 ; r<R ; r++ ) 
         {
	 diff = fabs(lambda[r] - lambda_rtp[r]);
	 lambda_rtp[r] = lambda[r];
	 if (diff > max)
             max = diff;
	 }
		
      } while (max > epsilon);

   CoreIter = rtp_ci;

   /* Anzahl der Bedieneinheiten = 1, falls resultierender Knoten nur eine Bedieneinheit besitzt */
   /* Anzahl der Bedieneinheiten = 0, falls resultierender Knoten vom Typ M/G/1_IS		 */
   /*--------------------------------------------------------------------------------------------*/
   for (i = 0;i < N;i++)
      {
      if ( typ[i] == 1 || typ[i] == 3 || typ[i] == 5 || typ[i] == 9)
         mm[i] = 1;
      if ( typ[i] == 4 )
	 mm[i] = 0;
      }

   /* Berechnen der Leistungsgroessen */
   /*---------------------------------*/
   leistungsgroessen();

   /* Wieserherstellen der alten Bedienzeiten */
   /*-----------------------------------------*/
   umkopieren();

}

