static char *SccsId = "@(#)PEPSY:\tspeicher.c\t1.1\t92/03/27 11:40:25";
/*********************************************************************************/
/*  Diese Datei enthaelt die dynamische Speicherverwaltung fuer die  		 */
/*  Felder des approximierten Scat				    		 */
/*********************************************************************************/


#include  <stdio.h>
#include  "def.h"


#define	STREUUNG	20	/* maximale Streubreite, zur dynamischen	*/
				/* Speicherbelegung in speicher_alloc2(),	*/
				/* nochmal in sc3.c definiert			*/


/********************************************************************************/
/*  								     	        */
/*  FUNKTION							     	        */
/*  sp_1_alloc()						     	        */
/*								     	        */
/*  Wird aufgerufen in :          gespeichert in :		     	        */
/*  - eingabe()                   - eingabe.c			     	        */
/*								     	        */
/*  Ruft auf :		          gespeichert in :		     	        */
/*  - d_3dim_alloc()		  ../ea/memory.c		     	        */
/*  - d_2dim_alloc()		  ../ea/memory.c		     	        */
/*  - d_1dim_alloc()		  ../ea/memory.c		     	        */
/*  - i_1dim_alloc()		  ../ea/memory.c		     	        */
/* 								     	        */
/*  Die Funktion allokiert den Speicherplatz fuer die Felder des     	        */
/*  approximierten SCAT - Algorithmus				     	        */
/*								     	        */
/********************************************************************************/


sp_1_alloc()
   
{
   extern	double	***d_3dim_alloc();	
   extern	double	 **d_2dim_alloc();
   extern	double	  *d_1dim_alloc();
   extern 	int	  *i_1dim_alloc();

   

/* Speicher fuer die Knotentypen bereitstellen */
/*---------------------------------------------*/
   if ((typ = i_1dim_alloc(N + 1)) == (int *) 0)
      mall_err("typ");

/* Speicher fuer das Hilfsfeld der Knotentypen bereitstellen */
/*-----------------------------------------------------------*/
   if ((typ_rtp = i_1dim_alloc(N + 1)) == (int *) 0)
      mall_err("typ_rtp");

/* Speicher fuer die Anzahl der Bedieneinheiten bereitstellen */
/*------------------------------------------------------------*/
   if ((mm = i_1dim_alloc(N + 1)) == (int *) 0)
      mall_err("mm");

/* Speicher fuer die Anzahl der Auftraege pro Klasse bereitstellen */
/*-----------------------------------------------------------------*/
   if ((K = d_1dim_alloc(R + 3)) == (double *) 0)
      mall_err("K");

/* Speicher fuer den Durchsatz bereitstellen */
/*-------------------------------------------*/
   if ((lambda = d_1dim_alloc(R + 1)) == (double *) 0)
      mall_err("lambda");

/* Speicher fuer das Hilfsfeld fuer den Durchsatz bei RTP bereitstellen */
/*----------------------------------------------------------------------*/
   if ((lambda_rtp = d_1dim_alloc(R + 1)) == (double *) 0)
      mall_err("lambda_rtp");

/* Speicher fuer die Besuchshaeufigkeiten bereitstellen */
/*------------------------------------------------------*/
   if ((besh = d_2dim_alloc(R + 1,N + 1)) == (double **) 0)
      mall_err("besh");

/* Speicher fuer die mittl. Bedienzeiten bereitstellen */
/*-----------------------------------------------------*/
   if ((sq = d_2dim_alloc(R + 1,N + 1)) == (double **) 0)
      mall_err("sq");

/* Speicher fuer das Hilfsfeld fuer die Bedienzeiten bereitstellen */
/*-----------------------------------------------------------------*/
   if ((sq_alt = d_2dim_alloc(R + 1,N + 1)) == (double **) 0)
      mall_err("sq_alt");

/* Speicher fuer die quadrierten Variationskoeffizienten der Bedienzeiten  bereitstellen */
/*---------------------------------------------------------------------------------------*/
   if ((vc = d_2dim_alloc(R + 1,N + 1)) == (double **) 0)
      mall_err("vc");

/* Speicher fuer die Antwortzeiten bereitstellen */
/*-----------------------------------------------*/
   if ((tq = d_2dim_alloc(R + 1,N + 1)) == (double **) 0)
      mall_err("tq");

/* Speicher fuer die mittl. Auftragszahlen bereitstellen */
/*-------------------------------------------------------*/
   if ((kq_K = d_2dim_alloc(R + 1,N + 1)) == (double **) 0)
      mall_err("kq_K");

/* Speicher fuer das Hilfsfeld fuer die maximalen Abweichunge bereitstellen */
/*--------------------------------------------------------------------------*/
   if ((kq_alt = d_2dim_alloc(R + 1,N + 1)) == (double **) 0)
      mall_err("kq_alt");

/* Speicher fuer den Durchsatz pro Klasse und Knoten bereitstellen */
/*-----------------------------------------------------------------*/
   if ((durchsatz = d_2dim_alloc(R + 1,N + 1)) == (double **) 0)
      mall_err("durchsatz");

/* Speicher fuer die Auslastung pro Klasse und Knoten bereitstellen */
/*------------------------------------------------------------------*/
   if ((rho = d_2dim_alloc(R + 1,N + 1)) == (double **) 0)
      mall_err("rho");

/* Speicher fuer die m. Wartezeit pro Klasse und Knoten bereitstellen */
/*--------------------------------------------------------------------*/
   if ((mwz = d_2dim_alloc(R + 1,N + 1)) == (double **) 0)
      mall_err("mwz");

/* Speicher fuer die m. Warteschlangenlaenge pro Klasse und Knoten bereitstellen */
/*-------------------------------------------------------------------------------*/
   if ((mws = d_2dim_alloc(R + 1,N + 1)) == (double **) 0)
      mall_err("mws");

/* Speicher fuer die Fehler bei den mittl. Auftragszahlen bereitstellen */
/*----------------------------------------------------------------------*/
   if ((D = d_3dim_alloc(R + 1,R + 1,N + 1)) == (double ***) 0)
      mall_err("D");

/* Speicher fuer die mittl. Auftragszahlen im Zustand (K-1r) bereitstellen */
/*-------------------------------------------------------------------------*/
   if ((kq_Kminus1r = d_3dim_alloc(R + 1,R + 1,N + 1)) == (double ***) 0)
      mall_err("kq_Kminus1r");

/* Speicher fuer die Schaetzungen fuer die mittl. Auftragszahlen im Zustand (K-1r) bereitstellen */
/*-----------------------------------------------------------------------------------------------*/
   if ((kq_schaetz = d_3dim_alloc(R + 1,R + 1,N + 1)) == (double ***) 0)
      mall_err("kq_schaetz");

}



/********************************************************************************/
/*  								     		*/
/*  FUNKTION							     		*/
/*  sp_2_alloc()						     		*/
/*								     		*/
/*  Wird aufgerufen in :          gespeichert in :		     		*/
/*  - main()                      - main.c			     		*/
/*								     		*/
/*  Ruft auf :		          gespeichert in :		     		*/
/*  - d_2dim_alloc()		  ../ea/memory.c		     		*/
/*  - d_1dim_alloc()		  ../ea/memory.c		     		*/
/* 								     		*/
/*  Die Funktion allokiert den Speicherplatz fuer die Randwahrschein-		*/
/*  lichkeiten P, fuer die Wahrscheinlichkeitsmasse W und fuer die   		*/
/*  Skalierfunktion PR						     		*/
/*								     		*/
/********************************************************************************/


sp_2_alloc()
   
{
   extern	double	 **d_2dim_alloc();
   extern	double	  *d_1dim_alloc();

   
   int		KR;		/* Hilfsgroesse, mittl. Anzahl der Auftraege im */
				/* Zustand |K -1r|				*/
   int		max_mm;		/* Hilfsgroesse, maximale Anzahl der 		*/
				/* Bedieneinheiten				*/
   int		i;		/* Laufvariable fuer die Knoten			*/
   int		r;		/* Laufvariable fuer die Klassen		*/



/* Berechnung der Groesse KR */
/*---------------------------*/
   for (KR = 0, r = 0; r < R; r++)
      KR += (int)K[r];
   KR-- ;
   /* if (dbg) fprintf(stderr,"|K - 1r| = %d\n",KR); */

/* Berechnung der Groesse max_mm */
/*-------------------------------*/
   for (max_mm = 0, i = 0; i < N; i++)
      {
      if ( max_mm < mm[i])
         max_mm = mm[i];
      }
   /* if (dbg) fprintf(stderr,"Max. Zahl der Bedieneinheiten an einer Station = %d\n",max_mm); */

/* Speicher fuer die Randwahrscheinlichkeiten bereitstellen */
/*----------------------------------------------------------*/
   if ((P = d_1dim_alloc(max_mm + 2)) == (double *) 0)
      mall_err("P");

/* Speicher fuer die Wahrscheinlichkeitsmasse bereitstellen */
/*----------------------------------------------------------*/
   if ((W = d_2dim_alloc(KR + 2, STREUUNG + 2)) == (double **) 0)
      mall_err("W");

/* Speicher fuer die Skalierfunktion bereitstellen */
/*-------------------------------------------------*/
   if ((PR = d_1dim_alloc(KR + 2)) == (double *) 0)
      mall_err("PR");

}


/********************************************************************************/
/*
*/
/*  FUNKTION                                                                    */
/*  sp_3_alloc()   27.7.91                                                      */
/*                                                                              */
/*  Wird aufgerufen in :            gespeichert in :                            */
/*  -main()                         - main.c                                    */
/*                                                                              */
/*  Ruft auf :                      gespeichert in :                            */
/*  - d_2dim_alloc()                ../ea/memory.c                              */
/*  - d_1dim_alloc()                ../ea/memory.c                              */
/*                                                                              */
/*  Die Funktion fordert den Speicherplatz fuer die Bedienraten pro             */ 
/*  Bedieneinheit und Knoten (asymmetrische multiple server) an                 */
/*                                                                              */
/*                                                                              */
/********************************************************************************/

sp_3_alloc()

{
   extern     double   **d_2dim_alloc();
   extern     double    *d_1dim_alloc();

   int        max_mm;      /* Hilfsgroesse, maximale Anzahl der                 */
                           /* Bedieneinheiten                                   */
   int        i;           /* Laufvariable fuer die Knoten                      */


/* Berechnung der Groesse max_mm */

   for (max_mm = 0, i = 0; i < N; i++)
      {
      if ( max_mm < mm[i])
          max_mm = mm[i];
      }

/* Speicher fuer Bedienratenpro Knoten und Bedieneinheit bereitstellen */

   if ((amue = d_2dim_alloc(N+1, max_mm+2)) == (double **) 0 )
      mall_err("amue");

/* Speicher fuer Summe der Bedienraten pro Knoten bereitstellen */

   if ((sumamue = d_1dim_alloc(N+1)) == (double *) 0 )
      mall_err("sumamue");

}

/********************************************************************************/
/*  								     		*/
/*  FUNKTION							     		*/
/*  sp_1_free()							     		*/
/*								     		*/
/*  Wird aufgerufen in :          gespeichert in :		     		*/
/*  - main()                      - main.c			     		*/
/*								     		*/
/*  Ruft auf :		          gespeichert in :		     		*/
/*  - d_3dim_free()		  ../ea/memory.c		     		*/
/*  - d_2dim_free()		  ../ea/memory.c		     		*/
/*  - d_1dim_free()		  ../ea/memory.c		     		*/
/*  - i_1dim_free()		  ../ea/memory.c		     		*/
/* 								     		*/
/*  Die Funktion gibt den Speicherplatz fuer die Felder des	     		*/
/*  SCAT - Algorithmus frei					     		*/
/*								     		*/
/********************************************************************************/


sp_1_free()
   
{
   extern	int	d_3dim_free();	
   extern	int	d_2dim_free();
   extern	int	d_1dim_free();
   extern 	int	i_1dim_free();



/* Speicher fuer die Knotentypen freigeben */
/*-----------------------------------------*/
   i_1dim_free(typ,N + 1);

/* Speicher fuer das Hilfsfeld der Knotentypen freigeben */
/*-------------------------------------------------------*/
   i_1dim_free(typ_rtp, N + 1);

/* Speicher fuer die Anzahl der Bedieneinheiten freigeben */
/*--------------------------------------------------------*/
   i_1dim_free(mm, N + 1);

/* Speicher fuer die Anzahl der Auftraege pro Klasse freigeben */
/*-------------------------------------------------------------*/
   d_1dim_free(K, R + 3);

/* Speicher fuer den Durchsatz freigeben */
/*---------------------------------------*/
   d_1dim_free(lambda, R + 1);

/* Speicher fuer das Hilfsfeld fuer den Durchsatz bei RTP freigeben */
/*------------------------------------------------------------------*/
   d_1dim_free(lambda_rtp, R + 1);

/* Speicher fuer die Besuchshaeufigkeiten freigeben */
/*--------------------------------------------------*/
   d_2dim_free(besh, R + 1,N + 1);

/* Speicher fuer die mittl. Bedienzeiten freigeben */
/*-------------------------------------------------*/
   d_2dim_free(sq, R + 1,N + 1);

/* Speicher fuer das Hilfsfeld fuer die Bedienzeiten freigeben */
/*-------------------------------------------------------------*/
   d_2dim_free(sq_alt, R + 1,N + 1);

/* Speicher fuer die quadrierten Variationskoeffizienten der Bedienzeiten  freigeben */
/*-----------------------------------------------------------------------------------*/
   d_2dim_free(vc, R + 1,N + 1);

/* Speicher fuer die Antwortzeiten freigeben */
/*-------------------------------------------*/
   d_2dim_free(tq, R + 1,N + 1);

/* Speicher fuer die mittl. Auftragszahlen freigeben */
/*---------------------------------------------------*/
   d_2dim_free(kq_K, R + 1,N + 1);

/* Speicher fuer das Hilfsfeld fuer die maximalen Abweichunge freigeben */
/*----------------------------------------------------------------------*/
   d_2dim_free(kq_alt, R + 1,N + 1);

/* Speicher fuer den Durchsatz pro Klasse und Knoten freigeben */
/*-------------------------------------------------------------*/
   d_2dim_free(durchsatz, R + 1,N + 1);

/* Speicher fuer die Auslastung pro Klasse und Knoten freigeben */
/*--------------------------------------------------------------*/
   d_2dim_free(rho, R + 1,N + 1);

/* Speicher fuer die m. Wartezeit pro Klasse und Knoten freigeben */
/*----------------------------------------------------------------*/
   d_2dim_free(mwz, R + 1,N + 1);

/* Speicher fuer die m. Warteschlangenlaenge pro Klasse und Knoten freigeben */
/*---------------------------------------------------------------------------*/
   d_2dim_free(mws, R + 1,N + 1);

/* Speicher fuer die Fehler bei den mittl. Auftragszahlen freigeben */
/*------------------------------------------------------------------*/
   d_3dim_free(D, R + 1,R + 1,N + 1);

/* Speicher fuer die mittl. Auftragszahlen im Zustand (K-1r) freigeben */
/*---------------------------------------------------------------------*/
   d_3dim_free(kq_Kminus1r, R + 1,R + 1,N + 1);

/* Speicher fuer die Schaetzungen fuer die mittl. Auftragszahlen im Zustand (K-1r) freigeben */
/*-------------------------------------------------------------------------------------------*/
   d_3dim_free(kq_schaetz, R + 1,R + 1,N + 1);

}




/********************************************************************************/
/*  								     		*/
/*  FUNKTION							     		*/
/*  sp_2_free()							     		*/
/*								     		*/
/*  Wird aufgerufen in :          gespeichert in :		     		*/
/*  - main()                      - main.c			     		*/
/*								     		*/
/*  Ruft auf :		          gespeichert in :		     		*/
/*  - d_2dim_free()		  ../ea/memory.c		     		*/
/*  - d_1dim_free()		  ../ea/memory.c		     		*/
/* 								     		*/
/*  Die Funktion gibt den Speicherplatz fuer die in speicher_alloc2()		*/
/*  belegten Felder frei					     		*/
/*								     		*/
/********************************************************************************/


sp_2_free()
   
{
   extern	int	d_2dim_free();
   extern	int	d_1dim_free();


   int		KR;		/* Hilfsgroesse, mittl. Anzahl der Auftraege im */
				/* Zustand |K -1|				*/
   int		max_mm;		/* Hilfsgroesse, maximale Anzahl der 		*/
				/* Bedieneinheiten				*/
   int		i;		/* Laufvariable fuer die Knoten			*/
   int		r;		/* Laufvariable fuer die Klassen		*/



/* Berechnung der Groesse KR */
/*---------------------------*/
   for (KR = 0, r = 0; r < R; r++)
      KR += (int)K[r];
   KR-- ;

/* Berechnung der Groesse max_mm */
/*-------------------------------*/
   for (max_mm = 0, i = 0; i < N; i++)
      {
      if ( max_mm < mm[i])
         max_mm = mm[i];
      }

/* Speicher fuer die Randwahrscheinlichkeiten freigeben */
/*------------------------------------------------------*/
   d_1dim_free(P,max_mm + 2);
   
/* Speicher fuer die Wahrscheinlichkeitsmasse freigeben */
/*------------------------------------------------------*/
   d_2dim_free(W, KR + 2, STREUUNG + 2);

/* Speicher fuer die Skalierungsfunktion freigeben */
/*-------------------------------------------------*/
   d_1dim_free(PR, KR + 2);

}
 

/********************************************************************************/
/*
*/
/*  FUNKTION                                                                    */
/*
*/
/*  sp_3_free()    27.7.91                                                      */
/*  Wird aufgerufen in :               gespeichert in :                         */
/*  - main()                           - main.c                                 */
/*  Ruft auf :                         gespeichert in :                         */
/*  - d_2dim_free()                    ../ea/memory.c                           */
/*  - d_1dim_free()                    ../ea/memory.c                           */
/*                                                                              */
/*  Die Funktion gibt den Speicherplatz fuer die in Speicher_alloc3()           */
/*  belegten Felder frei                                                        */
/*                                                                              */
/********************************************************************************/

sp_3_free()

{
   extern      int      d_2dim_free();
   extern      int      d_1dim_free();

   int         max_mm;             /* Hilfsgroesse, maximale Anzahl der         */
                                   /* Bedieneinheiten                           */
   int         i;                  /* Laufvariable pro Knoten                   */


   /* Berechnung der Groesse max_mm  */

   for (max_mm = 0, i = 0; i < N; i++)
      {
       if ( max_mm < mm[i])
           max_mm = mm[i];
      }


   /* Speicher fuer Bedienraten pro Knoten und Bedieneinheit freigeben */

   d_2dim_free (amue,N+1, max_mm+2);

   /* Speicher fuer die Summe der Bedienraten pro Knoten freigeben */
  
   d_1dim_free (sumamue,N+1);

}

