#include <stdio.h>
#include <string.h>
/*	#include <values.h>	fuer MAXINT	*/
#include "const+type.h"

static char *SccsId = "@(#)PEPSY:\tcmva.c\t1.5\t94/04/26 13:04:18";

#ifndef MAXINT
#define	MAXINT	((int)(~((unsigned)1<<((8*(int)sizeof(int))-1))))
#endif

int ksize, psize;

int N, R, K[RMAX], m[NMAX];
double e[NMAX][RMAX], mue[NMAX][RMAX], *lmue[NMAX][RMAX];
double *lambda[RMAX], *kmean[NMAX][RMAX];
double *p[NMAX];

double lambdaK[RMAX], kmeanK[NMAX][RMAX];
double *pK[NMAX];
int pflag, vflag, oflag;

int main(argc, argv)
int argc;
char *argv[];
{
	/*		Sccs support from SccsLogging.c			*/	
	extern int SccsRelease;
	extern int SccsLevel;

	int i, j, finput();
	void call_error(), memory(), cmva(), set_K();
	void print_perfK(), print_lambdaK(), print_lambda();
	void print_kmeanK(), print_kmean(), print_p();

	for (i = 1; i < argc; ++i)
	{
		if (argv[i][0] != '-')
			call_error("cmva");
		for (j = 1; argv[i][j]; ++j)
		{
			switch (argv[i][j])
			{
				case 'V':
					fprintf(stdout, "%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
					exit(0);
					break;
				case 'r':
				case 'l':
				case 'L':
				case 'k':
				case 'K':
				case 'f':
				case 'F':
					break;
				case 'p':
				case 'P':
					++pflag;
					break;
				case 'v':
					++vflag;
					break;
				default:
					call_error("cmva");
					break;
			}
			++oflag;
		}
	}
	oflag -= vflag;
	if (oflag == 0)
		call_error("cmva");
	finput(stdin, &N, &R, K, m, NULL, NULL, NULL, e, mue, lmue, NULL);
	memory();
	cmva();
	set_K();
	for (i = 1; i < argc; ++i)
	{
		for (j = 1; argv[i][j]; ++j)
		{
			switch (argv[i][j])
			{
				case 'r':
					print_perfK("cmva", N, R, K, m, e, mue,
						lambdaK, kmeanK, pK);
					break;
				case 'l':
					print_lambdaK(R, lambdaK);
					break;
				case 'L':
					print_lambda(R, lambda);
					break;
				case 'k':
					print_kmeanK(N, R, kmeanK);
					break;
				case 'K':
					print_kmean(N, R, kmean);
					break;
				case 'p':
					print_p(N, pK, ksize, NULL);
					break;
				case 'P':
					print_p(N, p, psize, NULL);
					break;
				case 'f':
					print_p(N, pK, ksize, m);
					break;
				case 'F':
					print_p(N, p, psize, m);
					break;
			}
		}
	}
	exit(0);
}

void call_error(name)
char *name;
{
	fprintf(stderr, "Aufruf:   %s -rlLkKpPfFv\n", name);
	fprintf(stderr, "    -r:   Rohdaten ausgeben\n");
	fprintf(stderr, "    -l:   relative Durchsaetze\n");
	fprintf(stderr, "    -L:   lastabhaengige relative Durchsaetze\n");
	fprintf(stderr, "    -k:   mittlere Fuellungen\n");
	fprintf(stderr, "    -K:   lastabhaengige mittlere Fuellungen\n");
	fprintf(stderr, "    -p:   Randwahrscheinlichkeiten aller Knoten rueckwaerts\n");
	fprintf(stderr, "    -P:   lastabhaengige Randwahrscheinlichkeiten aller Knoten rueckwaerts\n");
	fprintf(stderr, "    -f:   Randwahrscheinlichkeiten aller FESC-Knoten rueckwaerts\n");
	fprintf(stderr, "    -F:   lastabhaengige Randwahrscheinlichkeiten aller FESC-Knoten rueckwaerts\n");
	fprintf(stderr, "    -v:   Fortschritte melden\n");
	exit(1);
}

void set_K()
{
	int i, r;

	for (r = 0; r < R; ++r)
	{
		lambdaK[r] = lambda[r][ksize - 1];
	}
	for (i = 0; i < N; ++i)
	{
		for (r = 0; r < R; ++r)
		{
			kmeanK[i][r] = kmean[i][r][ksize - 1];
		}
		if (pflag || m[i] == FESC)
		{
			pK[i] = p[i] + psize - ksize;
		}
	}
}


static int i, r, k[RMAX], kcode, krsize[RMAX];
static int NpMarg, NpMMm, *pp;
static double tmean[NMAX][RMAX], *p_Marg, *p_MMm, *psum[NMAX];

void memory()
{
	char *malloc();
	double dksize, dpsize, *p1, *p2;
	int jsize;
	void stor_error();

	dksize = 1;
	dpsize = 1;
	for (r = 0; r < R; ++r)
	{
		dksize *= K[r] + 1;
		dpsize *= (K[r] + 1) * (K[r] + 2) / 2;
	}
	for (i = 0; i < N; ++i)
	{
		if (pflag || m[i] == FESC)
			++NpMarg;
		if (m[i] > 1)
			NpMMm += m[i];
	}
	if (((N + 1 + NpMMm) * R * dksize + NpMarg * dpsize)*sizeof(double) > MAXINT)
	{
		stor_error();
	}
	ksize = dksize;
	if (dpsize <= MAXINT)
		psize = dpsize;
	kmean[0][0] = (double *)malloc(N * R * ksize * sizeof(double));
	lambda[0] = (double *)malloc(R * ksize * sizeof(double));
	if (NpMarg)
	{
		p_Marg = (double *)malloc(NpMarg * psize * sizeof(double));
		pp = (int *)malloc((ksize + 1) * sizeof(int));
	}
	if (NpMMm)
	{
		p_MMm = (double *)malloc(NpMMm * ksize * sizeof(double));
	}
	if (kmean[0][0] == NULL || lambda[0] == NULL ||
		(NpMarg && (p_Marg == NULL || pp == NULL)) ||
		(NpMMm && p_MMm == NULL))
	{
		stor_error();
	}
	for (r = 0; r < R; ++r)
	{
		lambda[r] = lambda[0] + r * ksize;
	}
	p1 = p_Marg;
	p2 = p_MMm;
	for (i = 0; i < N; ++i)
	{
		for (r = 0; r < R; ++r)
		{
			kmean[i][r] = kmean[0][0] + (i * R + r) * ksize;
		}
		if (pflag || m[i] == FESC)
		{
			p[i] = p1;
			p1 += psize;
		}
		if (m[i] > 1)
		{
			psum[i] = p2;
			p2 += m[i] * ksize;
		}
	}
	krsize[R - 1] = 1;
	for (r = R - 2; r >= 0; --r)
	{
		krsize[r] = krsize[r + 1] * (K[r + 1] + 1);
	}
	if (NpMarg)
	{
		pp[0] = 0;
		for (kcode = 1; kcode <= ksize; ++kcode)
		{
			jsize = 1;
			for (r = 0; r < R; ++r)
			{
				jsize *= k[r] + 1;
			}

			for (r = R - 1; r >= 0; --r)
			{
				if (++k[r] > K[r])
				{
					k[r] = 0;
				}
				else
					break;
			}
			pp[kcode] = pp[kcode - 1] + jsize;
		}
	}
}

void cmva()
{
	double sum;
	static int oldcount;
	void init(), tmeanMG1(), tmeanMMm(), tmeanFESC(), pMMm(), pMarg();

	init();
	for (kcode = 1;; ++kcode)
	{
		for (r = R - 1; r >= 0; --r)
		{
			if (++k[r] > K[r])
			{
				k[r] = 0;
			}
			else
				break;
		}
		if (r < 0)
			break;

		if (vflag)
		{
			double quot = kcode / 10000.0;
			int newcount = (int)(quot * quot);

			if (newcount > oldcount)
			{
				oldcount = newcount;
				fputc('.', stderr);
			}
		}
		for (i = 0; i < N; ++i)
		{
			for (r = 0; r < R; ++r)
			{
				if (k[r] > 0 && e[i][r] > 0)
				{
					switch(m[i])
					{
						case FESC:
						{
							tmeanFESC();
							break;
						}
						case IS:
						{
							tmean[i][r] = 1 / mue[i][r];
							break;
						}
						case 1:
						{
							tmeanMG1();
							break;
						}
						default:  /* m[i] > 1 */
						{
							tmeanMMm();
							break;
						}
					}
				}
				else
				{
					tmean[i][r] = 0;
				}
			}
		}
		for (r = 0; r < R; ++r)
		{
			if (k[r] > 0)
			{
				sum = 0;
				for (i = 0; i < N; ++i)
				{
					sum += e[i][r] * tmean[i][r];
				}
				lambda[r][kcode] = sum == 0 ? 0 : k[r] / sum;
			}
			else
			{
				lambda[r][kcode] = 0;
			}
		}
		for (i = 0; i < N; ++i)
		{
			for (r = 0; r < R; ++r)
			{
				kmean[i][r][kcode] =
					lambda[r][kcode] * tmean[i][r] * e[i][r];
			}
			if (pflag || m[i] == FESC)
				pMarg();
			if (m[i] > 1)
				pMMm();
		}
	}
	if (vflag &&  oldcount > 0)
		fputc('\n', stderr);
}

void init()
{
	int j;

	for (r = 0; r < R; ++r)
	{
		lambda[r][0] = 0;
	}
	for (i = 0; i < N; ++i)
	{
		for (r = 0; r < R; ++r)
		{
			kmean[i][r][0] = 0;
		}
		if (pflag || m[i] == FESC)
			p[i][0] = 1;
		if (m[i] > 1)
		{
			psum[i][0] = 1;
			for (j = 1; j < m[i]; ++j)
			{
				psum[i][j] = 0;
			}
		}
	}
}

void tmeanMG1()
{
	int s, k1code;
	double sum;

	sum = 1;
	k1code = kcode - krsize[r];
	for (s = 0; s < R; ++s)
	{
		sum += kmean[i][s][k1code];
	}
	tmean[i][r] = sum / mue[i][r];
}

void tmeanMMm()
{
	int s, j, k1code;
	double sum;

	sum = 1;
	k1code = kcode - krsize[r];
	for (s = 0; s < R; ++s)
	{
		sum += kmean[i][s][k1code];
	}
	k1code *= m[i];
	for (j = 0; j <= m[i] - 2; ++j)
	{
		sum += (m[i] - j - 1) * psum[i][k1code + j];
	}
	tmean[i][r] = sum / mue[i][r] / m[i];
}

void tmeanFESC()
{
	int s, jcode, p1code;
	double sum;
	static int j1[RMAX];

	--k[r];
	sum = 0;
	jcode = krsize[r];
	for (p1code = pp[kcode - krsize[r]];; ++p1code)
	{
		sum += (j1[r] + 1) / lmue[i][r][jcode] * p[i][p1code];

		for (s = R - 1; s >= 0; --s)
		{
			if (++j1[s] > k[s])
			{
				j1[s] = 0;
				jcode -= k[s] * krsize[s];
			}
			else
			{
				jcode += krsize[s];
				break;
			}
		}
		if (s < 0)
			break;
	}
	tmean[i][r] = sum;
	++k[r];
}

void pMMm()
{
	int j;
	double sum, temp;

	temp = 0;
	for (j = m[i] - 1; j > 0; --j)
	{
		sum = 0;
		for (r = 0; r < R; ++r)
		{
			if (k[r] > 0 && e[i][r] > 0)
			{
				sum += e[i][r] / mue[i][r] * lambda[r][kcode]
					* psum[i][(kcode - krsize[r]) * m[i] + j - 1];
			}
		}
		temp += (m[i] - j) * (psum[i][kcode * m[i] + j] = sum / j);
	}
	for (r = 0; r < R; ++r)
	{
		if (e[i][r] > 0)
		{
			temp += e[i][r] / mue[i][r] * lambda[r][kcode];
		}
	}
	psum[i][kcode * m[i]] =
		(temp = 1 - temp / m[i]) < 0 ? 0 : temp;
}

void pMarg()
{
	double sum, temp;
	int pcode, p1code[RMAX];
	static int j[NMAX], jcode, jsum;

	for (r = 0; r < R; ++r)
	{
		if (k[r] > 0)
		{
			p1code[r] = pp[kcode - krsize[r] + 1] - 1;
		}
	}
	temp = 0;
	for (pcode = pp[kcode + 1] - 1;; --pcode)
	{
		for (r = R - 1; r >= 0; --r)
		{
			if (--j[r] < 0)
			{
				j[r] = k[r];
				jsum += k[r];
				jcode += k[r] * krsize[r];
			}
			else
			{
				--jsum;
				jcode -= krsize[r];
				break;
			}
		}
		if (jcode == 0)
			break;

		sum = 0;
		for (r = 0; r < R; ++r)
		{
			if (j[r] > 0)
			{
				if (e[i][r] > 0)
				{
					if (m[i] == FESC)
					{
						sum += e[i][r] * lambda[r][kcode]
							/ lmue[i][r][jcode]
							* j[r]
							* p[i][p1code[r]];
					}
					else
					{
						sum += e[i][r] * lambda[r][kcode]
							/ mue[i][r]
							* p[i][p1code[r]];
					}
				}
				--p1code[r];
			}
		}
		switch(m[i])
		{
			case FESC:
			case IS:
			{
				sum /= jsum;
				break;
			}
			case 1:
			{
				break;
			}
			default:  /* m[i] > 1 */
			{
				sum /= (m[i] < jsum ? m[i] : jsum);
				break;
			}
		}
		temp += p[i][pcode] = sum;
	}
	p[i][pcode] = (temp = 1 - temp) < 1e-16 ? 0 : temp;
}
