static char *SccsId = "@(#)PEPSY:\thm.c\t1.3\t94/04/26 13:03:53";
#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include "const+type.h"

#define TAIL(path) (strrchr(path, '/') ? strrchr(path, '/') + 1 : path)

static char *PEPSYHOME;
extern int ksize, psize;

int N, R, K[RMAX], m[NMAX], typ[NMAX];
double e[NMAX][RMAX], mue[NMAX][RMAX], *lmue[NMAX][RMAX];
double csq[NMAX][RMAX], ptrans[RMAX][NMAX + 1][NMAX + 1];

double *lambda[RMAX];
double *kmean[NMAX][RMAX], *p[NMAX];

double lambdaK[RMAX], kmeanK[NMAX][RMAX];
double *pK[NMAX];

int lflag, Lflag, kflag, Kflag, fflag, Fflag, pflag, hflag, vflag, oflag, Nflag;
int hmin;

main(argc, argv)
int argc;
char *argv[];
{
	/*		Sccs support from SccsLogging.c			*/	
	extern int SccsRelease;
	extern int SccsLevel;

	int i, j, finput();
	struct tree tree;
	void call_error(), memory(), hm(), print_perfK(), print_p();

	if((PEPSYHOME = (char *)getenv("PEPSYHOME")) == NULL)
	{
		fprintf(stderr,"Environment Variable PEPSYHOME nicht gesetzt\n");
		exit(1);
	}
	for (i = 1; i < argc; ++i)
	{
		if (argv[i][0] != '-')
			call_error("hm");
		for (j = 1; argv[i][j]; ++j)
		{
			switch (argv[i][j])
			{
				case 'V':  				/* kirschni 22.11.1991 */
					fprintf(stdout, "%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
					exit(0);
					break;
				case 'r':
					++lflag;
					++kflag;
					++fflag;
					break;
				case 'L':
					++Lflag;
				case 'l':
					++lflag;
					break;
				case 'K':
					++Kflag;
					++Fflag;
				case 'k':
					++kflag;
					++fflag;
					break;
				case 'P':
					++pflag;
				case 'F':
					++Fflag;
				case 'f':
					++fflag;
					break;
				case 'p':
					++pflag;
					++fflag;
					break;
				case 'h':
					++hflag;
					if ((hmin = atoi(&argv[i][j + 1])) < 0)
					{
						fprintf(stderr, "Hierarchiestufe: %d\n", hmin);
						exit(1);
					}
					while (isdigit(argv[i][j + 1]))
						++j;
					break;
				case 'v':
					++vflag;
					break;
				default:
					call_error("hm");
					break;
			}
			++oflag;
		}
	}
	oflag -= vflag;
	if (oflag == 0)
		call_error("hm");
	
	tree.meth = NULL;
	Nflag = finput(stdin, &N, &R, K, m, typ, csq, ptrans, e, mue, lmue, &tree);
	if (tree.meth == NULL)
	{
		fprintf(stderr, "Angaben zur hierarchischen Struktur nicht gefunden!\n");
		exit(1);
	}
	memory(&tree);
	if(vflag) dump_tree(&tree,0);
	hm(&tree, lambda);
	for (i = 1; i < argc; ++i)
	{
		for (j = 1; argv[i][j]; ++j)
		{
			switch (argv[i][j])
			{
				case 'r':
					print_perfK("hm", N, R, K, m, e, mue,
						lambdaK, kmeanK, pK);
					break;
				case 'l':
					print_lambdaK(R, lambdaK);
					break;
				case 'L':
					print_lambda(R, lambda);
					break;
				case 'k':
					print_kmeanK(N, R, kmeanK);
					break;
				case 'K':
					print_kmean(N, R, kmean);
					break;
				case 'p':
					print_p(N, pK, ksize, NULL);
					break;
				case 'P':
					print_p(N, p, psize, NULL);
					break;
				case 'f':
					print_p(N, pK, ksize, m);
					break;
				case 'F':
					print_p(N, p, psize, m);
					break;
				case 'h':
					while (isdigit(argv[i][j + 1]))
						++j;
					break;
			}
		}
	}
	exit(0);
}

void call_error(name)
char *name;
{
	fprintf(stderr, "Aufruf:   %s -rlLkKpPfFvh\n", name);
	fprintf(stderr, "    -r:   Rohdaten ausgeben\n");
	fprintf(stderr, "    -l:   relative Durchsaetze\n");
	fprintf(stderr, "    -L:   lastabhaengige relative Durchsaetze\n");
	fprintf(stderr, "    -k:   mittlere Fuellungen\n");
	fprintf(stderr, "    -K:   lastabhaengige mittlere Fuellungen\n");
	fprintf(stderr, "    -p:   Randwahrscheinlichkeiten aller Knoten rueckwaerts\n");
	fprintf(stderr, "    -P:   lastabhaengige Randwahrscheinlichkeiten aller Knoten rueckwaerts\n");
	fprintf(stderr, "    -f:   Randwahrscheinlichkeiten aller FESC-Knoten rueckwaerts\n");
	fprintf(stderr, "    -F:   lastabhaengige Randwahrscheinlichkeiten aller FESC-Knoten rueckwaerts\n");
	fprintf(stderr, "    -v:   Fortschritte melden\n");
	fprintf(stderr, "    -hn:  Netz der Hierarchiestufe n ausgeben\n");
	exit(1);
}


int h;
double *_lambda[NMAX][RMAX];

void hm(tree, lambda)
struct tree *tree;
double *lambda[RMAX];
{
	int N_, m_[NMAX], typ_[NMAX];
	double e_[NMAX][RMAX], mue_[NMAX][RMAX], *lmue_[NMAX][RMAX];
	double csq_[NMAX][RMAX], ptrans_[RMAX][NMAX + 1][NMAX + 1];
	int make_level();
	void apply_meth();

	N_ = make_level(tree, m_, typ_, csq_, ptrans_, e_, mue_, lmue_, 0);
	apply_meth(tree, N_, m_, typ_, csq_, ptrans_, e_, mue_, lmue_, lambda);
}

int make_level(tree, m_, typ_, csq_, ptrans_, e_, mue_, lmue_, i_)
struct tree *tree;
int m_[NMAX], typ_[NMAX], i_;
double csq_[NMAX][RMAX], ptrans_[RMAX][NMAX + 1][NMAX + 1];
double e_[NMAX][RMAX], mue_[NMAX][RMAX], *lmue_[NMAX][RMAX];
{
	int i, r, kcode, tables(), renu[NMAX + 1], fescflag[NMAX + 1];
	struct tree *ptree;
	void tree_e(), edges(), short_circuit();

	for (ptree = tree; ptree; ptree = ptree->pright)
	{
		if (ptree->pdown)
		{
			if (h >= hmin)
			{
				m_[i_] = FESC;
				if (Nflag)
				{
					for (r = 0; r < R; ++r)
					{
						csq_[i_][r] = 1;
					}
					typ_[i_] = FESC;
				}
				tree_e(ptree->pdown, e_[i_]);
				++h;
				hm(ptree->pdown, lmue_[i_]);
				--h;
				for (kcode = 1; kcode < ksize; ++kcode)
				{
					for (r = 0; r < R; ++r)
					{
						lmue_[i_][r][kcode] *= e_[i_][r];
					}
				}
				i_++;
			}
			else
			{
				++h;
				i_ = make_level(ptree->pdown,
					m_, typ_, csq_, ptrans_, e_, mue_, lmue_, i_);
				--h;
			}
		}
		else
		{
			i = ptree->i;
			m_[i_] = m[i];
			if (Nflag)
			{
				for (r = 0; r < R; ++r)
				{
					csq_[i_][r] = csq[i][r];
				}
				typ_[i_] = typ[i];
			}
			for (r = 0; r < R; ++r)
			{
				e_[i_][r] = e[i][r];
				if (m[i] == FESC)
				{
					lmue_[i_][r] = lmue[i][r];
				}
				else
				{
					mue_[i_][r] = mue[i][r];
				}
			}
			i_++;
		}
	}
	if (Nflag)
	{
		for (i = 0; i <= N; ++i)
		{
			renu[i] = 0;
			fescflag[i] = 0;
		}
		tables(tree, 1, renu, fescflag);
		edges(i_, renu, fescflag, ptrans_, e_);
		short_circuit(i_, renu, ptrans_);
	}
	return(i_);
}

void tree_e(tree, esum)
struct tree *tree;
double esum[RMAX];
{
	int r;
	static int h;

	if (h == 0)
	{
		for (r = 0; r < R; ++r)
		{
			esum[r] = 0;
		}
	}
	for (; tree; tree = tree->pright)
	{
		if (tree->pdown)
		{
			++h;
			tree_e(tree->pdown, esum);
			--h;
		}
		else
		{
			for (r = 0; r < R; ++r)
			{
				esum[r] += e[tree->i][r];
			}
		}
	}
}

int tables(tree, i_, renu, fescflag)
struct tree *tree;
int i_, renu[NMAX + 1], fescflag[NMAX + 1];
{
	void tree_i_();

	for (; tree; tree = tree->pright)
	{
		if (tree->pdown)
		{
			++h;
			if (h > hmin)
			{
				tree_i_(tree->pdown, i_++, renu, fescflag);
			}
			else
			{
				i_ = tables(tree->pdown, i_, renu, fescflag);
			}
			--h;
		}
		else
			renu[tree->i + 1] = i_++;
	}
	return(i_);
}

void tree_i_(tree, i_, renu, fescflag)
struct tree *tree;
int i_, renu[NMAX + 1], fescflag[NMAX + 1];
{
	int i;

	for (; tree; tree = tree->pright)
	{
		if (tree->pdown)
			tree_i_(tree->pdown, i_, renu, fescflag);
		else
		{
			i = tree->i + 1;
			renu[i] = i_;
			fescflag[i] = 1;
		}
	}
}

void edges(i_, renu, fescflag, ptrans_, e_)
int i_, renu[NMAX + 1], fescflag[NMAX + 1];
double ptrans_[RMAX][NMAX + 1][NMAX + 1], e_[NMAX][RMAX];
{
	int r, i, j;

	for (i = 1; i <= N; ++i)
	{
		if (renu[i] == 0)
			renu[i] = ++i_;
	}
	for (r = 0; r < R; ++r)
	{
		for (i = 0; i <= N; ++i)
		{
			for (j = 0; j <= N; ++j)
			{
				ptrans_[r][i][j] = 0;
			}
		}
	}
	for (r = 0; r < R; ++r)
	{
		for (i = 0; i <= N; ++i)
		{
			for (j = 0; j <= N; ++j)
			{
				if (fescflag[i])
				{
					ptrans_[r][renu[i]][renu[j]] +=
						e[i - 1][r] * ptrans[r][i][j] / e_[renu[i] - 1][r];
				}
				else
				{
					ptrans_[r][renu[i]][renu[j]] += ptrans[r][i][j];
				}
			}
		}
	}
}

void short_circuit(N_, renu, ptrans_)
int N_, renu[NMAX + 1];
double ptrans_[RMAX][NMAX + 1][NMAX + 1];
{
	int jr, i, j, k, r;
	double leave;

	for (jr = 1; jr <= N; ++jr)
	{
		if (renu[jr] > N_)
		{
			j = renu[jr];
			for (r = 0; r < R; ++r)
			{
				leave = 1 - ptrans_[r][j][j];
				for (i = 0; i <= N; ++i)
				{
					if (i != j)
					{
						for (k = 0; k <= N; ++k)
						{
							if (k != j)
								ptrans_[r][i][k] +=
									ptrans_[r][i][j] * ptrans_[r][j][k] / leave;
						}
					}
				}
				for (i = 0; i <= N; ++i)
					ptrans_[r][i][j] = 0;
			}
		}
	}
}

void apply_meth(tree, N_, m_, typ_, csq_, ptrans_, e_, mue_, lmue_, lambda)
struct tree *tree;
int N_, m_[NMAX], typ_[NMAX];
double csq_[NMAX][RMAX], ptrans_[RMAX][NMAX + 1][NMAX + 1];
double e_[NMAX][RMAX], mue_[NMAX][RMAX], *lmue_[NMAX][RMAX];
double *lambda[RMAX];
{
	char cmdstr[2048], c;
	int i, r, first_i(), p2open();
	void foutput(), finputlmuei(), perror(), p1close(), p2close();
	void fscan_kmeanK(), fscan_kmean(), fscan_p(), fscan_pK();


	if (hflag && h == 0)
	{
		if (Nflag)
			foutput(stdout, N_, R, K, m_, typ_, csq_, ptrans_, NULL,
				mue_, lmue_, tree, hmin);
		else
			foutput(stdout, N_, R, K, m_, NULL, NULL, NULL, e_,
				mue_, lmue_, tree, hmin);
		fflush(stdout);
		if (hflag == oflag)
		{
			exit(0);
		}
	}
	sprintf(cmdstr, "%s/bin2/verfahren//%s.prog %s%s%s%s", PEPSYHOME, tree->meth, vflag ? "-v" : "",
		h > 0 || Lflag ? " -L" : lflag ? " -l" : "",
		kflag ? h > 0 || Kflag ? " -K" : " -k" : "",
		pflag ? h > 0 || Fflag ? " -P" : " -p" : fflag ? h > 0 || Fflag ? " -F" : " -f" : "");
	if(vflag)
		fprintf(stderr,"hm: apply_meth %s, command %s\n",
			tree->meth, cmdstr);
	if (p2open(cmdstr))
	{
		perror("p2open");
		exit(1);
	}
	if (Nflag)
		foutput(stdout, N_, R, K, m_, typ_, csq_, ptrans_, NULL,
			mue_, lmue_, NULL);
	else
		foutput(stdout, N_, R, K, m_, NULL, NULL, NULL, e_,
			mue_, lmue_, NULL);
	p1close();
/*
	while(scanf("%c",&c) != EOF) fprintf(stderr,"%c",c);
*/
	if (scanf(" %c", &c) == EOF)
	{
		fprintf(stderr,"error in last meth %s\n",tree->meth);
		exit(1);
	}
	ungetc(c, stdin);
	if (h > 0 || Lflag)
	{
		i = h == 0 ? 0 : first_i(tree);
		for (r = 0; r < R; ++r)
			lambda[r] = _lambda[i][r];
		finputlmuei(stdin, R, lambda);
		if (h == 0)
			for (r = 0; r < R; ++r)
				lambdaK[r] = lambda[r][ksize - 1];
	}
	else if (lflag)
	{
		for (r = 0; r < R; ++r)
			scanf("%lf", &lambdaK[r]);
	}
	if (kflag)
	{
		if (h > 0 || Kflag)
		{
			fscan_kmean(stdin, tree);
			if (h == 0)
				for (i = 0; i < N; ++i)
					for (r = 0; r < R; ++r)
						kmeanK[i][r] = kmean[i][r][ksize - 1];
		}
		else
			fscan_kmeanK(stdin, tree);
	}
	if (fflag)
	{
		if (h > 0 || Fflag)
			fscan_p(stdin, tree);
		else
			fscan_pK(stdin, tree);
	}
	p2close();
}

int first_i(tree)
struct tree *tree;
{
	while (tree->pdown)
		tree = tree->pdown;
	return(tree->i);
}
