static char *SccsId = "@(#)PEPSY:\tinputhm.c\t1.3\t93/05/14 15:41:20";
#include <stdio.h>
#include "const+type.h"

extern int ksize, psize;
extern int R, K[RMAX];
extern int krsize[RMAX], *pp;
extern double kmeanK[NMAX][RMAX], *pK[NMAX];
extern double *kmean[NMAX][RMAX], *p[NMAX];

static int k[RMAX], kcode, j[RMAX], jcode, l[RMAX];
static double pFESC;

void fscan_kmeanK(fp, tree)
FILE *fp;
struct tree *tree;
{
	int i, r;

	for (; tree; tree = tree->pright)
	{
		if (tree->pdown)
		{
			for (r = 0; r < R; ++r)
			{
				fscanf(fp, "%*lf");
			}
		}
		else
		{
			i = tree->i;
			for (r = 0; r < R; ++r)
			{
				fscanf(fp, "%lf", &kmeanK[i][r]);
			}
		}
	}
}

void fscan_kmean(fp, tree)
FILE *fp;
struct tree *tree;
{
	int i, r;

	for (; tree; tree = tree->pright)
	{
		if (tree->pdown)
		{
			for (kcode = 1; kcode < ksize; ++kcode)
			{
				for (r = 0; r < R; ++r)
				{
					fscanf(fp, "%*lf");
				}
			}
		}
		else
		{
			i = tree->i;
			for (kcode = 1; kcode < ksize; ++kcode)
			{
				for (r = 0; r < R; ++r)
				{
					fscanf(fp, "%lf", &kmean[i][r][kcode]);
				}
			}
		}
	}
}

void fscan_pK(fp, tree)
FILE *fp;
struct tree *tree;
{
	int i, r;
	void tree_parseK();

	for (; tree; tree = tree->pright)
	{
		if (tree->pdown)
		{
			for (jcode = kcode = ksize - 1; jcode >= 0; --jcode)
			{
				for (r = R - 1; r >= 0; --r)
				{
					if (--j[r] < 0)
					{
						j[r] = K[r];
					}
					else
						break;
				}
				fscanf(fp, "%lf", &pFESC);
				tree_parseK(tree->pdown);
			}
		}
		else
		{
			i = tree->i;
			if (pK[i])
			{
				for (jcode = ksize - 1; jcode >= 0; --jcode)
				{
					fscanf(fp, "%lf", &pK[i][jcode]);
				}
			}
		}
	}
}

void tree_parseK(tree)
struct tree *tree;
{
	int i, r, pjcode, pkcode;

	for (; tree; tree = tree->pright)
	{
		if (tree->pdown)
		{
			tree_parseK(tree->pdown);
		}
		else
		{
			i = tree->i;
			for (r = 0; r < R; ++r)
			{
				if (jcode == kcode)
				{
					kmeanK[i][r] = kmean[i][r][jcode] * pFESC;
				}
				else
				{
					kmeanK[i][r] += kmean[i][r][jcode] * pFESC;
				}
			}
			if (p[i])
			{
				for (pjcode = pp[jcode], pkcode = 0;; ++pjcode)
				{
					if (jcode == kcode)
					{
						pK[i][pkcode] = p[i][pjcode] * pFESC;
					}
					else
					{
						pK[i][pkcode] += p[i][pjcode] * pFESC;
					}

					for (r = R - 1; r >= 0; --r)
					{
						if (++l[r] > j[r])
						{
							l[r] = 0;
							pkcode -= j[r] * krsize[r];
						}
						else
						{
							pkcode += krsize[r];
							break;
						}
					}
					if (r < 0)
						break;
				}
			}
		}
	}
}

static void tree_parse(tree)
struct tree *tree;
{
	int i, r, pjcode, pkcode, jrsize;

	for (; tree; tree = tree->pright)
	{
		if (tree->pdown)
		{
			tree_parse(tree->pdown);
		}
		else
		{
			i = tree->i;
			for (r = 0; r < R; ++r)
			{
				if (jcode == kcode)
				{
					kmean[i][r][kcode] = kmean[i][r][jcode] * pFESC;
				}
				else
				{
					kmean[i][r][kcode] += kmean[i][r][jcode] * pFESC;
				}
			}
			if (p[i])
			{
				for (pjcode = pp[jcode], pkcode = pp[kcode];; ++pjcode)
				{
					if (jcode == kcode)
					{
						p[i][pkcode] = p[i][pjcode] * pFESC;
					}
					else
					{
						p[i][pkcode] += p[i][pjcode] * pFESC;
					}

					jrsize = 1;
					for (r = R - 1; r >= 0; --r)
					{
						if (++l[r] > j[r])
						{
							l[r] = 0;
							pkcode -= j[r] * jrsize;
							jrsize *= k[r] + 1;
						}
						else
						{
							pkcode += jrsize;
							break;
						}
					}
					if (r < 0)
						break;
				}
			}
		}
	}
}
void fscan_p(fp, tree)
FILE *fp;
struct tree *tree;
{
	int i, pcode, r;
	void tree_parse();

	for (; tree; tree = tree->pright)
	{
		if (tree->pdown)
		{
			for (kcode = ksize, jcode = 0;;)
			{
				if (jcode == 0)
				{
					if (--kcode < 0)
						break;

					for (r = R - 1; r >= 0; --r)
					{
						if (--k[r] < 0)
						{
							k[r] = K[r];
						}
						else
						{
							break;
						}
					}
				}
				for (r = R - 1; r >= 0; --r)
				{
					if (--j[r] < 0)
					{
						j[r] = k[r];
						jcode += k[r] * krsize[r];
					}
					else
					{
						jcode -= krsize[r];
						break;
					}
				}
				fscanf(fp, "%lf", &pFESC);
				tree_parse(tree->pdown);
			}
		}
		else
		{
			i = tree->i;
			if (p[i])
			{
				for (pcode = psize - 1; pcode >= 0; --pcode)
				{
					fscanf(fp, "%lf", &p[i][pcode]);
				}
			}
		}
	}
}

