static char *SccsId = "@(#)PEPSY:\tmemhm.c\t1.6\t94/02/10 15:42:01";
#include <stdio.h>
/* #include <values.h> ersetzt durch MAXINT-define	kirschni */
#include "const+type.h"

#ifndef MAXINT
#define	MAXINT	((int)(~((unsigned)1<<((8*(int)sizeof(int))-1))))
#endif

extern int fflag, Fflag, pflag;
extern int N, R, K[RMAX], m[NMAX];
extern double *pK[NMAX];
extern double *lambda[RMAX];
extern double *kmean[NMAX][RMAX], *p[NMAX];
extern double *_lambda[NMAX][RMAX];

extern void stor_error(), tree_NpMarg(), tree_mem();

int ksize, psize, krsize[RMAX], *pp;

static int NpMargK, NpMarg, k[RMAX], kcode;

char *malloc();

void memory(tree)
struct tree *tree;
{
	double dksize, dpsize;
	int i, r, jsize;

	dksize = 1;
	dpsize = 1;
	for (r = 0; r < R; ++r)
	{
		dksize *= K[r] + 1;
		dpsize *= (K[r] + 1) * (K[r] + 2) / 2;
	}
	tree_NpMarg(tree);
	if (((2 * N * R + NpMargK) * dksize + NpMarg * dpsize)
		* sizeof(double) > MAXINT)
	{
		stor_error();
	}
	ksize = dksize;
	if (dpsize <= MAXINT)
		psize = dpsize;
	kmean[0][0] = (double *)malloc(N * R * ksize * sizeof(double));
	_lambda[0][0] = (double *)malloc(N * R * ksize * sizeof(double));
	if (_lambda[0][0] == NULL)
		stor_error();
	tree_mem(tree);
	if (NpMarg && (pp = (int *)malloc(ksize * sizeof(int))) == NULL)
		stor_error();
	for (i = 0; i < N; ++i)
	{
		for (r = 0; r < R; ++r)
		{
			_lambda[i][r] = _lambda[0][0] + (i * R + r) * ksize;
			kmean[i][r] = kmean[0][0] + (i * R + r) * ksize;
		}
	}
	krsize[R - 1] = 1;
	for (r = R - 2; r >= 0; --r)
	{
		krsize[r] = krsize[r + 1] * (K[r + 1] + 1);
	}
	if (NpMarg)
	{
		pp[0] = 0;
		for (kcode = 1;; ++kcode)
		{
			jsize = 1;
			for (r = 0; r < R; ++r)
			{
				jsize *= k[r] + 1;
			}

			for (r = R - 1; r >= 0; --r)
			{
				if (++k[r] > K[r])
				{
					k[r] = 0;
				}
				else
					break;
			}
			if (r < 0)
				break;

			pp[kcode] = pp[kcode - 1] + jsize;
		}
	}
}

void tree_NpMarg(tree)
struct tree *tree;
{
	static int h;
	int i;

	for (; tree; tree = tree->pright)
	{
		if (tree->pdown)
		{
			++h;
			tree_NpMarg(tree->pdown);
			--h;
		}
		else
		{
			i = tree->i;
			if (pflag || (fflag && m[i] == FESC))
			{
				if (h > 0 || Fflag)
					++NpMarg;
				else
					++NpMargK;
			}
		}
	}
}

void tree_mem(tree)
struct tree *tree;
{
	static int h;
	int i;

	for (; tree; tree = tree->pright)
	{
		if (tree->pdown)
		{
			++h;
			tree_mem(tree->pdown);
			--h;
		}
		else
		{
			i = tree->i;
			if (pflag || (fflag && m[i] == FESC))
			{
				if (h > 0 || Fflag)
				{
					p[i] = (double *)malloc(psize * sizeof(double));
					if (p[i] == NULL)
						stor_error();
					pK[i] = p[i] + psize - ksize;
				}
				else
				{
					pK[i] = (double *)malloc(ksize * sizeof(double));
					if (pK[i] == NULL)
						stor_error();
				}
			}
		}
	}
}
