#include <ctype.h>
#include <stdio.h>
#include <string.h>
#define  DEFINITIONS
#include "const+type.h"

static char *SccsId = "@(#)PEPSY:\tinput.c\t1.2\t92/03/27 11:42:22";

extern int ksize, vflag;

void stor_error()
{
	fprintf(stderr, "Zu viele Auftraege, Speicherplatz fehlt\n");
	exit(1);
}

void fscan_over_comment(fp) /* scans from the actual position over blanks, */
register FILE *fp;          /* over blank lines and over the characters    */
{                           /* between # and '\n'                          */
	int c;

	while (fscanf(fp, " #%c", &c) == 1)
		if (c != '\n')
			fscanf(fp, "%*[^\n]");
}

void fgetname(tmpstr, len, fp)
char tmpstr[];
int len;
FILE *fp;
{
	int c, i;

	while (isspace(c = fgetc(fp)))
	{
	}
	ungetc(c,fp);
	for (i = 0; i < len; ++i)
	{
		if(!isspace(c = fgetc(fp)))
		{
			tmpstr[i] = c;
		}
		else
			break;
	}
	tmpstr[i] = '\0';
	if (i == len)
	{
		tmpstr[len - 1] = '\0';
		fprintf(stderr, "Name zu lang: '%s'\n", tmpstr);
		exit(1);
	}
}

int finput(fp, pN, pR, K, m, typ, csq, ptrans, e, mue, lmue, tree)
FILE *fp;
int *pN, *pR, K[RMAX], m[NMAX], typ[NMAX];
double csq[NMAX][RMAX], ptrans[RMAX][NMAX + 1][NMAX + 1];
double e[NMAX][RMAX], mue[NMAX][RMAX], *lmue[NMAX][RMAX];
struct tree *tree;
{
	char typstr[METH_LEN];
	int N, R, Nflag;
	void finputdim(), lmue_memory();
	void finput_e(), finput_tcp(), ptoe(), finputrest();

	finputdim(fp, pN, pR, K, m);
	N = *pN;
	R = *pR;
	if(vflag > 3)
		fprintf(stderr,"finput: N = %d, R = %d\n",N,R);
	lmue_memory(N, R, m, lmue);
	fscan_over_comment(fp);
    if (Nflag = !isdigit(ungetc(getc(fp), fp)))
	{
		if (ptrans == NULL)
		{
			int typ1[NMAX]; 
			double csq1[NMAX][RMAX], ptrans1[RMAX][NMAX + 1][NMAX + 1];
			if(vflag > 3)
				fprintf(stderr,"finput: calling finput_tcp (1) ...\n");

			finput_tcp(fp, N, R, typ1, csq1, ptrans1);
			ptoe(N, R, e, ptrans1);
			Nflag = 0;
		}
		else
		{
			if(vflag > 3)
				fprintf(stderr,"finput: calling finput_tcp (2) ...\n");
			finput_tcp(fp, N, R, typ, csq, ptrans);
			if (e)
				ptoe(N, R, e, ptrans);
		}
	}
	else
	{
		if(vflag > 3)
			fprintf(stderr,"finput: calling finput_e ...\n");
		finput_e(fp, N, R, e);
	}
	if(vflag > 3)
		fprintf(stderr,"finput: calling finput_rest ...\n");
	finputrest(fp, N, R, m, mue, lmue, tree);
	if(vflag > 3)
		fprintf(stderr,"finput: Nflag = %d\n",Nflag);
	return(Nflag != 0);
}

void finputdim(fp, pN, pR, K, m)
FILE *fp;
int *pN, *pR, K[RMAX], m[NMAX];
{
	int N, R, i, r;

	fscan_over_comment(fp);
	fscanf(fp, "%d", pN);
	N = *pN;
	fscan_over_comment(fp);
	fscanf(fp, "%d", pR);
	R = *pR;
	ksize = 1;
	for (r = 0; r < R; ++r)
	{
		fscan_over_comment(fp);
		fscanf(fp, "%d", &K[r]);
		ksize *= K[r] + 1;
	}
	for (i = 0; i < N; ++i)
	{
		fscan_over_comment(fp);
		fscanf(fp, "%d", &m[i]);
	}
}

void lmue_memory(N, R, m, lmue)
int N, R, m[NMAX];
double *lmue[NMAX][RMAX];
{
	char *malloc();
	int i, r, Nlmue;
	double *p;

	Nlmue = 0;
	for (i = 0; i < N; ++i)
	{
		if (m[i] == FESC)
			++Nlmue;
	}
	if (Nlmue)
	{
		p = (double *)malloc(Nlmue * R * ksize * sizeof(double));
		if (p == NULL)
			stor_error();
		for (i = 0; i < N; ++i)
		{
			if (m[i] == FESC)
			{
				for (r = 0; r < R; ++r)
				{
					lmue[i][r] = p;
					p += ksize;
				}
			}
		}
	}
}

void finput_e(fp, N, R, e)
FILE *fp;
int N, R;
double e[NMAX][RMAX];
{
	int i, r;

	for (i = 0; i < N; ++i)
	{
		for (r = 0; r < R; ++r)
		{
			fscan_over_comment(fp);
			fscanf(fp, "%lf", &e[i][r]);
		}
	}
}

void finput_tcp(fp, N, R, typ, csq, ptrans)
FILE *fp;
int N, R, typ[NMAX];
double csq[NMAX][RMAX], ptrans[RMAX][NMAX + 1][NMAX + 1];
{
	char typstr[METH_LEN];
	int i, j, r;

	for (i = 0; i < N; ++i)
	{
		fscan_over_comment(fp);
		fgetname(typstr, METH_LEN, fp);
		for (j = 0; j < sizeof(TYP) / sizeof(char *); ++j)
		{
			if (strcmp(typstr, TYP[j]) == 0)
			{
				typ[i] = j - 1;
				break;
			}
		}
		if(vflag > 3)
			fprintf(stderr,"finput_tcp: Knoten %d, Strat %s\n",i+1,typstr);
		if (j == sizeof(TYP) / sizeof(char *))
		{
			fprintf(stderr, "Bedienstrategie '%s' unbekannt\n", typstr);
			exit(1);
		}
	}
	if(vflag > 3)
		fprintf(stderr,"finput_tcp: reading csq\n");
	for (i = 0; i < N; ++i)
	{
		for (r = 0; r < R; ++r)
		{
			fscan_over_comment(fp);
			fscanf(fp, "%lf", &csq[i][r]);
		}
	}
	if(vflag > 3)
		fprintf(stderr,"finput_tcp: reading ptrans\n");
	for (r = 0; r < R; ++r)
	{
		for (i = 0; i <= N; ++i)
		{
			for (j = 0; j <= N; ++j)
			{
				fscan_over_comment(fp);
				fscanf(fp, "%lf", &ptrans[r][i][j]);
			}
		}
	}
}

void finputlmuei(fp, R, lmuei)
FILE *fp;
int R;
double *lmuei[RMAX];
{
	int r, kcode, cflag;
	double val;

	cflag = 0;
	for (kcode = 1; kcode < ksize; ++kcode)
	{
		for (r = 0; r < R; ++r)
		{
			if (cflag)
			{
				lmuei[r][kcode] = val;
			}
			else
			{
				fscan_over_comment(fp);
				if(fscanf(fp, "%lf", &val) == EOF)
				{
					fprintf(stderr,"finputlmuei: unexpected eof\n");
					exit(1);
				}
				if (val < 0)
				{
					cflag = 1;
					val = lmuei[r][kcode - 1];
				}
				lmuei[r][kcode] = val;
				if(vflag > 3)
					fprintf(stderr,"finputlmuei: %lg\n",lmuei[r][kcode]);
			}
		}
	}
}

void finputrest(fp, N, R, m, mue, lmue, tree)
FILE *fp;
int N, R, m[NMAX];
double mue[NMAX][RMAX], *lmue[NMAX][RMAX];
struct tree *tree;
{
	int i, r;
	void finputlmuei(), fgettree();

	if(vflag > 3)
		fprintf(stderr,"finput_rest: calling finputmue\n");
	for (i = 0; i < N; ++i)
	{
		if (m[i] == FESC)
		{
			finputlmuei(fp, R, lmue[i]);
		}
		else
		{
			for (r = 0; r < R; ++r)
			{
				fscan_over_comment(fp);
				fscanf(fp, "%lf", &mue[i][r]);
			}
		}
	}
	if(vflag > 3)
		fprintf(stderr,"finput_rest: calling fgettree\n");
	if (tree)
	{
		fscan_over_comment(fp);
		fgettree(tree, fp);
	}
}

void mem_error()
{
	fprintf(stderr, "Baum-Eingabe: Speicherplatz fehlt\n");
	exit(1);
}

void fgettree(tree, fp)
struct tree *tree;
FILE *fp;
{
	char c[2], tmpstr[METH_LEN], *malloc();
	int i, cflag;

	if(vflag > 3)
		fprintf(stderr,"fgettree: \n");
		
	if (fscanf(fp, "%1s", c) != 1)
		return;
	if (c[0] != '(')
	{
		ungetc(c[0], fp);
		return;
	}
	fgetname(tmpstr, METH_LEN, fp);
	if ((tree->meth = (char *) malloc(strlen(tmpstr) + 1)) == NULL)
		mem_error();
	if(vflag > 3)
		fprintf(stderr,"fgettree: %s\n",tmpstr);
	strcpy(tree->meth, tmpstr);
	for (cflag = 0;; cflag++)
	{
		if (fscanf(fp, "%d", &i) == 1)
		{
			if (cflag && (tree = tree->pright = (struct tree *)malloc(sizeof(struct tree))) == NULL)
				mem_error();
			tree->i = i - 1;
			tree->pdown = NULL;
		}
		else if (fscanf(fp, "%1s", c), c[0] == '(')
		{
			if (cflag && (tree = tree->pright = (struct tree *)malloc(sizeof(struct tree))) == NULL)
				mem_error();
			if ((tree->pdown = (struct tree *)malloc(sizeof(struct tree))) == NULL)
				mem_error();
			ungetc('(', fp);
			fgettree(tree->pdown, fp);
		}
		else
			break;
	}
	tree->pright = NULL;
}

dump_tree(tree,level)
struct tree *tree;
int level;
{
	/* Ausgabe des Hierarchie Baumes */

	if(tree->pdown != NULL)
	{
		dump_tree(tree->pdown,level+1);
	}
	if(tree->pright != NULL)
	{
		dump_tree(tree->pright,level);
	}
	if(tree->meth != NULL)
		fprintf(stderr,"level %d, method %s \n",level,tree->meth);
}
