static char *SccsId = "@(#)PEPSY:\tna.c\t1.7\t95/05/22 10:00:21";
#include <ctype.h>
#include <stdio.h>
#include <string.h>
/* #include <values.h>	MAXINT per define */
#include <signal.h>
#include "const+type.h"
#include "d_debug.h"

#define TAIL(path) (strrchr(path, '/') ? strrchr(path, '/') + 1 : path)

#ifndef MAXINT
#define	MAXINT	((int)(~((unsigned)1<<((8*(int)sizeof(int))-1))))
#endif

int dbg;

int ksize, psize, krsize[RMAX];

int N, R, K[RMAX], m[NMAX], typ[NMAX], iR[NMAX], nq[NMAX];
double e[NMAX][RMAX], mue[NMAX][RMAX], *lmue[NMAX][RMAX];
double csq[NMAX][RMAX], ptrans[RMAX][NMAX + 1][NMAX + 1];
double *lambda[RMAX], *kmean[NMAX][RMAX];
double *p[NMAX];

double lambdaK[RMAX], kmeanK[NMAX][RMAX];
double *pK[NMAX];

int ph_flag[NMAX];
double esum[RMAX], mrho[NMAX][RMAX];

int Lflag, Kflag, fflag, Fflag, pflag, vflag, Gflag, sflag, iflag, oflag;
int VerfahrensIndex, Iterationen;

extern int atoi();

void sig_catch()
{
	kill(SIGKILL,0);
}

int main(argc, argv)
int argc;
char *argv[];
{
    /*		Sccs support from SccsLogging.c			*/	
    extern int SccsRelease;
    extern int SccsLevel;

    int c;
    extern char *optarg;
    extern int optind;
    int i, j, Nflag, finput();
    void call_error(), memory(), na(), set_K();
    void print_perfK(), print_lambdaK(), print_lambda();
    void print_kmeanK(), print_kmean(), print_p();

    for(i=0;i<30;i++)
	signal(i,(void (*)())sig_catch);


    while ((c = getopt(argc, argv, "VrlLkKpPfFvGd:s:i:")) != EOF)
    {
	switch (c)
	{
	case 'V':		/* kirschni  22.11.1991 */
	    fprintf(stdout, "%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
	    exit(0);
	    break;
	case 'd':
	    dbg=atoi(optarg);
	    break;
	case 'r':
	case 'l':
	case 'k':
	    break;
	case 'L':
	    ++Lflag;
	    break;
	case 'K':
	    ++Kflag;
	    break;
	case 'P':
	    ++pflag;
	case 'F':
	    ++Fflag;
	case 'f':
	    ++fflag;
	    break;
	case 'p':
	    ++pflag;
	    ++fflag;
	    break;
	case 'v':
	    ++vflag;
	    break;
	case 'G':
	    ++Gflag;
	    break;
	case 's':
	    ++sflag;
	    VerfahrensIndex = atoi(optarg);
	    break;
	case 'i':
	    ++iflag;
	    Iterationen = atoi(optarg);
	    break;
	default:
	    call_error("num");
	    break;
	}
	++oflag;
    }
    if (optind < argc)
	call_error("num");
    if (Gflag && (Lflag || Kflag || Fflag))
    {
	fprintf(stderr, "Kombination von -G mit -L, -K, -F oder -P unsinnig\n");
	exit(1);
    }
    oflag -= vflag + Gflag + sflag + iflag;
    if (oflag == 0)
	call_error("num");
    Nflag = finput(stdin, &N, &R, K, m, typ, csq, ptrans, e, mue, lmue, NULL);

    dbginfo3(1, "%s: N=%d R=%d ", argv[0], N, R); 
    for (i=0; i<R; i++)
	dbginfo2(1, "K[%d]=%d ", i, K[i]);
    for (i=0; i<N; i++)
	dbginfo2(1, "m[%d]=%d ", i, m[i]);
    dbgtext(1, "\n");
	
    if (Nflag == 0)
    {
	fprintf(stderr, "Eingabe mit Uebergangswahrscheinlichkeiten erwartet!\n");
	exit(1);
    }
    memory();
    na();
    if (Lflag || Kflag || Fflag)
	set_K();
    for (i = 1; i < argc; ++i)
    {
	for (j = 1; argv[i][j]; ++j)
	{
	    switch (argv[i][j])
	    {
	    case 'r':
		print_perfK("num", N, R, K, m, e, mue,
			    lambdaK, kmeanK, pK);
		break;
	    case 'l':
		print_lambdaK(R, lambdaK);
		break;
	    case 'L':
		print_lambda(R, lambda);
		break;
	    case 'k':
		print_kmeanK(N, R, kmeanK);
		break;
	    case 'K':
		print_kmean(N, R, kmean);
		break;
	    case 'p':
		print_p(N, pK, ksize, NULL);
		break;
	    case 'P':
		print_p(N, p, psize, NULL);
		break;
	    case 'f':
		print_p(N, pK, ksize, m);
		break;
	    case 'F':
		print_p(N, p, psize, m);
		break;
	    case 's':
	    case 'i':
		if (isdigit(argv[i][j + 1]) == '\0')
		    ++i;
		j = strlen(argv[i]) - 1;
		break;
	    }
	}
    }
    exit(0);
}

void call_error(name)
char *name;
{
	fprintf(stderr, "Aufruf:   %s -rlLkKpPfFvGsi\n", name);
	fprintf(stderr, "    -r:   Rohdaten ausgeben\n");
	fprintf(stderr, "    -l:   relative Durchsaetze\n");
	fprintf(stderr, "    -L:   lastabhaengige relative Durchsaetze\n");
	fprintf(stderr, "    -k:   mittlere Fuellungen\n");
	fprintf(stderr, "    -K:   lastabhaengige mittlere Fuellungen\n");
	fprintf(stderr, "    -p:   Randwahrscheinlichkeiten aller Knoten rueckwaerts\n");
	fprintf(stderr, "    -P:   lastabhaengige Randwahrscheinlichkeiten aller Knoten rueckwaerts\n");
	fprintf(stderr, "    -f:   Randwahrscheinlichkeiten aller FESC-Knoten rueckwaerts\n");
	fprintf(stderr, "    -F:   lastabhaengige Randwahrscheinlichkeiten aller FESC-Knoten rueckwaerts\n");
	fprintf(stderr, "    -v:   Fortschritte melden\n");
	fprintf(stderr, "    -G:   Datei Gleichgewicht nicht neu berechnen\n");
	fprintf(stderr, "    -d:   Debugging einschalten (z.B. -d 100)\n");
	fprintf(stderr, "    -sn:  Verfahren n verwenden (siehe nu)\n");
	fprintf(stderr, "    -in:  Anzahl der Iterationen (siehe nu)\n");
	exit(1);
}

void set_K()
{
	int i, r;

	for (r = 0; r < R; ++r)
	{
		lambdaK[r] = lambda[r][ksize - 1];
	}
	for (i = 0; i < N; ++i)
	{
		for (r = 0; r < R; ++r)
		{
			kmeanK[i][r] = kmean[i][r][ksize - 1];
		}
		if (p[i])
		{
			pK[i] = p[i] + psize - ksize;
		}
	}
}

void memory()
{
	char *malloc();
	int i, r, NpMarg;
	double dksize, dpsize, *p_Marg;
	void stor_error();

	dksize = 1;
	dpsize = 1;
	for (r = 0; r < R; ++r)
	{
		dksize *= K[r] + 1;
		dpsize *= (K[r] + 1) * (K[r] + 2) / 2;
	}
	NpMarg = 0;
	for (i = 0; i < N; ++i)
		if (pflag || (fflag && m[i] == FESC))
			++NpMarg;
	if ((((Lflag > 0) + (Kflag > 0) * N) * R * dksize +
		NpMarg * (Fflag ? dpsize : dksize)) * sizeof(double) > MAXINT)
	{
		stor_error();
	}
	if (dksize <= MAXINT)
		ksize = dksize;
	if (dpsize <= MAXINT)
		psize = dpsize;
	if (Lflag)
	{
		if ((lambda[0] = (double *)malloc(R * ksize * sizeof(double))) == NULL)
			stor_error();
		for (r = 0; r < R; ++r)
			lambda[r] = lambda[0] + r * ksize;
	}
	if (Kflag)
	{
		if ((kmean[0][0] = (double *)malloc(N * R * ksize * sizeof(double))) == NULL)
		{
			stor_error();
		}
		for (i = 0; i < N; ++i)
			for (r = 0; r < R; ++r)
				kmean[i][r] = kmean[0][0] + (i * R + r) * ksize;
	}
	if (NpMarg)
	{
		if ((p_Marg = (double *)malloc(NpMarg *
			(Fflag ? psize : ksize) * sizeof(double))) == NULL)
		{
			stor_error();
		}
		for (i = 0; i < N; ++i)
		{
			if (pflag || m[i] == FESC)
			{
				if (Fflag)
				{
					p[i] = p_Marg;
					p_Marg += psize;
				}
				else
				{
					pK[i] = p_Marg;
					p_Marg += ksize;
				}
			}
		}
	}
}

char nucall[50], indexstr[20], iterstr[20];

void na_k()
{
	FILE *fp;
	void foutput(), nuperf();

	if (Gflag == 0)
	{
		sprintf(nucall, "nu -ce%s%s%s", vflag ? "v" : "", indexstr, iterstr);
		if (vflag)
			fprintf(stderr, "%s\n", nucall);
		if ((fp = popen(nucall, "w")) == NULL)
		{
			fprintf(stderr, "popen error\n");
			exit(1);
		}
		foutput(fp, N, R, K, m, typ, csq, ptrans, NULL, mue, lmue, NULL);
		pclose(fp);
	}
	nuperf();
}

void na1_k()
{
	FILE *fp;
	void foutput();

	sprintf(nucall, "nu -cK%s", vflag ? "v" : "");
	if (vflag)
		fprintf(stderr, "%s\n", nucall);
	if ((fp = popen(nucall, "w")) == NULL)
	{
		fprintf(stderr, "popen error\n");
		exit(1);
	}
	foutput(fp, N, R, K, m, typ, csq, ptrans, NULL, mue, lmue, NULL);
	pclose(fp);
	if (vflag)
		fprintf(stderr, "\n");
}

void na2_k()
{
	FILE *fp;
	int r;
	void nuperf();

	sprintf(nucall, "nu -e%s%s%s", vflag ? "v" : "", indexstr, iterstr);
	if (vflag)
		fprintf(stderr, "%s\n", nucall);
	if ((fp = popen(nucall, "w")) == NULL)
	{
		fprintf(stderr, "popen error\n");
		exit(1);
	}
	for (r = 0; r < R; ++r)
		fprintf(fp, " %d", K[r]);
	pclose(fp);
	if (vflag)
		fprintf(stderr, "\n");
	nuperf();
}

void na()
{
	int i, r, jsize, kcode, Ksum;
	int k[RMAX];
	void na_k(), na1_k(), na2_k();

	for (i = 0; i < N; ++i)
	{
		nq[i] = -m[i];
		for (r = 0; r < R; ++r)
		{
			if (e[i][r])
			{
				iR[i]++;
				nq[i] += K[r];
				esum[r] += e[i][r];
			}
			if (csq[i][r] != 1)
				ph_flag[i] = 1;
		}
		if (typ[i] == IS || nq[i] < 0)
			nq[i] = 0;
	}
	krsize[R - 1] = K[R - 1] + 1;
	for (r = R - 2; r >= 0; --r)
		krsize[r] = krsize[r + 1] * (K[r] + 1);
	if (sflag)
		sprintf(indexstr, " -s%d", VerfahrensIndex);
	if (iflag)
		sprintf(iterstr, " -i%d", Iterationen);
	if (Lflag == 0 && Kflag == 0 && Fflag == 0)
	{
		na_k();
		return;
	}
	na1_k();
	Ksum = 0;
	for (r = 0; r < R; ++r)
		Ksum += k[r] = K[r];
	for (i = 0; i < N; ++i)
	{
		if (Fflag && (pflag || m[i] == FESC))
		{
			p[i][0] = 1;
			pK[i] = p[i] + psize;
		}
	}
	for (kcode = ksize - 1; Ksum > 0; --kcode)
	{
		jsize = 1;
		for (r = 0; r < R; ++r)
			jsize *= K[r] + 1;
		for (i = 0; i < N; ++i)
			if (Fflag && (pflag || m[i] == FESC))
				pK[i] -= jsize;
		na2_k();
		if (Lflag)
			for (r = 0; r < R; ++r)
				lambda[r][kcode] = lambdaK[r];
		if (Kflag)
			for (i = 0; i < N; ++i)
				for (r = 0; r < R; ++r)
					kmean[i][r][kcode] = kmeanK[i][r];

		for (r = R - 1; r >= 0; --r)
		{
			if (--K[r] < 0)
			{
				K[r] = k[r];
				Ksum += K[r];
			}
			else
			{
				--Ksum;
				break;
			}
		}
	}
	for (r = 0; r < R; ++r)
		K[r] = k[r];
}
