static char *SccsId = "@(#)PEPSY:\tnuperf.c\t1.3\t93/06/25 16:13:19";
#include <stdio.h>
#include <math.h>
#include <string.h>
/* #include <values.h>	*/
#include "const+type.h"

extern int ksize, krsize[RMAX];

extern int N, R, K[RMAX], m[NMAX], typ[NMAX], iR[NMAX], nq[NMAX];
extern double e[NMAX][RMAX], mue[NMAX][RMAX], *lmue[NMAX][RMAX];
extern double csq[NMAX][RMAX];

extern double lambdaK[RMAX], kmeanK[NMAX][RMAX];
extern double *pK[NMAX];

extern int ph_flag[NMAX];
extern double esum[RMAX], mrho[NMAX][RMAX];

char co_dat[] = "Codierung";
char eq_dat[] = "Gleichgewicht";

extern int pflag, fflag;

double pstate;
FILE *co, *eq;

void nuperf()
{
	int i, r;
	void perf1(), perf2();

	if ((co = fopen(co_dat, "r")) == NULL)
	{
		fprintf(stderr, "Datei '%s': Fehler beim Oeffnen\n", co_dat);
		exit(1);
	}
	if ((eq = fopen(eq_dat, "r")) == NULL)
	{
		fprintf(stderr, "Datei '%s': Fehler beim Oeffnen\n", eq_dat);
		exit(1);
	}
	for (r = 0; r < R; ++r)
		lambdaK[r] = 0;
	for (i = 0; i < N; ++i)
	{
		for (r = 0; r < R; ++r)
		{
			kmeanK[i][r] = 0;
			mrho[i][r] = 0;
			if (typ[i] == FESC)
				mue[i][r] = 0;
		}
	}
	while (fscanf(co, "%*d") != EOF)
	{
		fscanf(eq, "%*d %lf", &pstate);
		for (i = 0; i < N; ++i)
			perf1(i);
	}
	for (i = 0; i < N; ++i)
		perf2(i);
	for (r = 0; r < R; ++r)
		if (esum[r])
			lambdaK[r] /= esum[r];
}

#define MIN(a, b) ((a) < (b) ? (a) : (b))

void perf1(i)
int i;
{
	int r, j, k, ki_, ki[RMAX], phirk, kcode, sij, qij, wir;

	if (typ[i] == FESC)
	{
		ki_ = 0;
		for (r = 0; r < R; ++r)
		{
			if (e[i][r])
			{
				fscanf(co, "%d", &ki[r]);
				kmeanK[i][r] += pstate * ki[r];
				if (ki[r] > 0)
					ki_++;
				if (csq[i][r] != 1)
					fscanf(co, "%*d");
			}
			else
				ki[r] = 0;
		}
		if (ki_)
		{
			kcode = 0;
			for (r = 0; r < R; ++r)
			{
				kcode = kcode * krsize[r] + ki[r];
			}
			for (r = 0; r < R; ++r)
			{
				if (e[i][r] && ki[r] > 0)
				{
					mrho[i][r] += pstate / ki_;
					mue[i][r] += pstate * lmue[i][r][kcode];
				}
			}
		}
		if (fflag)
		{
			kcode = 0;
			for (r = 0; r < R; ++r)
				kcode = kcode * (K[r] + 1) + ki[r];
			pK[i][kcode] += pstate;
		}
		return;
	}
	for (r = 0; r < R; ++r)
		ki[r] = 0;
	if (iR[i] == 1 && nq[i] > 0)
	{
		for (r = 0; r < R; ++r)
		{
			if (e[i][r])
			{
				fscanf(co, "%d", &ki[r]);
				kmeanK[i][r] += pstate * ki[r];
				mrho[i][r] += pstate * MIN(ki[r], m[i]);
				if (csq[i][r] != 1)
				{
					for (j = 0; j < m[i]; ++j)
						fscanf(co, "%*d");
				}
			}
		}
	}
	else switch(nq[i] <= 0 ? IS : typ[i])
	{
		case IS:
		{
			for (r = 0; r < R; ++r)
			{
				if (e[i][r])
				{
					if (csq[i][r] == 1)
					{
						fscanf(co, "%d", &ki[r]);
						kmeanK[i][r] += pstate * ki[r];
					}
					else
					{
						ki[r] = 0;
						for (k = 1; k <= K[r]; ++k)
						{
							fscanf(co, "%d", &phirk);
							if (phirk > 0)
							{
								kmeanK[i][r] += pstate;
								ki[r]++;
							}
						}
					}
				}
			}
			break;
		}
		case PS:
		{
			ki_ = 0;
			for (r = 0; r < R; ++r)
			{
				if (e[i][r])
				{
					if (csq[i][r] == 1)
					{
						fscanf(co, "%d", &ki[r]);
					}
					else
					{
						ki[r] = 0;
						for (k = 1; k <= K[r]; ++k)
						{
							fscanf(co, "%d", &phirk);
							if (phirk > 0)
								ki[r]++;
						}
					}
					kmeanK[i][r] += pstate * ki[r];
					ki_ += ki[r];
				}
				else
					ki[r] = 0;
			}
			if (ki_)
				for (r = 0; r < R; ++r)
					mrho[i][r] += pstate * MIN(ki_, m[i]) * ki[r] / ki_;
			break;
		}
		case FCFS:
		case LCFS:
		{
			for (j = 0; j < m[i]; ++j)
			{
				fscanf(co, "%d", &sij);
				if (sij)
				{
					kmeanK[i][sij - 1] += pstate;
					mrho[i][sij - 1] += pstate;
					ki[sij - 1]++;
				}
				if (ph_flag[i])
					fscanf(co, "%*d");
			}
			for (j = 0; j < nq[i]; ++j)
			{
				fscanf(co, "%d", &qij);
				if (qij)
				{
					kmeanK[i][qij - 1] += pstate;
					ki[qij - 1]++;
				}
			}
			break;
		}
		case SIRO:
		case FCFS_NP:
		case LCFS_NP:
		case SIRO_NP:
		{
			for (j = 0; j < m[i]; ++j)
			{
				fscanf(co, "%d", &sij);
				if (sij)
				{
					kmeanK[i][sij - 1] += pstate;
					mrho[i][sij - 1] += pstate;
					ki[sij - 1]++;
				}
				if (ph_flag[i])
					fscanf(co, "%*d");
			}
			for (r = 0; r < R; ++r)
			{
				if (e[i][r])
				{
					fscanf(co, "%d", &wir);
					kmeanK[i][r] += pstate * wir;
					ki[r] += wir;
				}
			}
			break;
		}
		case FCFS_PR:
		case LCFS_PR:
		case PS_PR:
		{
			for (r = 0; r < R; ++r)
			{
				if (e[i][r])
				{
					if (csq[i][r] == 1)
					{
						fscanf(co, "%d", &ki[r]);
					}
					else
					{
						ki[r] = 0;
						for (k = 1; k <= K[r]; ++k)
						{
							fscanf(co, "%d", &phirk);
							if (phirk > 0)
								ki[r]++;
						}
					}
					kmeanK[i][r] += pstate * ki[r];
				}
				else
					ki[r] = 0;
			}
			ki_ = 0;
			for (r = 0; r < R; ++r)
			{
				if (m[i] - ki_ <= 0)
					break;
				mrho[i][r] += pstate * MIN(m[i] - ki_, ki[r]);
				ki_ += ki[r];
			}
			break;
		}
	}
	if (pflag)
	{
		kcode = 0;
		for (r = 0; r < R; ++r)
			kcode = kcode * (K[r] + 1) + ki[r];
		pK[i][kcode] += pstate;
	}
}

void perf2(i)
int i;
{
	int r, j, k;

	if (typ[i] == FESC)
	{
		for (r = 0; r < R; ++r)
		{
			if (e[i][r] && mrho[i][r])
			{
				lambdaK[r] += mue[i][r];
				mue[i][r] /= mrho[i][r];
			}
		}
		return;
	}
	if (iR[i] == 1 && nq[i] > 0)
	{
		for (r = 0; r < R; ++r)
			if (e[i][r])
				lambdaK[r] += mrho[i][r] * mue[i][r];
		return;
	}
	switch(nq[i] <= 0 ? IS : typ[i])
	{
		case IS:
		{
			for (r = 0; r < R; ++r)
			{
				if (e[i][r])
					lambdaK[r] += kmeanK[i][r] * mue[i][r];
				if (typ[i] != IS)
					mrho[i][r] = kmeanK[i][r];
			}
			break;
		}
		case PS:
		case FCFS:
		case LCFS:
		case SIRO:
		case FCFS_NP:
		case LCFS_NP:
		case SIRO_NP:
		case FCFS_PR:
		case LCFS_PR:
		case PS_PR:
		{
			for (r = 0; r < R; ++r)
				if (e[i][r])
					lambdaK[r] += mrho[i][r] * mue[i][r];
			break;
		}
	}
}
