#include <stdio.h>
#include <string.h>
#include "const+type.h"

static char *SccsId = "@(#)PEPSY:\tspec.c\t1.3\t93/02/11 15:37:31";

#define TAIL(path) (strrchr(path, '/') ? strrchr(path, '/') + 1 : path)

int ksize, vflag ;

int N, R, K[RMAX], m[NMAX], typ[NMAX], iR[NMAX], nq[NMAX];
double e[NMAX][RMAX], mue[NMAX][RMAX], *lmue[NMAX][RMAX];
double csq[NMAX][RMAX], ptrans[RMAX][NMAX + 1][NMAX + 1];

int ph[NMAX][RMAX], phmax[NMAX], ph_flag, Kflag;
double b1[NMAX][RMAX], rel_mue1[NMAX][RMAX], rel_mue2[NMAX][RMAX];

char common_dat[] = "common.h";
char excl_dat[] = "priv_excl.c";
char rules_dat[] = "priv_rules.c";

main(argc, argv)
int argc;
char *argv[];
{
	int i, r, j, Nflag, finput();
	void call_error(), short_circuit0(), cox(), spec();

	for (i = 1; i < argc; ++i)
	{
		if (argv[i][0] != '-')
			call_error(TAIL(argv[0]));
		for (j = 1; argv[i][j]; ++j)
		{
			switch (argv[i][j])
			{
				case 'K':
					++Kflag;
					break;
				default:
					call_error(TAIL(argv[0]));
					break;
			}
		}
	}
	Nflag = finput(stdin, &N, &R, K, m, typ, csq, ptrans, e, mue, lmue, NULL);
	if (Nflag == 0)
	{
		fprintf(stderr, "Eingabe mit Uebergangswahrscheinlichkeiten erwartet!\n");
		exit(1);
	}
	short_circuit0();
	cox();
	spec();
	exit(0);
}

void call_error(name)
char *name;
{
	fprintf(stderr, "Aufruf: %s -K\n", name);
	fprintf(stderr, "    -K:   variable Anzahl von Auftraegen\n");
	exit(1);
}

int nval;
FILE *ex, *rl;

void spec()
{
	int i, r, j, k, firstflag;
	void printf_MIN(), printf_MAX(), fprintf_excl_term(), fprintf_excl_sum();
	void printf_NOT(), fprintf_RULE();
	void make_common(), fclose_private_excl(), fclose_private_rules();
	FILE *prepare_private_excl(), *prepare_private_rules();

	for (i = 0; i < N; ++i)
	{
		nq[i] = -m[i];
		for (r = 0; r < R; ++r)
		{
			if (e[i][r])
			{
				iR[i]++;
				nq[i] += K[r];
			}
		}
		if (typ[i] == IS || nq[i] < 0)
			nq[i] = 0;
	}
	make_common(common_dat);
	ex = prepare_private_excl(common_dat, excl_dat);
	rl = prepare_private_rules(common_dat, rules_dat);

	printf("#include \"%s\"\n", common_dat);
	printf("\nDIM %d ", nval);
	if (ph_flag)
		printf("   ");
	for (i = 1; i < nval; ++i)
	{
		printf("   ");
		if (ph_flag)
			printf("   ");
	}
	printf(";   /* Dimension des Zustandsvektors */\n");
	printf("MIN");
	for (i = 0; i < N; ++i)
		printf_MIN(i);
	printf(";   /* Beschreibung der moeglichen Auspraegungen */\n");
	printf("MAX");
	for (i = 0; i < N; ++i)
		printf_MAX(i);
	printf(";\n\n");
	for (r = 0; r < R; ++r)
	{
		if (r > 0)
			fprintf(ex, " ||\n");
		firstflag = 1;
		for (i = 0; i < N; ++i)
		{
			if (e[i][r])
			{
				if (firstflag)
				{
					fprintf(ex, "		");
					firstflag = 0;
				}
				else
					fprintf(ex, " + ");
				fprintf_excl_term(i, r);
			}
		}
		if (firstflag)
			fprintf(ex, "		0", r + 1);
		else
			fprintf(ex, " != K%d", r + 1);
	}
	fprintf_excl_sum();
	for (i = 0; i < N; ++i)
		printf_NOT(i);
	printf("\nRULE {VAL[0] < 0} -> VAL[0] += 0 : 0.0 : 0.0;\n");
	for (i = 1; i <= N; ++i)
	{
		fprintf(rl, "\n	/* Uebergaenge von Knoten %d */\n", i);
		fprintf_RULE(i);
	}
	fclose_private_excl(ex);
	fclose_private_rules(rl);
}

void arrival(i, r)
int i, r;
{
	int j, k;

	if (typ[i - 1] == FESC)
	{
		fprintf(rl, "			k%d_%d += 1,\n", i, r);
		return;
	}
	if (iR[i - 1] == 1 && nq[i - 1] > 0)
	{
		if (csq[i - 1][r - 1] != 1)
		{
			for (j = 1; j <= m[i - 1]; ++j)
			{
				fprintf(rl, "			%sif (ph%d_%d == 0)\n",
					j > 1 ? "else " : "", i, j);
				fprintf(rl, "				ph%d_%d = 1;\n", i, j);
			}
		}
		fprintf(rl, "			k%d_%d += 1,\n", i, r);
		return;
	}
	switch(nq[i - 1] == 0 ? IS : typ[i - 1])
	{
		case IS:
		case PS:
		case FCFS_PR:
		case LCFS_PR:
		case PS_PR:
		{
			if (csq[i - 1][r - 1] == 1)
				fprintf(rl, "			k%d_%d += 1,\n", i, r);
			else
			{
				for (k = 1; k < K[r - 1]; ++k)
				{
					fprintf(rl, "			%sif (ph%d_%d_%d == 0)\n",
						k > 1 ? "else " : "", i, r, k);
					fprintf(rl, "				ph%d_%d_%d = 1;\n", i, r, k);
				}
				fprintf(rl, "			%sph%d_%d_%d = 1,\n",
					k > 1 ? "else\n				" : "", i, r, k);
				break;
			}
			break;
		}
		case FCFS:
		case LCFS:
		{
			for (j = 1; j <= m[i - 1]; ++j)
			{
				fprintf(rl, "			%sif (s%d_%d == 0)\n",
					j > 1 ? "else " : "", i, j);
				fprintf(rl, "				s%d_%d = %d;\n", i, j, r);
			}
			for (j = 1; j < nq[i - 1]; ++j)
			{
				fprintf(rl, "			else if (q%d_%d == 0)\n", i, j);
				fprintf(rl, "				q%d_%d = %d;\n", i, j, r);
			}
			fprintf(rl, "			else\n");
			fprintf(rl, "				q%d_%d = %d,\n", i, j, r);
			break;
		}
		case LCFS_PF:
		{
			for (j = nq[i-1]; j > 1; --j)
			{
				fprintf(rl, "				q%d_%d = q%d_%d;\n", i, j,i,j-1);
			}
			fprintf(rl, "				q%d_%d = s%d_%d;\n", i, 1,i,1);
			for(j=m[i-1]; j > 1; --j)
			{
				fprintf(rl, "				s%d_%d = s%d_%d;\n", i, j,i,j-1);
			}
			fprintf(rl, "				s%d_%d = %d,\n", i, m[i-1], r);

				
			break;
		}
		case SIRO:
		case FCFS_NP:
		case LCFS_NP:
		case SIRO_NP:
		{
			for (j = 1; j <= m[i - 1]; ++j)
			{
				fprintf(rl, "			%sif (s%d_%d == 0)\n",
					j > 1 ? "else " : "", i, j);
				fprintf(rl, "				s%d_%d = %d;\n", i, j, r);
			}
			fprintf(rl, "			else\n");
			fprintf(rl, "				w%d_%d += 1,\n", i, r);
			break;
		}
	}
}
