#include <stdio.h>
#include "const+type.h"

static char *SccsId = "@(#)PEPSY:\tspec_define.c\t1.2\t92/03/27 11:44:33";

extern int ksize;

extern int N, R, K[RMAX], m[NMAX], typ[NMAX], iR[NMAX], nq[NMAX];
extern double e[NMAX][RMAX], mue[NMAX][RMAX], *lmue[NMAX][RMAX];
extern double csq[NMAX][RMAX];

extern int ph[NMAX][RMAX], phmax[NMAX], ph_flag, Kflag;
extern double rel_mue1[NMAX][RMAX], rel_mue2[NMAX][RMAX];
extern double b1[NMAX][RMAX];

extern int nval;

void fprintf_defines1(fp)
FILE *fp;
{
	int i, r, j, k;
	void fprintf_VAL();

	nval = 0;
	for (i = 0; i < N; ++i)
	{
		fprintf_VAL(fp, i);
	}
	fprintf(fp, "\n#define R  ");
	if (ph_flag)
		fprintf(fp, "   ");
	fprintf(fp, "%d   /* Anzahl der Klassen */\n", R);
	for (r = 0; r < R; ++r)
	{
		if (Kflag)
		{
			fprintf(fp, "VAR int K%d;    ", r + 1);
			if (ph_flag)
				fprintf(fp, "   ");
		}
		else
		{
			fprintf(fp, "#define K%d ", r + 1);
			if (ph_flag)
				fprintf(fp, "   ");
			fprintf(fp, "%d   ", K[r]);
		}
		fprintf(fp, "/* Anzahl der Auftraege in Klasse %d */\n", r + 1);
	}
	for (i = 0; i < N; ++i)
	{
		if (phmax[i] != 1 && nq[i] > 0 && typ[i] != FESC)
		{
			fprintf(fp, "#define Ph%d   %d   ", i + 1, phmax[i]);
			fprintf(fp, "/* maximale Anzahl der Phasen in Knoten ");
			fprintf(fp, "%d */\n", i + 1);
		}
		for (r = 0; r < R; ++r)
		{
			if (e[i][r] && csq[i][r] != 1)
			{
				fprintf(fp, "#define Ph%d_%d %d   ",
					i + 1, r + 1, ph[i][r]);
				fprintf(fp, "/* Anzahl der Phasen in Knoten ");
				fprintf(fp, "%d, Klasse %d */\n", i + 1, r + 1);
			}
		}
	}
}

void fprintf_VAL(fp, i)
FILE *fp;
int i;
{
	int r, j, k;

	if (typ[i] == FESC)
	{
		for (r = 0; r < R; ++r)
		{
			if (e[i][r])
			{
				fprintf(fp, "#define k%d_%d ", i + 1, r + 1);
				if (ph_flag)
					fprintf(fp, "   ");
				fprintf(fp, "VAL[%d]   ", nval++);
				fprintf(fp, "/* Anzahl der Auftraege in Knoten ");
				fprintf(fp, "%d, Klasse %d */\n", i + 1, r + 1);
				if (csq[i][r] != 1)
				{
					fprintf(fp, "#define ph%d_%d   VAL[%d]   ",
						i + 1, r + 1, nval++);
					fprintf(fp, "/* Phase Knoten %d, ", i + 1);
					fprintf(fp, "Klasse %d */\n", r + 1);
				}
			}
		}
		return;
	}
	if (iR[i] == 1 && nq[i] > 0)
	{
		for (r = 0; r < R; ++r)
		{
			if (e[i][r])
			{
				fprintf(fp, "#define k%d_%d ", i + 1, r + 1);
				if (ph_flag)
					fprintf(fp, "   ");
				fprintf(fp, "VAL[%d]   ", nval++);
				fprintf(fp, "/* Anzahl der Auftraege in Knoten ");
				fprintf(fp, "%d, Klasse %d */\n", i + 1, r + 1);
				if (csq[i][r] != 1)
				{
					for (j = 0; j < m[i]; ++j)
					{
						fprintf(fp, "#define ph%d_%d   VAL[%d]   ",
							i + 1, j + 1, nval++);
						fprintf(fp, "/* Phase des Auftrags in Knoten %d, ",
							i + 1);
						fprintf(fp, "Bedienstation %d */\n", j + 1);
					}
				}
			}
		}
		return;
	}
	switch(nq[i] == 0 ? IS : typ[i])
	{
		case IS:
		case PS:
		case FCFS_PR:
		case LCFS_PR:
		case PS_PR:
		{
			for (r = 0; r < R; ++r)
			{
				if (e[i][r] == 0)
					continue;
				if (csq[i][r] == 1)
				{
					fprintf(fp, "#define k%d_%d ", i + 1, r + 1);
					if (ph_flag)
						fprintf(fp, "   ");
					fprintf(fp, "VAL[%d]   ", nval++);
					fprintf(fp, "/* Anzahl der Auftraege in Knoten ");
					fprintf(fp, "%d, Klasse %d */\n", i + 1, r + 1);
				}
				else
				{
					for (k = 1; k <= K[r]; ++k)
					{
						fprintf(fp, "#define ph%d_%d_%d VAL[%d]   ",
							i + 1, r + 1, k, nval++);
						fprintf(fp, "/* Phase Knoten %d, ", i + 1);
						fprintf(fp, "Klasse %d, Auftrag %d */\n",
							r + 1, k);
					}
				}
			}
			break;
		}
		case FCFS:
		case LCFS:
		{
			for (j = 0; j < m[i]; ++j)
			{
				fprintf(fp, "#define s%d_%d ", i + 1, j + 1);
				if (ph_flag)
					fprintf(fp, "   ");
				fprintf(fp, "VAL[%d]   ", nval++);
				fprintf(fp, "/* Klasse des Auftrags in Knoten %d, ",
					i + 1);
				fprintf(fp, "Bedienstation %d */\n", j + 1);
				if (phmax[i] > 1)
				{
					fprintf(fp, "#define ph%d_%d   ", i + 1, j + 1);
					fprintf(fp, "VAL[%d]   ", nval++);
					fprintf(fp, "/* Phase des Auftrags in Knoten %d, ",
						i + 1);
					fprintf(fp, "Bedienstation %d */\n", j + 1);
				}
			}
			for (j = 0; j < nq[i]; ++j)
			{
				fprintf(fp, "#define q%d_%d ", i + 1, j + 1);
				if (ph_flag)
					fprintf(fp, "   ");
				fprintf(fp, "VAL[%d]   ", nval++);
				fprintf(fp, "/* Klasse des Auftrags in Knoten %d, ",
					i + 1);
				fprintf(fp, "Warteplatz %d */\n", j + 1);
			}
			break;
		}
		case LCFS_PF:
		{
			for (j = 0; j < m[i]; ++j)
			{
				fprintf(fp, "#define s%d_%d ", i + 1, j + 1);
				if (ph_flag)
					fprintf(fp, "   ");
				fprintf(fp, "VAL[%d]   ", nval++);
				fprintf(fp, "/* Klasse des Auftrags in Knoten %d, ",
					i + 1);
				fprintf(fp, "Bedienstation %d */\n", j + 1);
				if (phmax[i] > 1)
				{
					fprintf(fp, "#define ph%d_%d   ", i + 1, j + 1);
					fprintf(fp, "VAL[%d]   ", nval++);
					fprintf(fp, "/* Phase des Auftrags in Knoten %d, ",
						i + 1);
					fprintf(fp, "Bedienstation %d */\n", j + 1);
				}
			}
			for (j = 0; j < nq[i]; ++j)
			{
				fprintf(fp, "#define q%d_%d ", i + 1, j + 1);
				if (ph_flag)
					fprintf(fp, "   ");
				fprintf(fp, "VAL[%d]   ", nval++);
				fprintf(fp, "/* Klasse des Auftrags in Knoten %d, ",
					i + 1);
				fprintf(fp, "Warteplatz %d */\n", j + 1);
				if (phmax[i] > 1)
				{
					fprintf(fp, "#define ph%d_%d   ", i + 1, j + 1 + m[i]);
					fprintf(fp, "VAL[%d]   ", nval++);
					fprintf(fp, "/* Phase des Auftrags in Knoten %d, ",
						i + 1);
					fprintf(fp, "Warteplatz %d */\n", j + 1);
				}
			}
			break;
		}
		case SIRO:
		case FCFS_NP:
		case LCFS_NP:
		case SIRO_NP:
		{
			for (j = 0; j < m[i]; ++j)
			{
				fprintf(fp, "#define s%d_%d ", i + 1, j + 1);
				if (ph_flag)
					fprintf(fp, "   ");
				fprintf(fp, "VAL[%d]   ", nval++);
				fprintf(fp, "/* Klasse des Auftrags in Knoten %d, ",
					i + 1);
				fprintf(fp, "Bedienstation %d */\n", j + 1);
				if (phmax[i] > 1)
				{
					fprintf(fp, "#define ph%d_%d   ", i + 1, j + 1);
					fprintf(fp, "VAL[%d]   ", nval++);
					fprintf(fp, "/* Phase des Auftrags in Knoten %d, ",
						i + 1);
					fprintf(fp, "Bedienstation %d */\n", j + 1);
				}
			}
			for (r = 0; r < R; ++r)
			{
				if (e[i][r])
				{
					fprintf(fp, "#define w%d_%d ", i + 1, r + 1);
					if (ph_flag)
						fprintf(fp, "   ");
					fprintf(fp, "VAL[%d]   ", nval++);
					fprintf(fp, "/* Anzahl der wartenden Auftraege in ");
					fprintf(fp, "Knoten %d, Klasse %d */\n", i + 1, r + 1);
				}
			}
			break;
		}
	}
}

void fprintf_defines2(fp)
FILE *fp;
{
	int i, r;
	void fprintf_mue_markov();

	putc('\n', fp);
	for (i = 0; i < N; ++i)
		fprintf_mue_markov(fp, i);
	if (ph_flag == 0)
		return;
	putc('\n', fp);
	for (i = 0; i < N; ++i)
	{
		for (r = 0; r < R; ++r)
		{
			if (e[i][r] && csq[i][r] != 1)
			{
				fprintf(fp, "#define rel_mue%d_%d_1 %.15le   ",
					i + 1, r + 1, rel_mue1[i][r]);
				fprintf(fp, "/* relative mittlere Bedienrate Knoten ");
				fprintf(fp, "%d, Klasse %d, Phase 1 */\n",
					i + 1, r + 1);
				fprintf(fp, "#define rel_mue%d_%d_2 %.15le   ",
					i + 1, r + 1, rel_mue2[i][r]);
				fprintf(fp, "/* relative mittlere Bedienrate Knoten ");
				fprintf(fp, "%d, Klasse %d, Phase 2 */\n",
					i + 1, r + 1);
			}
		}
	}
	putc('\n', fp);
	for (i = 0; i < N; ++i)
	{
		for (r = 0; r < R; ++r)
		{
			if (e[i][r] && csq[i][r] != 1)
			{
				fprintf(fp, "#define a%d_%d %.15le   ",
					i + 1, r + 1, 1 - b1[i][r]);
				fprintf(fp, "/* Verzweigungsw. Knoten ");
				fprintf(fp, "%d, Klasse %d, Phase 1 nach Phase 2 */\n",
					i + 1, r + 1);
			}
		}
	}
}

void fprintf_mue_markov(fp, i)
FILE *fp;
int i;
{
	int r, s, kcode, kR;

	for (r = 0; r < R; ++r)
	{
		if (e[i][r])
		{
			if (typ[i] == FESC)
			{
				fprintf(fp, "double lmue%d_%d", i + 1, r + 1);
				for (s = 0; s < R; ++s)
				{
					fprintf(fp, "[%d]", K[s] + 1);
				}
				fprintf(fp, " =   /* lastab. Bedienraten ");
				fprintf(fp, "Knoten %d, Klasse %d */\n{\n", i + 1, r + 1);
				kR = 0;
				for (kcode = 0; kcode < ksize; ++kcode)
				{
					fprintf(fp, "%.16lg, ", lmue[i][r][kcode]);
					if (kR++ == K[R - 1])
					{
						putc('\n', fp);
						kR = 0;
					}
				}
				fprintf(fp, "};\n");
			}
			else
			{
				fprintf(fp, "#define mue%d_%d %.15le   ",
					i + 1, r + 1, mue[i][r]);
				fprintf(fp, "/* mittlere Bedienrate Knoten %d, ", i + 1);
				fprintf(fp, "Klasse %d */\n", r + 1);
			}
		}
	}
}
