#include <stdio.h>
#include "const+type.h"

static char *SccsId = "@(#)PEPSY:\tspec_excl.c\t1.2\t92/03/27 11:44:35";

extern int N, R, K[RMAX], m[NMAX], typ[NMAX], iR[NMAX], nq[NMAX];
extern double e[NMAX][RMAX], csq[NMAX][RMAX];

extern int ph[NMAX][RMAX], phmax[NMAX], ph_flag;

extern FILE *ex;

void fprintf_excl_term(i, r)
int i, r;
{
	int j, k;

	if (typ[i] == FESC)
	{
		fprintf(ex, "k%d_%d", i + 1, r + 1);
		return;
	}
	if (iR[i] == 1 && nq[i] > 0)
	{
		fprintf(ex, "k%d_%d", i + 1, r + 1);
		return;
	}
	switch(nq[i] == 0 ? IS : typ[i])
	{
		case IS:
		case PS:
		case FCFS_PR:
		case LCFS_PR:
		case PS_PR:
		{
			if (csq[i][r] == 1)
				fprintf(ex, "k%d_%d", i + 1, r + 1);
			else
			{
				if (K[r] == 0)
					fprintf(ex, "0");
				for (k = 1; k <= K[r]; ++k)
				{
					if (k > 1)
						fprintf(ex, " + ");
					fprintf(ex, "(ph%d_%d_%d > 0)", i + 1, r + 1, k);
				}
			}
			break;
		}
		case FCFS:
		case LCFS:
		{
			for (j = 0; j < m[i]; ++j)
			{
				if (j > 0)
					fprintf(ex, " + ");
				fprintf(ex, "(s%d_%d == %d)",
					i + 1, j + 1, r + 1);
			}
			for (j = 0; j < nq[i]; ++j)
			{
				fprintf(ex, " + (q%d_%d == %d)",
					i + 1, j + 1, r + 1);
			}
			break;
		}
		case LCFS_PF:
		{
			for (j = 0; j < m[i]; ++j)
			{
				if (j > 0)
					fprintf(ex, " + ");
				fprintf(ex, "(s%d_%d == %d)",
					i + 1, j + 1, r + 1);
			}
			for (j = 0; j < nq[i]; ++j)
			{
				fprintf(ex, " + (q%d_%d == %d)",
					i + 1, j + 1, r + 1);
			}
			break;
		}
		case SIRO:
		case FCFS_NP:
		case LCFS_NP:
		case SIRO_NP:
		{
			for (j = 0; j < m[i]; ++j)
			{
				fprintf(ex, "(s%d_%d == %d) + ",
					i + 1, j + 1, r + 1);
			}
			fprintf(ex, "w%d_%d", i + 1, r + 1);
			break;
		}
	}
}

void fprintf_excl_sum()
{
	int i, r, j;

	for (i = 0; i < N; ++i)
	{
		if (iR[i] == 1 && nq[i] > 0 && typ[i] != FESC)
		{
			for (r = 0; r < R; ++r)
			{
				if (e[i][r] && csq[i][r] != 1)
				{
					fprintf(ex, " ||\n");
					for (j = 0; j < m[i]; ++j)
						fprintf(ex, "%s(ph%d_%d > 0)",
							j > 0 ? " + " : "		", i + 1, j + 1);
					fprintf(ex, " != MIN(%d, k%d_%d)", m[i], i + 1, r + 1);
				}
			}
		}
	}
}

void printf_NOT(i)
int i;
{
	int r, j, k;

	if (typ[i] == FESC)
	{
		for (r = 0; r < R; ++r)
			if (e[i][r] && csq[i][r] != 1)
				printf("NOT {k%d_%d == 0}{ph%d_%d > 1};\n",
					i + 1, r + 1, i + 1, r + 1);
		return;
	}
	if (iR[i] == 1 && nq[i] > 0)
	{
		return;
	}
	switch(nq[i] == 0 ? IS : typ[i])
	{
		case IS:
		case PS:
		{
			break;
		}
		case FCFS_PR:
		case LCFS_PR:
		case PS_PR:
		{
			for (r = 0; r < R; ++r)
				if (e[i][r] && csq[i][r] != 1)
					for (k = 1; k < K[r]; ++k)
						printf("NOT {ph%d_%d_%d == 0}{ph%d_%d_%d > 0};\n",
							i + 1, r + 1, k, i + 1, r + 1, k + 1);
			break;
		}
		case FCFS:
		case LCFS:
		{
			for (j = 0; j < m[i]; ++j)
			{
				if (phmax[i] > 1)
					printf("NOT {s%d_%d == 0}{ph%d_%d > 1};\n",
						i + 1, j + 1, i + 1, j + 1);
				for (r = 0; r < R; ++r)
				{
					if (e[i][r] == 0)
					{
						printf("NOT {s%d_%d == %d};\n",
							i + 1, j + 1, r + 1);
					}
					else if (csq[i][r] == 1)
					{
						if (phmax[i] > 1)
							printf("NOT {s%d_%d == %d}{ph%d_%d > 1};\n",
								i + 1, j + 1, r + 1, i + 1, j + 1);
					}
					else if (ph[i][r] < phmax[i])
					{
						printf("NOT {s%d_%d == %d}{ph%d_%d > Ph%d_%d};\n",
							i + 1, j + 1, r + 1, i + 1, j + 1, i + 1, r + 1);
					}
				}
				printf("NOT {s%d_%d == 0}{q%d_1 > 0};\n",
					i + 1, j + 1, i + 1);
			}
			for (j = 0; j < nq[i]; ++j)
			{
				if (j > 0)
					printf("NOT {q%d_%d == 0}{q%d_%d > 0};\n",
						i + 1, j, i + 1, j + 1);
				for (r = 0; r < R; ++r)
				{
					if (e[i][r] == 0)
					{
						printf("NOT {q%d_%d == %d};\n",
							i + 1, j + 1, r + 1);
					}
				}
			}
			break;
		}
		case LCFS_PF:
		{
			for (j = 0; j < m[i]; ++j)
			{
				if (phmax[i] > 1)
					printf("NOT {s%d_%d == 0}{ph%d_%d > 1};\n",
						i + 1, j + 1, i + 1, j + 1);
				for (r = 0; r < R; ++r)
				{
					if (e[i][r] == 0)
					{
						printf("NOT {s%d_%d == %d};\n",
							i + 1, j + 1, r + 1);
					}
					else if (csq[i][r] == 1)
					{
						if (phmax[i] > 1)
							printf("NOT {s%d_%d == %d}{ph%d_%d > 1};\n",
								i + 1, j + 1, r + 1, i + 1, j + 1);
					}
					else if (ph[i][r] < phmax[i])
					{
						printf("NOT {s%d_%d == %d}{ph%d_%d > Ph%d_%d};\n",
							i + 1, j + 1, r + 1, i + 1, j + 1, i + 1, r + 1);
					}
				}
				printf("NOT {s%d_%d == 0}{q%d_1 > 0};\n",
					i + 1, j + 1, i + 1);
			}
			for (j = 0; j < nq[i]; ++j)
			{
				if (phmax[i] > 1)
					printf("NOT {q%d_%d == 0}{ph%d_%d > 1};\n",
						i + 1, j + 1, i + 1, j + 1 + m[i]);
				for (r = 0; r < R; ++r)
				{
					if (e[i][r] == 0)
					{
						printf("NOT {q%d_%d == %d};\n",
							i + 1, j + 1, r + 1);
					}
					else if (csq[i][r] == 1)
					{
						if (phmax[i] > 1)
							printf("NOT {q%d_%d == %d}{ph%d_%d > 1};\n",
								i + 1, j + 1, r + 1, i + 1, j + 1 + m[i]);
					}
					else if (ph[i][r] < phmax[i])
					{
						printf("NOT {q%d_%d == %d}{ph%d_%d > Ph%d_%d};\n",
							i + 1, j + 1, r + 1, i + 1, j + 1 + m[i], i + 1, r + 1);
					}
				}
				if(j < nq[i]-1)
					printf("NOT {q%d_%d == 0}{q%d_%d > 0};\n",
						i + 1, j + 1, i + 1, j + 2);
			}
			break;
		}
		case SIRO:
		case FCFS_NP:
		case LCFS_NP:
		case SIRO_NP:
		{
			for (j = 0; j < m[i]; ++j)
			{
				if (phmax[i] > 1)
					printf("NOT {s%d_%d == 0}{ph%d_%d > 1};\n",
						i + 1, j + 1, i + 1, j + 1);
				for (r = 0; r < R; ++r)
				{
					if (e[i][r] == 0)
					{
						printf("NOT {s%d_%d == %d};\n",
							i + 1, j + 1, r + 1);
					}
					else
					{
						if (csq[i][r] == 1)
						{
							if (phmax[i] > 1)
								printf("NOT {s%d_%d == %d}{ph%d_%d > 1};\n",
									i + 1, j + 1, r + 1, i + 1, j + 1);
						}
						else if (ph[i][r] < phmax[i])
						{
							printf("NOT {s%d_%d == %d}{ph%d_%d > Ph%d_%d};\n",
								i + 1, j + 1, r + 1,
								i + 1, j + 1, i + 1, r + 1);
						}
						printf("NOT {s%d_%d == 0}{w%d_%d > 0};\n",
							i + 1, j + 1, i + 1, r + 1);
					}
				}
			}
			break;
		}
	}
}
