#include <stdio.h>
#include "const+type.h"

static char *SccsId = "@(#)PEPSY:\tspec_phirk.c\t1.2\t92/03/27 11:44:38";

extern int N, R, K[RMAX], m[NMAX];
extern double e[NMAX][RMAX], mue[NMAX][RMAX], *lmue[NMAX][RMAX];
extern double csq[NMAX][RMAX], ptrans[RMAX][NMAX + 1][NMAX + 1];

extern int ph[NMAX][RMAX], phmax[NMAX], ph_flag;

extern FILE *rl;

void ISrules(i)
int i;
{
	int r, j, k;
	void arrival();

	for (r = 0; r < R; ++r)
	{
		if (e[i - 1][r] == 0)
			continue;
		if (csq[i - 1][r] == 1)
		{
			for (j = 1; j <= N; ++j)
			{
				if (j != i && ptrans[r][i][j] > 0)
				{
					fprintf(rl, "\n	RULE(k%d_%d > 0,\n", i, r + 1);
					fprintf(rl, "			k%d_%d -= 1;\n", i, r + 1);
					arrival(j, r + 1);
					fprintf(rl, "		mue%d_%d * k%d_%d", i, r + 1, i, r + 1);
					fprintf(rl, ", %.15le)\n", ptrans[r][i][j]);
				}
			}
			continue;
		}
		for (k = 1; k <= K[r]; ++k)
		{
			fprintf(rl, "\n	RULE(ph%d_%d_%d == 1,\n", i, r + 1, k);
			fprintf(rl, "			ph%d_%d_%d += 1,\n", i, r + 1, k);
			fprintf(rl, "		rel_mue%d_%d_1 * mue%d_%d",
				i, r + 1, i, r + 1);
			fprintf(rl, ", a%d_%d)\n", i, r + 1);
			if (ph[i - 1][r] > 2)
			{
				fprintf(rl, "\n	RULE(ph%d_%d_%d > 1 && ", i, r + 1, k);
				fprintf(rl, "ph%d_%d_%d < Ph%d_%d,\n", i, r + 1, k, i, r + 1);
				fprintf(rl, "			ph%d_%d_%d += 1,\n", i, r + 1, k);
				fprintf(rl, "		rel_mue%d_%d_2 * mue%d_%d",
					i, r + 1, i, r + 1);
				fprintf(rl, ", 1.0)\n");
			}
		}
		for (j = 1; j <= N; ++j)
		{
			if (ptrans[r][i][j] > 0)
			{
				for (k = 1; k <= K[r]; ++k)
				{
					if (i != j)
					{
						fprintf(rl, "\n	RULE(ph%d_%d_%d == 1,\n", i, r + 1, k);
						fprintf(rl, "			ph%d_%d_%d = 0;\n",
							i, r + 1, k);
						arrival(j, r + 1);
						fprintf(rl, "		rel_mue%d_%d_1 * mue%d_%d\n",
							i, r + 1, i, r + 1);
						fprintf(rl, ", (1 - a%d_%d) * %.15le)\n",
							i, r + 1, ptrans[r][i][j]);
					}
					fprintf(rl, "\n	RULE(ph%d_%d_%d == Ph%d_%d,\n",
						i, r + 1, k, i, r + 1);
					if (i != j)
					{
						fprintf(rl, "			ph%d_%d_%d = 0;\n",
							i, r + 1, k);
						arrival(j, r + 1);
					}
					else
						fprintf(rl, "			ph%d_%d_%d = 1,\n",
							i, r + 1, k);
					fprintf(rl, "		rel_mue%d_%d_2 * mue%d_%d",
						i, r + 1, i, r + 1);
					fprintf(rl, ", %.15le)\n", ptrans[r][i][j]);
				}
			}
		}
	}
}

static void fprintf_ksum(i)
int i;
{
	int s, k, firstflag;

	firstflag = 1;
	for (s = 0; s < R; ++s)
	{
		if (e[i - 1][s])
		{
			if (csq[i - 1][s] == 1)
			{
				if (firstflag)
				{
					fprintf(rl, "			itmp = k%d_%d", i, s + 1);
					firstflag = 0;
				}
				else
					fprintf(rl, " + k%d_%d", i, s + 1);
			}
			else
			{
				for (k = 1; k <= K[s]; ++k)
				{
					if (firstflag)
					{
						fprintf(rl, "			itmp = (ph%d_%d_%d > 0)",
							i, s + 1, k);
						firstflag = 0;
					}
					else
						fprintf(rl, " + (ph%d_%d_%d > 0)", i, s + 1, k);
				}
			}
		}
	}
	fprintf(rl, ";\n");
	return;
}

void PSrules(i)
int i;
{
	int r, j, k;
	void arrival();

	for (r = 0; r < R; ++r)
	{
		if (e[i - 1][r] == 0)
			continue;
		if (csq[i - 1][r] == 1)
		{
			for (j = 1; j <= N; ++j)
			{
				if (j != i && ptrans[r][i][j] > 0)
				{
					fprintf(rl, "\n	RULE(k%d_%d > 0,\n", i, r + 1);
					fprintf_ksum(i);
					fprintf(rl, "			k%d_%d -= 1;\n", i, r + 1);
					arrival(j, r + 1);
					fprintf(rl, "		mue%d_%d * k%d_%d", i, r + 1, i, r + 1);
					fprintf(rl, " / itmp");
					if (m[i - 1] > 1)
						fprintf(rl, " * MIN(itmp, %d)", m[i - 1]);
					fprintf(rl, ", %.15le)\n", ptrans[r][i][j]);
				}
			}
			continue;
		}
		for (k = 1; k <= K[r]; ++k)
		{
			fprintf(rl, "\n	RULE(ph%d_%d_%d == 1,\n", i, r + 1, k);
			fprintf_ksum(i);
			fprintf(rl, "			ph%d_%d_%d += 1,\n", i, r + 1, k);
			fprintf(rl, "		rel_mue%d_%d_1 * mue%d_%d",
				i, r + 1, i, r + 1);
			fprintf(rl, " / itmp");
			if (m[i - 1] > 1)
				fprintf(rl, " * MIN(itmp, %d)", m[i - 1]);
			fprintf(rl, ", a%d_%d)\n", i, r + 1);
			if (ph[i - 1][r] > 2)
			{
				fprintf(rl, "\n	RULE(ph%d_%d_%d > 1 && ", i, r + 1, k);
				fprintf(rl, "ph%d_%d_%d < Ph%d_%d,\n", i, r + 1, k, i, r + 1);
				fprintf_ksum(i);
				fprintf(rl, "			ph%d_%d_%d += 1,\n", i, r + 1, k);
				fprintf(rl, "		rel_mue%d_%d_2 * mue%d_%d",
					i, r + 1, i, r + 1);
				fprintf(rl, " / itmp");
				if (m[i - 1] > 1)
					fprintf(rl, " * MIN(itmp, %d)", m[i - 1]);
				fprintf(rl, ", 1.0)\n");
			}
		}
		for (j = 1; j <= N; ++j)
		{
			if (ptrans[r][i][j] > 0)
			{
				for (k = 1; k <= K[r]; ++k)
				{
					if (i != j)
					{
						fprintf(rl, "\n	RULE(ph%d_%d_%d == 1,\n", i, r + 1, k);
						fprintf_ksum(i);
						fprintf(rl, "			ph%d_%d_%d = 0;\n",
							i, r + 1, k);
						arrival(j, r + 1);
						fprintf(rl, "		rel_mue%d_%d_1 * mue%d_%d",
							i, r + 1, i, r + 1);
						fprintf(rl, " / itmp");
						if (m[i - 1] > 1)
							fprintf(rl, " * MIN(itmp, %d)", m[i - 1]);
						fprintf(rl, ", (1 - a%d_%d) * %.15le)\n",
							i, r + 1, ptrans[r][i][j]);
					}
					fprintf(rl, "\n	RULE(ph%d_%d_%d == Ph%d_%d,\n",
						i, r + 1, k, i, r + 1);
					fprintf_ksum(i);
					if (i != j)
					{
						fprintf(rl, "			ph%d_%d_%d = 0;\n",
							i, r + 1, k);
						arrival(j, r + 1);
					}
					else
						fprintf(rl, "			ph%d_%d_%d = 1,\n",
							i, r + 1, k);
					fprintf(rl, "		rel_mue%d_%d_2 * mue%d_%d",
						i, r + 1, i, r + 1);
					fprintf(rl, " / itmp");
					if (m[i - 1] > 1)
						fprintf(rl, " * MIN(itmp, %d)", m[i - 1]);
					fprintf(rl, ", %.15le)\n", ptrans[r][i][j]);
				}
			}
		}
	}
}

static void fprintf_kdiff(i, r)
int i, r;
{
	int s, k;

	fprintf(rl, "%d", m[i - 1]);
	for (s = 0; s < r; ++s)
		if (e[i - 1][s])
			if (csq[i - 1][s] == 1)
				fprintf(rl, " - k%d_%d", i, s + 1);
			else
				for (k = 1; k <= K[s]; ++k)
					fprintf(rl, " - (ph%d_%d_%d > 0)", i, s + 1, k);
}

#define MIN(a, b) (a < b ? a : b)

void FCFS_PRrules(i)
int i;
{
	int r, j, s, k, l, ksum, kr;
	void arrival();

	ksum = 0;
	for (r = 0; r < R; ++r)
	{
		if (e[i - 1][r] == 0)
			continue;
		if (csq[i - 1][r] == 1)
		{
			for (j = 1; j <= N; ++j)
			{
				if (j != i && ptrans[r][i][j] > 0)
				{
					fprintf(rl, "\n	RULE((itmp = MIN(k%d_%d, ", i, r + 1);
					fprintf_kdiff(i, r);
					fprintf(rl, ")) > 0,\n");
					fprintf(rl, "			k%d_%d -= 1;\n", i, r + 1);
					arrival(j, r + 1);
					fprintf(rl, "		itmp * mue%d_%d, %.15le)\n",
						i, r + 1, ptrans[r][i][j]);
				}
			}
			continue;
		}
		kr = MIN(m[i - 1], K[r]);
		for (k = 1; k <= kr; ++k)
		{
			fprintf(rl, "\n	RULE(ph%d_%d_%d == 1", i, r + 1, k);
			if (m[i - 1] - ksum - k < 0)
			{
				fprintf(rl, " && ");
				fprintf_kdiff(i, r);
				fprintf(rl, " > %d", k - 1);
			}
			fprintf(rl, ",\n");
			fprintf(rl, "			ph%d_%d_%d += 1,\n", i, r + 1, k);
			fprintf(rl, "		rel_mue%d_%d_1 * mue%d_%d", i, r + 1, i, r + 1);
			fprintf(rl, ", a%d_%d)\n", i, r + 1);
			if (ph[i - 1][r] > 2)
			{
				fprintf(rl, "\n	RULE(ph%d_%d_%d > 1 && ", i, r + 1, k);
				fprintf(rl, "ph%d_%d_%d < Ph%d_%d", i, r + 1, k, i, r + 1);
				if (m[i - 1] - ksum - k < 0)
				{
					fprintf(rl, " && ");
					fprintf_kdiff(i, r);
					fprintf(rl, " > %d", k - 1);
				}
				fprintf(rl, ",\n");
				fprintf(rl, "			ph%d_%d_%d += 1,\n", i, r + 1, k);
				fprintf(rl, "		rel_mue%d_%d_2 * mue%d_%d",
					i, r + 1, i, r + 1);
				fprintf(rl, ", 1.0)\n");
			}
		}
		for (j = 1; j <= N; ++j)
		{
			if (ptrans[r][i][j] > 0)
			{
				for (k = 1; k <= kr; ++k)
				{
					if (i != j || k < K[r])
					{
						fprintf(rl, "\n	RULE(ph%d_%d_%d == 1", i, r + 1, k);
						if (i == j)
						{
							for (l = k + 1; l <= K[r]; ++l)
								fprintf(rl, "%s(ph%d_%d_%d > 1)",
									l == k + 1 ? " && (" : " || ",
									i, r + 1, k + 1);
							fprintf(rl, ")");
						}
						if (m[i - 1] - ksum - k < 0)
						{
							fprintf(rl, " && ");
							fprintf_kdiff(i, r);
							fprintf(rl, " > %d", k - 1);
						}
						fprintf(rl, ",\n");
						for (l = k; l < K[r]; ++l)
							fprintf(rl, "			ph%d_%d_%d = ph%d_%d_%d;\n",
								i, r + 1, l, i, r + 1, l + 1);
						fprintf(rl, "			ph%d_%d_%d = 0;\n",
							i, r + 1, K[r]);
						arrival(j, r + 1);
						fprintf(rl, "		rel_mue%d_%d_1 * mue%d_%d",
							i, r + 1, i, r + 1);
						fprintf(rl, ", (1 - a%d_%d) * %.15le)\n",
							i, r + 1, ptrans[r][i][j]);
					}
					fprintf(rl, "\n	RULE(ph%d_%d_%d == Ph%d_%d",
						i, r + 1, k, i, r + 1);
					if (m[i - 1] - ksum - k < 0)
					{
						fprintf(rl, " && ");
						fprintf_kdiff(i, r);
						fprintf(rl, " > %d", k - 1);
					}
					fprintf(rl, ",\n");
					for (l = k; l < K[r]; ++l)
						fprintf(rl, "			ph%d_%d_%d = ph%d_%d_%d;\n",
							i, r + 1, l, i, r + 1, l + 1);
					fprintf(rl, "			ph%d_%d_%d = 0;\n",
						i, r + 1, K[r]);
					arrival(j, r + 1);
					fprintf(rl, "		rel_mue%d_%d_2 * mue%d_%d",
						i, r + 1, i, r + 1);
					fprintf(rl, ", %.15le)\n", ptrans[r][i][j]);
				}
			}
		}
		ksum += K[r];
	}
}

void LCFS_PRrules(i)
int i;
{
	int r, j, s, k, l, ksum, kr;
	void arrival();

	ksum = 0;
	for (r = 0; r < R; ++r)
	{
		if (e[i - 1][r] == 0)
			continue;
		if (csq[i - 1][r] == 1)
		{
			for (j = 1; j <= N; ++j)
			{
				if (j != i && ptrans[r][i][j] > 0)
				{
					fprintf(rl, "\n	RULE((itmp = MIN(k%d_%d, ", i, r + 1);
					fprintf_kdiff(i, r);
					fprintf(rl, ")) > 0,\n");
					fprintf(rl, "			k%d_%d -= 1;\n", i, r + 1);
					arrival(j, r + 1);
					fprintf(rl, "		itmp * mue%d_%d, %.15le)\n",
						i, r + 1, ptrans[r][i][j]);
				}
			}
			continue;
		}
		kr = MIN(m[i - 1], K[r]);
		for (k = 1; k <= kr; ++k)
		{
			fprintf(rl, "\n	RULE(ph%d_%d_%d == 1", i, r + 1, K[r] + 1 - k);
			if (m[i - 1] - ksum - k < 0)
			{
				fprintf(rl, " && ");
				fprintf_kdiff(i, r);
				for (l = K[r] + 2 - k; l <= K[r]; ++l)
					fprintf(rl, " - (ph%d_%d_%d > 0)", i, r + 1, l);
				fprintf(rl, " > 0");
			}
			fprintf(rl, ",\n");
			fprintf(rl, "			ph%d_%d_%d += 1,\n",
				i, r + 1, K[r] + 1 - k);
			fprintf(rl, "		rel_mue%d_%d_1 * mue%d_%d", i, r + 1, i, r + 1);
			fprintf(rl, ", a%d_%d)\n", i, r + 1);
			if (ph[i - 1][r] > 2)
			{
				fprintf(rl, "\n	RULE(ph%d_%d_%d > 1 && ",
					i, r + 1, K[r] + 1 - k);
				fprintf(rl, "ph%d_%d_%d < Ph%d_%d",
					i, r + 1, K[r] + 1 - k, i, r + 1);
				if (m[i - 1] - ksum - k < 0)
				{
					fprintf(rl, " && ");
					fprintf_kdiff(i, r);
					for (l = K[r] + 2 - k; l <= K[r]; ++l)
						fprintf(rl, " - (ph%d_%d_%d > 0)", i, r + 1, l);
					fprintf(rl, " > 0");
				}
				fprintf(rl, ",\n");
				fprintf(rl, "			ph%d_%d_%d += 1,\n",
					i, r + 1, K[r] + 1 - k);
				fprintf(rl, "		rel_mue%d_%d_2 * mue%d_%d",
					i, r + 1, i, r + 1);
				fprintf(rl, ", 1.0)\n");
			}
		}
		for (j = 1; j <= N; ++j)
		{
			if (ptrans[r][i][j] > 0)
			{
				for (k = 1; k <= kr; ++k)
				{
					if (i != j || k > 1)
					{
						fprintf(rl, "\n	RULE(ph%d_%d_%d == 1",
							i, r + 1, K[r] + 1 - k);
						if (i == j)
						{
							for (l = K[r] + 2 - k; l <= K[r]; ++l)
								fprintf(rl, "%s(ph%d_%d_%d > 1)",
									l == K[r] + 2 - k ? " && (" : " || ", i, r + 1, l);
							if (K[r] + 2 - k <= K[r])
								fprintf(rl, ")");
						}
						if (m[i - 1] - ksum - k < 0)
						{
							fprintf(rl, " && ");
							fprintf_kdiff(i, r);
							for (l = K[r] + 2 - k; l <= K[r]; ++l)
								fprintf(rl, " - (ph%d_%d_%d > 0)", i, r + 1, l);
							fprintf(rl, " > 0");
						}
						fprintf(rl, ",\n");
						for (l = K[r] + 1 - k; l < K[r]; ++l)
							fprintf(rl, "			ph%d_%d_%d = ph%d_%d_%d;\n",
								i, r + 1, l, i, r + 1, l + 1);
						fprintf(rl, "			ph%d_%d_%d = 0;\n",
							i, r + 1, K[r]);
						arrival(j, r + 1);
						fprintf(rl, "		rel_mue%d_%d_1 * mue%d_%d",
							i, r + 1, i, r + 1);
						fprintf(rl, ", (1 - a%d_%d) * %.15le)\n",
							i, r + 1, ptrans[r][i][j]);
					}
					fprintf(rl, "\n	RULE(ph%d_%d_%d == Ph%d_%d",
						i, r + 1, K[r] + 1 - k, i, r + 1);
					if (m[i - 1] - ksum - k < 0)
					{
						fprintf(rl, " && ");
						fprintf_kdiff(i, r);
						for (l = K[r] + 2 - k; l <= K[r]; ++l)
							fprintf(rl, " - (ph%d_%d_%d > 0)", i, r + 1, l);
						fprintf(rl, " > 0");
					}
					fprintf(rl, ",\n");
					for (l = K[r] + 1 - k; l < K[r]; ++l)
						fprintf(rl, "			ph%d_%d_%d = ph%d_%d_%d;\n",
							i, r + 1, l, i, r + 1, l + 1);
					fprintf(rl, "			ph%d_%d_%d = 0;\n",
						i, r + 1, K[r]);
					arrival(j, r + 1);
					fprintf(rl, "		rel_mue%d_%d_2 * mue%d_%d",
						i, r + 1, i, r + 1);
					fprintf(rl, ", %.15le)\n", ptrans[r][i][j]);
				}
			}
		}
		ksum += K[r];
	}
}

void PS_PRrules(i)
int i;
{
	int r, j, s, k, l, ksum, kr;
	void arrival();

	ksum = 0;
	for (r = 0; r < R; ++r)
	{
		if (e[i - 1][r] == 0)
			continue;
		if (csq[i - 1][r] == 1)
		{
			for (j = 1; j <= N; ++j)
			{
				if (j != i && ptrans[r][i][j] > 0)
				{
					fprintf(rl, "\n	RULE((itmp = MIN(k%d_%d, ", i, r + 1);
					fprintf_kdiff(i, r);
					fprintf(rl, ")) > 0,\n");
					fprintf(rl, "			k%d_%d -= 1;\n", i, r + 1);
					arrival(j, r + 1);
					fprintf(rl, "		itmp * mue%d_%d, %.15le)\n",
						i, r + 1, ptrans[r][i][j]);
				}
			}
			continue;
		}
		kr = MIN(m[i - 1], K[r]);
		for (k = 1; k <= kr; ++k)
		{
			fprintf(rl, "\n	RULE(ph%d_%d_%d == 1", i, r + 1, k);
			fprintf(rl, " && (avail = ");
			fprintf_kdiff(i, r);
			fprintf(rl, ") > 0");
			fprintf(rl, ",\n");
			for (l = 1; l <= K[r]; ++l)
				fprintf(rl, "%s (ph%d_%d_%d > 0)",
					l == 1 ? "			itmp =" : " +", i, r + 1, l);
			fprintf(rl, ";\n");
			fprintf(rl, "			ph%d_%d_%d += 1,\n", i, r + 1, k);
			fprintf(rl, "		rel_mue%d_%d_1 * mue%d_%d", i, r + 1, i, r + 1);
			fprintf(rl, " / itmp * MIN(avail, itmp)");
			fprintf(rl, ", a%d_%d)\n", i, r + 1);
			if (ph[i - 1][r] > 2)
			{
				fprintf(rl, "\n	RULE(ph%d_%d_%d > 1 && ", i, r + 1, k);
				fprintf(rl, "ph%d_%d_%d < Ph%d_%d", i, r + 1, k, i, r + 1);
				fprintf(rl, " && (avail = ");
				fprintf_kdiff(i, r);
				fprintf(rl, ") > 0");
				fprintf(rl, ",\n");
				for (l = 1; l <= K[r]; ++l)
					fprintf(rl, "%s (ph%d_%d_%d > 0)",
						l == 1 ? "			itmp =" : " +", i, r + 1, l);
				fprintf(rl, ";\n");
				fprintf(rl, "			ph%d_%d_%d += 1,\n", i, r + 1, k);
				fprintf(rl, "		rel_mue%d_%d_2 * mue%d_%d",
					i, r + 1, i, r + 1);
				fprintf(rl, " / itmp * MIN(avail, itmp)");
				fprintf(rl, ", 1.0)\n");
			}
		}
		for (j = 1; j <= N; ++j)
		{
			if (ptrans[r][i][j] > 0)
			{
				for (k = 1; k <= kr; ++k)
				{
					if (i != j)
					{
						fprintf(rl, "\n	RULE(ph%d_%d_%d == 1", i, r + 1, k);
						fprintf(rl, " && (avail = ");
						fprintf_kdiff(i, r);
						fprintf(rl, ") > 0");
						fprintf(rl, ",\n");
						for (l = 1; l <= K[r]; ++l)
							fprintf(rl, "%s (ph%d_%d_%d > 0)",
								l == 1 ? "			itmp =" : " +",
								i, r + 1, l);
						fprintf(rl, ";\n");
						for (l = k; l < K[r]; ++l)
							fprintf(rl, "			ph%d_%d_%d = ph%d_%d_%d;\n",
								i, r + 1, l, i, r + 1, l + 1);
						fprintf(rl, "			ph%d_%d_%d = 0;\n",
							i, r + 1, K[r]);
						arrival(j, r + 1);
						fprintf(rl, "		rel_mue%d_%d_1 * mue%d_%d",
							i, r + 1, i, r + 1);
						fprintf(rl, ", (1 - a%d_%d) * %.15le)\n",
							i, r + 1, ptrans[r][i][j]);
					}
					fprintf(rl, "\n	RULE(ph%d_%d_%d == Ph%d_%d",
						i, r + 1, k, i, r + 1);
					fprintf(rl, " && (avail = ");
					fprintf_kdiff(i, r);
					fprintf(rl, ") > 0");
					fprintf(rl, ",\n");
					for (l = 1; l <= K[r]; ++l)
						fprintf(rl, "%s (ph%d_%d_%d > 0)",
							l == 1 ? "			itmp =" : " +", i, r + 1, l);
					fprintf(rl, ";\n");
					for (l = k; l < K[r]; ++l)
						fprintf(rl, "			ph%d_%d_%d = ph%d_%d_%d;\n",
							i, r + 1, l, i, r + 1, l + 1);
					fprintf(rl, "			ph%d_%d_%d = 0;\n",
						i, r + 1, K[r]);
					arrival(j, r + 1);
					fprintf(rl, "		rel_mue%d_%d_2 * mue%d_%d",
						i, r + 1, i, r + 1);
					fprintf(rl, ", %.15le)\n", ptrans[r][i][j]);
				}
			}
		}
		ksum += K[r];
	}
}
