#include <stdio.h>
#include <math.h>
#include "const+type.h"

static char *SccsId = "@(#)PEPSY:\tspec_prepare.c\t1.2\t92/03/27 11:44:41";

extern int N, R;
extern double e[NMAX][RMAX], mue[NMAX][RMAX];
extern double csq[NMAX][RMAX], ptrans[RMAX][NMAX + 1][NMAX + 1];

extern int ph[NMAX][RMAX], phmax[NMAX], ph_flag;
extern double b1[NMAX][RMAX], rel_mue1[NMAX][RMAX], rel_mue2[NMAX][RMAX];

void short_circuit0()
{
	int i, k, r;
	double leave;

	for (r = 0; r < R; ++r)
	{
		if (ptrans[r][0][0] == 1)
			continue;
		leave = 1 - ptrans[r][0][0];
		for (i = 1; i <= N; ++i)
			for (k = 1; k <= N; ++k)
				ptrans[r][i][k] += ptrans[r][i][0] * ptrans[r][0][k] / leave;
	}
}

void cox()
{
	int i, r;

	for (i = 0; i < N; ++i)
	{
		for (r = 0; r < R; ++r)
		{
			if (e[i][r] == 0)
				continue;
			if (csq[i][r] < 1)
			{
				ph[i][r] = ceil(1 / csq[i][r]);
				b1[i][r] = ((2.0 * csq[i][r] + 1) * ph[i][r] - 2 -
					sqrt((ph[i][r] - 4 * csq[i][r]) * ph[i][r] + 4)) /
					(2 * (csq[i][r] + 1) * (ph[i][r] - 1));
				rel_mue1[i][r] = rel_mue2[i][r] =
					ph[i][r] - b1[i][r] * (ph[i][r] - 1);
			}
			else if (csq[i][r] == 1)
			{
				ph[i][r] = 1;
				b1[i][r] = 1;
				rel_mue1[i][r] = 1;
			}
			else
			{
				double sqroot = sqrt(1.0 - 2.0 / (1.0 + csq[i][r]));

				ph[i][r] = 2;
				b1[i][r] = csq[i][r] * (1.0 - sqroot);
				rel_mue1[i][r] = 1.0 + sqroot;
				rel_mue2[i][r] = 1.0 - sqroot;
			}
			if (ph[i][r] > phmax[i])
				phmax[i] = ph[i][r];
		}
		if (phmax[i] != 1)
			ph_flag = 1;
	}
}
