#include <stdio.h>
#include "const+type.h"

static char *SccsId = "@(#)PEPSY:\tspec_rules.c\t1.2\t92/03/27 11:44:45";
extern int N, R, K[RMAX], m[NMAX], typ[NMAX], iR[NMAX], nq[NMAX];
extern double e[NMAX][RMAX], mue[NMAX][RMAX], *lmue[NMAX][RMAX];
extern double csq[NMAX][RMAX], ptrans[RMAX][NMAX + 1][NMAX + 1];

extern int ph[NMAX][RMAX], phmax[NMAX], ph_flag;

void fprintf_RULE(i)
int i;
{
	void FCFSrulesR1(), FESCrules(), ISrules(), PSrules();
	void FCFSrules(), LCFSrules(), SIROrules(), FCFS_NPrules();
	void FCFS_PRrules(), LCFS_PRrules(), PS_PRrules(), LCFS_PFrules();

	if (typ[i - 1] == FESC)
	{
		FESCrules(i);
		return;
	}
	if (iR[i - 1] == 1 && nq[i - 1] > 0)
	{
		FCFSrulesR1(i);
		return;
	}
	switch(nq[i - 1] == 0 ? IS : typ[i - 1])
	{
		case IS:
		{
			ISrules(i);
			break;
		}
		case PS:
		{
			PSrules(i);
			break;
		}
		case FCFS:
		{
			FCFSrules(i);
			break;
		}
		case LCFS:
		{
			LCFSrules(i);
			break;
		}
		case LCFS_PF:
		{
			LCFS_PFrules(i);
			break;
		}
		case SIRO:
		{
			SIROrules(i);
			break;
		}
		case FCFS_NP:
		case LCFS_NP:
		case SIRO_NP:
		{
			FCFS_NPrules(i);
			break;
		}
		case FCFS_PR:
		{
			FCFS_PRrules(i);
			break;
		}
		case LCFS_PR:
		{
			LCFS_PRrules(i);
			break;
		}
		case PS_PR:
		{
			PS_PRrules(i);
			break;
		}
	}
}

extern FILE *rl;

void FCFSrulesR1(i)
int i;
{
	int r, j, js;
	void arrival();

	for (r = 0; r < R; ++r)
	{
		if (e[i - 1][r] == 0)
			continue;
		if (csq[i - 1][r] == 1)
		{
			for (j = 1; j <= N; ++j)
			{
				if (i != j && ptrans[r][i][j] > 0)
				{
					fprintf(rl, "\n	RULE(k%d_%d > 0,\n", i, r + 1);
					fprintf(rl, "			k%d_%d -= 1;\n", i, r + 1);
					arrival(j, r + 1);
					fprintf(rl, "		mue%d_%d", i, r + 1);
					if (m[i - 1] > 1)
						fprintf(rl, " * MIN(k%d_%d, %d)", i, r + 1, m[i - 1]);
					fprintf(rl, ", %.15le)\n", ptrans[r][i][j]);
				}
			}
			continue;
		}
		for (js = 1; js <= m[i - 1]; ++js)
		{
			fprintf(rl, "\n	RULE(ph%d_%d == 1,\n", i, js);
			fprintf(rl, "			ph%d_%d += 1,\n", i, js);
			fprintf(rl, "		rel_mue%d_%d_1 * mue%d_%d, a%d_%d)\n",
				i, r + 1, i, r + 1, i, r + 1);
			if (ph[i - 1][r] > 2)
			{
				fprintf(rl, "\n	RULE(ph%d_%d > 1 && ", i, js);
				fprintf(rl, "ph%d_%d < Ph%d_%d,\n", i, js, i, r + 1);
				fprintf(rl, "			ph%d_%d += 1,\n", i, js);
				fprintf(rl, "		rel_mue%d_%d_2 * mue%d_%d, 1.0)\n",
					i, r + 1, i, r + 1);
			}
		}
		for (j = 1; j <= N; ++j)
		{
			if (ptrans[r][i][j] > 0)
			{
				for (js = 1; js <= m[i - 1]; ++js)
				{
					if (i != j)
					{
						fprintf(rl, "\n	RULE(ph%d_%d == 1,\n", i, js);
						fprintf(rl, "			k%d_%d -= 1;\n", i, r + 1);
						fprintf(rl, "			if (k%d_%d < %d)\n",
							i, r + 1, m[i - 1]);
						fprintf(rl, "				ph%d_%d = 0;\n", i, js);
						arrival(j, r + 1);
						fprintf(rl, "		rel_mue%d_%d_1 * mue%d_%d",
							i, r + 1, i, r + 1);
/*
						if (m[i - 1] > 1)
							fprintf(rl, " * MIN(k%d_%d, %d)",
								i, r + 1, m[i - 1]);
*/
						fprintf(rl, ", (1 - a%d_%d) * %.15le)\n",
							i, r + 1, ptrans[r][i][j]);
					}
					fprintf(rl, "\n	RULE(ph%d_%d == Ph%d_%d,\n",
						i, js, i, r + 1);
					if (i == j)
						fprintf(rl, "			ph%d_%d = 1,\n", i, js);
					else
					{
						fprintf(rl, "			k%d_%d -= 1;\n", i, r + 1);
						fprintf(rl, "			if (k%d_%d < %d)\n",
							i, r + 1, m[i - 1]);
						fprintf(rl, "				ph%d_%d = 0;\n", i, js);
						fprintf(rl, "			else\n");
						fprintf(rl, "				ph%d_%d = 1;\n", i, js);
						arrival(j, r + 1);
					}
					fprintf(rl, "		rel_mue%d_%d_2 * mue%d_%d",
						i, r + 1, i, r + 1);
/*
					if (m[i - 1] > 1)
						fprintf(rl, " * MIN(k%d_%d, %d)", i, r + 1, m[i - 1]);
*/
					fprintf(rl, ", %.15le)\n", ptrans[r][i][j]);
				}
			}
		}
	}
}

void FESCrules(i)
int i;
{
	int r, j, s;
	void arrival();

	for (r = 0; r < R; ++r)
	{
		if (e[i - 1][r] == 0)
			continue;
		if (csq[i - 1][r] == 1)
		{
			for (j = 1; j <= N; ++j)
			{
				if (j != i && ptrans[r][i][j] > 0 && e[i - 1][r])
				{
					fprintf(rl, "\n	RULE(k%d_%d > 0,\n", i, r + 1);
					fprintf(rl, "			k%d_%d -= 1;\n", i, r + 1);
					arrival(j, r + 1);
					fprintf(rl, "		lmue%d_%d", i, r + 1);
					for (s = 0; s < R; ++s)
						fprintf(rl, "[k%d_%d]", i, s + 1);
					fprintf(rl, ", %.15le)\n", ptrans[r][i][j]);
				}
			}
			continue;
		}
		fprintf(rl, "\n	RULE(ph%d_%d == 1 && k%d_%d > 0,\n",
			i, r + 1, i, r + 1);
		fprintf(rl, "			ph%d_%d += 1,\n", i, r + 1);
		fprintf(rl, "		rel_mue%d_%d_1 * lmue%d_%d", i, r + 1, i, r + 1);
		for (s = 0; s < R; ++s)
			fprintf(rl, "[k%d_%d]", i, s + 1);
		fprintf(rl, ", a%d_%d)\n", i, r + 1);
		if (ph[i - 1][r] > 2)
		{
			fprintf(rl, "\n	RULE(ph%d_%d > 1 && ", i, r + 1);
			fprintf(rl, "ph%d_%d < Ph%d_%d,\n", i, r + 1, i, r + 1);
			fprintf(rl, "			ph%d_%d += 1,\n", i, r + 1);
			fprintf(rl, "		rel_mue%d_%d_2 * lmue%d_%d",
				i, r + 1, i, r + 1);
			for (s = 0; s < R; ++s)
				fprintf(rl, "[k%d_%d]", i, s + 1);
			fprintf(rl, ", 1.0)\n");
		}
		for (j = 1; j <= N; ++j)
		{
			if (ptrans[r][i][j] > 0)
			{
				if (i != j)
				{
					fprintf(rl, "\n	RULE(ph%d_%d == 1 && k%d_%d > 0,\n",
						i, r + 1, i, r + 1);
					fprintf(rl, "			k%d_%d -= 1;\n", i, r + 1);
					arrival(j, r + 1);
					fprintf(rl, "		rel_mue%d_%d_1 * lmue%d_%d",
						i, r + 1, i, r + 1);
					for (s = 0; s < R; ++s)
						fprintf(rl, "[k%d_%d]", i, s + 1);
					fprintf(rl, ", (1 - a%d_%d) * %.15le)\n",
						i, r + 1, ptrans[r][i][j]);
				}
				fprintf(rl, "\n	RULE(ph%d_%d == Ph%d_%d,\n",
					i, r + 1, i, r + 1);
				if (i == j)
					fprintf(rl, "			ph%d_%d = 1,\n", i, r + 1);
				else
				{
					fprintf(rl, "			k%d_%d -= 1;\n", i, r + 1);
					fprintf(rl, "			ph%d_%d = 1;\n", i, r + 1);
					arrival(j, r + 1);
				}
				fprintf(rl, "		rel_mue%d_%d_2 * lmue%d_%d",
					i, r + 1, i, r + 1);
				for (s = 0; s < R; ++s)
					fprintf(rl, "[k%d_%d]", i, s + 1);
				fprintf(rl, ", %.15le)\n", ptrans[r][i][j]);
			}
		}
	}
}
