#include <stdio.h>
#include "const+type.h"

static char *SccsId = "@(#)PEPSY:\tspec_sij.c\t1.2\t92/03/27 11:44:47";

extern int N, R, K[RMAX], m[NMAX], typ[NMAX], iR[NMAX], nq[NMAX];
extern double e[NMAX][RMAX], mue[NMAX][RMAX], *lmue[NMAX][RMAX];
extern double csq[NMAX][RMAX], ptrans[RMAX][NMAX + 1][NMAX + 1];

extern int ph[NMAX][RMAX], phmax[NMAX], ph_flag;

extern FILE *rl;

static void endo(i, r)
int i;
{
	int js;

	for (js = 1; js <= m[i - 1]; ++js)
	{
		fprintf(rl, "\n	RULE(s%d_%d == %d && ph%d_%d == 1,\n",
			i, js, r + 1, i, js);
		fprintf(rl, "			ph%d_%d += 1,\n", i, js);
		fprintf(rl, "		rel_mue%d_%d_1 * mue%d_%d, a%d_%d)\n",
			i, r + 1, i, r + 1, i, r + 1);
		if (ph[i - 1][r] > 2)
		{
			fprintf(rl, "\n	RULE(s%d_%d == %d && ph%d_%d > 1 && ",
				i, js, r + 1, i, js);
			fprintf(rl, "ph%d_%d < Ph%d_%d,\n", i, js, i, r + 1);
			fprintf(rl, "			ph%d_%d += 1,\n", i, js);
			fprintf(rl, "		rel_mue%d_%d_2 * mue%d_%d, 1.0)\n",
				i, r + 1, i, r + 1);
		}
	}
}

void FCFSrules(i)
int i;
{
	int r, j, js, jq;
	void arrival();

	for (r = 0; r < R; ++r)
	{
		if (e[i - 1][r] == 0)
			continue;
		if (csq[i - 1][r] == 1)
		{
			for (j = 1; j <= N; ++j)
			{
				if (ptrans[r][i][j] > 0)
				{
					for (js = 1; js <= m[i - 1]; ++js)
					{
						fprintf(rl, "\n	RULE(s%d_%d == %d", i, js, r + 1);
						if (i == j)
						{
							fprintf(rl, " && (");
							for (jq = 1; jq <= nq[i - 1]; ++jq)
							{
								if (jq > 1)
									fprintf(rl, " || ");
								fprintf(rl, "q%d_%d > 0 && q%d_%d != %d",
									i, jq, i, jq, r + 1);
							}
							fprintf(rl, ")");
						}
						fprintf(rl, ",\n			s%d_%d = q%d_1;\n",
							i, js, i);
						for (jq = 1; jq < nq[i - 1]; ++jq)
							fprintf(rl, "			q%d_%d = q%d_%d;\n",
								i, jq, i, jq + 1);
						fprintf(rl, "			q%d_%d = 0;\n", i, jq);
						arrival(j, r + 1);
						fprintf(rl, "		mue%d_%d, %.15le)\n",
							i, r + 1, ptrans[r][i][j]);
					}
				}
			}
			continue;
		}
		endo(i, r);
		for (j = 1; j <= N; ++j)
		{
			if (ptrans[r][i][j] > 0)
			{
				for (js = 1; js <= m[i - 1]; ++js)
				{
					fprintf(rl, "\n	RULE(s%d_%d == %d", i, js, r + 1);
					fprintf(rl, " && ph%d_%d == 1", i, js);
					if (i == j)
					{
						fprintf(rl, " && (");
						for (jq = 1; jq <= nq[i - 1]; ++jq)
						{
							if (jq > 1)
								fprintf(rl, " || ");
							fprintf(rl, "q%d_%d > 0 && q%d_%d != %d",
								i, jq, i, jq, r + 1);
						}
						fprintf(rl, ")");
					}
					fprintf(rl, ",\n			s%d_%d = q%d_1;\n",
						i, js, i);
					for (jq = 1; jq < nq[i - 1]; ++jq)
						fprintf(rl, "			q%d_%d = q%d_%d;\n",
							i, jq, i, jq + 1);
					fprintf(rl, "			q%d_%d = 0;\n", i, jq);
					arrival(j, r + 1);
					fprintf(rl, "		rel_mue%d_%d_1 * mue%d_%d",
						i, r + 1, i, r + 1);
					fprintf(rl, ", (1 - a%d_%d) * %.15le)\n",
						i, r + 1, ptrans[r][i][j]);

					fprintf(rl, "\n	RULE(s%d_%d == %d", i, js, r + 1);
					fprintf(rl, " && ph%d_%d == Ph%d_%d", i, js, i, r + 1);
					fprintf(rl, ",\n			s%d_%d = q%d_1;\n",
						i, js, i);
					fprintf(rl, "			ph%d_%d = 1;\n", i, js);
					for (jq = 1; jq < nq[i - 1]; ++jq)
						fprintf(rl, "			q%d_%d = q%d_%d;\n",
							i, jq, i, jq + 1);
					fprintf(rl, "			q%d_%d = 0;\n", i, jq);
					arrival(j, r + 1);
					fprintf(rl, "		rel_mue%d_%d_2 * mue%d_%d, %.15le)\n",
						i, r + 1, i, r + 1, ptrans[r][i][j]);
				}
			}
		}
	}
}

void LCFSrules(i)
int i;
{
	int r, j, js, jq;
	void arrival();

	for (r = 0; r < R; ++r)
	{
		if (e[i - 1][r] == 0)
			continue;
		if (csq[i - 1][r] == 1)
		{
			for (j = 1; j <= N; ++j)
			{
				if (j != i && ptrans[r][i][j] > 0)
				{
					for (js = 1; js <= m[i - 1]; ++js)
					{
						fprintf(rl, "\n	RULE(s%d_%d == %d,\n", i, js, r + 1);
						for (jq = nq[i - 1]; jq > 0; --jq)
						{
							fprintf(rl, "			%sif (q%d_%d > 0)\n",
								jq < nq[i - 1] ? "else " : "", i, jq);
							fprintf(rl, "			{\n");
							fprintf(rl, "				s%d_%d = q%d_%d;\n",
								i, js, i, jq);
							fprintf(rl, "				q%d_%d = 0;\n", i, jq);
							fprintf(rl, "			}\n");
						}
						fprintf(rl, "			else\n");
						fprintf(rl, "				s%d_%d = 0;\n", i, js);
						arrival(j, r + 1);
						fprintf(rl, "		mue%d_%d, %.15le)\n",
							i, r + 1, ptrans[r][i][j]);
					}
				}
			}
			continue;
		}
		endo(i, r);
		for (j = 1; j <= N; ++j)
		{
			if (ptrans[r][i][j] > 0)
			{
				for (js = 1; js <= m[i - 1]; ++js)
				{
					if (i != j)
					{
						fprintf(rl, "\n	RULE(s%d_%d == %d", i, js, r + 1);
						fprintf(rl, " && ph%d_%d == 1,\n", i, js);
						for (jq = nq[i - 1]; jq > 0; --jq)
						{
							fprintf(rl, "			%sif (q%d_%d > 0)\n",
								jq < nq[i - 1] ? "else " : "", i, jq);
							fprintf(rl, "			{\n");
							fprintf(rl, "				s%d_%d = q%d_%d;\n",
								i, js, i, jq);
							fprintf(rl, "				q%d_%d = 0;\n", i, jq);
							fprintf(rl, "			}\n");
						}
						fprintf(rl, "			else\n");
						fprintf(rl, "				s%d_%d = 0;\n", i, js);
						arrival(j, r + 1);
						fprintf(rl, "		rel_mue%d_%d_1 * mue%d_%d",
							i, r + 1, i, r + 1);
						fprintf(rl, ", (1 - a%d_%d) * %.15le)\n",
							i, r + 1, ptrans[r][i][j]);
					}

					fprintf(rl, "\n	RULE(s%d_%d == %d", i, js, r + 1);
					fprintf(rl, " && ph%d_%d == Ph%d_%d,\n", i, js, i, r + 1);
					if (i == j)
						fprintf(rl, "			ph%d_%d = 1,\n", i, js);
					else
					{
						fprintf(rl, "			ph%d_%d = 1;\n", i, js);
						for (jq = nq[i - 1]; jq > 0; --jq)
						{
							fprintf(rl, "			%sif (q%d_%d > 0)\n",
								jq < nq[i - 1] ? "else " : "", i, jq);
							fprintf(rl, "			{\n");
							fprintf(rl, "				s%d_%d = q%d_%d;\n",
								i, js, i, jq);
							fprintf(rl, "				q%d_%d = 0;\n", i, jq);
							fprintf(rl, "			}\n");
						}
						fprintf(rl, "			else\n");
						fprintf(rl, "				s%d_%d = 0;\n", i, js);
						arrival(j, r + 1);
					}
					fprintf(rl, "		rel_mue%d_%d_2 * mue%d_%d, %.15le)\n",
						i, r + 1, i, r + 1, ptrans[r][i][j]);
				}
			}
		}
	}
}

void SIROrules(i)
int i;
{
	int r, j, s, js, ss, firstflag;
	void arrival();

	for (r = 0; r < R; ++r)
	{
		if (e[i - 1][r] == 0)
			continue;
		if (csq[i - 1][r] == 1)
		{
			for (j = 1; j <= N; ++j)
			{
				if (ptrans[r][i][j] > 0)
				{
					for (js = 1; js <= m[i - 1]; ++js)
					{
						if (i != j)
						{
							fprintf(rl, "\n	RULE(s%d_%d == %d", i, js, r + 1);
							for (s = 0; s < R; ++s)
								if (e[i - 1][s])
									fprintf(rl, " && w%d_%d == 0", i, s + 1);
							fprintf(rl, ",\n");
							fprintf(rl, "			s%d_%d = 0;\n", i, js);
							arrival(j, r + 1);
							fprintf(rl, "		mue%d_%d, ", i, r + 1);
							fprintf(rl, "%.15le)\n", ptrans[r][i][j]);
						}
						for (s = 0; s < R; ++s)
						{
							if (i == j && r == s || e[i - 1][s] == 0)
								continue;
							fprintf(rl, "\n	RULE(s%d_%d == %d && w%d_%d > 0,\n",
								i, js, r + 1, i, s + 1);
							firstflag = 1;
							for (ss = 0; ss < R; ++ss)
							{
								if (e[i - 1][ss])
								{
									if (firstflag)
									{
										fprintf(rl, "			itmp = %s",
											i == j ? "1 + " : "");
										fprintf(rl, "w%d_%d", i, ss + 1);
										firstflag = 0;
									}
									else
										fprintf(rl, " + w%d_%d", i, ss + 1);
								}
							}
							fprintf(rl, ";\n");
							fprintf(rl, "			w%d_%d -= 1;\n", i, s + 1);
							fprintf(rl, "			s%d_%d = %d;\n",
								i, js, s + 1);
							arrival(j, r + 1);
							fprintf(rl, "		mue%d_%d, ", i, r + 1);
							fprintf(rl, "%.15le * w%d_%d / itmp)\n",
								ptrans[r][i][j], i, s + 1);
						}
					}
				}
			}
			continue;
		}
		endo(i, r);
		for (j = 1; j <= N; ++j)
		{
			if (ptrans[r][i][j] > 0)
			{
				for (js = 1; js <= m[i - 1]; ++js)
				{
					if (i != j)
					{
						fprintf(rl, "\n	RULE(s%d_%d == %d", i, js, r + 1);
						fprintf(rl, " && ph%d_%d == 1", i, js);
						for (s = 0; s < R; ++s)
							if (e[i - 1][s])
								fprintf(rl, " && w%d_%d == 0", i, s + 1);
						fprintf(rl, ",\n");
						fprintf(rl, "			s%d_%d = 0;\n", i, js);
						arrival(j, r + 1);
						fprintf(rl, "		rel_mue%d_%d_1 * mue%d_%d",
							i, r + 1, i, r + 1);
						fprintf(rl, ", (1 - a%d_%d) * %.15le)\n",
							i, r + 1, ptrans[r][i][j]);
					}
					for (s = 0; s < R; ++s)
					{
						if (i == j && r == s || e[i - 1][s] == 0)
							continue;
						fprintf(rl, "\n	RULE(s%d_%d == %d", i, js, r + 1);
						fprintf(rl, " && ph%d_%d == 1", i, js);
						fprintf(rl, " && w%d_%d > 0,\n", i, s + 1);
						firstflag = 1;
						for (ss = 0; ss < R; ++ss)
						{
							if (e[i - 1][ss])
							{
								if (firstflag)
								{
									fprintf(rl, "			itmp = %s",
										i == j ? "1 + " : "");
									fprintf(rl, "w%d_%d", i, ss + 1);
									firstflag = 0;
								}
								else
									fprintf(rl, " + w%d_%d", i, ss + 1);
							}
						}
						fprintf(rl, ";\n");
						fprintf(rl, "			w%d_%d -= 1;\n", i, s + 1);
						fprintf(rl, "			s%d_%d = %d;\n",
							i, js, s + 1);
						arrival(j, r + 1);
						fprintf(rl, "		rel_mue%d_%d_1 * mue%d_%d",
							i, r + 1, i, r + 1);
						fprintf(rl, ", (1 - a%d_%d) * %.15le",
							i, r + 1, ptrans[r][i][j]);
						fprintf(rl, " * w%d_%d / itmp)\n", i, s + 1);
					}

					if (i != j)
					{
						fprintf(rl, "\n	RULE(s%d_%d == %d", i, js, r + 1);
						fprintf(rl, " && ph%d_%d == Ph%d_%d", i, js, i, r + 1);
						for (s = 0; s < R; ++s)
							if (e[i - 1][s])
								fprintf(rl, " && w%d_%d == 0", i, s + 1);
						fprintf(rl, ",\n");
						fprintf(rl, "			s%d_%d = 0;\n", i, js);
						fprintf(rl, "			ph%d_%d = 1;\n", i, js);
						arrival(j, r + 1);
						fprintf(rl, "		rel_mue%d_%d_2 * mue%d_%d",
							i, r + 1, i, r + 1);
						fprintf(rl, ", %.15le)\n", ptrans[r][i][j]);
					}
					for (s = 0; s < R; ++s)
					{
						if (e[i - 1][s] == 0)
							continue;
						fprintf(rl, "\n	RULE(s%d_%d == %d", i, js, r + 1);
						fprintf(rl, " && ph%d_%d == Ph%d_%d", i, js, i, r + 1);
						if (i != j || r != s)
							fprintf(rl, " && w%d_%d > 0", i, s + 1);
						fprintf(rl, ",\n");
						firstflag = 1;
						for (ss = 0; ss < R; ++ss)
						{
							if (e[i - 1][ss])
							{
								if (firstflag)
								{
									fprintf(rl, "			itmp = %s",
										i == j ? "1 + " : "");
									fprintf(rl, "w%d_%d", i, ss + 1);
									firstflag = 0;
								}
								else
									fprintf(rl, " + w%d_%d", i, ss + 1);
							}
						}
						fprintf(rl, ";\n");
						if (i == j && r == s)
							fprintf(rl, "			ph%d_%d = 1,\n", i, js);
						else
						{
							fprintf(rl, "			w%d_%d -= 1;\n", i, s + 1);
							fprintf(rl, "			s%d_%d = %d;\n",
								i, js, s + 1);
							fprintf(rl, "			ph%d_%d = 1;\n", i, js);
							arrival(j, r + 1);
						}
						fprintf(rl, "		rel_mue%d_%d_2 * mue%d_%d",
							i, r + 1, i, r + 1);
						if (i == j && r == s)
							fprintf(rl, ", %.15le * (1 + w%d_%d) / itmp)\n",
								ptrans[r][i][j], i, s + 1);
						else
							fprintf(rl, ", %.15le * w%d_%d / itmp)\n",
								ptrans[r][i][j], i, s + 1);
					}
				}
			}
		}
	}
}

void FCFS_NPrules(i)
int i;
{
	int r, j, s, js, ir, is;
	void arrival();

	ir = 0;
	for (r = 0; r < R; ++r)
	{
		if (e[i - 1][r] == 0)
			continue;
		ir++;
		if (csq[i - 1][r] == 1)
		{
			for (j = 1; j <= N; ++j)
			{
				if (ptrans[r][i][j] > 0)
				{
					for (js = 1; js <= m[i - 1]; ++js)
					{
						if (i == j)
						{
							if (ir == 1)
								continue;
							fprintf(rl, "\n	RULE(s%d_%d == %d", i, js, r + 1);
							is = 0;
							for (s = 0; s < r; ++s)
							{
								if (e[i - 1][s] == 0)
									continue;
								++is;
								fprintf(rl, "%sw%d_%d > 0",
									is > 1 ? " || " : " && (", i, s + 1);
							}
							fprintf(rl, "),\n");
							is = 0;
							for (s = 0; s < r; ++s)
							{
								if (e[i - 1][s] == 0)
									continue;
								++is;
								fprintf(rl, "			%sif (w%d_%d > 0)\n",
									is > 1 ? "else " : "", i, s + 1);
								fprintf(rl, "			{\n");
								fprintf(rl, "				s%d_%d = %d;\n",
									i, js, s + 1);
								fprintf(rl, "				w%d_%d -= 1;\n",
									i, s + 1);
								fprintf(rl, "			}\n");
							}
							arrival(j, r + 1);
							fprintf(rl, "		mue%d_%d, %.15le)\n",
								i, r + 1, ptrans[r][i][j]);
						}
						else
						{
							fprintf(rl, "\n	RULE(s%d_%d == %d,\n", i, js, r + 1);
							is = 0;
							for (s = 0; s < R; ++s)
							{
								if (e[i - 1][s] == 0)
									continue;
								++is;
								fprintf(rl, "			%sif (w%d_%d > 0)\n",
									is > 1 ? "else " : "", i, s + 1);
								fprintf(rl, "			{\n");
								fprintf(rl, "				s%d_%d = %d;\n",
									i, js, s + 1);
								fprintf(rl, "				w%d_%d -= 1;\n",
									i, s + 1);
								fprintf(rl, "			}\n");
							}
							fprintf(rl, "			else\n");
							fprintf(rl, "				s%d_%d = 0;\n", i, js);
							arrival(j, r + 1);
							fprintf(rl, "		mue%d_%d, %.15le)\n",
								i, r + 1, ptrans[r][i][j]);
						}
					}
				}
			}
			continue;
		}
		endo(i, r);
		for (j = 1; j <= N; ++j)
		{
			if (ptrans[r][i][j] > 0)
			{
				for (js = 1; js <= m[i - 1]; ++js)
				{
					if (i == j)
					{
						if (ir > 1)
						{
							fprintf(rl, "\n	RULE(s%d_%d == %d", i, js, r + 1);
							fprintf(rl, " && ph%d_%d == 1", i, js);
							is = 0;
							for (s = 0; s < r; ++s)
							{
								if (e[i - 1][s] == 0)
									continue;
								++is;
								fprintf(rl, "%sw%d_%d > 0",
									is > 1 ? " || " : " && (", i, s + 1);
							}
							fprintf(rl, "),\n");
							is = 0;
							for (s = 0; s < r; ++s)
							{
								if (e[i - 1][s] == 0)
									continue;
								++is;
								fprintf(rl, "			%sif (w%d_%d > 0)\n",
									is > 1 ? "else " : "", i, s + 1);
								fprintf(rl, "			{\n");
								fprintf(rl, "				s%d_%d = %d;\n",
									i, js, s + 1);
								fprintf(rl, "				w%d_%d -= 1;\n",
									i, s + 1);
								fprintf(rl, "			}\n");
							}
							arrival(j, r + 1);
							fprintf(rl, "		mue%d_%d", i, r + 1);
							fprintf(rl, ", (1 - a%d_%d) * %.15le)\n",
								i, r + 1, ptrans[r][i][j]);
						}
					}
					else
					{
						fprintf(rl, "\n	RULE(s%d_%d == %d", i, js, r + 1);
						fprintf(rl, " && ph%d_%d == 1", i, js);
						fprintf(rl, ",\n");
						is = 0;
						for (s = 0; s < R; ++s)
						{
							if (e[i - 1][s] == 0)
								continue;
							++is;
							fprintf(rl, "			%sif (w%d_%d > 0)\n",
								is > 1 ? "else " : "", i, s + 1);
							fprintf(rl, "			{\n");
							fprintf(rl, "				s%d_%d = %d;\n",
								i, js, s + 1);
							fprintf(rl, "				w%d_%d -= 1;\n",
								i, s + 1);
							fprintf(rl, "			}\n");
						}
						fprintf(rl, "			else\n");
						fprintf(rl, "				s%d_%d = 0;\n", i, js);
						arrival(j, r + 1);
						fprintf(rl, "		mue%d_%d", i, r + 1);
						fprintf(rl, ", (1 - a%d_%d) * %.15le)\n",
							i, r + 1, ptrans[r][i][j]);
					}

					if (i == j)
					{
						fprintf(rl, "\n	RULE(s%d_%d == %d", i, js, r + 1);
						fprintf(rl, " && ph%d_%d == Ph%d_%d", i, js, i, r + 1);
						fprintf(rl, ",\n");
						is = 0;
						for (s = 0; s < r; ++s)
						{
							if (e[i - 1][s] == 0)
								continue;
							++is;
							fprintf(rl, "			%sif (w%d_%d > 0)\n",
								is > 1 ? "else " : "", i, s + 1);
							fprintf(rl, "			{\n");
							fprintf(rl, "				s%d_%d = %d;\n",
								i, js, s + 1);
							fprintf(rl, "				w%d_%d -= 1;\n",
								i, s + 1);
							fprintf(rl, "				w%d_%d += 1;\n",
								i, r + 1);
							fprintf(rl, "			}\n");
						}
						fprintf(rl, "			ph%d_%d = 1,\n", i, js);
						fprintf(rl, "		mue%d_%d", i, r + 1);
						fprintf(rl, ", %.15le)\n", ptrans[r][i][j]);
					}
					else
					{
						fprintf(rl, "\n	RULE(s%d_%d == %d", i, js, r + 1);
						fprintf(rl, " && ph%d_%d == Ph%d_%d", i, js, i, r + 1);
						fprintf(rl, ",\n");
						is = 0;
						for (s = 0; s < R; ++s)
						{
							if (e[i - 1][s] == 0)
								continue;
							++is;
							fprintf(rl, "			%sif (w%d_%d > 0)\n",
								is > 1 ? "else " : "", i, s + 1);
							fprintf(rl, "			{\n");
							fprintf(rl, "				s%d_%d = %d;\n",
								i, js, s + 1);
							fprintf(rl, "				w%d_%d -= 1;\n",
								i, s + 1);
							fprintf(rl, "			}\n");
						}
						fprintf(rl, "			else\n");
						fprintf(rl, "				s%d_%d = 0;\n", i, js);
						fprintf(rl, "			ph%d_%d = 1;\n", i, js);
						arrival(j, r + 1);
						fprintf(rl, "		mue%d_%d", i, r + 1);
						fprintf(rl, ", %.15le)\n", ptrans[r][i][j]);
					}
				}
			}
		}
	}
}

void LCFS_PFrules(i)
int i;
{
	int r, j, js, jq,is;
	void arrival();

	for (r = 0; r < R; ++r)
	{
		if (e[i - 1][r] == 0)
			continue;
		if (csq[i - 1][r] == 1)     /* Exponentialverteilung */
		{
			for (j = 1; j <= N; ++j)
			{
				if (j != i && ptrans[r][i][j] > 0)
				{
					for (js = 1; js <= m[i - 1]; ++js)
					{
						fprintf(rl, "\n	RULE(s%d_%d == %d,\n", i, js, r + 1);
						for(is = js; is > 1; is--)
						{
							fprintf(rl, "				s%d_%d = s%d_%d;\n",i,is,i,is-1); 
						}
						fprintf(rl, "				s%d_%d = q%d_%d;\n", i,1,i,1);
						for (jq = 1; jq < nq[i - 1] ;  ++jq)
						{
							fprintf(rl, "				q%d_%d = q%d_%d;\n", i, jq, i, jq+1);
						}
						fprintf(rl, "				q%d_%d = 0;\n", i, jq );
						arrival(j, r + 1);
						fprintf(rl, "		mue%d_%d, %.15lg)\n",
							i, r + 1, ptrans[r][i][j]);
					}
				}
			}
			continue;
		}
		endo(i, r);    /* Phasenverteilung */
		for (j = 1; j <= N; ++j)
		{
			if (ptrans[r][i][j] > 0)
			{
				for (js = 1; js <= m[i - 1]; ++js)
				{
					if (i != j)
					{
						fprintf(rl, "\n	RULE(s%d_%d == %d", i, js, r + 1);
						fprintf(rl, " && ph%d_%d == 1,\n", i, js);
						for(is = js; is > 1; is--)
						{
							fprintf(rl, "				s%d_%d = s%d_%d;\n",i,is,i,is-1); 
							fprintf(rl, "				ph%d_%d = ph%d_%d;\n",i,is,i,is-1); 
						}
						fprintf(rl, "				s%d_%d = q%d_%d;\n", i,1,i,1);
						fprintf(rl, "				s%d_%d = ph%d_%d;\n", i,1,i,1);
						for (jq = 1; jq < nq[i - 1] ;  ++jq)
						{
							fprintf(rl, "				q%d_%d = q%d_%d;\n", i, jq, i, jq+1);
						}
						fprintf(rl, "				q%d_%d = 0;\n", i, jq );
						arrival(j, r + 1);
						fprintf(rl, "		rel_mue%d_%d_1 * mue%d_%d",
							i, r + 1, i, r + 1);
						fprintf(rl, ", (1 - a%d_%d) * %.15le)\n",
							i, r + 1, ptrans[r][i][j]);
					}

					fprintf(rl, "\n	RULE(s%d_%d == %d", i, js, r + 1);
					fprintf(rl, " && ph%d_%d == Ph%d_%d,\n", i, js, i, r + 1);
					if (i == j)
						fprintf(rl, "			ph%d_%d = 1,\n", i, js);
					else
					{
						for(is = js; is > 1; is--)
						{
							fprintf(rl, "				s%d_%d = s%d_%d;\n",i,is,i,is-1); 
							fprintf(rl, "				ph%d_%d = ph%d_%d;\n",i,is,i,is-1); 
						}
						fprintf(rl, "				s%d_%d = q%d_%d;\n", i,1,i,1);
						fprintf(rl, "				s%d_%d = ph%d_%d;\n", i,1,i,1);
						for (jq = 1; jq < nq[i - 1] ;  ++jq)
						{
							fprintf(rl, "				q%d_%d = q%d_%d;\n", i, jq, i, jq+1);
						}
						fprintf(rl, "				q%d_%d = 0;\n", i, jq );
						arrival(j, r + 1);
					}
					fprintf(rl, "		rel_mue%d_%d_2 * mue%d_%d, %.15le)\n",
						i, r + 1, i, r + 1, ptrans[r][i][j]);
				}
			}
		}
	}
}
