static char *SccsId = "@(#)PEPSY:\tcutilities.c\t1.2\t92/03/27 11:45:05";
#include <stdio.h>
#include <string.h>

extern int lineno;
extern char **maxstring;

void error();

typedef struct Listelem {
   char *var;
   unsigned short type;
   struct Listelem *next;
} Listelem;

#define NULLP (Listelem *)0
static  Listelem *varlist= NULLP; 
static  Listelem *end_of_list= NULLP; 
/* Returns 0 on success, and a number > 0 on failure. */
/* Parameters: Length, type and address of variable. */
int install(length, vtype, strp)
int length;
unsigned short vtype;
char *strp;
{
   Listelem *ende;
   Listelem *listp;
   char *charp;
   char *malloc();

   charp = malloc(length+1);
   if (charp == (char *)0)
      error(__FILE__, __LINE__, "malloc().");

   charp = strcpy(charp, strp);

   listp = (Listelem *)malloc(sizeof(Listelem));
   if (listp == NULLP)
      error(__FILE__, __LINE__, "malloc().");

   listp->var = charp;
   listp->type = vtype;
   listp->next = NULLP;

   if(varlist == NULLP)
   {
		/* first entry */
		varlist = listp;
		end_of_list = listp;
	}
	else
	{
		end_of_list->next = listp;
		end_of_list = listp;
	}
		
   return 0;
}

/* Returns 0 on success. */
/* Iff there is no such Variable 1 is returned. */
/* Iff types do not match 2 is returned. */
/* Parameters: Type and address of variable. */
int lookup(vtype, strp)
unsigned short vtype;
char *strp;
{
   Listelem *listp;

   listp = varlist;

   while (listp != NULLP)
   {
      if (strcmp(listp->var, strp) == 0)
      {  if (listp->type <= vtype) return 0;
         else
         {  fprintf(stderr,
            "Warnung Zeile %d, Variable %s. Typkonflikt!\n", lineno, strp);/*FEH*/

            return 2;
         }
      }
      else listp = listp->next;
   }

   fprintf(stderr,
           "Fehler Zeile %d. Unbekannte Variable %s.\n", lineno, strp);/*FEH*/
   return 1;
} 

/* Returns pointer to a string. At list end (char *)0 is returned. */
/* Parameter: Index of desired variable. */
/* (Return Parameter: Type of variable. */
char *getvar(ind, typep)
int ind;
unsigned short *typep;
{
   static Listelem *listp;
   char *helpp;

   if (ind < 0) listp = varlist;

   while (ind > 0)
   {
      if (listp == NULLP) break;
      ind--;
      listp = listp->next;
   }

   if (listp == NULLP)
   {  typep = (unsigned short *)0;
      return (char *)0;
   }
   else
   {  helpp = listp->var;
      *typep = listp->type;
      listp = listp->next;
      return (helpp);
   }
}

/*************************************************/
#define CODE_BUF_S 200

static char code_buf[CODE_BUF_S];
static free = CODE_BUF_S;
static n_elem_p = 0;

void append(length, format, string)
int length;
char *format, *string;
{
	
   if (free > length)
   {  sprintf((code_buf+n_elem_p), format, string);
      free -= length;
      n_elem_p += length;
#ifdef DEBUG
      fprintf(stderr, "Expression: %s\n", code_buf);
#endif
   }
   else
      error(__FILE__, __LINE__, "append(): Das Feld code_buf ist zu klein.");
}

/* mode == 0; Zerstoerendes Schreiben. */
/* mode != 0; Nicht Zerstoerendes Schreiben. */
char *write_str(mode)
short mode;
{
#ifdef DEBUG
   if ((mode == 0) && (n_elem_p > 0))
      fprintf(stderr, "---------------------\n");
#endif
   
   if (n_elem_p == 0) *code_buf = '\0';

   if (mode == 0)
   {
      free = CODE_BUF_S;
      n_elem_p = 0;
   }

   return (code_buf);
}


#define MAXSTRINGDIM 80

alloc_max(num)
unsigned int num;
{
	register i;
	char *malloc();

	maxstring = (char **) malloc(num*sizeof(char *));
	if(maxstring == (char **) 0)
	{
		fprintf(stderr,"no more space (alloc_max)\n");
		exit(1);
	}
#ifdef DEBUG
	fprintf(stderr,"alloc_max: head allocated\n");
#endif
	for(i=0;i<num;i++)
	{
		maxstring[i] = malloc(MAXSTRINGDIM*sizeof(char));
		if(maxstring[i] == (char * ) 0)
		{
			fprintf(stderr,"no more space (alloc_max)\n");
			exit(1);
		}
#ifdef DEBUG
	fprintf(stderr,"alloc_max: element %d allocated\n",i);
#endif
	}
}

void error(filename, lineno, cll)
char *filename, *cll;
int lineno;
{
   (void)fprintf(stderr, "\nDatei %s, Zeile %d. %s\n",
                 filename, lineno, cll);
   exit(1);
}

