#ifdef __cplusplus
   #include <stdio.h>
   extern "C" {
     extern void yyerror(char *);
     extern int yylex();
   }
#endif	/* __cplusplus */ 

# line 6 "specgram.y"
short c_error = 0;
/* c_error = 0: Weder Fehler noch Warnung;
   c_error = 1: Warnung;
   c_error = 2: Fehler;
*/

unsigned short typeflag;
/* typeflag = 1: type is int;
   typeflag = 2: type is double and 0 <= value <= 1.0;
   typeflag = 3: type is double;
*/

char **maxstring;  
int c;
/* dynamische Obergrenzen 
*/
unsigned int leftside = 1;
int c;
/* welchen Zustandsvektor soll ich verwenden ???
*/
# define VAR 257
# define DIM 258
# define MAX 259
# define MIN 260
# define NOT 261
# define SUM 262
# define RULE 263
# define GOES_TO 264
# define FDECL 265
# define IDECL 266
# define PDECL 267
# define OUTPUT 268
# define RESULT 269
# define FINAL 270
# define CONST 271
# define VARIABLE 272
# define VAL 273
# define DELIM 274
# define SEPARATOR 275
# define QUESTION 276
# define QDELIM 277
# define LEFT 278
# define RIGHT 279
# define LEFTS 280
# define RIGHTS 281
# define LEFTV 282
# define RIGHTV 283
# define EQ 284
# define NE 285
# define LE 286
# define GE 287
# define L 288
# define G 289
# define OR 290
# define AND 291
# define ADD 292
# define MINUS 293
# define MULT 294
# define DIV 295
# define ASSIGN 296
# define ADDASS 297
# define MINASS 298
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif

/* __YYSCLASS defines the scoping/storage class for global objects
 * that are NOT renamed by the -p option.  By default these names
 * are going to be 'static' so that multi-definition errors
 * will not occur with multiple parsers.
 * If you want (unsupported) access to internal names you need
 * to define this to be null so it implies 'extern' scope.
 * This should not be used in conjunction with -p.
 */
#ifndef __YYSCLASS
# define __YYSCLASS static
#endif
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval;
__YYSCLASS YYSTYPE yyval;
typedef int yytabelem;
# define YYERRCODE 256

# line 351 "specgram.y"

/*looper	:	AND | OR
	;
*/

#include <stdio.h>
#include "specgraml.c"
#include "cutilities.h"


char OUTPUT_MAT[] = "(void)fprintf(fpmat, \"%lu %lu %lg\\n\", j, k, __rate)";
char OUTPUT_COD[] = "(void)fprintf(fpcod, \"%lu \", j)";
unsigned long vectordim = 0;
short count = 0;

main(argc, argv)
int argc;
char *argv[];
{

   firstblock();
   yyparse();
   printf("}\n\n");

   if (c_error == 1) exit(1);
   if (c_error == 2) exit(2);
   exit(0);

}


firstblock()
{
   printf("/* First block. */\n");
   printf("#include <stdio.h>\n");
   printf("#include <assert.h>\n\n");
   
   printf("#include \"rutilities.c\"\n\n");
   printf("#include \"priv_excl.c\"\n\n");
   printf("#include \"priv_rules.c\"\n\n");

   printf("int dimension;\n");
   printf("int base;\n");
   printf("unsigned long state_count;\n");
   printf("int *__x1, *__x2, *__x3, *min, *max;\n");
   printf("FILE  *fpcod, *fpdim, *fpmat, *fppar;\n\n");

   printf("void setbuf(), free();\n");
   printf("char *calloc();\n");
   printf("int fclose();\n");
   printf("FILE *fopen();\n");
   printf("unsigned long encode();\n");
   printf("void copy(), error();\n");
   printf("/* First block end. */\n\n");

}

void secondblock()
{
   printf("\n/* Second block. */\n");
   printf("main(argc,argv)\n");
   printf("int argc;\nchar *argv[];\n");
   printf("{\n");
   printf("int i, j;\n");
   printf("int retval;\n\n");

   printf("int exclusions();\n");
   printf("void rules();\n\n");

   printf("parse_options(argc,argv);\n");

   printf("fpcod = fopen(\"Codierung.tmp\",\"w+\");\n");
   printf("if (fpcod == (FILE *)0) error(__FILE__, \"fopen-Codierung.tmp\", __LINE__);\n");
   printf("fpmat = fopen(\"Matrix.tmp\",\"w+\");\n");
   printf("if (fpmat == (FILE *)0) error(__FILE__, \"fopen-Matrix.tmp\", __LINE__);\n");
   printf("fpdim = fopen(\"Dimension\",\"w+\");\n");
   printf("if (fpdim == (FILE *)0) error(__FILE__, \"fopen-Dimension\", __LINE__);\n");
   printf("fppar = fopen(\"Parameter\",\"w\");\n");
   printf("if (fppar == (FILE *)0) error(__FILE__, \"fopen-Parameter\", __LINE__);\n");
   printf("/* Second block end. */\n\n");

}

init_para()
{
   unsigned short type;
   char *charp;

   printf("/* Modellparamerterinitialisierung (init_para()). */\n");

   printf("dimension = %d;\n", vectordim);
   
   if ((charp=getvar(-1, &type)) != (char *)0)
   {
      printf("(void)printf(\"Wert der Variablen '%s': \");\n",
             charp);
      if (type == 1)  /* its type is int! */
      {
         printf("(void)scanf(\"%s\", &%s);\n", "%d", charp);
         printf("fprintf(fppar, \"%s: %%d\\n\", %s);\n", charp, charp);
      }
      else            /* its type is double! */
      {
         printf("(void)scanf(\"%s\", &%s);\n", "%lf", charp);
         printf("fprintf(fppar, \"%s: %%lf\\n\", %s);\n", charp, charp);
      }
   }
   
   while ((charp=getvar(0, &type)) != (char *)0)
   {
      printf("(void)printf(\"Wert der Variablen '%s': \");\n",
             charp);
      if (type == 1)  /* its type is int! */
      {
         printf("(void)scanf(\"%s\", &%s);\n", "%d", charp);
         printf("fprintf(fppar, \"%s: %%d\\n\", %s);\n", charp, charp);
      }
      else             /* its type is double! */
      {
         printf("(void)scanf(\"%s\", &%s);\n", "%lf", charp);
         printf("fprintf(fppar, \"%s: %%lf\\n\", %s);\n", charp, charp);
      }
   }
   printf("/* Modellparameterinitialisierung end. */\n\n");

}

thirdblock()
{
   printf("/* Third block. */\n");
   printf("__x1 = (int *)calloc(dimension,sizeof(int));\n");
   printf("if (__x1 == (int *)0) error(__FILE__, \"calloc\", __LINE__);\n");
   printf("__x2 = (int *)calloc(dimension,sizeof(int));\n");
   printf("if (__x2 == (int *)0) error(__FILE__, \"calloc\", __LINE__);\n");
   printf("__x3 = (int *)calloc(dimension,sizeof(int));\n");
   printf("if (__x3 == (int *)0) error(__FILE__, \"calloc\", __LINE__);\n");
   printf("min = (int *)calloc(dimension,sizeof(int));\n");
   printf("if (min == (int *)0) error(__FILE__, \"calloc\", __LINE__);\n");
   printf("max = (int *)calloc(dimension,sizeof(int));\n");
   printf("if (max == (int *)0) error(__FILE__, \"calloc\", __LINE__);\n");
   printf("/*Third block end. */\n\n");

}


forthblock()
{
   int i;

   printf("\n/* Forth block. */\n");
   printf("base = 2;\n");
   printf("for(i=0;i<dimension;i++)\n");
   printf("{\n");
   printf("if (max[i] >= base)\n");
   printf("   base = max[i]+1;\n");
   printf("}\n\n");

   i = vectordim;
   for (i=0; i<vectordim; i++)
   {
      printf("for (__x1[%d]=min[%d]; __x1[%d]<=%s; __x1[%d]++)\n",
      i, i, i, maxstring[i],i);
   }
   
   printf("{\n");
   printf("   if (exclusions()) continue;\n");
   printf("   if (private_excl()) continue;\n");
   printf("   state_count++;\n\n");
  
   printf("   if(dbg) fprintf(stderr,\"\\n\"); \n");
   printf("   rules();\n\n");
   printf("   private_rules();\n\n");

   printf("   for (i=0; i<dimension; i++)\n");
   printf("      (void)fprintf(fpcod, \"%%d \", __x1[i]);\n");
   printf("   (void)fprintf(fpcod, \"\\n\");\n\n");

   printf("}\n(void)fprintf(stderr, \"\\n\");\n\n");

   printf("(void)fprintf(fpdim, \"%%10lu\\n\", state_count);\n");
   printf("(void)fprintf(fppar, \"Zahlenbasis: %%10lu\\n\", base);\n");
   printf("(void)fprintf(fppar, \"Vektorlaenge: %%10lu\\n\", dimension);\n");
   printf("\n");

   printf("(void)fclose(fpcod);\n");
   printf("(void)fclose(fpmat);\n");
   printf("(void)fclose(fpdim);\n");
   printf("(void)fclose(fppar);\n");

   printf("\n}\n\n\n");

}

int yyerror()
{
   fprintf(stderr,
           "Fehler Zeile %d. %s ist KEIN Token!\n", lineno-1, yytext);/*FEH*/
   if (c_error == 1) exit(1);
   if (c_error == 2) exit(2);
}
__YYSCLASS yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 55,
	280, 64,
	-2, 45,
-1, 58,
	280, 33,
	-2, 28,
-1, 115,
	275, 47,
	-2, 70,
-1, 154,
	275, 73,
	-2, 75,
	};
# define YYNPROD 110
# define YYLAST 287
__YYSCLASS yytabelem yyact[]={

    91,    92,    93,    94,    95,    96,   168,    85,    80,    81,
    82,    83,   165,   128,   129,   130,    80,    81,    82,    83,
   124,    80,    81,    82,    83,   152,    99,    87,    80,    81,
    82,    83,   151,    59,    56,   153,    80,    81,    82,    83,
   142,    65,   136,    80,    81,    82,    83,   140,   133,   121,
    65,    80,    81,    82,    83,    73,   163,   113,    80,    81,
    82,    83,    80,    81,    82,    83,    80,    81,    82,    83,
    80,    81,    82,    83,    91,    92,    93,    94,    95,    96,
    40,    39,    65,    77,    40,    39,    65,    64,    98,    40,
    39,    64,    49,    51,    19,    40,    39,    34,    33,    32,
   103,    25,    67,    54,    12,    10,    11,    86,    44,    28,
    46,    31,    14,    36,     4,     6,    61,    63,    89,   127,
    62,    27,    97,   108,    79,   114,    84,   101,    -1,   169,
   166,   162,   157,   154,   150,   126,   138,   139,   105,    29,
    71,    69,   118,    70,    66,    38,    53,    43,   161,   158,
   156,   148,   143,   125,   115,   104,    68,    55,    50,    45,
    17,   107,    57,   141,   110,    75,   123,    76,    74,    58,
    47,    30,    18,     8,    60,    72,    48,    78,    37,    24,
    41,    15,    35,    23,    13,     5,    22,    21,    72,    20,
     9,    52,    42,    26,    72,    16,    90,     7,     3,     2,
     1,   102,     0,     0,     0,     0,     0,   106,     0,     0,
     0,    88,     0,    90,     0,    72,     0,   100,   112,   111,
     0,     0,   116,    72,   119,    90,    72,     0,    72,     0,
     0,     0,     0,     0,    90,   132,   131,     0,   109,     0,
   135,   134,    90,     0,   137,    90,   117,    90,     0,   120,
     0,   122,     0,     0,     0,   145,   146,   144,   147,     0,
   149,     0,     0,     0,     0,     0,     0,   155,     0,     0,
     0,     0,     0,   159,     0,     0,   160,     0,     0,   164,
     0,     0,     0,   167,     0,     0,   170 };
__YYSCLASS yytabelem yypact[]={

 -3000, -3000,  -143, -3000,  -161,  -148, -3000, -3000, -3000,  -180,
 -3000, -3000, -3000, -3000, -3000,  -170,  -154,  -154,  -150, -3000,
  -173,  -174,  -175,  -146,  -176, -3000,  -160, -3000, -3000, -3000,
  -152, -3000, -3000, -3000, -3000, -3000, -3000,  -182, -3000, -3000,
 -3000,  -181,  -166, -3000, -3000,  -246, -3000,  -247,  -187, -3000,
 -3000, -3000,  -168, -3000, -3000, -3000, -3000,  -223, -3000, -3000,
  -191,  -276, -3000, -3000, -3000,  -275, -3000, -3000,  -157,  -253,
  -223,  -284, -3000, -3000,  -186,  -254,  -223, -3000,  -276, -3000,
 -3000, -3000, -3000, -3000,  -187,  -171, -3000, -3000,  -284, -3000,
 -3000, -3000, -3000, -3000, -3000, -3000, -3000,  -223, -3000, -3000,
  -284,  -187,  -222, -3000,  -232,  -223, -3000,  -187,  -223,  -230,
  -223, -3000,  -276, -3000,  -263, -3000,  -283,  -284,  -187,  -226,
  -276, -3000,  -284,  -187, -3000,  -233,  -232, -3000, -3000, -3000,
 -3000, -3000,  -234, -3000, -3000,  -241, -3000,  -283,  -187,  -187,
 -3000,  -187, -3000,  -187, -3000,  -276,  -249,  -256,  -240,  -276,
  -187, -3000, -3000, -3000, -3000,  -276,  -187,  -210, -3000,  -276,
 -3000,  -218,  -187, -3000,  -264, -3000,  -187,  -271, -3000,  -187,
  -276 };
__YYSCLASS yytabelem yypgo[]={

     0,   200,   199,   198,   197,   195,   193,   192,   191,   190,
   189,   187,   186,   185,   184,   183,   182,   181,   180,   179,
   178,   120,   176,   174,   116,   173,   172,   171,   170,   169,
   168,   167,   140,   118,   166,   165,   164,   163,   162,   161,
   160,   121,   159,   157,   156,   155,   154,   153,   152,   151,
   150,   149,   148,   147,   146,   144,   143,   142,   141,   138,
   137,   117,   119,   136,   135,   134,   133,   132,   131,   130,
   129,   128,   124,   127,   126,   125,   123,   122 };
__YYSCLASS yytabelem yyr1[]={

     0,     1,     2,     2,    10,     9,    11,     9,    12,     9,
    15,     3,    17,    18,    13,    14,    19,    14,    20,    20,
    22,    16,    23,    23,    25,     4,    26,    28,    30,    26,
    31,    34,    29,    35,    36,    37,    29,    27,    38,    39,
    27,    40,     5,     5,    42,    44,    45,    47,    48,    50,
    52,    41,     6,     6,    53,     7,     7,    54,     8,     8,
    55,    56,    57,    43,    58,    59,    60,    43,    63,    46,
    64,    65,    46,    49,    66,    67,    68,    69,    70,    66,
    71,    51,    24,    24,    73,    24,    74,    24,    21,    21,
    75,    61,    32,    76,    32,    77,    32,    33,    33,    33,
    33,    33,    33,    72,    72,    72,    72,    62,    62,    62 };
__YYSCLASS yytabelem yyr2[]={

     0,    14,     0,     8,     1,     7,     1,     7,     1,     7,
     1,     9,     1,     1,    11,     0,     1,     8,     3,     5,
     1,     9,     3,     5,     1,     7,     0,     1,     1,    13,
     1,     1,    15,     1,     1,     1,    19,     0,     1,     1,
    17,     1,     4,     4,     1,     1,     1,     1,     1,     1,
     1,    32,     0,     4,     3,     0,     4,     3,     0,     4,
     3,     1,     1,    15,     1,     1,     1,    19,     1,     9,
     1,     1,    13,     5,     0,     1,     1,     1,     1,    22,
     3,     2,     2,     2,     1,     8,     1,     9,     3,     3,
     1,    10,     2,     1,     8,     1,     9,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2 };
__YYSCLASS yytabelem yychk[]={

 -3000,    -1,    -2,    -3,   257,   -13,   258,    -4,   -25,    -9,
   266,   267,   265,   -14,   260,   -17,    -5,   -40,   -26,   274,
   -10,   -11,   -12,   -15,   -19,   271,    -6,   -41,   263,   -41,
   -27,   261,   272,   272,   272,   -16,   259,   -20,   -21,   272,
   271,   -18,    -7,   -53,   268,   -42,   262,   -28,   -22,   274,
   -21,   274,    -8,   -54,   269,   -43,   280,   -38,   -29,   280,
   -23,   -24,   -21,   -61,   278,   273,   -55,   270,   -44,   -58,
   -56,   -32,   -61,   278,   -30,   -35,   -31,   274,   -24,   -72,
   292,   293,   294,   295,   -74,   282,   264,   280,   -32,   -33,
   -72,   284,   285,   286,   287,   288,   289,   -77,   274,   280,
   -32,   -73,   -24,   271,   -45,   -59,   -33,   -39,   -76,   -32,
   -36,   -33,   -24,   279,   -75,   -46,   -61,   -32,   -57,   -24,
   -32,   279,   -32,   -34,   283,   -47,   -64,   -62,   296,   297,
   298,   -33,   -24,   274,   -33,   -24,   275,   -61,   -63,   -60,
   281,   -37,   281,   -48,   -62,   -24,   -24,   -24,   -49,   -24,
   -65,   281,   281,   275,   -66,   -24,   -50,   -67,   -51,   -24,
   -33,   -52,   -68,   274,   -24,   276,   -69,   -24,   277,   -70,
   -24 };
__YYSCLASS yytabelem yydef[]={

     2,    -2,     0,    24,     0,    15,    12,    41,    26,     0,
     4,     6,     8,    10,    16,     0,    52,     0,    37,     3,
     0,     0,     0,     0,     0,    13,    55,    43,    44,    42,
    25,    27,     5,     7,     9,    11,    20,     0,    18,    88,
    89,     0,    58,    53,    54,     0,    38,     0,     0,    17,
    19,    14,     1,    56,    57,    -2,    61,     0,    -2,    30,
     0,    22,    82,    83,    86,     0,    59,    60,     0,     0,
     0,     0,    92,    95,     0,     0,     0,    21,    23,    84,
   103,   104,   105,   106,     0,     0,    46,    65,     0,    39,
    93,    97,    98,    99,   100,   101,   102,     0,    29,    34,
     0,     0,     0,    90,     0,     0,    62,     0,     0,     0,
     0,    31,    85,    87,     0,    -2,     0,     0,     0,     0,
    94,    96,     0,     0,    91,     0,     0,    68,   107,   108,
   109,    66,     0,    40,    35,     0,    48,     0,     0,     0,
    63,     0,    32,     0,    71,    69,     0,     0,     0,    74,
     0,    67,    36,    49,    -2,    72,     0,     0,    50,    81,
    76,     0,     0,    51,     0,    77,     0,     0,    78,     0,
    79 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

__YYSCLASS yytoktype yytoks[] =
{
	"VAR",	257,
	"DIM",	258,
	"MAX",	259,
	"MIN",	260,
	"NOT",	261,
	"SUM",	262,
	"RULE",	263,
	"GOES_TO",	264,
	"FDECL",	265,
	"IDECL",	266,
	"PDECL",	267,
	"OUTPUT",	268,
	"RESULT",	269,
	"FINAL",	270,
	"CONST",	271,
	"VARIABLE",	272,
	"VAL",	273,
	"DELIM",	274,
	"SEPARATOR",	275,
	"QUESTION",	276,
	"QDELIM",	277,
	"LEFT",	278,
	"RIGHT",	279,
	"LEFTS",	280,
	"RIGHTS",	281,
	"LEFTV",	282,
	"RIGHTV",	283,
	"EQ",	284,
	"NE",	285,
	"LE",	286,
	"GE",	287,
	"L",	288,
	"G",	289,
	"OR",	290,
	"AND",	291,
	"ADD",	292,
	"MINUS",	293,
	"MULT",	294,
	"DIV",	295,
	"ASSIGN",	296,
	"ADDASS",	297,
	"MINASS",	298,
	"-unknown-",	-1	/* ends search */
};

__YYSCLASS char * yyreds[] =
{
	"-no such reduction-",
	"markovmodell : variables vectordscrptn exclusions ruleslist outputs resultlist finals",
	"variables : /* empty */",
	"variables : variables VAR declaration DELIM",
	"declaration : IDECL",
	"declaration : IDECL VARIABLE",
	"declaration : PDECL",
	"declaration : PDECL VARIABLE",
	"declaration : FDECL",
	"declaration : FDECL VARIABLE",
	"vectordscrptn : dimconstr minconstr",
	"vectordscrptn : dimconstr minconstr maxconstr",
	"dimconstr : DIM",
	"dimconstr : DIM CONST",
	"dimconstr : DIM CONST DELIM",
	"minconstr : /* empty */",
	"minconstr : MIN",
	"minconstr : MIN mintail DELIM",
	"mintail : sexpr",
	"mintail : mintail sexpr",
	"maxconstr : MAX",
	"maxconstr : MAX maxtail DELIM",
	"maxtail : arexpr",
	"maxtail : maxtail arexpr",
	"exclusions : /* empty */",
	"exclusions : notlist sumlist",
	"notlist : /* empty */",
	"notlist : notlist NOT",
	"notlist : notlist NOT notexpr",
	"notlist : notlist NOT notexpr DELIM",
	"notexpr : LEFTS",
	"notexpr : LEFTS varexp cooper",
	"notexpr : LEFTS varexp cooper arexpr RIGHTS",
	"notexpr : notexpr",
	"notexpr : notexpr LEFTS",
	"notexpr : notexpr LEFTS varexp cooper",
	"notexpr : notexpr LEFTS varexp cooper arexpr RIGHTS",
	"sumlist : /* empty */",
	"sumlist : sumlist SUM",
	"sumlist : sumlist SUM varexp cooper",
	"sumlist : sumlist SUM varexp cooper arexpr DELIM",
	"ruleslist : /* empty */",
	"ruleslist : rule",
	"ruleslist : ruleslist rule",
	"rule : RULE",
	"rule : RULE oldstate",
	"rule : RULE oldstate GOES_TO",
	"rule : RULE oldstate GOES_TO newstate",
	"rule : RULE oldstate GOES_TO newstate SEPARATOR",
	"rule : RULE oldstate GOES_TO newstate SEPARATOR transrate SEPARATOR",
	"rule : RULE oldstate GOES_TO newstate SEPARATOR transrate SEPARATOR transprob",
	"rule : RULE oldstate GOES_TO newstate SEPARATOR transrate SEPARATOR transprob DELIM",
	"outputs : /* empty */",
	"outputs : outputs outputrule",
	"outputrule : OUTPUT",
	"resultlist : /* empty */",
	"resultlist : resultlist resultexpr",
	"resultexpr : RESULT",
	"finals : /* empty */",
	"finals : finals finalexpr",
	"finalexpr : FINAL",
	"oldstate : LEFTS",
	"oldstate : LEFTS varexp cooper",
	"oldstate : LEFTS varexp cooper arexpr RIGHTS",
	"oldstate : oldstate",
	"oldstate : oldstate LEFTS",
	"oldstate : oldstate LEFTS varexp cooper",
	"oldstate : oldstate LEFTS varexp cooper arexpr RIGHTS",
	"newstate : vsexp asoper",
	"newstate : vsexp asoper arexpr",
	"newstate : newstate",
	"newstate : newstate vsexp asoper",
	"newstate : newstate vsexp asoper arexpr",
	"transrate : arexpr ifpartlist",
	"ifpartlist : /* empty */",
	"ifpartlist : ifpartlist",
	"ifpartlist : ifpartlist cooper",
	"ifpartlist : ifpartlist cooper arexpr QUESTION",
	"ifpartlist : ifpartlist cooper arexpr QUESTION arexpr QDELIM",
	"ifpartlist : ifpartlist cooper arexpr QUESTION arexpr QDELIM arexpr",
	"results : OUTPUT",
	"transprob : arexpr",
	"arexpr : sexpr",
	"arexpr : vsexp",
	"arexpr : arexpr aroper",
	"arexpr : arexpr aroper arexpr",
	"arexpr : LEFT",
	"arexpr : LEFT arexpr RIGHT",
	"sexpr : VARIABLE",
	"sexpr : CONST",
	"vsexp : VAL LEFTV CONST",
	"vsexp : VAL LEFTV CONST RIGHTV",
	"varexp : vsexp",
	"varexp : varexp aroper",
	"varexp : varexp aroper varexp",
	"varexp : LEFT",
	"varexp : LEFT varexp RIGHT",
	"cooper : EQ",
	"cooper : NE",
	"cooper : LE",
	"cooper : GE",
	"cooper : L",
	"cooper : G",
	"aroper : ADD",
	"aroper : MINUS",
	"aroper : MULT",
	"aroper : DIV",
	"asoper : ASSIGN",
	"asoper : ADDASS",
	"asoper : MINASS",
};
#endif /* YYDEBUG */
#define YYFLAG  (-3000)
/* @(#) $Revision: 66.3 $ */    

/*
** Skeleton parser driver for yacc output
*/

#if defined(NLS) && !defined(NL_SETN)
#include <msgbuf.h>
#endif

#ifndef nl_msg
#define nl_msg(i,s) (s)
#endif

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab

#ifndef __RUNTIME_YYMAXDEPTH
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#else
#define YYACCEPT	{free_stacks(); return(0);}
#define YYABORT		{free_stacks(); return(1);}
#endif

#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( (nl_msg(30001,"syntax error - cannot backup")) );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
/* define for YYFLAG now generated by yacc program. */
/*#define YYFLAG		(FLAGVAL)*/

/*
** global variables used by the parser
*/
# ifndef __RUNTIME_YYMAXDEPTH
__YYSCLASS YYSTYPE yyv[ YYMAXDEPTH ];	/* value stack */
__YYSCLASS int yys[ YYMAXDEPTH ];		/* state stack */
# else
__YYSCLASS YYSTYPE *yyv;			/* pointer to malloc'ed value stack */
__YYSCLASS int *yys;			/* pointer to malloc'ed stack stack */
#ifdef __cplusplus
	extern char *malloc(int);
	extern char *realloc(char *, int);
	extern void free();
# else
	extern char *malloc();
	extern char *realloc();
	extern void free();
# endif /* __cplusplus */
static int allocate_stacks(); 
static void free_stacks();
# ifndef YYINCREMENT
# define YYINCREMENT (YYMAXDEPTH/2) + 10
# endif
# endif	/* __RUNTIME_YYMAXDEPTH */
long  yymaxdepth = YYMAXDEPTH;

__YYSCLASS YYSTYPE *yypv;			/* top of value stack */
__YYSCLASS int *yyps;			/* top of state stack */

__YYSCLASS int yystate;			/* current state */
__YYSCLASS int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
__YYSCLASS int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */

	/*
	** Initialize externals - yyparse may be called more than once
	*/
# ifdef __RUNTIME_YYMAXDEPTH
	if (allocate_stacks()) YYABORT;
# endif
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
# ifndef __RUNTIME_YYMAXDEPTH
			yyerror( (nl_msg(30002,"yacc stack overflow")) );
			YYABORT;
# else
			/* save old stack bases to recalculate pointers */
			YYSTYPE * yyv_old = yyv;
			int * yys_old = yys;
			yymaxdepth += YYINCREMENT;
			yys = (int *) realloc(yys, yymaxdepth * sizeof(int));
			yyv = (YYSTYPE *) realloc(yyv, yymaxdepth * sizeof(YYSTYPE));
			if (yys==0 || yyv==0) {
			    yyerror( (nl_msg(30002,"yacc stack overflow")) );
			    YYABORT;
			    }
			/* Reset pointers into stack */
			yy_ps = (yy_ps - yys_old) + yys;
			yyps = (yyps - yys_old) + yys;
			yy_pv = (yy_pv - yyv_old) + yyv;
			yypv = (yypv - yyv_old) + yyv;
# endif

		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( (nl_msg(30003,"syntax error")) );
				yynerrs++;
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 4:
# line 59 "specgram.y"
{ typeflag = 1; } break;
case 5:
# line 60 "specgram.y"
{ printf("int %s;\n", yytext); } break;
case 6:
# line 61 "specgram.y"
{ typeflag = 2; } break;
case 7:
# line 62 "specgram.y"
{ printf("double %s;\n", yytext); } break;
case 8:
# line 63 "specgram.y"
{ typeflag = 3; } break;
case 9:
# line 64 "specgram.y"
{ printf("double %s;\n", yytext); } break;
case 10:
# line 69 "specgram.y"
{ if (count < (vectordim-1))
		  {  fprintf(stderr,
		     "Semantik Warnung: Das MIN-Konstrukt enthaelt nicht genuegend Elemente.\n");/*FEH*/
		     c_error = 1;
		  }
		} break;
case 11:
# line 76 "specgram.y"
{ if (count < (vectordim-1))
		  {  fprintf(stderr,
		     "Semantik Fehler: Das MAX-Konstrukt enthaelt nicht genuegend Elemente.\n");/*FEH*/
		     c_error = 2;
		  }
		} break;
case 12:
# line 83 "specgram.y"
{ typeflag = 1; } break;
case 13:
# line 84 "specgram.y"
{ vectordim = atoi(yytext);
			alloc_max(vectordim); } break;
case 14:
# line 87 "specgram.y"
{
		   secondblock();
	 	   init_para();
		   thirdblock();
		} break;
case 16:
# line 94 "specgram.y"
{ count = 0; typeflag = 1; } break;
case 18:
# line 98 "specgram.y"
{
		  if (count < vectordim)
		     printf("min[%d] = %s;\n", count, write_str(0));
		  if (count == vectordim)
		  {  fprintf(stderr,
		     "Semantik Warnung: Das MIN-Konstrukt enthaelt zu viele Elemente.\n");/*FEH*/
		     c_error = 1;
		     (void)write_str(0);
		  }
		  count++;
		} break;
case 19:
# line 111 "specgram.y"
{
		  if (count < vectordim)
		     printf("min[%d] = %s;\n", count, write_str(0));
		  if (count == vectordim)
		  {  fprintf(stderr,
		     "Semantik Warnung: Das MIN-Konstrukt enthaelt zu viele Elemente.\n");/*FEH*/
		     c_error = 1;
		     (void)write_str(0);
		  }
		  count++;
		} break;
case 20:
# line 123 "specgram.y"
{ count = 0;  typeflag = 1; } break;
case 21:
# line 124 "specgram.y"
{ forthblock(); } break;
case 22:
# line 127 "specgram.y"
{ if (count < vectordim)
			 {
			 strcpy(maxstring[count],write_str(0));
		     printf("max[%d] = %s;\n", count, maxstring[count]);
			 }
		  if (count == vectordim)
		  {  fprintf(stderr,
		     "Semantik Fehler: Das MAX-Konstrukt enthaelt zu viele Elemente.\n");/*FEH*/
		     c_error = 2;
		     (void)write_str(0);
		  }
 		  count++;
		} break;
case 23:
# line 142 "specgram.y"
{ if (count < vectordim)
			 {
			 strcpy(maxstring[count],write_str(0));
		     printf("max[%d] = %s;\n", count, maxstring[count]);
			 }
		  if (count == vectordim)
		  {  fprintf(stderr,
		     "Semantik Fehlr: Das MAX-Konstrukt enthaelt zu viele Elemente.\n");/*FEH*/
		     c_error = 2;
		     (void)write_str(0);
		  }
 		  count++;
		} break;
case 24:
# line 157 "specgram.y"
{ printf("int exclusions()\n{\n");
		  typeflag = 1;
		} break;
case 25:
# line 161 "specgram.y"
{ printf("\nreturn(0);\n}\n\n"); } break;
case 27:
# line 165 "specgram.y"
{ printf("if ("); } break;
case 28:
# line 166 "specgram.y"
{ printf("%s", write_str(0)); } break;
case 29:
# line 167 "specgram.y"
{ printf(") return (1);\n"); } break;
case 30:
# line 169 "specgram.y"
{ append(1, "%s", "("); typeflag = 1; } break;
case 31:
# line 171 "specgram.y"
{ append((yyleng+2), " %s ", yytext);
				  typeflag = 3;
				} break;
case 32:
# line 175 "specgram.y"
{ append(1, "%s", ")"); } break;
case 33:
# line 176 "specgram.y"
{ append(4, "%s", " && "); } break;
case 34:
# line 177 "specgram.y"
{ append(1, "%s", "("); typeflag = 1; } break;
case 35:
# line 179 "specgram.y"
{ append((yyleng+2), " %s ", yytext);
				  typeflag = 3;
				} break;
case 36:
# line 183 "specgram.y"
{ append(1, "%s", ")"); } break;
case 38:
# line 188 "specgram.y"
{ printf("if (("); typeflag = 1; } break;
case 39:
# line 190 "specgram.y"
{ printf("%s) %s ", write_str(0), yytext);
				  typeflag = 3;
				} break;
case 40:
# line 194 "specgram.y"
{ printf("%s) return (1);\n", write_str(0)); } break;
case 41:
# line 197 "specgram.y"
{ count = 0;
		  printf("void rules()\n{\n");
		  printf("unsigned long j, k;\n");
		  printf("double __rate, __prob;\n\n");

		  printf("copy(__x1, __x2);\n");
		  printf("j = encode(__x1);\n\n");
		  printf("%s;\n", OUTPUT_COD);
		} break;
case 44:
# line 209 "specgram.y"
{ count++;
				  printf("if (");
				} break;
case 45:
# line 212 "specgram.y"
{ printf("%s)\n{\n", write_str(0)); } break;
case 46:
# line 213 "specgram.y"
{ typeflag = 1; 
		  printf("   copy(__x1,__x3);\n"); } break;
case 47:
# line 215 "specgram.y"
{ leftside = 1;} break;
case 48:
# line 217 "specgram.y"
{ printf("   k = encode(__x1);\n\n");
		  printf("   copy(__x1, __x2);\n");
		  printf("   copy(__x3, __x1);\n");
		  typeflag = 3;
		} break;
case 49:
# line 223 "specgram.y"
{ printf("\n");  typeflag = 2; } break;
case 50:
# line 225 "specgram.y"
{ printf("   __prob = %s;\n", write_str(0));
		  printf("   assert(__prob <= 1.0);\n");
		  printf("   __rate *= __prob;\n");
		  printf("   if(dbg) { actual_state(__x1); fprintf(stderr,\"\\t\"); \n");
		  printf("         actual_state(__x2); fprintf(stderr,\"%%lg\\n\",__rate); }\n");
		  printf("   %s;\n", OUTPUT_MAT);
                  printf("}\n");
                } break;
case 54:
# line 239 "specgram.y"
{ while ((c = input()) != ';') ;
                 } break;
case 57:
# line 246 "specgram.y"
{ while ((c=input()) != ';');
                 } break;
case 60:
# line 253 "specgram.y"
{ while ((c=input()) != ';');
                 } break;
case 61:
# line 256 "specgram.y"
{ append(1, "%s", "("); typeflag = 1; } break;
case 62:
# line 258 "specgram.y"
{ append((yyleng+2), " %s ", yytext);
				  typeflag = 3;
				} break;
case 63:
# line 262 "specgram.y"
{ append(1, "%s", ")"); } break;
case 64:
# line 263 "specgram.y"
{ append(4, "%s", " && "); } break;
case 65:
# line 264 "specgram.y"
{ append(1, "%s", "("); typeflag = 1; } break;
case 66:
# line 266 "specgram.y"
{ append((yyleng+2), " %s ", yytext);
				  typeflag = 3;
				} break;
case 67:
# line 270 "specgram.y"
{ append(1, "%s", ")"); } break;
case 68:
# line 273 "specgram.y"
{ append((yyleng+2), " %s ", yytext);
				  typeflag = 3;
				  leftside = 0;
				} break;
case 69:
# line 277 "specgram.y"
{ printf("   %s;\n", write_str(0));
				  typeflag = 1;
				} break;
case 70:
# line 280 "specgram.y"
{ leftside = 1;} break;
case 71:
# line 282 "specgram.y"
{ append((yyleng+2), " %s ", yytext);
				  typeflag = 3;
				  leftside = 0;
				} break;
case 72:
# line 286 "specgram.y"
{ printf("   %s;\n", write_str(0));
				  typeflag = 1;
				} break;
case 73:
# line 291 "specgram.y"
{ printf("   __rate = %s;\n", write_str(0));
				  printf("A%-hX:\n", count);
				} break;
case 75:
# line 296 "specgram.y"
{ printf("   if ((%s ", write_str(0)); } break;
case 76:
# line 297 "specgram.y"
{ append((yyleng+4), ") %s (", yytext); } break;
case 77:
# line 299 "specgram.y"
{ printf("%s))\n   {\n", write_str(0)); } break;
case 78:
# line 301 "specgram.y"
{ printf("      __rate = %s;\n", write_str(0));
				  printf("      goto A%-hX;\n   }\n", count);} break;
case 80:
# line 306 "specgram.y"
{ while((c = input()) != EOF ) ; } break;
case 84:
# line 315 "specgram.y"
{ append((yyleng+2), " %s ", yytext); } break;
case 86:
# line 317 "specgram.y"
{ append(1, "%s", "("); } break;
case 87:
# line 319 "specgram.y"
{ append(1, "%s", ")"); } break;
case 88:
# line 321 "specgram.y"
{ append(yyleng, "%s", yytext); } break;
case 89:
# line 322 "specgram.y"
{ append(yyleng, "%s", yytext); } break;
case 90:
# line 326 "specgram.y"
{ c_assert(atoi(yytext)>=vectordim, c_error);
		  c_assert(atoi(yytext)<0, c_error);
		  if(leftside)
			  append((yyleng+6), "__x1[%s]", yytext);
			else
			  append((yyleng+6), "__x3[%s]", yytext);
		} break;
case 93:
# line 337 "specgram.y"
{ append((yyleng+2), " %s ", yytext); } break;
case 95:
# line 339 "specgram.y"
{ append(1, "%s", "("); } break;
case 96:
# line 341 "specgram.y"
{ append(1, "%s", ")"); } break;
	}
	goto yystack;		/* reset registers in driver code */
}

# ifdef __RUNTIME_YYMAXDEPTH

static int allocate_stacks() {
	/* allocate the yys and yyv stacks */
	yys = (int *) malloc(yymaxdepth * sizeof(int));
	yyv = (YYSTYPE *) malloc(yymaxdepth * sizeof(YYSTYPE));

	if (yys==0 || yyv==0) {
	   yyerror( (nl_msg(30004,"unable to allocate space for yacc stacks")) );
	   return(1);
	   }
	else return(0);

}


static void free_stacks() {
	if (yys!=0) free((char *) yys);
	if (yyv!=0) free((char *) yyv);
}

# endif  /* defined(__RUNTIME_YYMAXDEPTH) */

