/*
@(#)PEPSY:	specgram.y	1.2	92/03/27 12:42:00
*/

%{
short c_error = 0;
/* c_error = 0: Weder Fehler noch Warnung;
   c_error = 1: Warnung;
   c_error = 2: Fehler;
*/

unsigned short typeflag;
/* typeflag = 1: type is int;
   typeflag = 2: type is double and 0 <= value <= 1.0;
   typeflag = 3: type is double;
*/

char **maxstring;  
int c;
/* dynamische Obergrenzen 
*/
unsigned int leftside = 1;
int c;
/* welchen Zustandsvektor soll ich verwenden ???
*/
%}

/* Keywords */
%token VAR DIM MAX MIN NOT SUM RULE GOES_TO
%token FDECL IDECL PDECL
%token OUTPUT RESULT FINAL

/* Expressions tokens */
%token CONST VARIABLE VAL 

/* Delimiter */
%token DELIM SEPARATOR QUESTION QDELIM LEFT RIGHT LEFTS RIGHTS LEFTV RIGHTV

/* Comparison operators */
%token EQ NE LE GE L G

/* Logical operators. */
%token OR AND 

/* Arthmetic operators */
%token ADD MINUS MULT DIV

/* Assignment operators */
%token ASSIGN ADDASS MINASS

%start markovmodell
%%
/* Grammar Rules. */
markovmodell:	variables vectordscrptn exclusions ruleslist outputs resultlist finals;

variables:	/* empty */
	 |	variables VAR declaration DELIM 
	 ;
declaration:	IDECL	 { typeflag = 1; }
		VARIABLE { printf("int %s;\n", yytext); }
	   |	PDECL	 { typeflag = 2; }
		VARIABLE { printf("double %s;\n", yytext); }
	   |	FDECL	 { typeflag = 3; }
		VARIABLE { printf("double %s;\n", yytext); }
	   ;

vectordscrptn:	dimconstr
		minconstr
		{ if (count < (vectordim-1))
		  {  fprintf(stderr,
		     "Semantik Warnung: Das MIN-Konstrukt enthaelt nicht genuegend Elemente.\n");/*FEH*/
		     c_error = 1;
		  }
		} 
		maxconstr
		{ if (count < (vectordim-1))
		  {  fprintf(stderr,
		     "Semantik Fehler: Das MAX-Konstrukt enthaelt nicht genuegend Elemente.\n");/*FEH*/
		     c_error = 2;
		  }
		} 
	     ;
dimconstr:	DIM		{ typeflag = 1; }
		CONST		{ vectordim = atoi(yytext);
			alloc_max(vectordim); }
 		DELIM
		{
		   secondblock();
	 	   init_para();
		   thirdblock();
		}
	    ;
minconstr:	/* empty */
	 |	MIN		{ count = 0; typeflag = 1; }
		mintail DELIM
	 ;
mintail :	sexpr
		{
		  if (count < vectordim)
		     printf("min[%d] = %s;\n", count, write_str(0));
		  if (count == vectordim)
		  {  fprintf(stderr,
		     "Semantik Warnung: Das MIN-Konstrukt enthaelt zu viele Elemente.\n");/*FEH*/
		     c_error = 1;
		     (void)write_str(0);
		  }
		  count++;
		}
	|	mintail
		sexpr
		{
		  if (count < vectordim)
		     printf("min[%d] = %s;\n", count, write_str(0));
		  if (count == vectordim)
		  {  fprintf(stderr,
		     "Semantik Warnung: Das MIN-Konstrukt enthaelt zu viele Elemente.\n");/*FEH*/
		     c_error = 1;
		     (void)write_str(0);
		  }
		  count++;
		}
	;
maxconstr:	MAX			{ count = 0;  typeflag = 1; }
		maxtail DELIM		{ forthblock(); }
	 ;
maxtail	:	arexpr
		{ if (count < vectordim)
			 {
			 strcpy(maxstring[count],write_str(0));
		     printf("max[%d] = %s;\n", count, maxstring[count]);
			 }
		  if (count == vectordim)
		  {  fprintf(stderr,
		     "Semantik Fehler: Das MAX-Konstrukt enthaelt zu viele Elemente.\n");/*FEH*/
		     c_error = 2;
		     (void)write_str(0);
		  }
 		  count++;
		}
	|	maxtail
		arexpr
		{ if (count < vectordim)
			 {
			 strcpy(maxstring[count],write_str(0));
		     printf("max[%d] = %s;\n", count, maxstring[count]);
			 }
		  if (count == vectordim)
		  {  fprintf(stderr,
		     "Semantik Fehlr: Das MAX-Konstrukt enthaelt zu viele Elemente.\n");/*FEH*/
		     c_error = 2;
		     (void)write_str(0);
		  }
 		  count++;
		}
	;

exclusions:	{ printf("int exclusions()\n{\n");
		  typeflag = 1;
		}
		notlist
		sumlist		{ printf("\nreturn(0);\n}\n\n"); }
	;
notlist	:	/* empty */
	|	notlist
		NOT		{ printf("if ("); }
	        notexpr		{ printf("%s", write_str(0)); }
		DELIM		{ printf(") return (1);\n"); }
	;
notexpr :	LEFTS		{ append(1, "%s", "("); typeflag = 1; }
		varexp
		cooper		{ append((yyleng+2), " %s ", yytext);
				  typeflag = 3;
				}
		arexpr
		RIGHTS		{ append(1, "%s", ")"); }
	|	notexpr		{ append(4, "%s", " && "); }
		LEFTS		{ append(1, "%s", "("); typeflag = 1; }
		varexp
		cooper		{ append((yyleng+2), " %s ", yytext);
				  typeflag = 3;
				}
		arexpr
		RIGHTS		{ append(1, "%s", ")"); }
	;

sumlist :	/* empty */
	|	sumlist
		SUM		{ printf("if (("); typeflag = 1; }
		varexp
		cooper		{ printf("%s) %s ", write_str(0), yytext);
				  typeflag = 3;
				}
		arexpr
		DELIM		{ printf("%s) return (1);\n", write_str(0)); }
	;

ruleslist:	{ count = 0;
		  printf("void rules()\n{\n");
		  printf("unsigned long j, k;\n");
		  printf("double __rate, __prob;\n\n");

		  printf("copy(__x1, __x2);\n");
		  printf("j = encode(__x1);\n\n");
		  printf("%s;\n", OUTPUT_COD);
		}
		rule
	|	ruleslist rule
	;
rule	:	RULE		{ count++;
				  printf("if (");
				}
		oldstate	{ printf("%s)\n{\n", write_str(0)); }
		GOES_TO		{ typeflag = 1; 
		  printf("   copy(__x1,__x3);\n"); }
		newstate { leftside = 1;}
		SEPARATOR
		{ printf("   k = encode(__x1);\n\n");
		  printf("   copy(__x1, __x2);\n");
		  printf("   copy(__x3, __x1);\n");
		  typeflag = 3;
		}
		transrate
		SEPARATOR	{ printf("\n");  typeflag = 2; }
		transprob
		{ printf("   __prob = %s;\n", write_str(0));
		  printf("   assert(__prob <= 1.0);\n");
		  printf("   __rate *= __prob;\n");
		  printf("   if(dbg) { actual_state(__x1); fprintf(stderr,\"\\t\"); \n");
		  printf("         actual_state(__x2); fprintf(stderr,\"%%lg\\n\",__rate); }\n");
		  printf("   %s;\n", OUTPUT_MAT);
                  printf("}\n");
                }
		DELIM
	;
outputs:        /*empty*/
                |outputs outputrule 
                ;
outputrule:     OUTPUT
                { while ((c = input()) != ';') ;
                 }
                ;
resultlist:     /*empty*/
                | resultlist resultexpr
                ;
resultexpr:     RESULT
                { while ((c=input()) != ';');
                 }
                ;
finals:         /*empty*/
                | finals finalexpr
                ;
finalexpr:      FINAL
                { while ((c=input()) != ';');
                 }
                ;
oldstate:	LEFTS		{ append(1, "%s", "("); typeflag = 1; }
		varexp
		cooper		{ append((yyleng+2), " %s ", yytext);
				  typeflag = 3;
				}
		arexpr
		RIGHTS		{ append(1, "%s", ")"); }
	|	oldstate	{ append(4, "%s", " && "); }
		LEFTS		{ append(1, "%s", "("); typeflag = 1; }
		varexp
		cooper		{ append((yyleng+2), " %s ", yytext);
				  typeflag = 3;
				}
		arexpr
		RIGHTS		{ append(1, "%s", ")"); }
	;
newstate:	vsexp
		asoper		{ append((yyleng+2), " %s ", yytext);
				  typeflag = 3;
				  leftside = 0;
				}
		arexpr		{ printf("   %s;\n", write_str(0));
				  typeflag = 1;
				}
	|	newstate { leftside = 1;}
		vsexp
		asoper		{ append((yyleng+2), " %s ", yytext);
				  typeflag = 3;
				  leftside = 0;
				}
		arexpr		{ printf("   %s;\n", write_str(0));
				  typeflag = 1;
				}
	;
transrate:	arexpr
		ifpartlist	{ printf("   __rate = %s;\n", write_str(0));
				  printf("A%-hX:\n", count);
				}
	;
ifpartlist:	/* empty */
	|	ifpartlist	{ printf("   if ((%s ", write_str(0)); }
		cooper		{ append((yyleng+4), ") %s (", yytext); }
		arexpr
		QUESTION	{ printf("%s))\n   {\n", write_str(0)); }
		arexpr
		QDELIM		{ printf("      __rate = %s;\n", write_str(0));
				  printf("      goto A%-hX;\n   }\n", count);}
		arexpr
	;
results: OUTPUT
	{ while((c = input()) != EOF ) ; }
	;

transprob:	arexpr
	;

arexpr:		sexpr
	|	vsexp
	|	arexpr
		aroper  	{ append((yyleng+2), " %s ", yytext); }
		arexpr
	|	LEFT		{ append(1, "%s", "("); }
		arexpr
		RIGHT		{ append(1, "%s", ")"); }
	;
sexpr	:	VARIABLE	{ append(yyleng, "%s", yytext); }
	|	CONST		{ append(yyleng, "%s", yytext); }
	;
vsexp:		VAL
		LEFTV CONST
		{ c_assert(atoi(yytext)>=vectordim, c_error);
		  c_assert(atoi(yytext)<0, c_error);
		  if(leftside)
			  append((yyleng+6), "__x1[%s]", yytext);
			else
			  append((yyleng+6), "__x3[%s]", yytext);
		}
		RIGHTV
	;
varexp	:	vsexp
	|	varexp
		aroper  	{ append((yyleng+2), " %s ", yytext); }
		varexp
	|	LEFT		{ append(1, "%s", "("); }
		varexp
		RIGHT		{ append(1, "%s", ")"); }
	;

cooper	:	EQ | NE | LE | GE | L | G
	;
aroper	:	ADD | MINUS | MULT | DIV
	;
asoper	:	ASSIGN | ADDASS | MINASS
	;

%%
/*looper	:	AND | OR
	;
*/

#include <stdio.h>
#include "specgraml.c"
#include "cutilities.h"


char OUTPUT_MAT[] = "(void)fprintf(fpmat, \"%lu %lu %lg\\n\", j, k, __rate)";
char OUTPUT_COD[] = "(void)fprintf(fpcod, \"%lu \", j)";
unsigned long vectordim = 0;
short count = 0;

main(argc, argv)
int argc;
char *argv[];
{

   firstblock();
   yyparse();
   printf("}\n\n");

   if (c_error == 1) exit(1);
   if (c_error == 2) exit(2);
   exit(0);

}


firstblock()
{
   printf("/* First block. */\n");
   printf("#include <stdio.h>\n");
   printf("#include <assert.h>\n\n");
   
   printf("#include \"rutilities.c\"\n\n");
   printf("#include \"priv_excl.c\"\n\n");
   printf("#include \"priv_rules.c\"\n\n");

   printf("int dimension;\n");
   printf("int base;\n");
   printf("unsigned long state_count;\n");
   printf("int *__x1, *__x2, *__x3, *min, *max;\n");
   printf("FILE  *fpcod, *fpdim, *fpmat, *fppar;\n\n");

   printf("void setbuf(), free();\n");
   printf("char *calloc();\n");
   printf("int fclose();\n");
   printf("FILE *fopen();\n");
   printf("unsigned long encode();\n");
   printf("void copy(), error();\n");
   printf("/* First block end. */\n\n");

}

void secondblock()
{
   printf("\n/* Second block. */\n");
   printf("main(argc,argv)\n");
   printf("int argc;\nchar *argv[];\n");
   printf("{\n");
   printf("int i, j;\n");
   printf("int retval;\n\n");

   printf("int exclusions();\n");
   printf("void rules();\n\n");

   printf("parse_options(argc,argv);\n");

   printf("fpcod = fopen(\"Codierung.tmp\",\"w+\");\n");
   printf("if (fpcod == (FILE *)0) error(__FILE__, \"fopen-Codierung.tmp\", __LINE__);\n");
   printf("fpmat = fopen(\"Matrix.tmp\",\"w+\");\n");
   printf("if (fpmat == (FILE *)0) error(__FILE__, \"fopen-Matrix.tmp\", __LINE__);\n");
   printf("fpdim = fopen(\"Dimension\",\"w+\");\n");
   printf("if (fpdim == (FILE *)0) error(__FILE__, \"fopen-Dimension\", __LINE__);\n");
   printf("fppar = fopen(\"Parameter\",\"w\");\n");
   printf("if (fppar == (FILE *)0) error(__FILE__, \"fopen-Parameter\", __LINE__);\n");
   printf("/* Second block end. */\n\n");

}

init_para()
{
   unsigned short type;
   char *charp;

   printf("/* Modellparamerterinitialisierung (init_para()). */\n");

   printf("dimension = %d;\n", vectordim);
   
   if ((charp=getvar(-1, &type)) != (char *)0)
   {
      printf("(void)printf(\"Wert der Variablen '%s': \");\n",
             charp);
      if (type == 1)  /* its type is int! */
      {
         printf("(void)scanf(\"%s\", &%s);\n", "%d", charp);
         printf("fprintf(fppar, \"%s: %%d\\n\", %s);\n", charp, charp);
      }
      else            /* its type is double! */
      {
         printf("(void)scanf(\"%s\", &%s);\n", "%lf", charp);
         printf("fprintf(fppar, \"%s: %%lf\\n\", %s);\n", charp, charp);
      }
   }
   
   while ((charp=getvar(0, &type)) != (char *)0)
   {
      printf("(void)printf(\"Wert der Variablen '%s': \");\n",
             charp);
      if (type == 1)  /* its type is int! */
      {
         printf("(void)scanf(\"%s\", &%s);\n", "%d", charp);
         printf("fprintf(fppar, \"%s: %%d\\n\", %s);\n", charp, charp);
      }
      else             /* its type is double! */
      {
         printf("(void)scanf(\"%s\", &%s);\n", "%lf", charp);
         printf("fprintf(fppar, \"%s: %%lf\\n\", %s);\n", charp, charp);
      }
   }
   printf("/* Modellparameterinitialisierung end. */\n\n");

}

thirdblock()
{
   printf("/* Third block. */\n");
   printf("__x1 = (int *)calloc(dimension,sizeof(int));\n");
   printf("if (__x1 == (int *)0) error(__FILE__, \"calloc\", __LINE__);\n");
   printf("__x2 = (int *)calloc(dimension,sizeof(int));\n");
   printf("if (__x2 == (int *)0) error(__FILE__, \"calloc\", __LINE__);\n");
   printf("__x3 = (int *)calloc(dimension,sizeof(int));\n");
   printf("if (__x3 == (int *)0) error(__FILE__, \"calloc\", __LINE__);\n");
   printf("min = (int *)calloc(dimension,sizeof(int));\n");
   printf("if (min == (int *)0) error(__FILE__, \"calloc\", __LINE__);\n");
   printf("max = (int *)calloc(dimension,sizeof(int));\n");
   printf("if (max == (int *)0) error(__FILE__, \"calloc\", __LINE__);\n");
   printf("/*Third block end. */\n\n");

}


forthblock()
{
   int i;

   printf("\n/* Forth block. */\n");
   printf("base = 2;\n");
   printf("for(i=0;i<dimension;i++)\n");
   printf("{\n");
   printf("if (max[i] >= base)\n");
   printf("   base = max[i]+1;\n");
   printf("}\n\n");

   i = vectordim;
   for (i=0; i<vectordim; i++)
   {
      printf("for (__x1[%d]=min[%d]; __x1[%d]<=%s; __x1[%d]++)\n",
      i, i, i, maxstring[i],i);
   }
   
   printf("{\n");
   printf("   if (exclusions()) continue;\n");
   printf("   if (private_excl()) continue;\n");
   printf("   state_count++;\n\n");
  
   printf("   if(dbg) fprintf(stderr,\"\\n\"); \n");
   printf("   rules();\n\n");
   printf("   private_rules();\n\n");

   printf("   for (i=0; i<dimension; i++)\n");
   printf("      (void)fprintf(fpcod, \"%%d \", __x1[i]);\n");
   printf("   (void)fprintf(fpcod, \"\\n\");\n\n");

   printf("}\n(void)fprintf(stderr, \"\\n\");\n\n");

   printf("(void)fprintf(fpdim, \"%%10lu\\n\", state_count);\n");
   printf("(void)fprintf(fppar, \"Zahlenbasis: %%10lu\\n\", base);\n");
   printf("(void)fprintf(fppar, \"Vektorlaenge: %%10lu\\n\", dimension);\n");
   printf("\n");

   printf("(void)fclose(fpcod);\n");
   printf("(void)fclose(fpmat);\n");
   printf("(void)fclose(fpdim);\n");
   printf("(void)fclose(fppar);\n");

   printf("\n}\n\n\n");

}

int yyerror()
{
   fprintf(stderr,
           "Fehler Zeile %d. %s ist KEIN Token!\n", lineno-1, yytext);/*FEH*/
   if (c_error == 1) exit(1);
   if (c_error == 2) exit(2);
}
