static char *SccsId = "@(#)PEPSY:\tinstZustEntf.c\t1.2\t92/03/27 11:45:29";
/**********************************************************************************************************************/
/*													              */
/*	MODULNAME:							ERSTELLT:				      */
/*	"instabile_Zustaende_entfernen.c"				Mai 1989	(Peter Menninger)	      */
/*													              */
/*	KURZ-BESCHREIBUNG:											      */
/*	positive Kanten auf instabile Zustaende (Pfadlaenge: 1) werden auf stabile Zustaende umgelenkt                */
/*	(instabile Zustaende werden so uebersprungen und isoliert ==> instabile Zustaende sind nicht mehr erreichbar) */
/*													              */
/*	FUNKTIONEN:											              */
/*  	- Instabile_Zustaende_aushaengen ()	 								      */
/*													              */
/**********************************************************************************************************************/

/**********************************************************************************************************************/
/*														      */
/*	FUNKTION												      */
/*	Instabile_Zustaende_entfernen ()									      */
/*  														      */
/*  	WIRD AUFGERUFEN IN:              	                      	GESPEICHERT IN:				      */
/*  	- Berechnungen ()						"main.c"				      */
/*									     					      */
/*  	BESCHREIBUNG:									                              */
/*  	alle Kanten stabiler Zustaende mit allen Kanten des jeweiligen instabilen 'nach'-Zustandes neu verrechnen     */
/*									     					      */
/*  	VERWENDETE FUNKTIONEN:						GESPEICHERT IN:		     	       	      */
/*	- Head_Meldung_Instabil_umhaengen ()				"meldungen.c"				      */
/*	- Zwei_Kanten_kuerzen ()					"meldungen.c"				      */
/*	- Balken ()							"meldungen.c"				      */
/*									     					      */
/*  	VERWENDETE ABKUERZUNGEN:					DEFINED IN:		     	       	      */
/*	- ALLE_STABILEN_ZUSTAENDE					"define.h"  				      */
/*	- KEINE_KANTE							"define.h"  				      */
/*									     					      */
/**********************************************************************************************************************/


#include "define.h"
#include "defs.h"


Instabile_Zustaende_entfernen ()

{
	register struct kante	*pos_kante;				/* Kante eines   stabilen Zustands	      */
	register struct kante	*neg_kante;				/* Kante eines instabilen Zustands	      */

	register long		zustand;				/* durchlaeuft alle Zustaende		      */


	Head_Meldung_instabil_umhaengen ();				/* Anzeige der Taetigkeit		      */
	
	
	Balken (2);

	ALLE_STABILE_ZUSTAENDE 						/* alle stabile Zustaende bearbeiten	      */

	    ALLE_KANTEN (pos_kante, zustand) {				/*    alle Kanten bearbeiten		      */
		if (pos_kante->uebergangs_rate > 0 &&			/*    falls uebergangs_rate > 0 	      */
                    instabil[pos_kante->nach] > 0) {			/*       und instabile 'nach'-Zustaende       */

		    pos_kante->gueltig = -1;  				/*       positive Kante ungueltig kennzeichnen*/
		    kanten_reduziert++;					/*       entfernte Kanten hochzaehlen	      */

		    ALLE_KANTEN (neg_kante, pos_kante->nach) { 		/*       alle Kanten des 'nach'-Zustandes     */
			if (neg_kante->uebergangs_rate < 0 &&		/*	    falls negative Uebergangsrate     */
			    zustand != neg_kante->nach)			/*          und kein Ring		      */

			    Zwei_Kanten_kuerzen 			/*	    kuerze (positive,negative)	      */
			    (zustand, pos_kante, neg_kante);
		    }
		}
	    }

	}

	Balken (2);

}
