static char *SccsId = "@(#)PEPSY:\tmain.c\t1.2\t92/03/27 11:45:36";
/**********************************************************************************************************************/
/*													              */
/*	MODULNAME:							ERSTELLT:				      */
/*	"main.c"							Mai 1989	(Peter Menninger)	      */
/*													              */
/*	KURZ-BESCHREIBUNG:											      */
/*	- Modul liest Aufrufoptionen ein									      */
/*	- Einlesen der Dateien										              */
/*	- Bearbeiten der Dateien gemaess Aufrufoptionen							              */
/*													              */
/*	FUNKTIONEN:											              */
/*  	- main ()												      */
/*  	- Berechnungen ()											      */
/*	- Debug ()												      */
/*													              */
/**********************************************************************************************************************/

#define MAIN
#include "define.h"
#include "defs.h"

#define USAGE()	{\
		fprintf (stderr, "\nusage: %s  [-Optionen] [-Debug_Optionen]", argv[0]);\
		fprintf (stderr, "\n\nOptionen:");\
		fprintf (stderr, "\np:  entfernen positiver Kanten (bei instabilen Zustaenden)");\
		fprintf (stderr, "\nn:  normieren negativer Kanten (auf Summe -1)");\
		fprintf (stderr, "\nt:  negative Pfade auf Laenge 1 kuerzen");\
		fprintf (stderr, "\ne:  nicht  erreichbare  Zustaende  entfernen");\
		fprintf (stderr, "\ni:  instabile Zustaende entfernen");\
		fprintf (stderr, "\nv:  verdichten");\
		fprintf (stderr, "\n\nDebug_Optionen:");\
		fprintf (stderr, "\n'd1' oder 'd 1':  Taetigkeitsmeldungen +  Dimensions- und Kantenzahl");\
		fprintf (stderr, "\n'd2' oder 'd 2':  Anzeige aller Berechnungen\n");\
		exit(1);}

int		ok = 0;

/**********************************************************************************************************************/
/*													              */
/*	FUNKTION												      */
/*  	main (optionen)												      */
/*  									    					      */
/*  	BESCHREIBUNG:									                              */
/*      Dimension, Kantenzahl, Codierung.tmp, Matrix.tmp lesen							      */
/*	ordnet die eingegebenen Optionen 'optionen' zu			     					      */
/*      Aufruf der Funktion  Berechnungen ()									      */
/*      Dimension, Kantenzahl, Codierung.tmp, Matrix.tmp schreiben						      */
/*  									    					      */
/*  	VERWENDETE FUNKTIONEN:						GESPEICHERT IN:		     		      */
/*  	- Balken ()							"meldungen.c"			              */
/*  	- In_Dimension ()						"io_allgemein.c"			      */
/*  	- In_MElemente () 						"io_allgemein.c"  			      */
/*  	- Out_Dimension () 						"io_allgemein.c" 			      */
/*  	- Out_MElemente () 						"io_allgemein.c"  			      */
/*  	- Codierung_einlesen () 					"io_datei.c"   				      */
/*  	- Codierung_schreiben () 					"io_datei.c"   				      */
/*  	- Matrix_einlesen () 						"io_datei.c"   				      */
/*  	- Matrix_schreiben () 						"io_datei.c"   				      */
/*  									    					      */
/**********************************************************************************************************************/


main (argc, argv)
int	argc;
char 	**argv;

{
	static char   	optionen[10];
	static int  	i = 0;
	static int      copy = 0;
	extern char *getenv();


	if (argc == 1) {   						/* falls Aufruf ohne Argumente		      */
	    strcpy (optionen, "pnteiev");				/*    Vorbesetzen 			      */ 
	    ok = 1; 							/*    richtig				      */
	} else 								/* mit Argumente			      */ 
	    if (argv[1][0] == '-')  					/*    erstes Zeichen: '-'		      */
		if (argv[1][1] == 'd') {  				/*       falls naechstes Zeichen 'd'   	      */
	    	    strcpy (optionen, "pnteiev");			/*          Optionen besetzen		      */
		    Debug (argc, 2, argv[1][2], argv[2][0]);		/*	    dbg Wert zuweisen		      */
		} else {						/*       falls naechstes Zeichen nicht 'd'    */
		    while  (optionen[i++] = argv[1][i+1]);		/*	    naechste Zeichen lesen  	      */
		    if (strlen (optionen) == strspn(optionen, "vpntei"))/*          falls alle Zeichen in {vptei}     */
			if (argc == 2) 					/*	       falls kein weiteres Argument   */  
			    ok =1;					/*	          richtig  (z.B.  -vp)	      */
			 else 						/*	        bei weiteren Argumenten	      */
			    if (argv[2][0] == '-' && argv[2][1] == 'd') /*              falls naechste Zeichen '-d'   */
				Debug (argc, 3, argv[2][2], argv[3][0]);/*                 dbg Wert zuweisen	      */
		}

	if (ok) {
	    COLS = atoi(getenv("COLUMNS"));
	    if(COLS == 0)
		COLS = 80;
	    Balken (1);

	    dimension_in = In_Dimension ();				/* Dimension     einlesen		      */
	    kanten_in    = In_MElemente ();				/* Kantenanzahl  einlesen	              */
	    Codierung_einlesen (COD_TMP);				/* Codierung.tmp einlesen		      */
	    Matrix_einlesen    (MATRIX_TMP);				/* Matrix.tmp    einlesen		      */

	    Berechnungen (optionen);

	    Codierung_schreiben (COD_TMP, COD);				/* Codierung schreiben			      */
	    Matrix_schreiben    (MATRIX);				/* Matrix    schreiben			      */
	    Out_Dimension (dimension_in - dimension_reduziert);		/* Dimension schreiben			      */
	    Out_MElemente (kanten_in    - kanten_reduziert);		/* MElemente schreiben			      */

	    Balken (1);

	    if(copy) system("cp Matrix Matrix.tmp; cp Codierung Codierung.tmp");
	} else 
	    USAGE ();

	if (dbg) printf ("\n");
	exit (0);

}




/**********************************************************************************************************************/
/*													              */
/*	FUNKTION												      */
/*  	Berechnungen (optionen)											      */
/*  									    					      */
/*  	WIRD AUFGERUFEN IN:                                    		GESPEICHERT IN:			     	      */
/*  	- main () 							"main.c"    				      */
/*									     					      */
/*  	BESCHREIBUNG:									                              */
/*	   je nach eingegebenen Optionen werden die gewuenschten Berechnungen ausgefuehrt (Steuerfunktion)	      */
/*									     					      */
/*  	VERWENDETE FUNKTIONEN:						GESPEICHERT IN:		     		      */
/*  	- Verdichten_Codierung () 					"verdichten.c"   			      */
/*  	- Verdichten_Matrix () 						"verdichten.c"   			      */
/*  	- Positiv_entfernen ()	 					"pos_entfernen_neg_normieren.c"		      */
/*  	- Negativ_normieren () 						"pos_entfernen_neg_normieren.c"		      */
/*  	- Negative_Pfade_Laenge_1 () 					"negative_Pfade_Laenge_1.c"		      */
/*  	- Erreichbarkeitsanalyse () 					"erreichbar.c" 				      */
/*  	- Instabile_Zustaende_entfernen ()				"instabile_Zustaende_aushaengen.c"  	      */
/*  	- Instabil_berechnen () 					"routinen.c"   				      */
/*  	- Ungueltige_Kanten_entfernen () 				"routinen.c"   				      */
/*  	- Berechnungen () 						"main.c"   				      */
/* 									     					      */
/*  	VERWENDETE ABKUERZUNGEN:					DEFINED IN:		     	       	      */
/*	- COD_TMP							"define.h"				      */
/*	- MATRIX_TMP							"define.h"				      */
/*														      */
/**********************************************************************************************************************/


Berechnungen (optionen)
char 	*optionen;

{
	char   	menue;
	int	stelle = 0;

	while ((menue = *(optionen+stelle++)) != '\0') {		/* eine Option nach der anderen abarbeiten    */
	    switch (menue) {						/*    je nach Option			      */
		case 'v':   if (stelle > 1) {				/*       falls 1. Option == 'v'               */
				Verdichten_Codierung ();		/*           Verdichten entfaellt	      */
			    	Verdichten_Matrix (); 			/*         (da beim Einlesen schon verdichtet)*/
			    }
			    break;

		case 'p':   Instabil_berechnen ();			/*       Instabile Zustaende kennzeichen      */
			    Positiv_entfernen (); 			/*       bei instabilen Zustaenden: positive  */
			    Ungueltige_Kanten_entfernen ();		/*           Kanten ungueltig kennzeichnen    */
			    free (instabil);
			    break;					/*       ungueltige Kanten entfernen	      */

		case 'n':   Instabil_berechnen ();			/*       Instabile Zustaende kennzeichen      */
			    Negativ_normieren (); 			/*       bei instabilen Zustaenden: negative  */
			    free (instabil);
			    break;					/*       Uebergangsrate auf Summe -1 normieren*/

		case 't':   Instabil_berechnen ();			/*       Instabile Zustaende kennzeichen      */
			    Negative_Pfade_Laenge_1 ();			/*       negative Pfade auf Laenge 1 kuerzen  */
			    Ungueltige_Kanten_entfernen ();		/*       ungueltige Kanten entfernen	      */
			    free (instabil);
			    break;				

		case 'e':   Erreichbarkeitsanalyse ();			/*       Zustaende ohne einmuendenden Kanten  */
			    Ungueltige_Kanten_entfernen ();		/*       kennzeichnen (Kanten ungueltig)      */
			    break;					/*       ungueltige Kanten entfernen	      */

		case 'i':   Instabil_berechnen ();			/*       Instabile Zustaende kennzeichen      */
			    Instabile_Zustaende_entfernen ();		/*       positive Kanten auf inst. Zustaende  */
			    Ungueltige_Kanten_entfernen ();		/*       umlenken
			    free (instabil);
			    break;					/*       ungueltige Kanten entfernen	      */
	    }
	}

}




/**********************************************************************************************************************/
/*													              */
/*	FUNKTION												      */
/*  	Debug (optionen)											      */
/*  									    					      */
/*  	WIRD AUFGERUFEN IN:                                    		GESPEICHERT IN:			     	      */
/*  	- main () 							"main.c"    				      */
/*									     					      */
/*  	BESCHREIBUNG:									                              */
/*	Eingabe: -d x oder -dx  (fuer Debug-Wert) ==>   dbg = x 	     					      */
/*									     					      */
/**********************************************************************************************************************/


Debug (argc, anzahl, wert_1, wert_2)
int	argc;
int	anzahl;
char	wert_1;
char	wert_2;

{ 
	if (argc == anzahl) {						/* falls argc == anzahl   (z.B -dx)	      */
	    if (((dbg = wert_1 - '0') == 1 ) || (dbg == 2))  		/*    falls x == 1 oder x == 2	    	      */
		ok = 1;							/*        ok.				      */
	} else 					
	    if (argc == anzahl+1)					/* falls argc == anzahl+1  (z.B -d x)	      */
		if (((dbg = wert_2 - '0') == 1 ) || (dbg == 2)) 	/*    falls x == 1 oder x == 2	    	      */
		    ok = 1;						/*        ok.				      */
}
