/**********************************************************************************************************************/
/*													              */
/*	MODULNAME:							ERSTELLT:				      */
/*	"meldungen.c"							Mai 1989	(Peter Menninger)	      */
/*													              */
/*	FUNKTIONEN:											              */
/*  	- Balken ()												      */
/*	- Head_Meldung_Codierung_verdichten ()		- Head_Meldung_Matrix_verdichten ()			      */
/*	- Work_Meldung_Codierung_verdichten ()   	- Work_Meldung_Matrix_verdichten ()			      */
/*													              */
/*	- Head_Meldung_positiv_entfernen ()		- Head_Meldung_negativ_normieren ()			      */
/*	- Work_Meldung_positiv_entfernen ()       	- Work_Meldung_negativ_normieren ()			      */
/*												 		      */
/*	- Head_Meldung_erreichbar ()										      */
/*	- Work_Meldung_nicht_erreichbar ()									      */
/*													              */
/*	- Head_Meldung_Pfad_Laenge_1 () 		- Head_Meldung_instabil_umhaengen ()			      */
/*													              */
/*	- Head_Meldung_In_MElemente ()			- Head_Meldung_In_Dimension ()				      */
/*	- Head_Meldung_Out_MElemente ()			- Head_Meldung_Out_Dimension ()				      */
/*	- Meldung_falsche_MElemente ()			- Meldung_falsche_Dimension ()				      */
/*													              */
/*	- Meldung_aus ()				- Meldung_keine_Kante_vorhanden ()			      */
/*	- Meldung_und ()				- Meldung_Kantenanfang_kleiner_vorheriger ()		      */
/*	- Neue_Kante ()					- Meldung_Zustand_groesser_vorheriger ()		      */
/*													              */
/*	- Meldung_ausserhalb () 			- Meldung_nicht_innerhalb ()				      */
/*													              */
/**********************************************************************************************************************/

static char *SccsId = "@(#)PEPSY:\tmeldungen.c\t1.3\t92/03/27 11:45:38";

#ifdef ultrix
#	include <cursesX.h>
#else
#	include <curses.h>
#endif

#include <string.h>
#include "define.h"
#include "defs.h"

#define SPACE_16	(COLS > 96 ? "                " : "")
#define SPACE_37	(COLS > 117 ? "                                     " : "")

#define DBG1_IO(format, parameter_1, parameter_2, parameter_3)	\
				if (dbg >= 1) { \
					fflush (stdout); \
					putchar ('\n'); \
					sprintf (var, format, parameter_1, parameter_2, parameter_3); \
					sprintf (format_neu, "%%%ds", COLS - strlen (var)-1); \
					sprintf (var + strlen (var), format_neu, "|"); \
					printf (var); \
				}

#define DBG1(format, parameter_1, parameter_2)	\
				if (dbg >= 1) { \
					fflush (stdout); \
					putchar ('\n'); \
					sprintf (var, format, parameter_1, parameter_2); \
					sprintf (format_neu, "%%%ds", COLS - strlen (var)-1); \
					sprintf (var + strlen (var), format_neu, "|"); \
					printf (var); \
				}


#define AUSGABE(format, parameter)	\
				sprintf (var, format, parameter); \
				fflush (stdout); \
				printf (var);


char			var[151];				/* zudruckende Variable hat hoechstens 150 Zeichen    */
char			format_neu[10];				/* Format fuer sprintf				      */
char			balken[151] ="------------------------------------------------------------------------------------------------------------------------------------------------------"; 




Balken (debug)							/* Balken in der Laenge der aktuellen Bildschirmbreite*/
short	debug;
{
	if (dbg >= debug ) {				
	    fflush (stdout); 
	    putchar ('\n'); 
	    var[0] = '|'; 
	    sprintf (format_neu, "%%.%ds", COLS-2); 
	    sprintf (var + 1, format_neu, balken); 
	    var[COLS-2] = '|'; 
	    printf (var);
	}
}




Head_Meldung_Codierung_verdichten ()

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*                        unverdichtete Zustaende:               Codierung.tmp verdichten			      */
/*--------------------------------------------------------------------------------------------------------------------*/
	DBG1("|           unverdichtete Zustaende:               %s%s verdichten", SPACE_16, COD_TMP);
} 




Work_Meldung_Codierung_verdichten (gedruckt, codierung, zustand)
long		gedruckt;
unsigned long	*codierung;
long		zustand;

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*     65->0               66->1               67->2              128->3              257->4              258->5      */
/*--------------------------------------------------------------------------------------------------------------------*/
	AUSGABE ("%s", gedruckt % (COLS/19) == 0 ? "\n" : "");
	AUSGABE ("%10lu", *(codierung+zustand));
	AUSGABE ("->", 0);
	AUSGABE ("%-7ld", zustand);
} 




Head_Meldung_Matrix_verdichten ()

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*               					  	Matrix.tmp verdichten				      */
/*--------------------------------------------------------------------------------------------------------------------*/
	DBG1("|                                                  %s%s    verdichten", SPACE_16, MATRIX_TMP);
} 




Work_Meldung_Matrix_verdichten (gedruckt, von, von__verdichtet, nach, nach_verdichtet)
long		gedruckt;
unsigned long	von;
unsigned long	nach;
long		von__verdichtet;
long		nach_verdichtet;

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*     65>0----->66>2             258>7------>512>9							              */
/*--------------------------------------------------------------------------------------------------------------------*/
	AUSGABE ("%s", gedruckt % (COLS/36) == 0 ? "\n" : "");
	AUSGABE ("%10lu", von);
	AUSGABE (">", 0);
	AUSGABE ("%-4ld", von__verdichtet);
	AUSGABE ("----->", 0);
	AUSGABE ("%10lu", nach);
	AUSGABE (">", 0);
	AUSGABE ("%-4ld", nach_verdichtet);
} 




Meldung_ausserhalb (von, nach, wer, untere_Grenze, obere_Grenze)
unsigned long	von, nach, wer;
unsigned long	untere_Grenze, obere_Grenze;

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*      ---->   Semantik-Fehler:  Kante (9160--------->67)  							      */
/*      			  Zustand (9160) ausserhalb der Liste ('65' - '8192')				      */
/*		(Zustaende-Codierung aus 'Matrix.tmp' und 'Codierung.tmp' stimmen nicht ueberein)		      */
/*--------------------------------------------------------------------------------------------------------------------*/
	SEMANTIK"\n----> Semantik-Fehler:  Kante (%lu--------->%lu)", von, nach);  
	SEMANTIK"\n\t\t\tZustand (%lu) ausserhalb der Liste ('%lu' - '%lu')", wer, untere_Grenze, obere_Grenze);  
	SEMANTIK"\n\t(Zustaende-Codierungen aus '%s' und '%s' stimmen nicht ueberein)\n", MATRIX_TMP, COD_TMP);
	exit (1);
}




Meldung_nicht_innerhalb (von, nach, wer, untere_Grenze, obere_Grenze)
unsigned long	von, nach, wer;
unsigned long	untere_Grenze, obere_Grenze;

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*    	---->   Semantik-Fehler:  Kante (4162--------->67)							      */
/*				  Zustand (4162) nicht innerhalb der Liste ('65' - '8192')			      */
/*	   	(Zustaende-Codierungen aus 'Matrix.tmp' und 'Codierung.tmp' stimmen nicht ueberein)		      */
/*--------------------------------------------------------------------------------------------------------------------*/
	SEMANTIK"\n----> Semantik-Fehler:  Kante (%lu--------->%lu)", von, nach);  
	SEMANTIK"\n\t\t\tZustand (%lu) nicht innerhalb der Liste ('%lu' - '%lu') ", wer, untere_Grenze, obere_Grenze); 
	SEMANTIK"\n\t(Zustaende-Codierungen aus '%s' und '%s' stimmen nicht ueberein)\n", MATRIX_TMP, COD_TMP);
	exit (1);
} 




Head_Meldung_positiv_entfernen ()

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*               	  instabile  Zustaende:         positive  Kanten  entfernen				      */
/*--------------------------------------------------------------------------------------------------------------------*/
	DBG1("|           instabile  Zustaende:         %spositive Kanten  entfernen", SPACE_16, 0);
} 




Work_Meldung_positiv_entfernen (gedruckt, zustand, link)
long		gedruckt;
long		zustand;
struct kante	*link;

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*    30 --- 0.0029--->2           32 --- 0.0168--->10          32 --- 0.0029--->8           35 ---     16--->36      */
/*--------------------------------------------------------------------------------------------------------------------*/
	AUSGABE ("%s", gedruckt % (COLS/25)== 0 ? "\n" : "");
	AUSGABE ("%6ld",  zustand);
	AUSGABE ("---", 0);
	AUSGABE ("%6g", ((float)((int)(link->uebergangs_rate*10000)))/10000);
	AUSGABE ("--->", 0);
	AUSGABE ("%-6ld", link->nach);
} 




Head_Meldung_negativ_normieren ()

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*		               		         	negative  Kanten  normieren				      */
/*--------------------------------------------------------------------------------------------------------------------*/
	DBG1("|                                         %snegative Kanten  normieren", SPACE_16, 0)
} 




Work_Meldung_negativ_normieren (gedruckt, zustand, kante, summe)
long		gedruckt;
long		zustand;
struct kante  *kante;
double		summe;

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*  35 -- (-0.01-->-0.004) ---> 16          36 -- (-0.98-->-0.245) ---> 22          36 -- (-0.01-->-0.004) ---> 29    */
/*--------------------------------------------------------------------------------------------------------------------*/
	AUSGABE ("%s", gedruckt % (COLS/31) == 0 ? "\n" : "");
	AUSGABE ("%6ld", zustand);
	AUSGABE ("--(", 0);
	AUSGABE ("%5g", ((float)((int)(100*kante->uebergangs_rate)))/100);
	AUSGABE ("=>", 0);
	AUSGABE ("%5g", ((float)((int)(100*kante->uebergangs_rate/summe)))/100);
	AUSGABE (")-->", 0);
	AUSGABE ("%-6ld", kante->nach);
}




Head_Meldung_erreichbar ()

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*              	  nicht erreichbare Zustaende:  	   Zustand  entfernen                                 */
/*--------------------------------------------------------------------------------------------------------------------*/
	DBG1("|           nicht erreichbare Zustaende:           %sZustand  entfernen", SPACE_16, 0); 
} 




Work_Meldung_nicht_erreichbar (gedruckt, zustand)
long	gedruckt;
long	zustand;

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*     354     456	          										      */
/*--------------------------------------------------------------------------------------------------------------------*/
	AUSGABE ("%s", (gedruckt % (COLS/7)) == 0 ? "\n" : "");
	AUSGABE ("%7ld", zustand);
} 




Head_Meldung_Pfad_Laenge_1 ()

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*		               		         	 negative  Pfade   kuerzen				      */
/*--------------------------------------------------------------------------------------------------------------------*/
	DBG1("|                                         %snegative Pfade   kuerzen", SPACE_16, 0);
}




Head_Meldung_instabil_umhaengen ()

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*               	  vor instabilen Zustaenden:      positive Kanten  umlenken                                   */
/*--------------------------------------------------------------------------------------------------------------------*/
    	DBG1("|           vor instabilen Zustaenden:    %spositive Kanten  umlenken", SPACE_16, 0);

}




Head_Meldung_In_MElemente (kanten)
long	kanten;

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*   Input:      Kanten:	 138	                                                                              */
/*--------------------------------------------------------------------------------------------------------------------*/
	DBG1 ("|  Input:   Kanten:                %7ld", kanten, 0);
}



Head_Meldung_Out_MElemente (kanten)
long	kanten;

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*   Output:     Kanten:	  34                      Kanten-Reduktion:  7					      */
/*--------------------------------------------------------------------------------------------------------------------*/ 
	DBG1_IO ("|  Output:  Kanten:                %7ld         %sKanten-Reduktion:   %7ld", 
	    kanten, SPACE_37, kanten_in - kanten);
} 



Meldung_falsche_MElemente (kanten_in, kanten)
long	kanten_in;
long	kanten;

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*   ---->   Semantik-Fehler:  Kanten aus MElemente (-Dimension): 136 						      */
/*				      und Matrix.tmp:             126						      */
/*--------------------------------------------------------------------------------------------------------------------*/
	SEMANTIK"\n---->   Semantik-Fehler:  Kanten aus %s (-Dimension): \t%6ld ", MATRIX_ELEMENTE, kanten_in);  
	SEMANTIK"\n                                 und %s:\t\t%6ld", MATRIX_TMP, kanten);
	Balken (1);
	putchar ('\n');
	exit (1);
}
	


Head_Meldung_In_Dimension (dimension)
long	dimension;

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*   Input:      Dimension der Matrix:   45                                                                           */
/*--------------------------------------------------------------------------------------------------------------------*/
	DBG1("|  Input:   Dimension der Matrix:   %6ld", dimension, 0);
} 



Head_Meldung_Out_Dimension (dimension)
long	dimension;

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*   Output:     Dimension der Matrix:   260             Dimensions-Reduktion:  190                                   */
/*--------------------------------------------------------------------------------------------------------------------*/
	DBG1_IO ("|  Output:  Dimension der Matrix:   %6ld         %sDimensions-Reduktion:%6ld",
	dimension, SPACE_37, dimension_in - dimension);

	if (dimension == 0) {
	    SEMANTIK"\n---->\tSemantik-Fehler:  kein Zustand mehr vorhanden\n");  
	    exit(1);
	}
}



Meldung_falsche_Dimension (dimension_in, dimension)
long	dimension_in;
long	dimension;

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*   ---->   Semantik-Fehler:  Dimension  aus Dimension     136 						      */
/*				          und Codierung.tmp 126							      */
/*--------------------------------------------------------------------------------------------------------------------*/
	SEMANTIK"\n---->   Semantik-Fehler:  Dimension aus %s:\t%6ld", DIMENSION, dimension_in);  
	SEMANTIK"\n                                    und %s:\t%6ld", COD_TMP, dimension);
	Balken (1);
	putchar ('\n');
	exit (1);
}
	




Meldung_aus (zustand, kante_1)
long		zustand;
struct kante	*kante_1;

{
/*--------------------------------------------------------------------------------------------------------------------*/
/* aus:         44 -------------- (-0.245) ------> 42                                                                 */
/*--------------------------------------------------------------------------------------------------------------------*/
	AUSGABE("\naus: ", 0);
	AUSGABE("%6ld", zustand);
	AUSGABE(" %s", (COLS<120)? "":"--------");
	AUSGABE("----- (", 0);
	AUSGABE("%6g", ((float)((long)((kante_1->uebergangs_rate)*1000)))/1000);
	AUSGABE(")", 0);
	AUSGABE("%s", (COLS<120)? "":"--------");
	AUSGABE("----> ", 0);
	AUSGABE("%-6ld", kante_1->nach);
}



Meldung_und (zustand, kante_2)
long		zustand;
struct kante	*kante_2;

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*  und:                                            42      -------------- (-0.49)  ------>     26                    */
/*--------------------------------------------------------------------------------------------------------------------*/
	AUSGABE ("\nund:    \t\t\t%s", (COLS>=120)?"\t\t":"");
	AUSGABE ("%-6ld", zustand);
	AUSGABE ("%s----- ", (COLS<120)? "":"--------");
	AUSGABE ("(%6g)", ((float)((long)(kante_2->uebergangs_rate*1000)))/1000);
	AUSGABE ("%s----->", (COLS<120)? "":"--------");
	AUSGABE ("%6ld", kante_2->nach);
} 



Neue_Kante (zustand, kante, text)
long		zustand;
struct kante	*kante;
char		*text;

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*    ==>      11 ---------------------------------- 1      ----------------------------------->    10  (neu)         */
/*--------------------------------------------------------------------------------------------------------------------*/
	AUSGABE ("\n==>  ", 0); 
	AUSGABE ("%6ld", zustand); 
	AUSGABE (" %s", (COLS < 120) ? "" : "----------------"); 
	AUSGABE ("------------------ ", 0); 
	AUSGABE ("%-7g", ((float)((long)(kante->uebergangs_rate*10000)))/10000); 
	AUSGABE ("%s", (COLS < 120) ? "" : "----------------"); 
	AUSGABE ("------------------->", 0); 
	AUSGABE ("%6ld", kante->nach); 
	AUSGABE ("  (%s)\n", text); 
}



Meldung_Zustand_groesser_vorheriger (zustand, aktueller, vorheriger)
long		zustand;
unsigned long	vorheriger;
unsigned long	aktueller;

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*----> Semantik-Fehler: 											      */
/*      Zustaende in 'Codierung.tmp' nicht in aufsteigender Reihenfolge						      */
/*                        20-ter Zustand:       5120								      */
/*			  21-ter Zustand:       4192								      */
/*===> - Zustaende nicht geordnet 									  	      */
/*     - Codierungen groesser als 4294967295 (Ueberlauf!) 							      */
/*--------------------------------------------------------------------------------------------------------------------*/
	SEMANTIK"\n----> Semantik-Fehler:"); 
	SEMANTIK"\n      Zustaende in '%s' nicht in aufsteigender Reihenfolge", COD_TMP); 
	SEMANTIK"\n\t\t\t%ld-ter Zustand: %lu", zustand-1, vorheriger);
	SEMANTIK"\n\t\t\t%ld-ter Zustand: %lu", zustand, aktueller);
	SEMANTIK"\n====> -  Zustaende nicht geordnet ");
	SEMANTIK"\n      -  Codierungen groesser als 4294967295 (Ueberlauf!)\n");
	exit(1);
}




Meldung_keine_Kante_vorhanden ()

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*-----> Semantik-Fehler:    keine Kanten (mit Uebergangsrate <> 0) vorhanden!				              */
/*--------------------------------------------------------------------------------------------------------------------*/
	SEMANTIK"\n----> Semantik-Fehler:    keine Kanten (mit Uebergangsrate <> 0) vorhanden!\n");
	exit (1);
}



Meldung_Kantenanfang_kleiner_vorheriger (von, von__vorheriger, nach, nach_vorheriger)
unsigned long	von;
unsigned long	nach;
unsigned long	von__vorheriger;
unsigned long	nach_vorheriger;

{
/*--------------------------------------------------------------------------------------------------------------------*/
/*----> Semantik-Fehler:  											      */
/*	Kanten in 'Matrix.tmp' in absteigender Reihenfolge						              */
/*			  auf:   Kante (67 ------> 128)								      */
/*			  folgt: Kante (28 ------> 4160)							      */
/*====> - Kanten nicht geordnet 										      */
/*      - Codierungen groesser als 4294967295 (Ueberlauf!)							      */
/*--------------------------------------------------------------------------------------------------------------------*/
	SEMANTIK"\n----> Semantik-Fehler:"); 
	SEMANTIK"\n      Kanten in '%s' in absteigender Reihenfolge", MATRIX_TMP); 
	SEMANTIK"\n\t\t\tauf:   Kante (%lu ------> %lu)", von__vorheriger, nach_vorheriger);
	SEMANTIK"\n\t\t\tfolgt: Kante (%lu ------> %lu)", von, nach);
	SEMANTIK"\n====> -  Kanten nicht geordnet ");
	SEMANTIK"\n      -  Codierungen groesser als 4294967295 (Ueberlauf!)\n");
	exit(1);
} 
