/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tausgabe.c\t1.2\t95/05/19 15:36:36";

#define ALLGEMEIN_C
#define EXTERN_KNOTENTYPEN

#include "init.h"

/***********************************************************
************************************************************
**
**	Autor: Martin Fischer
**
**	Datum: November 1993
**
**	Funktionsname: Ausgabe
**
**	Funktionstyp: void
**
**	Uebergabeparameter: File *fpout - Filedescriptor
**
**
**	Beschreibung:
**  Ausgabe der geforderten Leistungsgroessen an den durch
**  den Filedescriptor beschriebenen Ausgabekanal
**
**
************************************************************
***********************************************************/

void Ausgabe(fpout)
FILE *fpout;
{
	int i, k;
	KNOTEN_KLASSE *akt_node;

	fpout = stdout;

	fprintf(fpout, "%s\n", verfahren_name);

	fprintf(fpout, "2 %d %d\n", AnzKnoten, AnzKlassen);


	for (k = 0; k < AnzKlassen; k++) {

		dbginfo(1, "KLASSE %d:\n", k)

		for (i = 1; i <= AnzKnoten; i++) {

			akt_node = &(klasse[k].knoten[i]);

			dbginfo(DBG_AUSGABE, "KNOTEN %d: ", i)
			dbginfo(DBG_AUSGABE, "lambda: %f  ", akt_node->lambda)
			dbginfo(DBG_AUSGABE, "e: %f  ", akt_node->e)
			dbginfo(DBG_AUSGABE, "mue: %f  ", akt_node->mue)
			dbginfo(DBG_AUSGABE, "rho: %f  ", akt_node->rho)
			dbginfo(DBG_AUSGABE, "mvz: %f  ", akt_node->mvz)
			dbginfo(DBG_AUSGABE, "maa: %f  ", akt_node->maa)
			dbginfo(DBG_AUSGABE, "mwz: %f  ", akt_node->mwz)
			dbginfo(DBG_AUSGABE, "mwsl: %f\n", akt_node->mwsl)

		} /* end for i */

	} /* end for k */

	dbgtext(DBG_AUSGABE, "\n")	

	dbgtext(DBG_AUSGABE, "quad. Varkoeff d. Ankunftsprozesse\n")

	for (k = 0; k < AnzKlassen; k++) {

		dbginfo(1, "KLASSE %d:\n", k)

		for (i = 1; i <= AnzKnoten; i++) {

			akt_node = &(klasse[k].knoten[i]);

			dbginfo(DBG_AUSGABE, "%f  ", akt_node->c2A)

		} /* end for i */

	} /* end for k */

	dbgtext(DBG_AUSGABE, "\n")
}


void Ausgabe_Q(fpout, p)
FILE *fpout;
int p;
{
	int i, k;
	KNOTEN_KLASSE *akt_node;

	fpout = stdout;

/*	fprintf(fpout, "multioutput\n%s\n", verfahren[p].name);*/

	fprintf(fpout, "multioutput\n%s\n", &(VERFAHREN[0]));

	fprintf(fpout, "2 %d %d\n", AnzKnoten, AnzKlassen);

	for (k = 0; k < AnzKlassen; k++) {

		dbginfo(1, "KLASSE %d:\n", k)

		for (i = 1; i <= AnzKnoten; i++) {

			akt_node = &(klasse[k].knoten[i]);

			/* printf("%6.3lf\n", akt_node->mwsl); */

			fprintf(fpout,
				"%8.6f %8.6f %8.6f %8.6f %8.6f %8.6f %8.6f %8.6f\n",
				akt_node->lambda,
				akt_node->e,
				1/akt_node->mue,
				akt_node->rho,
				akt_node->mvz,
				akt_node->maa,
				akt_node->mwz,
				akt_node->mwsl);

			/* fprintf(fpout, "%8.6f\n", akt_node->c2A); */

		} /* end for i */

	} /* end for k */


  /* Ausgabe von Zusatzinformation: */

  /* Ausgabe des Namen des angewandten Verfahrens */
  /* Wichtig zur Unterscheidung bei der all-Option */

  fprintf(fpout, "Das Netz wurde mit den Verfahren %s analysiert\n", verfahren[p].name);
  fprintf(fpout, " \n");

  /* Ausgabe der Formeln zur Berechnung der Leistungsgroessen */
  /* Die Ausgabe erfolgt fuer jeden Knoten und Klasse */

  fprintf(fpout, "folgende Formeln wurden zur Berechnung\n");
  fprintf(fpout, "der Leistungsgroessen verwendet:\n");
  fprintf(fpout, " \n");

  fprintf(fpout, "            ");
  for (i = 1; i <= AnzKnoten; i++)
  {
    fprintf(fpout, "|  Knoten %d  ", i);
  } 
  fprintf(fpout, "\n");
  fprintf(fpout, "------------");
  for (i = 1; i <= AnzKnoten; i++)
  {
    fprintf(fpout, "|------------", i);
  }
  fprintf(fpout, "\n");

	for (k = 0; k < AnzKlassen; k++) {

		dbginfo(1, "KLASSE %d:\n", k)

    fprintf(fpout, "Klasse  %d   ", k+1);

		for (i = 1; i <= AnzKnoten; i++) {

			akt_node = &(klasse[k].knoten[i]);

			fprintf(fpout, "|    %s     ", akt_node->flg_name);

		} /* end for i */

    fprintf(fpout, "\n");

	} /* end for k */

 fprintf(fpout, " \n");
  fprintf(fpout, "Legende: \n \n");
  fprintf(fpout, "cos : Formel nach Cosmetatos\n");
  fprintf(fpout, "a_c : Formel nach Allen und Cunneen\n");
  fprintf(fpout, "klb : Formel nach Kramer und Langenbach-Belz\n");
  fprintf(fpout, "pag : Formel nach Page\n");
  fprintf(fpout, "mar : Formel nach Marchal\n");
  fprintf(fpout, "kim : Formel nach Kimura\n");


}


/***********************************************************
************************************************************
**
**	Autor: Martin Fischer
**
**	Datum: November 1993
**
**	Funktionsname: InitPostFilter
**
**	Funktionstyp: void
**
**	Uebergabeparameter: File *fpout - Filedescriptor
**
**
**	Beschreibung:
**
**
************************************************************
***********************************************************/

void InitPostFilter(fpout, anz)
FILE *fpout;
int anz;
{
/*
	fprintf(fpout, "multioutput %i\n", anz);
*/
}
