/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  91058 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

/***********************************************************
************************************************************
**
**  Modulname: auto_all.c
**
**	Beschreibung:
**  in diesen Modul werden alle verfahrenspezifischen Funk-
**  tionen fuer die automatische Auswahl einer Dekompositions-
**  methode definiert. Die Funktionen aus diesen Modul duerfen 
**  Funktionen aus den Modulen 'allgemein.c', 'leistung.c', 
**  sowie aus den Modulen fuer die implementierten Dekomposi-
**  tionsmethoden verwenden.
**  
**
***********************************************************
***********************************************************/

static char *SccsId = "@(#)PEPSY:\tauto_all.c\t1.2\t95/05/19 15:36:41";

#define AUTO_ALL_C
#define EXTERN_KNOTENTYPEN

#include "init.h"
#include "d_debug.h"


int *auto_all_CheckVerfahren()
{
    int i, n, KnotenMenge;
    int *p;
    int ok;

    Einlesen(stdin);

    if (NetzTyp != 2) {
	fprintf(stderr, "falscher Netztyp\n\n");
	printf("0 0 0\n");
	exit(-1);
    }

    KnotenMenge = 0;

    for (i = 1; i <= AnzKnoten; i++)
    {
	KnotenMenge |= knoten[i].KnotenTyp;
    }

    n = 0;
    p = (int *)malloc((ANZ_VERFAHREN + 1)*sizeof(int));

    dbginfo(10, "auto_all_CheckVerfahren(): KnotenMenge=0x%x\n", KnotenMenge);
    dbginfo(10, "auto_all_CheckVerfahren(): AnzKlassen =%d\n", AnzKlassen);

    for (i = 0; i < ANZ_VERFAHREN; i++)
    {
	dbginfo(10, "auto_all_CheckVerfahren(): Teste Verfahren '%s'...\n", verfahren[i].name);

	ok = 1;

	if (((verfahren[i].KnTypen & KnotenMenge) != KnotenMenge))
	{
	    dbginfo(10, "auto_all_CHeckVerfahren(): ... failed. Erlaubte Knotenmenge=0x%x.\n", verfahren[i].KnTypen);
	    ok = 0;
	}

	if ((verfahren[i].Klassen != 0) && (verfahren[i].Klassen < AnzKlassen))
	{
	    dbginfo(10, "auto_all_CheckVerfahren(): ... failed. Erlaubte Klassenzahl max %d.\n", verfahren[i].Klassen);
	    ok = 0;
	}

	if (ok)
	{
	    dbgtext(10, "auto_all_CheckVerfahren(): ... ist anwendbar!\n");

	    p[n] = i;
	    n++;
	}
    }

    p[n] = -1;

    if (*p == -1){
	fprintf(stderr, "Auf das eingegebene Netz ist kein Verfahren anwendbar\n");
	printf("0 0 0 \n");
    }
	
    AnzVer = n;

    return (p);
}


