/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  91058 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

/***********************************************************
************************************************************
**
**  Modulname: auto_best.c
**
**	Beschreibung:
**  in diesen Modul werden alle verfahrenspezifischen Funk-
**  tionen fuer die automatische Auswahl einer Dekompositions-
**  methode definiert. Die Funktionen aus diesen Modul duerfen 
**  Funktionen aus den Modulen 'allgemein.c', 'leistung.c', 
**  sowie aus den Modulen fuer die implementierten Dekomposi-
**  tionsmethoden verwenden.
**  
**
***********************************************************
***********************************************************/

static char *SccsId = "@(#)PEPSY:\tauto_best.c\t1.2\t95/05/19 15:36:43";

#define AUTO_BEST_C
#define EXTERN_KNOTENTYPEN

#include "init.h"

#define PF 1
#define N_PF 0
#define SINGLE_CLASS 2
#define MULTI_CLASS 0
#define SINGLE_SERVER 4
#define MULTI_SERVER 0 

char *tabelle[8] = {
	"pujolle",   /*  000  */
	"pujolle",   /*  001  */
	"whitt",     /*  010  */
	"whitt",     /*  011  */
	"whitt",     /*  100  */
	"chylla",    /*  101  */
	"whitt",     /*  110  */
	"kuehn"      /*  111  */
};


int *auto_best_CheckVerfahren()
{
	int i, index0, index1, index2, index;
	int ProofAnzKlassen(), ProofProduktform(), ProofAnzBS();
	int *p;
	Einlesen(stdin);

	if (NetzTyp != 2) {
		fprintf(stderr, "falscher Netztyp\n");
		printf("0 0 0\n");
		exit(-1);
	}

	/* Setze Formel zur Berechnung der LG auf 'auto' */

  formel_name = (char *)malloc (5 *sizeof(char));
	strcpy(formel_name, "auto\0");	
	formel_nr = GetFormelLeistung();

	index0 = ProofProduktform();

	index1 = ProofAnzKlassen();

	index2 = ProofAnzBS();

	index = index0 | index1 | index2;

	for (i = 0; i < ANZ_VERFAHREN; i++) {

		if (!strcmp(tabelle[index], verfahren[i].name)) {
			p = (int *)malloc(2*sizeof(int));
			p[0] = i;
			p[1] = -1;

/*			strcpy(verfahren[i].name, "dekomp");*/
			AnzVer = SINGLE;

			return (p);
		}
	}

	exit(-1);

}


int ProofAnzKlassen()
{

	if (AnzKlassen > 1) {
		return (MULTI_CLASS);
	}
	else if (AnzKlassen == 1) {
		return (SINGLE_CLASS);
	}
	else {
		exit(-1);
	}
}

int ProofProduktform()
{
	int i;

	for (i = 1; i <= AnzKnoten; i++) {
		if ((knoten[i].KnotenTyp & (TYP_PF)) != knoten[i].KnotenTyp) {
			return (N_PF);
		}
	}
	return (PF);
}


int ProofAnzBS()
{
	int i;

	for (i = 1; i <= AnzKnoten; i++) {
		if (knoten[i].AnzServer > 1) {
			return (MULTI_SERVER);
		}
	}
	return (SINGLE_SERVER);
}

