/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  91058 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/


/***********************************************************
************************************************************
**
**  Modulname: def.h
**
**	Beschreibung:
**  Definition der globalen Daten
**
***********************************************************
***********************************************************/
static char *SccsDef_h = "@(#)PEPSY:\tdef.h\t1.2\t95/05/19 15:36:49";

#define EXTERN_KNOTENTYPEN

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include "d_debug.h"
#include "d_konst.h"

#include "typedef.h"
#include "allg.h"
#include "help.h"
#include "leistung.h"
#include "kuehn.h"
#include "chylla.h"
#include "pujolle.h"
#include "whitt.h"
#include "auto.h"

#define SQR(x) pow(x, 2.0)

/* netzweite Daten */

#ifdef MAIN_C
#define EXTERN
#else
#define EXTERN extern
#endif

EXTERN	int	NetzTyp;	/* Typ des Netzes */
EXTERN	int	AnzKnoten;	/* Anzahl der Knoten */
EXTERN	int	AnzKlassen;	/* Anzahl der Klassen */
EXTERN	KLASSE *klasse;	/* Array mit den klassenabhaengigen Daten */			
EXTERN	KNOTEN_NETZ *knoten;	/* Array mit den knotenabhaengigen, jedoch klassenunabhaengigen Daten */
EXTERN	int	dbg;
EXTERN	double	epsilon;
EXTERN	int AnzVer;
EXTERN	char *verfahren_name, *formel_name;
EXTERN	int verfahren_nr, formel_nr;
EXTERN	char VERFAHREN[16];

#ifdef MAIN_C
EXTERN	int FLAG_FLG = 0;
#else
EXTERN	int FLAG_FLG;
#endif


#define MAX_IT 50

#define STABIL 1
#define INSTABIL 0

#define OK 1
#define ERROR 0

#define SINGLE 1

#define DBG_EINGABE 20
#define DBG_AUSGABE 5
#define DBG_FKT1 5
#define DBG_FKT2 5
#define DBG_FKT3 5
#define DBG_REKON 5
#define DBG_OPT 5
#define DBG_L1 5
#define DBG_L2 5
#define DBG_L3 5
#define DBG_L4 5
#define DBG_L5 5
#define DBG_L6 5
#define DBG_L7 5
