/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  91058 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/


/***********************************************************
************************************************************
**
**  Modulname: 
**
**	Beschreibung:
**  
**
***********************************************************
***********************************************************/
static char *SccsId = "@(#)PEPSY:\tinit.c\t1.2\t95/05/19 15:37:00";


#define EXTERN_KNOTENTYPEN

#include "init.h"

/*
#define ANZ_VERFAHREN 8
#define ANZ_FORMELN_LEISTUNG 9

extern func_struct_t verfahren[];
extern leistung_s_t ForLei[];
*/

/***********************************************************
************************************************************
**
**	Autor: Martin Fischer
**
**	Datum: November 1993
**
**	Funktionsname: GetVerfahren
**
**	Funktionstyp: int
**
**	Uebergabeparameter: keine
**
**
**	Beschreibung:
**    Auswertung der Option v zur Bestimmung des vom Benutzer
**    ausgewaehlten Dekompositionsverfahren. Ist die Option v
**    nicht gesetzt, so wird ein Default-Verfahren genommen.
**
**
************************************************************
***********************************************************/

int GetVerfahren()
{
    int i;

    for (i = 0; i < ANZ_VERFAHREN; i++) {

	if (!strcmp(verfahren_name, verfahren[i].name)) {
	    /* richtiges Verfahren mittels Option eingegeben */
	    dbginfo(1, "Name des Verfahren ist %s\n", verfahren[i].name)
		return (i);
	}
    }

    return(0);
}


/***********************************************************
************************************************************
**
**	Autor: Martin Fischer
**
**	Datum: November 1993
**
**	Funktionsname: GetFormelLeistung
**
**	Funktionstyp: int
**
**	Uebergabeparameter: keine
**
**
**	Beschreibung:
**    Auswertung der Option f zur Bestimmung der vom
**    Benutzer ausgewaehlten Formel zur Berechnung der
**    Leistungsgroessen. Ist die Option f nicht gesetzt,
**    so wird ein Default-Funktion genommen.
**
************************************************************
***********************************************************/

int GetFormelLeistung()
{
    int i;

    for (i = 0; i < ANZ_FORMELN_LEISTUNG; i++) {

	if (!strcmp(formel_name, ForLei[i].name)) {
	    /* richtiges Verfahren mittels Option eingegeben */
	    dbginfo(1, "Name der Formel fuer Leistungsgroessenberechnung ist %s\n", ForLei[i].name)
		FLAG_FLG = 1;
	    return (i);
	}
    }

    return(0);
}


/***********************************************************
************************************************************
**
**	Autor: Martin Fischer
**
**	Datum: November 1993
**
**	Funktionsname: InitFLG()
**
**	Funktionstyp: int
**
**	Uebergabeparameter: int verf Nummer des Verfahrens
**
**
**	Beschreibung:
**    Bestimmung der Formel zur Berechnung der LG fuer das
**    aktuelle Verfahren
**
**
************************************************************
***********************************************************/

int InitFLG(verf)
int verf;
{
    int ret;

    if (FLAG_FLG == 0)
    {
	formel_name = (char *)malloc((strlen(verfahren[verf].defaultFormel)+1) * sizeof(char));
	strcpy(formel_name, verfahren[verf].defaultFormel);
	/*    printf("Formelname: %s\n", formel_name); */
	ret = GetFormelLeistung();

	if (FLAG_FLG == 1)
	{
	    return(ret);
	}
	else
	{
	    dbginfo(1, "Default-Formel zur Berechnung der Leistungsgroessen fuer Verfahren %s ist nicht initialisiert\n", verfahren[verf].name);
	    return(ret);
	}
    }
}
