/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  91058 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/


/***********************************************************
************************************************************
**
**  Modulname: lut_ca.h
**
**	Beschreibung:
**  
**
***********************************************************
***********************************************************/
static char *SccsLut_ca_h = "@(#)PEPSY:\tlut_ca.h\t1.2\t95/05/19 15:37:14";

#include  "lut_cb.h"
#include  "lut_k1_m1.h"
#include  "lut_k1_m2.h"
#include  "lut_k1_m4.h"
#include  "lut_k1_m8.h"
#include  "lut_k2_m1.h"
#include  "lut_k2_m2.h"
#include  "lut_k2_m4.h"
#include  "lut_k2_m8.h"


typedef struct {
	double ca2;
	LookUpTab_CB *lut_cb;
} LookUpTab_CA;


LookUpTab_CA LUT_K1_M1_R03[] = {
	{0.25, LUT_K1_M1_R03_CA025},
	{0.5, LUT_K1_M1_R03_CA05},
	{0.75, LUT_K1_M1_R03_CA075},
	{1.0, LUT_K1_M1_R03_CA1},
	{1.25, LUT_K1_M1_R03_CA125},
	{1.5, LUT_K1_M1_R03_CA15},
	{2.0, LUT_K1_M1_R03_CA2},
	{3.0, LUT_K1_M1_R03_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K1_M1_R05[] = {
	{0.25, LUT_K1_M1_R05_CA025},
	{0.5, LUT_K1_M1_R05_CA05},
	{0.75, LUT_K1_M1_R05_CA075},
	{1.0, LUT_K1_M1_R05_CA1},
	{1.25, LUT_K1_M1_R05_CA125},
	{1.5, LUT_K1_M1_R05_CA15},
	{2.0, LUT_K1_M1_R05_CA2},
	{3.0, LUT_K1_M1_R05_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K1_M1_R07[] = {
	{0.25, LUT_K1_M1_R07_CA025},
	{0.5, LUT_K1_M1_R07_CA05},
	{0.75, LUT_K1_M1_R07_CA075},
	{1.0, LUT_K1_M1_R07_CA1},
	{1.25, LUT_K1_M1_R07_CA125},
	{1.5, LUT_K1_M1_R07_CA15},
	{2.0, LUT_K1_M1_R07_CA2},
	{3.0, LUT_K1_M1_R07_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K1_M1_R08[] = {
	{0.25, LUT_K1_M1_R08_CA025},
	{0.5, LUT_K1_M1_R08_CA05},
	{0.75, LUT_K1_M1_R08_CA075},
	{1.0, LUT_K1_M1_R08_CA1},
	{1.25, LUT_K1_M1_R08_CA125},
	{1.5, LUT_K1_M1_R08_CA15},
	{2.0, LUT_K1_M1_R08_CA2},
	{3.0, LUT_K1_M1_R08_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K1_M1_R09[] = {
	{0.25, LUT_K1_M1_R09_CA025},
	{0.5, LUT_K1_M1_R09_CA05},
	{0.75, LUT_K1_M1_R09_CA075},
	{1.0, LUT_K1_M1_R09_CA1},
	{1.25, LUT_K1_M1_R09_CA125},
	{1.5, LUT_K1_M1_R09_CA15},
	{2.0, LUT_K1_M1_R09_CA2},
	{3.0, LUT_K1_M1_R09_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K1_M2_R03[] = {
	{0.25, LUT_K1_M2_R03_CA025},
	{0.5, LUT_K1_M2_R03_CA05},
	{0.75, LUT_K1_M2_R03_CA075},
	{1.0, LUT_K1_M2_R03_CA1},
	{1.25, LUT_K1_M2_R03_CA125},
	{1.5, LUT_K1_M2_R03_CA15},
	{2.0, LUT_K1_M2_R03_CA2},
	{3.0, LUT_K1_M2_R03_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K1_M2_R05[] = {
	{0.25, LUT_K1_M2_R05_CA025},
	{0.5, LUT_K1_M2_R05_CA05},
	{0.75, LUT_K1_M2_R05_CA075},
	{1.0, LUT_K1_M2_R05_CA1},
	{1.25, LUT_K1_M2_R05_CA125},
	{1.5, LUT_K1_M2_R05_CA15},
	{2.0, LUT_K1_M2_R05_CA2},
	{3.0, LUT_K1_M2_R05_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K1_M2_R07[] = {
	{0.25, LUT_K1_M2_R07_CA025},
	{0.5, LUT_K1_M2_R07_CA05},
	{0.75, LUT_K1_M2_R07_CA075},
	{1.0, LUT_K1_M2_R07_CA1},
	{1.25, LUT_K1_M2_R07_CA125},
	{1.5, LUT_K1_M2_R07_CA15},
	{2.0, LUT_K1_M2_R07_CA2},
	{3.0, LUT_K1_M2_R07_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K1_M2_R08[] = {
	{0.25, LUT_K1_M2_R08_CA025},
	{0.5, LUT_K1_M2_R08_CA05},
	{0.75, LUT_K1_M2_R08_CA075},
	{1.0, LUT_K1_M2_R08_CA1},
	{1.25, LUT_K1_M2_R08_CA125},
	{1.5, LUT_K1_M2_R08_CA15},
	{2.0, LUT_K1_M2_R08_CA2},
	{3.0, LUT_K1_M2_R08_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K1_M2_R09[] = {
	{0.25, LUT_K1_M2_R09_CA025},
	{0.5, LUT_K1_M2_R09_CA05},
	{0.75, LUT_K1_M2_R09_CA075},
	{1.0, LUT_K1_M2_R09_CA1},
	{1.25, LUT_K1_M2_R09_CA125},
	{1.5, LUT_K1_M2_R09_CA15},
	{2.0, LUT_K1_M2_R09_CA2},
	{3.0, LUT_K1_M2_R09_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K1_M4_R03[] = {
	{0.25, LUT_K1_M4_R03_CA025},
	{0.5, LUT_K1_M4_R03_CA05},
	{0.75, LUT_K1_M4_R03_CA075},
	{1.0, LUT_K1_M4_R03_CA1},
	{1.25, LUT_K1_M4_R03_CA125},
	{1.5, LUT_K1_M4_R03_CA15},
	{2.0, LUT_K1_M4_R03_CA2},
	{3.0, LUT_K1_M4_R03_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K1_M4_R05[] = {
	{0.25, LUT_K1_M4_R05_CA025},
	{0.5, LUT_K1_M4_R05_CA05},
	{0.75, LUT_K1_M4_R05_CA075},
	{1.0, LUT_K1_M4_R05_CA1},
	{1.25, LUT_K1_M4_R05_CA125},
	{1.5, LUT_K1_M4_R05_CA15},
	{2.0, LUT_K1_M4_R05_CA2},
	{3.0, LUT_K1_M4_R05_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K1_M4_R07[] = {
	{0.25, LUT_K1_M4_R07_CA025},
	{0.5, LUT_K1_M4_R07_CA05},
	{0.75, LUT_K1_M4_R07_CA075},
	{1.0, LUT_K1_M4_R07_CA1},
	{1.25, LUT_K1_M4_R07_CA125},
	{1.5, LUT_K1_M4_R07_CA15},
	{2.0, LUT_K1_M4_R07_CA2},
	{3.0, LUT_K1_M4_R07_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K1_M4_R08[] = {
	{0.25, LUT_K1_M4_R08_CA025},
	{0.5, LUT_K1_M4_R08_CA05},
	{0.75, LUT_K1_M4_R08_CA075},
	{1.0, LUT_K1_M4_R08_CA1},
	{1.25, LUT_K1_M4_R08_CA125},
	{1.5, LUT_K1_M4_R08_CA15},
	{2.0, LUT_K1_M4_R08_CA2},
	{3.0, LUT_K1_M4_R08_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K1_M4_R09[] = {
	{0.25, LUT_K1_M4_R09_CA025},
	{0.5, LUT_K1_M4_R09_CA05},
	{0.75, LUT_K1_M4_R09_CA075},
	{1.0, LUT_K1_M4_R09_CA1},
	{1.25, LUT_K1_M4_R09_CA125},
	{1.5, LUT_K1_M4_R09_CA15},
	{2.0, LUT_K1_M4_R09_CA2},
	{3.0, LUT_K1_M4_R09_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K1_M8_R03[] = {
	{0.25, LUT_K1_M8_R03_CA025},
	{0.5, LUT_K1_M8_R03_CA05},
	{0.75, LUT_K1_M8_R03_CA075},
	{1.0, LUT_K1_M8_R03_CA1},
	{1.25, LUT_K1_M8_R03_CA125},
	{1.5, LUT_K1_M8_R03_CA15},
	{2.0, LUT_K1_M8_R03_CA2},
	{3.0, LUT_K1_M8_R03_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K1_M8_R05[] = {
	{0.25, LUT_K1_M8_R05_CA025},
	{0.5, LUT_K1_M8_R05_CA05},
	{0.75, LUT_K1_M8_R05_CA075},
	{1.0, LUT_K1_M8_R05_CA1},
	{1.25, LUT_K1_M8_R05_CA125},
	{1.5, LUT_K1_M8_R05_CA15},
	{2.0, LUT_K1_M8_R05_CA2},
	{3.0, LUT_K1_M8_R05_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K1_M8_R07[] = {
	{0.25, LUT_K1_M8_R07_CA025},
	{0.5, LUT_K1_M8_R07_CA05},
	{0.75, LUT_K1_M8_R07_CA075},
	{1.0, LUT_K1_M8_R07_CA1},
	{1.25, LUT_K1_M8_R07_CA125},
	{1.5, LUT_K1_M8_R07_CA15},
	{2.0, LUT_K1_M8_R07_CA2},
	{3.0, LUT_K1_M8_R07_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K1_M8_R08[] = {
	{0.25, LUT_K1_M8_R08_CA025},
	{0.5, LUT_K1_M8_R08_CA05},
	{0.75, LUT_K1_M8_R08_CA075},
	{1.0, LUT_K1_M8_R08_CA1},
	{1.25, LUT_K1_M8_R08_CA125},
	{1.5, LUT_K1_M8_R08_CA15},
	{2.0, LUT_K1_M8_R08_CA2},
	{3.0, LUT_K1_M8_R08_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K1_M8_R09[] = {
	{0.25, LUT_K1_M8_R09_CA025},
	{0.5, LUT_K1_M8_R09_CA05},
	{0.75, LUT_K1_M8_R09_CA075},
	{1.0, LUT_K1_M8_R09_CA1},
	{1.25, LUT_K1_M8_R09_CA125},
	{1.5, LUT_K1_M8_R09_CA15},
	{2.0, LUT_K1_M8_R09_CA2},
	{3.0, LUT_K1_M8_R09_CA3},
	{-1.0, NULL}
};


LookUpTab_CA LUT_K2_M1_R03[] = {
	{0.25, LUT_K2_M1_R03_CA025},
	{0.5, LUT_K2_M1_R03_CA05},
	{0.75, LUT_K2_M1_R03_CA075},
	{1.0, LUT_K2_M1_R03_CA1},
	{1.25, LUT_K2_M1_R03_CA125},
	{1.5, LUT_K2_M1_R03_CA15},
	{2.0, LUT_K2_M1_R03_CA2},
	{3.0, LUT_K2_M1_R03_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M1_R05[] = {
	{0.25, LUT_K2_M1_R05_CA025},
	{0.5, LUT_K2_M1_R05_CA05},
	{0.75, LUT_K2_M1_R05_CA075},
	{1.0, LUT_K2_M1_R05_CA1},
	{1.25, LUT_K2_M1_R05_CA125},
	{1.5, LUT_K2_M1_R05_CA15},
	{2.0, LUT_K2_M1_R05_CA2},
	{3.0, LUT_K2_M1_R05_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M1_R07[] = {
	{0.25, LUT_K2_M1_R07_CA025},
	{0.5, LUT_K2_M1_R07_CA05},
	{0.75, LUT_K2_M1_R07_CA075},
	{1.0, LUT_K2_M1_R07_CA1},
	{1.25, LUT_K2_M1_R07_CA125},
	{1.5, LUT_K2_M1_R07_CA15},
	{2.0, LUT_K2_M1_R07_CA2},
	{3.0, LUT_K2_M1_R07_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M1_R08[] = {
	{0.25, LUT_K2_M1_R08_CA025},
	{0.5, LUT_K2_M1_R08_CA05},
	{0.75, LUT_K2_M1_R08_CA075},
	{1.0, LUT_K2_M1_R08_CA1},
	{1.25, LUT_K2_M1_R08_CA125},
	{1.5, LUT_K2_M1_R08_CA15},
	{2.0, LUT_K2_M1_R08_CA2},
	{3.0, LUT_K2_M1_R08_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M1_R09[] = {
	{0.25, LUT_K2_M1_R09_CA025},
	{0.5, LUT_K2_M1_R09_CA05},
	{0.75, LUT_K2_M1_R09_CA075},
	{1.0, LUT_K2_M1_R09_CA1},
	{1.25, LUT_K2_M1_R09_CA125},
	{1.5, LUT_K2_M1_R09_CA15},
	{2.0, LUT_K2_M1_R09_CA2},
	{3.0, LUT_K2_M1_R09_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M1_R095[] = {
	{0.25, LUT_K2_M1_R095_CA025},
	{0.5, LUT_K2_M1_R095_CA05},
	{0.75, LUT_K2_M1_R095_CA075},
	{1.0, LUT_K2_M1_R095_CA1},
	{1.25, LUT_K2_M1_R095_CA125},
	{1.5, LUT_K2_M1_R095_CA15},
	{2.0, LUT_K2_M1_R095_CA2},
	{3.0, LUT_K2_M1_R095_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M2_R03[] = {
	{0.25, LUT_K2_M2_R03_CA025},
	{0.5, LUT_K2_M2_R03_CA05},
	{0.75, LUT_K2_M2_R03_CA075},
	{1.0, LUT_K2_M2_R03_CA1},
	{1.25, LUT_K2_M2_R03_CA125},
	{1.5, LUT_K2_M2_R03_CA15},
	{2.0, LUT_K2_M2_R03_CA2},
	{3.0, LUT_K2_M2_R03_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M2_R05[] = {
	{0.25, LUT_K2_M2_R05_CA025},
	{0.5, LUT_K2_M2_R05_CA05},
	{0.75, LUT_K2_M2_R05_CA075},
	{1.0, LUT_K2_M2_R05_CA1},
	{1.25, LUT_K2_M2_R05_CA125},
	{1.5, LUT_K2_M2_R05_CA15},
	{2.0, LUT_K2_M2_R05_CA2},
	{3.0, LUT_K2_M2_R05_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M2_R07[] = {
	{0.25, LUT_K2_M2_R07_CA025},
	{0.5, LUT_K2_M2_R07_CA05},
	{0.75, LUT_K2_M2_R07_CA075},
	{1.0, LUT_K2_M2_R07_CA1},
	{1.25, LUT_K2_M2_R07_CA125},
	{1.5, LUT_K2_M2_R07_CA15},
	{2.0, LUT_K2_M2_R07_CA2},
	{3.0, LUT_K2_M2_R07_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M2_R08[] = {
	{0.25, LUT_K2_M2_R08_CA025},
	{0.5, LUT_K2_M2_R08_CA05},
	{0.75, LUT_K2_M2_R08_CA075},
	{1.0, LUT_K2_M2_R08_CA1},
	{1.25, LUT_K2_M2_R08_CA125},
	{1.5, LUT_K2_M2_R08_CA15},
	{2.0, LUT_K2_M2_R08_CA2},
	{3.0, LUT_K2_M2_R08_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M2_R09[] = {
	{0.25, LUT_K2_M2_R09_CA025},
	{0.5, LUT_K2_M2_R09_CA05},
	{0.75, LUT_K2_M2_R09_CA075},
	{1.0, LUT_K2_M2_R09_CA1},
	{1.25, LUT_K2_M2_R09_CA125},
	{1.5, LUT_K2_M2_R09_CA15},
	{2.0, LUT_K2_M2_R09_CA2},
	{3.0, LUT_K2_M2_R09_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M2_R095[] = {
	{0.25, LUT_K2_M2_R095_CA025},
	{0.5, LUT_K2_M2_R095_CA05},
	{0.75, LUT_K2_M2_R095_CA075},
	{1.0, LUT_K2_M2_R095_CA1},
	{1.25, LUT_K2_M2_R095_CA125},
	{1.5, LUT_K2_M2_R095_CA15},
	{2.0, LUT_K2_M2_R095_CA2},
	{3.0, LUT_K2_M2_R095_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M4_R03[] = {
	{0.25, LUT_K2_M4_R03_CA025},
	{0.5, LUT_K2_M4_R03_CA05},
	{0.75, LUT_K2_M4_R03_CA075},
	{1.0, LUT_K2_M4_R03_CA1},
	{1.25, LUT_K2_M4_R03_CA125},
	{1.5, LUT_K2_M4_R03_CA15},
	{2.0, LUT_K2_M4_R03_CA2},
	{3.0, LUT_K2_M4_R03_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M4_R05[] = {
	{0.25, LUT_K2_M4_R05_CA025},
	{0.5, LUT_K2_M4_R05_CA05},
	{0.75, LUT_K2_M4_R05_CA075},
	{1.0, LUT_K2_M4_R05_CA1},
	{1.25, LUT_K2_M4_R05_CA125},
	{1.5, LUT_K2_M4_R05_CA15},
	{2.0, LUT_K2_M4_R05_CA2},
	{3.0, LUT_K2_M4_R05_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M4_R07[] = {
	{0.25, LUT_K2_M4_R07_CA025},
	{0.5, LUT_K2_M4_R07_CA05},
	{0.75, LUT_K2_M4_R07_CA075},
	{1.0, LUT_K2_M4_R07_CA1},
	{1.25, LUT_K2_M4_R07_CA125},
	{1.5, LUT_K2_M4_R07_CA15},
	{2.0, LUT_K2_M4_R07_CA2},
	{3.0, LUT_K2_M4_R07_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M4_R08[] = {
	{0.25, LUT_K2_M4_R08_CA025},
	{0.5, LUT_K2_M4_R08_CA05},
	{0.75, LUT_K2_M4_R08_CA075},
	{1.0, LUT_K2_M4_R08_CA1},
	{1.25, LUT_K2_M4_R08_CA125},
	{1.5, LUT_K2_M4_R08_CA15},
	{2.0, LUT_K2_M4_R08_CA2},
	{3.0, LUT_K2_M4_R08_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M4_R09[] = {
	{0.25, LUT_K2_M4_R09_CA025},
	{0.5, LUT_K2_M4_R09_CA05},
	{0.75, LUT_K2_M4_R09_CA075},
	{1.0, LUT_K2_M4_R09_CA1},
	{1.25, LUT_K2_M4_R09_CA125},
	{1.5, LUT_K2_M4_R09_CA15},
	{2.0, LUT_K2_M4_R09_CA2},
	{3.0, LUT_K2_M4_R09_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M4_R095[] = {
	{0.25, LUT_K2_M4_R095_CA025},
	{0.5, LUT_K2_M4_R095_CA05},
	{0.75, LUT_K2_M4_R095_CA075},
	{1.0, LUT_K2_M4_R095_CA1},
	{1.25, LUT_K2_M4_R095_CA125},
	{1.5, LUT_K2_M4_R095_CA15},
	{2.0, LUT_K2_M4_R095_CA2},
	{3.0, LUT_K2_M4_R095_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M8_R03[] = {
	{0.25, LUT_K2_M8_R03_CA025},
	{0.5, LUT_K2_M8_R03_CA05},
	{0.75, LUT_K2_M8_R03_CA075},
	{1.0, LUT_K2_M8_R03_CA1},
	{1.25, LUT_K2_M8_R03_CA125},
	{1.5, LUT_K2_M8_R03_CA15},
	{2.0, LUT_K2_M8_R03_CA2},
	{3.0, LUT_K2_M8_R03_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M8_R05[] = {
	{0.25, LUT_K2_M8_R05_CA025},
	{0.5, LUT_K2_M8_R05_CA05},
	{0.75, LUT_K2_M8_R05_CA075},
	{1.0, LUT_K2_M8_R05_CA1},
	{1.25, LUT_K2_M8_R05_CA125},
	{1.5, LUT_K2_M8_R05_CA15},
	{2.0, LUT_K2_M8_R05_CA2},
	{3.0, LUT_K2_M8_R05_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M8_R07[] = {
	{0.25, LUT_K2_M8_R07_CA025},
	{0.5, LUT_K2_M8_R07_CA05},
	{0.75, LUT_K2_M8_R07_CA075},
	{1.0, LUT_K2_M8_R07_CA1},
	{1.25, LUT_K2_M8_R07_CA125},
	{1.5, LUT_K2_M8_R07_CA15},
	{2.0, LUT_K2_M8_R07_CA2},
	{3.0, LUT_K2_M8_R07_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M8_R08[] = {
	{0.25, LUT_K2_M8_R08_CA025},
	{0.5, LUT_K2_M8_R08_CA05},
	{0.75, LUT_K2_M8_R08_CA075},
	{1.0, LUT_K2_M8_R08_CA1},
	{1.25, LUT_K2_M8_R08_CA125},
	{1.5, LUT_K2_M8_R08_CA15},
	{2.0, LUT_K2_M8_R08_CA2},
	{3.0, LUT_K2_M8_R08_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M8_R09[] = {
	{0.25, LUT_K2_M8_R09_CA025},
	{0.5, LUT_K2_M8_R09_CA05},
	{0.75, LUT_K2_M8_R09_CA075},
	{1.0, LUT_K2_M8_R09_CA1},
	{1.25, LUT_K2_M8_R09_CA125},
	{1.5, LUT_K2_M8_R09_CA15},
	{2.0, LUT_K2_M8_R09_CA2},
	{3.0, LUT_K2_M8_R09_CA3},
	{-1.0, NULL}
};

LookUpTab_CA LUT_K2_M8_R095[] = {
	{0.25, LUT_K2_M8_R095_CA025},
	{0.5, LUT_K2_M8_R095_CA05},
	{0.75, LUT_K2_M8_R095_CA075},
	{1.0, LUT_K2_M8_R095_CA1},
	{1.25, LUT_K2_M8_R095_CA125},
	{1.5, LUT_K2_M8_R095_CA15},
	{2.0, LUT_K2_M8_R095_CA2},
	{3.0, LUT_K2_M8_R095_CA3},
	{-1.0, NULL}
};

