/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  91058 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/


/***********************************************************
************************************************************
**
**  Modulname: lut_rho.h
**
**	Beschreibung:
**  
**
***********************************************************
***********************************************************/

#include "lut_ca.h"

static char *SccsLut_rho_h = "@(#)PEPSY:\tlut_rho.h\t1.2\t95/05/19 15:37:46";

typedef struct {
	double rho;
	LookUpTab_CA *lut_ca;
} LookUpTab_R;


LookUpTab_R LUT_K1_M1[] = {
	{0.3, LUT_K1_M1_R03},
	{0.5, LUT_K1_M1_R05},
	{0.7, LUT_K1_M1_R07},
	{0.8, LUT_K1_M1_R08},
	{0.9, LUT_K1_M1_R09},
	{-1.0, NULL}
};

LookUpTab_R LUT_K1_M2[] = {
	{0.3, LUT_K1_M2_R03},
	{0.5, LUT_K1_M2_R05},
	{0.7, LUT_K1_M2_R07},
	{0.8, LUT_K1_M2_R08},
	{0.9, LUT_K1_M2_R09},
	{-1.0, NULL}
};


LookUpTab_R LUT_K1_M4[] = {
	{0.3, LUT_K1_M4_R03},
	{0.5, LUT_K1_M4_R05},
	{0.7, LUT_K1_M4_R07},
	{0.8, LUT_K1_M4_R08},
	{0.9, LUT_K1_M4_R09},
	{-1.0, NULL}
};


LookUpTab_R LUT_K1_M8[] = {
	{0.3, LUT_K1_M8_R03},
	{0.5, LUT_K1_M8_R05},
	{0.7, LUT_K1_M8_R07},
	{0.8, LUT_K1_M8_R08},
	{0.9, LUT_K1_M8_R09},
	{-1.0, NULL}
};

LookUpTab_R LUT_K2_M1[] = {
	{0.3, LUT_K2_M1_R03},
	{0.5, LUT_K2_M1_R05},
	{0.7, LUT_K2_M1_R07},
	{0.8, LUT_K2_M1_R08},
	{0.9, LUT_K2_M1_R09},
	{0.95, LUT_K2_M1_R095},
	{-1.0, NULL}
};

LookUpTab_R LUT_K2_M2[] = {
	{0.3, LUT_K2_M2_R03},
	{0.5, LUT_K2_M2_R05},
	{0.7, LUT_K2_M2_R07},
	{0.8, LUT_K2_M2_R08},
	{0.9, LUT_K2_M2_R09},
	{0.95, LUT_K2_M2_R095},
	{-1.0, NULL}
};


LookUpTab_R LUT_K2_M4[] = {
	{0.3, LUT_K2_M4_R03},
	{0.5, LUT_K2_M4_R05},
	{0.7, LUT_K2_M4_R07},
	{0.8, LUT_K2_M4_R08},
	{0.9, LUT_K2_M4_R09},
	{0.95, LUT_K2_M4_R095},
	{-1.0, NULL}
};


LookUpTab_R LUT_K2_M8[] = {
	{0.3, LUT_K2_M8_R03},
	{0.5, LUT_K2_M8_R05},
	{0.7, LUT_K2_M8_R07},
	{0.8, LUT_K2_M8_R08},
	{0.9, LUT_K2_M8_R09},
	{0.95, LUT_K2_M8_R095},
	{-1.0, NULL}
};
