/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  91058 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/


/***********************************************************
************************************************************
**
**  Modulname: main.c  
**
***********************************************************
***********************************************************/

static char *SccsId = "@(#)PEPSY:\tmain.c\t1.2\t95/05/19 15:37:49";

#define MAIN_C

#include "init.h"


/***********************************************************
************************************************************
**
**	Autor: Martin Fischer
**
**	Datum: November 1993
**
**	Funktionsname: main
**
**	Funktionstyp: void
**
**	Uebergabeparameter: int  argc
**                      char **argv
**
**
**	Beschriebung:
**  Hauptprogramm das Dekompositionsverfahren 'dekomp'
**
**  aufgerufene Funktionen:
**    InitVerfahren()  ->  Modul allgemein.c
**    verfahren[nr].FktX  ->  Modul init.h
**
************************************************************
***********************************************************/

int main(argc, argv)
int argc;
char **argv;
{
    int *p;

    InitVerfahren(argc, argv);

    if (strncmp(verfahren[verfahren_nr].name, "all", 3) == 0)
    {
      strncpy(&(VERFAHREN[0]), "dekomp\0", 7);
    }
    else if (strncmp(verfahren[verfahren_nr].name, "best", 4) == 0)
    {
      strncpy(&(VERFAHREN[0]), "dekomp\0", 7);
    }
    else
    {
      strncpy(&(VERFAHREN[0]), verfahren[verfahren_nr].name, 15);
    }


    p = (*(verfahren[verfahren_nr].CheckVerfahren))();

    InitPostFilter(stdout, AnzVer);

    SaveInputData();

    while (*p != -1) {

	GetOrigInputData();

	(*(verfahren[*p].InitNetz))();

	(*(verfahren[*p].InitIteration))();

	do {

	    /* Approximative Berechnung der quadrierten Variationskoeff.
	     ** fuer die Ankunftsprozesse */

	    (*(verfahren[*p].Iterationsschritt))(iterationen);

	}
	while ((abbruch = (*(verfahren[*p].CheckItAbbruch))(iterationen++))); /* Ueberpruefung der Abbruchbedingungen */
	
  /* Falls Option -f nicht gesetzt ist, Ermittlung der Formel
     zur Berechnung der Leistungsgroessen ueber Default-Werte */

  InitFLG(*p);

	/* Berechnung der uebrigen Leistungsgroessen und Ausgabe
	 ** der gewuenschten Daten an den Postfilter */

	(*(verfahren[*p].Leistung))(*p);

	p++;
    }

    return (0);
}

