/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  91058 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/


/***********************************************************
************************************************************
**
**  Modulname: typedef.h
**
**	Beschreibung:
**  Definition der Datenstrukturen (Typdefinitionen  und
**  Strukturen)
**
***********************************************************
***********************************************************/
static char *SccsTypeDef_h = "@(#)PEPSY:\ttypedef.h\t1.2\t95/05/19 15:37:57";

/* Definition der Funktionen-Pointer */

typedef int	(*PFI)();	/* Funktions-Pointer einer int Funktion */
typedef int	*(*PFI_P)();	/* Funktions-Pointer einer int Funktion */	
typedef void 	(*PFV)();	/* Funktions-Pointer einer void Funktion */	
typedef double	(*PFD)();	/* Funktions-Pointer einer double Funktion */	

/* Struktur mit den Funktions-Pointern */
typedef struct {
	char	name[32];
	char	defaultFormel[32];
	int	KnTypen;
	int	Klassen;
	PFI_P	CheckVerfahren;
	PFV	InitNetz;
	PFV	InitIteration;
	PFV	Iterationsschritt;
	PFI	CheckItAbbruch;
	PFV	Leistung;
} func_struct_t;


/* Struktur mit Funktions-Pointer zur Berechnung der Leistungsgroessen */
typedef struct {
		char	name[32];		/* Name der Formel */
		PFV		BerLeist;		/* Funktions-Pointer */
} leistung_s_t;


/* Struktur mit den von der jeweiligen Klasse abhaengigen Knoten-Daten */
typedef struct {
	double mue;					/* Bedienrate */
	double lambda;			/* Ankunftsrate */
	double mue_orig;		/* Bedienrate */
	double lambda_orig;	/* Ankunftsrate */
	double e;						/* Besuchshaeufigkeit */
	double rho;					/* Auslastung */
	double mvz;					/* mittlere Verweilzeit */
	double maa;					/* mittlere Anzahl von Auftraegen */
	double mwz;					/* mittlere Wartezeit */
	double mwsl;				/* mittlere Warteschlangenlaenge */
	double c2A;					/* quad. Var.koeff. des Ankunftsprozess */
	double c2A_orig;		/* quad. Var.koeff. des Ankunftsprozess */
	double c2B;					/* quad. Var.koeff. des Bedienprozesses */
	double c2B_orig;		/* quad. Var.koeff. des Bedienprozesses */
	double c2D;					/* quad. Var.koeff. des Abgangsprozesses */
  char *flg_name;     /* Pointer auf den Namen der Formel zur Ber. der LG */
} KNOTEN_KLASSE; 


/* Struktur mit den klassenabhaengigen Daten */
typedef struct {
	double **uew;				/* Uebergangsmatrix */
	double **uew_orig;	/* Uebergangsmatrix */
	double **rate;			/* Uebergangsrate */
	double **c2;				/* quad. Var.koeff. */
	double **c;					/* Var.koeff. */
	double **c_alt;			/* alter quad. Var.koeff. */
	double lambda;			/* Ankunftsrate pro Klasse */
	double mvz;					/* mittlere Verweilzeit pro Klasse */
  double maa;					/* mittlere Anzahl von Auftraegen pro Klasse */
  KNOTEN_KLASSE *knoten;
} KLASSE; 


/* Struktur mit den klassenunabhaengegen Knoten-Daten */
typedef struct {
	int	KnotenTyp;			/* Typ des Knoten */
	int	AnzServer;			/* Anzahl der Bedieneinheiten */
	double lambda;			/* Ankunfsrate pro Knoten */
	double rho;					/* Auslastung pro Knoten */
	double maa;					/* mittlere Anzahl von Auftraegen */
	double mue;					/* Bedienrate pro Knoten */
	double c2B;					/* quad. Var.koeff. des Bedienprozesses */
	double c2A;					/* quad. Var.koeff. des Ankunftsprozess */
	double c2D;					/* quad. Var.koeff. des Abgangsprozesses */
} KNOTEN_NETZ;

