/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tdiffapp.c\t1.3\t92/12/09 15:43:30";

#include <stdio.h>
#include <malloc.h>
# define LOCAL
# include "init.h"

#ifdef DEBUG
#define PRINT(fmt,string)	fprintf(stderr,fmt,string)
#else
#define PRINT(fmt,string)
#endif

void getline(fp,line)  /* einlesen einer Kommentarzeile */ 
FILE *fp;
char *line;
{
	int c;
	int i;

	while((*line++ = getc(fp)) != '\n')
		;
	*--line = '\0';
}

void abbruch(sig)
int sig;
{
        printf("diffprox_signal_%d\n 0 0 0 \n", sig);
        exit(1);
}

main(argc,argv)

int argc;
char **argv;

{
	/*		Sccs support from SccsLogging.c			*/	
	extern int SccsRelease;
	extern int SccsLevel;

	int i,j;
	float norm,hilf;
	char zeile[80],junk;
	float **uw, **A;
	float *b, *x, *rd;
	float *vark;

    for (i=1; i<12; i++)
        signal(i, abbruch);

	if ((argc > 1) && (!strcmp(argv[1], "-V")))    /* kirschni 22.11.1991 */
	{
		fprintf(stdout, "%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
		exit(0);
	}


	fpin = stdin;

	fpout = stdout;

	fscanf(fpin,"%d%c",&kn,&junk);
	PRINT("%d\n",kn);
	fscanf(fpin,"%f%c",&lambda,&junk);
	PRINT("%f\n",lambda);

/* Anfordern des Speicherbereiches */

	leistung = (struct perform *)calloc(kn,sizeof(struct perform));
	node = (struct knbeschr *)calloc(kn,sizeof(struct perform));
	uw = (float **) calloc(kn+1,sizeof(float*));
	for (i=0; i<=kn; i++)
		uw[i] = (float *) calloc(kn + 1,sizeof(float));
	A = (float **) calloc(kn,sizeof(float*));
	for (i=0; i<kn; i++)
		A[i] = (float *) calloc(kn, sizeof(float));
	b = (float *) calloc(kn,sizeof(float));
	x = (float *) calloc(kn,sizeof(float));
	rd = (float *) calloc(kn,sizeof(float));
	vark = (float *) calloc(kn,sizeof(float));


/* Einlesen der Uebergangswahrscheinlichkeiten */

	for(i=0; i<=kn; i++)
	{
		for(j=0; j<=kn; j++)
		{
			fscanf(fpin,"%f ",&uw[i][j]);
			PRINT("%f\t",uw[i][j]);
		}
		PRINT("\n","");
	}

/* Einlesen der restlichen Eingabegroessen */

	for(i=0; i<kn; i++)
	{
		fscanf(fpin,"%f %f %f",&node[i].sevrate,&node[i].cb,&vark[i]);
		PRINT("%f\t",node[i].sevrate);
		PRINT("%f\n",node[i].cb);
	}
		

/* Erstellen der Eingabematrix fuer den Gaussalgorithmus */

	for (i=0; i<kn; i++)
		for(j=0; j<kn; j++)
			A[i][j] = -uw[j+1][i+1];

	for (i=0; i<kn; i++)
	{
		A[i][i] += 1;
		b[i] = uw[0][i+1];
	}

	PRINT("zu invertierende Matrix\n","");
	for (i=0; i<kn; i++)
	{
		for(j=0; j<kn; j++)
			PRINT("%f\t",A[i][j] );
		PRINT("\n","");
	}

	PRINT("Poi\n","");
	for (i=0; i<kn; i++)
		PRINT("%f\t",b[i]);
		PRINT("\n","");

	if( gauss(A,x,b,kn,0.0000001) == -1 )
	{
		fprintf(stderr,"gauss aborted\n");
		printf("diffprox_gauss\n 0 0 0\n");
		exit(1);
	}

/* Berechnen der Knotendurchsaetze */

	PRINT("Durchsaetze\n","");
	for (i=0; i<kn; i++)
	{
		node[i].visits = x[i];
		leistung[i].durchsatz = lambda * x[i];
		PRINT("%f\t",leistung[i].durchsatz);
	}
		PRINT("\n","");

/* Berechnen der Knotenauslastungen */

	PRINT("Auslastungen\n","");
	for (i=0; i<kn; i++)
	{
		leistung[i].auslast = leistung[i].durchsatz / node[i].sevrate;
		PRINT("%f\t",leistung[i].auslast);
		if( leistung[i].auslast > 1 )
		{
			fprintf(stderr,"Stabilitaetsbedingung verletzt\n");
			printf("diffprox_instabil\n 0 0 0\n");
			exit(1);
		}
	}
		PRINT("\n","");

/* Berechnen der Variationskoeffizienten des Ankunftsprozesses */

	/*
	fprintf(fpout,"Variationskoeffizienten des Ankunftsprozesses\n");
	*/
	for (i=0; i<kn; i++)
	{
		hilf =0;
		for (j=0; j<kn; j++)
		{
			hilf += (node[j].cb -1)* uw[j+1][i+1]*uw[j+1][i+1] *
					node[j].visits / node[i].visits;
		}
		leistung[i].ca = 1 + hilf + (vark[i]-1) * uw[0][i+1]  * uw[0][i+1] 
						/ node[i].visits;
		/*
		fprintf(fpout,"%f\t",leistung[i].ca);
		*/
	}
		/*
		fprintf(fpout,"\n");
		*/

/* Berechnung der einzelnen "rho_dach" */

	/*
	fprintf(fpout,"Hilfsgroessen rho_dach\n","");
	*/
	for (i=0; i<kn; i++)
	{
		rd[i] = exp( -2*(node[i].sevrate - leistung[i].durchsatz) /
					(leistung[i].ca * leistung[i].durchsatz +
					node[i].cb * node[i].sevrate) );
		/*
		fprintf(fpout,"%f\t",rd[i]);
		*/
		if( rd[i] > 1 )
		{
			fprintf(stderr,"Stabilitaetsbedingung verletzt\n");
			fprintf(stderr,"approx. Auslastungen groesser 1\n");
			printf("diffprox_instabil\n 0 0 0\n");
			exit(1);
		}
	}
		/*
		fprintf(fpout,"\n");
		*/



/* Berechnen der mittleren Fuellung */

	for (i=0; i<kn; i++)
	{
				leistung[i].users = leistung[i].auslast / (1 - rd[i]);	
	}


/* Ausgeben der Leistungsgroessen */

	fprintf(fpout,"diffprox\n\n");
	fprintf(fpout,"2 %d 1\n\n",kn);
	for (i=0; i<kn; i++)
	{
		fprintf(fpout,"%8.6f %8.6f %8.6f %8.6f ",
			leistung[i].durchsatz,x[i], 1.0 / node[i].sevrate,leistung[i].auslast);
		hilf = leistung[i].users /leistung[i].durchsatz;
		fprintf(fpout,"%8.6f %8.6f ",
			hilf, leistung[i].users);
		hilf = hilf - 1.0 / node[i].sevrate,
		fprintf(fpout,"%8.6f %8.6f\n",hilf, hilf * leistung[i].durchsatz);
	}
	fprintf(fpout,"quad. Variationskoeffizienten Ankunftsprozess\n");
	for (i=0; i<kn; i++)
	{
		fprintf(fpout,"Knoten %d  %f\n",i+1,leistung[i].ca);
	}
	fprintf(fpout,"approximierte Auslastungen \n");
	for (i=0; i<kn; i++)
	{
		fprintf(fpout,"Knoten %d  %f\n",i+1,rd[i]);
	}
	close(fpin);
	close(fpout);
		
	exit(0);
}	
