static char *SccsId = "@(#)PEPSY:\tcore_alg.c\t1.2\t92/03/27 11:46:18";

#include <stdio.h>
#include "def_EPA" 

/***********************************************************


  FUNKTION
  Initialisierung_null()

  Wird aufgerufen in
  - Funktion SCAT   "         "   "    "core_alg.c"        

Berechnet fuer Schritt 2 des SCAT aus den Werten aus Schritt 1
im Fall, dass in der aktuellen Population die Klasse R leer
ist, die Gesamtzahl der Auftraege im System und besetzt
die k- und D-Werte vor.

***********************************************************/

Initialisierung_null()
{
   extern index3 ( );
   int i, j,r;

   for ( i = 0; i < N; i++ )
       if ( teilnetz[i] == tn )
       {
	  for ( r = 0; r < R; r++ )
	  {
              if ( r == kl-1 )
	      {
		 if ( Auftr[r][0] == 1 )
		    k[index3 (i, r, kl )] = 0.0;
		 else
		    k[index3 (i, r, kl )] = k_hilf[index3 (i, r, Auftr[R-1][0])] * 
		    (1.0 - 1.0/Auftr[r][0] );
              }
	      else
		 k[index3 (i, r, kl)] = k_hilf[index3 (i, r, Auftr[R-1][0])];
          }
       }	    

  Auftraege[kl]=0;           /* Gesamtzahl der Auftraege bestimmen */
  for (r=0; r<R; r++)
      Auftraege[kl]=Auftraege[kl]+Auftr[r][kl];
   
   for ( i = 0; i < N; i++ )
     if ( teilnetz[i] == tn ) 
       for ( r = 0; r < R; r++ )
	   for ( j = 0; j < R; j++ )
	       D[index3 (i, r, j)] = 0.0;
}
/***********************************************************


  FUNKTION
  Initialisierung()

  Wird aufgerufen in
  - Funktion SCAT   "         "   "    "core_alg.c"        

Berechnet aus den zwischengespeicherten Werten frueherer Core-
Aufrufe fuer Schritt 2 des SCAT die Gesamtahl der Auftraege im
System und besetzt die k-Werte und D-Werte vor.

***********************************************************/

Initialisierung()
{
   extern index3 ();
   int i, j,r;

   for ( i = 0; i < N; i++ )
       if ( teilnetz[i] == tn )
       {
	  if ( Auftr[R-1][0] == 0 )
          {
             Initialisierung_null();
	     return;
          }
          else
	  {
	     for ( r = 0; r < R - 1; r++ )
	     {
                 if ( r == kl-1 )
	         {
		    if ( Auftr[r][0] == 1 )
		       k[index3(i, r, kl)] = 0.0;
		    else
		       k[index3(i, r, kl)] = k_hilf[index3(i, r, Auftr[R-1][0]-1)] * 
		       (1.0 - 1.0/Auftr[r][0] );
                 }
	         else
	            k[index3(i, r, kl)] = k_hilf[index3 (i, r, Auftr[R-1][0]-1)];
             } 
	     if ( Auftr[R-1][0] == 1 )
	        k[index3(i, R-1, kl)] = 1.0/anz_knot_tn[tn-1];
             else
	        k[index3 (i, R-1, kl)] = k_hilf[index3 (i, R-1, Auftr[R-1][0]-1)] * 
		(1.0 + 1.0/Auftr[R-1][0] );
          }	    
       }
  Auftraege[kl]=0;           /* Gesamtzahl der Auftraege bestimmen */
  for (r=0; r<R; r++)
      Auftraege[kl]=Auftraege[kl]+Auftr[r][kl];
   
   for ( i = 0; i < N; i++ )
     if ( teilnetz[i] == tn ) 
       for ( r = 0; r < R; r++ )
	   for ( j = 0; j < R; j++ )
	       D[index3 (i, r, j)] = 0.0;
}
/***********************************************************

  FUNKTION
  Init_Population_k()

  Wird aufgerufen in
  - HAUPTPROGRAMM
    EPA-Alg.     gespeichert auf File  "epa.c"
  - Funktion SCAT   "         "   "    "scat.c"        

Berechnet die Gesamtzahl der Auftraege im System und besetzt
die k- und D-Werte vor.

***********************************************************/
Init_Population_k()
{
 
 extern index3();
 int	i,r,j;	/* Hilfsvariablen */

 for (i=0; i<N; i++)
     if ( teilnetz[i]==tn )
     {
	if ( R>1 )                       /* Mehr-Klassen-Fall */
	{
           if ( Auftr[R-1][0]==0 && Auftr[R-2][0]==0 )       /* uebliche Initalisierung */
	   {
              k[index3(i,R-1,0)]=0.0;
              k[index3(i,R-2,0)]=0.0;
	      for (r=0; r<R-2; r++)
	          k[index3(i,r,0)]=(1.0*Auftr[r][0])/anz_knot_tn[tn-1];
	   }
           if ( Auftr[R-1][0]==0 && Auftr[R-2][0]!=0 )
           {
       	      k[index3(i,R-1,0)]=0.0;
	      if ( Auftr[R-2][0]==1 )
	         k[index3(i,R-2,0)]=1/(double)anz_knot_tn[tn-1];
              else
	         k[index3(i,R-2,0)]=k_hilf[index3(i,R-2,0)]*Auftr[R-2][0]/(Auftr[R-2][0]-1);
	      for (r=0; r<R-2; r++)
	          k[index3(i,r,0)]=k_hilf[index3(i,r,0)];
           }
           if ( Auftr[R-1][0]!=0 )
           {
 	      if ( Auftr[R-1][0]==1 )
                 k[index3(i,R-1,0)]=1/(double)anz_knot_tn[tn-1]; 
              else
	         k[index3(i,R-1,0)]=k_hilf[index3(i,R-1,Auftr[R-1][0]-1)]*
	                            Auftr[R-1][0]/(Auftr[R-1][0]-1);
	      for (r=0; r<R-1; r++)
                  k[index3(i,r,0)]=k_hilf[index3(i,r,Auftr[r][0]-1)];
           }
        }
	else                            /* Ein-Klassen-Fall */
	   if ( Auftr[0][0]==1 )
	      k[index3(i,0,0)]=1/(double)anz_knot_tn[tn-1];
           else
	      k[index3(i,0,0)]=k_hilf[index3(i,0,0)]*Auftr[0][0]/(Auftr[0][0]-1);
       
        Auftraege[0]=0;                 /* Gesamtzahl der Auftraege bestimmen */
        for (r=0; r<R; r++)
    	    Auftraege[0]=Auftraege[0]+Auftr[r][0];

        for (r=0; r<R; r++)              /* D-Werte initialisieren */
            for (j=0; j<R; j++) 
	        D[index3(i,r,j)]=0.0;
    }
} /* Ende Init_Population_k */

/***********************************************************

  FUNKTION
  Wahrscheinlichkeit()

  Wird aufgerufen in
  - HAUPTPROGRAMM
    EPA-Alg.     gespeichert auf File  "epa.c"

Berechnet die Verteilung der Wahrscheinlichkeitenmasse,
bei lastabhaengigen Knoten im System.

***********************************************************/

Wahrscheinlichkeit()
{
 extern  double **d_2dim_calloc(); 
 int	 i;
 double  sum,pr[STREUUNG];

 if ( (auftraege-1)>STREUUNG )
    smax=STREUUNG;
 else
    smax=auftraege-1;

 if ( (wm=d_2dim_calloc(smax+1,smax+1))==0 )
 {
    fprintf(stderr,"Zu wenig Speicherplatz fuer wm!\n");
    printf("epascat_speicher\n 0 0 0\n");
    exit(1);
 } 

 pr[0]=45;
 for (breite=1; breite<smax; breite++)
     pr[breite]=pr[breite-1]*0.7;

 wm[0][0]=1.0;
 for (breite=1; breite<=smax; breite++)
 {
     sum=0.0;
     for (i=0; i<=breite-1; i++)
     {
         wm[breite][i]=wm[breite-1][i]*(1-pr[breite-1]/100);
         sum=sum+wm[breite][i];
     }
     wm[breite][breite]=1.0-sum;
 }
} /* Ende Wahrscheinlichkeit() */


/***********************************************************

  FUNKTION
  Core()

  Ruft auf:
  - Schaetzungen()    gespeichert auf File  "Core-Alg.c"
  - tundk()                "       "    "        "
  - Termination()          "       "    "        "

  Wird aufgerufen in:
  - FUNKTION 
    SCAT-Alg.              "       "    "   "scat.c"

 Diese Funktion entspricht dem Core-Algorithmus

***********************************************************/

Core()
{

 stop=0;
 altlim=Auftraege[kl]+1;

 /* solange Abbruchbedingung nicht erfuellt */
 while ( stop==0 )
 {
       Schaetzungen();
       tundk();
       Termination();
 }

} /* Ende Core */


/***********************************************************

  FUNKTION
  Schaetzungen()

  Wird aufgerufen in:
  - Core()     gespeichert auf File  "Core-Alg.c"

Berechnet die F-Werte und schaetzt die k-Werte bei
Entfernung eines Auftrags aus einer Klasse.Fuer lastab-
haengige Knoten werden die Randwahrscheinlichkeiten
berechnet.

***********************************************************/

Schaetzungen()
{

 extern index3();
 double zahl,sum;
 int    floor,hilf1,hilf2;
 int	i,r,j;	/* Hilfsvariablen */

 /* fuer alle Knoten und Klassen */
 
 for (i=0; i<N; i++)
     if ( teilnetz[i]==tn )
     for (r=0; r<R; r++)
	 if ( Auftr[r][kl]==0 )  
	    lambda_hilf[r]=0;
	 else 
         {
            sum=0.0;
            for (j=0; j<R; j++) /* alle Klassen */
            {
                zahl=0.0;

                /* berechne F-Werte */
                if ( Auftr[j][kl]==0 )
                   F[index3(i,j,kl)]=0.0;
                else
                   F[index3(i,j,kl)]=k[index3(i,j,kl)]/Auftr[j][kl];

               /* schaetze k */
               if ( j==r )
                  if ( Auftr[j][kl]==0 )
                     zahl=0.0;
                  else
                     zahl=(Auftr[j][kl]-1)*
                          (F[index3(i,j,kl)]+D[index3(i,j,r)]);
               else
                  zahl=Auftr[j][kl]*(F[index3(i,j,kl)]+D[index3(i,j,r)]);
               sum=sum+zahl;
           }   
           kgesch[i][r]=sum;
           /* Randwahrscheinlichkeiten */
           if ( BE[i]>1 )
           {
              floor=kgesch[i][r]; /* ganzzahliger Anteil */
              hilf1=Auftraege[kl]-1; 
              if ( hilf1<=BEDMAX )
                 pp[index3(i,r,hilf1)]=0.0;
 
              if ( floor>STREUUNG )
              {
                 breite=STREUUNG;
                 hilf2=floor-STREUUNG;
              }
              else
              {
                 breite=floor;
                 hilf2=0;
              }

              if ( anz_knot_tn[tn-1]==1 || floor==hilf1 ) 
	      {
               for (j=0; j<=BE[i]-2; j++)
		   if ( j==hilf1 )
                      pp[index3(i,r,hilf1)]=1.0;
		   else
	              pp[index3(i,r,j)]=0.0;
              }
              else
              for (j=0; j<=BE[i]-2; j++)
              {
                  if ( hilf1-floor<=floor && j>=hilf2 && j < hilf1 &&
                       j<=(2*floor-hilf1) )
                  { 
                     pp[index3(i,r,j)]=(hilf1-kgesch[i][r])*
                             wm[breite][floor-j]/(hilf1-j);
                     if ( hilf1<=BEDMAX )
                        pp[index3(i,r,hilf1)]=pp[index3(i,r,hilf1)]+
                                    1-pp[index3(i,r,j)];

                  }
                  else
                  {
                     if ( j>=(floor-breite) && j<=floor )
                     pp[index3(i,r,j)]=(2*floor-j+1-kgesch[i][r])*
                                wm[breite][floor-j]/
                                (2*floor-2*j+1);
                     else
                     {
                        if ( j>floor && j<=(floor+breite+1) )
                        pp[index3(i,r,j)]=wm[breite][2*floor-j+1]-
                                  pp[index3(i,r,2*floor-j+1)];
                       else
                          pp[index3(i,r,j)]=0.0;
                     }
                  }
              }
           } /* if */

        } /* Knoten und Klassen */
} /* Ende Schaetzungen */

/***********************************************************

  FUNKTION
  tundk()

  Wird aufgerufen in:
  - Core()      gespeichert auf File   "Core-Alg.c"

Berechnet die mittleren Verweilzeiten und die mittlere Zahl
von Auftraegen pro Knoten und Klasse.

***********************************************************/

tundk()
{

 extern   index3();
 double   sum,summe;
 int	  i,r,j;	/* Hilfsvariablen */

 /* fuer alle Klassen */
 for (r=0; r<R; r++)
     if ( Auftr[r][kl]!=0 ) 
     {
        summe=0.0;
        /* fuer alle Knoten */
        for (i=0; i<N; i++)
	if ( teilnetz[i]==tn )
        {

           /* berechne Verweilzeiten */
           if ( my[i][r]==0.0 )
              t[i][r]=0.0;
           else
           {
              if ( BE[i]==0 )  /* Infinite Server */
                 t[i][r]=1/my[i][r];
              else
              {
                 if ( BE[i]==1 )  /* Single Server */
                    t[i][r]=(1+kgesch[i][r])/my[i][r];
                 else
                 {
                    sum=0.0;
                    for (j=0; j<=BE[i]-2; j++)
                        sum=sum+(BE[i]-1-j)*pp[index3(i,r,j)];
                    t[i][r]=(1+kgesch[i][r]+sum)/
                          (my[i][r]*BE[i]);
                 }
              }
           }
           summe=summe+(t[i][r]*ee[i][r]);
        } /* Knoten */

        /* berechne k,Zwischenspeicherung der Werte */
        for (i=0; i<N; i++)
            if ( teilnetz[i]==tn )
               khilf[index3(i,r,kl)]=Auftr[r][kl]*ee[i][r]*t[i][r]/summe;

        lambda_hilf[r]=Auftr[r][kl]/summe; 

     } /* Klassen */
} /* Ende tundk */


/***********************************************************

  FUNKTION
  Termination()

  Wird aufgerufen in:
  - Core()     gespeichert auf File   "core-alg.c"

 Ueberprueft ob die Iteration des Core-Algorithmus 
 abgebrochen werden kann.

***********************************************************/

Termination()
{

 extern index3();
 double max,wert,abbruch;
 int	i,r;	/* Hilfsvariablen */

 abbruch=1.0/(4000+16*Auftraege[kl]);
 max=0.0;
 for (r=0; r<R; r++)
     if ( Auftr[r][kl]!=0 ) 
     for (i=0; i<N; i++)
       	 if ( teilnetz[i]==tn )
         {
             if ( Auftr[r][kl]==0 )
                wert=0.0;
             else
             {
                wert=khilf[index3(i,r,kl)]-k[index3(i,r,kl)];
                /* Betragsbildung */
                if ( wert<0.0 )
                wert= -wert;
                wert=wert/Auftr[r][kl];
             }

             /* bestimme maximalen Wert */
             if ( wert>max )
                max=wert;
        }

 neulim=max;

 if ( neulim>abbruch && neulim<altlim )
    stop=0;
 else
    stop=1;

 for (i=0; i<N; i++)
     if ( teilnetz[i]==tn )
        for (r=0; r<R; r++)
             k[index3(i,r,kl)]=khilf[index3(i,r,kl)];

 altlim=neulim;
    
} /* Ende Termination */
