static char *SccsId = "@(#)PEPSY:\teingabe.c\t1.2\t92/03/27 11:46:21";

#include <stdio.h>
#include "def_EPA"

/***********************************************************

  FUNKTION
  EINGABE     

  Wird aufgerufen in:
  - HAUPTPROGRAMM
    EPASCAT       gespeichert auf File eingabe.c 

Die Funktion liest die Eingabedaten von "stdin" 

***********************************************************/

   Eingabe()
   {
    extern     double 	  **d_2dim_calloc();
    extern     int        *i_1dim_calloc();
    register   int	i,j,r;		            /* Laufvariablen */
    int        netztyp, summe, wunsch, n;
    
    fscanf(stdin,"%d", &netztyp);
    if ( netztyp != 1 )
    {
       fprintf ( stderr, " Es koennen nur geschlossene Netze analysiert werden!\n");
       printf("epascat_netztyp\n 0 0 0\n");
       exit (1);
    }
    
    /* Knoten */
    fscanf(stdin,"%d",&N);


    /* Klassen */
    fscanf(stdin,"%d",&R);
    if ( R > RMAX )
       fprintf ( stderr, "Mehr als 5 Auftragsklassen sind nicht zugelassen!\n" );
 

    /* Auftraege pro Klasse */
    for (r=0; r<R; r++)
    {
        fscanf(stdin,"%d",&anz_auftr[r]);
    }
 
    
    /* Speicherplatz fuer Bedieneinheiten reservieren */
    if ( (BE=i_1dim_calloc(N))==0 )
    {
          fprintf(stderr,"Zu wenig Speicherplatz fuer BE!\n");
          printf("epascat_speicher\n 0 0 0\n");
          exit(1);
    }

    /* Bedieneinheiten pro Knoten */
    BEDMAX=0;
    for ( i=0; i<N; i++ )
    {
        fscanf(stdin,"%d",&BE[i]);
	BEDMAX = ( BEDMAX > BE[i] ? BEDMAX : BE[i] );
    }


    /* Besuchshaeufigkeiten o. Uebergangswahrscheinlichkeiten */
    fscanf(stdin,"%d",&haeuf);


    /* Speicherplatz fuer Besuchshaeufigkeiten reservieren */ 
    if ( (ee=d_2dim_calloc(N,R))==0 )
    {
          fprintf(stderr,"Zu wenig Speicherplatz fuer ee!\n");
          printf("epascat_speicher\n 0 0 0\n");
          exit(1);
    }  

    if ( haeuf==1 )  /* Uebergangswahrscheinlichkeiten */
    {
           /* Speicherplatz fuer Uebergangswahrscheinlichkeiten reservieren */
           if ( (p=(double *)calloc((N+1)*(N+1)*R,sizeof(double)))==0 )
           {
                 fprintf(stderr,"Zu wenig Speicherplatz fuer p!\n");
	         printf("epascat_speicher\n 0 0 0\n");
                 exit(1);
           } 
	   /* Speicherplatz fuer den Gauss-Algorithmus reservieren */
           if ( (b=d_2dim_calloc(N,R))==0 )
           {
                 fprintf(stderr,"Zu wenig Speicherplatz fuer b!\n");
	         printf("epascat_speicher\n 0 0 0\n");
                 exit(1);
           } 
	   for (r=0; r<R; r++)
	   {
		   for (i=0; i<=N; i++)
	           {
			 for (j=0; j<=N; j++)
			 {
                              fscanf(stdin,"%lf",&p[index3p(i,j,r)]);
			 }
                   } 
	    }             
    }

    else     /* Besuchshaeufigkeiten */
    {
	for (r=0; r<R; r++)
	{
		   for (i=0; i<N; i++)
		   {
                       fscanf(stdin,"%lf",&ee[i][r]);
		   }
        }
     }


    /* Speicherplatz fuer Bedienraten reservieren */
    if ( (my=d_2dim_calloc(N,R))==0 )
    {
          fprintf(stderr,"Zu wenig Speicherplatz fuer my!\n");
          printf("epascat_speicher\n 0 0 0\n");
          exit(1);
    } 
	for (r=0; r<R; r++)
	{ 
		for (i=0; i<N; i++)
		{
                     fscanf(stdin,"%lf",&my[i][r]);
		}
         }

    
    fscanf(stdin,"%d", &wunsch);
    if ( wunsch!=0 )
    { 
       fscanf(stdin, "%d", &teilnetze);
       /* Speicherplatz fuer Teilnetzvektor bereitstellen */
       if ( (teilnetz=i_1dim_calloc(N))==0 )
       {
          fprintf(stderr,"Zu wenig Speicherplatz fuer teilnetz!\n");
          printf("epascat_speicher\n 0 0 0\n");
          exit(1);
       } 
       for (i=0; i<N; i++)
       { 
           fscanf(stdin, "%d",&teilnetz[i]);
       }
    }
    else
    {
       fscanf(stdin, "%d", &teilnetze);

       /* Speicherplatz fuer Teilnetzvektor bereitstellen */
       if ( (teilnetz=i_1dim_calloc(N))==0 )
       {
          fprintf(stderr,"Zu wenig Speicherplatz fuer teilnetz!\n");
          printf("epascat_speicher\n 0 0 0\n");
          exit(1);
       } 

       /* Automatische Zerlegung des Netzes in Teilnetze */
       n=1;
       for (i=0; i<N; i++)
       {
	   if ( BE[i]>1 )
	   {
	      teilnetz[i]=n;
	      if ( n<teilnetze )
	         n=n+1;
              else
		 n=1;
           }
        }

       for (i=0; i<N; i++)
       {
	   if ( BE[i]==1 )
	   {
              teilnetz[i]=n;
	      if ( n<teilnetze )
	         n=n+1;
              else
		 n=1;
           }
        }

       for (i=0; i<N; i++)
       {
	   if ( BE[i]==0 )
	   {
	      teilnetz[i]=n;
	      if ( n<teilnetze )
	         n=n+1;
              else
		 n=1;
           }
        }
    }

    /* Speicherplatz fuer Vektor reservieren, der die Anzahl der Knoten pro Teilnetz enthaelt */
    if ( (anz_knot_tn=i_1dim_calloc(teilnetze))==0 )
    {
       fprintf(stderr,"Zu wenig Speicherplatz fuer anz_knot_tn!\n");
       printf("epascat_speicher\n 0 0 0\n");
       exit(1);
    } 

    /* Bestimmung der Zahl der Knoten pro Teilnetz */
    summe=0;
    for (i=1; i<=teilnetze; i++)
    {
        for (j=0; j<N; j++)
	    if ( i==teilnetz[j] )
	       summe=summe+1;
        anz_knot_tn[i-1]=summe;
        summe=0;
    }
 } /* Ende Eingabe */
