static char *SccsId = "@(#)PEPSY:\tepascat.c\t1.2\t92/03/27 11:46:25";

#include <stdio.h>
#include "defs_EPA"

/***********************************************************
  HAUPTPROGRAMM
  EPASCAT

  Ruft auf:	         		Gespeichert in
  - Eingabe()                   	"eingabe.c"
  - Gauss()            	        	"gauss.c" 
  - Wahrscheinlichkeit()        	"core_alg.c" 
  - Speicherplatz_anfordern()   	"dyn_sp.c"
  - Init_Population_k()          	"core-alg.c"
  - scat()                      	"scat.c" 
  - norm_konst                  	"norm_konst.c"
  - Faltung()                           "faltung.c"
  - Speicher_Core_frei()	        "speicher.c"
  - Speicher_fuer_Leistung()                 "
  - Leistung()                  	"leistung.c" 
  - Speicher_Leistung_frei()            "speicher.c"
  - Ausgabe()                           "ausgabe.c"
  - Speicher_Netzgroessen_frei()        "speicher.c"

***********************************************************/

void abbruch(sig)
int sig;
{
        printf("epascat_signal_%d\n 0 0 0 \n", sig);
        exit(1);
}

main(argc, argv)
	int argc;
	char *argv[];
{
	/*		Sccs support from SccsLogging.c			*/	
	extern int SccsRelease;
	extern int SccsLevel;

  extern	Eingabe();                  
  extern	Gauss();            	     
  extern	Wahrscheinlichkeit();       
  extern	Speicherplatz_anfordern(); 
  extern	Init_Population_k(); 
  extern	SCAT();                   
  extern	Norm_konst();              
  extern	Faltung();             
  extern	Speicher_Core_frei();	
  extern	Speicher_fuer_Leistung(); 
  extern	Leistung();              
  extern	Speicher_Leistung_frei();  
  extern	Speicher_fuer_Ausgabe();
  extern	Ausgabe();             
  extern 	Speicher_Netzgroessen_frei();       
  extern        index5();
  extern        d_2dim_free();

  int    wa=0;                          /* Entscheidung fuer Aufruf von */
                                        /* Wahrscheinlichkeit() */
  int  r,i,j;                           /* Laufvariablen */

	void abbruch();

	for (i=1; i<12; i++)
			signal (i, abbruch);

	if ((argc > 1) && (!strcmp(argv[1], "-V")))    /* kirschni 22.11.1991 */
	{
		fprintf(stdout, "%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
		exit(0);
	}


  Eingabe();                            /* Lesen der Eingabedaten von "stdin" */

  if ( haeuf == 1 )                     /* Gauss() berechnet die Besuchshaeufigkeiten */
  {                                     /* aus den Uebergangswahrscheinlichkeiten */
     Gauss();                           
     free(p);                           /* Speicherplatz fuer die Uebergangswahrschein- */ 
     d_2dim_free(b,N,R);                /* und den Gauss-Algorithmus freigeben */
  }

  kl=0;

  auftraege=0;

  for (i=0; i<N; i++)                   /* wenn sich ein lastabhaengiger Knoten im */
      if ( BE[i]>1 )                    /* System befindet, berechne Verteilung der */
         wa=1;                          /* Wahrscheinlichkeitenmasse */

 if ( wa==1 )
 {  
    for (r=0; r<R; r++)
        auftraege=auftraege+anz_auftr[r];
    Wahrscheinlichkeit();  
 } 

 Speicherplatz_anfordern(wa);            /* Speicherplatz fuer den Scat-Algorithmus bereitstellen */ 

 ggalt[index5(0,0,0,0,0)]=1.0;
 ggteil[index5(0,0,0,0,0)]=1.0;

 /* In den folgenden For-Schleifen werden fuer alle Teilnetze fuer saemtliche */
 /* Populationen, d. h. von der Nullpopulaion bis zur Gesamtpopulation die */
 /* Normalisierungskonstanten bestimmt, die nach Berchnung eines Teilnetzes */
 /* gefaltet werden */

 for (tn=1; tn<=teilnetze; tn++)
 {
     for  (j1=0; j1<=anz_auftr[0]; j1++) 
          for (j2=0; j2<=anz_auftr[1]; j2++)
              for (j3=0; j3<=anz_auftr[2]; j3++)
                  for (j4=0; j4<=anz_auftr[3]; j4++)
                      for (j5=0; j5<=anz_auftr[4]; j5++) 
			  if ( j1+j2+j3+j4+j5>0 )
	                  {	
			     Auftr[0][0]=j1;
		 	     Auftr[1][0]=j2;
                             Auftr[2][0]=j3;
			     Auftr[3][0]=j4;
			     Auftr[4][0]=j5;
			     Init_Population_k();
			     SCAT();
			     Norm_konst();
                          }

    if ( tn>1 )
       Faltung();
 }
 Speicher_Core_frei(wa);

 Speicher_fuer_Leistung();
 Leistung();
 Speicher_Leistung_frei();

 Ausgabe();

 Speicher_Netzgroessen_frei();

 exit(0);
} /* Ende Hauptprogramm epascat */
