static char *SccsId = "@(#)PEPSY:\tgauss.c\t1.2\t92/03/27 11:46:29";

#include  "def_EPA"

/***********************************************************

  FUNKTION
  Gauss()

  Wird aufgerufen in :
  - HAUPTPROGRAMM
    SCAT          gespeichert auf File "scat.c"

 Berechnet aus den Uebergangswahrscheinlichkeiten die 
 Besuchshaeufigkeiten pro Knoten und Klasse mit dem Gauss-
 Algorithmus.Die Besuchshaeufigkeiten am ersten Knoten 
 werden auf 1 gesetzt.

***********************************************************/

Gauss()
{
 int        klass,zei,folgz,spa;        /* Laufvariable */
 int        tausch;                     /* Anzeige ob Zeilentausch */
 double     sum,korr,hilf;              /* Hilfsvariable */
 extern     index3p();
 extern     double **d_2dim_calloc();
 extern     d_2dim_free();


 /* fuer alle Klassen */
 for ( klass=0; klass<R; klass++ )
 {

    /* Dekrementieren der Diagonale */
    for ( zei=1; zei<=N; zei++ )
        p[index3p(zei,zei,klass)]=p[index3p(zei,zei,klass)]-1.0;

    /* Initialisieren der rechten Seite */
    for ( spa=1; spa<=N; spa++ )
        b[spa-1][klass]= -p[index3p(0,spa,klass)];

    /* Umformen in Dreiecksmatrix */
    for ( zei=1; zei<=N; zei++ )
    {
        for ( folgz=zei+1; folgz<=N; folgz++ )
        {
            korr=p[index3p(zei,folgz,klass)]/
                 p[index3p(zei,zei,klass)];
            for ( spa=zei+1; spa<=N; spa++ )
            {
                p[index3p(spa,folgz,klass)]=
                p[index3p(spa,folgz,klass)]-
                (korr*p[index3p(spa,zei,klass)]);
            }
            b[folgz-1][klass]=b[folgz-1][klass]-
                           (korr*b[zei-1][klass]);
        }
    }

  /* Loesen des dreieckigen Gleichungssystems von hinten */
  for ( zei=N; zei>0; zei-- )
  {
     sum=b[zei-1][klass];
     for ( spa=zei+1; spa<=N; spa++ )
         sum=sum-(p[index3p(spa,zei,klass)]*ee[spa-1][klass]);
     if ( p[index3p(zei,zei,klass)]!=0.0 )
        ee[zei-1][klass]=sum/p[index3p(zei,zei,klass)];
     else  /* ee frei waehlbar */
        ee[zei-1][klass]=0.0;
  }

 } /* alle Klassen */ 

 d_2dim_free(b,N,R);

} /* Ende Gauss */

