static char *SccsId = "@(#)PEPSY:\tnorm_konst.c\t1.2\t92/03/27 11:46:33";

#include "def_EPA"

/***********************************************************

  FUNKTION
  NORM_KONST 

  Wird aufgerufen in 
  - HAUPTPROGRAMM
    EPASCAT              gespeichert auf File  "norm_konst.c

  Berechnet aus dem Durchsatz fuer die erste nichtleere
  Klasse der aktuellen Population und der Normalisierungs-
  konstante fuer die Population mit einem Auftrag weniger
  in dieser Klasse die Normalisierungskonstante der aktu-
  ellen Population.

***********************************************************/

 Norm_konst()
 {
  extern      index5();                 /* Funktion zur Adressberechnung */
  register    int    i;
  double           sum;           	/* Summe der Normalisierungskonstanten */
					/* fuer Mittelwertbildung */
  sum=0.0;
  i=0;

  if ( tn==1 )                           /* Teilnetz 1 wird gerade bearbeitet,  */
  {                                      /* d. h. keine Faltung erforderlich */
     if ( R>=1 && lambda_hilf[0]!=0.0 )
     {
        sum=sum+ggalt[index5(j1-1,j2,j3,j4,j5)]/lambda_hilf[0];
  	i=1;
     }
     if ( R>=2 && lambda_hilf[1]!=0.0 && i==0 )
     {
        sum=sum+ggalt[index5(j1,j2-1,j3,j4,j5)]/lambda_hilf[1];
  	i=1;
     }
     if ( R>=3 && lambda_hilf[2]!=0.0 && i==0 )
     {
  	sum=sum+ggalt[index5(j1,j2,j3-1,j4,j5)]/lambda_hilf[2];
  	i=1; 
     }
     if ( R>=4 && lambda_hilf[3]!=0.0 && i==0 )
     {
        sum=sum+ggalt[index5(j1,j2,j3,j4-1,j5)]/lambda_hilf[3];
  	i=1;
     }
     if ( R>=5 && lambda_hilf[4]!=0.0 && i==0 )
     {
  	sum=sum+ggalt[index5(j1,j2,j3,j4,j5-1)]/lambda_hilf[4];
  	i=1;
     }
     ggalt[index5(j1,j2,j3,j4,j5)]=sum;
  }
  else                                   /* Teilnetz >=2 */
  {
     if ( R>=1 && lambda_hilf[0]!=0.0 )
     {
  	sum=sum+ggteil[index5(j1-1,j2,j3,j4,j5)]/lambda_hilf[0];
  	i=1;
     }
     if ( R>=2 && lambda_hilf[1]!=0.0 && i==0 )
     {
  	sum=sum+ggteil[index5(j1,j2-1,j3,j4,j5)]/lambda_hilf[1];
  	i=1;
     }
     if ( R>=3 && lambda_hilf[2]!=0.0 && i==0 )
     {
  	sum=sum+ggteil[index5(j1,j2,j3-1,j4,j5)]/lambda_hilf[2];
  	i=1; 
     }
     if ( R>=4 && lambda_hilf[3]!=0.0 && i==0 )
     {
  	sum=sum+ggteil[index5(j1,j2,j3,j4-1,j5)]/lambda_hilf[3];
  	i=1;
     }
     if ( R>=5 && lambda_hilf[4]!=0.0 && i==0 )
     {
  	sum=sum+ggteil[index5(j1,j2,j3,j4,j5-1)]/lambda_hilf[4];
   	i=1;
     }
     ggteil[index5(j1,j2,j3,j4,j5)]=sum;
  }

  for (i=0; i<R; i++)
    lambda_hilf[i]=0.0;

 } /* Ende Normalisierungskonstante */
