static char *SccsId = "@(#)PEPSY:\tscat.c\t1.2\t92/03/27 11:46:35";

#include "def_EPA"

/***********************************************************
  
  FUNKTION
  SCAT 

  Wird aufgerufen in: 
  - Hauptprogramm       
    EPASCAT             gespeichert auf File "scat.c" 

  Ruft auf:             Gespeichert in:
  - Initialisierung()   "core-alg.c"
  - Core()                  "


Fuer die aktuelle Population wird der Scat-Algorithmus an-
gewendet. Es wird zunaechst der Core fuer die aktuelle Po-
pulation aufgerufen, dann wird fuer alle Populationen mit
einem Auftrag in den Klassen 1 bis R-2 eine Initialisierung
vorgenommen und schliesslich der Core fuer diese Populati-
onen aufgerufen. Fuer die Klassen R-1 und R sind diese 
Schritte nicht erforderlich, da hierfuer die Ergebnisse
aus frueheren Aufrufen, die zwischengespeichert wurden, be-
nutzt werden. Nach Berechnung der D-Werte wird der Core
noch einmal fuer die aktuelle Population aufgerufen.

***********************************************************/

SCAT()
{

 extern 	core();
 extern         index3();
 register int  	r,i;                    /* Laufvariablen */ 

 kl=0;

 /* Aufruf von Core bei gesamter Population */
 Core();

 /* Zwischenspeicherung der k[i][r] Werte nach k_zw_sp */
 for (i=0; i<N; i++)
     if ( teilnetz[i]==tn )
        for (r=0; r<R; r++)
            k_zw_sp[i][r]=k[index3(i,r,0)];


 /* Aufruf von Core bei jeder Population mit */
 /* einem Auftrag weniger in einer Klasse */
 for (kl=1; kl<=R-2; kl++)
 {
      /* Vorbesetzen der Auftraege pro Klasse */
      for (r=1; r<=R; r++)
         if ( kl==r && (Auftr[r-1][0]!=0) )
            Auftr[r-1][kl]=Auftr[r-1][0]-1;
         else
            Auftr[r-1][kl]=Auftr[r-1][0];

      if ( Auftr[kl-1][0]>0 )
      {
          Initialisierung ();
          Core();
      }
 }

 /* Berechnen der D-Werte fuer anschliessenden */
 /* Aufruf von Core */
	     
 for (i=0; i<N; i++)
     if ( teilnetz[i]==tn )
        for (r=0; r<R; r++)
            for (kl=0; kl<=R-2; kl++)
	        if ( Auftr[r][kl]==0 )
	           F[index3(i,r,kl)]=0.0;
                else
	           F[index3(i,r,kl)]=k[index3(i,r,kl)]/Auftr[r][kl];

 for (i=0; i<N; i++)
     if ( teilnetz[i]==tn )
        for (r=0; r<R; r++)
            for (kl=1; kl<=R-2; kl++)
	        D[index3(i,r,kl-1)]=F[index3(i,r,kl)]-F[index3(i,r,0)];

 if ( R==1 )                       /* Ein-Klassen-Fall */
    for (i=0; i<N; i++)
        if ( teilnetz[i]==tn )
           if ( Auftr[0][0]==1 )
	      D[index3(i,0,0)]=0.0-F[index3(i,0,0)];
           else    
	      D[index3(i,0,0)]=k_hilf[index3(i,0,0)]/(Auftr[0][0]-1)-F[index3(i,0,0)];

 if ( R>=2 )                       /* Mehr-Klassen-Fall */
    for (i=0; i<N; i++)
        if ( teilnetz[i]==tn )
        {
            if ( Auftr[R-1][0]==0 )
               for (r=0; r<R; r++)
	           D[index3(i,r,R-1)]=0.0;
            if ( Auftr[R-1][0]>=1 )
	    {
	        for (r=0; r<R-1; r++)
	            if ( Auftr[r][0]==0 )
	               D[index3(i,r,R-1)]=0.0;
	            else
	               D[index3(i,r,R-1)]=k_hilf[index3(i,r,Auftr[R-1][0]-1)]/
		       Auftr[r][0]-F[index3(i,r,0)];
                if ( Auftr[R-1][0]!=1 )
                   D[index3(i,R-1,R-1)]=k_hilf[index3(i,R-1,Auftr[R-1][0]-1)]/
		   (Auftr[R-1][0]-1)-F[index3(i,R-1,0)];
                else
                   D[index3(i,R-1,R-1)]= -F[index3(i,R-1,0)];
	    }
            if ( Auftr[R-2][0]==0 )
               for (r=0; r<R; r++)
	           D[index3(i,r,R-2)]=0.0;
            if ( Auftr[R-2][0]>=1 )
            {
	        for (r=0; r<R-2; r++)
	            if ( Auftr[r][0]==0 )
	               D[index3(i,r,R-2)]=0.0;
	            else
	               D[index3(i,r,R-2)]=k_hilf[index3(i,r,Auftr[R-1][0])]/
		       Auftr[r][0]-F[index3(i,r,0)];
	        if ( Auftr[R-2][0]!=1 )  
	           D[index3(i,R-2,R-2)]=k_hilf[index3(i,R-2,Auftr[R-1][0])]/
		   (Auftr[R-2][0]-1)-F[index3(i,R-2,0)];
	        else
	           D[index3(i,R-2,R-2)]= -F[index3(i,R-2,0)];
	        if ( Auftr[R-1][0]>=1 )
	           D[index3(i,R-1,R-2)]=k_hilf[index3(i,R-1,Auftr[R-1][0])]/
		   Auftr[R-1][0]-F[index3(i,R-1,0)];
                else
	           D[index3(i,R-1,R-2)]=0.0;
	    }
        }    
 
 kl=0;

 /* erneuter Aufruf von Core bei gesamter Population */
 Core();

 if ( R!=1 )
 {
    for (i=0; i<N; i++)
        if ( teilnetz[i]==tn )
           for (r=0 ;r<R; r++)
               k_hilf[index3(i,r,Auftr[R-1][0])]=k_zw_sp[i][r];
 }
 else
    for (i=0; i<N; i++)
	if ( teilnetz[i]==tn )
	k_hilf[index3(i,0,0)]=k_zw_sp[i][0];
} /* Ende SCAT */ 
