static char *SccsId = "@(#)PEPSY:\tspeicher.c\t1.2\t92/03/27 11:46:37";

#include <stdio.h>
#include <malloc.h>
#include "def_EPA"

/****************************************************************************

Es folgt eine Reihe von Speicherverwaltungsfunktionen, die der dynamischen
Speicherverwaltung dienen.

****************************************************************************/

/*****************************************************************************

Speicherplatz fuer 1-dimensionale Matrix fuer double-Werte reservieren

*****************************************************************************/ 

double *d_1dim_calloc(k1)
int 	k1;
{
 double *kk;
 /* char   *calloc(); */

 if ( (kk=(double *)calloc(k1, sizeof(double))) == (double *) 0 )
    return(0);

 return(kk); 

} /* Ende d_1dim_calloc() */

/*****************************************************************************

Speicherplatz fuer 1-dimensionale Matrix fuer double-Werte freigeben

*****************************************************************************/ 

d_1dim_free(kk,k1)
double *kk;
int    k1;
{
 free((char *)kk);

} /* Ende d_1dim_free() */

/**************************************************************************** 

Speicherplatz fuer 2-dimensionale Matrix fuer double-Werte reservieren

*****************************************************************************/ 

double **d_2dim_calloc(k1,k2)
int 	k1, k2;
{
 int 	i1;
 double **kk;
 /* char   *calloc(); */

 if ( (kk=(double **)calloc(k1,sizeof(double*))) == (double **) 0 )
    return(0);

 for (i1=0; i1<k1; i1++)
 {
     if ( (kk[i1]=(double *) calloc(k2,sizeof(double))) == (double *) 0 )
	return(0);
 }

 return(kk); 

} /* Ende d_2dim_calloc() */

/*****************************************************************************

Speicherplatz fuer 2-dimensionale Matrix fuer double-Werte freigeben

*****************************************************************************/ 


d_2dim_free(kk,k1,k2)
double  **kk;
int 	k1, k2;
{
 int 	i1;

 for (i1=0; i1<k1; i1++)
    free((char *) kk[i1]);

 free((char *) kk);

} /* Ende d_2dim_calloc() */

/*****************************************************************************

Speicherplatz fuer 3-dimensionale Matrix fuer double-Werte reservieren

*****************************************************************************/ 

double  *d_3dim_calloc(k1,k2,k3)
int 	k1,k2,k3;
{
 double	  *adr;
 /* char     *calloc(); */

 if ( (adr=(double *)calloc(k1*k2*k3,sizeof(double))) == NULL )
     return(0);

 return(adr);

}  /* Ende d_3dim_calloc() */

/*****************************************************************************

Speicherplatz fuer 5-dimensionale Matrix fuer double-Werte reservieren

*****************************************************************************/ 

double  *d_5dim_calloc(kk)
int 	*kk;
{
 double	  *adr;
 /* char     *calloc(); */
 register int i,speicher;

 speicher=1;

 for (i=0; i<5; i++)
     if ( kk[i]!=0 )
	speicher=speicher*(kk[i]+1);
  
 if ( (adr=(double *)calloc(speicher,sizeof(double))) == NULL )
     return(0);

 return(adr);

}  /* Ende d_5dim_calloc() */

/*****************************************************************************

Speicherplatz fuer 1-dimensionale Matrix fuer int-Werte reservieren

*****************************************************************************/ 

int 	*i_1dim_calloc(k1)
int	k1;
{
 int 	*kk;
 /* char   *calloc(); */

 if ( (kk=(int *)calloc(k1, sizeof(int))) == (int *) 0  )
    return(0);

 return(kk); 

} /* Ende i_1dim_calloc() */

/*****************************************************************************

Speicherplatz fuer 1-dimensionale Matrix fuer int-Werte freigeben

*****************************************************************************/ 

i_1dim_free(kk,k1)
int 	*kk;
int 	k1;
{
 free((char *)kk);

} /* Ende i_1dim_free */

/**************************************************************************** 

Speicherplatz fuer 2-dimensionale Matrix fuer int-Werte reservieren

*****************************************************************************/ 

int 	**i_2dim_calloc(k1,k2)
int	k1, k2;
{
 int 	i1;
 int 	**kk;
 /* char   *calloc(); */

 if ( (kk=(int **)calloc(k1,sizeof(int*))) == (int **) 0 )
    return(0);

 for (i1=0; i1<k1; i1++)
 {
     if ( (kk[i1]=(int *) calloc(k2,sizeof(int))) == (int *) 0 )
	return(0);
 }

 return(kk); 

} /* Ende i_2dim_calloc() */

/*****************************************************************************

Speicherplatz fuer 2-dimensionale Matrix fuer int-Werte freigeben

*****************************************************************************/ 

i_2dim_free(kk,k1,k2)
int  	**kk;
int 	k1, k2;
{
 int 	i1;

 for (i1=0; i1<k1; i1++)
     free((char *) kk[i1]);

 free((char *) kk);

} /* Ende 2_dim_free() */

/******************************************************************************

FUNKTION Speicherplatz_anfordern()

wird aufgerufen im Hauptprogramm
gespeichert auf File speicher.c
stellt Speicherplatz fuer die Fuknktionen Faltung(), scat() und Core()
zur Verfuegung.

******************************************************************************/

Speicherplatz_anfordern(a)
int 	a;
{
  extern  Offset();

  /* Offsets fuer die Speicherverwaltung der 5-dimensionalen Matrizen */ 
  Offset();

  /* Speicherplatz fuer Matrizen fuer die Funktion Faltung() reservieren */
  if ( (ggalt=d_5dim_calloc(anz_auftr))==0 )
  {
      fprintf(stderr,"Zu wenig Speicherplatz fuer ggalt!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
  }
  if ( (ggneu=d_5dim_calloc(anz_auftr))==0 )
  {
      fprintf(stderr,"Zu wenig Speicherplatz fuer ggneu!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
  }
  if ( (ggteil=d_5dim_calloc(anz_auftr))==0 )
  {
      fprintf(stderr,"Zu wenig Speicherplatz fuer ggteil!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
  }

  /* Speicherplatz fuer Hilfsgroesen fuer die Funktionen scat() und Core() reservieren */
  if ( (F=d_3dim_calloc(N,R,R+1))==0 )
  {
      fprintf(stderr,"Zu wenig Speicherplatz fuer F!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
  }
  if ( (D=d_3dim_calloc(N,R,R))==0 ) 
  { 
     fprintf(stderr,"Zu wenig Speicherplatz fuer D!\n"); 
     printf("epascat_speicher\n 0 0 0\n");
     exit(1); 
  } 
  if ( (k=d_3dim_calloc(N,R,R+1))==0 )
  {
      fprintf(stderr,"Zu wenig Speicherplatz fuer k!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
  }
  if ( (k_hilf=d_3dim_calloc(N,R, (R==1) ? 1 : anz_auftr[R-1]+1))==0 )
  {
      fprintf(stderr,"Zu wenig Speicherplatz fuer k_hilf!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
  }
  if ( a==1 )
     if ( (pp=d_3dim_calloc(N,R,BEDMAX+1))==0 )
     {
          fprintf(stderr,"Zu wenig Speicherplatz fuer pp!\n");
          printf("epascat_speicher\n 0 0 0\n");
          exit(1);
     }
  if ( (k_zw_sp=d_2dim_calloc(N,R))==0 )
  {
      fprintf(stderr,"Zu wenig Speicherplatz fuer k_zw_sp!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
  }
  if ( (kgesch=d_2dim_calloc(N,R))==0 )
  {
      fprintf(stderr,"Zu wenig Speicherplatz fuer kgesch!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
  }
  if ( (khilf=d_3dim_calloc(N,R,R+1))==0 )
  {
      fprintf(stderr,"Zu wenig Speicherplatz fuer khilf!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
  }
  if ( (Auftr=i_2dim_calloc(RMAX,R+1))==0 )
  {
      fprintf(stderr,"Zu wenig Speicherplatz fuer Auftr!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
  }
  if ( (lambda_hilf=d_1dim_calloc(R))==0 )
  {
      fprintf(stderr,"Zu wenig Speicherplatz fuer lambda_hilf!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
  }
  if ( (t=d_2dim_calloc(N,R))==0 )
  {
      fprintf(stderr,"Zu wenig Speicherplatz fuer t!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
  }

} /* Ende Funktion Speicherplatz_anfordern() */

/******************************************************************************

FUNKTION Speicher_fuer_Leistung()

wird aufgerufen im Hauptprogramm
gespeichert auf File speicher.c
stellt Speicherplatz fuer die Funktionen Leistung() zur Verfuegung.

******************************************************************************/

 Speicher_fuer_Leistung()
 {
   if ( (ff=d_5dim_calloc(anz_auftr))==0 )
   {
      fprintf(stderr,"Zu wenig Speicherplatz fuer ff!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
   }
   if ( (gN=d_5dim_calloc(anz_auftr))==0 )
   {
      fprintf(stderr,"Zu wenig Speicherplatz fuer gN!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
   }
   if ( (PI=d_5dim_calloc(anz_auftr))==0 )
   {
      fprintf(stderr,"Zu wenig Speicherplatz fuer PI!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
   }
   if ( (k_ir=d_2dim_calloc(N,R))==0 )
   {
      fprintf(stderr,"Zu wenig Speicherplatz fuer k_ir!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
   }
   if ( (lamda=d_2dim_calloc(N,R))==0 )
   {
      fprintf(stderr,"Zu wenig Speicherplatz fuer lamda!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
   }
   if ( (rho=d_2dim_calloc(N,R))==0 )
   {
      fprintf(stderr,"Zu wenig Speicherplatz fuer rho!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
   }
   if ( (w=d_2dim_calloc(N,R))==0 )
   {
      fprintf(stderr,"Zu wenig Speicherplatz fuer w!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
   }
   if ( (q=d_2dim_calloc(N,R))==0 )
   {
      fprintf(stderr,"Zu wenig Speicherplatz fuer q!\n");
      printf("epascat_speicher\n 0 0 0\n");
      exit(1);
   }

 } /* Ende Funktion Speicher_fuer_Leistung() */

/*****************************************************************************
 
 FUNKTION
 Speicher_Core_frei()  gespeichert auf File speicher.c
 gibt die fuer den Core_algorithmus belegten Speichergroessen wieder frei

*****************************************************************************/

 Speicher_Core_frei(a)
 int 	a;
 {

  free(F);
  free(D);
  free(k_hilf); 
  if( a==1 )
  {
   d_2dim_free(wm,smax+1,smax+1); 
   free(pp);
  }
  free(k);
  d_2dim_free(k_zw_sp,N,R); 
  d_2dim_free(kgesch,N,R); 
  free(khilf); 
  d_2dim_free(Auftr,R,R+1); 
  d_1dim_free(lambda_hilf,R); 
  free(ggneu);
  free(ggteil);  

 } /* Ende Funktion Speicher_Core_frei() */

/*****************************************************************************
 
 FUNKTION
 Speicher_Core_frei()  gespeichert auf File speicher.c
 gibt die fuer den Core_algorithmus belegten Speichergroessen wieder frei

*****************************************************************************/

 Speicher_Leistung_frei()
 {

  free(ggalt);
  free(ff);
  free(gN);
  free(PI);  

 } /* Ende Funktion Speicher_Leistung_frei() */

/*****************************************************************************
 
 FUNKTION
 Speicher_Netzgroessen_frei()  gespeichert auf File speicher.c
 gibt den Speicherplatz fuer die Netzgroessen frei

*****************************************************************************/

Speicher_Netzgroessen_frei()
{

 i_1dim_free(teilnetz,N);
 i_1dim_free(anz_knot_tn,teilnetze);
 d_1dim_free(BE,N);
 d_2dim_free(ee,N,R);
 d_2dim_free(my,N,R);
 d_2dim_free(t,N,R);
 d_2dim_free(lamda,N,R);
 d_2dim_free(rho,N,R);
 d_2dim_free(w,N,R);
 d_2dim_free(q,N,R);

} /* Ende Funktion Speicher_Netzgroessen_frei() */

/****************************************************************************

 FUNKTION
 Offset() gespeichert auf File speicher.c
 berechnet die Offsets fuer die 5-dimensionalen Matrizen

****************************************************************************/

Offset()
{

 int i,j;

 for (i=1; i<4; i++)                   
 {                                    
     offset[i]=1;                    
     for (j=i+1; j<5; j++)
         if ( anz_auftr[4-j]!=0 )
            offset[i]=offset[i]*(anz_auftr[4-j]+1);
 }

} /* Ende Funktion Offset() */

/****************************************************************************

 FUNKTION
 index3() gespeichert auf File speicher.c
 berechnet Adressen fuer alle 3-dimensionalen Matrizen ausser fuer die Ma-
 trix, die die Uebergangswahrscheinlichkeiten enthaelt

****************************************************************************/

index3(k1,k2,k3)
int 	k1,k2,k3;
{

 return(k1+k2*N+k3*N*R);

} /* Ende Funktion index3() */

/****************************************************************************

 FUNKTION
 index3p() gespeichert auf File speicher.c
 berechnet Adressen fuer die Uebergangswahrscheinlichkeitsmatrix

****************************************************************************/

index3p(k1,k2,k3)
int 	k1,k2,k3;
{

 return(k1+k2*(N+1)+k3*(N+1)*(N+1));

} /* Ende Funktion index3p() */

/****************************************************************************

 FUNKTION
 index3() gespeichert auf File speicher.c
 berechnet Adressen fuer alle 5-dimensionalen Matrizen 

****************************************************************************/

index5(i1,i2,i3,i4,i5)
int 	i1,i2,i3,i4,i5;
{
 register int adr,adr0,adr1,adr2,adr3;
 extern   int offset[4];

 adr0=i5*offset[0];
 adr1=i4*offset[1];
 adr2=i3*offset[2];
 adr3=i2*offset[3];
 adr=i1+adr0+adr1+adr2+adr3;

 return(adr);

} /* Ende Funktion index5 */
