/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tevlinp.c\t1.3\t92/03/27 11:47:17";

/***********************************************************************

 ######  #    #          #          #    #    #          #####
 #       #    #          #          #    ##   #          #    #
 #####   #    #  #####   #          #    # #  #  #####   #    #
 #       #    #          #          #    #  # #          #####
 #        #  #           #          #    #   ##          #
 ######    ##            ######     #    #    #          #

***********************************************************************/
#include <stdio.h>

#define MAXR 6          /* maximal 5 Klassen */
#define MAXN 11         /* maximal 10 Knoten */
#define MAXP 4          /* maximal 3 Stufen  */
#define STREUUNG 20     /* Streuung der WKM  */    

#define MAXGK 2400		/*  GK = (MAXR + 1) ** MAXP -1          */	
#define MAXGD 342		/*  GD = (MAXR + 1) ** (MAXP - 1) - 1   */

typedef int	BOOL;
#define TRUE 1
#define FALSE 0

FILE *fopen(), *fpin, *fpout;

int     R,                          /* Anzahl Klassen */                
        N,                          /* Anzahl Knoten */
        P,                          /* Anzahl Stufen */
        modus,                      /* aktuelle Stufenzahl */
        i, j, kr, ii,               /* Laufvariablen */
        poz,                        /* Index; siehe auch 
									   Funktion POPULATION() */
		dpos,                       /* Index; siehe auch
									   Funktion DPOPULATION() */
		pos2,                       /* Index; siehe auch
									   Funktion POSITION() */
		st,                         /* siehe Funktion 
									   INCREMENT() */
	    flag,					    /* zeigt an, ob wenigstens
									   ein multiple server-
									   Knoten vorhanden ist */
        wa,                         /* Entscheidung fuer Auf-
									   ruf von WAHRSCHEIN()   */
	    hp, zaehler,                /* Hilfsgroessen */
        gk, gd; 	                /* Feldgrenzen fuer Anzahl    
									   Auftraege und Deltawerte */
double  gr2;                        /* Hilfsgroesse */

int	    pop[MAXR],                  /* Populationsvektor */
		q[MAXN],                    /* Knotentypvektor   */
		dope[MAXP],                 /* Vektor fuer die linearisierte 
									   Darstellung der Pointer auf
									   die Kundenzahlmatrizen aller
									   betrachteten Populationen     */
        schleife[MAXP],             /* Darstellung der abgezogenen
									   Kunden bzw. ihrer Klasse      */
		ddope[MAXP-1],              /* Vektor fuer die linearisierte
									   Darstellung der Pointer auf
									   die Delta-Werte 1.Ordnung 
									   aller betrachteten Populati-
									   onen, mit Ausnahme derer der
									   letzten Stufe                 */
		hilf[MAXR],                 /* aktueller Populationsvektor   */
		m[MAXN],                    /* Anzahl identischer Bedienein-
									   heiten der Knoten             */
		stelle[MAXGK],              /* "Verweisvariablen-Vektor"     */
		sh[MAXP];                   /* siehe BININSERT               */

double	zeit[MAXN][MAXR],           /* Verweilzeit-Matrix            */ 
        rho[MAXN][MAXR],            /* relative Auslastungs-Matrix   */
        throughput[MAXN][MAXR],     /* Durchsatz-Matrix              */ 
        e[MAXN][MAXR],              /* Besuchshaeufigkeiten          */
        ut[MAXN][MAXR],             /* Auslastungs-Matrix            */ 
        durchsatz[MAXR],            /* (virtueller) Durchsatzvektor  */
        anzahl[MAXN][MAXR],         /* Kundenanzahl-Vektoren des
									   aktuellen Populationsvektors
									   minus einem Klasse-r-Kunden   */
        d[MAXN][MAXR][MAXR],        /* Delta-Werte-Vektor            */ 
        mwz[MAXN][MAXR],            /* mittlere Wartezeit            */
        mwsl[MAXN][MAXR],           /* mittl. Warteschlangenlaenge   */
        mue[MAXN][MAXR],            /* Bedienzeit-Matrix             */ 
        p[MAXN][MAXN][MAXR],        /* Uebergangswahrscheinlich-     
									   keiten von Knoten i nach 
									   Knoten j bei Klasse r         */
		fdelta[MAXGK][MAXN][MAXR];  /* Hilfsvektor;wird bei Aufruf
									   von DELTABERECHNUNG benutzt   */
   
BOOL    ind,                        /* verhindert beim ersten Durch-
									   lauf die Berechnung der 
									   Deltawerte                    */
		negativ;                    /* Abbruch-Variable fuer while-
									   Schleifen im Hauptprogramm.      
									   Siehe auch Beschreibung der
									   Funktion INCREMENT().         */

struct matrix {
	double	k[MAXN][MAXR][2];
};

struct abweichung {
	double	d[MAXN][MAXR][MAXR];
};

struct matrix *kundenir[MAXGK];
struct abweichung *delta[MAXGD];



/***********************************************************************

FUNKTION
GENERIERUNG()

Erzeugt die Objekte kundenir und delta. kundenir ist ein Pointer-
vektor mit Verweisen auf die Kundenzahl-Matrizen aller betrachteten
Populationen. delta ist ein Pointervektor mit Verweisen auf die
Deltawerte 1.Ordnung aller betrachteten Populationen, mit Ausnahme
derer der letzten Stufe.

***********************************************************************/

GENERIERUNG()
{
	int	i;

	struct matrix *mat_alloc();
	struct abweichung *abw_alloc();

	for (i = 0; i <= gk; i++)
		kundenir[i] = mat_alloc();

	for (i = 0; i <= gd; i++)
		delta[i] = abw_alloc();

} /* end GENERIERUNG */


/**********************************************************************/


/***********************************************************************

FUNKTION
EINGABE()

Liest die Eingabedaten in der angegebenen Reihenfolge ein.

***********************************************************************/

EINGABE()
{
	int	i, j;

    /* Lies Anzahl Knoten */
	fscanf(fpin, "%d", &N);

	/* Lies Anzahl Klassen */
	fscanf(fpin, "%d", &R);

	/* Lies Knotentyp */
	for (i = 1; i <= N; i++)
		fscanf(fpin, "%d", &q[i]);

    /* Lies Population */
	for (i = 1; i <= R; i++)
		fscanf(fpin, "%d", &pop[i]);

    /* Lies Bedienzeiten */
	for (i = 1; i <= R; i++)
		for (j = 1; j <= N; j++)
			fscanf(fpin, "%lf", &mue[j][i]);

    /* Lies Besuchshaeufigkeiten */
	for (i = 1; i <= R; i++)
		for (j = 1; j <= N; j++)
			fscanf(fpin, "%lf", &e[j][i]);

    /* Berechne rho aus mue und e */
	for (i = 1; i <= R; i++)
		for (j = 1; j <= N; j++)
			rho[j][i] = mue[j][i] ?                                
						1.0 / mue[j][i] * e[j][i] :0;

} /* end EINGABE */


/**********************************************************************/


/***********************************************************************

FUNKTION
AUSGABE()

Gibt die Ausgabedaten in der angegebenen Reihenfolge aus.

***********************************************************************/

AUSGABE()
{

	/* Ausgabe in interne Ausgabedatei */

	fprintf(fpout, "# Name des Analyseverfahrens\n");
	fprintf(fpout, "evlin%d\n\n", P);

	fprintf(fpout, "# Netztyp Knoten Klassen\n");
	fprintf(fpout, "%3d  %3d  %3d\n\n", 1, N, R);

	for (i = 1; i <= R; i++) {  /* fuer jede Klasse */
		 
		fprintf(fpout, "# Auftragsklasse %d\n\n", i);

		for (j = 1; j <= N; j++) {  /* fuer jeden Knoten */
			if(q[j]==1)ut[j][i]=0;      
			fprintf(fpout, "# Knoten %d  lambda  e  1/mue  rho  mvz  maa  mwz  mwsl\n", j);
			/* Gib aus: Durchsatz, Besuchshaeufigkeiten,   
						Bedienzeiten, Auslastung,
						mittlere Verweilzeit,
						mittlere Anzahl Auftraege,
						mittlere Wartezeit,
						mittlere Warteschlangenlaenge   */
			fprintf(fpout, "%04.3f  %04.3f  %04.3f  %04.3f  %04.3f  %04.3f  %04.3f  %04.3f\n\n",  
				throughput[j][i], e[j][i], e[j][i] ? rho[j][i] / e[j][i] : 0,
				ut[j][i], zeit[j][i], kundenir[0]->k[j][i][stelle[0]], mwz[j][i], mwsl[j][i]);
		}
	}

} /* end AUSGABE */


/**********************************************************************/

					
/***********************************************************************
 
FUNKTION
GAUSS()

Berechnet aus den Uebergangswahrscheinlichkeiten die Besuchshaeufig-
keiten pro Knoten und Klasse mit dem Gauss-Algorithmus. Die Besuchs-
haeufigkeiten am ersten Knoten werden auf 1 gesetzt.

***********************************************************************/
 
GAUSS()
{
	double sum, korr, hilf,              /* Hilfsvariablen */
		   b[MAXN][MAXR];                /* rechte Seite des
											Gleichungssystems */
	int klass, zei, folgz, spa,          /* Laufvariablen */
		tausch;                          /* Anzeige ob Zeilentausch */

/* fuer alle Klassen */
for ( klass=1; klass<=R; klass++ ){

	/* Dekrementieren der Diagonalen */
	for ( zei=1; zei<=N; zei++ )
	    p[zei][zei][klass]=p[zei][zei][klass]-1.0;

	/* Initialisieren der rechten Seite */
	for ( spa=1; spa<=N; spa++ )
		b[spa][klass]= -p[1][spa][klass];
	
	/* erste Zeile von e auf 1 setzen */
	e[1][klass]=1.0;

	/* pruefen ob Diagonalelement=0 */
	for ( zei=1; zei<=N; zei++ )
        {
		 if ( p[zei][zei][klass]==0.0 )
		    {
			/* Zeilentausch mit tieferer Zeile wenn moeglich */
			 folgz=zei+1;
			 tausch=0;
			 while ( folgz<=N && tausch==0 )
			  {
			   if ( p[folgz][zei][klass]!=0.0 )
				  {   /* vertauschen */
				   tausch=1;
				   for ( spa=1; spa<=N; spa++ )
					   {
						hilf=p[zei][spa][klass];
						p[zei][spa][klass]=
						  p[folgz][spa][klass];
						p[folgz][spa][klass]=hilf;
					   }
				   hilf=b[zei][klass];
				   b[zei][klass]=b[folgz][klass];
				   b[folgz][klass]=hilf;
				  }
			   folgz=folgz+1;
		      }
            }
        }

	/* Umformen in Dreiecksmatrix */
	for ( zei=2; zei<N; zei++ )
		{
		 for ( folgz=zei+1; folgz<=N; folgz++ )
			 {
			  korr=p[zei][folgz][klass]/
				   p[zei][zei][klass];
			  for ( spa=zei+1; spa<=N; spa++ )
				  {
				   p[spa][folgz][klass]=
					p[spa][folgz][klass]-
					(korr*p[spa][zei][klass]);
				  }
			  b[folgz][klass]=b[folgz][klass]-
							  (korr*b[zei][klass]);
			 }
		}

	/* Loesen des dreieckigen Gleichungssystems von hinten */
	for ( zei=N; zei>1; zei-- )
		{
		 sum=b[zei][klass];
		 for ( spa=zei+1; spa<=N; spa++ )
			 sum=sum-(p[spa][zei][klass]*e[spa][klass]);
		 if ( p[zei][zei][klass] != 0.0 )
			e[zei][klass]=sum/p[zei][zei][klass];
		 else   /* e frei waehlbar */
			e[zei][klass]= 1.0;
		}
	 }  /* alle Klassen */
	}  /* Ende GAUSS */


/**********************************************************************/

							
/***********************************************************************

FUNKTION
WAHRSCHEIN()

Berechnet die Verteilung der Wahrscheinlichkeitenmasse, bei
lastabhaengigen Knoten im System.

***********************************************************************/

WAHRSCHEIN()
{
 int smax;
 double sum, pr[STREUUNG];

}  
/**********************************************************************/


/***********************************************************************

FUNKTION
DOPEBERECHNUNG()

Berechnet die beiden DOPE-Vektoren.(Siehe auch Deklarationsteil) 

***********************************************************************/

DOPEBERECHNUNG()
{
	int	kr;

	dope[P] = 1;
	ddope[P-1] = 1;

	/* Berechne DOPE-Vektor */
	for (kr = 1; kr < P; kr++)
		dope[kr] = POWER(R + 1, P - kr);

	/* Berechne DDOPE-Vektor */
	for (kr = 1; kr <= P - 2; kr++)
		ddope[kr] = POWER(R + 1, P - 1 - kr);

} /* end DOPEBERECHNUNG */


/**********************************************************************/


/***********************************************************************

FUNKTION
POPULATION()

Berechnet den aktuellen Populationsvektor mit Hilfe der Werte von
schleife. Berechnet ausserdem die Werte fuer den Index poz.
kundenir[poz] verweist auf die Kundenzahl-Matrix des aktuellen
Populationsvektors.

***********************************************************************/

POPULATION()
{
	int	kr;

	for (kr = 1; kr <= R; kr++)
		hilf[kr] = pop[kr];

	poz = 0;

	for (kr = 1; kr <= modus; kr++) {
		hilf[schleife[kr]] = hilf[schleife[kr]] - 1;
		poz = poz + schleife[kr] * dope[kr];
	}

} /* end POPULATION */


/*********************************************************************/


/**********************************************************************

FUNKTION
DPOPULATION()

Berechnet die Werte fuer den Index dpos. delta[dpos] verweist auf die
Deltawerte 1.Ordnung des aktuellen Populationsvektors.

**********************************************************************/

DPOPULATION()
{
	int	kr;

	dpos = 0;

	for (kr = 1; kr <= modus; kr++)
		dpos = dpos + schleife[kr] * ddope[kr];

} /* end DPOPULATION */


/**********************************************************************/


/***********************************************************************

FUNKTION
POSITION()

Berechnet die Werte fuer den Index pos2 zum Zugriff auf den Vektor
kundenir und das Feld f.

***********************************************************************/

POSITION()
{
	int	kr;

	pos2 = 0;

	for (kr = 1; kr <= modus + 1; kr++)
		pos2 = pos2 + sh[kr] * dope[kr];

} /* end POSITION */


/**********************************************************************/


/***********************************************************************

FUNKTION
BININSERT(i, j, sh)

j wird binaer in die Folge schleife[1] bis schleife[i-1] eingefuegt, 
und das Ergebnis in sh abgespeichert.

***********************************************************************/

BININSERT(i, j, sh)
int	i, j;
int	sh[];
{
	int	x, l, r, m;

	l = 1;
	r = i - 1;

	while (l <= r) {
		m = ENTIER((l + r) / 2.0);

		if (j < schleife[m])
			r = m - 1;
		else
			l = m + 1;
	} /* end while */

	for (x = i - 1; x >= l; x--)
		sh[x+1] = schleife[x];

	for (x = 1; x < l; x++)
		sh[x] = schleife[x];

	sh[l] = j;

} /* end BININSERT */


/**********************************************************************/


/***********************************************************************

FUNKTION
INCREMENT()

Inkrementiert den Vektor schleife[modus] so, dass folgende Bedingungen
eingehalten werden:

(1) schleife[i] <= R              fuer alle i aus {1, ... , modus}

(2) schleife[i] <= schleife[i+1]  fuer alle i aus {1, ... , modus-1}.

st gibt die naechste zu veraendernde Komponente von schleife an.Ist
keine weitere Inkrementierung moeglich, wird negativ mit dem Wert
TRUE belegt.

BEISPIEL:
Sei modus=P=4, R=3, schleife(1,2,3,4)=(1,2,3,3), st=4.
Nach Aufruf von INCREMENT():
				schleife(1,2,3,4)=(1,3,3,3), st=4.

***********************************************************************/

INCREMENT()
{
	int	i;

	if (st > 0) {
		if (schleife[st] < R)
			schleife[st] = schleife [st] + 1;
		else
		 {
			while ((st == 0) ? FALSE : schleife[st] == R)
				st--;

			if (st > 0) {
				schleife[st] = schleife[st] + 1;

				for (i = st + 1; i <= modus; i++)
					schleife[i] = schleife[st];

				st = modus;
			} else
				negativ = TRUE;
		}
	} else
		negativ = TRUE;

} /* end INCREMENT */


/**********************************************************************/


/***********************************************************************

FUNKTION
REINIT()

Erzeugt den Initialzustand fuer die sukzessive Benutzung von
INCREMENT().

***********************************************************************/

REINIT()
{

	for (i = 1; i <= P; i++)
		schleife[i] = 1;

	negativ = FALSE;
	st = modus = P;

} /* end REINIT */


/**********************************************************************/


/***********************************************************************

FUNKTION
INITIALISIERUNG()

Nimmt die Gleichverteilung der Kundenzahlen auf die Bedienstationen
fuer die Populationen der untersten Stufe vor.

***********************************************************************/

INITIALISIERUNG()
{
	int	i, kr;

	REINIT();

	while (!negativ) {
		POPULATION();

		for (i = 1; i <= N; i++)
			for (kr = 1; kr <= R; kr++) {
				kundenir[poz]->k[i][kr][0] =                            
					  (double)hilf[kr] / (double)N;
			}

		INCREMENT();
	} /* end while */

	REINIT();

} /* end INITIALISIERUNG */


/**********************************************************************/


/***********************************************************************

FUNKTION
DELTABERECHNUNG(f)

Berechnet die Kundenzahlverhaeltnisse und die Deltawerte 1.Ordnung
aller zu betrachtenden Populationen, angefangen mit den untersten
bzw. zweituntersten Populationen bis hinauf zur obersten Population.
f wird nur deshalb uebergeben, damit dessen Werte nach aussen hin
bekannt sind. Die Uebergabe des Feldes hat keine darueber hinaus
gehende Bedeutung.

***********************************************************************/

DELTABERECHNUNG(f)
double	f[][MAXN][MAXR];
{
	int	i, kr, j;

	while (!negativ) {
		POPULATION();

        /* Initialisiere die Kundenzahlverhaeltnisse */
		for (i = 1; i <= N; i++)
			for (kr = 1; kr <= R; kr++)
				f[poz][i][kr] = (hilf[kr] > 0) ? 
				    kundenir[poz]->k[i][kr][stelle[poz]] / hilf[kr] : 0;

		INCREMENT();
	} /* end while */

	for (modus = P - 1; modus >= 0; modus--) {
		st = modus;
		negativ = FALSE;

		for (i = 1; i <= modus; i++)
			schleife[i] = 1;

		while (!negativ) {
			POPULATION();
			DPOPULATION();

			for (i = 1; i <= N; i++)
				for (kr = 1; kr <= R; kr++) {
					/* Berechne Kundenzahlverhaeltnisse */
					f[poz][i][kr] = (hilf[kr] > 0) ? 
					    kundenir[poz]->k[i][kr][stelle[poz]]            
                      / hilf[kr] : 0;

					/* Berechne Deltawerte */
					for (j = 1; j <= R; j++) {
						BININSERT(modus + 1, j, sh);
						POSITION();
						delta[dpos]->d[i][kr][j]=
						  f[pos2][i][kr] - f[poz][i][kr];
					} /* end for */
				} /* end for */

			INCREMENT();
		} /* end while */
	} /* end for */

	REINIT();

} /* end DELTABERECHNUNG */


/**********************************************************************/


/***********************************************************************

FUNKTION
DELTASCHAETZ()

Berechnet die geschaetzten Deltawerte mittels der Formel (4.14) aus
Kapitel 4. Das Ergebnis wird in d abgespeichert. v gibt das aktuelle
Vorzeichen an.

***********************************************************************/

DELTASCHAETZ()
{
	int	s[MAXP - 1];
	BOOL negativ;
	int	m, v, k, i, j, kr;

	v = POWER(-1, P);

	for (i = 1; i <= N; i++)
		for (kr = 1; kr <= R; kr++)
			for (j = 1; j <= R; j++)
				d[i][kr][j] = delta[0]->d[i][kr][j] * v * (-1);

	if (P > 1) {
		m = 1;
		negativ = FALSE;
		s[1] = 1;

		for (i = 2; i < P; i++)
			s[i] = 0;

		while (!negativ) {
			dpos = 0;

			for (k = 1; k <= m; k++)
				dpos = dpos + schleife[s[k]] * ddope[k];

			for (i = 1; i <= N; i++)
				for (kr = 1; kr <= R; kr++)
					for (j = 1; j <= R; j++)
						d[i][kr][j] =                                   
                           d[i][kr][j] + delta[dpos]->d[i][kr][j] * v;
             /**********************************************************

			 FUNKTION
			 DKOMB

			 Inkrementiert die Vektoren s[m] mit (1<=m<=P-1) so, dass
			 folgende Bedingungen eingehalten werden:

			 (1)  s[i] <= P      fuer alle i aus {1, ..., m}

			 (2)  s[i] < s[i+1]  fuer alle i aus {1, ..., m-1}

			 m entspricht modus, help entspricht st und negativ ent-
			 spricht negativ in der Prozedur INCREMENT. Allerdings
			 findet die Inkrementierung von m in DKOMB statt,
			 waehrend die Inkrementierung von modus ausserhalb von
			 INCREMENT stattfindet. Laesst sich der Vektor s[P-1]
			 nicht weiter inkrementieren, wird negativ mit dem Wert
			 TRUE besetzt.

			 **********************************************************/

			 {
				/* DKOMB */

				int	h, help, i;

				if (s[m] < P)
					s[m] = s[m] + 1;
				else
				 {
					h = P;
					help = m;

					while ((help == 0) ? FALSE : s[help] == h) {
						help = help - 1;
						h = h - 1;
					} /* end while */

					if (help > 0) {
						s[help] = s[help] + 1;

						for (i = help + 1; i <= m; i++)
							s[i] = s[i-1] + 1;
					} else
					 {
						if (m < P - 1) {
							m++;
							v = v * (-1);

							for (i = 1; i <= m; i++)
								s[i] = i;
						} else
							negativ = TRUE;
					} /* end if */
				} /* end if */
			} /* end DKOMB */

		} /* end while */
	} /* end if */

} /* end DELTASCHAETZ */


/**********************************************************************/


/***********************************************************************

FUNKTION
KNOTENZEIT(c)

Berechnet fuer jede Klasse die Summe der Verweilzeiten ueber alle
Knoten.

***********************************************************************/

double	KNOTENZEIT(c)

int	c;
{

	int	i;
	double	hilf;

	hilf = 0;

	for (i = 1; i <= N; i++)
		hilf = hilf + zeit[i][c];
	return hilf;

} /* end KNOTENZEIT */


/**********************************************************************/


/***********************************************************************

FUNKTION
APPMWA(kundenir, wf, pp, anzahl)

Berechnet die approximierten Kundenzahlwerte der Population pp mit
Hilfe der MWA-Beziehungen. Dabei bedeuten:

pp:       aktuelle Population 
anzahl:   Kundenzahlvektoren der Populationen pp abzueglich eines
		  Klasse-r-Kunden
kundenir: Kundenzahlwerte der Population pp
wf:       "Verweisvariable".

***********************************************************************/

APPMWA(kundenir, wf, pp, anzahl)

int	*wf;
double	kundenir[][MAXR][2], anzahl[][MAXR];
int	pp[];
{

	int	i, kr;

	/* Berechne Verweilzeiten */
	for (i = 1; i <= N; i++)
		for (kr = 1; kr <= R; kr++)
			if (pp[kr] <= 0)
				zeit[i][kr] = 0;
			else if (q[i] == 1)
				zeit[i][kr] = rho[i][kr];
			else
				zeit[i][kr] = rho[i][kr] * (1 + anzahl[i][kr]);

	/* Berechne Durchsatz */
	for (kr = 1; kr <= R; kr++)
		durchsatz[kr] = (pp[kr] > 0) ? pp[kr] / KNOTENZEIT(kr) : 0;

	*wf = (*wf == 0) ? 1 : 0;

    /* Berechne Kundenzahlwerte */
	for (i = 1; i <= N; i++)
		for (kr = 1; kr <= R; kr++)
			kundenir[i][kr][*wf] = durchsatz[kr] * zeit[i][kr];

} /* end APPMWA */


/**********************************************************************/


/***********************************************************************

FUNKTION
MAX(kundenir, pp)

Berechnet die maximale Abweichung bezueglich der Kundenzahlverhaelt-
nisse der beiden letzten Iterationen. Dient zur Ueberpruefung der
Abbruchbedingung in der Prozedur CORESTRICH sowie im Hauptprogramm.
kundenir und pp haben dieselbe Bedeutung wie bei APPMWA.

***********************************************************************/

double	MAX(kundenir, pp)

double	kundenir[][MAXR][2];
int	pp[];

{

	int	i, kr;
	double	hilf, maxi;

	maxi = 0;

	for (i = 1; i <= N; i++)
		for (kr = 1; kr <= R; kr++) {
			double	ABS();

			if (pp[kr] > 0)
				hilf = ABS(kundenir[i][kr][0]                           
					 - kundenir[i][kr][1]) / pp[kr];
			else
				hilf = 0;
			if (hilf > maxi)
				maxi = hilf;
		} /* end for */
	return maxi;

} /* end MAX */


/**********************************************************************/

 
/***********************************************************************

FUNKTION
CORESTRICH(kundenir, wf, pp, delta)

Berechnet die approximierten Kundenzahlwerte der Population pp nach
dem Prinzip des CORE-AA.   
kundenir, wf und pp haben dieselbe Bedeutung wie bei APPMWA.
delta:  geschaetzte Deltawerte 1.Ordnung der Population pp.
Der Programmtext fuer die Prozedur STARTWERTE wurde zweimal ausge-
schrieben, weil dies einfacher ist, als die Prozedur auszugliedern
und zweimal aufzurufen.

***********************************************************************/

CORESTRICH(kundenir, wf, pp, delta)

int	*wf;
double	kundenir[][MAXR][2], delta[][MAXR][MAXR];
int	pp[];
{

	double	anzahl[MAXN][MAXR];
	int	help;
	double	aider;

	 /******************************************************************

	 FUNKTION
	 KARDINALITAET

	 Berechnet den Betrag des Vektors pp.

	 ******************************************************************/
	 {
		/* KARDINALITAET */

		int	kr;

		help = 0;

		for (kr = 1; kr <= R; kr++)
			help = help + pp[kr];

     }  /* end KARDINALITAET */                            

	 /******************************************************************

	 FUNKTION
	 STARTWERTE

	 Berechnet die Werte der Kundenzahl-Vektoren der Populationen pp
	 abzueglich eines Klasse-r-Kunden.

	 ******************************************************************/
	 {
		/* STARTWERTE */

		double	f[MAXN][MAXR];
		int	i, kr, j;

		for (i = 1; i <= N; i++)
			for (kr = 1; kr <= R; kr++)
				anzahl[i][kr] = 0;

		for (i = 1; i <= N; i++)
			for (kr = 1; kr <= R; kr++) {
				if (pp[kr] > 0)
					f[i][kr] = kundenir[i][kr][*wf] / pp[kr];
				else
					f[i][kr] = 0;

				for (j = 1; j <= R; j++) {
					pp[j] = pp[j] - 1;

					if (pp[kr] > 0)
						anzahl[i][j] = anzahl[i][j] + pp[kr] * 
						    (f[i][kr] + delta[i][kr][j]);

					pp[j] = pp[j] + 1;
				} /* end for */
			} /* end for */

	} /* end STARTWERTE */

	APPMWA(kundenir, wf, pp, anzahl);

	zaehler++;
	aider = 1.0 / (4000.0 + 16.0 * help);

	while (MAX(kundenir, pp) > aider) {
		{ 
		/* STARTWERTE */

		double	f[MAXN][MAXR];
		int	i, kr, j;

		for (i = 1; i <= N; i++)
			for (kr = 1; kr <= R; kr++)
				anzahl[i][kr] = 0;

		for (i = 1; i <= N; i++)
			for (kr = 1; kr <= R; kr++) {
				if (pp[kr] > 0)
					f[i][kr] = kundenir[i][kr][*wf] / pp[kr];
				else
					f[i][kr] = 0;

				for (j = 1; j <= R; j++) {
					pp[j] = pp[j] - 1;

					if (pp[kr] > 0)
						anzahl[i][j] = anzahl[i][j] + pp[kr] * 
						    (f[i][kr] + delta[i][kr][j]);

					pp[j] = pp[j] + 1;
				} /* end for */
			} /* end for */

	} /* end STARTWERTE */

	APPMWA(kundenir, wf, pp, anzahl);

	zaehler++;
} /* end while */


} /* end CORESTRICH */


/**********************************************************************/


/***********************************************************************

FUNKTION
LEISTUNGSMASZE()

Berechnet die Leistungsgroessen Verweilzeit, Durchsatz, Auslastung,
mittlere Wartezeit und mittlere Warteschlangenlaenge in eben dieser
Reihenfolge. Alle Berechnungen beziehen sich auf die letzte Popu-
lation und stellen demnach die endgueltigen Werte dar.

***********************************************************************/

LEISTUNGSMASZE()
{
	int	i, kr;

	for (i = 1; i <= N; i++)
		for (kr = 1; kr <= R; kr++) {
			
			/* Berechne Verweilzeit */
			if (e[i][kr] != 0)
				zeit[i][kr] = zeit[i][kr] / e[i][kr];
			else
				zeit[i][kr] = 0;

			/* Berechne Durchsatz */
			throughput[i][kr] = durchsatz[kr] * e[i][kr];

			/* Berechne Auslastung */
			ut[i][kr] = durchsatz[kr] * rho[i][kr];

			/* Berechne mittlere Wartezeit */
			if (e[i][kr])
				mwz[i][kr] = zeit[i][kr] - rho[i][kr] / e[i][kr];

            /* Berechne mittlere Warteschlangenlaenge */
			mwsl[i][kr] = throughput[i][kr] * mwz[i][kr];
		} /* end for */

} /* LEISTUNGSMASZE */


/**********************************************************************/


/***********************************************************************

FUNKTION
POWER(basis, exponent)

POWER ist eine einfache Potenzierungsfunktion.

***********************************************************************/

POWER(basis, exponent)
int	basis, exponent;
{
	int	p;
	int	i;

	p = 1;

	if (exponent == 0)
		return(p);
	else if (exponent < 0)
		fprintf(stderr, "bug POWER\n");
	else
	 {
		for (i = 1; i <= exponent; i++)
			p = p * basis;

		return(p);
	}

} /* end POWER */


/**********************************************************************/


/**********************************************************************/

struct matrix *mat_alloc()
{
	struct matrix *mp;
	char	*calloc();

	mp = (struct matrix *)calloc(1, sizeof(struct matrix ));

	return(mp);

} /* end mat_alloc */


/**********************************************************************/


/**********************************************************************/

struct abweichung *abw_alloc()
{
	struct abweichung *ap;
	char	*calloc();

	ap = (struct abweichung *)calloc(1, sizeof(struct abweichung ));

	return(ap);

}  /* end abw_alloc */


/**********************************************************************/


/***********************************************************************

FUNKTION
ABS(x)

Berechnet den Absolutbetrag der reellen Zahl x.

***********************************************************************/

double	ABS(x)
double	x;
{
	return((x > 0) ? x : -x);

} /* end ABS */


/**********************************************************************/


/***********************************************************************

FUNKTION
ENTIER(x)

Rundet die reelle Zahl x ab.           

***********************************************************************/

int	ENTIER(x)
double	x;
{
	int	i;
	i = x;

	return(i);

} /* end ENTIER */


/**********************************************************************/

void abbruch(sig)
int sig;
{
        printf("evlinp_signal_%d\n 0 0 0 \n", sig);
        exit(1);
}

/***********************************************************************

HAUPTPROGRAMM
main     

Nach sequentieller Ausfuehrung der Prozeduren EINGABE, DOPEBERECHNUNG,
GENERIERUNG und INITIALISIERUNG wird die while-Schleife sooft ausge-
fuehrt bis die Abbruchbedingung erfuellt ist; mindestens jedoch ein-
mal. Danach erfolgt der Aufruf der Prozeduren LEISTUNGSMASZE und
AUSGABE.

***********************************************************************/

main(argc, argv)
int	argc;
char	*argv[];
{
	/*		Sccs support from SccsLogging.c			*/	
	extern int SccsRelease;
	extern int SccsLevel;

    int i;
    void abbruch();

    for (i=1; i<12; i++)
        signal (i, abbruch);

	if ((argc > 1) && (!strcmp(argv[1], "-V")))    /* kirschni 22.11.1991 */
	{
		fprintf(stdout, "%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
		exit(0);
	}


	switch (argc) {
	case 1:
		P = 1;
		break;
	case 2:
		if ((P = atoi(argv[1])) < 1 || P >= MAXP ) {
			P = 1;
		}
		break;
	default:
		fprintf(stderr, "evlinp: zuviele Parameter\n");
		printf("evlinp_parameter\n 0 0 0\n");
		exit(1);
		break;
	}
	/*
    if (!(fpin = fopen("in","rb")))
    {
       printf("File %s kann nicht eroeffnet werden!\n","in");
       printf("evlinp_file\n 0 0 0\n");
       exit(1);
    }
    if (!(fpout = fopen("out","wb")))
    {
       printf("File %s kann nicht eroeffnet werden!\n","out");
       printf("evlinp_file\n 0 0 0\n");
       exit(2);
    }
	*/
	fpin = stdin;
	fpout = stdout;
	
	EINGABE();

	fclose(fpin);

	gk = POWER(R + 1, P) - 1;
	gd = POWER(R + 1, P - 1) - 1;
	flag=0;                                         /* DUMP */
    if ( flag==1 )          /* berechne die Besuchshaeufigkeiten */
	   GAUSS();             /* aus den Uebergangswahrscheinlichkeiten */
	DOPEBERECHNUNG();
	GENERIERUNG();
	INITIALISIERUNG();

	/* wenn sich mindestens ein lastabhaengiger Knoten im System be-
	   findet, berechne die Verteilung der WKM                       */
    for ( i=1; i<=N; i++ )
		if ( m[i]>1 )
		   wa=1;
	if ( wa==1 )
	   WAHRSCHEIN();

	hp = 0;

	for (kr = 1; kr <= R; kr++)
		hp = hp + pop[kr];

	gr2 = 1.0 / ((40000.0 + 160.0 * hp) * POWER(10, P - 1));

	while (gr2 < MAX(kundenir[0]->k, pop) || !ind) {
		ii++;

		if (ind)
			DELTABERECHNUNG(fdelta);

		while (!negativ) {
			POPULATION();
			DELTASCHAETZ();

			CORESTRICH(kundenir[poz]->k, &stelle[poz], hilf, d);

			INCREMENT();
		} /* end while */

		for (modus = P - 1; modus >= 0; modus--) {
			st = modus;
			negativ = FALSE;

			for (i = 1; i <= modus; i++)
				schleife[i] = 1;

			while (!negativ) {
				POPULATION();

				for (i = 1; i <= N; i++)
					for (kr = 1; kr <= R; kr++)
						anzahl[i][kr] = 0;

				for (i = 1; i <= N; i++)
					for (kr = 1; kr <= R; kr++)
						for (j = 1; j <= R; j++) {
							BININSERT(modus + 1, j, sh);
							POSITION();
							anzahl[i][j] = anzahl[i][j] + 
							    kundenir[pos2]->k[i][kr][stelle[pos2]];
						} /* end for */

				APPMWA(kundenir[poz]->k, &stelle[poz], hilf, anzahl);

				INCREMENT();
			} /* end while */

		} /* end for */

		REINIT();
		ind = TRUE;

	} /* end while */

	LEISTUNGSMASZE();
	AUSGABE();
	fclose(fpout);

	exit(0);
} /* end main */


/**********************************************************************/






