/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tfaltung.c\t1.2\t92/03/27 11:47:32";

/*
 ######    ##    #        #####  #    #  #    #   ####
 #        #  #   #          #    #    #  ##   #  #    #
 #####   #    #  #          #    #    #  # #  #  #
 #       ######  #          #    #    #  #  # #  #  ###
 #       #    #  #          #    #    #  #   ##  #    #
 #       #    #  ######     #     ####   #    #   ####

 programmiert von Otto Niesser
*/

#include <stdio.h>

#define BOOLEAN int
#define TRUE 1
#define FALSE 0

#define AND &&
#define OR ||
#define NOT ! 

/*        Festlegung des Gleitkommaformats                              */
/*        bei float : REAL_FORM = "%9.5f "                              */
/*                    REAL_READ = "%f"                                  */
/*                                                                      */
/*        bei double: REAL_FORM = "%9.5lf "                             */
/*                    REAL_READ = "%lf"                                 */

#define REAL double
#define REAL_FORM "%9.5lf "
#define REAL_READ "%lf"

/*        Makro zum Einlesen aus stdio mit Fehlerbehandlung             */

#define LIES(A,B)       scanf(A,&B);                                    \
                        if((REAL)B < 0.0)                               \
                        {                                               \
                          f_eingabe = TRUE;                             \
                          fehler = TRUE;                                \
                          return;                                       \
                        }                

/*        Makro zur Speicherplatzbelegung mit Erfolgsueberpruefg        */

#define ALLOCATE(P,S,T) P=(T*)calloc((unsigned)(S),sizeof(T));          \
                        if(P == NULL)                                   \
                        {                                               \
                          f_speicher = TRUE;                            \
                          fehler = TRUE;                                \
                          return;                                       \
                        }                                               \
                        else                                            \
                          mem += (S) * sizeof(T);

/*        Abbildung 2-dim Index -> 1-dim Index                          */

#define IND2(I,J) ((J) * M + I)

/*        Globale Variablen                                             */

int     *N,                /* Populationsvektor                         */
        *n,                /* laeuft ueber alle Populationen            */
        *n1,*n2,           /* Hilfsvektoren fuer G                      */
        M,                 /* Anzahl der Knoten                         */
        *kn_typ,           /* Knotentyp                                 */
        *anz_bs,           /* Anzahl Bedienstationen bei M/M/k          */
        R,                 /* Anzahl der Klassen                        */
        *prod_v,           /* Produkt(N[i]+1)                           */
        ue_w;              /* Flag fuer Uebergangsw'keiten              */
REAL    *F,                /* Hilfsfunktion fuer Normalisierungsconst.  */
        *G,                /*               - || -                      */
        *G1,               /*               - || -                      */
        *mue,              /* Bedienrate                                */
        *e,                /* Besuchshaeufigkeiten                      */
        *t,                /* Mittlere Verweilzeit                      */
        *lambda,           /* Durchsatz                                 */
        *k,                /* Mittlere Auftragszahl                     */
        *rho,              /* Auslastung                                */
        sum1;              /* Hilfsvariable fuer Summation              */
BOOLEAN f_eingabe=FALSE,   /* Eingabefehler                             */
        f_speicher=FALSE,  /* kein Speicher mehr frei                   */
        f_uew=FALSE,       /* Uebergangsw'keiten nicht mehr unterstuetzt*/
        fehler=FALSE;      /* allgemeiner Fehler                        */

char    *calloc();

int     mem = 0;           /* benoetigter Speicherplatz                 */

/*        Schleife ueber alle Populationen                              */

pop_loop(n,N,call,arg1,arg2)
int *n,*N,call,arg1,arg2;
{
  REAL hilf;
  REAL sum;
  int i,j,uebertrag;

  uebertrag = 0;
  for (i = 0; i < R; i++)
    n[i] = 0;
  do
  {
    if (NOT fehler)
    {
      switch (call)
      {
        case 0:  /* F berechnen */
                 ber_F();
                 break;
        case 1:  /* G berechnen */
                 sum1 = 0.0;
                 pop_loop(n1,N,2,arg1,0);
                 G[ind(arg1,n)] = sum1;
                 break;
        case 2:  /* G berechnen 1. Hilfsschleife */
                 if(sum_hilf())
                   sum1 += G[ind(arg1-1,n1)] * F[ind(arg1,n2)];
                 break;
        case 4:  /* k berechnen */
                 if (n[arg2] > 0)
                 {
                   for (i = 0; i < R; i++)
                     N[i] -= n[i];
                   hilf = G1[ind(arg1,N)];
                   for (i = 0; i < R; i++)
                     N[i] += n[i];
                   hilf = F[ind(arg1,n)] * hilf / G[ind(M-1,N)];
                   sum1 += n[arg2] * hilf;
                 }
                 break;
        case 5:  /* G1 berechnen */
                 for (i = 0; i < M; i++)
                 {
                   if (null(n))
                   G1[ind(i,n)] = 1;
                   for (j = 0; j < M-1; j++)
                   {
                     sum1 = 0.0;
                     pop_loop(n1,n,6,i,j);
                     G1[ind(i,n)] = G[ind(M-1,n)] - sum1;
                   }
                 }
                 break;
        case 6:  /* G1 berechnen Hilfsschleife */
                 for (i = 0; i < R; i++)
                   N[i] -= n[i];
                 hilf = G1[ind(arg1,N)];
                 for (i = 0; i < R; i++)
                   N[i] += n[i];
                 if (NOT null(n))
                   sum1 += F[ind(arg1,n)] * hilf;
                 break;
      } 
    }
    
    n[0]++;
    for (i = 0; i < R; i++)
    {
      n[i] += uebertrag;
      if (n[i] > N[i])
      {
        n[i] = 0;
        uebertrag = 1;
      }
      else
        uebertrag = 0;
    }
  }while (uebertrag == 0);
}

ber_F()
{
  REAL prod,fak(),pwr(),mue1,beta;
  int i,j;

  for (i = 0; i < M; i++)
  {
    switch (kn_typ[i])
    {
      case 1:;
      case 5: prod = 1;
              for (j = 0; j < R; j++)
                prod *= 1/fak(n[j]) * pwr(e[IND2(i,j)],n[j]);
              break;
      case 2:;
      case 3:;
      case 4: prod = 1;
              for (j = 0; j < R; j++)
                prod *= 1/fak(n[j]) * pwr(e[IND2(i,j)]/mue[IND2(i,j)],n[j]);
              break;
    }

    switch (kn_typ[i])
    {
      case 1: beta = 1.0;
              break;
      case 5: if (i_sum(n,R) <= anz_bs[i])
                beta = fak(i_sum(n,R));
              else
                beta = fak(anz_bs[i])*pwr((REAL)anz_bs[i],i_sum(n,R)-anz_bs[i]);
              break;
    }
    switch (kn_typ[i])
    {
      case 1:;
      case 5: F[ind(i,n)] = 
                fak(i_sum(n,R)) / beta * 
                pwr(1/mue[IND2(i,0)],i_sum(n,R)) * prod;
              break;
      case 2:;
      case 4: F[ind(i,n)] = 
                fak(i_sum(n,R)) * prod;
              break;
      case 3: F[ind(i,n)] = prod;
              break;
    }
  }
  G[ind(0,n)] = F[ind(0,n)];
}

/*        Initialisierung des Verfahrens                                */

verf_init()
{
  pop_loop(n,N,0,0,0); /* F berechnen */
}

/*        Berechnungsschritt des Faltungsalgorithmus                    */

verfahren()
{
  int i,j;
  REAL hilf;

  for (i = 1; i < M; i++)
    pop_loop(n,N,1,i,0); /* G berechnen */ 

  pop_loop(n,N,5,0,0); /* G1 berechnen */ 

  for (i = 0; i < M; i++)
    for (j = 0; j < R; j++)
    {
      N[j]--;
      hilf = G[ind(M-1,N)];
      N[j]++;
      lambda[IND2(i,j)] = e[IND2(i,j)] * hilf/G[ind(M-1,N)];

      if (kn_typ[i] == 5)
        rho[IND2(i,j)] = lambda[IND2(i,j)]/(anz_bs[i] * mue[IND2(i,j)]);
      else
        rho[IND2(i,j)] = lambda[IND2(i,j)]/mue[IND2(i,j)];

      if (kn_typ[i] == 3)
      {
        k[IND2(i,j)] = lambda[IND2(i,j)]/mue[IND2(i,j)];
        t[IND2(i,j)] = 1 / mue[IND2(i,j)];
      }
      else
      {
        sum1 = 0.0;
        pop_loop(n,N,4,i,j); /* k berechnen */

        k[IND2(i,j)] = sum1;
        if (lambda[IND2(i,j)] > 0.0)
          t[IND2(i,j)] = k[IND2(i,j)] / lambda[IND2(i,j)];
        else
          t[IND2(i,j)] = 0.0;
      }
    }
}

/*        Ausgabe                                                       */

aus()
{
	/*		Sccs support from SccsLogging.c			*/	
	extern int SccsRelease;
	extern int SccsLevel;

  int i,j,kk;
  
  printf("# Verfahrensname \n");
  printf("  faltung \n");
  printf("# Version %d.%d \n\n", SccsRelease, SccsLevel);
  printf("# Speicherplatzbedarf: %d Bytes\n\n",mem);

  printf("# Netztyp Knoten Klassen \n");
  printf("  %d       %d      %d \n\n",1,M,R);

  printf("# fuer alle Klassen \n");
  printf("#    fuer alle Knoten \n");
  printf("# lambda    e         1/mue     rho       mvz       ");
  printf("maa       mwz       mwsl \n");
  for (j = 0; j < R; j++)
  {
    for (i = 0; i < M; i++)
    {
      printf(REAL_FORM,lambda[IND2(i,j)]); 
      printf(REAL_FORM,e[IND2(i,j)]); 
      printf(REAL_FORM,1/mue[IND2(i,j)]);

      if (e[IND2(i,j)] > 0.0)
      {     
        if (kn_typ[i] == 3)
        { printf("%9.5f ",0.0); }
        else
          printf(REAL_FORM,rho[IND2(i,j)]); 

        printf(REAL_FORM,t[IND2(i,j)]);
        printf(REAL_FORM,k[IND2(i,j)]);

        if (kn_typ[i] == 3)
        { printf("%9.5f %9.5f ",0.0,0.0); }
        else
        {
          printf(REAL_FORM,t[IND2(i,j)] - 1/mue[IND2(i,j)]);
          printf(REAL_FORM,lambda[IND2(i,j)] * (t[IND2(i,j)] - 
            1/mue[IND2(i,j)])); 
        }
      }
      else
        for (kk = 0; kk < 5; kk++)
          printf("%9.5f ",0.0);
      printf("\n");
    }
    printf("\n");
  }
}

/*        Ausgabe im Fehlerfall                                         */

fehler_aus()
{
  if (f_eingabe)
  { 
    fprintf(stderr,"fehlerhafte Eingabedatei \n"); 
    printf("faltung_eingabe\n0 0 0 \n");
  }

  if (f_speicher)
  { 
    fprintf(stderr,"nicht genug Speicher vorhanden \n"); 
    printf("faltung_speicher\n0 0 0 \n");
  }

  if (f_uew)
  { 
    fprintf(stderr,
            "Uebergangsw'keiten ab v0.06 nicht mehr unterstuetzt \n"); 
    printf("faltung_uew\n0 0 0 \n");
  }
}

/*        Initialisierung der Variablen                                 */

init()
{
  int i,j,kk;
  int prod;
  int MR;

  LIES("%d",M);
  LIES("%d",R);

  if ((M == 0) OR (R == 0))
  {
    fehler = TRUE;
    f_eingabe = TRUE;
    return;
  }

  MR = M * R;
  ALLOCATE(n,R,int)
  ALLOCATE(n1,R,int)
  ALLOCATE(n2,R,int)
  ALLOCATE(N,R,int)
  ALLOCATE(kn_typ,M,int)
  ALLOCATE(anz_bs,M,int)
  ALLOCATE(mue,MR,REAL)
  ALLOCATE(e,MR,REAL)
  ALLOCATE(k,MR,REAL)
  ALLOCATE(t,MR,REAL)
  ALLOCATE(rho,MR,REAL)
  ALLOCATE(lambda,MR,REAL)
  ALLOCATE(prod_v,R+1,int)

  for (i = 0; i < M; i++)
  { 
    LIES("%d",kn_typ[i]);
    if (kn_typ[i] == 5) /* M/M/k */
    { LIES("%d",anz_bs[i]); }
  }

  for (j = 0; j < R; j++)
  { LIES("%d",N[j]); }

  LIES("%d",ue_w);
  
  if (NOT ue_w)
    for (j = 0; j < R; j++)
    {
      for (i = 0; i < M; i++)
      {
        LIES(REAL_READ,mue[IND2(i,j)]);
        LIES(REAL_READ,e[IND2(i,j)]);
      }
    }
  else
  {
    fehler = TRUE;
    f_uew = TRUE;
    return;
  }

  prod_v[0] = 1;
  for (j = 0; j < R; j++)
  { prod_v[j+1] = prod_v[j] * (N[j] + 1); }

  prod = M * prod_v[R];
  ALLOCATE(F,prod,REAL)
  ALLOCATE(G,prod,REAL)
  ALLOCATE(G1,prod,REAL)

  verf_init();
}

/*        Abbildung R+1-dim Index -> 1-dim Index                        */

ind(i,n)
int i,*n;
{
  int k,sum;

  sum = 0;
  for (k = 0; k < R; k++)
  { sum += (n[k] * prod_v[k]); } 
  sum = sum * M + i;
  return(sum);
}

/*        Fakultaet                                                     */

REAL fak(x)
int x;
{
  REAL hilf;

  hilf = 1.0;

  for(; x > 0; x--)
    hilf *= (REAL)x;

  return(hilf);
}

/*        Potenz                                                        */

REAL pwr(x,a)
int a;
REAL x;
{
  if (a == 0) return (1.0);
  return (x * pwr(x,a-1));
}

/*        Integer-summe                                                 */

i_sum(a,b)
int *a,b;
{
  int s;
  
  s = 0;
  b--;
  for (; b >= 0; b--)
    s += a[b];
  return(s);
}

/*        Summenbedingung                                               */

sum_hilf()
{
  int i;

  for (i = 0; i < R; i++)
  {
    n2[i] = n[i] - n1[i];
    if (n2[i] < 0) return(0);
  }
  return (1);
}

null(n)
int *n;
{
  int i;
 
  for (i = 0; i < R; i++)
    if (n[i] != 0)
      return(FALSE);
  return(TRUE);
}

/*         Hauptprogramm                                               */

void abbruch(sig)
int sig;
{
        printf("faltung_signal_%d\n 0 0 0 \n", sig);
        exit(1);
}

main(argc, argv)
	int argc;
	char *argv[];
{
	/*		Sccs support from SccsLogging.c			*/	
	extern int SccsRelease;
	extern int SccsLevel;

  {
        int i;
        void abbruch();

        for (i=1; i<12; i++)
                signal (i, abbruch);
  }
	if ((argc > 1) && (!strcmp(argv[1], "-V")))    /* kirschni 22.11.1991 */
	{
		fprintf(stdout, "%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
		exit(0);
	}


  init();
  if (NOT fehler)
    verfahren();
  if (NOT fehler)
  {
    aus();
    exit(0);
  }
  else
  {
    fehler_aus();
    exit(1);
  }
}

