/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\teinlesen.c\t1.2\t93/05/19 15:10:32";

#include "gdaten.h"
#include "math.h"
#include <stdio.h>

double helplambda;

einlesen(fp)
FILE *fp;
{
	int i,j;
	double help;
	fscanf(fp,"%d",&N);

#	ifdef DEBUG
	printf("N = %d\n",N);
#	endif

	speich_beleg(N);

	fscanf(fp,"%lg", &help);
	helplambda = help;

	for(i=1;i<=N;i++)
	{
		fscanf(fp,"%lg",& c0[i]);
		c0[i] = sqrt(c0[i]);
#		ifdef DEBUG
		printf("c0[%d] = %lg ",i,c0[i]); 
#		endif
	}	
#	ifdef DEBUG
	printf("\n");
#	endif

	
	for(i=1;i<=N;i++)
	{
		fscanf(fp,"%lg",& my_R[i]);
#		ifdef DEBUG
		printf("my_R[%d] = %lg ",i,my_R[i]); 
#		endif
	}
#	ifdef DEBUG
	printf("\n");
#	endif
	
	for(i=1;i<=N;i++)
	{
		fscanf(fp,"%lg",&cB_R[i]);
		cB_R[i] = sqrt(cB_R[i]);
#		ifdef DEBUG
		printf("cB_R[%d] = %lg ",i,cB_R[i]); 
#		endif
	}
#	ifdef DEBUG
	printf("\n");
#	endif

	for(j=0;j<=N;j++)
	{
		fscanf(fp,"%lg",&p_R[0][j]);
		if(p_R[0][j] == 0.0 ) c0[j] = 0.0;
#		ifdef DEBUG
		printf("p_R[%d][%d] = %lg ",0,j,p_R[0][j]); 
#		endif
	}
	for(i=1;i<=N;i++)
	{
		for(j=0;j<=N;j++)
		{
			fscanf(fp,"%lg",&p_R[i][j]);
#			ifdef DEBUG
			printf("p_R[%d][%d] = %lg ",i,j,p_R[i][j]); 
#			endif
		}
		lambda0[i] = help * p_R[0][i];
#		ifdef DEBUG
		printf("lamda0 = %g\n",lambda0[i]);
#		endif
	}
	fscanf(fp,"%lg",& epsilon);
#	ifdef DEBUG
	printf("epsilon = %lg ",epsilon); 
#	endif
}



speich_beleg(knoten)
int knoten;
{
	int s;
	int size;
	int k;


	s=knoten +1;
	size = sizeof(double);


	lambda0		= (double *)calloc(s,size);
	c0		= (double *)calloc(s,size);
	my_R		= (double *)calloc(s,size);
	cB_R		= (double *)calloc(s,size);
	lambda_R	= (double *)calloc(s,size);
	rho_R		= (double *)calloc(s,size);
	my		= (double *)calloc(s,size);
	cB_q		= (double *)calloc(s,size);
	lambda		= (double *)calloc(s,size);
	rho		= (double *)calloc(s,size);
	cA_q		= (double *)calloc(s,size);
	cD_q		= (double *)calloc(s,size);
	g		= (double *)calloc(s,size);


	size =sizeof(double*);

	p_R		= (double**)calloc(s,size);
	p		= (double**)calloc(s,size);
	c		= (double**)calloc(s,size);
	c_neu		= (double**)calloc(s,size);
	c_alt		= (double**)calloc(s,size);
	c_delta		= (double**)calloc(s,size);


	size = sizeof(double);

	for(k=0;k<=knoten;k++)
	{
		p_R[k]		=(double*)calloc(s,size);
		p[k]		=(double*)calloc(s,size);
		c[k]		=(double*)calloc(s,size);
		c_neu[k]	=(double*)calloc(s,size);
		c_alt[k]	=(double*)calloc(s,size);
		c_delta[k]	=(double*)calloc(s,size);
	}
}
