/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tgauss.c\t1.2\t92/03/27 11:47:58";

#include <stdio.h>

/*  Gauss'scher Algorithmus zum loesen eines linearen Gleichungssystems
    mit Spaltenpivotsuche
    die uebergebene Matrix wird durch den Algorithmus zerstoert
*/

#define ERROR(a,b)	fprintf(stderr,a,b);

gauss(A,x,b,dim,eps)   /*  loesen von A*x = b    */
int dim;
double eps;
double x[], b[];
double **A;
{
	int index, andex, ondex, pivot;
	double help1, help2, help3, help4, help5;

	/* jetzt geht's los
	   herbeischaffen der Dreiecksform
	*/

	for(index=0;index<dim;index++)
	{
		/* bestimme Pivot_Element */

		help1 = 0.0;
		pivot = index;

		for(andex=index;andex<dim;andex++)
		{
			help2 = A[andex][index];

			if(help2<0.0)
				help2 *= -1.0;

			if(help2>help1)
			{
				pivot= andex;
				help1=help2;
			}
		}

		if(help1<eps)
		{
			ERROR("Matrix singulaer\n"," ");
			ERROR("Epsilon = %g\n",eps);
			return(-1);
		}
		
		/* vertauschen der Zeilen 'pivot' und 'index' */

		for(andex=index;andex<dim;andex++)
		{
			help3 = A[pivot][andex];
			A[pivot][andex]=A[index][andex];
			A[index][andex]=help3;
		}
		help3 = b[pivot];
		b[pivot]=b[index];
		b[index]=help3;

		/* elementarer Berechnungsschritt */

		help4=A[index][index];

		for(andex=index+1;andex<dim;andex++)
		{
			/* Multiplikator */

			help5=A[andex][index]/help4;
			for(ondex=index;ondex<dim;ondex++)
				A[andex][ondex] -= help5*A[index][ondex];
			b[andex] -= help5*b[index];
		}
	}

	/* jetzt sollte die Matrix Dreiecksform haben */

	/* Rueckwaertsaufloesung */

	x[dim-1] = b[dim-1]/A[dim-1][dim-1];
	for(andex=dim-2;andex>=0;andex--)
	{
		x[andex]=b[andex];
		for(ondex=andex+1;ondex<dim;ondex++)
			x[andex] -= A[andex][ondex]*x[ondex];
		x[andex] /= A[andex][andex];
	}

	/* jetzt sollte in x die Loesung stehen */

}
