/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tkuehn.c\t1.4\t93/05/19 15:19:02";

#define MAIN
#include "gdaten.h"
#include <stdio.h>

void abbruch(sig)
int sig;
{
        printf("kuehn_signal_%d\n 0 0 0 \n", sig);
        exit(1);
}

main(argc,argv)
	int	argc;
	char 	**argv;
/*	
	Einlesen der daten und berechnung des KUEHN-Verfahrens
*/
{
	/*		Sccs support from SccsLogging.c			*/	
	extern int SccsRelease;
	extern int SccsLevel;

	int i;
	void abbruch();

	for (i=1; i<12; i++)
			signal (i, abbruch);

	if ((argc > 1) && (!strcmp(argv[1], "-V")))    /* kirschni 22.11.1991 */
	{
		fprintf(stdout, "%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
		exit(0);
	}


	/*
		FILE *fp;
		if((fp =fopen(*++argv,"r"))==NULL)
			{
			perror("Eingabedatei lesen");
			printf("kuehn_versagt\n 0 0 0\n");
			exit(1);
			}
		einlesen(fp);
		fclose(fp);
	*/

	einlesen(stdin);
	kuehn();
	exit(0);
}

kuehn()
{
	int i,
		j,
		vergleich;


	schritt1();
	schritt2();
	schritt3();
	schritt4();

	for(i=1;i<=N;i++)
	{
		for(j=1;j<=N;j++)
		{
			c_neu[i][j] = c[i][j];
		}
	}

	vergleich = 0;

	for( iteration = 1;vergleich==0;iteration++)
	{
#		ifdef DEBUG
			printf("\n");
			printf("%d-te iteration**************************\n\n",iteration);
			printf("\n");
			printf("vark.der %d-ten iteration:\n",(iteration - 1));
#		endif

		for(i=1;i<=N;i++)
      	{
			for(j=1;j<=N;j++)
			{
				c_alt[i][j] = c_neu[i][j];
#				ifdef DEBUG
					printf("%lg  ",c_alt[i][j]);
#				endif
			}

#			ifdef DEBUG
		         printf("\n");
#			endif
		}

	
	        	
		for(knoten =1;knoten<=N;knoten++)
		{
#			ifdef DEBUG
				printf("\n");
				printf("knoten %d++++++++++++++++++++++++\n\n",knoten);
#			endif
			schritt5();
			schritt6();
			schritt7();
		}

#		ifdef DEBUG
			printf("\n");
			printf("vark.der %d-ten iteration:\n",iteration);
#		endif

		for(i=1;i<=N;i++)
		{
			for(j=1;j<=N;j++)
			{
				c_neu[i][j] = c[i][j];
#				ifdef DEBUG
					printf("%lg  ",c_neu[i][j]);
#				endif
			}
#			ifdef DEBUG
		   		printf("\n");
#			endif
		}
	
		vergleich = schritt8();
	}

	schritt9();
}
