/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tschritt1.c\t1.2\t93/05/19 15:10:16";

#include "gdaten.h"

schritt1()
/*bestimmung der ankunftsraten bei den einzelnen knoten
 *und ueberpruefung der stabilitaetsbedingung fuer alle knoten; */
{
	int i,j;
	double **matrix1;
#	ifdef DEBUG
	printf("\n\n");
	printf("schritt1\n");
#	endif
	matrix1 = (double **)calloc(N,sizeof(double *));
	for(i=0;i<N;i++)
		matrix1[i] = (double *)calloc(N,sizeof(double));


	/*nur die elemente mit i,j >=1 der matrix p_R (transponiert)sind
	 *interessant fuer die berechnung mit gauss */
	for (i=0;i<N;i++)
	{
		for(j=0;j<N;j++)
		{
			matrix1[i][j] =p_R[j+1][i+1];
#			ifdef DEBUG
			printf("%lg     ",matrix1[i][j]);
#			endif
		}
#		ifdef DEBUG
		printf("\n");
#		endif
		lambda0[i]=lambda0[i+1];
	}


	/*berechnung der lambda_R aus p_R und den lambda0 */

	karl(N,matrix1,lambda0,lambda_R);

	/*lambda_R werden wieder umberechnet */
	for(i=N; i>0; i--)
	{
		lambda_R[i]=lambda_R[i-1];
		lambda0[i]=lambda0[i-1];
	}
	
#	ifdef DEBUG
	printf("ergebnis:\n");
	for (i=1;i<=N;i++)
		printf("lambda_R[%d]=%lg\n",i,lambda_R[i]);
#	endif


	/*ueberpruefung der stabilitaetsbedingung */
	for(i=1;i<=N;i++)
	{
		rho_R[i] = lambda_R[i] / my_R[i];
		if(rho_R[i] >=1)
		{
			printf("kuehn_instabil\n 0 0 0\n");
			exit(1);
		}

	}

#	ifdef DEBUG
	printf("stabilitaetsbedingung ist erfuellt:alle rho 's sind< 1\n");
	for (i=1;i<=N;i++)
		printf("rho_R[%d] = %lg\n",i,rho_R[i]);
#	endif

} 
