/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tschritt3.c\t1.2\t93/05/19 15:10:19";

#include "gdaten.h"

schritt3()
{
	int i,j;
	double **matrix2;
#	ifdef DEBUG
	printf("\n\n");
	printf("schritt3\n");
#	endif

	matrix2 = (double **)calloc(N,sizeof(double*));
	for (i=0;i<N;i++)
		matrix2[i] = (double*)calloc(N,sizeof(double));

	/*berechnung der matrix bzw der lambda0 fuer gauss */
	for(i=0;i<N;i++)
	{
		for(j=0;j<N;j++)
		{
			matrix2[i][j] = p[j+1][i+1];
		}
		lambda0[i] = lambda0[i+1];
	} 


	/*berechnung der lambda aus p und den lambda0 */
	karl(N,matrix2,lambda0,lambda);
	for(i=N;i>0;i--)
	{
		lambda[i] =lambda[i-1];
		lambda0[i] =lambda0[i-1];
	}		
#	ifdef DEBUG
	printf("ergebnis:\n");
	for(i=1;i<=N;i++)
		printf("lambda[%d]=%lg\n",i,lambda[i]);
#	endif

	/*berechnung von rho aus lambda und my */
	for(i=1;i<=N;i++)
	{
		rho[i] = lambda[i] /my[i];
#	ifdef DEBUG
		printf("rho[%d] =%lg\n",i,rho[i]);
#	endif
	}
}
