/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tschritt6.c\t1.2\t93/05/19 15:10:25";

#include "gdaten.h"
#include <math.h>
/*ermittlung des varkoeff cD[i] des abgangsprozesses aus den varkoeff
 *des ankunftsprozesses cA[i] und des bedienprozesses cB[i] */

schritt6()
{
#	ifdef DEBUG
	printf("\n");
	printf("schritt6\n");
#	endif

	if ( sqrt (cA_q[knoten]) <1)
	     {
#			ifdef DEBUG
		     printf("cA_q < 1\n");
#			endif
             g[knoten] = exp( -2 * (1-rho[knoten])
	             * (1-cA_q[knoten])*(1-cA_q[knoten])
	             *(1/( 3*rho[knoten]*(cA_q[knoten]+cB_q[knoten]))));
	     }
	else
		{
#		ifdef DEBUG
		printf("cA_q >=1\n");
#		endif
		g[knoten] = exp( -(1 -rho[knoten]) * (cA_q[knoten] - 1)
		       *(1/(cA_q[knoten] + (4 * cB_q[knoten]))) );
		}

	cD_q[knoten] = cA_q[knoten]
		       + (2 * rho[knoten] *rho[knoten] *cB_q[knoten])
		       - ((rho[knoten] *rho[knoten]
			   *(cA_q[knoten] +cB_q[knoten]) ) * g[knoten]);

#	ifdef DEBUG
	printf("ergebnis:\n");
	printf("g[%d] = %lg\n",knoten,g[knoten]);
	printf("cD_q[%d] = %lg \n",knoten,cD_q[knoten]);
#	endif
}
