/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tschritt9.c\t1.2\t93/05/19 15:10:30";

#include "gdaten.h"
extern double helplambda;

schritt9()
/*bestimmung der leistungsgroessen */
{
	int i;
	double *wq,		/*wartezeit */
	       *tq,		/*verweilzeit */
	       *kq;		/*anzahl auftraege im system */

	wq = (double *)calloc(N+1,sizeof(double));
	tq = (double *)calloc(N+1,sizeof(double));
	kq = (double *)calloc(N+1,sizeof(double));

	for(i=1;i<=N;i++)
		wq[i] = (1/my_R[i]) * (rho[i]/(2 *(1-rho[i])))
			*(cA_q[i] +cB_q[i]) * g[i] ;
	
	for(i=1;i<=N;i++)
	{
		tq[i] =wq[i] + 1/my_R[i] ;
		kq[i] =lambda_R[i] * tq[i] ;
	}

#	ifdef DEBUG
	printf("ergebnis des KUEHN - VERFAHRENS fuer allg. offene warteschlangennetze\n\n");
	printf("wq: Wartezeit, tq: Verweilzeit, kq: Anzahl Auftraege \n\n");
	for (i=1;i<=N;i++)
		printf("cA_q[%d] = %lg \n",i,cA_q[i]);
#	endif
	printf("kuehn\n\n%d %d %d\n\n",2,N,1);
	printf("# lambda   e    1/mue   rho    mvz   maa    mwz   mwsl\n\n");
	for (i=1;i<=N;i++)
		printf("%6.4g %6.4g %6.4g %6.4g %6.4g %6.4g %6.4g %6.4g \n",
			lambda_R[i], lambda_R[i] / helplambda, 1.0/my_R[i], rho[i],
			tq[i],kq[i],wq[i],wq[i]*lambda_R[i]);
	printf("\n\n");
	printf("Variationskoeffizienten der Ankunftsprozesse\n");
	for (i=1;i<=N;i++)
		printf("Knoten %d   %f\n",i,cA_q[i]);
			
}
