/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tausgabe.c\t1.2\t92/03/27 11:48:34";

#include <stdio.h>
#include "d_mnetz.h"
#include "d_mleist.h"

/***********************************************************

  FUNKTION
  ausgabe()

  Wird aufgerufen in:
  - HAUPTPROGRAMM
    MARIE		gespeichert auf File  "marie.c"

 Schreibt die berechneten Leistungsgroessen auf stdout 

***********************************************************/

ausgabe()
{
 extern netzstruktur 	netz;
 extern leiststruktur	leist;

 int	i;
 double help;

 /* Kopf ausgeben */

 fprintf(stdout,"  marie\n\n");
 fprintf(stdout,"  1  ");		/* geschlossenes Netz	*/
 fprintf(stdout,"  %d  ",netz.knot);	/* Anzahl Knoten	*/
 fprintf(stdout,"  %d  \n\n",1);	/* Anzahl Klassen	*/

 /* Ausgabe der Leistungsgroessen */

 for ( i=0; i<netz.knot; i++ )
 {
      	fprintf(stdout,"%8.4f  ",leist.lambda[i]);
      	fprintf(stdout,"%8.4f  ",netz.besh[i]);
      	fprintf(stdout,"%8.4f  ",1/netz.bedr[i]);
      	fprintf(stdout,"%8.4f  ",leist.rho[i]);
      	fprintf(stdout,"%8.4f  ",leist.vzeit[i]);
      	fprintf(stdout,"%8.4f  ",leist.fuell[i]);
	/* Mittlere Wartezeit */
      	fprintf(stdout,"%8.4f  ",help = leist.vzeit[i]-(1/netz.bedr[i]));
	/* Mittlere Warteschlangenlaenge */
      	fprintf(stdout,"%8.4f  ",leist.lambda[i] * help);
     	fprintf(stdout,"\n");
 }
 fprintf(stdout,"\n");

} /* Ende ausgabe */
