/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\teingabe.c\t1.2\t92/03/27 11:48:36";

#include <stdio.h>
#include "d_mnetz.h"
#include "xxalloc.h"

/***********************************************************

  FUNKTION
  eingabe()

  Wird aufgerufen in:
  - HAUPTPROGRAMM
    MARIE	gespeichert auf File  "marie.c"

Die Funktion liest die Eingabedaten von "stdin" 

***********************************************************/

eingabe()
{
    extern	netzstruktur netz;	/* Die Netzgroessen		*/
					/* siehe "d_mnetz.h"		*/

    int		i,j;			/* Laufvariablen		*/
    int		dbg=0;

    /* Netztyp */
    fscanf(stdin,"%*d");

    /* Knoten */
    fscanf(stdin,"%d",&netz.knot);
if (dbg) fprintf(stderr,"netz.knot = %d\n",netz.knot);

    netz.bede = i1_alloc(0,netz.knot-1);
    netz.bedr = d1_alloc(0,netz.knot-1);
    netz.besh = d1_alloc(0,netz.knot-1);
    netz.quvari = d1_alloc(0,netz.knot-1);
    netz.bedstr = i1_alloc(0,netz.knot-1);
    netz.belz = i1_alloc(0,netz.knot-1);

    /* Klassen */
    fscanf(stdin,"%*d");

    /* Anzahl Auftraege */
    fscanf(stdin,"%d",&netz.auftr);
if (dbg) fprintf(stderr,"auftraege = %d\n",netz.auftr);

    /* Bedieneinheiten pro Knoten */
    for ( i=0; i<netz.knot; i++ )
    {
        fscanf(stdin,"%d",&netz.bede[i]);
if (dbg) fprintf(stderr,"Bede = %d\n",netz.bede[i]);
    }

    /* Bedienraten */
    for ( i=0; i<netz.knot; i++ )
    {
        fscanf(stdin,"%lf",&netz.bedr[i]);
if (dbg) fprintf(stderr,"Bedr = %lf\n",netz.bedr[i]);
    }

    /* Besuchshaeufigkeiten o. Uebergangswahrscheinlichkeiten */
    fscanf(stdin,"%d",&netz.haeuf);

    if ( netz.haeuf==1 )  /* Uebergangswahrscheinlichkeiten */
    {
	fprintf(stderr, "Uebergangsw'keiten nicht mehr unterstuetzt\n");
	printf("marie_uebergaenge\n 0 0 0\n");
	exit(1);
    }
    else     /* Besuchshaeufigkeiten */
    {
      	for ( i=0; i<netz.knot; i++ )
	{
            fscanf(stdin,"%lf",&netz.besh[i]);
if (dbg) fprintf(stderr,"E = %lf\n",netz.besh[i]);
	}
    }

    /* Quadr. Variationskoeffizienten */
    for ( i=0; i<netz.knot; i++ )
    {
        fscanf(stdin,"%lf",&netz.quvari[i]);
if (dbg) fprintf(stderr,"Quvakoef = %lf\n",netz.quvari[i]);
    }

    /* Bedienstrategien */
    for ( i=0; i<netz.knot; i++ )
    {
        fscanf(stdin,"%d",&netz.bedstr[i]);
if (dbg) fprintf(stderr,"Bstratg = %d\n",netz.bedstr[i]);
    }

    /* Belegung */
    for ( i=0; i<netz.knot; i++ )
    {
        fscanf(stdin,"%d",&netz.belz[i]);
if (dbg) fprintf(stderr,"Beleg = %d\n",netz.belz[i]);
    }

    /* Epsilon */
    fscanf(stdin,"%lf",&netz.epsi);
if (dbg) fprintf(stderr,"epsilon = %lf\n",netz.epsi);

} /* Ende eingabe */
