/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tmem_ein.c\t1.2\t92/03/27 11:49:02";

/* ********************************************************************
**                                                                   **
**                       Include Dateien                             **
**                                                                   **
******************************************************************** */

#include <stdio.h>
#include "mem_netz.h"
#include "mem_def.h"

/* ********************************************************************
**                                                                   **
**                       eingabe                                     **
**                 aufgerufen von : main()                           **
**                                                                   **
******************************************************************** */

eingabe(eingabedatei)
FILE *eingabedatei;
{
	int    i,j,r;          /* Zaehlvariablen i,j : Knoten r: Klasse      */
	double sum;            /* Hilfsvariable */

	extern int auftrag;        /* Gesamtanzahl der Auftraege in einem
			               geschlossenen Netz */
	extern int sp_eingabe();   /* belegt Speicherplatz fuer die 
				       einzulesenden Groessen */



/* ********************************************************************
**                           EINGABE                                 **
******************************************************************** */

	fscanf(eingabedatei,"%d ",&netz.typ);
	if (!((netz.typ == OFFEN)||(netz.typ == GESCHLOSSEN)))
	{
		fprintf(stderr,"MAXEN:EINGABE: Netztyp unbekannt\n");
		printf("mem_netztyp\n 0 0 0\n");
		exit(1);
	}
	/* Netzart    2 : offen  1 : geschlossen */

	fscanf(eingabedatei,"%d ",&netz.knoten);
	if (netz.knoten == 0)
	{
		fprintf(stderr,"MAXEN:EINGABE: Zahl der Knoten 0 ");
		printf("mem_kn_zahl\n 0 0 0\n");
		exit(1);
	}

	/* Anzahl der Knoten */

	fscanf(eingabedatei,"%d ",&netz.klasse);
	if (netz.klasse == 0)
	{
		fprintf(stderr,"MAXEN:EINGABE: Zahl der Klassen 0 ");
		printf("mem_kl_zahl\n 0 0 0\n");
		exit(1);
	}

	/* Anzahl der verschiedenen Klassen 
			       im System */

	sp_eingabe();
	/* Speicherbelegung */

	if (netz.typ == GESCHLOSSEN)
	{
		for(r=0;r<netz.klasse;r++)
		{
			fscanf(eingabedatei,"%d ",&netz.auftrag[r]);
			if (netz.auftrag[r] == 0)
			{
				fprintf(stderr,"MAXEN:EINGABE: Zahl der Auftraege 0 ");
				printf("mem_auftr_zahl\n 0 0 0\n");
				exit(1);
			}
			/* Anzahl der Auftraege im System */
		} /* ENDE for(r) */

		auftrag = 0;
		for(r=0;r<netz.klasse;r++)
			auftrag += netz.auftrag[r];
		if (netz.klasse > auftrag)
		{
			fprintf(stderr,"MAXENT:EINGABE       \n");
			fprintf(stderr,"       mehr Klassen als Auftraege \n");
			printf("mem_auftr_kl\n 0 0 0\n");
			exit(1);
		}

		/* Berechnung der Auftraege im System, 
			    keine Unterscheidung bzgl. Klassen */

	} /* ENDE netz.typ = GESCHLOSSEN */
	else
	{ /* netz.typ = OFFEN */

		for(r=0;r<netz.klasse;r++)
			for(i=0;i<netz.knoten;i++)
				fscanf(eingabedatei,"%lf ",&netz.e_ankunftsrate[r][i]);

		/* Ankunftsrate pro Klasse von aussen */

		for(r=0;r<netz.klasse;r++)
			for(i=0;i<netz.knoten;i++)
				fscanf(eingabedatei,"%lf ",&netz.e_a_quadvar[r][i]);

		/* quadrierter Variationskoeffizient pro Klasse
			     und Knoten des auesseren Ankunftsprozesses */
	} /* ENDE else */

	/* Netz offen : 
			      zusaetzliche Groessen muessen angegeben
                              werden
                                 - Ankunftsrate von aussen der Klasse r
                                 - aeusserer quadrierter Variations-
				   koeffizient der Klasse r  */

	for(r=0;r<netz.klasse;r++)
		for(i=0;i<netz.knoten;i++)
			fscanf(eingabedatei,"%lf ",&netz.bedienrate[r][i]);

	/* Bedienrate der Bedienzeitverteilung 
                                          pro Knoten und Klasse */

	for(r=0;r<netz.klasse;r++)
		for(i=0;i<netz.knoten;i++)
			fscanf(eingabedatei,"%lf ",&netz.s_quadvar[r][i]);

	/* quadrierter Variationskoeffizient
                               der Bedienzeitverteilung pro Knoten 
			       und Klasse */

	for(r=0;r<netz.klasse;r++)
		for(i=0;i<netz.knoten;i++)
			for(j=0;j<netz.knoten;j++)
				fscanf(eingabedatei,"%lf ",&netz.uebwkt[r][i][j]);

	/* Uebergangswahrscheinlichkeiten von
			       Knoten -> Knoten pro Klasse */
	for(i=0;i<netz.knoten;i++)
		for(r=0;r<netz.klasse;r++)
		{
			if (netz.uebwkt[r][i][i] == 1.0)
			{
				fprintf(stderr,"MAXENT:EINGABE : Aufraege der Klasse %d ",r+1);
				fprintf(stderr,"koennen den Knoten %d nicht verlassen\n",i+1);
				printf("mem_kn_verl\n 0 0 0\n");
				exit(1);
			}
			if (netz.typ == GESCHLOSSEN)
			{
				if (netz.bedienrate[r][i] > 0.0)
				{
					sum = 0;
					for(j=0;j<netz.knoten;j++)
						sum += netz.uebwkt[r][i][j];
					if (abs(sum -1) > SUMTOLERANZ)
					{
						fprintf(stderr,"MAXENT:EINGABE : Summe der ");
						fprintf(stderr,"Wahrscheinlichkeiten ungleich 1 (klasse %d, Knoten %d (%lg)\n",r,i,sum);
						printf("mem_uew\n 0 0 0\n");
						exit(1);
					}
				} /* ENDE if(bedienrate) */
			} /* ENDE if(netztyp) */
		} /* ENDE for(r-i) */
	/* Test ob die eingelesenen Uebergangs-
					 wahrscheinlichkeiten plausibel sind */
	
	/* Nachlauf: Uebernahme der von aussen schon gegebenen Besuchshaeufigkeiten */
	for(r=0;r<netz.klasse;r++)
		for(i=0;i<netz.knoten;i++)
		{
			fscanf(eingabedatei,"%lf ",&netz.bsh[r][i]);
		}

} /* ENDE eingabe */
