/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tmem_main.c\t1.4\t93/05/19 15:23:50";

#define MAIN

/* ********************************************************************
**                                                                   **
**                  Include Dateien                                  **
**                                                                   **
******************************************************************** */

#include <stdio.h>
#include "mem_var.h"          /* enthaelt alle Variablen */
#include "mem_netz.h"         /* Netzstruktur */
#include "mem_def.h"          /* zusaetzliche Definitionen */

void abbruch(sig)
int sig;
{
        printf("mem_signal_%d\n 0 0 0 \n", sig);
        exit(1);
}

/* ***************************************************************
**                                                              **
**                          Hauptprogramm                       **
**                                                              **
*************************************************************** */

main(argc,argv)
int argc;
char *argv[];
{
	/*		Sccs support from SccsLogging.c			*/	
	extern int SccsRelease;
	extern int SccsLevel;

	extern int eingabe();          /* Eingabe: liest benoetigte Werte ein */
	extern int offen_netz();       /* Analyse eines offenen Netzes        */
	extern int geschl_netz();      /* Analyse eines geschlossenen Netzes  */
	extern int ausgabe();          /* Ausgabe                             */

	int	 i;
	int  typ;                 /* Hilfsvariable */
	FILE *fp;                 /* Filedeskriptor */

	void abbruch();

	for (i=1; i<12; i++)
			signal (i, abbruch);

	if ((argc > 1) && (!strcmp(argv[1], "-V")))    /* kirschni 22.11.1991 */
	{
		fprintf(stdout, "%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
		exit(0);
	}


	/* ********************************************************
    **                                                       **
    **                  Einlesen der Netzdaten               **
    **                                                       **
    ******************************************************** */

	if (argc == 1)                 /* ohne Argumente */
		eingabe(stdin);
	else /* maximal eine Datei zugelassen */
	{
		argc--;
		if (argc > 1)
		{
			fprintf(stderr,"MEM: too much files\n");
			fprintf(stderr,"USAGE :  <entropie> [inputfile] \n");
			printf("mem_aufruf\n 0 0 0\n");
			exit(1);
		}
		else
		{
			if (( fp = fopen(*++argv,"r")) == NULL)
			{
				fprintf(stderr,"MEM: can`t open %s\n",*argv);
				printf("mem_file\n 0 0 0\n");
				exit(1);
			}
			else
				eingabe(fp);
			fclose(fp);
		}
	} /* ENDE else */

	/* ********************************************************************
   **                                                                   **
   **                         Analyse des Netzes                        **
   **                                                                   **
   ******************************************************************** */

	typ = netz.typ;        /* Ermittle Netztyp (1 : OFFEN 2: GESCHLOSSEN) */

	switch(typ) {
	case OFFEN       :     /* offenes Netz wird analysiert */

		offen_netz();
		break;

	case GESCHLOSSEN :     /* geschlossenes Netz wird analysiert */

		geschl_netz();
		break;

	default :             /* Fehlermeldung, Netztyp unbekannt */

		fprintf(stderr,FALSCHES_NETZ);
		break;

	} /* ENDE switch */

	/* Analysiere offene und geschlossene Netze und
			    berechne Auslastung Durchsatz und mittlere
			    Anzahl von Auftraegen in den einzelnen Knoten */

	/* *********************************************************************
   **                                                                    **
   **                        Ausgabe                                     **
   **                                                                    **
   ********************************************************************* */

	ausgabe();
	/* Gib Ergebnis aus */
	exit(0);
} /* ENDE main */
