/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsMemnetz_h = "@(#)PEPSY:\tmem_netz.h\t1.3\t93/05/19 15:23:53";

#ifdef MAIN
#define EXTERN
#else
#define EXTERN extern
#endif

/**************************************************************
**                                                           **
**                    Netzstruktur                           **
**                                                           **
************************************************************ */

EXTERN struct netzstruktur {
            int      typ;             /* Netztyp */
            int      knoten;          /* Anzahl Knoten */
            int      *auftrag;        /* Anzahl Auftraege pro Klasse
				         in einem geschlossenem Netz
				         zur Zeit nur eine KLasse 
				         moeglich */
            int      klasse;          /* Anzahl Klassen */
            double   ***uebwkt;       /* Uebergangswahrscheinlichkeit
					  fuer alle Klassen
					       Knoten --> Knoten */
            double   **ankunftsrate;  /* Ankunftsrate pro KLasse 
					 und Knoten */
            double   **e_ankunftsrate;  /* Ankunftsrate pro Klasse */
	    double   **bsh;           /* Besuchshaeufigkeit */
            double   **bedienrate;    /* Bedienrate pro Klasse und 
					 Knoten */
            double   **altankunftsrate; /* alter Wert der Ankunftsrate  pro Klasse 
					 und Knoten */
            double   **altbedienrate; /* alter Wert der Bedienrate pro Klasse 
					 und Knoten */
            double   **auslastung;    /* Auslastung ... */
            double   **anzauftrag;    /* mittlere Anzahl von Auftraegen
					 pro Klasse und Knoten */
            double   **verweilzeit;   /* Verweilzeit ... */
            double   **wartezeit;     /* Wartezeit in Schlange */
            double   **warteschlange; /* mittlere Warteschlangen-
					 laenge ... */
            double   **s_quadvar;     /* quadr. Variationskoeffizient
					 des Bedienprozesses 
					 pro Klasse und Knoten */
            double   **a_quadvar;     /* quadr. Variationskoeffizient
					 des Ankunftsprozesses 
					 pro Klasse und Knoten */
            double   **e_a_quadvar;   /* quadr. Variationskoeffizient
					 des externen Ankunftsprozesses 
					 pro Klasse und Knoten */
            double   **d_quadvar;     /* quadr. Variationskoeffizient
					 des Abgangsprozesses 
					 pro Klasse und Knoten */
            } netz;
