/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsMemvar_h = "@(#)PEPSY:\tmem_var.h\t1.2\t92/03/27 11:49:10";

/* *************************************************************
**                                                            **
**                enthaelt alle globalen Variablen            **
**                                                            **
************************************************************* */

/* **************    Filedeskriptoren        **************** */

FILE   *ausgabedatei;        /* Filedeskriptor fuer Ausgabe-
		                datei */

/* **************    INTEGER  VARIABLEN      **************** */

int    auftrag;              /* Anzahl der Auftraege im Netz */
int    bottle;               /* Nummer des Knotens mit der groessten
				Auslastung ==>>
				Flaschenhals */
int    feed=0;               /* Boolean, zeigt an,ob Ruuecklaufkorrektur
				stattgefunden hat, vorbesetzt mit False */

/* **************    DOUBLE VARIABLEN        **************** */

double e_a_quadvar;          /* quadr. Gesamtvariationskoeffizient
				aller externen Ankunftsprozesse */
double e_ges_ankunft;        /* Gesamtankunftsrate bei einem
				offenem Netz, Summe ueber alle
				Klassen */
double lambdarb;             /* lambda_R^b */

/* **************    DOUBLE Vektoren         **************** */

double *ankunftsrate;        /* Ankunftsrate pro Knoten */
double *bedienrate;          /* Bedienrate pro Knoten */
double *auslastung;          /* Auslastung des Knotens i */
double *mul;                 /* Auslastung des Knotens i in einem
				Pseudo-offenem Netz, abhaengig von
				_mulkonst */
double *mulkonst;            /* multiplikative Konstanten pro Klasse */
double *anzauftrag;          /* Anzahl der Auftraege im Knoten i */
double *x_lagrange;          /* Lagrange Multiplikator */
double *g_lagrange;          /* Lagrange Multiplikator */
double *s_quadvar;           /* quadr. Variationskoeffizient des
				Bedienprozessses */
double *a_quadvar;           /* quadr. Variationskoeffizient des
				Ankunftsprozesses */
double *d_quadvar;           /* quadr. Variationskoeffizient des 
				Abgangsprozesses */
double *normkonst;           /* Normalisierungskonstante */
double *hilfvek;             /* Hilfsvektor zur Bestimmung der 
				Normalisierungskonstanten */
double *f;                   /* Hilfsvektor zur Bestimmung der
				Normalisierungskonstanten */
double *bvek;                /* Rechte Seite eines inhomogenen
			        Gleichungssystems */
double *fvek;                /* Vektor der Summen der mittleren
				Auftragszahl im System pro Klasse */
		             /* rechte Seite des Gleichungssystems
			        J _mvek = _fvek */
	                     /* wobei J Jacobimatrix 
			        _mvek Loesungsvektor */
double *mvek;                /* enthaelt Loesung des Gleichungssystems
                                J _mvek = _fvek */
double *e_ankunftsrate;      /* Externe Ankunftsrate pro Klasse */
double *e_z_ankunft;         /* Zwischenankunftsrate
				 0 --> Knoten */
double *e_besuch;            /* Wahrscheinlichkeit, dass ein von 
				aussen eintreffender Auftrag zur 
				Klasse c gehoert */
double *e_d_quadvar;         /* quadr.  Variationskoeffizient
                                der externen Ankunftsprozesse
				pro Klasse */
double *e_ueb;               /* Uebergangswahrscheinlichkeit
				 0 --> Knoten */

double *sigmacs;             /* sigma_cs */
double *taucs;               /* tau_cs */

/* **************    DOUBLE FELDER        **************** */

double **besuch;             /* Wahrscheinlickeit, dass ein in Knoten i
				eintreffender Auftrag der Klasse r 
				angehoert */
double **z_ankunft;          /* Zwischenankunftsrate
				  Knoten --> Knoten */
double **uebwkt;             /* Uebergangsmatrix
				  Knoten --> Knoten */
double **wa;                 /* Hilfsmatrix, verhindert, dass
				Uebergangsmatrix _uebwkt veraendert
				wird */
double **jacobi;             /* Jacobi Matrix
			        Dimension :
				   Anzahl Klassen X Anzahl Klassen */
double **pocs;               /* Wahrscheinlichkeit p_cs(0) dafuer,
				dass kein Aufrag der Klasse c sich im,
				Knoten s befindet */
