/* memory.c

   Alle notwendigen Funktionen fuer die dynamische Speicherplatz-
   verwaltung.
*/

static char *SccsId = "@(#)PEPSY:\tmemory.c\t1.5\t94/09/08 17:12:57";

#include "summa.h"

extern FILE   *fd;
extern int    *typ,
*m,
*auftrag,
kn,
kl;
extern double *lambda,
*clambda,
**e,
**mue,
**c;

extern void fehler_ex();
extern char *malloc();
extern int  free();

unsigned long MEM=0;  /* Memory-Counter */

/* block(n)

   liefert Zeiger auf Speicherblock der Groesse (n) * sizeof(char);
   gibt Fehlermeldung aus,wenn nicht genuegend Speicher vorhanden ist.
   (Programm wird dann abgebrochen !)

   Th.Hahn  12.10.1989
*/

char *block(n)
unsigned long n;
{
	void Blockfree();
	char *zg=malloc(n);

	if (zg==(char *)0)
	{
		fprintf(stderr,"\n Out of Memory !\n");
		fprintf(stderr," angefordert: %lu Byte(s)\n",n);
		Blockfree();
		fehler_ex(0);
	}
	MEM+=n;
	return zg;
}

/* Blockalloc()

   Speicherfelder reservieren

   Th.Hahn  12.10.1989
*/

void Blockalloc()
{
	int f,g=kn*sizeof(int);

	typ=(int *)(block(g));
	m=(int *)(block(g));
	auftrag=(int *)(block(kl*sizeof(int)));
	g=kn*sizeof(double *);
	e=(double **)(block(g));
	mue=(double **)(block(g));
	c=(double **)(block(g));
	g=kl*sizeof(double);
	lambda=(double *)(block(g));
	clambda=(double *)(block(g));
	for(f=0;f<kn;e[f]=mue[f]=c[f]=0,f++);
	for(f=0;f<kn;f++)
	{
		e[f]=(double *)(block(g));
		mue[f]=(double *)(block(g));
		c[f]=(double *)(block(g));
	}
}

/* Blockfree()

   Rueckgabe aller reservierten Speicherfelder

   Th.Hahn  12.10.1989
*/

void Blockfree()
{
	int f;
/*
	fprintf(stderr,"Speicherbedarf: %lu Byte(s)\n",MEM);
*/
	if (lambda) free(lambda);
	if (clambda) free(clambda);
	if (m) free(m);
	if (auftrag) free(auftrag);
	if (typ) free(typ);
	if (e)
	{
		for(f=0;f<kn;f++)
			if (e[f]) free(e[f]);
		free(e);
	}
	if (mue)
	{
		for(f=0;f<kn;f++)
			if (mue[f]) free(mue[f]);
		free(mue);
	}
	if (c)
	{
		for(f=0;f<kn;f++)
			if (c[f]) free(c[f]);
		free(c);
	}
	if (fd) fclose(fd);
}
