/* option.c

   Einlesen und Pruefen der gesetzen Optionen.
*/

static char *SccsId = "@(#)PEPSY:\toption.c\t1.4\t94/01/27 12:30:38";

#include "summa.h"

extern void fehler_ex();
extern int  getopt();

extern char *optarg;
extern int  optind,
opterr;

/* Optionen von sum in option[]

   ( Verwendbare Optionsbuchstaben : a..z,0..9 )

   ( Optionen, denen beim Aufruf Argumente mitgegeben werden muessen,
     erhalten zusaetzlich einen Doppelpunkt ! )
*/

char   option[]="f:pdawvmk";
unsigned int   opt;        /* Bitmaske fuer ges.Optionen */
unsigned int   decopt[36]; /* Feld zur Decodierung ges. Optionen */
double dyn_a=.0,   /* Faktor fuer dyn_fak() (-f) */
dyn_n=.0;   /* Faktor fuer dyn_fak() (-f) */

/* setfopt()

   Vorbesetzung von (decopt[]) gemaess (option[]).
   Dies ist fuer den Gebrauch von topt() notwendig.

   Th.Hahn  08.02.1990
*/

void setfopt()
{
	char c,b;
	unsigned int i,d;

	for(i=0;i<36;i++) decopt[i]=0;
	i=d=0;
	while((c=option[i]))
	{
		if (c!=':')
		{
			b=c;
			if (c>='0' && c<='9') c-=48;
			else if (c>='a' && c<='z') c-=87;
			if (c>=0 && c<36)
				if (!decopt[c]) decopt[c]=1<<(i-d);
				else fprintf(stderr,"** Option '%c' mehrfach ! **\n",b);
			else fprintf(stderr,"** Option '%c' nicht erlaubt ! **\n",b);
		}
		else d++;
		i++;
	}
}

/* topt(s)

   Ergibt in Abhaengigkeit des Strings (*s) und der setzbaren Optionen
   in (option[]) eine Bitmaske, mit der die vom User gesetzten Optionen
   (entsprechender Wert in (opt)) getestet werden koennen.

   Th.Hahn  05.12.1989
*/

unsigned int topt(s)
char *s;
{
	char c;
	unsigned int f=0;

	while((c=(*s++)))
	{
		if (c>='0' && c<='9') c-=48;
		else if (c>='a' && c<='z') c-=87;
		if (c>=0 && c<36) f+=decopt[c];
	}
	return f;
}

/* usage()

   Ausgabe des Aufrufformates und der Aufrufoptionen.

   Th.Hahn  27.12.1989
*/

void usage()
{
	fprintf(stderr,"\n  Format : sum [ <Infile >Outfile [ Optionen ] ] | [ ! ]\n\n");
	fprintf(stderr,"Optionen :\n");
	fprintf(stderr,"\t-m      : M/M/1 -> M/M/1//M\n");
	fprintf(stderr,"\t-k      : M/M/1 -> M/M/1//K\n");
	fprintf(stderr,"\t-fa,n   : dyn.Faktor verwenden (BCMP-Knoten; Parameter a,n)\n");
	fprintf(stderr,"\t-a      : einfache Wartewahrscheinlichkeiten\n");
	fprintf(stderr,"\t-w      : erweiterte einfache Wartewahrscheinlichkeiten (-a)\n");
	fprintf(stderr,"\t-p      : Schleifentestwert ausgeben\n");
	fprintf(stderr,"\t-d      : debug\n");
	fprintf(stderr,"\t-v      : Ergebnisse mit 6 Nachkommastellen\n");
	fprintf(stderr,"\n");
	fehler_ex(0);
}

/* readopt(argc,argv)

   Einlesen der bei Programmaufruf gesetzten Optionen (UNIX-Standard)
   und evtl. Fehlerbehandlung.
   Anzahl Argumente (argc), Pointer darauf (argv[]).

   Th.Hahn  08.02.1990
*/

void readopt(argc,argv)
int argc;
char *argv[];
{
	int c;
	unsigned int h,d;

	opt=0;
	if (argc>1)
	{
		while((c=getopt(argc,argv,option))!=EOF)
		{
			for(h=d=0;h<Anz_Opt;h++)
				if (option[h]==':') d++;
				else
					if (c==option[h])
					{
						if (!(opt&1<<(h-d)))
						{
							opt|=1<<(h-d);
							switch(c)
							{
							case 'f' : 
								sscanf(optarg,"%lf,%lf",&dyn_a,&dyn_n);
								fprintf(stderr,"dyn_a : %lf dyn_n : %lf\n",dyn_a,dyn_n);
								if (dyn_a<.0 || dyn_n<1.0)
								{
/* code folded from here */
	fprintf(stderr,"Faktoren dyn_a bzw. dyn_n pruefen !\n");
	fehler_ex(13);
/* unfolding */
								}
								break;
							}
						}
						break;
					}
			if (h==Anz_Opt) usage();
		}
		if (argv[1][0]=='!') usage();
	}
}
