/* funktionen.c

   Hilfsfunktionen fuer sum.
*/

static char *SccsId = "@(#)PEPSY:\tfunktionen.c\t1.4\t92/12/09 16:38:37";

#include "summa.h"

extern unsigned int   opt;
extern int    *typ,
TRACE,
*m,
kl,
kn,
MODE,
WEITER,
auftraege;
extern double *lambda,
**e,
**mue,
**c,
**uew,
**ublamb,
**ca,
**cc,
**ca_alt,
**cd,
rho_kn_kl(),
dyn_a,
dyn_n;

extern unsigned int   topt();
extern double pow(),
exp(),
sqrt(),
fabs();

bool pwarn=false;

/* fak(w)

   Berechnet die Fakultaet von (w) (positiv Integer).

*/

double fak(w)
int w;
{
	int g;
	double f=1.0;

	for(g=2;g<=w;f*=g,g++);
	return f;
}

/* kor_fak(i,r)

   Berechnung des Korrekturfaktors Knoten (i), Klasse (r) in
   Abhaengigkeit des Knotentyps.

*/

double kor_fak(i,r)
int i,r;
{
	int t=typ[i];
	double a=1.0;

	if (t==1&&MODE!=0|| t==2&&MODE!=0 ||t==3&&MODE!=0||t==9&&MODE!=0|| t==5 || t==6 || t==7 || t==8 || t==14 || t==15 || t==18 || t==19)   /*MEM*/
	{	
		if (MODE==1 || MODE==2 || MODE==3 || MODE==4 || MODE==5)
                	a=(c[i][r]+ca[i][r])/2.0;
		a=(c[i][r]+1.0)/2.0;
/*		fprintf(stdout,"%d:a ist %lf \n",i,a);*/
	}
	if (t==1 && MODE==0|| t==3 &&MODE==0 || t==9 &&MODE==0 || t==10 || t==14)
		return ((auftraege-a)/(double)(auftraege));
	else
		if (t==11 || t==15)
		{
			if (auftraege>1) return ((auftraege-1.0-a)/(auftraege-1.0));
			else return MAXFLOAT;
		}
		else
			if (t==1&&MODE!=0|| t==3&&MODE!=0||t==9&&MODE!=0||t==2 || t==5 || t==6 || t==7 || t==8 || t>15 && t<20)
			{
				if (auftraege>m[i]) return ((auftraege-m[i]-a)/(auftraege-m[i]));
				else return MAXFLOAT;
			}
			else return 1.0;
}


/* gkorr(i)

   Berechnung des Korrekturfaktors g der Kuehnmethode fuer Knoten i

*/

double gkorr(i)
int i;
{
	double h,h1,expo;

	expo=0;
        h1=rho_kn_kl(i,0);
	if (MODE==2 && ca[i][0]<1)
	{	
		expo =  (2*(1-h1))/3*h1;
		expo *= ((1-ca[i][0])*(1-ca[i][0]))/(ca[i][0]+c[i][0]);
		expo =  -expo;
	}
	if (MODE==2 && ca[i][0]>=1)
	{
		expo =  (ca[i][0]-1)/(ca[i][0]+4*c[i][0]);
		expo *= -(1-h1);
	}

	if (TRACE==1)
	{
/*	fprintf(stdout,"expo von Knoten %d ist %lf   ",i,expo);*/
	}


	if (TRACE==1)
        fprintf(stdout,"g  von Knoten %d ist %lf  \n ",i,exp(expo));
	h=exp(expo);
	return h;
}




/* rho_kn_kl(i,r)

   Berechnung der Auslastung Knoten (i), Klasse (r).

*/

double rho_kn_kl(i,r)
int i,r;
{
	double h;

	if (typ[i]==4) return .0;
	else 
		if (fabs(h=lambda[r]*e[i][r]/m[i]/mue[i][r])<MINRHO)
			if (h<.0) return (-MINRHO);
			else return MINRHO;
		else return h;
}

/* rho_kn(i)

   Berechnung der Auslastung Knoten (i).

*/

double rho_kn(i)
int i;
{
	int r;
	double h=.0;

	for(r=0;r<kl;r++) h+=rho_kn_kl(i,r);
	if (fabs(h)<MINRHO)
		if (h<.0) return (-MINRHO);
		else return MINRHO;
	return h;
}

/* dyn_fak(i,r)

   Berechnet den dynamischen Korrekturfaktor fuer Knoten (i),
   Klasse (r) (BCMP-Knoten).

*/

double dyn_fak(i,r)
int i,r;
{
	double h=rho_kn(i);

	if (!(opt&topt("f")) || h<=null || h>=1.0) return 1.0;
	if (typ[i]<4 || typ[i]==9)
		return (1.0-dyn_a*pow(h,dyn_n)*(1.0-h));
	return 1.0;
}

/* sig(i,r)

   Berechnung von rho((i),0)+rho((i),1)+...+rho((i),(r)-1) (Knoten (i)).

*/

double sig(i,r)
int i,r;
{
	int k=0;
	double h=.0;

	while(k<=r-1)
	{
		h+=rho_kn_kl(i,k);
		k++;
	}
	return h;
}

/* p_wart(rho,i)

   Wartewahrscheinlichkeit fuer Auslastung (rho) und Knoten (i).

*/

double p_wart(rho,i)
double rho;
int i;
{
	int f;
	double fak=1.0,sm1=.0,h0=1.0,h1=m[i]*rho;

	if (rho>=1.0) return 1.0;
	if (rho<=MINRHO) return .0;
	if (opt&topt("a"))
	{
		if (!pwarn)
			if (m[i]>1 && fabs(.7-rho)<.001)
			{
				fprintf(stderr,"** p_wart()-Warnung **\n");
				pwarn=true;
			}
		if (rho>=.7) return ((pow(rho,(double)(m[i]))+rho)/2.0);
		else
			if (!(opt&topt("w")) || opt&topt("w") && rho>=.3)
				return (pow(rho,(m[i]+1.0)/2.0));
			else
			{
				for(f=0;f<m[i];f++)
				{
					sm1+=h0/fak;
					fak*=f+1.0;
					h0*=h1;
				}
				return (1.0-sm1/exp(m[i]*rho));
			}
	}
	else
	{
		for(f=0;f<m[i];f++)
		{
			sm1+=h0/fak;
			fak*=f+1.0;
			h0*=h1;
		}
		h0/=fak*(1.0-rho);
		return (h0/(sm1+h0));
	}
}

/*ANKUNFT()

	Variationkoeffizient des Ankunftsprozesses berechnen

*/

void ANKUNFT()
{
	int i,j;
	double hilfm,h2;
/****************************************************************************/
/*									    */
/* Falls durch Analyse() Summationsalgorithmus wg. erreichen von MAXIT      */
/* abbricht, soll auch die Berechnung der Ankunftsvar.koeff. stoppen und    */ 
/* damit das Gesamtverfahren.						   */
/*									    */
/****************************************************************************/

	if (WEITER==0) fprintf(stderr,"** Abbruch ANKUNFT **\n");


/****************************************************************************/
/*									    */
/* Berechnung der neuen Ankunftsvar.koeff. bezogen auf das mit dem von dem  */
/* Summationsalgorithmus neu gelieferte lambda[0]	                    */
/*       								    */
/****************************************************************************/

	else
	{	
        for (i=0;i<=kn;i++)
       		for (j=0;j<=kn;j++)
		{	
			if (i==0)
				ublamb[i][j]=lambda[0]*uew[i][j];
			else
			ublamb[i][j]=lambda[0]*e[i-1][0]*uew[i][j];

		if (TRACE==1)
		{
		fprintf(stdout,"ublamb[%d][%d] ist %lf\n",i,j,ublamb[i][j]);
     	        fprintf(stdout,"uew[%d][%d] ist %lf\n",i,j,uew[i][j]);
		}

		} 
	if (TRACE==1)
	fprintf(stdout,"lambda[0] ist %lf\n",lambda[0]);

/*****************************************************************************/
/*Fuer jeden Knoten Berechnung der cd, cc und schliesslich der ca            */
/*									     */
/*entsprechend dem MODE-Wert:						     */
/*                                                                           */
/* MODE = 0: Normale Summationsmethode mit Ankunftsvar.koeff = 1	     */
/*                                                                           */
/* MODE = 1: Berechnung nach der Maximum Entropie Methode [BOLC89,ab S.198]  */
/*                                                                           */
/* MODE = 2: Berechnung des Faktors g nach Kuehn, der in die Antwortzeit-    */
/*           gleichung eingeht, veraendertes cd, sonst wie MODE =1.          */
/*                                                                           */
/* MODE = 3: Berechnung nach Pujolle [Huett]			   	     */
/*                                                                           */
/* MODE = 4: Berechnung nach Whitt [Huett]				     */
/*                                                                           */ 
/* MODE = 5: ---------Noch frei----------------------------------------------*/
/*              							     */
/*****************************************************************************/

        /*********************/
        /*Berechnung der cd  */
	/*********************/

	if (MODE==1||MODE==5)	
	for (i=1;i<=kn;i++)
	{
		cd[i][0]=rho_kn_kl(i-1,0)*(1-rho_kn_kl(i-1,0));
		cd[i][0]+=(1-rho_kn_kl(i-1,0))*ca[i-1][0];
		cd[i][0]+=rho_kn_kl(i-1,0)*rho_kn_kl(i-1,0)*c[i-1][0];
		if (TRACE==1)
		{	
		fprintf(stdout,"cd[%d][0] ist %lf     ",i,cd[i][0]);
                fprintf(stdout,"rho_kn_kl(%d,0) ist %lf\n",i,rho_kn_kl(i-1,0));
		}

	}	

	if (MODE==2)
	for (i=1;i<=kn;i++)
	{
		h2=rho_kn_kl(i-1,0);

		cd[i][0]=p_wart(h2,i-1)*p_wart(h2,i-1)*(c[i-1][0]-1);
		cd[i][0]+=(1-p_wart(h2,i-1))*(ca[i-1][0]-1);
		cd[i][0]+=1;
                if (TRACE==1)
                {
                fprintf(stdout,"cd[%d][0] ist %lf     ",i,cd[i][0]);
                fprintf(stdout,"rho_kn_kl(%d,0) ist %lf\n",i,rho_kn_kl(i-1,0));
                }

	}

	if (MODE==3)
	for (i=1;i<=kn;i++)
	{
	   if (typ[i-1]==4) cd[i][0]=ca[i-1][0];
	   else
           {
		cd[i][0]=rho_kn_kl(i-1,0)*rho_kn_kl(i-1,0)*(c[i-1][0]+1);
		cd[i][0]*=(1-rho_kn_kl(i-1,0))*ca[i-1][0];
		cd[i][0]+=(rho_kn_kl(i-1,0)*(1-2*rho_kn_kl(i-1,0)));
	   }
                if (TRACE==1)
                {
                fprintf(stdout,"cd[%d][0] ist %lf     ",i,cd[i][0]);
                fprintf(stdout,"rho_kn_kl(%d,0) ist %lf\n",i,rho_kn_kl(i-1,0));
                }
	}

	if (MODE==4)
	for (i=1;i<=kn;i++)
	{
		if (m[i-1]>0) hilfm=m[i-1];
		else hilfm=1;

		if (TRACE==1)
	        fprintf(stdout,"sqrt(m[%d]) ist %lf \n",i,sqrt(hilfm));
		cd[i][0]=(1-rho_kn_kl(i-1,0)*rho_kn_kl(i-1,0))*(ca[i-1][0]-1);
		cd[i][0]+=(rho_kn_kl(i-1,0)*rho_kn_kl(i-1,0)/sqrt(hilfm)*(c[i-1][0]-1));
		cd[i][0]+=1;
                if (TRACE==1)
                {
                fprintf(stdout,"cd[%d][0] ist %lf     ",i,cd[i][0]);
                fprintf(stdout,"rho_kn_kl(%d,0) ist %lf\n",i,rho_kn_kl(i-1,0));
		}
	}

	/*********************************************************/
	/*Sicherung des ca der Iteration vorher fuer jeden Knoten*/
	/*********************************************************/

	for (i=0;i<kn;i++) 
	{
		ca_alt[i][0]=ca[i][0];
		if (TRACE==1)
                fprintf(stdout,"ca_alt[%d][0] ist %lf  ",i,ca_alt[i][0]);
	}


	/*********************************************/
	/*Berechnung der cc von Knoten i zu Knoten j */
	/*********************************************/

	for (i=1;i<=kn;i++)
		for (j=0;j<=kn;j++)
		{
			cc[i][j]=1+uew[i][j]*(cd[i][0]-1);
			if (TRACE==1)
			fprintf(stdout,"cc[%d][%d] ist %lf \n",i,j,cc[i][j]);
		}

	/**************************/
	/*Berechnung von cd[0][0] */
	/**************************/

	if (MODE==1 || MODE==2)
	{	
		cd[0][0]=0;
		for (j=1;j<=kn;j++)
		cd[0][0]+=ublamb[j][0]/(lambda[0]*(cc[j][0]+1));

		cd[0][0]=1/cd[0][0];
		cd[0][0]=cd[0][0]-1;
	}

	if (MODE==3)
	{
		cd[0][0]=0;
		for (j=1;j<=kn;j++)
			cd[0][0]+=ublamb[j][0]*cc[j][0];
		cd[0][0]*=(1/lambda[0]);
	}

	if (MODE==4)
	{
		cd[0][0]=0;
		for (j=1;j<=kn;j++)
			cd[0][0]+=((ublamb[j][0]*cc[j][0])/lambda[0]);
		
	}
	if (TRACE==1)
	fprintf(stdout,"cd[0][0] ist %lf\n",cd[0][0]);

	/****************************************/
	/*Berechnung von cc[0][j] fuer j=1,..,N */
	/****************************************/

	for (j=1;j<=kn;j++)
	{
 		cc[0][j]=1+uew[0][j]*(cd[0][0]-1);
		if (TRACE==1)
		fprintf(stdout,"cc[0][%d] ist %lf \n",j,cc[0][j]);
	}

	/**********************************************************/
	/*Berechnung des Ankunftsvarkoeff. ca[i][0] fuer i=1,..,N */
	/**********************************************************/

	if (MODE==1 || MODE==2)
	for (i=1;i<=kn;i++)
	{
		ca[i-1][0]=0;
		for (j=0;j<=kn;j++)
		{
		ca[i-1][0]+=ublamb[j][i]/(lambda[0]*e[i-1][0]*(cc[j][i]+1));
		if (TRACE==1)
		{
 	        	fprintf(stdout,"ca[%d][0] ist %lf\n",i-1,ca[i-1][0]);
		}	
		}
		ca[i-1][0]=1/ca[i-1][0];
		ca[i-1][0]=ca[i-1][0]-1;
		if (TRACE==1)
		fprintf(stdout,"**ca[%d][0]   ist %lf  ",i-1,ca[i-1][0]);
	}

	if (MODE==3)
	for (i=1;i<=kn;i++)
	{
		ca[i-1][0]=0;
		for (j=0;j<=kn;j++)
		{
               	ca[i-1][0]+=ublamb[j][i]*cc[j][i];
                if (TRACE==1)
                {
                        fprintf(stdout,"ca[%d][0] ist %lf\n",i-1,ca[i-1][0]);
                }
		}
		ca[i-1][0]*=(1/(lambda[0]*e[i-1][0]));

                if (TRACE==1)
                fprintf(stdout,"**ca[%d][0]   ist %lf  ",i-1,ca[i-1][0]);


	}
	if (MODE==4)
	for (i=1;i<=kn;i++)
	{
		ca[i-1][0]=0;
		for (j=0;j<=kn;j++)
		{
		ca[i-1][0]+=((ublamb[j][i]*cc[j][i])/(lambda[0]*e[i-1][0]));
                if (TRACE==1)
                {
                        fprintf(stdout,"ca[%d][0] ist %lf\n",i-1,ca[i-1][0]);
                }

		}	
	}	
	
	/*********************************/
	/*Berechnung ob Verfahrensabbruch*/
	/*********************************/
	WEITER=0;
	for (i=0;i<kn;i++)
	{
		if (fabs(ca_alt[i][0]-ca[i][0])>=GRENZE)
		WEITER=1;
	}
	
	} /*endelse*/


}







/* addx()

   Hilfsfunktionen fuer die Berechnung der mittleren
   Auftragszahlen.

*/

double add1(i,j)
int i,j;
{
	int r;
	double h=.0;

	for(r=0;r<=j;r++) h+=rho_kn_kl(i,r)/mue[i][r];
	return h;
}

double add2(i,j)
int i,j;
{
	int r;
	double h=.0;

	for(r=0;r<=j;r++)
		h+=lambda[r]*e[i][r]*(c[i][r]+1.0)/mue[i][r]/mue[i][r];
	return h;
}

double add3(i,j)
int i,j;
{
	int r;
	double h=.0;

	for(r=0;r<=j;r++)
		h+=rho_kn_kl(i,r)*(c[i][r]+1.0)/mue[i][r];
	return h;
}
