/* memory.c

   Alle notwendigen Funktionen fuer die dynamische Speicherplatz-
   verwaltung.
*/

static char *SccsId = "@(#)PEPSY:\tmemory.c\t1.4\t94/09/08 17:14:09";

#include "summa.h"

extern FILE   *fd;
extern int    *typ,
*m,
*auftrag,
kn,
kl;
extern double *lambda,
*clambda,
**e,
**mue,
**uew,
**ublamb,
**ca,
**cd,
**ca_alt,
**cc,
**c;

extern void fehler_ex();
extern char *malloc();
extern int  free();

unsigned long MEM=0;  /* Memory-Counter */

/* block(n)

   liefert Zeiger auf Speicherblock der Groesse (n) * sizeof(char);
   gibt Fehlermeldung aus,wenn nicht genuegend Speicher vorhanden ist.
   (Programm wird dann abgebrochen !)

*/

char *block(n)
unsigned long n;
{
	void Blockfree();
	char *zg=malloc(n);

	if (zg==(char *)0)
	{
		fprintf(stderr,"\n Out of Memory !\n");
		fprintf(stderr," angefordert: %lu Byte(s)\n",n);
		Blockfree();
		fehler_ex(0);
	}
	MEM+=n;
	return zg;
}

/* Blockalloc()

   Speicherfelder reservieren

*/

void Blockalloc()
{
	int f,g=kn*sizeof(int);

	typ=(int *)(block(g));
	m=(int *)(block(g));
	auftrag=(int *)(block(kl*sizeof(int)));

	g=kn*sizeof(double *);
	e=(double **)(block(g));
	mue=(double **)(block(g));
	c=(double **)(block(g));
        ca_alt=(double **)(block(g));
        ca=(double **)(block(g));

        g=(kn+1)*sizeof(double *);
        uew=(double **)(block(g));
        cd=(double **)(block(g));
        cc=(double **)(block(g));
        ublamb=(double **)(block(g));

	g=kl*sizeof(double);
	lambda=(double *)(block(g));
	clambda=(double *)(block(g));

	for(f=0;f<kn;e[f]=mue[f]=c[f]=ca[f]=ca_alt[f]=0,f++);
	for(f=0;f<kn;f++)
	{
		e[f]=(double *)(block(g));
		mue[f]=(double *)(block(g));
		c[f]=(double *)(block(g));
                ca_alt[f]=(double *)(block(g));
                ca[f]=(double *)(block(g));
        }


        g=(kn+1)*sizeof(double );

        for(f=0;f<=kn;uew[f]=0,f++);
	for(f=0;f<=kn;f++)
        uew[f]=(double *)(block(g));

        for(f=0;f<=kn;ublamb[f]=0,f++);
        for(f=0;f<=kn;f++)
        ublamb[f]=(double *)(block(g));

        for(f=0;f<=kn;cc[f]=0,f++);
        for(f=0;f<=kn;f++)
        cc[f]=(double *)(block(g));

        for(f=0;f<=kn;cd[f]=0,f++);
        for(f=0;f<=kn;f++)
        cd[f]=(double *)(block(g));


}

/* Blockfree()

   Rueckgabe aller reservierten Speicherfelder

*/

void Blockfree()
{
	int f;

	/*
	fprintf(stderr,"Speicherbedarf: %lu Byte(s)\n",MEM);
	*/
	if (lambda) free(lambda);
	if (clambda) free(clambda);
	if (m) free(m);
	if (auftrag) free(auftrag);
	if (typ) free(typ);
	if (e)
	{
		for(f=0;f<kn;f++)
			if (e[f]) free(e[f]);
		free(e);
	}
	if (mue)
	{
		for(f=0;f<kn;f++)
			if (mue[f]) free(mue[f]);
		free(mue);
	}
	if (c)
	{
		for(f=0;f<kn;f++)
			if (c[f]) free(c[f]);
		free(c);
	}
        if (ca)
        {
                for(f=0;f<kn;f++)
                        if (ca[f]) free(ca[f]);
                free(ca);
        }
        if (ca_alt)
        {
                for(f=0;f<kn;f++)
                        if (ca_alt[f]) free(ca_alt[f]);
                free(ca_alt);
        }
        if (cd)
        {
                for(f=0;f<=kn;f++)
                        if (cd[f]) free(cd[f]);
                free(cd);
        }
        if (cc)
        {
                for(f=0;f<=kn;f++)
                        if (cc[f]) free(cc[f]);
                free(cc);
        }

        if (uew)
        {
                for(f=0;f<=kn;f++)
                        if (uew[f]) free(uew[f]);
                free(uew);
        }
        if (ublamb)
        {
                for(f=0;f<=kn;f++)
                        if (ublamb[f]) free(ublamb[f]);
                free(ublamb);
        }



	if (fd) fclose(fd);
}
