static char *SccsId = "@(#)PEPSY:\tanalyse.c\t1.3\t92/12/09 16:43:46";

/* analyse.c

   Netzanalyse mit der Summationsmethode (R>=1).

   Th.Hahn  13.11.1989
*/

#include "multidef.h"

extern bool   mit,
kfw;
extern unsigned int   opt;
extern int    ukn,
ukl,
*auftrag,
auftraege,
kn,
kl;

extern  unsigned long  count;
extern FILE   *fd;
extern double **mue;

extern void   Blockfree(),
kor_lam(),
fehler_ex();
extern unsigned int   topt();
extern double fabs(),
dyn_fak(),
sum_k(),
k(),
sum_k_HNB(),
abl_sum_k_HNB(),
HNenner(),
abl_HNenner(),
rho_kn_kl();

bool   klam,        /* Flag fuer : kor_lam() bei Bedarf aufrufen */
ckl;         /* Counter fuer : max.Zahl Versuche ohne stat. kor_lam() */
int    it;          /* Iterationszaehler */
 unsigned long  Mcount=0;    /* Zahl der MAXIT-Ueberschreitungen */
double *lambda=0,   /* Durchsatz */
*clambda=0,  /* Kopie Durchsatz */
ctest;       /* Wert von test() */

/* test()

   Austesten der neuen Naeherungswerte Lambda[].

   Th.Hahn  22.11.1989
*/

double test()
{
	int i,j;
	double h=.0,d,d1;

	for(i=0;i<kl;i++) h+=fabs(auftrag[i]-sum_k(i));
	if (opt&topt("p")) fprintf(stderr,"test(%d) : %g\n",it,h);
	if (opt&topt("d"))
	{
		for(i=0;i<kl;i++)
		{
			fprintf(fd,"\thn(%d)    : %g\n",i,auftrag[i]*HNenner(-1,-1,i)-sum_k_HNB(i));
			fprintf(fd,"\tk(x,%d)   :",i);
			d=.0;
			for(j=0;j<kn;j++)
			{
				d1=k(j,i);
				fprintf(fd," %g",d1);
				d+=d1;
			}
			if (kn>1) fprintf(fd," (%g)",d);
			fprintf(fd,"\n");
			if (opt&topt("f"))
			{
				fprintf(fd,"\tdf(x,%d):",i);
				for(j=0;j<kn;j++) fprintf(fd," %g",dyn_fak(j,i));
				fprintf(fd,"\n");
			}
		}
		fprintf(fd,"test(%d) : %g\n",it,h);
	}
	return h;
}

/* Analyse()

   Netzanalyse ausfuehren.

   Th.Hahn  19.01.1990
*/

void Analyse()
{
	int w,j;
	double h0,h1,h2,h3,h4;

	mit=false;
	it=0;
	ckl=stckl;
	klam=false;
	ctest=auftraege+EPS;
	for(w=0;w<kl;w++) lambda[w]=clambda[w]=null;
	while((h0=test())>EPS)
	{
		if (h0<ctest)
		{
			ctest=h0;
			for(w=0;w<kl;w++) clambda[w]=lambda[w];
		}
		else klam=true;
		if (it>=MAXIT)
		{
			fprintf(stderr,"** MAXIT erreicht ! **\n");
			if (h0>ctest)
				for(w=0;w<kl;w++) lambda[w]=clambda[w];
			Mcount++;
			mit=true;
			break;
		}
		it++;
		for(w=0;w<kl;w++)
		{
			h0=HNenner(-1,-1,w);
			h1=sum_k_HNB(w);
			h2=abl_HNenner(-1,w);
			h3=abl_sum_k_HNB(w);
			h4=auftrag[w]*h2-h3;
			if (!h4)
			{
				fprintf(stderr,"** Tangentensteigung Klasse %d gleich null **\n",w);
				Blockfree();
				fehler_ex(15);
			}
			else lambda[w]-=(auftrag[w]*h0-h1)/h4;
			if (!lambda[w])
			{
				fprintf(stderr,"** analyse() : lambda(%d)=0 **\n",w);
				lambda[w]=.5*null;
			}
			if (opt&topt("d"))
			{
				fprintf(fd,"\tHN() %g sk() %g aHN() %g ask() %g\n",h0,h1,h2,h3);
				fprintf(fd,"\tTangenten-Steigung Klasse %d : %g\n",w,h4);
				for(j=0;j<kl;j++)
					fprintf(fd,"\tsum_k(%d) : %g\n",j,sum_k(j));
			}
			if (!(opt&topt("x")))
				if (lambda[w]<null) kor_lam(w);
				else
					if (klam)
						if (sum_k(w)>auftrag[w]+KEPS)
						{
							kor_lam(w);
							if (ckl>0)
							{
								ckl--;
								klam=false;
							}
						}
		}
		if (opt&topt("d"))
		{
			fprintf(fd,"\tlambda() :");
			for(w=0;w<kl;w++) fprintf(fd," %g",lambda[w]);
			fprintf(fd,"\n");
			for(w=0;w<kn;w++)
			{
				fprintf(fd,"\trho(%d,x) :",w);
				h0=.0;
				for(j=0;j<kl;j++)
				{
					h1=rho_kn_kl(w,j);
					fprintf(fd," %g",h1);
					h0+=h1;
				}
				if (kl>1) fprintf(fd," (%g)",h0);
				fprintf(fd,"\n");
			}
		}
	}
	if (!kfw)
		for(w=0;w<kl;w++)
		{
			if (auftrag[w]*abl_HNenner(-1,w)-abl_sum_k_HNB(w)>.0)
			{
				fprintf(stderr,"** Achtung  : Tangentensteigung Klasse %d positiv **\n",w);
				fprintf(stderr,"** Diagnose : evtl. falsche Nullstelle fuer Klasse %d berechnet **\n",w);
			}
		}
	if (opt&topt("u"))
		fprintf(stdout,"count %lu rho %lf maa %lf mue %lf (%d)\n",count,rho_kn_kl(ukn,ukl),k(ukn,ukl),mue[ukn][ukl],
		    it);
}
