static char *SccsId = "@(#)PEPSY:\teingabe.c\t1.3\t92/12/09 16:43:50";

/* eingabe.c 

   Einlesen der Netzdaten.
*/

#include "multidef.h"

extern unsigned int opt;
extern  int sw,
ot;

extern void Blockalloc(),
get_parms(),
Blockfree(),
fehler_ex();
extern unsigned int topt();

bool   ownt,        /* Flag fuer : Typ<0 vorhanden (own type) */
mm1,         /* Flag fuer : M/M/1-FCFS-Knoten vorhanden */
kfw;         /* Flag fuer : Korrekturfaktorwarnung */
int    *typ=0,      /* Knotentypen */
*m=0,        /* Zahl der Bedieneinheiten */
*auftrag=0,  /* Zahl der Auftraege in den Klassen */
auftraege,   /* Gesamtzahl der Auftraege */
kn,          /* Zahl der Knoten */
kl;          /* Zahl der Klassen */
double **e=0,       /* Besuchshaeufigkeiten */
**mue=0,     /* Bedienraten */
**c=0;       /* Variationskoeffizienten */

/* eingabe()

   Einlesen der Netzdaten ueber die Standardeingabe.

   Th.Hahn  13.01.1990
*/

void eingabe()
{
	int i,j;

	fscanf(stdin,"%d",&i);
	if (i!=1)
	{
		fprintf(stderr,"Falscher Netztyp !\n");
		fehler_ex(1);
	}
	fscanf(stdin,"%d",&kn);
	fscanf(stdin,"%d",&kl);
	if (kn<1 || kl<1)
	{
		fprintf(stderr,"Anzahl Knoten/Klassen pruefen !\n");
		fehler_ex(2);
	}
	auftraege=0;
	Blockalloc();
	for(i=0;i<kl;i++)
	{
		fscanf(stdin,"%d",&auftrag[i]);
		if (auftrag[i]<1)
		{
			fprintf(stderr,"Anzahl Auftraege Klasse %d pruefen !\n",i);
			Blockfree();
			fehler_ex(3);
		}
		if (opt&topt("s"))
			if (auftrag[i]>sw) auftrag[i]-=sw;
			else auftrag[i]=1;
		auftraege+=auftrag[i];
	}
	for(i=0;i<kn;i++)
	{
		fscanf(stdin,"%d",&m[i]);
		if (m[i]<0)
		{
			fprintf(stderr,"Zahl der Bedieneinheiten Knoten %d pruefen !\n",i);
			Blockfree();
			fehler_ex(16);
		}
	}
	for(i=0;i<kn;i++)
		for(j=0;j<kl;j++)
		{
			fscanf(stdin,"%lf",&mue[i][j]);
			if (mue[i][j]<=.0)
			{
				fprintf(stderr,"Bedienrate Knoten %d Klasse %d pruefen !\n",i,j);
				Blockfree();
				fehler_ex(4);
			}
		}
	fscanf(stdin,"%d",&i);
	if (i)
	{
		fprintf(stderr,"keine Besuchshaeufigkeiten !\n");
		Blockfree();
		fehler_ex(5);
	}
	for(i=0;i<kn;i++)
		for(j=0;j<kl;j++)
		{
			fscanf(stdin,"%lf",&e[i][j]);
			if (e[i][j]<.0)
			{
				fprintf(stderr,"Besuchshaeufigkeit Knoten %d Klasse %d pruefen !\n",j,i);
				Blockfree();
				fehler_ex(6);
			}
		}
	for(i=0;i<kl;i++)
	{
		for(j=0;j<kn;j++)
			if (e[j][i]>.0) break;
		if (j==kn)
		{
			fprintf(stderr,"Besuchshaeufigkeiten Klasse %d pruefen !\n",i);
			Blockfree();
			fehler_ex(7);
		}
	}
	ownt=mm1=kfw=false;
	for(i=0;i<kn;i++)
	{
		fscanf(stdin,"%d",&typ[i]);
		if (typ[i]<-4 || typ[i]==0 || typ[i]>19 || typ[i]==12 || typ[i]==13 || typ[i]>0 && (!m[i] && typ[i]!=4 ||
		    m[i] && typ[i]==4))
		{
			fprintf(stderr,"Typ Knoten %d pruefen !\n",i);
			Blockfree();
			fehler_ex(9);
		}
		if (!(-5<typ[i] && typ[i]<0 || typ[i]==2 || typ[i]==6 || typ[i]==8 || typ[i]>15 && typ[i]<20) && m[i]>1)
		{
			fprintf(stderr,"Knoten %d ist unzulaessiger Multiple-Server !\n",i);
			Blockfree();
			fehler_ex(10);
		}
		if (!i)
			if (opt&topt("o"))
			{
				typ[0]= -ot;
				ownt=true;
			}
		if (typ[i]<0 && !m[i])
		{
			fprintf(stderr,"Negative Knotentypen sind nicht zugelassen fuer IS-Knoten !\n");
			Blockfree();
			fehler_ex(11);
		}
		if (!mm1 && typ[i]==1) mm1=true;
		if (!ownt && typ[i]<0) ownt=true;
	}
	for(i=0;i<kn;i++)
	{
		for(j=0;j<kl;j++)
		{
			fscanf(stdin,"%lf",&c[i][j]);
			if (c[i][j]<.0 || c[i][j]!=1.0 && (-5<typ[i] && typ[i]<5 || typ[i]>8 && typ[i]<14 || typ[i]==16 ||
			    typ[i]==17))
			{
				fprintf(stderr,"Variationskoeffizient Knoten %d Klasse %d pruefen !\n",i,j);
				Blockfree();
				fehler_ex(12);
			}
		}
		if (typ[i]==7 || typ[i]==8) typ[i]-=2; /* G/G/m-FCFS -> M/G/m-FCFS */
	}
	if (kl>1)
		for(i=0;i<kn;i++)
			if (typ[i]==1 || typ[i]==2)
				for(j=1;j<kl;j++)
					if (mue[i][0]!=mue[i][j])
					{
						fprintf(stderr,"** Achtung : Bedienraten verschieden an M/M/m-FCFS-Knoten ! **\n");
						break;
					}
	for(i=0;i<kn;i++)
	{
		j=typ[i];
		if (((j==11 || j==15) && auftraege==1) || ((j==2 || j==5 || j==6 || j>15 && j<20) && auftraege<=m[i]))
		{
			fprintf(stderr,"** Korrekturfaktor-Warnung Knoten %d ! **\n",i);
			if (!kfw) kfw=true;
		}
	}
	if (ownt) get_parms();
}
