static char *SccsId = "@(#)PEPSY:\tmemory.c\t1.4\t94/04/26 13:35:19";
/* memory.c

   Alle notwendigen Funktionen fuer die dynamische Speicherplatz-
   verwaltung.
*/

#include "multidef.h"

extern  unsigned long  Mcount;
extern FILE   *fd,*st;
extern int    *typ,
*m,
*auftrag,
kn,
kl;
extern double *lambda,
*clambda,
**e,
**mue,
**c,
***parm,
**prand,
*auftrm1,
*auftrzm2,
*maazm2,
*mvzzm2,
*mwzzm2,
*mhilf;
extern struct Wert *first;

extern void travers(),
fehler_ex();
extern char *malloc();
extern int  free();

 unsigned long MEM=0;  /* Memory-Counter */

/* block(n)

   liefert Zeiger auf Speicherblock der Groesse (n) * sizeof(char);
   gibt Fehlermeldung aus, wenn nicht genuegend Speicher vorhanden ist.
   (Programm wird dann abgebrochen !)

   Th.Hahn  12.10.1989
*/

char *block(n)
 unsigned long n;
{
	void Blockfree();
	char *zg=malloc(n);

	if (zg==(char *)0)
	{
		fprintf(stderr,"\n Out of Memory !\n");
		fprintf(stderr," angefordert: %lu Byte(s)\n",n);
		Blockfree();
		fehler_ex(0);
	}
	MEM+=n;
	return zg;
}

/* Blockalloc()

   Speicherfelder reservieren.

   Th.Hahn  12.10.1989
*/

void Blockalloc()
{
	int f,g=kn*sizeof(int);

	typ=(int *)(block(g));
	m=(int *)(block(g));
	auftrag=(int *)(block(kl*sizeof(int)));
	g=kn*sizeof(double *);
	e=(double **)(block(g));
	mue=(double **)(block(g));
	c=(double **)(block(g));
	g=kl*sizeof(double);
	lambda=(double *)(block(g));
	clambda=(double *)(block(g));
	for(f=0;f<kn;e[f]=mue[f]=c[f]=0,f++);
	for(f=0;f<kn;f++)
	{
		e[f]=(double *)(block(g));
		mue[f]=(double *)(block(g));
		c[f]=(double *)(block(g));
	}
}

/* Blockfree()

   Rueckgabe aller reservierten Speicherfelder.

   Th.Hahn  12.10.1989
*/

void Blockfree()
{
	int f,g;

/*
	fprintf(stderr,"Speicherbedarf: %lu Byte(s)\n",MEM);
*/
	if (first) travers(first);
	if (st) fclose(st);
	if (Mcount)
		fprintf(stdout,"Zahl der MAXIT-Ueberschreitungen : %lu\n",Mcount);
	if (lambda) free(lambda);
	if (clambda) free(clambda);
	if (m) free(m);
	if (auftrag) free(auftrag);
	if (typ) free(typ);
	if (e)
	{
		for(f=0;f<kn;f++)
			if (e[f]) free(e[f]);
		free(e);
	}
	if (mue)
	{
		for(f=0;f<kn;f++)
			if (mue[f]) free(mue[f]);
		free(mue);
	}
	if (c)
	{
		for(f=0;f<kn;f++)
			if (c[f]) free(c[f]);
		free(c);
	}
	if (parm)
	{
		for(f=0;f<kn;f++)
		{
			if (parm[f])
			{
				for(g=0;g<kl;g++)
					if (parm[f][g]) free(parm[f][g]);
				free(parm[f]);
			}
		}
		free(parm);
	}
	if (prand)
	{
		for(f=0;f<kn;f++)
			if (prand[f]) free(prand[f]);
		free(prand);
	}
	if (auftrm1) free(auftrm1);
	if (auftrzm2) free(auftrzm2);
	if (maazm2) free(maazm2);
	if (mvzzm2) free(mvzzm2);
	if (mwzzm2) free(mwzzm2);
	if (mhilf) free(mhilf);
	if (fd) fclose(fd);
}
