static char *SccsId = "@(#)PEPSY:\toption.c\t1.4\t94/01/27 12:36:26";

/* option.c

   Einlesen und Pruefen der gesetzen Optionen.
*/

#include "multidef.h"

extern void fehler_ex();
extern int  getopt();

extern char *optarg;
extern int  optind,
opterr;

/* Optionen von multisum in option[]

   ( Verwendbare Optionsbuchstaben : a..z,0..9 )

   ( Optionen, denen beim Aufruf Argumente mitgegeben werden muessen,
     erhalten zusaetzlich einen Doppelpunkt ! )
*/

char   option[]="u:l:i:s:o:f:pdmxawkvbt";

unsigned int   opt;        /* Bitmaske fuer ges.Optionen */
unsigned int   decopt[36]; /* Feld zur Decodierung ges. Optionen */
int    ukn=0,      /* spez.ausgew.Knoten (-u) */
ukl=0,      /* spez.ausgew.Klasse (-u) */
lkl=0,      /* spez.ausgew.Klasse (-l) */
sw=0,       /* Verminderungswert  (-s) */
ot=0,       /* Typ fuer Knoten 1  (-o) */
fn=0;       /* Art des dynfak()   (-f) */
double iu=null,    /* Untergrenze fuer -l (-i) */
io=null,    /* Obergrenze  fuer -l (-i) */
dyn_a=.0,   /* Faktor fuer dyn_fak() (-f) */
dyn_n=.0;   /* Faktor fuer dyn_fak() (-f) */

/* setfopt()

   Vorbesetzung von (decopt[]) gemaess (option[]).
   Dies ist fuer den Gebrauch von topt() notwendig.

   Th.Hahn  08.02.1990
*/

void setfopt()
{
	char c,b;
	unsigned int i,d;

	for(i=0;i<36;i++) decopt[i]=0;
	i=d=0;
	while((c=option[i]))
	{
		if (c!=':')
		{
			b=c;
			if (c>='0' && c<='9') c-=48;
			else if (c>='a' && c<='z') c-=87;
			if (c>=0 && c<36)
				if (!decopt[c]) decopt[c]=1<<(i-d);
				else fprintf(stderr,"** Option '%c' mehrfach ! **\n",b);
			else fprintf(stderr,"** Option '%c' nicht erlaubt ! **\n",b);
		}
		else d++;
		i++;
	}
}

/* topt(s)

   Ergibt in Abhaengigkeit des Strings (*s) und der setzbaren Optionen
   in (option[]) eine Bitmaske, mit der die vom User gesetzten Optionen
   (entsprechender Wert in (opt)) getestet werden koennen.

   Th.Hahn  05.12.1989
*/

unsigned int topt(s)
char *s;
{
	char c;
	unsigned int f=0;

	while((c=(*s++)))
	{
		if (c>='0' && c<='9') c-=48;
		else if (c>='a' && c<='z') c-=87;
		if (c>=0 && c<36) f+=decopt[c];
	}
	return f;
}

/* usage()

   Ausgabe des Aufrufformates und der Aufrufoptionen.

   Th.Hahn  27.12.1989
*/

void usage()
{
	fprintf(stderr,"\n  Format : multisum [ <Infile >Outfile [ Optionen ] ] | [ ! ]\n\n");
	fprintf(stderr,"Optionen :\n");
	fprintf(stderr,"\t-fF,a,n : dynamischen Faktor verwenden (BCMP-Knoten), wobei\n");
	fprintf(stderr,"\t\t  F=0 : Default-Faktor und -Parameter\n");
	fprintf(stderr,"\t\t  F=1 : (1-a*r(i,r)*r(i)^(n-1)*(1-r(i)))\n");
	fprintf(stderr,"\t\t  F=2 : (1-a*r(i,r)^n*(1-r(i)))\n");
	fprintf(stderr,"\t\t  F=3 : (1-a*r(i,r)^n*(1-r(i,r))\n");
	fprintf(stderr,"\t\t  F=4 : (1-a*r(i)^n*(1-r(i)))\n");
	fprintf(stderr,"\t-uKn,Kl : Stuetzstellenberechnung fuer Knoten,Klasse\n");
	fprintf(stderr,"\t-lKl    : Analysefunktion berechnen fuer Lambda(Kl)\n");
	fprintf(stderr,"\t-iUG,OG : Intervallvorgabe fuer Lambda(Kl) (-l)\n");
	fprintf(stderr,"\t-oT     : Knoten 1 auf Typ -T (-5<-T<0) setzen\n");
	fprintf(stderr,"\t-b      : Parameter fuer Knoten mit Typ<-1 berechnen (auch -o)\n");
	fprintf(stderr,"\t-sK     : Auftragszahl je Klasse um K vermindern\n");
	fprintf(stderr,"\t-m      : Momente und Verteilungen (M/M/1-FCFS-Knoten bei R=1)\n");
	fprintf(stderr,"\t-t      : Umverteilung der Randwahrscheinlichkeiten (-m)\n");
	fprintf(stderr,"\t-a      : einfache Wartewahrscheinlichkeiten\n");
	fprintf(stderr,"\t-w      : erweiterte einfache Wartewahrscheinlichkeiten (-a)\n");
	fprintf(stderr,"\t-x      : keine Lambda-Korrektur ausfuehren\n");
	fprintf(stderr,"\t-p      : Schleifentestwert ausgeben\n");
	fprintf(stderr,"\t-d      : debug\n");
	fprintf(stderr,"\t-v      : Ergebnisse mit 6 Nachkommastellen\n");
	fprintf(stderr,"\n");
	fehler_ex(0);
}

/* readopt(argc,argv)

   Einlesen der bei Programmaufruf gesetzten Optionen (UNIX-Standard)
   und evtl. Fehlerbehandlung.
   Anzahl Argumente (argc), Pointer darauf (argv[]).

   Th.Hahn  08.02.1990
*/

void readopt(argc,argv)
int argc;
char *argv[];
{
	int c;
	unsigned int h,d;

	opt=0;
	if (argc>1)
	{
		while((c=getopt(argc,argv,option))!=EOF)
		{
			for(h=d=0;h<Anz_Opt;h++)
				if (option[h]==':') d++;
				else
					if (c==option[h])
					{
						if (!(opt&1<<(h-d)))
						{
							opt|=1<<(h-d);
							switch(c)
							{
							case 'u' : 
								sscanf(optarg,"%d,%d",&ukn,&ukl);
								ukn--;
								ukl--;
								break;
							case 'l' : 
								sscanf(optarg,"%d",&lkl);
								lkl--;
								break;
							case 'i' : 
								sscanf(optarg,"%lf,%lf",&iu,&io);
								break;
							case 's' : 
								sscanf(optarg,"%d",&sw);
								if (sw<1) sw=1;
								break;
							case 'o' : 
								sscanf(optarg,"%d",&ot);
								if (ot<1 || ot>4) ot=1;
								break;
							case 'f' : 
								sscanf(optarg,"%d,%lf,%lf",&fn,&dyn_a,&dyn_n);
								if (!fn) /* default */
								{
/* code folded from here */
	fn=4;
	dyn_a=20.0;
	dyn_n=20.0;
/* unfolding */
								}
								if (fn<1 || fn>4) fn=1;
								fprintf(stderr,"dyn_a : %lf dyn_n : %lf\n",dyn_a,dyn_n);
								if (dyn_a<.0 || dyn_n<2.0)
								{
/* code folded from here */
	fprintf(stderr,"Faktoren dyn_a bzw. dyn_n pruefen !\n");
	fehler_ex(13);
/* unfolding */
								}
								break;
							}
						}
						break;
					}
			if (h==Anz_Opt) usage();
		}
		if (argv[1][0]=='!' || ukn<0 || ukl<0 || lkl<0) usage();
	}
}
