/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsGlobal_h = "@(#)PEPSY:\tglobal.h\t1.9\t94/03/03 10:28:05";

/* Definition der globalen Variablen fuer MMVA */

#ifndef GLOBAL_H
#define GLOBAL_H

#define MAXDOUBLE 1.7976931348623157e+308
#ifndef MAXFLOAT
#   define MAXFLOAT ((float)3.40282346638528860e+38)
#endif
#define true 1
#define false 0
#define MINRHO 1e-32   /* Schranke fuer rho */
#define null 1e-16     /* "Ersatz-Null" */

int ctlmsg=0; /* Ausgabe von Kontrollmeldungen */

typedef unsigned char bool;
typedef unsigned long Ulong;
typedef double * pointer;


/* Definition einer Zustandsstruktur fuer die Bearbeitung von asymmetrischen */
/* multiple servern bei zufaelliger Auswahl einer freien Bedieneinheit       */
/* ------------------------------------------------------------------------- */
struct Zustand            /* Zustand im MARKOV-Graphen             */
{
   short belegt[10];      /* lfd. Nummern belegter Bedieneinheiten */
   int anz;               /* Anzahl belegter Bedieneinheiten       */
   double value;          /* Zustandswahrscheinlichkeit            */
   struct Zustand* next;  /* naechster Zustand                     */
};

int dbg;               /* p_lang_init() */

int kn;                /* Anzahl Knoten */
int kl;                /* Anzahl Klassen */
int *zv=0;             /* Populationsvektor */
int *nzv=0;            /* System-Populationsvektor */
int *hv=0;             /* Hilfsvektor */
double *hdv=0;         /* Hilfsvektor */
Ulong MEM=0;           /* benoetigter Speicherplatz (Byte) */
Ulong GESAUFTR=0;      /* Gesamtzahl Auftraege aller Klassen */
int   MAXAUFTR=0;      /* groesste Anzahl Auftraege einer Klasse */
Ulong MAXDECODE=1;     /* Maximum der Pop.-Vektordecodierung */
Ulong aktvekt;         /* Decodierung des akt.Pop.-Vektors */
Ulong *codefakt=0;     /* Multiplikatoren fuer Vektor(de)codierung */
bool oom=false;        /* Flag fuer: out of memory */
bool bdv=false;        /* Flag fuer: Klassen-Bedienzeiten verschieden */
bool bsn=false;        /* Flag fuer: Besuchshaeufigkeit null vorhanden */
bool mm1=false;        /* Flag fuer: M/M/1-Knoten vorhanden */
bool mts=false;        /* Flag fuer: Multiple Server vorhanden */
int *m=0;              /* Anzahl Bedieneinheiten/Knoten */
int *anzkl=0;          /* Anzahl Auftraege/Klasse */
pointer e=0;           /* Besuchshaufigkeit Knoten/Klasse */
pointer mue=0;         /* Bedienrate Knoten/Klasse */
double **amue;         /* Bedienraten pro BE fuer asymm. multiple server*/
double  *sumamue;      /* Summe der amue ueber die Bedieneinheiten */
double **amue_geord;   /* Bedienraten fuer asymm. multiple server, fallend */
			     /* geordnet */
int *typ=0;            /* Typ der Knoten : 0 <-> Typ-3
					   1 <-> Typ-1
					   2 <-> Typ-2,4 */
pointer muequer=0;     /* mittl.Bedienrate Knoten */
pointer aus=0;         /* rel.Auslastung Knoten/Klasse */
pointer antwzeit=0;    /* mittl.Verweilzeit Knoten/Klasse/Pop. */
pointer lam=0;         /* Durchsatz Klasse/Pop. */
pointer ka1=0;         /* mittl.Anz.Auftr.Knoten/Pop. */
pointer ewka=0;        /* mittl.Anz.Auftr.Knoten/Klasse/Pop. */
pointer *pe=0;         /* bed.Wahrsch. (MWA) */
pointer gg=0;          /* Normal.-Konst. */
pointer *norm=0;       /* genormte Bedienzeit Knoten/Pop. */
pointer dxantwzeit=0;  /* dx-mittl.Verweilzeit Knoten/Klasse/Pop. */
pointer dxlam=0;       /* dx-Durchsatz Klasse/Pop. */
pointer dxka1=0;       /* dx-mittl.Anz.Auftr.Knoten/Pop. */
pointer dxewka=0;      /* dx-mittl.Anz.Auftr.Knoten/Klasse/Pop. */
pointer *dxpe=0;       /* dx-bed.Wahrsch. (dxMWA) */
pointer prandbase=0;   /* Basispointer auf Randwahrsch. */
pointer auftrm1=0;     /* 1.Moment fuer Anz.Auftr./Knoten */
pointer auftrzm2=0;    /* Varianz fuer Anz.Auftr./Knoten */
pointer sauftrzm2=0;   /* Varianz fuer Anz.Auftr./Knoten (Strelen) */
pointer *pwschlbase=0; /* Wahrsch.fuer Warteschlangenlaenge */
pointer wschlm1=0;     /* 1.Moment fuer Warteschlangenlaenge */
pointer wschlzm2=0;    /* Varianz fuer Warteschlangenlaenge */
pointer *wzeitm1=0;    /* 1.Moment Wartezeit M/M/1 (Approximativ) */
pointer *wzeitzm2=0;   /* Varianz Wartezeit M/M/1  (     ""     ) */
pointer *vzeitm1=0;    /* 1.Moment Verweilzeit M/M/1  (  ""   )   */
pointer *vzeitzm2=0;   /* Varianz Verweilzeit M/M/1   (  ""   )   */
pointer ff=0;          /* Hilfsfeld zur Berechnung von RHO */
pointer gN=0;          /* "" */
pointer pI=0;          /* "" */
pointer lambda=0;      /* Ankunftsrate Knoten/Klasse */
pointer rho=0;         /* Auslastung Knoten/Klasse */
pointer rhoges=0;      /* Auslastung Knoten */
#endif
