/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tmmva.c\t1.12\t94/03/03 10:28:09";

/* Moments and Mean Value Analysis  (MMVA) */

#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <math.h>
#include <malloc.h>
#include <sys/types.h>
#include "libpepsy.h"

extern	void	qsort();

#ifndef GLOBAL_H
#include "global.h"
#endif

int opt=16;                    /* Bitmaske fuer gesetzte Optionen */
                               /* Default : -va */

#ifndef FUNKTIONEN_H
#include "funktionen.h"      
#endif

void abbruch(sig)
int sig;
{
        printf("mmva_signal_%d\n 0 0 0 \n", sig);
        exit(1);
}

int main(argc,argv)
int argc;
char *argv[];
{
	/*		Sccs support from SccsLogging.c			*/	
	extern int SccsRelease;
	extern int SccsLevel;

	extern char *optarg;

	Ulong f,g,h,i,j,k;
	int c;
	int	errflg=0;
	double s;


        void abbruch();

        for (c=1; c<12; c++)
                signal (c, abbruch);


	if (p_lang_init(argv[0])!=0) exit(-2);

	/*	

		kirschni 12.2.1992

		major improvement!!!!

	*/
	f=0;
	while ((c=getopt(argc, argv, "wsdbpv:V")) != EOF)
	{
		switch(c)
		{
			case 'd':		
						ctlmsg = 1;
						break;
			case 'w':
						opt |= 1;
						break;
			case 's':
						opt |= 2;
						break;
			case 'b':
						opt |= 4;
						break;
			case 'p':
						opt |= 8;
						break;
			case 'v':
						if (!f)
						{
							opt^=16; /* Default `-va' zuruecknehmen */
							f=1;
						}
						if (!(opt&112)) /* die erste `-v' Option */
							switch(optarg[0])
							{
								case 'a':
											opt |= 16;
											break;
								case 'b':
											opt |= 32;
											break;
								case 'c':
											opt |= 64;
											break;
								default:
											errflg=1;
							}
						break;
			case 'V':
						fprintf(stdout, "%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
						exit(0);
						break;
			default:
						errflg = 1;
						break;
		}
		if (errflg)
		{
			fprintf(stderr,"Usage: %s [<infile] [>outfile] [-w] [-s] [-b] [-p]\n     %s -V\n", argv[0], argv[0]); 
			fprintf(stderr,"\t%s\n",spr("usag01"));
			fprintf(stderr,"\t%s\n",spr("usag02"));
			fprintf(stderr,"\t%s\n",spr("usag03"));
			fprintf(stderr,"\t%s\n",spr("usag04"));
			fprintf(stderr,"\n\t%s\n\n",spr("usag05"));
			fprintf(stderr,"\t%s\n",spr("usag06"));
			fprintf(stderr,"\t%s\n",spr("usag07"));
			fprintf(stderr,"\t%s\n",spr("usag08"));
			fprintf(stderr,"\t%s\n",spr("usag09"));
			fprintf(stderr,"\t%s\n\n",spr("usag10"));
			exit(1);
		}
	}
	/*
		end of major improvement !!
	*/

	scanf("%d",&c);
	if (c!=1)
	{
		fprintf(stderr,"%s\n",spr("chk001"));
		printf("%s\n0 0 0 \n",spr("chk002"));
		exit(1);
	}
	scanf("%d",&kn);
	scanf("%d",&kl);
	if (kn<1 || kl<1)
	{
		fprintf(stderr,"%s %s/%s !\n",spr("chk003"),spr("std001"),spr("std002"));
		printf("%s\n0 0 0 \n",spr("chk004"));
		exit(2);
	}
	Blockalloc1();
	for(f=0;f<kl;f++)
	{
		scanf("%d",&anzkl[f]);
		if (anzkl[f]<1)
		{
			fprintf(stderr,"%s (%s %d)\n",spr("chk005"),spr("std002"),f+1);
			Blockfree();
			printf("%s\n0 0 0 \n",spr("chk006"));
			exit(3);
		}
	}
	for(f=0;f<kn;f++)
	{
		scanf("%d",&m[f]);
		if (m[f]<0)
		{
			fprintf(stderr,"%s (%s %d) !\n",spr("chk007"),spr("std001"),f+1);
			Blockfree();
			printf("%s\n0 0 0 \n",spr("chk008"));
			exit(4);
		}
	}
	scanf("%d",&c);
	if (c)
	{
		fprintf(stderr,"\n%s\n",spr("chk009"));
		Blockfree();
		printf("%s\n0 0 0 \n",spr("chk010"));
		exit(5);
	}
	for(f=0;f<kl;f++)
	{
		for(g=0,s=.0;g<kn;g++)
		{
			i=Index(g,f,0);
			scanf("%lg",&e[i]);
			s+=e[i];
		}
		if (s<=.0)
		{
			fprintf(stderr,"\n%s (%s %d) !\n",spr("chk011"),spr("std002"),f+1);
			Blockfree();
			printf("%s\n0 0 0 \n",spr("chk010"));
			exit(6);
		}
	}
	for(f=0;f<kl;f++)
		for(g=0;g<kn;g++)
		{
			i=Index(g,f,0);
			scanf("%lg",&mue[i]);
			if (mue[i]<=.0)
			{
				fprintf(stderr,"%s (%s %d %s %d) !\n",spr("chk013"),spr("std001"),g+1,spr("std002"),f+1);
				Blockfree();
				printf("%s\n0 0 0 \n",spr("chk015"));
				exit(7);
			}
		}
	for(f=0;f<kn;f++)
	{
		scanf("%d",&typ[f]);
		if (typ[f]<0 || (typ[f]>2 && typ[f]!=20))
		{
			fprintf(stderr,"%s %d %s\n",spr("std001"),f+1,spr("chk017"));
			Blockfree();
			printf("%s\n0 0 0 \n",spr("chk018"));
			exit(8);
		}
	}
  
/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*      Einlesen der Bedienraten pro Knoten und Bedieneiheit                 */
/*                                                                           */
/*      Speicherplatz wird zuvor fuer die Bedienraten in Abhaengigkeit       */
/*      von der Anzahl der Bedieneinheiten pro Knoten angefordert            */
/*                                                                           */
/*                                                                           */
/*****************************************************************************/

	Blockalloc3();
	for(f=0;f<kn;f++)
		if (typ[f]==20)
		{
			sumamue[f]=.0;
			for(i=0;i<m[f];i++)
			{
				scanf("%lf",&amue[f][i]);
				sumamue[f]+= amue[f][i]; 
			}
			j=Index(f,0,0);
			mue[j]=sumamue[f]/m[f];   
		}

/*****************************************************************************/
/*                                                                           */
/*                                                                           */
/*      Sortieren der Bedienraten fuer asymmetrische multiple server         */
/*      Knoten nach der Groesse aufsteigend                                  */
/*      							                                         */
/*      Fuer die Analyse nach Baer gleichzeitig absteigend sortieren         */
/*                                                                           */
/*                                                                           */
/*****************************************************************************/

	for(f=0;f<kn;f++)
		if (typ[f]==20)
     	{	
     		(void)qsort(amue[f],m[f],sizeof(double),(int)strcmp);
			for (j=0;j<m[f];j++)
				amue_geord[f][j]=amue[f][m[f]-j-1];
		}	

	for(f=0;f<kl;f++)
		MAXDECODE*=anzkl[f]+1;
	MAXAUFTR=anzkl[0];
	for(f=1;f<kl;f++)
		MAXAUFTR=MAX(MAXAUFTR,anzkl[f]);
	GESAUFTR=sum(anzkl);
	Blockalloc2();
	Reset();
	if (ctlmsg) fprintf(stderr,"\nMWA()\n");
	if (!(opt & 4))
	{
		if (bdv) fprintf(stderr,"%s\n",spr("chk019"));
		MWA();
	}
	else MWA2();
	NORM();
	h=false;
	/*
	for(i=0;i<kn;i++)
		if(m[i] > 1) h = true;
	if(h == true)
	{
		if( prandbase == (double *) 0)
			prandbase=(double *)(block(kn*MAXDECODE*sizeof(double)));
		if (ctlmsg) fprintf(stderr,"%s %e\n",spr("chk020"),anzvekt());
		WAHRSCH();
	}
	*/
	LEIST(argv[0]);
	if (opt & 3)
	{
		if (opt & 2)
		{
			if (ctlmsg) fprintf(stderr,"dxMWA()\n");
			dxMWA();
			SMOMAUS();
		}
		if (mm1)
		{
			fprintf(stdout,"\n%s\n",spr("res001"));
			MOMAUS2(wzeitmom,wzeitm1,wzeitzm2);
			fprintf(stdout,"\n%s\n",spr("res002"));
			MOMAUS2(vzeitmom,vzeitm1,vzeitzm2);
		}
	}
	if (opt & 1)
	{
		if (bsn) fprintf(stderr,"%s\n",spr("chk021"));
		if (ctlmsg) fprintf(stderr,"%s %e\n",spr("chk020"),anzvekt());
		if(h != true) WAHRSCH();
		fprintf(stdout,"\n%s\n",spr("res003"));
		for(f=0;f<kn;f++)
		{
			fprintf(stdout,"%s %d:\n",spr("std001"),f+1);
			h=f*MAXDECODE;
			i=0;
			code(i,zv);
			do
			{
				fprintf(stdout," p(%d)(",f+1);
				for(g=0;g<kl-1;fprintf(stdout,"%d,",zv[g]),g++);
				fprintf(stdout,"%d)=",zv[g]);
				foutnl(prandbase[h+i]);
				i++;
			}while(nextzv(zv));
		}
		aktpwschl();
		c=MAXAUFTR+1;
		fprintf(stdout,"\n%s\n",spr("res004"));
		for(f=0;f<kn;f++)
		{
			fprintf(stdout,"%s %d:\n",spr("std001"),f+1);
			if (pwschlbase[f])
				for(g=0;g<kl;g++)
				{
					fprintf(stdout," %s %d:\n",spr("std002"),g+1);
					for(i=0,h=c*g;i<=(k=MIN(anzkl[g],GESAUFTR-m[f]));i++)
					{
						fprintf(stdout,"  p(%d) = ",i);
						foutnl(pwschlbase[f][h+i]);
					}
				}
			else 
				for(g=0;g<kl;g++)
				{
					fprintf(stdout," %s %d:\n",spr("std002"),g+1);
					fprintf(stdout,"  p(0) = ");
					foutnl(1.0);
				}
		}
		fprintf(stdout,"\n%s\n",spr("res005"));
		MOMAUS1(auftrmom,auftrm1,auftrzm2);
		fprintf(stdout,"\n%s\n",spr("res006"));
		MOMAUS1(wschlmom,wschlm1,wschlzm2);
	}
	Blockfree();
	exit(0);
}
