/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsDNetz_h = "@(#)PEPSY:\td_netz.h\t1.2\t92/03/27 11:51:11";

/*********************************************************************
***                                                                ***
***  Modul:   d _ n e t z . h                                      ***
***                                                                ***
***----------------------------------------------------------------***
***                                                                ***
***  Datum:   10.07.87                                             ***
***  Version: 2.0 ( dynamische Speicherverwaltung )                ***
***  Autor:   Gerhard Schmuck                                      ***
***  Inhalt:  Definition systemgueltiger Netz- und Leistungs-      ***
***           groessen                                             ***
***                                                                ***
**********************************************************************
*/
#include "d_para.h"
/*
*************** Allgemeingueltige Netzparameter **********************
*/
typedef struct  {

      char   typ,                  /* Netztyp: 'c': geschlossen     */
                                   /*          'o': offen           */
			           /*          'm': gemischt     */
             knottyp   [TLEN][NMAX+1];  /* Knotentyp                */

      int    knot,                 /* Anzahl Knoten                 */
             klass,                /* Anzahl Auftragsklassen        */
             bede      [NMAX+1],   /* Anzahl Bedieneinh. pro Knoten */
             auft      [RMAX];     /* Anzahl Auftraege pro Klasse   */

      double ankr      [RMAX],     /* Klassen-Ankunftsrate          */
             **bedr,   /* [NMAX+1][RMAX]  Bedienraten               */
             **vark,   /* [NMAX+1][RMAX]  Q.Variationskoeffizienten */
             **besh;   /* [NMAX+1][RMAX]  Besuchshaeufigkeiten      */

      float  ***uew;   /* [NMAX+1][NMAX+1][RMAX] Uebergangswahrsch. */

}     netzparameter; 
/*

*************** Struktur fuer Einzel-Leistungsgroessen ***************
*/
typedef struct {

      double **lambda, /* [NMAX+1][RMAX]  Einzeldurchsaetze         */
             **rho,    /* [NMAX+1][RMAX]  Einzelauslastungen        */
             **vzeit,  /* [NMAX+1][RMAX]  Mittlere Verweilzeit      */
             **wzeit,  /* [NMAX+1][RMAX]  Mittlere Wartezeit        */
             **mauft,  /* [NMAX+1][RMAX]  Mittlere Auftragsanzahl   */
             **mqlen;  /* [NMAX+1][RMAX]  Mittl. Warteschlangenlen. */

}     leistgroessen;
/*
*************** Struktur fuer Knoten-Gesamt-Leistungsgroessen ********
*/
typedef struct {

      double lambda [NMAX+1],
             rho    [NMAX+1],
             vzeit  [NMAX+1],
             wzeit  [NMAX+1],
             mauft  [NMAX+1],
             mqlen  [NMAX+1];

}     gesamtleistgr;
/*
*************** Struktur fuer Netz-Leistungsgroessen *****************
*/
typedef struct {

      double lambda [RMAX],
             vzeit  [RMAX],
             wzeit  [RMAX],
             mauft  [RMAX],
             mqlen  [RMAX];
      char   typ    [RMAX];  /* Klassentyp o,c */

}     klassenleistgr;
/*
*************** Ende der Netzparameter-Definitionen *****************/

