/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tasymfkt.c\t1.3\t94/02/15 09:30:51";

/*********************************************************************
***                                                                ***
***  Modul:   a s y m f k t . c                                    ***
***                                                                ***
***----------------------------------------------------------------***
***                                                                ***
***  Datum:   07.04.92                                             ***
***  Version: 1.0                                                  ***
***  Autor:   Kirsten Roggenkamp                                   ***
***  Inhalt:  Funktionen zur Berechnung von Leistungsgroessen      ***
***           von asymmetrischen M/M/m-Knoten                      ***
***                                                                ***
**********************************************************************
*/
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "d_netz.h"

extern	void *malloc();
#define MINRHO 1e-32               /* Schranke fuer rho              */

extern netzparameter net;
extern leistgroessen lgr;
extern int fac();
/*
**********************************************************************
*                       Funktion mul_rho                             *
**********************************************************************
Hilfsfunktion fuer rho_zufall                                        
*/

double mul_rho(s,anz,rho)
int s,anz;
double rho[];
{
   double val = 0;
   int    i,j,k,l,m,n,o,p,q,r;


   switch(anz)
   {
      case 1:
      {
         for (i = 0; i < s; i++)
         val = val + rho[i];
         return(val);
      }
      case 2:
      {
         for (i = 0;   i < (s-1); i++)
         for (j = i+1; j < s    ; j++)
         val = val + rho[i]*rho[j];
         return(val);
      }
      case 3:
      {
         for (i = 0;   i < (s-2); i++)
         for (j = i+1; j < (s-1); j++)
         for (k = j+1; k < s    ; k++)
         val = val + rho[i]*rho[j]*rho[k];
         return(val);
      }
      case 4:
      {
         for (i = 0;   i < (s-3); i++)
         for (j = i+1; j < (s-2); j++)
         for (k = j+1; k < (s-1); k++)
         for (l = k+1; l < s    ; l++)
         val = val + rho[i]*rho[j]*rho[k]*rho[l];
         return(val);
      }
      case 5:
      {
         for (i = 0;   i < (s-4); i++)
         for (j = i+1; j < (s-3); j++)
         for (k = j+1; k < (s-2); k++)
         for (l = k+1; l < (s-1); l++)
         for (m = l+1; m < s    ; m++)
         val = val + rho[i]*rho[j]*rho[k]*rho[l]*rho[m];
         return(val);
      }
      case 6:
      {
         for (i = 0;   i < (s-5); i++)
         for (j = i+1; j < (s-4); j++)
         for (k = j+1; k < (s-3); k++)
         for (l = k+1; l < (s-2); l++)
         for (m = l+1; m < (s-1); m++)
         for (n = m+1; n < s    ; n++)
         val = val + rho[i]*rho[j]*rho[k]*rho[l]*rho[m]*rho[n];
         return(val);
      }
      case 7:
      {
         for (i = 0;   i < (s-6); i++)
         for (j = i+1; j < (s-5); j++)
         for (k = j+1; k < (s-4); k++)
         for (l = k+1; l < (s-3); l++)
         for (m = l+1; m < (s-2); m++)
         for (n = m+1; n < (s-1); n++)
         for (o = n+1; o < s    ; o++)
         val = val + rho[i]*rho[j]*rho[k]*rho[l]*rho[m]*rho[n]*rho[o];
         return(val);
      }
      case 8:
      {
         for (i = 0;   i < (s-7); i++)
         for (j = i+1; j < (s-6); j++)
         for (k = j+1; k < (s-5); k++)
         for (l = k+1; l < (s-4); l++)
         for (m = l+1; m < (s-3); m++)
         for (n = m+1; n < (s-2); n++)
         for (o = n+1; o < (s-1); o++)
         for (p = o+1; p < s    ; p++)
         val = val + rho[i]*rho[j]*rho[k]*rho[l]*rho[m]*rho[n]*rho[o]
                   * rho[p];
         return(val);
      }
      case 9:
      {
         for (i = 0;   i < (s-8); i++)
         for (j = i+1; j < (s-7); j++)
         for (k = j+1; k < (s-6); k++)
         for (l = k+1; l < (s-5); l++)
         for (m = l+1; m < (s-4); m++)
         for (n = m+1; n < (s-3); n++)
         for (o = n+1; o < (s-2); o++)
         for (p = o+1; p < (s-1); p++)
         for (q = p+1; q < s    ; q++)
         val = val + rho[i]*rho[j]*rho[k]*rho[l]*rho[m]*rho[n]*rho[o]
                   * rho[p]*rho[q];
         return(val);
      }
      case 10:
      {
         for (i = 0;   i < (s-9); i++)
         for (j = i+1; j < (s-8); j++)
         for (k = j+1; k < (s-7); k++)
         for (l = k+1; l < (s-6); l++)
         for (m = l+1; m < (s-5); m++)
         for (n = m+1; n < (s-4); n++)
         for (o = n+1; o < (s-3); o++)
         for (p = o+1; p < (s-2); p++)
         for (q = p+1; q < (s-1); q++)
         for (r = q+1; r < s    ; r++)
         val = val + rho[i]*rho[j]*rho[k]*rho[l]*rho[m]*rho[n]*rho[o]
                   * rho[p]*rho[q]*rho[r];
         return(val);
      }
   }
   return(0.0);
}


/*
**********************************************************************
*                       Funktion Zust_liste                          *
**********************************************************************
Hilfsfunktion fuer rho_zufall                             
*/

struct Zustand* Zust_Liste(s)  /* Erzeugung eine Liste von MARKOV-Zustaenden */
int s;                         /* Anzahl Bedienstationen                     */
{
   int i,j;                    /* Schleifenindices                           */
   int anz;                    /* Anzahl der zu erzeugenden Zustaende        */
   struct Zustand* first;      /* Zeiger auf ersten Zustand                  */
   struct Zustand* ptr;        /* Hilfszeiger                                */


   /* Anzahl Listenelemente feststellen */
   /* ================================= */
      anz = 1;
      for (i = 0; i < s; i ++)
      {
         anz = anz * 2;
      }
      anz = anz - 1;


   /* Erstes Element erzeugen und initialisieren */
   /* ========================================== */
      first = (struct Zustand *) malloc (sizeof(struct Zustand));
      for (i = 0; i < s; i++) first->belegt[i] = 0;
      first->anz   = 0;
      first->value = 1;
      first->next = NULL;
      ptr = first;
   

   /* weitere Elemente erzeugen und initialisieren */
   /* ============================================ */
      for (i = 0; i < (anz-1); i++)
      {
         ptr->next = (struct Zustand *) malloc (sizeof(struct Zustand));
         ptr = ptr->next;
         for (j = 0; j < s; j++) ptr->belegt[j] = 0;
         ptr->anz   = 0;
         ptr->value = 1;
         ptr->next = NULL;
      }


   /* Ruecksprung */
   /* =========== */
      return(first);
}



/*
**********************************************************************
*                       Funktion Ini_Liste                           *
**********************************************************************
Hilfsfunktion fuer rho_zufall                                        
*/

struct Zustand* Ini_Liste(ptr,anz,s) 
                               /* Initialisierung der Zustandsliste          */
struct Zustand* ptr;           /* Erstes zu initialisierendes Element        */
int anz;                       /* Anzahl belegter Zustaende                  */
int s;                         /* Anzahl Bedienstationen                     */
{
   int    i,j,k,l,m,n,o,p,q,r;

   switch(anz)
   {
      case 1:
      {
         for (i = 0; i < s; i++)
         {
            ptr->anz = 1;
            ptr->belegt[i] = 1;
            ptr = ptr->next;
         } 
         return(ptr);
      }
      case 2:
      {
         for (i = 0;   i < (s-1); i++)
         for (j = i+1; j < s    ; j++)
         {
            ptr->anz = 2;
            ptr->belegt[i] = 1; ptr->belegt[j] = 1;
            ptr = ptr->next;
         } 
         return(ptr);
      }
      case 3:
      {
         for (i = 0;   i < (s-2); i++)
         for (j = i+1; j < (s-1); j++)
         for (k = j+1; k < s    ; k++)
         {
            ptr->anz = 3;
            ptr->belegt[i] = 1; ptr->belegt[j] = 1;
            ptr->belegt[k] = 1;
            ptr = ptr->next;
         } 
         return(ptr);
      }
      case 4:
      {
         for (i = 0;   i < (s-3); i++)
         for (j = i+1; j < (s-2); j++)
         for (k = j+1; k < (s-1); k++)
         for (l = k+1; l < s    ; l++)
         {
            ptr->anz = 4;
            ptr->belegt[i] = 1; ptr->belegt[j] = 1;
            ptr->belegt[k] = 1; ptr->belegt[l] = 1;
            ptr = ptr->next;
         } 
         return(ptr);
      }
      case 5:
      {
         for (i = 0;   i < (s-4); i++)
         for (j = i+1; j < (s-3); j++)
         for (k = j+1; k < (s-2); k++)
         for (l = k+1; l < (s-1); l++)
         for (m = l+1; m < s    ; m++)
         {
            ptr->anz = 5;
            ptr->belegt[i] = 1; ptr->belegt[j] = 1;
            ptr->belegt[k] = 1; ptr->belegt[l] = 1;
            ptr->belegt[m] = 1;
            ptr = ptr->next;
         } 
         return(ptr);
      }
      case 6:
      {
         for (i = 0;   i < (s-5); i++)
         for (j = i+1; j < (s-4); j++)
         for (k = j+1; k < (s-3); k++)
         for (l = k+1; l < (s-2); l++)
         for (m = l+1; m < (s-1); m++)
         for (n = m+1; n < s    ; n++)
         {
            ptr->anz = 6;
            ptr->belegt[i] = 1; ptr->belegt[j] = 1;
            ptr->belegt[k] = 1; ptr->belegt[l] = 1;
            ptr->belegt[m] = 1; ptr->belegt[n] = 1;
            ptr = ptr->next;
         } 
         return(ptr);
      }
      case 7:
      {
         for (i = 0;   i < (s-6); i++)
         for (j = i+1; j < (s-5); j++)
         for (k = j+1; k < (s-4); k++)
         for (l = k+1; l < (s-3); l++)
         for (m = l+1; m < (s-2); m++)
         for (n = m+1; n < (s-1); n++)
         for (o = n+1; o < s    ; o++)
         {
            ptr->anz = 7;
            ptr->belegt[i] = 1; ptr->belegt[j] = 1;
            ptr->belegt[k] = 1; ptr->belegt[l] = 1;
            ptr->belegt[m] = 1; ptr->belegt[n] = 1;
            ptr->belegt[o] = 1;
            ptr = ptr->next;
         } 
         return(ptr);
      }
      case 8:
      {
         for (i = 0;   i < (s-7); i++)
         for (j = i+1; j < (s-6); j++)
         for (k = j+1; k < (s-5); k++)
         for (l = k+1; l < (s-4); l++)
         for (m = l+1; m < (s-3); m++)
         for (n = m+1; n < (s-2); n++)
         for (o = n+1; o < (s-1); o++)
         for (p = o+1; p < s    ; p++)
         {
            ptr->anz = 8;
            ptr->belegt[i] = 1; ptr->belegt[j] = 1;
            ptr->belegt[k] = 1; ptr->belegt[l] = 1;
            ptr->belegt[m] = 1; ptr->belegt[n] = 1;
            ptr->belegt[o] = 1; ptr->belegt[p] = 1;
            ptr = ptr->next;
         } 
         return(ptr);
      }
      case 9:
      {
         for (i = 0;   i < (s-8); i++)
         for (j = i+1; j < (s-7); j++)
         for (k = j+1; k < (s-6); k++)
         for (l = k+1; l < (s-5); l++)
         for (m = l+1; m < (s-4); m++)
         for (n = m+1; n < (s-3); n++)
         for (o = n+1; o < (s-2); o++)
         for (p = o+1; p < (s-1); p++)
         for (q = p+1; q < s    ; q++)
         {
            ptr->anz = 9;
            ptr->belegt[i] = 1; ptr->belegt[j] = 1;
            ptr->belegt[k] = 1; ptr->belegt[l] = 1;
            ptr->belegt[m] = 1; ptr->belegt[n] = 1;
            ptr->belegt[o] = 1; ptr->belegt[p] = 1;
            ptr->belegt[q] = 1;
            ptr = ptr->next;
         } 
         return(ptr);
      }
      case 10:
      {
         for (i = 0;   i < (s-9); i++)
         for (j = i+1; j < (s-8); j++)
         for (k = j+1; k < (s-7); k++)
         for (l = k+1; l < (s-6); l++)
         for (m = l+1; m < (s-5); m++)
         for (n = m+1; n < (s-4); n++)
         for (o = n+1; o < (s-3); o++)
         for (p = o+1; p < (s-2); p++)
         for (q = p+1; q < (s-1); q++)
         for (r = q+1; r < s    ; r++)
         {
            ptr->anz = 10;
            ptr->belegt[i] = 1; ptr->belegt[j] = 1;
            ptr->belegt[k] = 1; ptr->belegt[l] = 1;
            ptr->belegt[m] = 1; ptr->belegt[n] = 1;
            ptr->belegt[o] = 1; ptr->belegt[p] = 1;
            ptr->belegt[q] = 1; ptr->belegt[r] = 1;
            ptr = ptr->next;
         } 
         return(ptr);
      }
   }
   return(NULL);
}

/*
**********************************************************************
*                       Funktion rho_zufall                          *
**********************************************************************
Berechnet die Auslastung rho eines asymmetrischen Knotens nach Baer/
Fischer/Hertel bei zufaelliger Auswahl einer freien Bedieneinheit
*/

 double rho_zufall(i)
 int i;
 {
 double help;
 int    j;                           /* Schleifenindex                      */
 int    s;                           /* Anzahl Bedienstationen (max. 10)    */
 double quotient[10];                /* Quotient aus lambda und amue        */
 double eta[10];                     /* Kanalspezifische Auslastungen       */
 double h;                           /* Rueckgabewert                       */
 double P_0;                         /* Leerwahrscheinlichkeit              */
 double N;                           /* Hilfsgroesse fuer grossen Nenner    */
 double c;                           /* Hilfsgroesse                        */
 struct Zustand* first;              /* Zeiger auf ersten Zustand           */
 struct Zustand* last;               /* Zeiger auf letzten Zustand          */
 struct Zustand* ptr;                /* Hilfszeiger                         */
 struct Zustand* ini_ptr;            /* Hilfszeiger                         */

 extern double P_w;                  /* Wartewahrscheinlichkeit             */
 extern double mul_rho();
 extern struct Zustand * Zust_Liste();
 extern struct Zustand * Ini_Liste();


   /* Berechnung der Quotienten quotient[k] */
   /* ===================================== */
	s = net.bede[i];
      for (j = 0; j < s; j++)
      {
          quotient[j] = lgr.lambda[i][0] / net.amue[i][j];
      }


   /* Berechnung von P_0 */
   /* ================== */
      P_0 = 0;
      for (j = 1; j <= s; j++)
      {
          P_0 = P_0 + (fac(s-j) * mul_rho(s,j,quotient));
      }
      P_0 = (P_0 / fac(s)) + 1;
      P_0 = 1 / P_0;


   /* Berechnung der uebrigen Zustandswahrscheinlichkeiten */
   /* ==================================================== */
      /* Zustandsliste erstellen */
      /* ----------------------- */
         first = Zust_Liste(s);

      /* Liste initialisieren */
      /* -------------------- */
         ini_ptr = first;
         for (j = 1; j <= s; j++)
         {
            ptr = Ini_Liste(ini_ptr,j,s);
            ini_ptr = ptr;
         }

      /* Wahrscheinlichkeiten berechnen */
      /* ------------------------------ */
         ptr = first;
         while (ptr != NULL)
         {
            last = ptr;
		help = fac(s-(ptr->anz));
		help = help/fac(s);
		help = help * P_0;
		ptr->value = help;
            for (j = 0; j < s; j++)
            {
               if (ptr->belegt[j] == 1) 
                 { 
                     ptr->value = ptr->value * quotient[j];
                 }
            }
            ptr = ptr->next;
         }
           


   /* Berechnung der kanalspezifischen Auslastungsgrade fuer das */
   /* Verlustsystem                                              */
   /* ========================================================== */
      for (j = 0; j < s; j++) eta[j] = 0;
      ptr = first;
      while (ptr != NULL)
      {
         for (j = 0; j < s; j++)
         {
            if (ptr->belegt[j] == 1) eta[j] = eta[j] + ptr->value;
	   }
         ptr = ptr->next;
      }


   /* Berechnung von c */
   /* ================ */
      c = 0;
      for (j = 0; j < s; j++)
      {
          c = c + (1 / quotient[j]);
      }
      c = 1 / c;


   /* Berechnung von N */
   /* ================ */
      N = 1 + (last->value * c / (1 - c));


   /* Berechnung von P_w */
   /* ================== */
      P_w = (last->value) / (N * (1 - c));


   /* Berechnung der kanalspezifischen Auslastungen fuer das */
   /* Wartesystem                                            */
   /* ====================================================== */
      for (j = 0; j < s; j++)
      {
         eta[j] = (eta[j] + (last->value * c / (1 - c))) / N;
      }


   /* Auslastungsgrad des Gesamtsystems */
   /* ================================= */
      h = 0;
      for (j = 0; j < s; j++)
      {
         h = h + (1 / eta[j]);
      }
      h = s * (1 / h);


	return(h);
 } 


/*
**********************************************************************
*                       Funktion Verlust                             *
**********************************************************************
Berechnet die Verlustwahrscheinlichkeit nach Baer/Fischer/Hertel bei
Auswahl der schnellsten freien Bedieneinheit, Hilfsfunktion fuer       
rho_schnell
*/

double Verlust(anz,bedien,lam)
int anz;
double bedien[];
double lam;
{
   double value = 1;              /* Rueckgabewert                  */
   double bed_zaehler[10], 
	    bed_nenner[10];           /* Argumente fuer rekursiven Auf- */
                                  /* ruf der Funktion               */
   int i,k;                       /* Schleifenindices               */

   if (anz == 0)
	return(1);
   
   else if (anz == 1)
   {
	value = lam/(lam + bedien[0]);
	return(value);
   }

   else
   {
	for (k = 1; k < anz; k++)
	{
	   /* Feld fuer Bedienraten im Zaehler initialisieren */
	   /* =============================================== */
		for (i = 0; i < k-1; i++)
		   bed_zaehler[i] = bedien[i];
		bed_zaehler[k-1] = bedien[anz-1];


	   /* Feld fuer Bedienraten im Nenner initialisieren */
	   /* ============================================== */
		for (i = 0; i < k-1; i++)
		   bed_nenner[i] = bedien[i];
		bed_nenner[k-1] = bedien[k-1] + bedien[anz-1];

	   value = value * (Verlust(k,bed_zaehler,lam)/
		     Verlust(k,bed_nenner,lam));
	}

	value = 1 + (value * bedien[anz-1] / lam);
	value = 1 / value;
	value = value * Verlust(anz-1,bedien,lam);

	return(value);
   }
}

/*
**********************************************************************
*                       Funktion rho_schnell                         *
**********************************************************************
Berechnet die Auslastung rho eines asymmetrischen Knotens nach Baer/
Fischer/Hertel bei Auswahl der schnellsten freien Bedieneinheit
*/

double rho_schnell(i)
int i;
{
   int r;
   double eta[10]; 
   double P_v;
   double ce = 0, N = 0;
   double h =.0;
   extern double P_w;

    /* Berechnung der kanalspezifischen Auslastungsgrade fuer das */
    /* Verlustsystem                                              */
    /* ========================================================== */
	   for (r = 0; r < net.bede[i]; r++)
	      eta[r] = (lgr.lambda[i][0] / net.amue[i][r]) * 
			   (Verlust(r,net.amue[i],lgr.lambda[i][0]) 
		         - Verlust(r+1,net.amue[i],lgr.lambda[i][0]));


    /* Berechnung von ce */
    /* ================= */
       for (r = 0; r < net.bede[i]; r++)
           ce = ce + (1 / (lgr.lambda[i][0]/net.amue[i][r]));
       ce = 1 / ce;


    /* Berechnung von P_v */
    /* ================== */
       P_v = Verlust(net.bede[i],net.amue[i],lgr.lambda[i][0]);


    /* Berechnung von N */
    /* ================ */
       N = 1 + (P_v * ce / (1 - ce));


    /* Berechnung von P_w */
    /* ================== */
       P_w = P_v / (N * (1 - ce));


    /* Berechnung der kanalspezifischen Auslastungen fuer das */
    /* Wartesystem                                            */
    /* ====================================================== */
       for (r = 0; r < net.bede[i]; r++)
           eta[r] = (eta[r] + (P_v * ce / (1 - ce))) / N;


    /* Auslastungsgrad des Gesamtsystems */
    /* ================================= */
       h = 0;
       for (r = 0; r < net.bede[i]; r++)
           h = h + (1 / eta[r]);
       h = net.bede[i]*(1/h);


       return(h);
}

/*
*********************************************************************
*                       Funktion p_wart_sch                         *
*********************************************************************
Berechnet die Wartewahrscheinlichkeit nach Scheuerer
*/

double p_wart_sch(rho,m)
double rho;
int m;
{	
   int k, bed;
   double zaehler = 0, nenner = 0;

   bed = net.bede[m];

   zaehler = pow(bed * rho,(double) bed)/(fac(bed) * (1-rho));

   for (k = 0; k < bed; k++)
	nenner += pow(bed * rho, (double) k)/fac(k);

   nenner += pow(bed * rho, (double) bed)/(bed * (1-rho));

   return(zaehler/nenner);
}

/*
*********************************************************************
*                       Funktion p_wart_bfh                         *
*********************************************************************
Berechnet die Wartewahrscheinlichkeit nach Baer/Fischer/Hertel  
*/

/*double p_wart_bfh(rho,i,verf)
double rho;
int i;
int verf;*/                    /* 0 = zufaellige Auswahl              */
			           /* 1 = Auswahl der schnellsten BE      */
/*{
     int r;
     double h0 = 1.0;
     double p_bel = 0,c_ex = 0,N = 0;
     struct Zustand *ptr;

     if (rho >= 1.0)    return 1.0;
     if (rho <= MINRHO) return 0.0;

	    if (verf == 0)
	    {
           ptr = all_ws(i);
           while (ptr->next != NULL) ptr = ptr->next;
           p_bel = ptr->value;
	    }
	    else
	    {
	       p_bel = Verlust(net.bede[i],net.amue[i],lgr.lambda[i][0]);
	    }

        for (r = 0; r < net.bede[i]; r++) 
	       c_ex = c_ex + (net.amue[i][r]/lgr.lambda[i][0]);
        c_ex = 1 / c_ex;

        N = 1 + (p_bel * c_ex / (1 - c_ex));

        h0 = p_bel / (N * (1 - c_ex));
        return(h0);

}*/

/*
*********************************************************************
*                       Funktion q_quer                             *
*********************************************************************
Berechnet die mittlere Warteschlangenlaenge nach Baer/Fischer/Hertel
*/

double q_quer(rho,i,verf)
double rho;
int i;
int verf;
{
   double  c = 0;
   extern double P_w;
   int j;

   for (j = 0; j < net.bede[i]; j++)
	c += net.amue[i][j] / lgr.lambda[i][0];
   c = 1/c;

   return((P_w * c) / (1- c));
}

/*
******************** Ende Modul asymfkt.c **************************/

