/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tio_berv.c\t1.5\t94/02/03 16:54:45";

/*********************************************************************
***                                                                ***
***  Modul:   i o _ b e r v . c                                    ***
***                                                                ***
***----------------------------------------------------------------***
***                                                                ***
***  Datum:   13.08.87                                             ***
***  Version: 1.0                                                  ***
***  Autor:   Gerhard Schmuck                                      ***
***  Inhalt:  Funktionen fuer standartisierte Verfahrensausgaben   ***
***                                                                ***
**********************************************************************
*/
#include <stdio.h>
#include "d_netz.h"

extern leistgroessen  lgr;
extern klassenleistgr kls;
extern netzparameter  net;
/*
**********************************************************************
*                        Funktion OUT_EINZLGR                        *
**********************************************************************
Ausgabe von Einzelleistungsgroessen auf die Standartausgabe
*/
void OUT_EINZLGR ( knot, klas)
int   knot, klas;
{
      int   kn, kl, i;
	double mueges;

      for ( kl=0; kl < klas; kl++) {
            printf ( "\n");
            for ( kn=1; kn <= knot; kn++) {
                  printf ( "%8.5f  ", lgr.lambda[kn][kl]);

		if(net.ankr[kl] == 0.0 )
			printf("%8.5f  ",lgr.lambda[kn][kl] / lgr.lambda[1][kl]  );
		else
			printf ( "%8.5f  ", lgr.lambda[kn][kl] / net.ankr[kl]);

		  if (net.bedr[kn][kl] == 0)
		    printf ( "%8.5f  ", 0.0);
		  else
		  {
		     if (net.knottyp[kn] == 20)
		     {
			  for (i = 0; i < net.bede[kn]; i++)
			     mueges += net.amue[kn][i];
                    printf ( "%8.5f  ", 1/mueges);
		     }
		     else
                    printf ( "%8.5f  ", 1/net.bedr[kn][kl]);
		  } 

                  printf ( "%8.5f  ", lgr.rho   [kn][kl]);
                  printf ( "%8.5f  ", lgr.vzeit [kn][kl]);
                  printf ( "%8.5f  ", lgr.mauft [kn][kl]);
                  printf ( "%8.5f  ", lgr.wzeit [kn][kl]);
                  printf ( "%8.5f  ", lgr.mqlen [kn][kl]);
                  printf ( "\n");
            }
      }
}
/*
********************************************************************
*                      Funktion OUT_KLASLGR                        *
********************************************************************
Ausgabe der Netzgroessen ( Klassengroessen) auf die Standartausgabe
*/
void OUT_NETZLGR ( klas)
      int  klas;
{
      int  kl;

      printf ( "# NETZGROESSEN\n");
      printf ( "# KlNr.    typ      lambda     mvz       maa       mwz");
      printf ( "       mwsl\n");
      for ( kl=0; kl < klas; kl++) {
            printf ( "  %3d   ", kl+1);
            printf ( "    %c     ", kls.typ[kl]);
            printf ( "%8.5f  ", kls.lambda[kl]);
            printf ( "%8.5f  ", kls.vzeit [kl]);
            printf ( "%8.5f  ", kls.mauft [kl]);
            printf ( "%8.5f  ", kls.wzeit [kl]);
            printf ( "%8.5f  ", kls.mqlen [kl]);
            printf ( "\n");
      }
}
/*
*********************************************************************
*                        Funktion OUT_STDKOPF                       *
*********************************************************************
Ausgabe des Standartkopfes
*/
void OUT_STDKOPF ( verfahren, netztyp, knoten, klassen)
      char  *verfahren, netztyp;
      int   knoten, klassen;
{
      printf ( "\n%s\n\n", verfahren);
      switch(netztyp)
      {
	case 'c':
		printf("1  ");
		break;
	case 'o':
		printf("2  ");
		break;
	case 'm':
		printf("4  ");
		break;
	default:
		break;
      }
      printf("%d  %d\n",knoten,klassen);
}
/*
********************* Ende Modul io_berv.c *************************/
