/*

					             P E P S Y 

			Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
				Universitaet Erlangen-Nuernberg,
				Lehrstuhl fuer Betriebssysteme
				Martensstrasse 1

				8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

/*
 #####   ######   ####     ##    #
 #    #  #       #    #   #  #   #
 #    #  #####   #       #    #  #
 #####   #       #       ######  #
 #   #   #       #    #  #    #  #
 #    #  ######   ####   #    #  ######

 programmiert von Otto Niesser
*/

static char *SccsId = "@(#)PEPSY:\trecal.c\t1.2\t92/03/27 11:52:32";

#include <stdio.h>

#define BOOLEAN int
#define TRUE 1
#define FALSE 0

#define AND &&
#define OR ||
#define NOT ! 

/*        Festlegung des Gleitkommaformats                              */
/*        bei float : REAL_FORM = "%9.5f "                              */
/*                    REAL_READ = "%f"                                  */
/*                                                                      */
/*        bei double: REAL_FORM = "%9.5lf "                             */
/*                    REAL_READ = "%lf"                                 */

#define REAL double 
#define REAL_FORM "%9.5lf "
#define REAL_READ "%lf"

/*        Makro zum Einlesen aus stdio mit Fehlerbehandlung             */

#define LIES(A,B)       scanf(A,&B);                                    \
					              if((REAL)B < 0.0)                               \
					              {                                               \
					                f_eingabe = TRUE;                             \
					                fehler = TRUE;                                \
					                return;                                       \
					              }                

/*        Makro zur Speicherplatzbelegung mit Erfolgsueberpruefg        */

#define ALLOCATE(P,S,T) P=(T*)calloc((unsigned)(S),sizeof(T));          \
					              if(P == NULL)                                   \
					              {                                               \
					                f_speicher = TRUE;                            \
					                fehler = TRUE;                                \
					                return;                                       \
					              }                                               \
					              else                                            \
					                mem += (S) * sizeof(T); 

/*        Runden                                                        */

#define INT(X)          (int)(X + 0.5)

/*        Abbildung 2-dim Index -> 1-dim Index                          */

#define IND2(I,J) ((I) * R + J)

#define IND_R(I,J) ((J) * R + I)

/*        n ueber k                                                     */

#define UEBER(N,K) (ffak[N] / (ffak[K] * ffak[N - (K)]))

/*        Anzahl von moeglichen Kombinationen                           */

#define ANZ(AUFTR,PL) UEBER(AUFTR + PL - 1,PL - 1)

/*        Globale Variablen                                             */

struct  pg { REAL *ptr; }; /* fuer Gst                                  */

int     *K,                /* Populationsvektor                         */
				Kst,               /* Anzahl Auftraege insgesamt                */
				*v,                /* Hilfsvektor fuer Gst                      */
				M,                 /* Anzahl der Knoten                         */
				*kn_typ,           /* Knotentyp                                 */
				typ_3_kn,          /* Ist ein Typ 3 Knoten im Netz?             */
				*anz_bs,           /* Anzahl Bedienstationen bei M/M/k          */
				R,                 /* Anzahl der Klassen                        */
				*r,                /* Numerierung der Auftraege                 */
				ue_w;              /* Flag fuer Uebergangsw'keiten              */
struct pg *Gst;            /* Hilfsfunktion fuer Normalisierungsconst.  */
REAL    *mue,              /* Bedienrate                                */
				*e,                /* Besuchshaeufigkeiten                      */
				*t,                /* Mittlere Verweilzeit                      */
				*lambda,           /* Durchsatz                                 */
				*k,                /* Mittlere Auftragszahl                     */
				*rho,              /* Auslastung                                */
				*ffak;             /* Tabelle der Fakultaeten                   */
BOOLEAN f_eingabe=FALSE,   /* Eingabefehler                             */
				f_speicher=FALSE,  /* kein Speicher mehr frei                   */
				f_uew=FALSE,       /* Uebergangsw'keiten nicht mehr unterstuetzt*/
				fehler=FALSE;      /* allgemeiner Fehler                        */
BOOLEAN typ_5_kn;          /* Ist ein M/M/k - Knoten im Netz ->         */ 
					                 /* Sonderbehandlung                          */

char    *calloc();

int     mem = 0;           /* benoetigter Speicherplatz                 */

/*        Schleife ueber alle Populationen                              */

pop_loop(n,N,call,arg1,arg2)
int         *n,N,call,arg1,arg2;
{
	REAL hilf;
	REAL sum;
	int i,j,rr,uebertrag;
	REAL last(); 

	uebertrag = 0;
	for (i = 0; i < M; i++)
		n[i] = 0;
	do
	{
		if ((NOT fehler) AND (i_sum(n,M) == N))
		{
			switch (call)
			{
				case 1: /* Initialisierung */
					      Gst[0].ptr[ind(0,n)] = 1.0;
					      break;
				case 2: /* Initialisierung und Verfahren */
					      hilf = 0.0;
					      rr = IND_R(arg2,arg1-1);
					      for (i = 0; i < M; i++)
					      {
					        n[i]++;
					        hilf += (1 + (n[i] - 1)*delta(i)) * 
					          e[IND2(i,r[rr]-1)] /
					          last(i,n[i]) / 
					          mue[IND2(i,r[rr]-1)] *
					          Gst[arg1-1].ptr[ind(arg1-1,n)];
					        n[i]--;
					      }
					      Gst[arg1].ptr[ind(arg1,n)] = hilf;
					      break;
			} 
		}

		n[0]++;
		for (i = 0; i < M; i++)
		{
			n[i] += uebertrag;
			if (n[i] > N)
			{
				n[i] = 0;
				uebertrag = 1;
			}
			else
				if (i_sum(n,M) > N)
				{
					n[i] = 0;
					uebertrag = 1;
				}
				else
					uebertrag  = 0;
		}
	}while (uebertrag == 0);
}

/*        Initialisierung des Verfahrens                                */

verf_init()
{
	int k;

	pop_loop(v,Kst,1,0,0);

	for (k = 0; k < Kst; k++)
		r[IND_R(0,k)] = r_bed_i(k);

	for (k = 1; k <= Kst-R; k++)
		pop_loop(v,Kst - k,2,k,0);
}

/*        Berechnungsschritt des Recalalgorithmus                       */

verfahren()
{
	int s,i,j,ii,x;
	REAL lambda_st,k_st,last();

	for ( s = 0; s < R; s++)
	{
		x = Kst - R + s;

		for ( i = x; i <= Kst; i++)
			if (i > 0)
				pop_loop(v,Kst - i,2,i,s);
		
		for ( i = 0; i < M; i++)
		{
			ii = IND2(i,s);
			if (typ_3_kn == -1)
			{
				lambda_st = 0.0;
				for(j = 0; j < M; j++)
				{
					null(v);
					v[j]++;
					lambda_st += Gst[Kst-1].ptr[ind(Kst-1,v)] /
					  (Gst[Kst].ptr[0] * (M + Kst - 1));
				}
			}
			else
			{
				null(v);
				v[typ_3_kn]++;
				lambda_st = Gst[Kst-1].ptr[ind(Kst-1,v)] /
					Gst[Kst].ptr[0];
			} 
			lambda_st *= e[ii];

			lambda[ii] = K[s] * lambda_st;

			null(v);
			v[i]++;
			k_st = Gst[Kst-1].ptr[ind(Kst-1,v)] /
				Gst[Kst].ptr[0] *
				e[ii] / mue[ii]  / last(i,1) ;

			k[ii] = K[s] * k_st;
		}

		if (s == R-1) break;

		for (i = 0; i < Kst; i++)
			r[IND_R(s+1,i)] = r_bed_v(s,i);

		x++;
		pop_loop(v,Kst - x,2,x,s+1);
	}

	for (i = 0; i < M; i++)
		for (j = 0; j < R; j++)
		{
			if (kn_typ[i] == 5)
				rho[IND2(i,j)] = lambda[IND2(i,j)] /(anz_bs[i] * mue[IND2(i,j)]);
			else
				rho[IND2(i,j)] = lambda[IND2(i,j)] / mue[IND2(i,j)];

			if (kn_typ[i] == 3)
				t[IND2(i,j)] = 1 / mue[IND2(i,j)];
			else
	if (lambda[IND2(i,j)] > 0.0)
					t[IND2(i,j)] = k[IND2(i,j)] / lambda[IND2(i,j)];
				else
					t[IND2(i,j)] = 0.0;
		}
}

/*        Ausgabe                                                       */

aus()
{
	/*		Sccs support from SccsLogging.c			*/	
	extern int SccsRelease;
	extern int SccsLevel;

	int i,j,kk;

	if (typ_5_kn)
		M--;
	
	printf("# Verfahrensname \n");
	printf("  recal \n");
	printf("# Version %d.%d\n\n",SccsRelease, SccsLevel);
	printf("# Speicherplatzbedarf: %d Bytes\n\n",mem);

	printf("# Netztyp Knoten Klassen \n");
	printf("  %d       %d      %d \n\n",1,M,R);

	printf("# fuer alle Klassen \n");
	printf("#    fuer alle Knoten \n");
	printf("# lambda    e         1/mue     rho       mvz       ");
	printf("maa       mwz       mwsl \n");
	for (j = 0; j < R; j++)
	{
		for (i = 0; i < M; i++)
		{
			printf(REAL_FORM,lambda[IND2(i,j)]); 
			printf(REAL_FORM,e[IND2(i,j)]); 
			printf(REAL_FORM,1/mue[IND2(i,j)]);

			if (e[IND2(i,j)] > 0.0)
			{     
				if (kn_typ[i] == 3)
				{ printf("%9.5f ",0.0); }
				else
					printf(REAL_FORM,rho[IND2(i,j)]); 

				printf(REAL_FORM,t[IND2(i,j)]);
				printf(REAL_FORM,k[IND2(i,j)]);

				if (kn_typ[i] == 3)
				{ printf("%9.5f %9.5f ",0.0,0.0); }
				else
				{
					printf(REAL_FORM,t[IND2(i,j)] - 1/mue[IND2(i,j)]);
					printf(REAL_FORM,lambda[IND2(i,j)] * (t[IND2(i,j)] - 
					  1/mue[IND2(i,j)])); 
				}
			}
			else
				for (kk = 0; kk < 5; kk++)
					printf("%9.5f ",0.0);
			printf("\n");
		}
		printf("\n");
	}
}

/*        Ausgabe im Fehlerfall                                         */

fehler_aus()
{
	if (f_eingabe)
	{ 
		fprintf(stderr,"fehlerhafte Eingabedatei \n"); 
		printf("recal_eingabe\n0 0 0 \n");
	}

	if (f_speicher)
	{ 
		fprintf(stderr,"nicht genug Speicher vorhanden \n"); 
		printf("recal_speicher\n0 0 0 \n");
	}

	if (f_uew)
	{ 
		fprintf(stderr,
					  "Uebergangsw'keiten ab v0.07 nicht mehr unterstuetzt \n"); 
		printf("recal_uew\n0 0 0 \n");
	}
}

/*        Initialisierung der Variablen                                */
/*        Falls ein M/M/k - Knoten im Netz ist, aber kein              */
/*        Typ-3-Knoten, so wird ein IS mit e=0 eingefuegt,             */
/*        da der Algorithmus sonst nicht funktioniert.                 */

init()
{
	int i,j,kk;
	int MR;

	LIES("%d",M);
	LIES("%d",R);

	if ((M == 0) OR (R == 0))
	{
		fehler = TRUE;
		f_eingabe = TRUE;
		return;
	}
 
	M++;

	MR = M * R;
	ALLOCATE(v,M,int)
	ALLOCATE(K,R,int)
	ALLOCATE(kn_typ,M,int)
	ALLOCATE(anz_bs,M,int)
	ALLOCATE(mue,MR,REAL)
	ALLOCATE(e,MR,REAL)
	ALLOCATE(k,MR,REAL)
	ALLOCATE(t,MR,REAL)
	ALLOCATE(rho,MR,REAL)
	ALLOCATE(lambda,MR,REAL)

	M--;

	typ_3_kn = -1;
	typ_5_kn = FALSE;

	for (i = 0; i < M; i++)
	{ 
		LIES("%d",kn_typ[i]);

		if (kn_typ[i] == 3)
			typ_3_kn = i;

		if (kn_typ[i] == 5) /* M/M/k */
		{ 
			LIES("%d",anz_bs[i]);
			typ_5_kn = TRUE;
		}
	}
 
	Kst = 0;

	for (j = 0; j < R; j++)
	{ 
		LIES("%d",K[j]);
		Kst += K[j];
	}

	LIES("%d",ue_w);
	
	if (NOT ue_w)
		for (j = 0; j < R; j++)
		{
			for (i = 0; i < M; i++)
			{
				LIES(REAL_READ,mue[IND2(i,j)]);
				LIES(REAL_READ,e[IND2(i,j)]);
			}
		}
	else
	{
		fehler = TRUE;
		f_uew = TRUE;
		return;
	}

	if (typ_5_kn AND (typ_3_kn == -1))
	{
		for (j = 0; j < R; j++)
		{
			e[IND2(M,j)] = 0.0;
			mue[IND2(M,j)] = 1.0;
		}
		typ_3_kn = M;
		M++;
	}
	else
		typ_5_kn = FALSE;

	ALLOCATE(ffak,Kst+M,REAL)
	ffak[0] = 1.0;
	for (i = 1; i < Kst + M; i++)
		ffak[i] = ffak[i-1] * (REAL)i;

	ALLOCATE(r,R*Kst,int)

	ALLOCATE(Gst,Kst + 1,struct pg)
	for (i = 0; i <= Kst; i++)
	{ ALLOCATE(Gst[i].ptr,INT(ANZ(Kst-i,M)),REAL) }

	verf_init();
}

/*        Abbildung M+1-dim Index -> 1-dim Index                        */

ind(i,n)
int i,*n;
{
	int j,k,sum,hilf;

	sum = 0;
	hilf = Kst - i;
	for (k = 0; k < M - 1; k++)
	{
		for (j = 0; j <= v[k] - 1; j++)
			sum += INT(ANZ(hilf - j,M - 1 - k));
		hilf -= v[k]; 
	}
		
	return(sum);
}

/*        Last-funktion                                                 */

REAL last(i,k)
int i,k;
{
	if (kn_typ[i] == 5)
	{
		if(k <= anz_bs[i])
			return((REAL)k);
		else
			return((REAL)anz_bs[i]);
	}
	return(1.0);
}

/*        Integer-summe                                                 */

i_sum(a,b)
int *a,b;
{
	int s;
	
	s = 0;
	b--;
	for (; b >= 0; b--)
		s += a[b];
	return(s);
}

/*        r - Bedingung bei der Initialisierung                         */

r_bed_i(k)
int k;
{
	int i,rueck;

	k++;
	for (i = 0; i < R; i++)
		K[i]--;

	if (k <= K[0]) 
		rueck = 1;
	else if ((k > K[0]) AND (k <= Kst - R))
		for (i = 2; i <= R; i++)
		{
			if (k <= i_sum(K,i))
			{ 
				rueck = i; 
				break;
			}
		}
	else 
		rueck = 1 - k + Kst; 

	for (i = 0; i < R; i++)
		K[i]++;

	return (rueck);
}

/*        r - Bedingung im Verfahren                                    */

r_bed_v(s,k)
int s,k;
{
	int rueck;

	if (k == s + Kst - R) 
		rueck = s+1;
	else if (k < s + Kst - R)
		rueck = r[IND_R(s,k)];
	else 
		rueck = r[IND_R(s,k)] + 1;

	return(rueck);
}

/*        Delta-Funktion                                                */

delta(k)
int k;
{
	int rueck;

	switch (kn_typ[k])
	{
		case 1: ;
		case 2: ;
		case 5: ;
		case 4: rueck = 1;
					  break;

		case 3: rueck = 0;
					  break;
	}
	return(rueck);
}

null(n)
int *n;
{
	int i;
 
	for (i = 0; i < M; i++)
		n[i] = 0;
}

/*        Hauptprogramm                                                 */

void abbruch(sig)
int sig;
{
				printf("recal_signal_%d\n 0 0 0 \n", sig);
				exit(1);
}

main(argc, argv)
	int argc;
		char *argv[];
{
	/*		Sccs support from SccsLogging.c			*/	
	extern int SccsRelease;
	extern int SccsLevel;

	int i;
	void abbruch();

	for (i=1; i<12; i++)
		signal (i, abbruch);

	if ((argc > 1) && (!strcmp(argv[1], "-V")))    /* kirschni 22.11.1991 */
	{
		fprintf(stdout, "%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
		exit(0);
	}


	init();
	if (NOT fehler)
		verfahren();
	if (NOT fehler)
	{
		aus();
		exit(0);
	}
	else
	{
		fehler_aus();
		exit(1);
	}
}

