/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tausgabe.c\t1.2\t92/03/27 11:52:44";

#include <stdio.h>
#include <string.h>
#include "d_scat.h"

/***********************************************************

  FUNKTION
  ausgabe()

  Wird aufgerufen in:
  - HAUPTPROGRAMM
    SCAT-Alg.        gespeichert auf File  "scat.c"
  - HAUPTPROGRAMM
    LINEARIZER             "      "    "   "LINEARIZER.c"

 Legt die berechneten Leistungsgroessen mit zugehoerigem  
 Text auf dem File "datei-aus" ab.

***********************************************************/

ausgabe(verfahren)
char	verfahren[];
{
 extern	int 	R;           	/* Anzahl der Auftragsklassen */
 extern	int 	N;           	/* Anzahl der Knoten */
 extern double 	**my;
                    	/* mittlere Bedienrate pro */
                    	/* Knoten und Klasse */
 extern double 	**ee;
                    	/* Besuchshaeufigkeiten pro */
                    	/* Knoten und Klasse */
 extern	double	***k;
                    	/* mittlere Auftragszahl pro */
                    	/* Knoten und Klasse; ist der */
                    	/* 3. Index 0 fuer die gesamte */
                    	/* Population,sonst bei Entfernen */
                    	/* eines Auftrags der jeweiligen */
                    	/* Klasse */
 extern	double  **t;
                    	/* mittlere Verweilzeit pro */
                    	/* Knoten und Klasse */
 extern	double  **lamda;
                    	/* Durchsatz pro Knoten und Klasse */
 extern	double  **rho;
                    	/* Auslastung pro Knoten und Klasse */
 extern	double  **w;
                    	/* mittlere Wartezeit pro */
                    	/* Knoten und Klasse */
 extern	double  **q;
                    	/* mittlere Warteschlangenlaenge pro */
                    	/* Knoten und Klasse */

 int	i,r;

 /* Ausgabe der Leistungsgroessen fuer alle Klassen */

 if (strcmp(verfahren,"scat") == 0)
   fprintf(stdout,"  scat\n\n");
 else
   fprintf(stdout,"  linearizer\n\n");
 fprintf(stdout,"  1  ");		/* geschlossenes Netz	*/
 fprintf(stdout,"  %d  ",N);		/* Anzahl Knoten	*/
 fprintf(stdout,"  %d  \n\n",R);	/* Anzahl Klassen	*/

 for ( r=0; r<R; r++ )
 {
     for ( i=0; i<N; i++ )
     {
      	fprintf(stdout,"%8.4f  ",lamda[i][r]);
      	fprintf(stdout,"%8.4f  ",ee[i][r]);
      	fprintf(stdout,"%8.4f  ",1/my[i][r]);
      	fprintf(stdout,"%8.4f  ",rho[i][r]);
      	fprintf(stdout,"%8.4f  ",t[i][r]);
      	fprintf(stdout,"%8.4f  ",k[i][r][0]);
      	fprintf(stdout,"%8.4f  ",w[i][r]);
      	fprintf(stdout,"%8.4f  ",q[i][r]);
     	fprintf(stdout,"\n");
     }
     fprintf(stdout,"\n");
 }
} /* Ende ausgabe */
