/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\teingabe.c\t1.2\t92/03/27 11:52:48";

#include <stdio.h>
#include "d_scat.h"
#include "xxalloc.h"

/***********************************************************

  FUNKTION
  eingabe()

  Wird aufgerufen in:
  - HAUPTPROGRAMM
    SCAT            gespeichert auf File  "scat.c"

Die Funktion liest die Eingabedaten von "stdin" 

***********************************************************/

static int dbg = 0;

eingabe()
{
    extern	int   	netz;    	/* Netztyp	*/
    extern	int 	N;           	/* Anzahl der Knoten */
    extern	int 	R;           	/* Anzahl der Auftragsklassen */
    extern	int     **Auftr;
                    	/* Anzahl der Auftraege pro Klasse */
                    	/* ist der 2. Index 0,wird die ganze */
                    	/* Population betrachtet,sonst die */
                    	/* Population bei Entfernen eines */
                    	/* Auftrags der jeweiligen Klasse */
    extern	int	*BE;
			/* Anzahl der identischen */
                    	/* Bedieneinheiten pro Knoten */
    extern	int	BEmax;

    extern	double 	**my;
                    	/* Bedienrate pro Knoten und Klasse */
    extern	int   	haeuf; 	/* Besuchshaeufigkeiten oder Uebergangsw. ? */
    extern	double	**ee;
                    	/* Besuchshaeufigkeiten pro */
                    	/* Knoten und Klasse */

    int		i,j,r;		/* Laufvariablen		*/

    /* Netztyp */
    fscanf(stdin,"%d",&netz);
	if (dbg) fprintf(stderr,"netz = %d\n",netz);

    /* Knoten */
    fscanf(stdin,"%d",&N);
	if (dbg) fprintf(stderr,"N = %d\n",N);

    /* Klassen */
    fscanf(stdin,"%d",&R);
	if (dbg) fprintf(stderr,"R = %d\n",R);

    Auftr = i2_alloc(0,R-1, 0,R);
    BE = i1_alloc(0,N-1);
    my = d2_alloc(0,N-1, 0,R-1);
    ee = d2_alloc(0,N-1, 0,R-1);

    /* Auftraege pro Klasse */
    for ( r=0; r<R; r++ )
	{
        fscanf(stdin,"%d",&Auftr[r][0]);
		if (dbg) fprintf(stderr,"Auftr = %d\n",Auftr[r][0]);
	}

    /* Bedieneinheiten pro Knoten */
    BEmax = 0;
    for ( i=0; i<N; i++ )
	{
        fscanf(stdin,"%d",&BE[i]);
	if (BE[i] > BEmax)
	    BEmax = BE[i];

		if (dbg) fprintf(stderr,"BE = %d\n",BE[i]);
	}

    /* Besuchshaeufigkeiten o. Uebergangswahrscheinlichkeiten */
    fscanf(stdin,"%d",&haeuf);

    if ( haeuf==1 )  /* Uebergangswahrscheinlichkeiten */
    {
	fprintf(stderr,"Uebergangsw'keiten nicht unterstuetzt\n");
	printf("scat_uebergaenge\n 0 0 0 \n");
	exit(1);
    }

    else     /* Besuchshaeufigkeiten */
    {

        for ( r=0; r<R; r++ )
		   for ( i=0; i<N; i++ )
		{
            fscanf(stdin,"%lf",&ee[i][r]);
			if (dbg) fprintf(stderr,"ee = %lf\n",ee[i][r]);
		}
    }

    /* Bedienraten */
	for ( r=0; r<R; r++ )
		for ( i=0; i<N; i++ )
		{
            fscanf(stdin,"%lf",&my[i][r]);
			if (dbg) fprintf(stderr,"my = %lf\n",my[i][r]);
		}

} /* Ende eingabe */
