/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

static char *SccsId = "@(#)PEPSY:\tergebnis.c\t1.2\t92/03/27 11:52:50";

#include "d_scat.h"

/***********************************************************

  FUNKTION
  Leistungsgroessen()

  Wird aufgerufen in 
  - HAUPTPROGRAMM
    SCAT          gespeichert auf File  "scat.c"
  - HAUPTPROGRAMM
    LINEARIZER          "      "    "   "LINEARIZER.c"

Berechnet aus den mittleren Verweilzeiten und den mittleren
Auftragszahlen den Durchsatz,die Auslastung,die mittlere
Wartezeit und die mittlere Warteschlangenlaenge pro Knoten
und Klasse.

***********************************************************/

Leistungsgroessen()
{
 extern	int 	R;           	/* Anzahl der Auftragsklassen */
 extern	int 	N;           	/* Anzahl der Knoten */
 extern	int	*BE;
			/* Anzahl der identischen */
                    	/* Bedieneinheiten pro Knoten */

 extern	double 	**my;
                    	/* Bedienrate pro Knoten und Klasse */
                    	/* Knoten und Klasse */
 extern	double	***k;
                    	/* mittlere Auftragszahl pro */
                    	/* Knoten und Klasse; ist der */
                    	/* 3. Index 0 fuer die gesamte */
                    	/* Population,sonst bei Entfernen */
                    	/* eines Auftrags der jeweiligen */
                    	/* Klasse */
 extern double  **t;
                    	/* mittlere Verweilzeit pro */
                    	/* Knoten und Klasse */
 extern double  **lamda;
                    	/* Durchsatz pro Knoten und Klasse */
 extern double  **rho;
                    	/* Auslastung pro Knoten und Klasse */
 extern double  **w;
                    	/* mittlere Wartezeit pro */
                    	/* Knoten und Klasse */
 extern double  **q;
                    	/* mittlere Warteschlangenlaenge pro */
                    	/* Knoten und Klasse */
 int i,r;

 /* fuer alle Knoten und Klassen */
 for ( i=0; i<N; i++ )
     for ( r=0; r<R; r++ )
        {

         if ( t[i][r]==0.0 )
            lamda[i][r]=0.0;
         else
            lamda[i][r]=k[i][r][0]/t[i][r];

         if ( BE[i]==0 || my[i][r]==0.0 )
           {
            rho[i][r]=0.0;
            w[i][r]=0.0;
            q[i][r]=0.0;
           }
         else if ( BE[i] == 1)
           {
            rho[i][r]=lamda[i][r]/(my[i][r]*BE[i]);
            if ( t[i][r]<=1/my[i][r] )
               w[i][r]=0.0;
            else
               w[i][r]=t[i][r]-1/my[i][r];
            q[i][r]=lamda[i][r]*w[i][r];
           }
		else /* BE[i] > 1 */
		{
            rho[i][r]=lamda[i][r]/(my[i][r]*BE[i]);
			/*
			rho[i][r] = -1.0;
			*/
            if ( t[i][r]<=1/my[i][r] )
               w[i][r]=0.0;
            else
               w[i][r]=t[i][r]-1/my[i][r];
            q[i][r]=lamda[i][r]*w[i][r];
		}
        }

} /* Ende Leistungsgroessen */
