static char *SccsData_h = "@(#)PEPSY:\tdata.h\t1.2\t92/03/27 11:53:09";
#ifndef DATA_H
#define DATA_H

#include "modell.h"
#include "lists.h"

#ifndef TRUE
#define TRUE			1
#define FALSE			0
#endif

#define NOTFOUND		-1

#define OK				TRUE
#define NOTOK			FALSE
#define UNABHAENGIG	TRUE
#define ABHAENGIG		FALSE

#define DUMPFILE		"Sim.Dump"
#define TRACEFILE		"Sim.Trace"

#define WARMUP_SP		1			/* Phasen der Simulation */
#define INDEPE_SP		2
#define CIMINI_SP		3
#define ENDE_SP		4

typedef int					boolean;
typedef unsigned long	tunit;

struct KI {
	double	mw;
	double	breite;
	double	quality;
};

struct AUSSEN {
	int		PassedJobs;
	int		BatchJobs;
	tunit		Verweilzeit;

	char	  *Name;
	int		KlassenTyp;

	double  *BatchMean;
};

struct JOB {
	struct LNode	 Node;	/* Zur Verkettung */

	struct EVENT	*Event;

	int				 Klasse;
	tunit				 ErschaffungsZeit;
	tunit				 RestBearbZeit;

	tunit				 suspendTime;
	tunit				 suspendBE;
};

#define COMPLETE_ET	1
#define ARRIVAL_ET	2
#define BATCHEND_ET	3
#define DEBUG_ET		4

struct EVENT {
	struct LNode Node;		/* Zur Verkettung */

	int			 Typ;

	union {	         		/* Bei Ankunft ZielWs, bei Completition Verursacher*/
		int		 Verursacher;
		int		 ZielWs;
	}				 Nr;
	struct JOB	*Job;
};

/*********************************************** Bedieneinheiten ***********/
#define WORK_ST		0						/* BE-Status */
#define IDLE_ST		1

struct BE_DATA {								/* Daten der BE fuer jede Klasse */
	tunit			 BelegtZeit;
	int			 PassedJobs;

	double		*BatchMean;
	struct KI	 ki;

	int			*KlWechselWkeit;
	int			*SuspendKWW;
	int			*UEW;
	int			*IRQ;
	boolean		*StatKW;

	int			 requeue;

	int			 BedZeitVtlg;
	double		 BZPar1,
					 BZPar2,
					 BZPar3;
};

struct BE {
	char				*Name;
	int				 BE_Typ;
	int				 AnzBE;
	int				 Status;
	int				*IRQStatus;

	tunit				 StatUpdate;

	struct BE_DATA	*BE_Data;

	struct LKopf  	 JobListe;
	struct JOB		*Job;

	struct EVENT	*Event;

	int			 	 AnzVorgWS;
	int				*Prev_WS;
};

/************************************************* Warteschlangen */
struct WS_DATA {
	long			WSLaenge;
   int			AnzAuftraege;
	int			PassedJobs;
   tunit			StatUpdate;

	double	  *BatchMean;
	struct KI	ki;
};

struct WS {
	char				*Name;
	int				 ListTyp;
	boolean			 PR_IRQ;

	struct LKopf	 JobListe;

	struct WS_DATA *WS_Data;

	int 				 AnzNachfolgBE;		/* Verbindungen zu den Nachfolgenden BE */
	int				*Next_BE;
};

#endif
