static char *SccsId = "@(#)PEPSY:\tdebug.c\t1.6\t94/02/04 11:22:56";
#include "signal.h"
#include "stdio.h"
#include "data.h"

/*************************** BS-Funktionen *********************************************/
extern FILE *fopen();

/************************* Funktionen und Prozeduren aus anderen Modulen ***************/
extern void fprintKI();

/*************************** globale Variablen (aus main.c!) ***************************/
extern struct BE		*be;
extern struct WS		*ws;
extern struct AUSSEN *AussenWelt;
extern int				 AnzBe, AnzKl, AnzWs, AnzBa, aktBa;
extern int				 SimulationsPhase,
							 KILimit;
extern char				*ModellName;
extern double			 SFaktor;
extern tunit			 Time,
							 BatchLaenge,
							 EndTime;
extern struct LKopf	 EventListe;
extern FILE				*ErrOut;
extern unsigned long	 aktanzjobs,
						 aktmaxanzjobs,
						 maxanzjobs;
extern boolean			 maxjobsreached;

void ForceEnd(sig)
	int sig;
{
	signal(SIGUSR2, ForceEnd);

	fprintf(ErrOut, "Signal %d!\n", sig);

	EndTime = Time;
}

void Dump(sig)
	int sig;
{
	int i, j, k;
	struct BE_DATA *be_data;
	struct WS_DATA *ws_data;
	struct EVENT *Event;
	struct JOB	 *Job;
	FILE *fp;

	signal(SIGUSR1, Dump);

	fprintf(ErrOut, "\nSignal %d received!\n", sig);

	fp = fopen(DUMPFILE,"w");

	if (fp == (FILE *)NULL)
	{
		fp = ErrOut;
	}

	fprintf(fp, "Modell : '%s'  Simulationsphase : %d  Time %lu\n",
																			ModellName, SimulationsPhase, Time);

	fprintf(fp, "AnzBe %6d AnzWs %6d AnzKl %d\n", AnzBe, AnzWs, AnzKl);
	fprintf(fp, "AnzBa %6d aktBa %6d BatchLaenge %lu\n", AnzBa, aktBa, BatchLaenge);
	fprintf(fp, "KILimit %d%\n", KILimit);
	fprintf(fp, "SFaktor %g\n", SFaktor);

	fprintf(fp, "AktAnzJobs %lu  MaxAnzJobs %lu  AktMaxAnzJobs %lu  MaxJobsReached %s\n",
				aktanzjobs, maxanzjobs, aktmaxanzjobs, (maxjobsreached)?"TRUE":"FALSE");

	fprintf(fp, "EventListe : (Zeitpunkt:Typ:Nr)  Laenge %d\n", EventListe.Laenge);
	for (Event=(struct EVENT *)EventListe.Anfang; Event!=(struct EVENT *)NULL;
															Event=(struct EVENT *)Event->Node.Next)
	{
		fprintf(fp, "   %lu:%d:%d ", ((struct LNode *)Event)->Prio,Event->Typ,Event->Nr.ZielWs);
		if ((Event->Typ == COMPLETE_ET) || (Event->Typ == ARRIVAL_ET))
		{
			Job = Event->Job;
			fprintf(fp, " Job{ EZ %ld KL %d RBZ %ld } ",
							 Job->ErschaffungsZeit, Job->Klasse, Job->RestBearbZeit);
		}
		fprintf(fp, "\n");
	}

	for (i=0; i<=AnzBe; i++)
	{
		fprintf(fp, "%s :\n", be[i].Name);

		fprintf(fp, "   Status %d Typ %d StatUpdate %ld",	be[i].Status,
																			be[i].BE_Typ, be[i].StatUpdate);

		fprintf(fp, " AnzVorgWs %d ", be[i].AnzVorgWS);
		for(j=0; j<be[i].AnzVorgWS; j++)
			fprintf(fp, "%d ", be[i].Prev_WS[j]);
		fprintf(fp, "\n");

		fprintf(fp, "   JobListe Laenge %d :\n", be[i].JobListe.Laenge);
		for (Job=(struct JOB *)be[i].JobListe.Anfang; Job!=(struct JOB*)NULL;
														Job = ((struct JOB *)((struct LNode *)Job)->Next))
		{
			fprintf(fp, "   Job{ EZ %lu KL %d RBZ %lu }\n",
							 Job->ErschaffungsZeit, Job->Klasse, Job->RestBearbZeit);
		}

		be_data = be[i].BE_Data;

		for (j=0; j<AnzKl; j++)
		{
			fprintf(fp, "   %-8s :\n", AussenWelt[j].Name);

			fprintf(fp, "   BZ %lu PJ %d BZVTLG %d BZP1 %g BZP2 %g BZP3 %g ReQueue %d\n",
							be_data[j].BelegtZeit, be_data[j].PassedJobs, be_data[j].BedZeitVtlg,
							be_data[j].BZPar1, be_data[j].BZPar2, be_data[j].BZPar3, be_data[j].requeue);
			
			fprintf(fp, "   SKW        ");
			for (k=0; k<AnzKl; k++)
				fprintf(fp, "%5d ", be_data[j].StatKW[k]);
			fprintf(fp, "\n");
						 
			if (be_data[j].KlWechselWkeit != (int *)NULL)
			{
				fprintf(fp, "   KWW     ");
				for (k=0; k<AnzKl; k++)
					fprintf(fp, "%5d ", be_data[j].KlWechselWkeit[k]);
				fprintf(fp, "\n");

				fprintf(fp, "   SuspKWW ");
				for (k=0; k<AnzKl; k++)
					fprintf(fp, "%5d ", be_data[j].SuspendKWW[k]);
				fprintf(fp, "\n");
			}
			else
			{
				fprintf(fp, "   Kein KW!\n");
			}

			fprintf(fp, "   IRQ        ");
			for (k=0; k<AnzKl; k++)
				fprintf(fp, "%5d ", be_data[j].IRQ[k]);
			fprintf(fp, "\n");
						 
			fprintf(fp, "   UEW        ");
			for (k=0; k<=AnzWs; k++)
				fprintf(fp, "%5d ", be_data[j].UEW[k]);
			fprintf(fp, "\n");
			
			fprintf(fp, "   Bat        ");
			for (k=0; k<=aktBa; k++)
				fprintf(fp, "%f ", be_data[j].BatchMean[k]);
			fprintf(fp, "\n");

			fprintf(fp, "   "); fprintKI(fp, &be_data[j].ki);
			fprintf(fp, "\n");
		}
	}

	for (i=0; i<=AnzWs; i++)
	{
		fprintf(fp, "%s :\n", ws[i].Name);

		fprintf(fp, "   LT %d AN %d ", ws[i].ListTyp, ws[i].AnzNachfolgBE);
		for (j=0; j<ws[i].AnzNachfolgBE; j++)
			fprintf(fp, "%d ",ws[i].Next_BE[j]);
		fprintf(fp, "\n");

		fprintf(fp, "   JobListe Laenge %d :\n", ws[i].JobListe.Laenge);
		for (Job=(struct JOB *)ws[i].JobListe.Anfang; Job!=(struct JOB *)NULL;
																				Job=(struct JOB *)Job->Node.Next)
		{
			fprintf(fp, "   Job{ EZ %lu KL %d RBZ %lu }\n",
							 Job->ErschaffungsZeit, Job->Klasse, Job->RestBearbZeit);
		}

		ws_data = ws[i].WS_Data;

		for (j=0; j<AnzKl; j++)
		{
			fprintf(fp, "   %-8s :\n", AussenWelt[j].Name);

			fprintf(fp, "   WSL %lu AA %d PJ %d UT %lu \n",
							ws_data[j].WSLaenge, ws_data[j].AnzAuftraege,
							ws_data[j].PassedJobs, ws_data[j].StatUpdate);

			fprintf(fp, "   Bat ");
			for (k=0; k<=aktBa; k++)
				fprintf(fp, "%f ", ws_data[j].BatchMean[k]);
			fprintf(fp, "\n");

			fprintf(fp, "   "); fprintKI(fp, &ws_data[j].ki);
			fprintf(fp, "\n");
		}
	}
	fclose(fp);
}

void DBG_JobList(JobListe)
struct LKopf *JobListe;
{
	struct LNode *aktElem;

	aktElem = JobListe->Anfang;

	fprintf(ErrOut, "Liste Laenge: %d\n", JobListe->Laenge);
	while (aktElem != (struct LNode *)NULL)
	{
		fprintf(ErrOut, "  %lu", ((struct JOB *)(aktElem))->RestBearbZeit);
		aktElem = aktElem->Next;
	}
	fprintf(ErrOut, "\n");
}

void DBG_EventList()
{
	struct EVENT	*Event;
	struct JOB		*Job;

	fprintf(ErrOut, "EventListe : (Zeitpunkt:Typ:Nr)  Laenge %d\n", EventListe.Laenge);
	for (Event=(struct EVENT *)EventListe.Anfang; Event!=(struct EVENT *)NULL;
															Event=(struct EVENT *)Event->Node.Next)
	{
		fprintf(ErrOut, "   %ld:%d:%d ", ((struct LNode *)Event)->Prio,Event->Typ,Event->Nr.ZielWs);
		if ((Event->Typ == COMPLETE_ET) || (Event->Typ == ARRIVAL_ET))
		{
			Job = Event->Job;
			fprintf(ErrOut, " Job{ EZ %ld KL %d RBZ %ld } ",
							 Job->ErschaffungsZeit, Job->Klasse, Job->RestBearbZeit);
		}
		fprintf(ErrOut, "\n");
	}
}
