
static char *SccsId = "@(#)PEPSY:\tlowlevel.c\t1.7\t94/02/04 11:23:05";

#include <stdio.h>
#include <sys/types.h>
#include	"time.h"
#include "data.h"

/**********************************************************************************************
**
**	struct EVENT	*CreateEvent(Typ, Data, Job, time)
**															Ereignis generieren und in EventListe merken
**	struct JOB		*CreateJob(Klasse)			Ein Auftrag mit initialisierten Werten erzeugen
** long				 GetBedZeit(aktBe, aktK)	Es wird eine Bedienzeit (zufaellig) erzeugt
**	char				*GetTimeStamp()				Liefert einen String mit der aktuellen Zeit
**
**********************************************************************************************/

/*************************** BS-Funktionen ***************************************************/
extern void		exit(),
				  *calloc();
extern size_t	strlen();
extern char	  *strcpy();
extern time_t	time();

/*************************** externe Funktionen und Prozeduren *******************************/
extern struct JOB		*AllocJob();										/* memory.c */
extern struct EVENT	*AllocEvent();										/* memory.c */
extern int				 Insort();											/* lists.c	*/
extern tunit exp_rnd(),				cox_rnd(),							/* rnd.c*/
				cox2_rnd(),				hypoexp_rnd(),
				lognorm_rnd(),			ge_rnd(),
				detexp_rnd(),			hyperexp_rnd(),
				normal_rnd(),			private_rnd();

/*********************** globale Variablen (aus main.c) **************************************/
extern struct BE		*be;
extern struct LKopf	 EventListe;
extern tunit			 Time;
extern FILE				*ErrOut;

struct JOB *CreateJob(Klasse)
	int Klasse;
/*
**	Es wird ein Job der angeforderten Klasse erzeugt und ein Zeiger darauf zurueckgegeben
**
*/
{
	struct JOB *Job;

	Job						 = (struct JOB *)AllocJob();
	Job->ErschaffungsZeit = Time;
   Job->Klasse				 = Klasse;
   Job->RestBearbZeit	 = 0L;

	return (Job);
}

struct EVENT *CreateEvent(Typ, Data, Job, eventtime)
	int Typ;
	int Data;
	struct JOB *Job;
	tunit eventtime;
/*
**	Es wird ein Event erzeugt und in die EventListe einsortiert. Moegliche Eventtypen: s. data.h.
**	Data ist vom Eventtyp abhaengig. Job ein mit dem Event verknuepfter Auftrag, und time die
**	Zeit, an der das Ereignis eintreten soll.
**
*/
{
	struct EVENT *Event;

   Event = (struct EVENT *)AllocEvent();

   Event->Typ = Typ;
	switch(Typ)
	{
		case ARRIVAL_ET : Event->Nr.ZielWs = Data;
								break;
		case COMPLETE_ET: Event->Nr.Verursacher = Data;
								break;
		case BATCHEND_ET: Event->Nr.ZielWs = Data;
								break;
		default			 : fprintf(ErrOut, "FATAL: CreateEvent: Unknown EventType %i!\n", Data);
								exit (-1);
								break;
	}
   Event->Job			= Job;
   Event->Node.Prio	= eventtime;
	Event->Node.Next	= (struct LNode *)NULL;

	(void)Insort(&EventListe, (struct LNode *)Event);

	return(Event);
}

tunit GetBedZeit(aktBe, aktK)
	int aktBe;
	int aktK;
/*
**	liefert fuer die aktBe und der aktK eine zufaellige BZ fuer einen Job
**
*/
{
	struct BE_DATA bd;
	long bz;

	bd = be[aktBe].BE_Data[aktK];

	switch(be[aktBe].BE_Data[aktK].BedZeitVtlg)
	{
		case EXPON_VTLG :
				bz = exp_rnd(bd.BZPar1);
				break;
		case CONST_VTLG :
				bz = (tunit) bd.BZPar1;
				break;
		case COX_VTLG	:
				bz = cox_rnd(bd.BZPar1, (int)bd.BZPar2, (int)bd.BZPar3);
				break;
		case COX2_VTLG	:
				bz = cox2_rnd(bd.BZPar1, bd.BZPar2, (int)bd.BZPar3);
				break;
		case DETEXP_VTLG	:
				bz = detexp_rnd((tunit)bd.BZPar1, bd.BZPar2);
				break;
		case HYPEREXP_VTLG	:
				bz = hyperexp_rnd(bd.BZPar1, bd.BZPar2, (int)bd.BZPar3);
				break;
		case HYPOEXP_VTLG	:
				bz = hypoexp_rnd(bd.BZPar1, bd.BZPar2);
				break;
		case GE_VTLG	:
				bz = ge_rnd(bd.BZPar1, (int)bd.BZPar2);
				break;
		case LOGNORM_VTLG	:
				bz = lognorm_rnd(bd.BZPar1, bd.BZPar2);
				break;
		case NORMAL_VTLG :
				bz = normal_rnd(bd.BZPar1, bd.BZPar2);
				break;
		case PRIVATE_VTLG:
				bz = private_rnd(bd.BZPar1, bd.BZPar2);
				break;
		default :
  	         fprintf(ErrOut, "FATAL: GetBedZeit() Unbekannter Vtlgstyp bei BE[%d], aktK[%d]!\n",
  	                        														(int)aktBe, (int)aktK);
  	         exit(-1);
	}

	return(bz);
}

char *GetTimeStamp()
/*
**	Liefert einen Zeiger auf einen String der die aktuelle Zeit enhaelt.
**	Fuer das Format siehe strftime(3C).
**
*/
{
	time_t clk;
	struct tm *tt;
	static	char buf[100];

#ifndef sequent

	clk	 = time((time_t *)NULL);		/* liefert die aktuelle Zeit als (long) zurueck -
														gemessen als Systemzeit in Ticks.
														Um ein vernuenftiges Format (DATUM HH:MM:SS)
														zu erhalten wird die Formatierungsroutine
														nl_cxtime() benutzt. %X bedeutet, dass das
														in Europa uebliche Format benutzt wird. */

	tt = localtime(&clk);

	(void)strftime(buf, 100, "%X", tt);

#else

	buf[0] = '\0';

#endif

	return(buf);
}

char *fscanName(fp)
	FILE *fp;
/*
**	Ein zusammenhaengender String wird vom File *fp eingelesen, dafuer Speicher reserviert
**	und ein Zeiger darauf zuruckgegeben.
**
*/
{
	char  buffer[BUFSIZ];
	char *s;
	unsigned l;

	fscanf(fp, "%s", buffer);

	l = strlen(buffer);

	s = (char *) calloc(++l, sizeof(char));

	return(strcpy(s, buffer));
}

void fprintKI(fp, ki)
	FILE			*fp;
	struct KI	*ki;
/*
**	Gibt ein Konfidenzintervall aus
**
*/
{
	fprintf(fp, "KI: %g [%g;%g] (Breite %g entspr. %g%%)",	ki->mw,
																				ki->mw - ki->breite,
																				ki->mw + ki->breite,
																				ki->breite,
																				ki->quality);
}


struct JOB *ShortestJob(Liste)
	struct LKopf *Liste;
{
	register struct JOB *shortestJob, *Job;


	shortestJob = (struct JOB *)Liste->Anfang;

	for (Job = (struct JOB *)Liste->Anfang; Job != (struct JOB *)NULL;
																		Job = (struct JOB *)Job->Node.Next)
	{
		if (Job->RestBearbZeit < shortestJob->RestBearbZeit)
			shortestJob = Job;
	}

	return (shortestJob);
}
