static char *SccsId = "@(#)PEPSY:\tmain.c\t1.10\t94/02/04 11:23:07";
#include <sys/types.h>

#include	"signal.h"
#include	"stdio.h"
#include	"data.h"

/************************** externe Funktionen und Prozeduren ********************************/
extern void	BE_belegen(),
				InitSim(),
				Dump(),
				EndJob(),
				ForceEnd(),
				FreeJob(),
				FreeEvent(),
				GetBatch(),
				InitStats(),
				Job_in_WS(),
				MakePEPSYOut(),
				ShowResults(),
				StartJob(),
				SuspendJob();
extern boolean TestBatches(),
					TestKI(),
					TestPrevWS_EMPTY();
extern char	*GetTimeStamp();
extern int	Ermittle_Next(),
				GetBe_IRQ(),
				GetBe_IDLE();
extern struct JOB	*AllocJob(),
						*Job_aus_WS(),
						*CreateJob();
extern struct EVENT *CreateEvent();
extern struct LNode *GetFirst();

/****************************** Funktionen und Prozeduren des BS *****************************
extern void		 exit();
extern FILE		*fopen();
extern double	 drand48();
*/
extern pid_t	 getpid();
extern int atoi();

/*********************************	Globale Variablen	****************************************/
struct LKopf	EmptyJobs;										/*	Liste fuer Pgm-eigenen Cache */
struct LKopf	EmptyEvents;									/*	Liste fuer Pgm-eigenen Cache */
struct LKopf	EventListe;										/*	Liste fuer zukuenftige	Ereignisse */
struct BE		*be;											/*	globale Netzelemente */
struct WS		*ws;
struct AUSSEN	*AussenWelt;
int				 AnzWs, AnzBe,	AnzKl, AnzBa, aktBa;
int				 KILimit;
boolean			 trace,
				 dump,
				 zufallinit,
				 mkpepout,
				 maxjobsreached;
double			 SFaktor;
long			 zufall;
int				 SimulationsPhase;
tunit			 Time;											/* Simulationsuhr */
tunit			 EndTime;
tunit			 BatchLaenge;
tunit			 Warmup;
unsigned long	 aktanzjobs,
				 maxanzjobs,
				 aktmaxanzjobs;
char			*ModellName;
FILE			*tracefp,
				*OutFile,
				*ErrOut;
/*********************************************************************************************/

void Batchend(event)
	struct EVENT *event;
{
	double KIQuality;
	boolean KIQ;

	FreeEvent(event);

	switch (SimulationsPhase)
	{
		case WARMUP_SP	:

			fprintf(OutFile, "%s Warmup Ende!\n\n", GetTimeStamp());

			GetBatch();

			InitStats();

			if	(trace)
			{
				fprintf(tracefp, "Warmupende. Time:%ld\n", Time);
			}

			SimulationsPhase = INDEPE_SP;

			break;
		case INDEPE_SP	:

			GetBatch();

			if (aktBa == (AnzBa-1))
			{
				if	(TestBatches()	==	UNABHAENGIG)
				{
					SimulationsPhase = CIMINI_SP;

					fprintf(OutFile, "%s Batches sind unabhaengig!\n\n", GetTimeStamp());
				}
				else
					SimulationsPhase = INDEPE_SP;
			}

			break;
		case CIMINI_SP	:

			GetBatch();

			if ((aktBa == (AnzBa-1)) || (BatchLaenge >= 1000000L))
			{
				if	((KIQ = TestKI(&KIQuality)) == OK)
					SimulationsPhase = ENDE_SP;
				else
					SimulationsPhase = CIMINI_SP;
				
				fprintf(OutFile, "%s max. Konf'Intervall +-%.1f%%! KIQuality %s\n",
										GetTimeStamp(),
										KIQuality,
										(KIQ)?"OK":"NOTOK");
			}
		
			break;
		case ENDE_SP	:
			/*	Darf nicht erreicht werden, da die Hauptschleife in Sim vorher abbricht */

			break;
		default			:
			
			fprintf(ErrOut, "FATAL:	Unbekannte Sim'Phase	%d!\n", SimulationsPhase);
			exit (-1);
	}

	if	((Time	> EndTime) || (Time+BatchLaenge < Time))
	{
		SimulationsPhase = ENDE_SP;
		fprintf(stderr, "EndTime erreicht!\n");
	}
	else
		(void)CreateEvent(BATCHEND_ET, 0, (struct JOB *)NULL, (tunit)(Time+BatchLaenge));
}

void Completion(event)
	struct EVENT *event;
/*
**
**	Ein Auftrag	wurde	zum Zeitpunkt Time-1	fertig.
**
**	Die statistischen Daten	muessen aktualisiert werden. Dann wird der Auftrag gemaess Klasssen-
**	wechsel- und Uebergangswahrscheinlichkeiten an eine WS weitergegeben (per ARRIVAL-Event zum
**	Zeitpunkt Time+1). Ein Neuer Job wird aus einer der VorgaengerWS geholt	und gestartet.
**
*/
{
	int			nextWs, nextK,	aktBe, aktK;
	struct JOB *Job;

	aktBe		 =	event->Nr.Verursacher;
	aktK		 =	event->Job->Klasse;
	Job			 =	event->Job;

	FreeEvent(event);

#	ifdef	DBG
		fprintf(ErrOut,"COMPLETITI	BE%03d KL%03d   JB%08.8lx EV%08.8lx \n", aktBe, aktK, Job, event);
#	endif

	EndJob(aktBe, Job);

	if	(aktBe == 0)
	{
		Job->ErschaffungsZeit =	Time;
	}

	if	((AussenWelt[aktK].KlassenTyp	==	OFFEN_KL) && (aktBe == 0))
	{
		be[aktBe].BE_Data[aktK].PassedJobs += 1;

		if (aktanzjobs > aktmaxanzjobs)
		{
			aktmaxanzjobs = aktanzjobs;

			if (aktanzjobs > maxanzjobs)
			{
				/*	Die maximale Zahl von Jobs im System ist erreicht (ueberschritten),
					deshalb wird der Auftrag nicht in das Netz eingeschleust, sondern
					geloescht. Damit der Benutzer dies mitgeteilt bekommt, wird dies
					in der variable maxjobsreached gemerkt und am Ende mitausgegeben! */

				if (trace && !maxjobsreached)
				{
					fprintf(tracefp, "MaxJobsReached Time:%ld JOB (Nr:%lu) killed!\n",
										Time, aktanzjobs);
				}

				maxjobsreached = TRUE;

				FreeJob(Job);
			}
		}
		else
		{
			nextWs =	Ermittle_Next(be[0].BE_Data[aktK].UEW,	AnzWs+1);
			event	 =	CreateEvent(ARRIVAL_ET, nextWs,	Job, Time);
			aktanzjobs++;
		}

		Job	 =	CreateJob(aktK);							/*	AnkunftsZeitpunkt des naechsten Jobs */
		StartJob(Job, 0);
	}
	else
	{	/*	Klassenwechsel: */

		if (be[aktBe].BE_Typ == PS_BT)
		{
			Job = (struct JOB *)GetFirst(&be[aktBe].JobListe);	/* erster fertiger Job einer PS-BE */
		}

		while (Job != (struct JOB *)NULL)
		{
			aktK = Job->Klasse;
			be[aktBe].BE_Data[aktK].PassedJobs += 1;

			if	(be[aktBe].BE_Data[aktK].KlWechselWkeit != (int	*)NULL)
			{
				nextK = Job->Klasse = Ermittle_Next(be[aktBe].BE_Data[aktK].KlWechselWkeit, AnzKl);

#				ifdef	DBG
					fprintf(ErrOut,"KLWECHSEL	BE%03d KL%03d->KL%03d\n",aktBe,aktK,nextK);
#				endif

				if	(be[aktBe].BE_Data[aktK].StatKW[nextK]	==	TRUE)
				{	
					/*	stationaerer KlWechsel erlaubt!
						Pruefen, ob alle Ws mit niedriger Prioritaet als nextWs leer sind */
		
					if	(TestPrevWS_EMPTY(aktBe, be[aktBe].BE_Data[nextK].requeue) == TRUE)
					{
						StartJob(Job,aktBe);
						return;
					}
					/*	sonst den Job in eine WS einreihen, da stationaerer KW nicht moeglich */
				}
			}
			else
			{
				nextK	= aktK;
			}

			/*	Naechste	WS	per UEW suchen	und dorthin	weiterreichen */

			nextWs =	Ermittle_Next(be[aktBe].BE_Data[nextK].UEW, AnzWs+1);
			event	 =	CreateEvent(ARRIVAL_ET, nextWs, Job, Time);

#			ifdef	DBG
				fprintf(ErrOut,"UEBERGANG	KL%03d BE%03d->WS%03d JB%08.8lx\n",aktK,aktBe,nextWs,Job);
#			endif
			
			if (be[aktBe].BE_Typ == PS_BT)
			{
				/* evtl. weitere Jobs aus der Merkliste holen */
				Job = (struct JOB *)GetFirst(&be[aktBe].JobListe);
			}
			else
			{
				Job = (struct JOB *)NULL;
			}
		}

		/* Die nun leere BE wieder beschaeftigen */
		BE_belegen(aktBe);
	}
}

void Arrival(event)
	struct EVENT *event;
/*
**
**	Zum aktuellen Zeitpunkt	(Time) kommt ein Auftrag an der WS an.
**
**	Der Auftrag wird gemaess Strategie eingereiht oder unterbricht einen Job auf einer nachfol-
**	genden BE oder wird auf einer freien BE gestartet. Die statistischen Daten werden neu
**	berechnet.
**
*/
{
	int			aktWs, aktK, nextBe;
	struct JOB *Job;

	aktWs	= event->Nr.ZielWs;
	Job	= event->Job;
	aktK	= Job->Klasse;

	FreeEvent(event);

#	ifdef	DBG
		fprintf(ErrOut,"ARRIVAL	   WS%03d KL%03d         JB%08.8lx EV%08.8lx\n", aktWs, aktK, Job, event);
#	endif

	if	((AussenWelt[aktK].KlassenTyp	==	OFFEN_KL) && (aktWs == 0))	/*	Aussenwelt */
	{
		AussenWelt[aktK].Verweilzeit	+=	Time-Job->ErschaffungsZeit;
		AussenWelt[aktK].BatchJobs		+=	1;
		aktanzjobs--;		/* ein Job weniger im Netz */

		FreeJob(Job);		/*	Job vernichten	*/
	}
	else
	{
		if	(aktWs == 0)
		{
			AussenWelt[aktK].Verweilzeit	+=	Time-Job->ErschaffungsZeit;
			AussenWelt[aktK].BatchJobs		+=	1;
		}

		nextBe =	GetBe_IDLE(aktWs); /* naechste unbeschaeftigte BE ermitteln	*/

		if	(nextBe != NOTFOUND)
		{
			if (ws[aktWs].ListTyp != PS_LT)
				ws[aktWs].WS_Data[aktK].PassedJobs += 1;
			StartJob(Job, nextBe);
		}
		else
		{
			/* Gibt	es	BE	mit PR oder	Interrupt-Strategien? */
			if	(ws[aktWs].PR_IRQ	==	TRUE)
			{
				nextBe =	GetBe_IRQ(aktWs, aktK, Job);

				if	(nextBe != NOTFOUND)
				{
					SuspendJob(nextBe, aktK);
					StartJob(Job, nextBe);
				}
				else
					Job_in_WS(Job,	aktWs);
			}
			else
				Job_in_WS(Job,	aktWs);
		}
	}
}

void Sim()
{
	struct EVENT	*event;

	/*	Solange noch events vorhanden, abarbeiten	! */

	while	((EventListe.Laenge>0) && (SimulationsPhase != ENDE_SP))
	{
		event	= (struct EVENT *)GetFirst(&EventListe);

#		ifdef	DBG
			if	(Time	!=	event->Node.Prio)
				fprintf(ErrOut,"TIME			%08d--------------------------------\n",event->Node.Prio);
#		endif
		if (Time > event->Node.Prio)
			fprintf(ErrOut, "Time wird erniedrigt! Event: TYP%d Data%d\n", event->Typ, event->Nr.ZielWs);

		Time = event->Node.Prio;

		switch (event->Typ)
		{
			case COMPLETE_ET :
				Completion(event);		/*	Prozedur	zur Behandlung	des Complete-events */
				break;
			case ARRIVAL_ET:
				Arrival(event);			/*	Prozedur	zur Behandlung	des Arrival-events */
				break;
			case BATCHEND_ET:
				Batchend(event);
				break;
			default:
				fprintf(ErrOut,"Unbekannter EventTyp: %d!\n",event->Typ);
				exit(-1);
		}
	}
}

int main(argc, argv)
	int	argc;
	char *argv[];
{
	FILE			*InFile;
	int			 c;
	int			 errflg=FALSE;

	/*		Sccs support from SccsLogging.c			*/	
	extern int SccsRelease;
	extern int SccsLevel;

	extern char	*optarg;

	signal(SIGUSR1, Dump);
	signal(SIGUSR2, ForceEnd);

	ErrOut			= stderr;
	InFile			= stdin;
	OutFile			= stdout;
	EndTime			= (tunit)4000000000;
	AnzBa			= 50;
	BatchLaenge		= (tunit)10000;
	Warmup			= (tunit)((tunit)10*BatchLaenge);
	KILimit			= 25;						/* entspr. 2,5% */
	trace			= FALSE;
	zufallinit		= FALSE;
	dump			= FALSE;
	mkpepout		= FALSE;
	maxjobsreached	= FALSE;	/* die maximalzahl vn Auftraegen wurde bisher */
								/* noch nie erreicht				*/
	maxanzjobs		= 10000L;	/* maximal 1e4 Jobs im System	*/
	aktanzjobs		= 0;		/* momentan sind keine Jobs im System	*/
	aktmaxanzjobs	= 0;		/* waren noch keine Jobs im System	*/

	while	((c=getopt(argc, argv, "FT:tE:B:b:i:j:e:o:dk:z:pV"))!=EOF)
	{
		switch (c)
		{
			case 'T':	EndTime	= (tunit)atoi(optarg);
						break;
			case 'B':	BatchLaenge =(tunit)	atoi(optarg);
						break;
			case 'b':	AnzBa =	atoi(optarg);
						break;
			case 'E':	Warmup = atoi(optarg);
						break;
			case 'i':	InFile = fopen(optarg,	"r");
						break;
			case 'e':	ErrOut = fopen(optarg,	"w");
						break;
			case 'o':	OutFile = fopen(optarg, "w");
						break;
			case 'k':	KILimit = atoi(optarg);
						break;
			case 'j':	maxanzjobs = atoi(optarg);
						break;
			case 't':	trace =	TRUE;
						break;
			case 'd':	dump = TRUE;
						break;
			case 'p':	mkpepout = TRUE;
						break;
			case 'z':	zufallinit = TRUE;
						zufall = atoi(optarg);
						break;
			case 'V':	printf("%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
						exit(0);
						break;
			default :	errflg = TRUE;
		}
	}
	if (errflg)
	{
		printf("USAGE :\n");
		printf("%s [-T endtime] [-E warmuptime] [-t] [-d] [-B Batchlaenge]\n", argv[0]);
		printf("   [-b AnzBatches] [-i InFile] [-e ErrorFile] [-z ZufallInit]\n");
		printf("   [-j MaxAnzJobs] [-k MaxKIBreite]\n");
		printf("%s -V\n", argv[0]);
		printf("Wenn Prozess das Signal USR1 erhaelt, wird ein Dump ausgefuert!\n");
		printf("Wenn Prozess das Signal USR2 erhaelt, wird die Simulation beendet!\n");
		exit(1);
	}

	if	(trace)
	{
		tracefp = fopen(TRACEFILE,"w");
		if	(tracefp	==	(FILE	*)NULL)
		{
			fprintf(ErrOut, "Kann %s nicht oeffnen!\n", TRACEFILE);
			exit (-1);
		}
		setbuf(tracefp, (char *)NULL);					/*	ungepufferte EA */
	}

	fprintf(ErrOut, "\nProzessnummer des Simulators fuer Unterbrechungssignale ");
	fprintf(ErrOut, "USR1 und USR2: %ld\n", (long)getpid());

	InitSim(InFile);

	fprintf(OutFile, "%s Start der Simulation\n\n", GetTimeStamp());

	Sim();
	ShowResults();

	if (mkpepout)
	{
		MakePEPSYOut();
	}

	fprintf(OutFile, "%s Ende der Simulation\n\n", GetTimeStamp());

	return(0);
}
