static char *SccsId = "@(#)PEPSY:\tmemory.c\t1.5\t94/02/04 11:23:09";
#include "data.h"

/**********************************************************************************************
**
**	Modul mit Speicherverwaltungsfunktionen
**
**	AllocGlobal
**		legt Speicherbereiche fuer die BE und WS an
**	AllocJob
**		liefert einen Zeiger auf einen Job
**	FreeJob
**		gibt einen Job wieder frei, evtl wird Speicherplatz aufgehoben
**	AllocEvent
**		liefert einen Zeiger auf ein Event
**	FreeEvent
**		gibt ein Event wieder frei, evtl wird Speicherplatz aufgehoben
**		
**********************************************************************************************/

/*********************** BS-Funktionen *******************************************************/
extern void	 free();
extern void	*malloc();
extern void *calloc();

/************************** Funktionen aus anderen Modulen ***********************************/
extern int	 			Enqueue();										/* aus lists.c */
extern struct LNode *GetFirst();										/* aus lists.c */

#define ZWISCHENSPEICHER 10 /* Zahl der Jobs, deren Speicherplatz aufgehoben wird, falls sie
										 freigegeben werden */

/***************************** globale Variablen (aus main.c!) ******************************/
extern struct LKopf	 EmptyJobs;
extern struct LKopf	 EmptyEvents;
extern struct BE		*be;
extern struct WS		*ws;
extern struct AUSSEN *AussenWelt;

void AllocGlobal(AnzBe, AnzWs, AnzKl, AnzBa)
int AnzWs,
	 AnzBe,
	 AnzKl,
	 AnzBa;
{
	int i, k;

	AnzBe++;	/* kirschni 2.12.1991 */
	AnzWs++;
	AnzKl++;
	AnzBa++;

	be				= (struct BE *)	 calloc((unsigned)AnzBe+1, sizeof(struct BE));
	ws				= (struct WS *)	 calloc((unsigned)AnzWs+1, sizeof(struct WS));
	AussenWelt	= (struct AUSSEN *)calloc((unsigned)AnzKl, sizeof(struct AUSSEN));

	for (i=0; i<=AnzWs; i++)
	{
		ws[i].WS_Data = (struct WS_DATA *)calloc((unsigned)AnzKl, sizeof(struct WS_DATA));

		for (k=0; k<AnzKl; k++)
	 	{
			ws[i].WS_Data[k].BatchMean = (double *)calloc((unsigned)AnzBa, sizeof(double));
		}
	}

	for (i=0; i<=AnzBe; i++)
	{
		be[i].BE_Data = (struct BE_DATA *)calloc((unsigned)AnzKl, sizeof(struct BE_DATA));

		for (k=0; k<AnzKl; k++)
	 	{
			be[i].BE_Data[k].KlWechselWkeit	= (int *)calloc((unsigned)AnzKl, sizeof(int));
			be[i].BE_Data[k].SuspendKWW		= (int *)calloc((unsigned)AnzKl, sizeof(int));
         be[i].BE_Data[k].IRQ					= (int *)calloc((unsigned)AnzKl, sizeof(int));
         be[i].BE_Data[k].UEW					= (int *)calloc((unsigned)AnzWs+1, sizeof(int));
			be[i].BE_Data[k].BatchMean			= (double *)calloc((unsigned)AnzBa, sizeof(double));
			be[i].BE_Data[k].StatKW				= (boolean *)calloc((unsigned)AnzKl, sizeof(boolean));
		}
	}

	for (k=0; k<AnzKl; k++)
	{
		AussenWelt[k].PassedJobs	= 0;
		AussenWelt[k].BatchJobs		= 0;
		AussenWelt[k].Verweilzeit	= 0L;
		AussenWelt[k].BatchMean		= (double *)calloc((unsigned)AnzBa, sizeof(double));
	}
}

struct JOB *AllocJob()
{
	if (EmptyJobs.Anfang == (struct LNode *)NULL)
	{
		return((struct JOB *)malloc(sizeof(struct JOB)));
	}
	else
	{
		return((struct JOB *)GetFirst(&EmptyJobs));
	}
 	/*NOTREACHED*/
}

void FreeJob(Job)
struct JOB *Job;
{
	if (EmptyJobs.Laenge >= ZWISCHENSPEICHER)
		free((void *)Job);
	else
		(void)Enqueue(&EmptyJobs, (struct LNode *)Job);
}

struct EVENT *AllocEvent()
{
	if (EmptyEvents.Anfang == (struct LNode *)NULL)
	{
		return((struct EVENT *)malloc(sizeof(struct EVENT)));
	}
	else
	{
		return((struct EVENT *)GetFirst(&EmptyEvents));
	}
	/*NOTREACHED*/
}

void FreeEvent(Event)
struct EVENT *Event;
{
	if (EmptyEvents.Laenge >= ZWISCHENSPEICHER)
		free((void *)Event);
	else
		(void)Enqueue(&EmptyEvents, (struct LNode *)Event);
}
