static char *SccsId = "@(#)PEPSY:\tresults.c\t1.9\t94/02/04 11:23:15";
#include "stdio.h"
#include "sys/types.h"
#include "sys/times.h"
#include "unistd.h"

#include "data.h"

/**************************** BS-Funktionen ********************************************/
extern double	 sqrt();
extern FILE		*fopen();
extern int		 fclose();
extern char		*strcat();
extern long		 sysconf();
extern void    *malloc();

/**************************** Funktionen und Prozeduren aus anderen Modulen ***********/
extern void		 GetKI();

/********************** (externe) globale Variablen aus main.c ************************/
extern int				 aktBa,
							 AnzBa,
							 AnzBe,
							 AnzKl,
							 AnzWs;
extern tunit			 Time,
							 Warmup,
							 BatchLaenge;
extern char				*ModellName;
extern struct BE		*be;
extern struct WS		*ws;
extern struct AUSSEN *AussenWelt;
extern FILE				*OutFile,
							*ErrOut;
extern double			 SFaktor;
extern unsigned long	 aktanzjobs,
						 aktmaxanzjobs,
						 maxanzjobs;
extern boolean			 maxjobsreached;

void ShowResults()
{
	struct tms		*buffer;
#   ifdef sequent
	   typedef int clock_t;
#   endif
	clock_t			 error;
	int				 i, k;
	long				 hz;
	struct KI		 ki;
	tunit				 effSTime;

	effSTime = Time - Warmup;

	fprintf(OutFile, "Modell :'%s'\n", ModellName);
	fprintf(OutFile, "Simulationsdauer insgesamt : %lu ZE. ", Time);
	fprintf(OutFile, "Davon: %lu ZE Warmup und %lu ZE effektive Simulationszeit\n\n",
															Warmup, effSTime);
	fprintf(OutFile, "Simuliert wurde am Ende mit %ld ZE pro Batch.\n", BatchLaenge);
	fprintf(OutFile, "Dabei wurden %d Batches gleichzeitig gehalten.\n", AnzBa);
	fprintf(OutFile, "Die Guete der Konfidenzintervalle ist 95%%\n\n");

	fprintf(OutFile, "Bei der Simulation waren maximal %lu Auftraege gleichzeitig\n", aktmaxanzjobs);
	fprintf(OutFile, "im Netzwerk.\n\n");

	if (maxjobsreached)
	{
		fprintf(OutFile, "WARNUNG: Die maximale Anzahl von Auftraegen (%lu) wurde erreicht!\n");
		fprintf(OutFile, "WARNUNG: Die Simulationsergebnisse sind wahrscheinlich verfaelscht!\n\n");
	}

	for (i=0; i<=AnzBe; i++)		/* Laufschleife ueber die BE */
	{
		fprintf(OutFile,"%s :\n",be[i].Name);

		for (k=0; k<AnzKl; k++) 		/* Laufschleife ueber die Klassen */
		{
			if (be[i].BE_Data[k].PassedJobs!=0)
			{
				fprintf(OutFile,"  %8s:", AussenWelt[k].Name);
				GetKI(&ki, be[i].BE_Data[k].BatchMean, aktBa+1);
				fprintf(OutFile, " Rho :%.4f (+-%.1f%%) [%.4f;%.4f]",
										ki.mw, ki.quality, ki.mw-ki.breite, ki.mw+ki.breite);
				fprintf(OutFile," #Jobs:%6d Durchsatz:%.4f\n", be[i].BE_Data[k].PassedJobs,
											(double)be[i].BE_Data[k].PassedJobs / (double)effSTime * SFaktor);
			}		
		}
	}
	for (i=0; i<=AnzWs; i++)
	{
		fprintf(OutFile,"%s :\n",ws[i].Name);

		for (k=0; k<AnzKl; k++) 		/* Laufschleife ueber die Klassen */
		{
			if (ws[i].WS_Data[k].PassedJobs!=0)
			{
				fprintf(OutFile,"  %8s:", AussenWelt[k].Name);
				GetKI(&ki, ws[i].WS_Data[k].BatchMean, aktBa+1);
				fprintf(OutFile, " MWSL:%.4f (+-%.1f%%) [%.4f;%.4f]",
										ki.mw, ki.quality, ki.mw-ki.breite, ki.mw+ki.breite);
				fprintf(OutFile," #Jobs:%6d Durchsatz:%.4f\n", ws[i].WS_Data[k].PassedJobs,
											(double)ws[i].WS_Data[k].PassedJobs / (double)effSTime * SFaktor);
			}
		}
	} 

	fprintf(OutFile,"\nMittlere Verweilzeit der Auftraege:\n");

	for (k=0; k<AnzKl; k++)       /* Laufschleife ueber die Klassen */
	{
		if (AussenWelt[k].PassedJobs!=0)
		{
			fprintf(OutFile,"  %8s:", AussenWelt[k].Name);
			GetKI(&ki, AussenWelt[k].BatchMean, aktBa+1);
			fprintf(OutFile, " Average:%.4f (+-%.1f%%) [%.4f;%.4f]",
								(ki.mw)/SFaktor,
								ki.quality,
								(ki.mw-ki.breite)/SFaktor,
								(ki.mw+ki.breite)/SFaktor);

			fprintf(OutFile," #Jobs:%6d Durchsatz:%.4f\n", AussenWelt[k].PassedJobs,
											(double)AussenWelt[k].PassedJobs / (double)effSTime * SFaktor);
		}
	}
	fprintf(OutFile, "\n");

	buffer = (struct tms *)malloc((size_t)sizeof(struct tms));
	error = times(buffer);
#ifdef sequent
	hz = 60;
#else
	hz = sysconf(_SC_CLK_TCK);
#endif

	if (error != (clock_t)-1)
	{
		fprintf(OutFile, "Simulationszeit: %g sec USER, %g sec SYS\n",
														((float)(buffer->tms_utime))/(float)hz,
														((float)(buffer->tms_stime))/(float)hz);
	}
	else
	{
		fprintf(OutFile, "Fehler bei der Zeitnahme!\n");
	}
}

void MakePEPSYOut()
{
	int i, k;
	struct KI ki;
	tunit	effSTime;
	FILE 	*fp;
	char	FileName[512];

	FileName[0] = '\0';
	(void)strcat(FileName, "r_");
	(void)strcat(FileName, ModellName);

	fp = fopen(FileName, "w");
	if (fp == (FILE *)NULL)
	{
		fprintf(stderr, "Kann '%s' nicht oeffnen!\n", FileName);
		return;
	}

	effSTime = Time - Warmup;

	for (k=0; k<AnzKl; k++) 		/* Laufschleife ueber die Klassen */
	{
		for (i=0; i<=AnzBe; i++)		/* Laufschleife ueber die BE */
		{
			if (be[i].BE_Data[k].PassedJobs != 0)
			{	
				GetKI(&ki, be[i].BE_Data[k].BatchMean, aktBa+1);
				fprintf(fp, "%g %g %ld\n", 
								ki.mw,
								(double)be[i].BE_Data[k].PassedJobs / (double)effSTime * SFaktor,
								be[i].BE_Data[k].PassedJobs);
			}
			else
				fprintf(fp, "%g %g %ld\n", 0.0, 0.0, 0L);
		}

		for (i=0; i<=AnzWs; i++)
		{
			if (ws[i].WS_Data[k].PassedJobs != 0)
			{
				GetKI(&ki, ws[i].WS_Data[k].BatchMean, aktBa+1);
				fprintf(fp, "%g %g %ld\n", ki.mw, 
								(double)ws[i].WS_Data[k].PassedJobs / (double)effSTime * SFaktor,
								ws[i].WS_Data[k].PassedJobs);
			}
			else
				fprintf(fp, "%g %g %ld\n", 0.0, 0.0, 0L);
		}
	}
	fclose(fp);
}
