static char *SccsId = "@(#)PEPSY:\tactiv.c\t1.3\t92/12/09 17:26:35";
/*    *** Funktion : Modell                                             */
/*    *** Rueckgabe: 1 = Adressausgang zur Endabrechnung                */
/*    ***            0 = normale Kontrollfluss-Uebergabe                */
/*    ***            wird in lokaler Variable reply gefuehrt            */
/*    ***                                                               */


#include "gpss_prepare.h"
#include "gpss_decl.h"
#include "gpss_priv.h"


int activ()
{
	LOGICAL check();

	int naddr=0,reply=NORMAL;
	int node;
	int prio;
	int target_node = -1;


	if(row_source != NULL)
	{
		naddr = row_source->target;
		prio = (row_source - sourcelist );
		target_node = (prio-1) / anzclass;
		prio = (prio-1) % anzclass + 1;
		dprint(ACTIV,"activ: quelle, prio %d, naddr %d, target %d\n",
			prio,naddr,target_node);
	}
	if(row_txact > 0)
	{
		naddr = activlist[row_txact].target;
		dprint(ACTIV,"activ: row_txact > 0 naddr %d\n",naddr);
	}
	if(naddr == 0)
	{
		return(NORMAL);
	}
	dprint(ACTIV,"activ: naddr %d\n",naddr);

	node = NODE(naddr);
	naddr = NUMBER(naddr);

	switch(knoten[node].strategie)
	{
	case QUELLE:
		dprint(ACTIV,"activ: calling src_manager class %d, naddr %d, target_node %d\n",prio,naddr,target_node);
		reply = node_srcmanager(prio,naddr,target_node);
		break;
	case PRIOFCFS:
	case FCFS:
	case LCFS:
		dprint(ACTIV,"activ: calling np_manager node %d, naddr %d\n",node,naddr);
		reply = node_np_manager(node,naddr);
		break;
	case PFCFS:
		dprint(ACTIV,"activ: calling pr_manager node %d, naddr %d\n",node,naddr);
		reply = node_pr_manager(node,naddr);
		break;
	case PLCFS:
		dprint(ACTIV,"activ: calling lcfs_manager node %d, naddr %d\n",node,naddr);
		reply = node_lcfs_manager(node,naddr);
		break;
	case RR:
		dprint(ACTIV,"activ: calling rr_manager node %d, naddr %d\n",node,naddr);
		reply = node_rr_manager(node,naddr);
		break;
	case PS:
		dprint(ACTIV,"activ: calling ps_manager node %d, naddr %d\n",node,naddr);
		reply = node_ps_manager(node,naddr);
		break;
	case IS:
		dprint(ACTIV,"activ: calling ne_manager node %d, naddr %d\n",node,naddr);
		reply = node_ne_manager(node,naddr);
		break;
	default:
		fprintf(ausdat,"\n#Fehler in ACTIV\n");
		fprintf(nunit2,"Fehler in activ, Knoten %d Strategie %d\n",node,knoten[node].strategie);
		reply = FEHLER;
		break;
	}
	return(reply);
}
