static char *SccsId = "@(#)PEPSY:\tcheck.c\t1.2\t92/03/27 12:00:36";
/************************************************************************/
/*                                                                      */
/*    *** Unterprogramm check                                           */
/*    ***                                                               */
/*    *** Funktion : Ueberpruefen der logischen Bedingungen             */
/*    *** Parameter: ncond = Nummer der logischen Bedingung             */
/*    *** Rueckgabe: TRUE , falls Bedingung erfuellt                    */
/*    ***            FALSE  sonst                                       */
/*                                                                      */


#include "gpss_prepare.h"
#include "gpss_decl.h"
#include "gpss_priv.h"

LOGICAL check(ncond)
int ncond ;
{
	/*    Zusaetzliche externe Funktionen deklarieren                       */
	/*    ===========================================                       */
	extern int wslength();
	/*   Lokale Variablen definieren                                     */
	/*   ===========================                                     */
	LOGICAL int_check;
	int next;

	dprint(CHECK,"check: ncond %d, to_node %d\n",ncond,to_node(row_txact));
	/*    Ausschluss mehrfacher Ueberpruefungen                          */
	/*    =====================================                          */
	int_check = FALSE ;
	/*
	if (tcond[ncond]  ==  TiMe) return(int_check);
	/*    Adressverteiler                                                */
	/*    ===============                                                */
	switch(ncond)
	{
		case 1: /*  Gate vor der Nachfolgerstation */
			/* Keine Blockierung, wenn                                     */
			/* - die naechste Station eine Senke ist                       */
			/* - die Wartekapazitaet der naechsten Station groesser als    */
			/*   ihre Warteschlangenlaenge ist                             */
			/* - die Wartekapazitaet der naechsten Station unendlich ist   */
			/* - die Strategie der naechsten Station                       */
			/*   - IS ist                                                  */
			next = to_node(row_txact) ;
			if(next == -1) /* Senke */
			{
				dprint(CHECK,"check: Senke\n");
				int_check = TRUE;
				break;
			}
			if(knoten[next].wsmax == -1)  /* unendliche Kapazitaet */
			{
				dprint(CHECK,"check: Kapazitaet unendlich\n");
				int_check = TRUE;
				break;
			}
			if(knoten[next].wsmax > knoten[next].anz_wait) /* noch Warteraum */
			{
				dprint(CHECK,"check: noch Kapazitaet wslen %d, wsmax %d\n",knoten[next].anz_wait,knoten[next].wsmax);
				int_check = TRUE;
				break;
			}
			if(knoten[next].strategie == IS)
			{
				dprint(CHECK,"check IS\n");
				int_check = TRUE;
				break;
			}
			break;
		case 2: /* Blockieren der Transaktion an einem PS-KNoten
						   bis 'wanted_time == virtual_time'  */
			int_check = gotten_time(row_txact);
			break;
		default: /* Fehler im Verteiler */
			;
			fprintf(nunit2,"\n\n+++++ check: TiMe=%12.4f Fehler im Adressverteiler  ncond=%3d\n",
				TiMe,ncond);
			dprint(CHECK,"von %d nach %d: check %s\n",
				from_node(row_txact),next,(int_check ? "true" : "false"));
			return(int_check);
	};
	/*    Vermerk fuer erfuellte Bedingung setzen                        */
	/*    =======================================                        */
	/*
	if (int_check)
		tcond[ncond] = TiMe;
	*/
	return(int_check);
}

