static char *SccsId = "@(#)PEPSY:\tget_mod.c\t1.3\t92/12/09 17:26:37";

/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

/*
	einlesen des Warteschlangen - Modelles 
	Berechnen der noetigen Simulator Speicherbereiche
*/


#include <stdio.h>
#include <math.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"
#include "gpss_priv.h"
#include "xxalloc.h"


extern FILE *fopen();

mod_input(fp)
FILE *fp;
{
	int i,j,k;
	int hilf_integer;
	double hilf_double;
	double wsksum,wskhilfsum;
	int anf;
	double qv,p;
	double mean,minimum,vari;
	int trans_max = 0;
	int max_se = 0;

	/* Ausgabedatei ausdat anlegen */
	if(dbg)
		ausfil = stderr;
	else if((ausfil = fopen("datasav","w")) == NULL)
	{
		fprintf(stderr,"can't open %s\n","datasav");
		fprintf(stderr,"try to continue with 'stdout'\n");
		ausfil = stdout;
	}

	/* epsilon modifizieren, testversion */

	eps = 1.0e-6;

	/* Eingabewerte */

	fscanf(fp,"%d",&anznode);
	fscanf(fp,"%d",&anzclass);
	fscanf(fp,"%d",&nettyp);
	fprintf(ausfil,"Knoten %d\nKlassen %d\n",anznode,anzclass);
	switch (nettyp)
	{
		case OPEN:
			fprintf(ausfil,"Netz offen\n");
			break;
		case CLOSED:
			fprintf(ausfil,"Netz geschlossen\n");
			break;
		case MIXED:
			fprintf(ausfil,"Netz gemischt\n");
			break;
		default:
			fprintf (ausdat,"\n#Netztyp existiert nicht \n");
			exit(0);
			break;
	}

	/* Anfordern des benoetigten Speicherplatzes */

	knoten = (KNOTEN *) n1_alloc(0,anznode,sizeof(KNOTEN));
	workTiMe = (WORKTIME **) n2_alloc(0,anznode,1,anzclass,sizeof(WORKTIME));
	bedienrate = d2_alloc(0,anznode,1,anzclass);
	besh = d2_alloc(1,anznode,1,anzclass);
	Class = i1_alloc(1,anzclass);
	klasse = i1_alloc(1,anzclass);
	anz_trans = i1_alloc(1,anzclass);
	uewsk = d3_alloc(1,anzclass,0,anznode,0,anznode);
	kap = i1_alloc(1,anznode);
	arr_mit = d2_alloc(0,anznode,0,anzclass);
	arr_var = d2_alloc(0,anznode,0,anzclass);
	arr_last = d2_alloc(0,anznode,0,anzclass);
	arr_anz = i2_alloc(0,anznode,0,anzclass);
	bed_mit = d2_alloc(0,anznode,0,anzclass);
	bed_var = d2_alloc(0,anznode,0,anzclass);
	bed_last = d2_alloc(0,anznode,0,anzclass);
	bed_anz = i2_alloc(0,anznode,0,anzclass);
	dep_mit = d2_alloc(0,anznode,0,anzclass);
	dep_var = d2_alloc(0,anznode,0,anzclass);
	dep_last = d2_alloc(0,anznode,0,anzclass);
	dep_anz = i2_alloc(0,anznode,0,anzclass);

	local_dim_info = i1_alloc(0,PARAM);

	if ((nettyp == CLOSED)||(nettyp == MIXED))
	{
		fprintf(ausfil,"Auftraege pro Klasse: ");
		for (i=1;i<=anzclass;i++)
		{
			fscanf(fp,"%d ",&hilf_integer);
			Class[i] = hilf_integer;
			fprintf(ausfil,"%d  ",Class[i]);
		}
		fprintf(ausfil,"\n");
	}

	/* Anzahl der Bedieneinheiten pro Knoten */

	fprintf(ausfil,"Bedieneinheiten pro Knoten:  ");
	for (i=1;i<=anznode;i++)
	{
		if(fscanf(fp,"%d",&hilf_integer) == 0)
			fprintf(ausfil,"fehler bei fscanf\n");
		knoten[i].anzse = hilf_integer;
		fprintf(ausfil," %d  ",knoten[i].anzse);
		if(hilf_integer == 0)
			max_se += 1;
		else
			max_se += hilf_integer;
	}
	fprintf(ausfil,"\n");

	/* Warteraum pro Knoten */

	fprintf(ausfil,"Warteraum pro Knoten:   ");
	for (i=1;i<=anznode;i++)
	{
		fscanf(fp,"%d",&hilf_integer);
		knoten[i].wsmax = hilf_integer;
		fprintf(ausfil,"%d   ",knoten[i].wsmax);
		if(hilf_integer == -1)
			trans_max += 100;
		else
			trans_max += hilf_integer;
	}
	knoten[0].wsmax = -1; /* Senke hat unendliche Kapazitaet */
	trans_max += max_se + 10;
	fprintf(ausfil,"\n");


	/* berechnen des Simulator Speicherbedarfs */

	get_dimension(local_dim_info);

	for(i=0;i<PARAM;i++)
	{
		local_dim_info[i] = 0;
	}

	local_dim_info[ZBIN_INDEX]  = 3*(anznode+1)*(anzclass+1);
	local_dim_info[ZEVT_INDEX]  = 10 * anznode + 9;
	local_dim_info[ZCONF_INDEX] = 500;
	local_dim_info[ZGATE_INDEX] = (anznode+1)*(anznode+1)+anznode;
	local_dim_info[ZPOL_INDEX]  = anznode+1;
	local_dim_info[ZMFAC_INDEX]  = anznode;
	local_dim_info[ZSE_INDEX]   = max_se;
	local_dim_info[ZSRC_INDEX]  = (anznode+1)*(anzclass+1);
	local_dim_info[ZTX_INDEX]   = trans_max;
	local_dim_info[ZTXIP_INDEX]   = 6;
	local_dim_info[ZTXFP_INDEX]   = 2;

	init_dimension(local_dim_info);

	alloc_space();



	/* Strategie fuer jeden Knoten */

	knoten[0].strategie = QUELLE;
	fprintf(ausfil,"Strategie pro Knoten:  \n");
	for (i=1;i<=anznode;i++)
	{
		fscanf(fp,"%d",&hilf_integer);
		knoten[i].strategie = hilf_integer;
		switch( knoten[i].strategie )
		{
			case 1:
				fprintf(ausfil,"priofcfs   ");
				break;
			case 2:
				fprintf(ausfil,"fcfs   ");
				break;
			case 3:
				fprintf(ausfil,"lcfs   ");
				break;
			case 5:
				fprintf(ausfil,"fcfs-pre   ");
				break;
			case 6:
				fprintf(ausfil,"lcfs-pre   ");
				break;
			case 7:
				fprintf(ausfil,"round robin   ");
				break;
			case 8:
				fprintf(ausfil,"processor sharing   ");
				if(knoten[i].wsmax >= 0)
					knoten[i].wsmax += knoten[i].anzse;
				break;
			case 9:
				fprintf(ausfil,"infinite server	");
				break;
			case 10:
				fprintf(ausfil,"rpriofcfs server	");
				break;
			default:
				fprintf(ausfil,"unbekannt   ");
				break;
		}
		fprintf(ausfil,"\n");

	}

	/* Bedienrate pro Knoten und Auftragsklasse */

	fprintf(ausfil,"Bedienrate pro Knoten:  \n");
	for(j=1;j<=anzclass;j++)
	{
		klasse[j] = 0;
		if ((nettyp == OPEN) || ((Class[j] == 0)&&(nettyp == MIXED)))
			anf = 0;
		else
			anf = 1;
		for (i=anf;i<=anznode;i++)
		{
			fscanf(fp,"%d",&hilf_integer);
			workTiMe[i][j].verteil = hilf_integer;
			switch(workTiMe[i][j].verteil)
			{
			case LOGNOR:
				/* Logarithmische Normalverteilung */
				fprintf(ausfil,"Lognormalverteilung ");
				fscanf(fp,"%lf",&hilf_double);
				workTiMe[i][j].mean = hilf_double;
				fscanf(fp,"%lf",&hilf_double);
				if(hilf_double < eps) hilf_double = eps;
				workTiMe[i][j].mean1 = hilf_double;
				fscanf(fp,"%lf",&hilf_double);
				workTiMe[i][j].mean2 = hilf_double;
				fscanf(fp,"%lf",&hilf_double);
				workTiMe[i][j].varikoeff = hilf_double;
				fprintf(ausfil,"mean %f, sigma %f, min %f, max %f\n",
				    workTiMe[i][j].mean,
				    workTiMe[i][j].varikoeff,
				    workTiMe[i][j].mean1,
				    workTiMe[i][j].mean2);
				break;
			case AUTOMATIC:
				/* Automatische Bestimmung der Verteilung
					aus Mittelwert und Variationskoeffizient */
				fprintf(ausfil,"automatische Bestimmung ");
				fscanf(fp,"%lf",&hilf_double);
				mean = workTiMe[i][j].mean = 1.0 / hilf_double;
				fscanf(fp,"%lf",&hilf_double);

				qv = hilf_double;
				if (qv <= 0.1)
				{
					/* deterministische Verteilung */
					workTiMe[i][j].varikoeff = 0.0;
				}
				else if (qv == 1)
				{
					/* Exponential-Verteilung */
					workTiMe[i][j].varikoeff = 1.0;
				}
				else if ((qv < 1)&&(qv > 0.1))
				{
					/* Cox-Verteilung */
					k = (int)ceil(1/qv);
					workTiMe[i][j].varikoeff = sqrt(qv);
					p = (2*k*qv+k-2-sqrt(k*k+4-4*k*qv))/(2*(qv+1)*(k-1));
					workTiMe[i][j].wsk = p;
					workTiMe[i][j].mean1 = mean/(k-p*(k-1));
					workTiMe[i][j].mean2 = (double) k;
				}
				else if (qv > 1)
				{
					/* Hyperexponential-Verteilung */
					p = 0.5 * ( 1.0 - sqrt((qv-1.0)/(qv+1.0)));
					workTiMe[i][j].wsk = p;
					workTiMe[i][j].varikoeff = sqrt(qv);
					workTiMe[i][j].mean1 = mean/(2*p);
					workTiMe[i][j].mean2 = mean/(2*(1-p));
				}
				fprintf(ausfil,"\nwsk=%8.6f;mean1=%10.4f;mean2=%10.4f;\n",
				    workTiMe[i][j].wsk,
				    workTiMe[i][j].mean1,
				    workTiMe[i][j].mean2);
				fprintf(ausfil," mean=%10.4f;varikoeff=%10.4f\n",
				    workTiMe[i][j].mean,
				    workTiMe[i][j].varikoeff * workTiMe[i][j].varikoeff);
				break;
			case AUTOMATIC2:
				/* Automatische Bestimmung der Verteilung
					aus Mittelwert und Variationskoeffizient */
				fprintf(ausfil,"automatische Bestimmung, Version 2");
				fscanf(fp,"%lf",&hilf_double);
				mean = workTiMe[i][j].mean = 1.0/hilf_double;
				fscanf(fp,"%lf",&hilf_double);

				qv = hilf_double;
				workTiMe[i][j].varikoeff = sqrt(qv);
				if (qv == 0.0)
				{
					/* deterministischer Verlauf plus exponentielle Pahse */
					workTiMe[i][j].mean1 = 0.0;
					workTiMe[i][j].mean2 = mean;
				}
				else if (qv <= 1.0)
				{
					/* deterministischer Verlauf plus exponentielle Pahse */
					workTiMe[i][j].mean1 = workTiMe[i][j].varikoeff * mean;
					workTiMe[i][j].mean2 = mean - workTiMe[i][j].mean1;
				}
				else if (qv > 1.0)
				{
					/* GE-Verteilung,
						Sprungfunktion bzw. exponentielle Phase */
					workTiMe[i][j].wsk = 2.0 / ( qv + 1.0);
					workTiMe[i][j].mean1 = mean *  ( qv + 1.0 ) / 2.0 ;
					workTiMe[i][j].mean2 = 1.01 * eps;
				}
				fprintf(ausfil,"\nwsk=%8.6f;mean1=%10.4f;mean2=%10.4f;\n",
				    workTiMe[i][j].wsk,
				    workTiMe[i][j].mean1,
				    workTiMe[i][j].mean2);
				fprintf(ausfil," mean=%10.4f;varikoeff=%10.4f\n",
				    workTiMe[i][j].mean,
				    workTiMe[i][j].varikoeff * workTiMe[i][j].varikoeff);
				break;
			default:
				fprintf(ausfil,"unbekannte Verteilung Knoten %d, Klasse %d (%d)\n",
					i,j,workTiMe[i][j].verteil)	;
				break;
			}
		}
		fprintf(ausfil,"\n");
	}

	/* Uebergangswahrscheinlichkeiten */

	for (i=1;i<=anzclass;i++)
	{
		/* aussen */
		fprintf(ausfil,"Klasse %d\n",i);
		if ((nettyp == OPEN)||((nettyp == MIXED)&&(Class[i] == 0)))
		{
			wsksum = 0.0;
			hilf_double = 0.0;
			uewsk[i][0][0] = hilf_double;
			for (k=1;k<anznode;k++)
			{
				fscanf(fp,"%lf",&hilf_double);
				wskhilfsum = wsksum;
				wsksum = wsksum + hilf_double;
				uewsk[i][0][k] = hilf_double;
			}
			uewsk[i][0][k] = 1.0 - wsksum;
		}
		/* restliche Knoten */
		for (j=1;j<=anznode;j++)
		{
			wsksum = 0.0;
			if ((nettyp == OPEN)||((nettyp == MIXED)&&(Class[i] == 0)))
			{
				fscanf(fp,"%lf",&hilf_double);
				wsksum = wsksum + hilf_double;
				uewsk[i][j][0] = hilf_double;
			}
			for(k=1;k<anznode;k++)
			{
				/* uewsk[class][node][node] */
				fscanf(fp,"%lf",&hilf_double);
				wskhilfsum = wsksum;
				wsksum = wsksum + hilf_double;
				uewsk[i][j][k] = hilf_double;
			}
			uewsk[i][j][k] = 1.0 - wsksum;
		}
		for(j=0;j<=anznode;j++)
		{
			for(k=0;k<=anznode;k++)
			{
				fprintf(ausfil,"%g ",uewsk[i][j][k]);
			}
			fprintf(ausfil,"\n");
		}
	}

	/* Simulationsdauer */
	tend = 0.0;
	fscanf(fp,"%d",&autosim);
	if (autosim == 1)
	{
		fscanf(fp,"%lf",&tend);
	}
	fprintf(ausfil,"autosim %d\tSimulationszeit %g\n",autosim,tend);
	/* deadlock Blockiernetze simulieren */
	fscanf(fp,"%d",&exblock);
	/* Quellen vor Knoten mit endlichen Kapazitaeten */
	/* Verlustsystem oder Blockierung */
	fscanf(fp,"%d",&srcblock);

	/* Besuchshaeufigkeiten */
	fprintf(ausfil,"Besuchshaeufigkeiten\n");
	for (i=1;i<=anzclass;i++)
	{
		for (j=1;j<=anznode;j++)
		{
			fscanf(fp,"%lg ",&besh[j][i]);
			fprintf(ausfil,"%lg ",besh[j][i]);
		}
		fprintf(ausfil,"\n");
	}
	if(dbg == 0)
		fclose(ausfil);
}

