/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/


static char *SccsGPSSPriv_h = "@(#)PEPSY:\tgpss_priv.h\t1.5\t92/12/10 18:51:26";

#define OPEN       2
#define CLOSED     1
#define MIXED      4

#define AUTOMATIC  0
#define LOGNOR     1
#define AUTOMATIC2  2
#define AUTOMATIC3  3

#define QUELLE     0
#define PRIOFCFS   1
#define FCFS       2
#define LCFS       3
#define PFCFS      5
#define PLCFS      6
#define RR         7
#define PS         8
#define IS         9

typedef struct knoten{
  int       wsmax;
  int       anzse;
  int       strategie;
  int       anz_wait;
  double    last_change;
  double    next_event;
  int       act;
  int 		pending;
  int		tx_list;
}                                 KNOTEN;

typedef struct workTiMe{
  int       verteil;
  double    mean;
  double    varikoeff;
  double    wsk;
  double    mean1;
  double    mean2;
}                                 WORKTIME;


#define wanted_time(index) (f_tx_priv[index][1])
#define virtual_time(index) (f_tx_priv[index][2])

#define to_node(index)	(i_tx_priv[index][1])
#define ps_next(index)	(i_tx_priv[index][2])
#define gotten_time(index) (i_tx_priv[index][3])
#define rr_next(index)  (i_tx_priv[index][4])
#define from_node(index)	(i_tx_priv[index][5])
#define current_class(index) (i_tx_priv[index][6])

/* Makro fuer Berechnung der richtigen Einsprungadresse */

#define SOURCE_INDEX(knoten,klasse)		(((knoten)*anzclass)+(klasse))
#define NODE(addr)		((addr) / 100)
#define NUMBER(addr)	((addr) % 100)
#define NEXT_ENTRY(node,number)		\
						(100*(node)+(number))

#define GATE(from,to)				\
						((from)*(anznode+1)+(to) +1)

#define WAIT_BIN_TOT(node,class)	\
						((node)*(anzclass+1)+anzclass+1)
#define WAIT_BIN(node,class) 		\
						((node)*(anzclass+1)+(class))
#define SERV_BIN_TOT(node,class)	\
						((anznode+1)*(anzclass+1)+(node)*(anzclass+1)+anzclass+1)
#define SERV_BIN(node,class) 	\
						((anznode+1)*(anzclass+1)+(node)*(anzclass+1)+(class))
#define BLOCK_BIN_TOT(node,class) 	\
						(2*(anznode+1)*(anzclass+1)+(node)*(anzclass+1)+anzclass+1)
#define BLOCK_BIN(node,class) 	\
						(2*(anznode+1)*(anzclass+1)+(node)*(anzclass+1)+(class))
/* Debug Ausgaben */


#define ALL        0xff000000
#define ACTIV      0x01000000
#define CHECK      0x02000000
#define FREE_GATE  0x04000000
#define GENERATION 0x08000000
#define SOURCELIST 0x10000000
#define NODE_MANAGER 0x20000000
#define TRANS 0x40000000


			
/* globale Variablen */


EXTERN FILE		*ausdat, *ausfil;     
EXTERN KNOTEN	*knoten;         
EXTERN WORKTIME **workTiMe; 
EXTERN double	**bedienrate;
EXTERN double	**besh;
EXTERN int		*Class;       
EXTERN int		*klasse;
EXTERN int		anzclass,anznode;
EXTERN int		nettyp;         
EXTERN int		autosim; 
EXTERN int		anzsource; 
EXTERN int		*anz_trans; 
EXTERN double	***uewsk;
EXTERN int		*kap;
EXTERN int		exblock,srcblock,srcbl;
EXTERN double	**arr_mit;
EXTERN double	**arr_var;
EXTERN double	**arr_last;
EXTERN int		**arr_anz;
EXTERN double	**bed_mit, **bed_var, **bed_last;
EXTERN int		**bed_anz;
EXTERN double	**dep_mit, **dep_var, **dep_last;
EXTERN int		**dep_anz;
EXTERN double	aktuTiMe;
EXTERN int		*local_dim_info;
