static char *SccsId = "@(#)PEPSY:\tlcfs_node.c\t1.2\t92/03/27 12:00:50";

#include "gpss_prepare.h"
#include "gpss_decl.h"
#include "gpss_priv.h"


/************************************************************************/
/*                                                                      */
/*    *** Unterprogramm node_lcfs_manager(node,ziel);                     */
/*    ***                                                               */
/*    *** Funktion : Modell eines Knotens mit verdraengenden            */
/*                   Strategien                                         */
/*    *** Rueckgabe: 1 = Adressausgang zur Endabrechnung                */
/*    ***            0 = normale Kontrollfluss-Uebergabe                */
/*    ***            wird in lokaler Variable reply gefuehrt            */
/*    ***                                                               */
/************************************************************************/
int node_lcfs_manager(node,naddr)
int node;
int naddr;
{
	LOGICAL check();
	int reply=NORMAL;
	int ueclass, next;
	double random;
	dprint(NODE_MANAGER,"lcfs_manager Knoten %d, case %d\n",node,naddr);
	assert(node >=1 && node <= anznode);

	switch(naddr){
	case 1:
		dprint(NODE_MANAGER,"lcfs_manager:   Knoten %d betreten\n",node);
		/* Erster Versuch eine Multifacility zubelegen */
		mv_ankunft(current_class(row_txact),node);
		from_node(row_txact) = node;
		CALL(wTiMe_arr(node,current_class(row_txact)))
		/* hier hat die neueste Transaction immer hoechste Prioritaet */
		tx_system[row_txact].priority = TiMe;
	case 2: /* Erneuter oder erster Versuch eine Multifacility zubelegen */
		CALL(mpreem(node,NEXT_ENTRY(node,2)))
		CALL(wTiMe_dep(node,current_class(row_txact)))
		CALL(bTiMe_arr(node,current_class(row_txact)))
		if((random = tx_system[row_txact].TiMe_left)< eps) /* keine verdraengte Tr */
		{
			CALL(verteil(node,current_class(row_txact),&random))
		}
		else
		{
			random = tx_system[row_txact].TiMe_left;
		}
		mv_bedienzeit(current_class(row_txact),node,random);
		CALL(mwork(node,random,0,NEXT_ENTRY(node,3)))
	case 3:
		CALL(bTiMe_dep(node,current_class(row_txact)))
		CALL(blockTiMe_arr(node,current_class(row_txact)))
		/* Naechsten Knoten suchen */
		ueclass = current_class(row_txact);
		to_node(row_txact) = nodenext(ueclass,node);
	case 4:
		/* Ist naechster Knoten aufnahmefaehig ? */
		next = to_node(row_txact);
		CALL(gate(GATE(node,next),1,1,0,NEXT_ENTRY(node,4)))
		/* Multifacility freigeben */
		CALL(blockTiMe_dep(node,current_class(row_txact)))
		CALL(free_gates(node))
		switch(mclear(node))
		{
			case FEHLER:
				return(FEHLER);
			case AUSGANG2:
				/* verdraengung */
				dprint(NODE_MANAGER,"lcfs_manager:   Knoten %d Klasse %d verdraengt\n",node, current_class(row_txact));
				if(wTiMe_arr(node,current_class(row_txact)) == FEHLER)
					return(FEHLER);
				return(NORMAL);
			case NORMAL:
				break;
		}
		/* zum naechsten Knoten gehen */
		dprint(NODE_MANAGER,"lcfs_manager:   Knoten %d verlassen\n",node);
		/* alte Prioritaet wieder herstellen */
		tx_system[row_txact].priority = (double)(-current_class(row_txact)+0.5);
		CALL(change())
		break;
	default: /* Fehler im Verteiler */
		fprintf(nunit2, "\n\n+++++ lcfs_manager: TiMe=%12.4f Fehler im Adressverteiler  naddr=%3d\n", TiMe,naddr);
		reply = FEHLER;
	};
	return(reply);
}

