static char *SccsId = "@(#)PEPSY:\tnp_node.c\t1.2\t92/03/27 12:00:52";

#include "gpss_prepare.h"
#include "gpss_decl.h"
#include "gpss_priv.h"

/************************************************************************/
/*                                                                      */
/*    *** Unterprogramm node_np_manager(node,ziel);                     */
/*    ***                                                               */
/*    *** Funktion : Modell eines Knotens mit nicht-verdraengenden      */
/*                   Strategien                                         */
/*    *** Rueckgabe: 1 = Adressausgang zur Endabrechnung                */
/*    ***            0 = normale Kontrollfluss-Uebergabe                */
/*    ***            wird in lokaler Variable reply gefuehrt            */
/*    ***                                                               */
/************************************************************************/
int node_np_manager(node,naddr)
int node;
int naddr;
{
	LOGICAL check();
	int reply=NORMAL;
	int ueclass;
	double random;
	int i, next;

	dprint(NODE_MANAGER,"np_manager Knoten %d case %d\n",node,naddr);
	assert(node >= 1 && node <= anznode);

	switch(naddr){
	case 1: /* Erster Versuch eine Multifacility zubelegen */
		dprint(NODE_MANAGER,"np_manager:   Knoten %d betreten\n",node);
		mv_ankunft(current_class(row_txact),node);
		CALL(wTiMe_arr(node,current_class(row_txact)))
		from_node(row_txact) = node;
	case 2: /* Erneuter oder erster Versuch eine Multifacility zubelegen */
		CALL(mseize(node,NEXT_ENTRY(node,2)))
		CALL(wTiMe_dep(node,current_class(row_txact)))
		CALL(bTiMe_arr(node,current_class(row_txact)))
		CALL(verteil(node,current_class(row_txact),&random))
		mv_bedienzeit(current_class(row_txact),node,random);
		CALL(mwork(node,random,0,NEXT_ENTRY(node,3)))
	case 3: /* Naechsten Knoten suchen */
		CALL(bTiMe_dep(node,current_class(row_txact)))
		CALL(blockTiMe_arr(node,current_class(row_txact)))
		ueclass = current_class(row_txact);
		to_node(row_txact) = nodenext(ueclass,node);
	case 4: /* Ist naechster Knoten aufnahmefaehig ? */
		next = to_node(row_txact);
		CALL(gate(GATE(node,next),1,1,0,NEXT_ENTRY(node,4)))
		/* Multifacility freigeben */
		CALL(blockTiMe_dep(node,current_class(row_txact)))
		mv_abgang(current_class(row_txact),node);
		CALL(free_gates(node))
		CALL(mclear(node))
		/* zum naechsten Knoten gehen */
		dprint(NODE_MANAGER,"np_manager Knoten %d verlassen\n",node);
		CALL(change())
		break;
	default: /* Fehler im Verteiler */
		;
		fprintf(nunit2, "\n\n+++++ activ: TiMe=%12.4f Fehler im Adressverteiler  naddr=%3d\n", TiMe,naddr);
		reply = FEHLER;
		break;
	};
	return(reply);
}

