static char *SccsId = "@(#)PEPSY:\tps_node.c\t1.3\t92/12/10 18:51:28";

#include "gpss_prepare.h"
#include "gpss_decl.h"
#include "gpss_priv.h"

/************************************************************************/
/*                                                                      */
/*    *** Unterprogramm node_ps_manager(node,ziel);                     */
/*    ***                                                               */
/*    *** Funktion : Modell eines Knotens mit Strategie PS              */
/*    *** Rueckgabe: 1 = Adressausgang zur Endabrechnung                */
/*    ***            0 = normale Kontrollfluss-Uebergabe                */
/*    ***            wird in lokaler Variable reply gefuehrt            */
/*    ***                                                               */
/************************************************************************/
int node_ps_manager(node,naddr)
int node;
int naddr;
{
	LOGICAL check();
	int reply=NORMAL;
	int ueclass, next, prev;
	double random,neuzeit;
	extern int pending_events;

	dprint(NODE_MANAGER,"ps_manager Knoten %d case %d\n",node,naddr);
	assert(node >= 1 && node <= anznode);
	switch(naddr){
	case 1:
		dprint(NODE_MANAGER,"ps_manager:   Knoten %d betreten\n",node);
		mv_ankunft(current_class(row_txact),node);
		from_node(row_txact) = node;
		CALL(verteil(node,current_class(row_txact),&random))
		mv_bedienzeit(current_class(row_txact),node,random);
		wanted_time(row_txact) = random;
		virtual_time(row_txact) = 0.0;
		gotten_time(row_txact) = 0.0;
		update_ps(node);
		knoten[node].act++;
		insert(node);
		CALL(bTiMe_arr(node,current_class(row_txact)))
		CALL(advanc(wanted_time(row_txact),NEXT_ENTRY(node,2)));
	case 2:
		dprint(ALL,"ps_manager: Knoten %d, Auftrag %d, Bedienzeit protokolliert\n",node,row_txact);
		CALL(bTiMe_dep(node,current_class(row_txact)));
		CALL(wTiMe_arr(node,current_class(row_txact)));
		CALL(announ(10*node+2,TiMe+eps));
		pending_events++;
		CALL(advanc(tend,NEXT_ENTRY(node,3)));
	case 3:
		/* Verweilzeit beendet */
		dprint(NODE_MANAGER,"ps_manager:   Knoten %d Verweilzeit protokolliert\n",node);
		CALL(wTiMe_dep(node,current_class(row_txact)))
		CALL(blockTiMe_arr(node,current_class(row_txact)))
		/* Naechsten Knoten suchen */
		ueclass = current_class(row_txact);
		to_node(row_txact) = nodenext(ueclass,node);
	case 4: /* Ist naechster Knoten aufnahmefaehig ? */
		dprint(NODE_MANAGER,"ps_manager:   Knoten %d zum naechsten Knoten\n",node);
		next = to_node(row_txact);
		CALL(gate(GATE(node,next),1,1,0,NEXT_ENTRY(node,4)))
		CALL(blockTiMe_dep(node,current_class(row_txact)))
		CALL(free_gates(node))
		mv_abgang(current_class(row_txact),node);
		dprint(NODE_MANAGER,"ps_manager:   Knoten %d verlassen\n",node);
		/* zum naechsten Knoten gehen */
		CALL(change())
		break;
	case 99:
		/* Fehler */
		fprintf(nunit2,"Transaction %d an falscher Stelle deblockiert\n",row_txact);
	reply = FEHLER;
	default: /* Fehler im Verteiler */
		;
		fprintf(nunit2, "\n\n+++++ activ: TiMe=%12.4f Fehler im Adressverteiler  naddr=%3d\n", TiMe,naddr);
		reply = FEHLER;
	};
	return(reply);
}


update_ps(node)
register int node;
{
	register next, count;
	double last_interval;
	double mintime = 100 * tend;
	double min2;

	last_interval = TiMe - knoten[node].last_change;
	knoten[node].last_change = TiMe;
	next = knoten[node].tx_list;
	count = 0;

	while(next != 0)
	{
		if(knoten[node].act < knoten[node].anzse)
			virtual_time(next) += last_interval ;
		else
			virtual_time(next) += last_interval * knoten[node].anzse / knoten[node].act;
		next = ps_next(next);
	}
}

insert(node)
int node;
{
	register int ltx, nltx;

	ltx = knoten[node].tx_list;

	if(ltx == 0)
	{
		knoten[node].tx_list = row_txact;
		ps_next(row_txact) = 0;
		return(0);
	}
	if(wanted_time(ltx) - virtual_time(ltx) > wanted_time(row_txact))
	{
		knoten[node].tx_list = row_txact;
		ps_next(row_txact)       = ltx;
		return(0);
	}

	while(ltx != 0)
	{
		nltx = ps_next(ltx);

		if(nltx == 0)
		{
			ps_next(ltx) = row_txact;
			ps_next(row_txact) = nltx;
			return(0);
		}
		if(wanted_time(nltx) - virtual_time(nltx) > wanted_time(row_txact))
		{
			ps_next(row_txact) = nltx;
			ps_next(ltx)       = row_txact;
			return(0);
		}
		ltx = nltx;
	}
	fprintf(nunit2,"ps-node: insert: error \n");
	return(-1);
}

Remove(node,ltx)
int node,ltx;
{
	if(knoten[node].tx_list == 0)
	{
		fprintf(nunit2,"ps-node: Remove: error \n");
		return(-1);
	}
	if(knoten[node].tx_list != ltx)
	{
		fprintf(nunit2,"ps-node: Remove: error-2 \n");
		return(-1);
	}
	knoten[node].tx_list = ps_next(knoten[node].tx_list);
	return(0);
}

dump_tx_list(node)
int node;
{
	register int ltx;

	ltx = knoten[node].tx_list;

	fprintf(nunit2,"Knoten %d: ");

	while(ltx != 0)
	{
		fprintf(nunit2, "%d (%lf,%lf) - ", 
			ltx, virtual_time(ltx), wanted_time(ltx) - virtual_time(ltx));
		ltx = ps_next(ltx);
	}
	fprintf(nunit2,"\n");
}

