static char *SccsId = "@(#)PEPSY:\tresult.c\t1.3\t93/05/17 12:32:49";

/*
	Berechnung der Leistungegroessen 

*/

#include <math.h>
#include <stdio.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"
#include "gpss_priv.h"

static double lambda, mvz, maa, rho, mwz, mwsl, bzeit, e;
static double blockzeit, blockanz, wkonfint, weinabw, weinend, bkonfint;
static double beinabw, beinend,Mittelwert, Varianz, Varianzkoeff;
static double maxkonfi;

results(fpout)
FILE *fpout;
{

	register int i,j;

	if(TiMe <= 0.0)
		return(0);

	endbin();
	maxkonfi = 0;

	fprintf(fpout,"\nsimulation\n");
	fprintf(fpout,"%4d %4d %4d\n\n",nettyp,anznode,anzclass);

	for(i=1;i<=anzclass;i++)
	{
		fprintf(fpout,"#Auftragsklasse %d \n",i);
		fprintf(fpout,"# N   lambda     e       1/mue    rho      mvz      maa      mwz      mwsl  \n");

		for(j=1;j<=anznode;j++)
		{
			basisgroessen(fpout,j,i);
		}
	}
	for(i=1;i<=anzclass;i++)
	{
		fprintf(fpout,"Auftragsklasse %d \n",i);
		fprintf(fpout,
		    " N | blockz | blockl |bmin    |bmax    |eende(b)|wmin    |wmax    |eende(w)\n");
		for(j=1;j<=anznode;j++)
		{
			zusatzgroessen(fpout,j,i);
		}
	}
	for(i=1;i<=anzclass;i++)
	{
		fprintf(fpout,"Mittelwert,Varianz und Variationskoeffizient\n");
		fprintf(fpout,"des Ankunfts-, Bedien- und Abgangsprozesses\n");
		fprintf (fpout,"Auftragsklasse %d \n",i);
		fprintf(fpout,
		    " N   MW(A)    Var(A)   Vko(A)   Basis    MW(B)    Var(B)   Vko(B)   Basis    MW(D)    Var(D)   Vko(D)   Basis    \n");
		for (j=1;j<=anznode;j++)
		{
			verteilungen(fpout,j,i);
		}
	}
	fprintf(fpout,"Netzgroessen  \n");
	fprintf(fpout," N   lambda     1/mue    rho      mvz      maa      mwz      mwsl  \n");
	for(j=0;j<=anznode;j++)
	{
		netzgroessen(fpout,j);
	}
	fprintf(fpout,
		" N | blockz | blockl |bmin    |bmax    |eende(b)|wmin    |wmax    |eende(w)\n");
	for(j=0;j<=anznode;j++)
	{
		zusatznetzgroessen(fpout,j);
	}

	fprintf(fpout,"\nGewuenschte Simulationsdauer = %lf\n",tend);
	fprintf(fpout,"Simulationsende : %lf \n",TiMe);
	fprintf(fpout,"groesstes Konfidenzintervall: %lf\n",maxkonfi);
	fprintf(fpout,"Falls Gewuenschte Simulationszeit != Simulationsende, dann siehe sim_fehler\n");
	return( (int) maxkonfi + 1);
}


basisgroessen(fpout,knot,klasse)
int knot, klasse;
FILE *fpout;
{
	register struct BINSTA *bp1, *bp2, *bp3;
	register int k;

	bp1 = &binsta[WAIT_BIN(knot,klasse)];
	bp2 = &binsta[SERV_BIN(knot,klasse)];
	bp3 = &binsta[BLOCK_BIN(knot,klasse)];

	/* Durchsatz */

	lambda = 
		((bin[SERV_BIN(knot,klasse)].access
			+bin[SERV_BIN(knot,klasse)].leave)/2)/TiMe;
	/* Mittlere Verweilzeit */

	mvz = bp1->wait*(1 + bp1->dev/100.0)
		+ bp2->wait*(1 + bp2->dev/100.0)
		+ bp3->wait*(1 + bp3->dev/100.0);

	/* Mittlere Anzahl der Auftraege */

	maa = 
		bp1->que_length+(bp1->que_length*bp1->dev/100)
		+ bp2->que_length+(bp2->que_length*bp2->dev/100)
		+ bp3->que_length+(bp3->que_length*bp3->dev/100);
	/* Auslastung */

	k = knoten[knot].anzse;
	if (k ==0)
		rho = 0.0;
	else
		rho = bin[SERV_BIN(knot,klasse)].total_wait/(k*TiMe);

	/* Mittlere Wartezeit */

	mwz = bp1->wait+(bp1->wait*bp1->dev/100);

	/* Mittlere Warteschlangenlaenge */

	mwsl = bp1->que_length+(bp1->que_length*bp1->dev/100);

	/* Mittlere Bedienzeit */

	bzeit = bp2->wait+(bp2->wait*bp2->dev/100.0);

	/* Besuchshaeufigkeit */
	e = besh[knot][klasse];

	fprintf(fpout, "   %8.4g %8.4g %8.4g %8.4g %8.4g %8.4g %8.4g %8.4g\n",
			lambda,e,bzeit,rho,mvz,maa,mwz,mwsl);
}

zusatzgroessen(fpout,knot,klasse)
int knot, klasse;
FILE *fpout;
{
	register struct BINSTA *bp1, *bp2, *bp3;

	bp1 = &binsta[WAIT_BIN(knot,klasse)];
	bp2 = &binsta[SERV_BIN(knot,klasse)];
	bp3 = &binsta[BLOCK_BIN(knot,klasse)];

	/* Mittlere Blockierzeit */

	blockzeit = bp3->wait+(bp3->wait*bp3->dev/100);

	/* Mittlere Blockanzahl */

	blockanz = bp3->que_length+(bp3->que_length*bp3->dev/100);


	/* Mittlere Wartezeit */

	mwz = bp1->wait+(bp1->wait*bp1->dev/100);

	/* Konfidenzintervall in % */

	wkonfint = bp1->confi;
	if(wkonfint > maxkonfi && mwz > 1e-3) maxkonfi = wkonfint;

	/* Abweichung wegen Einschwingphase */

	weinabw = bp1->dev;

	/* Ende der Einschwingphase */

	weinend = bp1->end_osz;

	/* Mittlere Bedienzeit */

	bzeit = bp2->wait+(bp2->wait*bp2->dev/100.0);

	/* Konfidenzintervall in % */

	bkonfint = bp2->confi;
	if(bkonfint > maxkonfi && bzeit > 1e-3) maxkonfi = bkonfint;

	/* Abweichung wegen Einschwingphase */

	beinabw = bp2->dev;

	/* Ende der Einschwingphase */

	beinend = bp2->end_osz;
	fprintf(fpout," %2d  %8.4g %8.4g %8.4g %8.4g %8.4g %8.4g %8.4g %8.4g\n",
		knot,blockzeit,blockanz,bzeit*(1.0-bkonfint/100),
		bzeit*(1.0+bkonfint/100),beinend,
		mwz*(1.0-wkonfint/100),mwz*(1.0+wkonfint/100),weinend);
}

verteilungen(fpout,knot,klasse)
int knot, klasse;
FILE *fpout;
{
	/* Berechnung des Mittelwertes und der Varianz            */

	if ((arr_anz[knot][klasse] > 0)&&(arr_mit[knot][klasse] > 0))
	{
		Mittelwert = arr_mit[knot][klasse]/arr_anz[knot][klasse];
		Varianz = (arr_var[knot][klasse]/arr_anz[knot][klasse]) - Mittelwert*Mittelwert;
		Varianzkoeff = Varianz/Mittelwert/Mittelwert;
		fprintf(fpout,
			" %d   %8.4g %8.4g %8.4g %8d ",
			knot,Mittelwert,Varianz,Varianzkoeff,arr_anz[knot][klasse]);
	}
	else
	{
		fprintf(fpout,"\n %d                            ",knot);
	}
	if ((bed_anz[knot][klasse] > 0)&&(bed_mit[knot][klasse] > 0))
	{
		Mittelwert = bed_mit[knot][klasse]/bed_anz[knot][klasse];
		Varianz = (bed_var[knot][klasse]/bed_anz[knot][klasse]) - Mittelwert*Mittelwert;
		Varianzkoeff = Varianz/Mittelwert/Mittelwert;
		fprintf(fpout,
			"%8.4g %8.4g %8.4g %8d ",
			Mittelwert,Varianz,Varianzkoeff,bed_anz[knot][klasse]);
	}
	else
	{
		fprintf(fpout,"                        ");
	}
	if ((dep_anz[knot][klasse] > 0)&&(dep_mit[knot][klasse] > 0))
	{
		Mittelwert = dep_mit[knot][klasse]/dep_anz[knot][klasse];
		Varianz = (dep_var[knot][klasse]/dep_anz[knot][klasse]) - Mittelwert*Mittelwert;
		Varianzkoeff = Varianz/Mittelwert/Mittelwert;
		fprintf(fpout,
			"%8.4g %8.4g %8.4g %8d ",
			Mittelwert,Varianz,Varianzkoeff,dep_anz[knot][klasse]);
	}
	else
	{
		fprintf(fpout,"                        ");
	}
	fprintf(fpout,"\n");
}

netzgroessen(fpout,knot)
int knot;
FILE *fpout;
{


	register struct BINSTA *bp1, *bp2, *bp3;
	int k,klassen = anzclass+1;

	bp1 = &binsta[WAIT_BIN_TOT(knot,klasse)];
	bp2 = &binsta[SERV_BIN_TOT(knot,klasse)];
	bp3 = &binsta[BLOCK_BIN_TOT(knot,klasse)];

	/* Durchsatz */

	lambda = 
		((bin[SERV_BIN_TOT(knot,klasse)].access
			+bin[SERV_BIN_TOT(knot,klasse)].leave)/2)/TiMe;
	/* Mittlere Verweilzeit */

	mvz = bp1->wait*(1 + bp1->dev/100.0)
		+ bp2->wait*(1 + bp2->dev/100.0)
		+ bp3->wait*(1 + bp3->dev/100.0);

	/* Mittlere Anzahl der Auftraege */

	maa = 
		bp1->que_length+(bp1->que_length*bp1->dev/100)
		+ bp2->que_length+(bp2->que_length*bp2->dev/100)
		+ bp3->que_length+(bp3->que_length*bp3->dev/100);
	/* Auslastung */

	if(knot == 0)
		k = 0;
	else
		k = knoten[knot].anzse;
	if (k ==0)
		rho = 0.0;
	else
		rho = bin[SERV_BIN_TOT(knot,klasse)].total_wait/(k*TiMe);

	/* Mittlere Wartezeit */

	mwz = bp1->wait+(bp1->wait*bp1->dev/100);

	/* Mittlere Warteschlangenlaenge */

	mwsl = bp1->que_length+(bp1->que_length*bp1->dev/100);

	/* Mittlere Bedienzeit */

	bzeit = bp2->wait+(bp2->wait*bp2->dev/100.0);

	/* Besuchshaeufigkeit */

	e = 0.0; 

	fprintf(fpout, "   %8.4g %8.4g %8.4g %8.4g %8.4g %8.4g %8.4g\n",
			lambda,bzeit,rho,mvz,maa,mwz,mwsl);
}

zusatznetzgroessen(fpout,knot)
int knot;
FILE *fpout;
{
	register struct BINSTA *bp1, *bp2, *bp3;
	int klasse = anzclass+1;

	bp1 = &binsta[WAIT_BIN(knot,klasse)];
	bp2 = &binsta[SERV_BIN(knot,klasse)];
	bp3 = &binsta[BLOCK_BIN(knot,klasse)];

	/* Mittlere Blockierzeit */

	blockzeit = bp3->wait+(bp3->wait*bp3->dev/100);

	/* Mittlere Blockanzahl */

	blockanz = bp3->que_length+(bp3->que_length*bp3->dev/100);


	/* Mittlere Wartezeit */

	mwz = bp1->wait+(bp1->wait*bp1->dev/100);

	/* Konfidenzintervall in % */

	wkonfint = bp1->confi;
	if(wkonfint > maxkonfi && mwz > 1e-3) maxkonfi = wkonfint;

	/* Abweichung wegen Einschwingphase */

	weinabw = bp1->dev;

	/* Ende der Einschwingphase */

	weinend = bp1->end_osz;

	/* Mittlere Bedienzeit */

	bzeit = bp2->wait+(bp2->wait*bp2->dev/100.0);

	/* Konfidenzintervall in % */

	bkonfint = bp2->confi;
	if(bkonfint > maxkonfi && bzeit > 1e-3) maxkonfi = bkonfint;

	/* Abweichung wegen Einschwingphase */

	beinabw = bp2->dev;

	/* Ende der Einschwingphase */

	beinend = bp2->end_osz;
	fprintf(fpout," %2d  %8.4g %8.4g %8.4g %8.4g %8.4g %8.4g %8.4g %8.4g\n",
		knot,blockzeit,blockanz,bzeit*(1.0-bkonfint/100),
		bzeit*(1.0+bkonfint/100),beinend,
		mwz*(1.0-wkonfint/100),mwz*(1.0+wkonfint/100),weinend);
}

