static char *SccsId = "@(#)PEPSY:\trr_node.c\t1.2\t92/03/27 12:01:02";

#include "gpss_prepare.h"
#include "gpss_decl.h"
#include "gpss_priv.h"

/************************************************************************/
/*                                                                      */
/*    *** Unterprogramm node_rr_manager(node,ziel);                     */
/*    ***                                                               */
/*    *** Funktion : Modell eines Knotens mit Strategie Round-Robin     */
/*    *** Rueckgabe: 1 = Adressausgang zur Endabrechnung                */
/*    ***            0 = normale Kontrollfluss-Uebergabe                */
/*    ***            wird in lokaler Variable reply gefuehrt            */
/*    ***                                                               */
/************************************************************************/
int node_rr_manager(node,naddr)
int node;
int naddr;
{
	LOGICAL check();

	int reply=NORMAL;
	int ueclass,next;
	double random;
	double thilf;
	double slice = 0.1;

	dprint(NODE_MANAGER,"rr_manager Knoten %d case %d\n",node,naddr);
	assert(node >= 1 && node <= anznode);
	switch(naddr){
	case 1: /* Erneuter oder erster Versuch eine Multifacility zubelegen */
		from_node(row_txact) = node;
		CALL(mseize(node,NEXT_ENTRY(node,1)))
		if (wanted_time(row_txact) == 0.0)
		{
			CALL(bTiMe_arr(node,current_class(row_txact)))
			CALL(free_gates(node))
			mv_ankunft(current_class(row_txact),node);
			CALL(verteil(node,current_class(row_txact),&random))
			mv_bedienzeit(current_class(row_txact),node,random);
			wanted_time(row_txact) = random;
			virtual_time(row_txact) = TiMe+random;
		}
		if (virtual_time(row_txact) < (TiMe + slice))
		{
			thilf = TiMe;
			TiMe = virtual_time(row_txact);
			CALL(bTiMe_dep(node,current_class(row_txact)))
			CALL(wTiMe_arr(node,current_class(row_txact)))
			TiMe = thilf;
			virtual_time(row_txact) = tend;
		}
		if (wanted_time(row_txact) > slice)
		{
			wanted_time(row_txact) = wanted_time(row_txact) - slice;
			CALL(mwork(node,slice,0,node*100+2))
		}
		else 
		{
			thilf = TiMe;
			TiMe = TiMe + wanted_time(row_txact);
			CALL(wTiMe_dep(node,current_class(row_txact)))
			TiMe = thilf;
			reply=mwork(node,wanted_time(row_txact),0,node*100+2);
			wanted_time(row_txact) =  0.0;
			if (reply == AUSGANG2 || reply == FEHLER) break;
		}
	case 2: /* Naechsten Knoten suchen */
		if (wanted_time(row_txact) != 0.0)
		{
			to_node(row_txact) = node;
		}
		else
		{
			ueclass = current_class(row_txact);
			to_node(row_txact) = nodenext(ueclass,node);
		}
	case 3: /* Ist naechster Knoten aufnahmefaehig ? */
		next = to_node(row_txact);
		if (wanted_time(row_txact) != 0.0){
			tx_system[row_txact].TiMe_left = 1.0;
			CALL(blockTiMe_arr(node,current_class(row_txact)))
			tx_system[row_txact].TiMe_left = 0.0;
		}
		else
		{
			CALL(blockTiMe_arr(node,current_class(row_txact)))
		}
		CALL(gate(GATE(node,next),1,1,0,NEXT_ENTRY(node,3)))
		if (wanted_time(row_txact) == 0.0)
		{
			mv_abgang(current_class(row_txact),node);
			CALL(blockTiMe_dep(node,current_class(row_txact)))
		}
		else
		{
			tx_system[row_txact].TiMe_left = 1.0;
			CALL(blockTiMe_dep(node,current_class(row_txact)))
			tx_system[row_txact].TiMe_left = 0.0;
		}
		/* Multifacility freigeben */
		CALL(free_gates(node))
		CALL(mclear(node))
		/* zum naechsten Knoten gehen */
		CALL(change())
		break;
	default: /* Fehler im Verteiler */
		;
		fprintf(nunit2, "\n\n+++++ activ: TiMe=%12.4f Fehler im Adressverteiler  naddr=%3d\n", TiMe,naddr);
		reply = FEHLER;
	};
	return(reply);
}

