static char *SccsId = "@(#)PEPSY:\tsr_node.c\t1.2\t92/03/27 12:01:04";

/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/


#include "gpss_prepare.h"
#include "gpss_decl.h"
#include "gpss_priv.h"


/************************************************************************/
/*                                                                      */
/*    *** Unterprogramm node_srcmanager(prio);                          */
/*    ***                                                               */
/*    *** Funktion : Modell einer Quelle                                */
/*    *** Rueckgabe: Folgeknoten                                        */
/*    ***                                                               */
/************************************************************************/

int node_srcmanager(prio,naddr,node)
int prio,naddr,node;
{
	LOGICAL check();
	int reply = NORMAL;
	double random;
	double priority;
	int local_bin, next;

	assert(prio <= anzclass);
	priority = (double)(-prio+0.5);
	switch(naddr)
	{
		case 1: /* Geschlossene Klasse, Transitionen zum Fuellen des Netzes */
			dprint(NODE_MANAGER,"node_srcmanager: Klasse %d (%d) -> Knoten %d\n",prio,anz_trans[prio],node);
			reply = genera(0.0,priority);
			if (reply == FEHLER)
				return(FEHLER);
			anz_trans[prio]++;
			to_node(row_txact) = node;
			current_class(row_txact) = prio;
			if(change() == FEHLER)
				return(FEHLER);
			return(NORMAL);
		case 2: /* Offene Klasse */
			verteil(0,prio,&random);
			reply = genera(random,priority);
			if (reply == FEHLER) return(FEHLER);
			anz_trans[prio]++;
			to_node(row_txact) = nodenext(prio,0);
			current_class(row_txact) = prio;
			CALL(bTiMe_arr(0,current_class(row_txact)));
		case 3:  /* nach Blockierung mit neuer Uberpruefung */
			prio = (int) tx_system[row_txact].priority;
			dprint(NODE_MANAGER,"node_srcmanager: Klasse %d (%d) -> Knoten %d war blockiert\n",current_class(row_txact),anz_trans[current_class(row_txact)],to_node(row_txact));
			from_node(row_txact) = 0;
			next = to_node(row_txact);
			/*
			reply = gate(GATE(0,next),1,1,0,NEXT_ENTRY(0,3));
			if (reply == FEHLER ) 
				return(FEHLER);
			*/
			if(check(1) == FALSE) /* d.h. Nachfolger nicht aufnahmefaehig */
			{
				dprint(NODE_MANAGER,"node_srcmanager: Klasse %d (%d) abgewiesen\n",current_class(row_txact),anz_trans[current_class(row_txact)]);
				anz_trans[current_class(row_txact)]--;
				termin();
				return(NORMAL);
			}
			CALL(bTiMe_dep(0,current_class(row_txact)));
			dprint(NODE_MANAGER,"node_srcmanager: Klasse %d (%d) \n",current_class(row_txact),anz_trans[current_class(row_txact)]);
			wTiMe_arr(0,current_class(row_txact));
			reply = change();
			break;
	}
	return(reply);
}

