static char *SccsId = "@(#)PEPSY:\ttool.c\t1.2\t92/03/27 12:01:06";

/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/


#include "gpss_prepare.h"
#include "gpss_decl.h"
#include "gpss_priv.h"
#include <assert.h>
#include <math.h>
#define CALLY(A) reply=A; \
                 if (reply == FEHLER || reply == AUSGANG2) return(reply);


int wTiMe_arr(node,cl)
int node; 
int cl; 
{
	int local_bin;
	int reply = NORMAL;

	assert(node <= anznode);
	assert(cl <= anzclass);
	local_bin = WAIT_BIN_TOT(node,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(arrive(local_bin,1));
	local_bin = WAIT_BIN(node,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(arrive(local_bin,1));
	local_bin = WAIT_BIN_TOT(0,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(arrive(local_bin,1));
	local_bin = WAIT_BIN(0,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(arrive(local_bin,1));
	return(reply);
}

int wTiMe_dep(node,cl)
int node; 
int cl; 
{
	int local_bin;
	int reply = NORMAL;

	assert(node <= anznode);
	assert(cl <= anzclass);
	local_bin = WAIT_BIN_TOT(node,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(depart(local_bin,1,250.0));
	local_bin = WAIT_BIN(node,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(depart(local_bin,1,250.0));
	local_bin = WAIT_BIN_TOT(0,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(depart(local_bin,1,250.0));
	local_bin = WAIT_BIN(0,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(depart(local_bin,1,250.0));
	return(reply);
}

int bTiMe_arr(node,cl)
int node;
int cl; 
{
	int local_bin;
	int reply = NORMAL;

	assert(node <= anznode);
	assert(cl <= anzclass);
	local_bin = SERV_BIN_TOT(node,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(arrive(local_bin,1));
	local_bin = SERV_BIN(node,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(arrive(local_bin,1));
	local_bin = SERV_BIN_TOT(0,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(arrive(local_bin,1));
	local_bin = SERV_BIN(0,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(arrive(local_bin,1));
	return(reply);
}

int bTiMe_dep(node,cl)
int node; 
int cl; 
{
	int local_bin;
	int reply = NORMAL;

	assert(node <= anznode);
	assert(cl <= anzclass);
	local_bin = SERV_BIN_TOT(node,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(depart(local_bin,1,250.0));
	local_bin = SERV_BIN(node,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(depart(local_bin,1,250.0));
	local_bin = SERV_BIN_TOT(0,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(depart(local_bin,1,250.0));
	local_bin = SERV_BIN(0,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(depart(local_bin,1,250.0));
	return(reply);
}

int blockTiMe_arr(node,cl)
int node; 
int cl; 
{
	int local_bin;
	int reply = NORMAL;

	assert(node <= anznode);
	assert(cl <= anzclass);
	local_bin = BLOCK_BIN_TOT(node,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(arrive(local_bin,1));
	local_bin = BLOCK_BIN(node,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(arrive(local_bin,1));
	return(reply);
}

int blockTiMe_dep(node,cl)
int node;
int cl; 
{
	int local_bin;
	int reply = NORMAL;

	assert(node <= anznode);
	assert(cl <= anzclass);
	local_bin = BLOCK_BIN_TOT(node,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(depart(local_bin,1,250.0));
	local_bin = BLOCK_BIN(node,cl);
	assert(local_bin >= 1&& local_bin <zbin);
	CALLY(depart(local_bin,1,250.0));
	return(reply);
}


int free_gates(node)
int node;  
{
	int reply = NORMAL;
	int i;
	dprint(FREE_GATE,"free_gate Knoten %d \n",node);
	if (knoten[node].wsmax != -1)
	{
		dprint(FREE_GATE,"free_gate Knoten %d \n",node);
		for (i=0;i<=anznode;i++)
		{
			CALLY(dblock(5,GATE(i,node),0,0));
		}
	}
	return(reply);
}

int change()
{
	int reply = NORMAL;
	int local_bin,nextnode;
	int prio;

	prio = current_class(row_txact);
	nextnode = to_node(row_txact);
	dprint(TRANS,"change: Klasse %d, Ziel %d\n",prio,nextnode);
	if (nextnode == 0) /* Senke */
	{
		CALLY(wTiMe_dep(0,prio));
		anz_trans[prio]--;
		dprint(TRANS,"change: Klasse %d (%d) fertig\n",prio,anz_trans[prio]);
		CALLY(termin());
	}
	else /* naechster Knoten */
	{
		reply = (nchain(3,row_txact)); /* um sicherzugehen */
		activlist[row_txact].target = NEXT_ENTRY(nextnode,1);
		activlist[row_txact].next = TiMe;
		CALLY(tchain(3,row_txact));
		/*
		head[3].next = TiMe;
		*/
	}
	return(reply);
}

int nodenext(cl,node)
int cl;  
int node;
{
	double actwsk;
	double value;
	extern double rnx();
	int i;

	assert(node >= 0 && node <= anznode);
	assert(cl >= 1 && cl <= anzclass);
	value = rnx(node*anzclass+cl); 
	actwsk = 0.0;
	for (i=0;i<=anznode;i++)
	{
		actwsk += uewsk[cl][node][i];
		dprint(TRANS,"nodenext: Klasse %d, Knoten %d -> %d, value %g,wsk %g\n",cl,node,i,value,actwsk);
		if(actwsk >= value)
		{
			dprint(TRANS,"nodenext: Klasse %d, Knoten %d -> %d, value %g\n",cl,node,i,value);
			return(i);
		}
	}
	dprint(ERROR,"nodenext: kein Nachfolger gefunden\n");
	return(anznode+1);
}

int verteil(node,cl,random)
int node;              /* 0=Quelle; 1..anznode = Knotennummer */
int cl;  
double *random;
{
	double mean,mean1,mean2,wsk,varikoeff;
	double min,max,max1,max2,ratio,sigma,a,b;
	double transfer;
	int k;
	int reply=NORMAL;
    int rangen;

	assert(node >= 0 && node <= anznode);
	assert(cl >= 1 && cl <= anzclass);
	/* offset wegen Generatroren fuer UEW's */
	rangen = anznode *anzclass * anzclass;
	/* 11 Generatoren pro Klasse und Knoten */
	rangen = rangen + (node*anzclass+cl)*11; 
	*random = 0.0;

	switch (workTiMe[node][cl].verteil)
	{
	case AUTOMATIC:
		mean = workTiMe[node][cl].mean;
		mean1 = workTiMe[node][cl].mean1;
		mean2 = workTiMe[node][cl].mean2;
		assert(mean > 0.0);
		varikoeff = workTiMe[node][cl].varikoeff;
		wsk = workTiMe[node][cl].wsk;
		if (wsk > 1.0) wsk = 1.0;
		if (wsk < 0.0) wsk = 0.0;
		if (varikoeff*varikoeff <= 0.1)
		{
			*random = mean;
			break;
		}
		if (varikoeff == 1.0)
		{
			reply = erlang2(mean,1,eps,100*mean,rangen,random);
			break;
		}
		if ((varikoeff < 1.0)&&(varikoeff*varikoeff > 0.1))
		{
			assert(mean1 > 0.0);
			assert(mean2 > 0.0);
			unifrm(0.0,1.0,rangen,&transfer);
			if (transfer <= wsk)
			{
				reply = erlang2(mean1,1,eps,100*mean1,rangen+1,random);
			}
			else
			{
				reply = erlang2(mean2*mean1,(int)mean2,eps,100*mean2*mean1,rangen+2,random);
			}
			break;
		}
		if (varikoeff > 1.0)
		{
			assert(mean1 > 0.0);
			assert(mean2 > 0.0);
			unifrm(0.0,1.0,rangen,&transfer);
			if (transfer <= wsk)
			{
				reply = erlang2(mean1,1,eps,100*mean1,rangen+1,random);
			}
			else
			{
				reply = erlang2(mean2,1,eps,100*mean2,rangen+2,random);
			}
			break;
		}
		break;
	case AUTOMATIC2:
		mean = workTiMe[node][cl].mean;
		mean1 = workTiMe[node][cl].mean1;
		mean2 = workTiMe[node][cl].mean2;
		varikoeff = workTiMe[node][cl].varikoeff;
		wsk = workTiMe[node][cl].wsk;
		if(varikoeff > 1.0 ) /* Approximation als GE-Verteilung */
		{
			assert(mean1 > 0.0);
			assert(mean2 > 0.0);
			unifrm(0.0,1.0,rangen,&transfer);
			if (transfer <= wsk)
				erlang2(mean1,1,eps,100*mean1,rangen+1,random);
			else
				*random = mean2;
			break;
		}
		if(varikoeff <= 1.0 ) /* konstanter Anteil plus exponentielle Phase */
		{
			if(mean1 > eps)
			{
				reply = erlang2(mean1,1,eps,100*mean1,rangen,random);
			}
			*random += mean2;
			break;
		}
		break;
	case LOGNOR:
		mean = workTiMe[node][cl].mean;
		min = workTiMe[node][cl].mean1;
		max = workTiMe[node][cl].mean2;
		sigma = workTiMe[node][cl].varikoeff;
		lognor2(mean,sigma,min,max,rangen,random);
		break;
	default:
		fprintf(nunit2,"unbekannte Verteilung Knoten %d, Klasse %d\n",
			node,cl);
		return(FEHLER);
		break;
	}
	dprint(TRANS,"verteil: Knoten %d, Klasse %d, Zeit %lg\n",node,cl,*random);
	return(reply);
}


