/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/

#define USAGE() { fprintf(stderr,"zulaessige Parameter \n\t-n no endtest\n\t-d mask debug Option\n"); exit(1); }


/* Simulator                                                   */
/* =========                                                   */

/*                                                                 */
/*   Einbinden der Header-Dateien                                  */
/*                                                                 */

#define MAIN
#include <signal.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"
#include "gpss_priv.h"

/*                                                                 */
/*   Vorbesetzung der Namen fuer Dateien                           */
/*                                                                 */

static char *SccsId = "@(#)PEPSY:\tuser.c\t1.6\t93/05/18 12:53:41";

/*                                                                      */
/*   Globale Benutzer-Variablen definieren                              */
/*   =====================================                              */

int (*user_endtest)();

/*   Rahmen und Benutzerprogramme                                       */

/************************************************************************/
/*                                                                      */
/*    *** GPSS  C  Simulationsprogramm                                  */
/*    ***                                                               */
/*    *** Modell  General Simulator                                     */
/*    ***                                                               */
/*    *** Version 1.0                                                   */
/*    ***                                                               */
/*    *** Autor               : Martina Goetz                           */
/*    *** Beginn              : 08.01.1988                              */
/*    *** Endgueltige Fassung : 25.07.1988                              */
/*    *** Letzte Aenderung    : 13.11.1989                              */
/*																		*/
/*	  *** Ergaenzungen: ueberpreufen der Breite des 95%-Konfidenz-      */
/*                      intervalls durch Benutzer meoglich              */
/*                      Funktion user_endtest()                         */
/*                                                                      */
/*                                                                      */
/*                                                                      */
/************************************************************************/

/* Private lokale Variablen definieren                                  */
/* ===================================                                  */
static int anzauftr,mwauftr;
static int seserv,anzse;
static int pos,offs;
static int ok,mausi;
static int rest;
int endtest();
int noendtest();


/*    1. Allgemeine C-Deklarationen                                     */
/*    =============================                                     */
main(argc,argv)
int argc;
char *argv[]; /* Namen der Ein- und Ausgabedatei */
{
	extern int init2(),init3(),flowc();
	extern int reset(),preset(),init1x(),init4(),savin(),endbin();
	extern int endplo(), init_ptr();

	/*		Sccs support from SccsLogging.c			*/	
	extern int SccsRelease;
	extern int SccsLevel;

	/*    Zusaetzliche externe Funktionen deklarieren		*/
	/*    ===========================================		*/
	extern void sig_bus(), sig_fpe(), sig_segv(), sig_stop(), sig_ill();

	extern mod_input();
	void get_info();

	/*    Lokale Variablen definieren                                    */
	/*    ===========================                                    */

	int max,anztr,xout ;
	int i,j,k,succ, c, testend = 0;
	char *ptr, *progname;
	FILE *eindat;
	long strtol();
	extern char *optarg;
	extern int optind;

	datain	= "sim_in";
	dataout	= "sim_ergebnis";

	while(( c= getopt(argc,argv,"d:nV")) != EOF)
	{
		switch(c)
		{
			case 'V':
				printf("%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
				exit(0);
				break;
			case 'd':
				if((dbg = strtol(optarg,(char **)NULL,0)) <= 0)
					dbg = 1;
				fprintf(stderr,"dbg set to 0x%x\n",dbg);
				break;
			case 'n':
				testend = 1;
				break;
			default:
				USAGE();
				break;
		}
	}


	/*    Festlegen der Betriebsart                                      */
	/*    =========================                                      */
	xmodus = 0;
	ymodus = 0;


	/*    Oeffnen der Dateien fuer Ein- und Ausgabe                      */
	/*    =========================================                      */
	/*                                                                   */
	switch(argc-optind)
	{
		case 0:
			eindat = stdin;
			if((ausdat  = fopen(dataout,"w")) == NULL)
			{
				fprintf(stderr,"Datei %s laesst sich nicht oeffnen\n",dataout);
				exit(1);
			}
			break;
		case 1:
			datain = argv[argc-1];
			if((eindat = fopen(datain ,"r") ) == NULL)
			{
				fprintf(stderr,"Datei %s laesst sich nicht oeffnen\n",datain);
				exit(1);
			}
			if((ausdat  = fopen(dataout,"w") ) == NULL)
			{
				fprintf(stderr,"Datei %s laesst sich nicht oeffnen\n",dataout);
				exit(1);
			}
			break;
		case 2:
			datain = argv[argc-2];
			dataout= argv[argc-1];
			if((eindat = fopen(datain ,"r") ) == NULL)
			{
				fprintf(stderr,"Datei %s laesst sich nicht oeffnen\n",datain);
				exit(1);
			}
			if((ausdat  = fopen(dataout,"w") ) == NULL)
			{
				fprintf(stderr,"Datei %s laesst sich nicht oeffnen\n",dataout);
				exit(1);
			}
			break;
		default: 
			USAGE();
			break;
	}
	if(testend == 0)
	{
		/* normaler Ablauf, Test der Konfidenzintervallbreite */

		user_endtest = endtest;
	}
	else
	{
		/* kein Test der Konfidenzintervallbreite */

		user_endtest = noendtest;
	}
	if(dbg)
		fprintf(stderr,"datain = %s, dataout = %s, endtest %s\n",
			datain,dataout,(testend == 0 ? "ja" : "nein"));
	if(dbg)
	{
		nunit2 = stderr;
	}
	else
	{
		if((nunit2  = fopen("sim_fehler","w") ) == NULL)
			nunit2 = stderr;
		fprintf(nunit2,"\n");
		setbuf(nunit2,NULL);
	}
	/*    Interaktive Eingabe: Terminal                                  */
	/*    -----------------------------                                  */
	xunit3 =  stdin ;

	/*    Interaktive Ausgabe: Terminal                                  */
	/*    -----------------------------                                  */
	xunit4 =  stdout ;

	/*    Datei fuer die Graphik Prozess Kommunikation: gracom           */
	/*    ----------------------------------------------------           */
	if ((unit5  = fopen("gracom","a+") ) == NULL) {
		fprintf(stderr, " user: Fehler beim Oeffnen von File gracom\n");
		exit(1);
	}

	/*    Scratchdatei: scrat1                                           */
	/*    --------------------                                           */
	if ((unit6  = fopen("scrat1","a+") ) == NULL) {
		fprintf(stderr, " user: Fehler beim Oeffnen von File scrat1\n");
		exit(1);
	}

	/*    Sicherungsdatei: saved                                         */
	/*    ----------------------                                         */
	if ((unit7  = fopen("saved","a+") ) == NULL) {
		fprintf(stderr, " user: Fehler beim Oeffnen von File saved\n");
		exit(1);
	}

	/*    Scratchdatei: scrat2                                           */
	/*    --------------------                                           */
	if ((unit8  = fopen("scrat2","a+") ) == NULL) {
		fprintf(stderr, " user: Fehler beim Oeffnen von File scrat2\n");
		exit(1);
	}

	/*    Plotdatei: plot1                                               */
	/*    ----------------                                               */
	if ((nunit21  = fopen("plot1","a+") ) == NULL) {
		fprintf(stderr, " user: Fehler beim Oeffnen von File plot1\n");
		exit(1);
	}

	/*    Plotdatei: plot2                                               */
	/*    ----------------                                               */
	if ((nunit22  = fopen("plot2","a+") ) == NULL) {
		fprintf(stderr, " user: Fehler beim Oeffnen von File plot2\n");
		exit(1);
	}

	/*    Graphikdatei fuer Vehicle-Aktivitaeten: cardat                 */
	/*    -------------------                                            */
	if ((nunit23  = fopen("cardat","a+") ) == NULL) {
		fprintf(stderr, " user: Fehler beim Oeffnen von File cardat\n");
		exit(1);
	}

	mod_input(eindat);
	fprintf(nunit2,"#Modelleingabe beendet\n");

	/*    Signalbehandlung                                               */
	/*    ================                                               */
	if (dbg == 0)   /* Losloesung vom Terminal */ 
		setpgrp();
	signal (SIGFPE,sig_fpe);
	signal (SIGBUS,sig_bus);
	signal (SIGSEGV,sig_segv);
	signal (SIGILL,sig_ill);
	signal (SIGQUIT,sig_stop);
	signal (SIGHUP,sig_stop);
	signal (SIGINT,sig_stop);
	signal (SIGKILL,sig_stop);
	signal (SIGUSR1,get_info);  /* mit kill -16 pid ist Zwischenergebnis 
												  in sim_fehler abrufbar */


	/*    2. Nullsetzen der Datenbereiche und Standardvorbesetzung       */
	/*    ========================================================       */
	/*    Besetzen der Pointer-Vektoren                                  */
	/*    =============================                                  */

	init_ptr();
	/*    Loeschen der Datenbereiche                                     */
	/*    ==========================                                     */
	reset();
	/*    Vorbesetzen                                                    */
	/*    ===========                                                    */
	preset();
	/*    Vorbesetzen privater Groessen                                  */
	/*    =============================                                  */

	if (autosim == 0)
	{
		if(dbg) fprintf(nunit2,"Berechnung von tend ... ");
		max = 1;
		for (i=1;i<=anzclass;i++)
		{
			for(j=0;j<=anznode;j++)
			{
				if (max < workTiMe[j][i].mean)
					max = (int)workTiMe[j][i].mean;
				if(j <= anznode)
				{
					knoten[j].tx_list = 0;
					knoten[j].pending = FALSE;
					knoten[j].next_event = 0.0;
				}
			}
		}
		tend = (double)(max) * 100000 ;
	}
	if(dbg) fprintf(nunit2,"%lg \n",tend);

	/*    3. Einlesen und setzen der Variablen                           */
	/*    ====================================                           */
	do
	{  /* solange xmodus = 1, aber mind. einmal  */
		int reply = NORMAL;
		/* Blockiernetze auf Deadlockfreiheit ueberpruefen           */
		srcbl = 0;
		if (nettyp == OPEN || nettyp == MIXED)
		{
			for (k=1;k<=anznode;k++)
			{
				succ = 0;
				anztr = 1000;
				for (j=1;j<=anzclass;j++)
				{
					if (uewsk[j][0][k+1] > 0)
						succ = 1;
				}
				if (succ == 1)
				{
					for(j=1;j<=anznode;j++)
						kap[j] = 0;
					if (knoten[k].wsmax == -1)
					{
						ok = 1;
						mausi = maus(k,1000+knoten[k].anzse,anztr);
					}
					else
					{
						srcbl = 1;
						ok = 0;
						mausi = maus(k,knoten[k].wsmax+knoten[k].anzse,anztr);
					}
					if ((mausi < 1000)||(ok == 0))
					{
						ok = 0;
						break;
					}
					else ok = 1;
				}
			}
		}
		if (nettyp == CLOSED)
		{
			anztr = 0;
			for (i=1;i<=anzclass;i++)
				anztr += Class[i];
			for(i=1;i<=anznode;i++)
			{
				for(j=1;j<=anznode;j++)
					kap[j] = 0;
				if (knoten[i].wsmax >= 0)
				{
					mausi = maus(i,knoten[i].wsmax+knoten[i].anzse,anztr);
				}
				else
					mausi = 1000;
				if ((mausi <= anztr)&&(mausi < 1000))
				{
					ok = 0;
					break;
				}
				else ok = 1;
			}
		}
		ok = 1;

		fprintf(nunit2,"#simulation, pid %d\n#0 0 0\n",getpid());
		/* Falls Dead-lock moeglich : Trotzdem Simulation durchfuehren ? */
		if ((ok == 0))
		{
			fprintf(nunit2,"#Netz ist nicht verklemmungsfrei \n");
			if (exblock == 1)
			{
				ok = 1;
			}
			else
			{
				fprintf(ausdat,"Netz ist nicht verklemmungsfrei ");
				exit(0);
			}
		}
		/* Falls Dead-lock an Quelle moeglich : Blockierung oder Verlust */
		if (srcbl == 1)
		{
			if (srcblock == 0)
			{
				srcbl = 0;
				fprintf(ausdat,"#An Quelle Verlustsystem \n");
				fprintf(nunit2,"#An Quelle Verlustsystem \n");
			}
			else
			{
				fprintf(ausdat,"#Nach Quelle Blockierung moeglich \n");
				fprintf(nunit2,"#Nach Quelle Blockierung moeglich \n");
			}
		}


		fprintf(nunit2,"#setzen source liste\n");
		/* Setzen Source-Liste                                       */
		if ((nettyp == CLOSED)||(nettyp == MIXED)) /* Netz geschlossen oder gemischt */
		{
			for(i=1;i<=anzclass;i++)
			{
				if ((nettyp == MIXED)&& (Class[i] == 0))
				{
					Class[i] = -1;
				}
				else
				{
					rest = (int) Class[i];
					for(j=1;j<=anznode;j++)
					{
						if(besh[j][i] <= 0.0)
						{
							sourcelist[SOURCE_INDEX(j,i)].remain = 0;
							continue;
						}
						if(knoten[j].wsmax < 0) /* IS */
						{
							sourcelist[SOURCE_INDEX(j,i)].remain = rest;
							dprint(SOURCELIST,"source: knoten %d, Klasse %d, initial %d Auftraege\n",j,i,sourcelist[SOURCE_INDEX(j,i)].remain);
							rest = 0;
							continue;
						}
						if(knoten[j].wsmax > rest)
						{
							sourcelist[SOURCE_INDEX(j,i)].remain = rest;
							dprint(SOURCELIST,"source: knoten %d, Klasse %d, initial %d Auftraege\n",j,i,sourcelist[SOURCE_INDEX(j,i)].remain);
							rest = 0;
							continue;
						}
						if(knoten[j].wsmax <= rest)
						{
							sourcelist[SOURCE_INDEX(j,i)].remain = knoten[j].wsmax;
							dprint(SOURCELIST,"source: knoten %d, Klasse %d, initial %d Auftraege\n",j,i,sourcelist[SOURCE_INDEX(j,i)].remain);
							rest -= knoten[j].wsmax;
							continue;
						}
						if(rest == 0)
						{
							sourcelist[SOURCE_INDEX(j,i)].remain = 0;
							continue;
						}
					}
				}
			}
		}
		/* Setzen Policy-, Strategie- und Plan-Matrix                */
		for(i=1;i<=anznode;i++)
		{
			pol[i].type = 2;
			pol[i].station = i;
			switch(knoten[i].strategie)
			{
			case PRIOFCFS:
				pol[i].policy = 1;
				break;
			case FCFS:
				pol[i].policy = 2;
				break;
			case LCFS:
				pol[i].policy = 3;
				break;
			case PFCFS:
				pol[i].policy = 1;
				break;
			case PLCFS:
				pol[i].policy = 1;
				break;
			case RR:
				pol[i].policy = 2;
				break;
			}
			plan[i].in = 1;
			plan[i].out = 1;
			dprint(ALL,"user: Knoten %d, Policy %d, Plani %d, Plano %d\n",i,pol[i].policy,plan[i].in,plan[i].out);
		}

		/* Setzen Kapazitaeten der Multifacilities                   */
		for(i=1;i<=anznode;i++)
		{
			mfac[i].cap = knoten[i].anzse;
			if (knoten[i].anzse == 0)
				knoten[i].strategie = IS;
		}
		/* Initialisieren der Datenbereiche                          */
		init1x();
		if(init2()==FEHLER) exit(1);
		if(init3()==FEHLER) exit(1);
		init4();
		user_rnx_init();
		/* Source-Start                                              */
		for(i=1;i<=anzclass;i++)
		{
			if (nettyp == OPEN)
			{
				if (sourcelist[SOURCE_INDEX(0,i)].remain > 0)
				{
					CALL(start(SOURCE_INDEX(0,i),0.0,NEXT_ENTRY(0,2)))
				}
			}
			if ((nettyp == CLOSED)||((nettyp == MIXED)&&(Class[i] != -1)))
			{
				for(j=1;j<=anznode;j++)
				{
					if (sourcelist[SOURCE_INDEX(j,i)].remain > 0)
					{
						CALL(start(SOURCE_INDEX(j,i),0.0,NEXT_ENTRY(0,1)));
					}
				}
			}
			if ((nettyp == MIXED)&&(Class[i] == -1))
			{
				if (sourcelist[SOURCE_INDEX(j,i)].remain > 0)
				{
					CALL(start(SOURCE_INDEX(j,i),0.0,NEXT_ENTRY(0,2)));
				}
			}
		}
		/*    6. Modell                                                 */
		if (flowc() == FEHLER)
		{
			fprintf(ausdat,"###Simulationslauf abgebrochen, letzter Stand\n");
		}
		/* 7. Endabrechnung                                               */
		results(ausdat);

	}
	while (xout == 1);
	/* Sichern des Systemzustandes                                       */

	fclose(ausdat);
	fclose(unit1);
	fclose(unit2);
	fclose(nunit2);
	fclose(unit7);
	fclose(plotfile[1].pointer);
	unlink(plotfile[1].fil_name);
}

