static char *SccsId = "@(#)PEPSY:\tverklemm.c\t1.2\t92/03/27 12:01:13";
/***********************************************************************/
/*                                                                     */
/*   *** Unterprogramm maus(node,kapa)                                 */
/*                                                                     */
/*   *** Funktion: Ermittlung von Verklemmungen in einem Netz          */
/*                                                                     */
/***********************************************************************/


#include <stdio.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"
#include "gpss_priv.h"


int maus(node,kapa,anztr)
int node;
int kapa;
int anztr;
{
	int i,j,anf,reply,succ,kapvorher;
	assert(node >= 1 && node <= anznode);
	/* Ende eines Zyklus erreicht */
	if (kap[node] > 0)
	{
		if (knoten[node].wsmax == -1)  /* unendliche Kapazitaet  */
			reply=(kapa-kap[node]+1000+knoten[node].anzse);
		else /* endliche Kapazitaet    */
			reply=(kapa-kap[node]+knoten[node].wsmax+knoten[node].anzse);
		return (reply);
	}
	else{
		/* Nicht am Ende eines Zykluses ; Alle Nachfolger dieses Knotens      */
		/* ueberpruefen, ob sie Ende eines Zyklus sind oder weiterverfolgen   */
		anf = 0;
		if (nettyp == CLOSED) anf = 1;
		/* Alle Knoten + aussen */
		for (i=anf;i<=anznode;i++)
		{
			/* eigene Knotenkapazitaet feststellen */
			if (knoten[node].wsmax == -1)
				kap[node] = kapa + 1000+knoten[node].anzse;
			else
				kap[node] = kapa + knoten[node].wsmax+knoten[node].anzse;
			/* Ist Knoten i ein Nachfolger des aktuellen Knotens */
			succ = 0;
			for (j=1;j<=anzclass;j++)
			{
				if (uewsk[j][node+1][i] > eps)
					succ = 1;
			}
			/* Fuer Nachfolgeknoten */
			kapvorher = kap[i-1];
			if (succ == 1)
			{
				if (i > 0)          /* Nachfolgeknoten i   */
					reply = maus(i-1,kap[node],anztr);
				else{               /* nachfolgend: aussen */
					reply = kapa;
				}
				/* Zuruecksetzen der eigenen Kapazitaet */
				kap[i-1]=kapvorher;
				/* Falls Netzkapazitaet kleiner oder gleich der Anzahl von Auftraegen */
				/* im System ist, dann Suche abbrechen                                */
				if (reply <= anztr) break;
			}
		}
		return(reply);
	}
}

