static char *SccsId = "@(#)PEPSY:\tactivb.c\t1.2\t92/03/27 11:53:59";

#include <signal.h>
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"
/************************************************************************/
/*                                                                      */
/*    *** Unterprogramm activb()                                        */
/*    ***                                                               */
/*    *** Funktion : Modell fuer den Busverkehr                         */
/*    *** Rueckgabe: 1 = Adressausgang zur Endabrechnung                */
/*    ***            0 = normale Kontrollfluss-Uebergabe                */
/*    ***            wird in lokaler Variable reply gefuehrt            */
/*    ***                                                               */

int	activb()
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{

	short	check;
	extern int	next_int(), bgen(), bload(), bride(), bout();
	double	et, pr, vel;
	int	nrout, ncar, kap,  istate;

	/*    Lokale Variablen definieren                                    */
	/*    ===========================                                    */
	int	naddr = 0, reply = NORMAL;

	/* Bestimmung der Zieladresse                                        */
	/* ==========================                                        */
	if (row_source != NULL) 
		naddr =  row_source->target;
	if (row_txact > 0) 
		naddr = activlist[row_txact].target;
	/* */
	/*     TRANSFER CONTROL TO LABEL */
	/*     ========================= */
	/* */
	if (naddr == 1) 
		goto l_1;
	if (naddr == 2) 
		goto l_2;

	fprintf(nunit2, "\n\n+++++ activb: TiMe=%12.4f Fehler im Adressverteiler  naddr=%3d\n",
	    TiMe, naddr);
	reply = FEHLER;
	goto l_9999;
	/* */
	/* */
	/*     MODEL */
	/*     ===== */
	/* */
	/*     GENERATION OF BUS */
	/*     ================= */
l_1:  
	switch (bgen(et, pr , kap , vel , nrout))  {
	case FEHLER: 
		goto l_9999;
	}
	/* */
	/*     DETERMINE STATUS */
	/*     ================ */
l_2:  
	ncar   = next_int(txadd[row_txact][1]);
	istate = next_int(carma[ncar][8]);
	switch (istate)  {
	case 1: 
		goto l_21;
	case 2: 
		goto l_22;
	case 3: 
		goto l_23;
	}
	/* */
	/*     LOAD */
	/*     ==== */
l_21:  
	switch (bload(0.) )  {
	case AUSGANG2: 
		goto l_9000;
	case FEHLER: 
		goto l_9999;
	}
	/* */
	/*     RIDE */
	/*     ==== */
l_22: 
	switch (bride() )  {
	case AUSGANG2: 
		goto l_9000;
	case FEHLER: 
		goto l_9999;
	}
	/* */
	/*     UNLOAD */
	/*     ====== */
l_23:  
	switch (bout(0.) )  {
	case AUSGANG2: 
		goto l_9000;
	case FEHLER: 
		goto l_9999;
	}
	/* */
	/* */
	/*     EXIT TO FLOW CONTROL */
	/*     ==================== */
l_9000: 
	return(reply);
	/* */
	/*     EXIT TO TERMINATING SECTION */
	/*     =========================== */
l_9999: 
	return(FEHLER);
}


