static char *SccsId = "@(#)PEPSY:\tactivt.c\t1.2\t92/03/27 11:54:03";

#include <signal.h>
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"
/************************************************************************/
/*                                                                      */
/*    *** Unterprogramm activt()                                        */
/*    ***                                                               */
/*    *** Funktion : Modell fuer den Busverkehr                         */
/*    *** Rueckgabe: 1 = Adressausgang zur Endabrechnung                */
/*    ***            0 = normale Kontrollfluss-Uebergabe                */
/*    ***            wird in lokaler Variable reply gefuehrt            */
/*    ***                                                               */
int	activt()
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	short	check;
	int	kap, nterm, itargp, nstrat, ncar, istate, istart, itargl, itargu, iparkl;
	double	et, pr, vel;
	extern int	next_int(), tgen(), tride(), tload(), tout(), tpark();

	/*    Lokale Variablen definieren                                    */
	/*    ===========================                                    */
	int	naddr = 0, reply = NORMAL;

	/* Bestimmung der Zieladresse                                        */
	/* ==========================                                        */
	if (row_source != NULL) 
		naddr = row_source->target;
	if (row_txact > 0) 
		naddr = activlist[row_txact].target;
	/* */
	/*     TRANSFER CONTROL TO LABEL */
	/*     ========================= */
	/* */
	if (naddr == 1) 
		goto l_1;
	if (naddr == 2) 
		goto l_2;

	fprintf(nunit2, "\n\n+++++ activt: TiMe=%12.4f Fehler im Adressverteiler  naddr=%3d\n",
	    TiMe, naddr);
	reply = FEHLER;
	goto l_9999;
	/* */
	/* */
	/*     MODEL */
	/*     ===== */
	/* */
	/*     GENERATION OF TAXIS */
	/*     =================== */
l_1:   
	switch (tgen(et, pr, kap, vel, nterm, itargp, nstrat) ) {
	case FEHLER: 
		goto l_9999;
	}
	/* */
	/*     DETERMINE STATUS */
	/*     ================ */
l_2:  
	ncar   = next_int(txadd[row_txact][1]);
	istate = next_int(carma[ncar][8]);
	switch (istate) {
	case 1: 
		goto l_21;
	case 2: 
		goto l_22;
	case 3: 
		goto l_23;
	case 4: 
		goto l_24;
	case 5: 
		goto l_25;
	case 6: 
		goto l_26;
	}
	/* */
	/*     JOURNEY FROM START TO LOADING POINT */
	/*     =================================== */
l_21: 
	istart = next_int(carma[ncar][6]);
	itargl = next_int(tarma[ncar][1]);
	switch ( tride(istart, itargl)) {
	case AUSGANG2: 
		goto l_9000;
	case FEHLER : 
		goto l_9999;
	}
	/* */
	/*     LOAD */
	/*     ==== */
l_22: 
	switch (tload(0.0))  {
	case AUSGANG2: 
		goto l_9000;
	case FEHLER : 
		goto l_9999;
	}

	/* */
	/*     JOURNEY FROM LOADING POINT TO UNLOADING-POINT */
	/*     ============================================= */
l_23: 
	itargl = next_int(carma[ncar][6]);
	itargu = next_int(tarma[ncar][2]);
	switch (tride(itargl, itargu)) {
	case AUSGANG2: 
		goto l_9000;
	case FEHLER : 
		goto l_9999;
	}
	/* */
	/*     UNLOAD */
	/*     ====== */
l_24: 
	switch (tout(0.0)) {
	case AUSGANG2: 
		goto l_9000;
	case FEHLER : 
		goto l_9999;
	}
	/* */
	/*     JOURNEY TO PARKING-LOT */
	/*     ====================== */
l_25: 
	itargu = next_int(carma[ncar][6]);
	iparkl = next_int(tarma[ncar][3]);
	if (iparkl != 0)
		switch (tride(itargu, iparkl) )  {
		case AUSGANG2: 
			goto l_9000;
		case FEHLER : 
			goto l_9999;
		}
	/* */
	/*     PARK */
	/*     ==== */
l_26: 
	switch (tpark()) {
	case AUSGANG2: 
		goto l_9000;
	case FEHLER : 
		goto l_9999;
	}
	/* */
	/* */
	/*     EXIT TO FLOW CONTROL */
	/*     ==================== */
l_9000:  
	return(reply);
	/* */
	/*     EXIT TO TERMINATING SECTION */
	/*     =========================== */
l_9999: 
	return (FEHLER);
}


