static char *SccsId = "@(#)PEPSY:\talloc_stor.c\t1.2\t92/03/27 11:54:09";
#include "gpss_prepare.h"
#include "gpss_decl.h"

/************************************************************************/
/*                                                                      */
/*    *** Unterprogramm alloc_stor(nst,ne,mark,iblock,*line,id)         */
/*    ***                                                               */
/*    *** Funktion : Belegen einer Storage                              */
/*    *** Parameter: nst    = Nummer der Storage                        */
/*    ***            ne     = Zahl der zu belegenden Speicherplaetze    */
/*    ***            mark   = Speicherplatzkennzeichen                  */
/*    ***            iblock = Blockierparameter                         */
/*    ***                     = 0: Die Tr ueberprueft bei der Ankunft   */
/*    ***                          ihre Speicherplatzanforderung        */
/*    ***                     = 1: Die Tr wird bei der Ankunft          */
/*    ***                          sofort blockiert                     */
/*    ***            *line  = Rueckgabe: Speicherplatzadresse           */
/*    ***            id     = Anweisungsnummer des Unterprogramm-       */
/*    ***                     aufrufes                                  */
/*    ***                                                               */
int	alloc_stor(nst, ne, mark, iblock, line, id)
int	id;
int	*line;
int	iblock;
int	mark;
int	ne;
int	nst;
{
	extern int	next_int();
	extern int	block(), policy(), strata();

	/* lokale Variablen definieren                                       */
	/* ===========================                                       */
	int	act_station, bl_station, remainder, reply;
	struct STOR *help_ptr;

	/*    Bestimmen der Stationsnummer                                   */
	/*    ============================                                   */
	act_station = offset.stor + nst - 1;

	/*    Ueberpruefen der Blockierbedingung                             */
	/*    ==================================                             */
	bl_station = next_int(activlist[row_txact].next);
	if (bl_station == -act_station  ||  iblock != 1) {

		/*    Speicherplatzzuteilung durch die Strategie                  */
		/*    ==========================================                  */
		strata(nst, ne);

		if (row_stor != NULL) {
			/*    eintragen in die Segment-Matrix                          */
			/*    ===============================                          */

			if (row_stor->length == 0) {
				/* Bereich nicht am Anfang des freien Bereichs */
				int	local_dist = 1;
				help_ptr = row_stor - 1;
				while (help_ptr->length == 0) {
					local_dist ++;
					help_ptr --;
				}
				remainder = help_ptr->length - local_dist - ne;/* Freier Bereich nach Eintrag */
				help_ptr->length = local_dist;
			} 
			    else

				/* Eintrag beginnt am ersten Element des freien Bereichs */
				remainder = row_stor->length - ne;
			/* endif */

			if (remainder > 0) {
				/* Noch freier Bereich nach Eintrag */
				help_ptr = row_stor + ne;
				help_ptr->length = remainder;
				help_ptr->mark   = -1;
			}

			/* Eintrag des Bereichs */
			row_stor->length = ne;
			row_stor->mark   = mark;
			*line = row_stor - sto_base[nst].addr + 1;
			tx_system[row_txact].t_block = 0.0;
			if ((iprint == 1 && jprint[4] != -1) || jprint[4] == 1) {
				fprintf(nunit2, " alloc :  TiMe=%12.4f  tr%6d,%4d   belegt%4d Speicherplaetze der sto%3d ab Adresse%4d\n",
				                 TiMe, tx_system[row_txact].nr, tx_system[row_txact].dup, ne, nst, line);
			}
			reply = NORMAL;
		} /* Ende Fall Eintragen  */
	} /* Ende kein sofortiges Blockieren */ 
	    else

	 {
		/*    blockieren                                                  */
		/*    ==========                                                  */
		int	ftx, np;
		if (bl_station != -act_station) 
			tx_system[row_txact].t_block = TiMe;
		activlist[row_txact].next =  -(double)act_station;
		activlist[row_txact].target = id;
		policy(4, nst, 0, &ftx, &np);
		block(4, nst, 0, ftx);
		if ((iprint == 1 && jprint[4] != -1) || jprint[4] == 1) {
			fprintf(nunit2, " alloc :  TiMe=%12.4f  tr%6d,%4d   wird blockiert an sto%3d\n",
			    TiMe, tx_system[row_txact].nr, tx_system[row_txact].dup, nst);
		}
		reply = AUSGANG2;
	}
	return(reply);
}


