static char *SccsId = "@(#)PEPSY:\tanar.c\t1.2\t92/03/27 11:54:11";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	anar(idim, icnum, clev, rmean, halfw, jmin, kmin, ip, iprin)
int	iprin ;
int	*ip ;
int	*kmin ;
int	*jmin ;
double	*halfw ;
double	*rmean ;
double	clev ;
int	icnum ;
int	idim ;
{
	/*                                                                      */
	/*    ***                                                               */
	/*    *** call anar(idim,icnum,clev,rmean, *halfw, *jmin, *kmin         */
	/*    ***            *ip,iprin,exit1)                                   */
	/*    **                                                                */
	/*    *** funktion : bestimmung von konfidenzintervallen                */
	/*    ***            (fishman: principles of discrete event             */
	/*    ***             simulation, 1978)                                 */
	/*    *** parameter: x     = feld der aufgesammelten werte              */
	/*                           (jetzt externe Variable !!!)               */
	/*    ***            idim  = anzahl der werte                           */
	/*    ***            icnum = nummer des konfidenzintervalls             */
	/*    ***            clev  = konfidenzzahl                              */
	/*    ***            rmean = rueckgabe : mittelwert                     */
	/*    ***             *halfw = rueckgabe: halbe intervallaenge          */
	/*    ***             *jmin  = rueckgabe: ende der einschwingphase      */
	/*    ***             *kmin  = rueckgabe: abstand zwischen unabhaengigen  */
	/*    ***                    stichproben                                */
	/*    ***             *ip    = rueckgabe: ordnung                       */
	/*    ***            iprin = ausgabe der einzelergebnisse               */
	/*    ***            exit1 = fehlerausgang                              */
	/*    ***                                                               */
	extern int	next_int();
	extern int	graph(), plot();
	int	q, q1, i, j, k, ip1, idimm1, max, m ;
	double	num, lz, beta[52], r[52] ;
	double	b[52][52], sigsq[52], h[8], g[5], rho1[52] ;
	double	vfunc[101][3], t1 ;
	double	c3, c2, c1, den ;
	double	d3, d2, d1, stand, zsq, sqhalf ;
	double	df, sqdf, chisq, vary, bsum, varmu ;
	double	z, studnt, dd ;
	double	alpha, rmean2, rintv, rplot, y ;
	double	xbar, cov, v, w, sum ;
	char	ro1[33], ro2[33];
	struct PLOT3 rvname[7];
	/*                                                                      */
	rvname[1].symbol = '*';
	strcpy(rvname[1].pvar_name, "xcon[i]");
	rvname[2].symbol = '+';
	strcpy(rvname[2].pvar_name, "cmean[i]");
	for (i = 3; i <= 6; i++) {
		rvname[i].symbol = ' ';
		strcpy(rvname[i].pvar_name, "        ");
	};
	c1 = 2.515517;
	c2 = 0.802853;
	c3 = 0.010328;
	d1 = 1.432788;
	d2 = 0.189269;
	d3 = 0.001308;
	strcpy(ro1, "graphische darstellung von ro1");
	strcpy(ro2, "graphische darstellung von ro2");
	/*                                                                      */
	/*    initialisieren                                                    */
	/*    ==============                                                    */
	for (i = 1 ; i <= zconf ; cmean[i] = 0.0, i++)
		;
	*halfw = -2.0;
	*jmin = -1;
	*kmin = -1;
	*ip = -1;
	q = 50;
	if (idim <= 200) 
		q = idim / 4;
	/*                                                                      */
	/*    berechnung des mittelwertes                                       */
	/*    ===========================                                       */
	for (i = 1, xbar = 0.0 ; i <= idim ; xbar += (double)xcon[i], i++)
		;
	xbar = xbar / (double)idim;
	*rmean = (double)xbar;
	if (idim < 24) 
		return(FEHLER) ;
	/*                                                                      */
	/*    berechnung der autocovarianzen, (gl 5.58)                         */
	/*    =========================================                         */
	q1 = q + 1;
	for (j = 1; j <= q1; j++) {
		cov = 0;
		i = 1;
l_2:  
		if (i > idim - j + 1) 
			goto l_3;
		cov = cov + (double)((xcon[i] - *rmean) * (xcon[i+j-1] - *rmean));
		i = i + 1;
		goto l_2;
l_3:  
		cov = cov / ( (idim - j + 1));
		r[j] = (double)cov;
		if (r[1] == 0.) 
			goto l_111;
		rho1[j] = r[j] / r[1];
	};
	/*                                                                      */
	/*    schaetzung der b[i][j], (gl 5.60 und 5.61)                        */
	/*    =========================================                         */
	b[1][1] = 1.0;
	sigsq[1] = r[1];
	for (i = 1; i <= q; ++i) {
		k = i + 1;
		v = 0.0;
		w = 0.0;
		for (j = 1; j <= i; ++j) {
			v = v + (double)(b[i][j] * r[j]) ;
			w = w + (double)(b[i][j] * r[i-j+2]);
		};
		b[k][1] = 1.0;
		b[k][k] = (double)(-w / v);
		j = 2;
l_6:  
		if (j >= k) 
			goto l_7;
		b[k][j] = b[i][j] + (b[k][k] * b[i][k-j+1]);
		j = j + 1;
		goto l_6;
		/*                                                                      */
		/*    schaetzung der sigsq[k], (gl 5.63)                                */
		/*    ==================================                                */
l_7:  
		sigsq[k] = 0.0;
		for (j = 1; j <= k; ++j) {
			sigsq[k] = sigsq[k] + (b[k][j] * r[j]) ;
		};
		if (sigsq[k] > 0.0) 
			continue;
		*halfw = -1.0;
		return(FEHLER);
		;
	};
	/*                                                                      */
	/*    ipth quantile of standard normal distribution                     */
	/*    ============================================                      */
	t1 = sqrt(-2.0 * log(0.1));
	num = (c3 * t1 + c2) * t1 + c1;
	den = ((d3 * t1 + d2) * t1 + d1) * t1 + 1.0;
	stand = t1 - (num / den);
	/*                                                                      */
	/*    bestimmung der h[i] fuer chi**2 verteilung                        */
	/*    ==========================================                        */
	zsq = stand * stand;
	sqhalf = sqrt(0.5);
	h[1] = stand / sqhalf;
	h[2] = 2.0 * (zsq - 1.0) / 3.0;
	h[3] = (zsq - 7.0) * stand * sqhalf / 9.0 ;
	h[4] = -((6.0 * zsq + 14.0) * zsq - 32.0) / 405.0;
	h[5] = ((9.0 * zsq + 256.0) * zsq - 433.0) * stand * sqhalf / 4860.0;
	h[6] = (((12.0 * zsq - 243.0) * zsq - 923.0) * zsq + 1472.0) / 25515.0;
	h[7] = -(((3753.0 * zsq + 4353.0) * zsq - 289517.0) * zsq - 289717.0) * stand * sqhalf / 9185400.0 ;
	/*                                                                      */
	/*    bestimmung von t, (gl. 5.64)                                      */
	/*    ============================                                      */
	*ip = -1;
	for (j = 1; j <= q; ++j) {
		t1 =  ((double)idim) * (1.0 - (sigsq[q+1] / sigsq[j]));
		/*                                                                      */
		/*    ipth quantile of chi**2 distribution with df degrees of freedom   */
		/*    ==============================================================    */
		df =  (double)(q + 1 - j);
		sqdf = sqrt(df);
		chisq = 0;
		i = 7;
		while (i > 0) {
			chisq = (chisq / sqdf) + h[i];
			i--;
		}
		chisq = ((chisq / sqdf) + 1.0) * df;
		/*                                                                      */
		/*    bestimmung der ordnung ip                                       */
		/*    =========================                                         */
		if (t1 > chisq) 
			continue;
		*ip = j - 1;
		ip1 =  j;
		for (i = 1; i <= ip1; ++i) {
			beta[i] = b[ip1][i];
		};
		vary = sigsq[ip1];
		goto l_12;
		;
	};
l_111:   
	*halfw = -2.0;
	return(FEHLER);
	/*                                                                      */
	/*    bestimmung des freiheitsgrades, (gl. 5.74)                        */
	/*    ==========================================                        */
l_12:  
	bsum = 0.0;
	lz = 0.0;
	for (i = 1; i <= ip1; ++i) {
		bsum = bsum + beta[i];
		lz = lz + beta[i] * (double)(*ip - (2 * (i - 1)));
	};
	varmu = vary / ((double)(idim) * pow(bsum, 2.));
	if ( *ip != 0) 
		goto l_14;
	df = (double)(idim - 1);
	goto l_15;
l_14:  
	df = MAX(1.0, (((double)(idim)) * bsum) / (2.0 * lz)) ;
	/*                                                                      */
	/*    ipth quantile of standard normal distribution                     */
	/*    ============================================                      */
l_15:  
	t1 = sqrt(-2.0 * log(1. - clev));
	num = (c3 * t1 + c2) * t1 + c1;
	den = ((d3 * t1 + d2) * t1 + d1) * t1 + 1.0;
	stand = t1 - (num / den);
	/*                                                                      */
	/*    bestimmung der g[i] fuer student verteilung                       */
	/*    ===========================================                       */
	z = fabs(stand);
	zsq = z * z;
	g[1] = (zsq + 1.0) * z / 4.0;
	g[2] = ((5.0 * zsq + 16.0) * zsq + 3.0) * z / 96.0;
	g[3] = (((3.0 * zsq + 19.0) * zsq + 17.0) * zsq - 15.0) * z / 384.0;
	g[4] = ((((79.0 * zsq + 776.0) * zsq + 1482.0) * zsq - 1920.0) * zsq - 945.0) * z / 92160.0;
	studnt = 0;
	i = 4;
l_17:  
	if (i < 1) 
		goto l_18;
	studnt = (studnt + g[i]) / df;
	i = i - 1;
	goto l_17;
l_18:  
	studnt = studnt + z;
	/*                                                                      */
	/*    bestimmung des konfidenzintervalles                               */
	/*    ===================================                               */
	*halfw = studnt * sqrt(varmu);
	*jmin = 0;
	*kmin = 0;
	if ( *ip == 0) 
		goto l_29;
	/*                                                                      */
	/*    berechnung von rho2, (gl. 5.77)                                   */
	/*    ===============================                                   */
	for (i = 1; i <=  *ip; ++i) {
		rho2[i] = rho1[i];
	};
	for (j = ip1; j <= idim; ++j) {
		sum = 0.0;
		for (i = 2; i <= ip1; ++i) {
			dd = (double) (beta[i] * rho2[j+1-i]);
			if (sum < (dd + 1.0e-19)  &&  sum > (dd - 1.0e-19)) 
				goto l_40;
			sum = sum - dd;
			continue;
l_40:  
			sum = 0.0;
			;
		};
		rho2[j] = (double)sum;
	};
	/*                                                                      */
	/*    abstand unabhaengiger stichproben                                 */
	/*    =================================                                 */
	alpha = 0.05;
	for (i = 1; i <= idim; ++i) {
		if (fabs(rho2[i]) <= alpha) 
			goto l_23;
		;
	};
l_23:   
	*kmin = i - 1;
	/*                                                                      */
	/*    bestimmung der bedingten mittelwerte, (gl. 5.79)                  */
	/*    ================================================                  */
	for ( i = 1 ; i <= *ip ; cmean[i] = 0.0, ++i) 
		;
	rmean2 = *rmean - xcon[1];
	for (j = ip1; j <= idim; ++j) {
		sum = 0.0;
		for (i = 2; i <= ip1; ++i) {
			dd = (double)(beta[i] * (cmean[j+1-i] - rmean2));
			if ((sum < dd + 1.0e-19)  &&     (sum > dd - 1.0e-19)) 
				goto l_45;
			sum = sum + dd;
			continue;
l_45:  
			sum = 0.0;
		};
		cmean[j] = rmean2 - (double)sum;
	};
	/*                                                                      */
	/*    ende der einschwingphase, (gl. 5.82)                              */
	/*    ====================================                              */
	rintv = (*rmean / 100.) * 5. ;
	idimm1 = idim - 1 ;
	for (i = 1; i <= idimm1; ++i) {
		if (fabs(cmean[idim-i] - rmean2) >= rintv) 
			goto l_28;
		;
	};
l_28:   
	*jmin = idim - i;
	/*                                                                      */
	/*    graphische darstellung von rho1 und rho2                          */
	/*    ========================================                          */
l_29: 
	if (iprin == 0) 
		return(NORMAL);
	max = q1;
	if (max > 100) 
		max = 100;
	for (i = 1; i <= max; ++i) {
		vfunc[i][1] = (double)i;
		vfunc[i][2] = (double) next_int(rho1[i] * 100.);
	};
	graph(vfunc, max, 0., 0., ro1);
	fprintf(nunit2, "\n\n%11skonfidenzintervall%4d - rho1\n", BLANKF, icnum);
	if ( *ip == 0) 
		goto l_150;
	if (max <  *kmin) 
		max =  *kmin + 5;
	if (max > idim) 
		max = idim;
	if (max > 100) 
		max = 100;
	for (i = 1; i <= max; ++i) {
		vfunc[i][1] = (double)i;
		vfunc[i][2] = (double) next_int(rho2[i] * 100.);
	};
	graph(vfunc, max, 0., 0., ro2);
	fprintf(nunit2, "\n\n%11skonfidenzintervall%4d - rho2\n", BLANKF, icnum);
	/*                                                                      */
	/*    ausdruck von  *ip und beta                                        */
	/*    =======================                                           */
l_150:  
	fprintf(nunit2, "\f\n\n\n konfidenzintervall%4d\n %22.22s\n\n\n", icnum, UNDERLINE);
	fprintf(nunit2, " autoregressive ordnung ip =%3d\n\n", *ip);
	fprintf(nunit2, " autoregressive koeffizienten ");
	i = 1;
	while (i <= ip1) {
		fprintf(nunit2, "%10.3e  ", beta[i]);
		if (i % 5 == 0) 
			fprintf(nunit2, "\n%30s", BLANKF);
		i++;
	}
	if (ip1 % 5 != 0) 
		fprintf(nunit2, "\n");
	if (iprin != 2) 
		return(NORMAL);
	if ((unit8 = fopen("scrat3", "w")) == NULL) {
		fprintf (nunit2, " anar: Fehler beim Oeffnen der Datei scrat3 im Modus 'w'\n");
		exit(1);
	}
	m = 0 ;
	z = 0.;
	rplot = (double)icnum;
	for (i = 1; i <= idim; ++i) {
		y = (double)i;
		cmean[i] = cmean[i] + xcon[1];
		fprintf(unit8, "%d %f %f %f %f %f %f %f %f\n", m, xcon[i], cmean[i], z, z, z, z, y, rplot);
	};
	fclose (unit8);
	if ((unit8 = fopen("scrat3", "r")) == NULL) {
		fprintf (nunit2, " anar: Fehler beim Oeffnen der Datei scrat3 im Modus 'r'\n");
		exit(1);
	}
	plot(icnum, unit8, nunit2, 1., 1, 3, 0., 0., 0, 0, rvname);
	fclose(unit8);
	unlink ("scrat3");
	return(NORMAL);
}


