static char *SccsId = "@(#)PEPSY:\tbegin.c\t1.2\t92/03/27 11:54:20";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	begin(nset)
int	nset ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call begin(nset,*9999)                                        */
	/*    ***                                                               */
	/*    *** funktion : starten der integration                            */
	/*    ***            berechnung der differentialquotienten              */
	/*    ***              nach diskreter zustandsaenderung                 */
	/*    ***            registrieren moeglicher crossings                  */
	/*    ***            archivierung der delay-variablen                   */
	/*    *** parameter: nset  = nummer des set, in dem kontinuierliche     */
	/*    ***                    variable diskret veraendert wurden         */
	/*    ***            exit1 = fehlerausgang                              */
	/*    ***                                                               */
	extern int	nchain(), tchain(), state(), detect(), defill();
	int	ncr, i, ns, nv ;
	double	x[2][3] ;
	/*                                                                      */
	/*    fehlerbehandlung falls 'nset' falsch angegeben                    */
	/*    ==============================================                    */
	if (intma[nset].method > 0) 
		goto l_100;
	fprintf(nunit2, "\n +++++ begin: TiMe = %12.4g integrationsmatrix fuer set%3d nicht besetzt\n",
	    TiMe, nset);
	goto l_9999;
	/*                                                                      */
	/*    starten der integration mit vorgegebener schrittweite             */
	/*    =====================================================             */
l_100:   
	switch (nchain(6, nset)) {
	case FEHLER : 
		goto l_9999;
	};
	equatlist[nset].next = TiMe;
	equatlist[nset].last = TiMe;
	switch (tchain(6, nset)) {
	case FEHLER : 
		goto l_9999;
	};
	/*                                                                      */
	/*    berechnung der differentialquotienten                             */
	/*    =====================================                             */
	switch (state(nset)) {
	case FEHLER : 
		goto l_9999;
	};
	/*                                                                      */
	/*    crossings auffinden und protokollieren                            */
	/*    ======================================                            */
	switch (detect(nset)) {
	case FEHLER : 
		goto l_9999;
	case AUSGANG2 : 
		goto l_9999;
	};
	for (ncr = 1; ncr <= zncro; ++ncr) {
		if (iflag[nset][ncr] == 0  &&  iflagp[nset][ncr] == 0) 
			continue;
		if (iflag[nset][ncr] == 1  &&  iflagp[nset][ncr] == 1) 
			continue;
		if (iflag[nset][ncr] == 1) 
			ttest = TiMe;
		if (iflag[nset][ncr] == 1) 
			intsta[nset].cross = intsta[nset].cross + 1;
		if (iflag[nset][ncr] == 1) 
			iflagp[nset][ncr] = 1;
		if (iflag[nset][ncr] == 0) 
			iflagp[nset][ncr] = 0;
		if ( iprint == 0   &&   jprint[19] <=  0  &&  jprint[20] <=  0 ) 
			continue;
		if ( iprint == 1   &&   jprint[19] == -1  &&  jprint[20] == -1 ) 
			continue;
		if (iflag[nset][ncr]  ==  1)
			fprintf(nunit2, " begin :  TiMe=%12.4f  crossing lokalisiert%39sgesetztes flag :%5sflag(%2d,%2d)\n",
			                    TiMe, BLANKF, BLANKF, nset, ncr);
		if (iflag[nset][ncr]  ==  0)
			fprintf(nunit2, " begin :  TiMe=%12.4f  crossing zurueckgenommen%35sgeloeschtes flag :  iflag(%2d,%2d)\n",
			                    TiMe, BLANKF, nset, ncr);
		;
	};
	/*                                                                      */
	/*                                                                      */
	/*    delay-variable speichern                                          */
	/*    ========================                                          */
	if (idelay  ==  0) 
		goto l_9000;
	for (i = 1; i <= zndvar; ++i) {
		ns  = devar[i].del_set;
		nv  = devar[i].del_var;
		if (ns  !=  nset) 
			continue;
		if (nv  >=  0) 
			x[1][1] = sv[nset][ nv];
		if (nv  <  0) 
			x[1][1] = dv[nset][-nv];
		x[1][2] = TiMe;
		switch (defill(ns, nv, x, 1)) {
		case FEHLER : 
			goto l_9999;
		};
		;
	};
	/*                                                                      */
l_9000:
	return(NORMAL);
l_9999:
	return(FEHLER);
}


