static char *SccsId = "@(#)PEPSY:\tbfit.c\t1.2\t92/03/27 11:54:22";
#include "gpss_prepare.h"
#include "gpss_decl.h"

/************************************************************************/
/*                                                                      */
/*    *** Unterprogramm bfit(nst,ne)                                    */
/*    ***                                                               */
/*    *** Funktion : Suchen nach einem freien Speicherbereich           */
/*    ***            nach der Strategie Best-Fit                        */
/*    *** Parameter: nst = Nummer der Storage                           */
/*    ***            ne  = Zahl der zu belegenden Speicherplaetze       */
/*    ***                                                               */
int	bfit(nst, ne)
int	ne ;
int	nst ;
{

	int	best;
	struct STOR *search_ptr;

	/*    initialisieren der Suche                                       */
	/*    ========================                                       */
	row_stor = NULL;
	search_ptr = sto_base[nst].addr;
	best = sto_base[nst].stor_cap;

	/*    suchen der Luecke                                              */
	/*    =================                                              */
	while (search_ptr < sto_base[nst+1].addr) {
		if (search_ptr->mark != -1  ||       /* kein freier Speicherbereich */
		search_ptr->length < ne ||       /* freier Bereich zu klein     */
		search_ptr->length - ne >= best) /* schon gefundener besser     */

			search_ptr = search_ptr + search_ptr->length;
		else
		 {
			best = search_ptr->length - ne;
			row_stor = search_ptr;
		}
	}
	return(NORMAL);
}


