static char *SccsId = "@(#)PEPSY:\tbgen.c\t1.3\t92/03/27 11:54:24";
#include <stdio.h>
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	bgen(et, pr, kap, vel, nrout)
float	et;
float	pr;
int	kap;
float	vel;
int	nrout;
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	/*     ***  */
	/*     *** CALL BGEN(ET,PR,KAP,VEL,NROUT,*9999) */
	/*     ***  */
	/*     *** PURPOSE : GENERATE A TRANSACTION WHICH REPRESENTS A BUS */
	/*     *** PARAMETERS: ET    = TIME BETWEEN SUCCESSIVE GENERATION OF */
	/*     ***                     TRANSACTIONS (BUSSES) */
	/*     ***             PR    = PRIORITY OF BUS GENERATED */
	/*     ***             KAP   = CAPACITY OF THE BUS  */
	/*     ***             VEL   = SPEED OF THE BUS */
	/*     ***             NROUT = ROUTE TO BE TAKEN BY BUS */
	/*     ***             *9999 = ERROR EXIT */
	/*     ***  */

	int	ctx, j,  sectnr, segmnr, nact, nterm;
	short	trace;
	double	pos;
	extern int	tchain(), next_int();

#ifdef DEBUG
dprint(BUS, "bgen: er %f, pr %f, kap %d, vel %f, nrout %d\n", /* */
	    et, pr, kap, vel, nrout);
#endif

	/*     ERROR TESTING  */
	/*     =============  */
	if (et < -eps)                    
		goto l_4000;
	if (kap < 0)                      
		goto l_4100;
	if (vel < eps)                    
		goto l_4200;
	if (nrout < 1 || nrout > anrout)  
		goto l_4300;
	if (row_source == NULL)           
		goto l_4400;
	if (tx_ctr >= txmax || 
	    row_source->remain == 0)      
		goto l_4500;
	if (row_source->sourci != 1)      
		goto l_4600;
	/* */
	/*     UPDATE THE COUNTER */
	/*     ================== */
	tx_ctr = tx_ctr + 1;
	row_source->remain = row_source->remain - 1.0;
	/* */
	/*     GENERATE */
	/*     ======== */
	for ( row_txact = ztx; row_txact >= 1; row_txact--)  {
		if (tx_system[row_txact].nr == 0) 
			goto l_200;
	}
	fprintf (nunit2, "\n\n+++++      bgen  : t= %12.4fERROR : carma array is full\n", TiMe);
	goto l_99;
	/* */
l_200: 
#ifdef DEBUG
dprint(LABEL, "bgen: label l_200\n"); /* */
#endif
	tx_system[row_txact].nr = tx_ctr;
	tx_system[row_txact].priority = pr;
	txi[row_txact]  = 1;
	for (ctx = 1; ctx <= zcar; ctx++)  {
		if (next_int(carma[ctx][1]) == 0) 
			goto l_400;
	}
	fprintf (nunit2, "\n\n+++++      bgen  : t= %12.4fERROR : carma array is full\n", TiMe);
	goto l_99;
	/* */
	/*     OCCUPY TXADD */
	/*     ============ */
l_400: 
#ifdef DEBUG
dprint(LABEL, "bgen: label l_400\n"); /* */
#endif
	txadd[row_txact][1] = (double)ctx;
	/* */
	/*     DETERMINE INITIAL POSITION */
	/*     ========================== */
	segmnr = routma[nrout][1];
	sectnr = segma[segmnr][1];
	pos    = sectma[sectnr][1];
	/* */
	/*     INITIALIZE CARMA ARRAY */
	/*     ====================== */
	carma[ctx][1] = (double)row_txact;
	carma[ctx][2] = -1.0;
	carma[ctx][3] = (double)kap;
#ifdef DEBUG
dprint(BUS, "bgen: carma[%d][3] = %f\n", ctx, carma[ctx][3]); /* */
#endif
	carma[ctx][4] = 0.0;
	carma[ctx][5] = vel;
	carma[ctx][6] = pos;
	carma[ctx][7] = 1.0;
	carma[ctx][8] = 1.0;
	carma[ctx][9] = 0.0;
	carma[ctx][10] = -1.0;
	/* */
	/*     INITIALIZE TARMA ARRAY */
	/*     ====================== */
	tarma[ctx][1] = 0.0;
	tarma[ctx][2] = 0.0;
	tarma[ctx][3] = 0.0;
	tarma[ctx][4] = 0.0;
	tarma[ctx][5] = (double)nrout;
	/* */
	/*     PLACE BUS AT LAST SEGMENT */
	/*     ========================= */
	for (j = 1; j <= zrout1; j++)  {
		if (routma[nrout][j] == 0) 
			goto l_600;
	}
l_600: 
#ifdef DEBUG
dprint(LABEL, "bgen: label l_600\n"); /* */
#endif
	if (j != zrout1)  
		j = j - 1;
	tarma[ctx][6] = (double)j;
	segmnr       = routma[nrout][j];
	/* */
	/*     PLACE BUS AT LAST SECTION */
	/*     ========================= */
	for (j = 1; j <= zsegm1; j++)  {
		if (segma[segmnr][j] == 0) 
			goto l_800;
	}
l_800: 
#ifdef DEBUG
dprint(LABEL, "bgen: label l_800\n"); /* */
#endif
	if (j != zsegm1)  
		j = j - 1;
	tarma[ctx][7] = (double)j;
	sectnr       = segma[segmnr][j];
	/* */
	/*     CHECK CONSISTENCY OF ROUTE */
	/*     ========================== */
	if (next_int(sectma[sectnr][2] * 10) != next_int(pos * 10)) 
		goto l_4700;
	/* */
	/*     PRINT */
	/*     ===== */
	trace = ((iprint == 1 || jprint[23] > 0) && jprint[23] != -1);
	/* */
	if (trace) 
		fprintf (nunit2, "bgen  :  t=%12.4f  bus%4d generated by source%3d travels on route %3d\n", TiMe, ctx, row_source -
		    sourcelist, nrout);
	if (kprint == 1) {
		nact = 10;
		nterm = next_int( pos );
		fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[row_txact], ctx, nact, nterm);
	}
	/* */
	/*     SCHEDULE THE NEXT GENERATION */
	/*     ============================ */
	if (tx_ctr != txmax)  {
		if (row_source->remain != 0) {
			row_source->next = TiMe + et;
			if (row_source->link != 0) 
				goto l_4800;
			tchain(2, row_source - sourcelist);
l_900:      
#ifdef DEBUG
dprint(LABEL, "bgen: label l_900\n"); /* */
#endif
			if (trace) 
				fprintf (nunit2, "                                  next activation of source at t=%12.4f\n",
				     row_source->next);
			/* */
			/*     GENERATION OF TRANSACTIONS BY SOURCE COMPLETED */
			/*     ============================================== */
		} else {
			if (trace) 
				fprintf (nunit2, "                                 source %3d is deactivated\n", row_source -
				    sourcelist);
		}
		/* */
		/*     TOTAL NUMBER OF TRANSACTION EXCEEDED */
		/*     ==================================== */
	} else {
		head[2].next = 0.0;
		head[2].link = -1;
		if (trace) 
			fprintf (nunit2, "\n                                  all sources are deactivated\n");
	}
	/* */
	/* */
	return(NORMAL);
	/* */
	/*     ERROR EXIT */
	/*     ========== */
	/* */
l_4000:  
	fprintf (nunit2, "\n\n+++++ bgen  :  t=%12.4f ERROR : negative TiMe until next genaration (%8.4f)\n", TiMe, et);
	goto l_99;
	/* */
l_4100:  
	fprintf (nunit2, "\n\n+++++ bgen  :  t=%12.4f ERROR : negative capacity (%3d) of the bus to be generated\n", TiMe,
	     kap);
	goto l_99;
	/* */
l_4200:  
	fprintf (nunit2, "\n\n+++++ bgen  :  t=%12.4f ERROR : negative speed (%8.4f) of the bus to be generated\n", TiMe,
	     vel);
	goto l_99;
	/* */
l_4300:  
	fprintf (nunit2, "\n\n+++++ bgen  :  t=%12.4f ERROR : invalid route (%3d) of the bus to be generated\n", TiMe, nrout);
	goto l_99;
	/* */
l_4400:  
	fprintf (nunit2, "\n\n+++++ bgen  :  t=%12.4f ERROR : index of source = 0\n                                         check label selector\n",
	     TiMe);
	goto l_99;
	/* */
l_4500:  
	fprintf (nunit2, "\n\n+++++ bgen  :  t=%12.4f ERROR : source %3d exceeds tx-limit\n", TiMe, row_source - sourcelist);
	goto l_99;
	/* */
l_4600:  
	fprintf (nunit2, "\n\n+++++ bgen  :  t=%12.4f ERROR : source %3d attempts to generate a bus\n", TiMe, row_source -
	    sourcelist);
	goto l_99;
	/* */
l_4700:  
	fprintf (nunit2, "\n\n+++++ bgen  :  t=%12.4f ERROR : invalid route (%3d) of the bus to be generated\n                                       route is not a closed path !\n",
	     TiMe, row_source - sourcelist);
	goto l_99;
l_4800:  
	fprintf (nunit2, "\n\n+++++ bgen  :  t=%12.4f ERROR : source with index %5d stall in source chain\n", TiMe, row_source -
	    sourcelist);
l_99:    
	return(FEHLER);
	/* */
}


