static char *SccsId = "@(#)PEPSY:\tbload.c\t1.3\t92/03/27 11:54:27";
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	bload(local_TiMe)
float	local_TiMe;
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	/*     ***  */
	/*     *** CALL BLOAD(TIME,*9000,*9999) */
	/*     ***  */
	/*     *** PURPOSE : LOAD A BUS */
	/*     *** PARAMETERS: TIME  = TIME REQUIRED TO LOAD ONE TRANSACTION */
	/*     ***             *9000 = EXIT ERROR CONTROL */
	/*     ***             *9999 = ERROR EXIT */
	/*     ***  */
	/* */

	int	art, ncar, partnr, routnr, sect, sectnr, segm, segmnr, stat[21];
	int	nact, next, nexttr, lasttr, itargu, i, nterm, k;
	short	beginn, trbeg, trace;
	extern int	next_int(), tchain();
	double	anzahl, adTiMe;

#ifdef DEBUG
dprint(BUS, "bload: time %f\n", local_TiMe); /* */
#endif

	/*     TEST FOR ERRORS */
	/*     =============== */
	ncar  = next_int( txadd[row_txact][1] );
	if (ncar == 0)           
		goto l_4000;
	if (txi[row_txact] != 1) 
		goto l_4100;
	if (local_TiMe < -eps)   
		goto l_4200;
	/* */
	/*     DETERMINE INDEX OF STATION AND INITIALIZE */
	/*     ========================================= */
	routnr = next_int(tarma[ncar][5]);
	segm   = next_int(tarma[ncar][6]);
	segmnr = routma[routnr][segm];
	partnr = next_int(tarma[ncar][7]);
	sectnr = segma[segmnr][partnr];
	nterm  = next_int(sectma[sectnr][2]);
	k      = offset.station + nterm - 1;
#ifdef DEBUG
dprint(BUS, "bload: k %d,  offset.station = %d, nterm %d\n", k, offset.station, nterm); /* */
#endif
	anzahl = 0.0;
	beginn =  TRUE;
	trbeg  =  TRUE;
	trace  = ((iprint == 1 || jprint[23] > 0) && jprint[23] != -1);
	/* */
	if (trace) 
		fprintf (nunit2, "bload :  t=%12.4f  bus%4d is at terminal%4d\n", TiMe, ncar, nterm);
	/* */
	/*     DETERMINE THE TERMINALS AT WHICH THE BUS IS TO BE UNLOADED */
	/*     ========================================================== */
	for ( i = 1 ; i <=  zrout1; i++) {
		stat[i] = 0 ;
		if (routma[routnr][i] != 0) {
			sect = segma[routma[routnr][i]][1];
			art  = next_int(sectma[sect][1] * 10.0) - next_int(sectma[sect][1]) * 10;
			if (art == 1)  
				stat[i] = next_int(sectma[sect][1]);
		}
	}
	/* */
	/*     IS THE BUS ALREADY FULL? */
	/*     ======================== */
	if (next_int(carma[ncar][3]) - next_int(carma[ncar][4]) == 0) {
		goto l_1000;
	}
	/* */
	/*     SEARCH FOR END OF CHAIN OF BUS */
	/*     ============================== */
	if (carma[ncar][2] >= 0) {
#ifdef DEBUG
dprint(BUS, "bload: carma[%d][2] = %f\n", ncar, carma[ncar][2]); /* */
#endif
		beginn =  FALSE;
		next   = next_int(carma[ncar][2]);
		goto l_210;
l_200: 
#ifdef DEBUG
dprint(BUS, "bload: label l_200 \n"); /* */
#endif
		next = activlist[next].blk_link;
l_210:   
		if (activlist[next].blk_link > 0) 
			goto l_200;
	}
	/* */
	/*     SEEK END OF LINKED LIST FOR THE BUS */
	/*     =================================== */
l_300: 
	if (trbeg) {
		if (bhead[k] == NULL)
			nexttr = -1;
		else
			nexttr = bhead[k] - activlist;
	} else {
		nexttr = activlist[lasttr].blk_link;
	}
	/* */
	/*     END OF LINKED LIST REACHED? */
	/*     =========================== */
	if (nexttr < 0) {
		goto l_1000;
	}
	/* */
	/*     BUS ALREADY FULL? */
	/*     ================= */
	if (next_int(carma[ncar][3]) - next_int(carma[ncar][4]) == 0) {
		activlist[next].blk_link = -1;
		goto l_1000;
	}

	/* */
	/*     DOES THE TRANSACTION REQUEST A BUS? */
	/*     =================================== */
	if (next_int(txadd[nexttr][3]) != 1) {
		trbeg =  FALSE;
		lasttr = nexttr;
		goto l_300;
	}
	/* */
	/*     DOES THE BUS TRAVEL TO THE TRANSACTION GOAL? */
	/*     ============================================ */
	itargu = next_int( txadd[nexttr][2] );
	for (i = 1 ; i <= zsta; i++) {
		if (stat[i] == itargu) 
			goto l_500;
	}
	trbeg =  FALSE;
	lasttr = nexttr;
	goto l_300;
	/* */
	/*     LOAD TRANSACTION IF SPACE AVAILABLE */
	/*     =================================== */
l_500: 
#ifdef DEBUG
dprint(LABEL, "bload: label l_500\n"); /* */
#endif
	anford = next_int( txadd[nexttr][4] );
	if (anford == 0)  
		anford = 1;
	/* */
	/*     IS SPACE AVAILABLE? */
	/*     ------------------- */
	if ((carma[ncar][4] + anford) > carma[ncar][3]) {
		goto l_300;
	}
	/* */
	/*     ENTER NUMBER OF PLACES OCCUPIED AND CHAIN TRANSACTION TO BUS */
	/*     ============================================================ */
	carma[ncar][4] = carma[ncar][4] + (double)anford;
	if (beginn) {
		carma[ncar][2] = (double)nexttr;
		beginn =  FALSE;
	} else {
		activlist[next].blk_link = nexttr;

	}
	next = nexttr;
	anzahl = anzahl + 1.0;
	adTiMe = local_TiMe * anzahl;
#ifdef DEBUG
dprint(BUS, "bload: belade Bus mit tr %d nach t = %d\n", tx_system[nexttr].nr, nterm); /* */
#endif
	if (trace) {
		fprintf (nunit2, "                         transaction%4d is loades in bus \n", tx_system[nexttr].nr);
		if (adTiMe > eps) 
			fprintf (nunit2, "                         (delayed by%12.4f units of TiMe)\n", adTiMe);
	}
	if (kprint == 1) {
		nact = 4;
		fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[nexttr], tx_system[nexttr].nr, nact, nterm);
	}
	/* */
	/* */
	/*     REMOVE TRANSACTION FROM LINKED LIST BELONGING TO TERMINAL */
	/*     ========================================================= */
#ifdef DEBUG
dprint(BUS, "bload: remove trans from linked list form terminal\n"); /* */
#endif
	if (trbeg) {
		bhead[k] = activlist + activlist[nexttr].blk_link;
	} else {
		lasttr = bhead[k] - activlist;
		goto l_610;
l_600:   
		lasttr = activlist[lasttr].blk_link;
l_610:   
		if (activlist[lasttr].blk_link != nexttr) 
			goto l_600;
		activlist[lasttr].blk_link = activlist[nexttr].blk_link;
	}
	/* */
	/*     UPDATE STATISTICS OF NUMBER OF TRANSACTIONS AND NUMBER OF PLACES */
	/*     ================================================================ */
	statis[ncar][5] = statis[ncar][5] + 1.0;
#ifdef DEBUG
dprint(BUS, "bload: statis[%d][5] == %f\n", ncar, statis[ncar][5]); /* */
#endif
	statis[ncar][6] = statis[ncar][6] + (double)anford;
	/* */
	statst[nterm][1] = statst[nterm][1] - adTiMe + (statst[nterm][2] - statst[nterm][3]) * (TiMe - statst[nterm][4]);
	statst[nterm][3] = statst[nterm][3] + 1.0;
	statst[nterm][4] = TiMe;
	/* */

	goto l_300;
	/* */
	/*     DURATION OF LOADING */
	/*     =================== */
l_1000: 
#ifdef DEBUG
dprint(LABEL, "bload: label l_1000 \n"); /* */
#endif
	adTiMe = local_TiMe * anzahl;
	if (next_int(anzahl) == 0) {
		if (trace) 
			fprintf (nunit2, "                         no transactions loaded\n");
	} else {
		if (kprint == 1) {
			nact = 12;
			fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[row_txact], ncar, nact, nterm);
		}
		if (adTiMe > eps) {
			if (trace) 
				fprintf (nunit2, "                         bus%4d delayed by %12.4f units of TiMe\n", ncar,
				     adTiMe);
			/* */
			/*     UPDATE STATISTICS OF DURATION OF LOADING */
			/*     ======================================== */
			statis[ncar][10] = statis[ncar][10] + adTiMe;
		}
		/* */
	}
	/* */
	/*     ENTER IN EVENT CHAIN */
	/*     ==================== */
	carma[ncar][8] = 2.0;
	activlist[row_txact].next = TiMe + adTiMe;
	activlist[row_txact].target = 2;
	tchain(3, row_txact);

	/* */
l_90:  
	return(AUSGANG2);
	/* */
	/*     ERROR EXIT */
	/*     ========== */
l_4000:  
	fprintf (nunit2, "\n\n+++++ bload :  t=%12.4f ERROR  : transaction attempts to load\n", TiMe);
	goto l_99;
	/* */
l_4100:  
	fprintf (nunit2, "\n\n+++++ bload :  t=%12.4f ERROR  : taxi or transporter in bload\n", TiMe);
	goto l_99;
	/* */
l_4200:  
	fprintf (nunit2, "\n\n+++++ bload :  t=%12.4f ERROR  : negative duration of loading %8.2f\n", TiMe, local_TiMe);
l_99:    
	return(FEHLER);
	/* */
}


