static char *SccsId = "@(#)PEPSY:\tbout.c\t1.3\t92/03/27 11:54:31";
#include <stdio.h>
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	bout(local_TiMe)
float	local_TiMe;
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	/*     ***  */
	/*     *** CALL BOUT(TIME,*9000,*9999) */
	/*     ***  */
	/*     *** PURPOSE : UNLOAD A TRANSACTION AT THE UNLOADING */
	/*     ***           TERMINAL */
	/*     *** PARAMETERS: TIME  = TIME TO UNLOAD A TRANSACTION */
	/*     ***             *9000 = EXIT TO FLOW CONTROL */
	/*     ***             *9999 = ERROR EXIT */
	/*     ***  */
	/* */

	int	ncar, partnr, routnr, sectnr, segm, segmnr;
	int	next, nact, last, nterm, line, i;
	short	beginn, trace;
	extern int	next_int(), tchain();
	double	anzahl, adTiMe;

#ifdef DEBUG
dprint(BUS, "bout: time %f\n", local_TiMe); /* */
#endif

	/*     TEST FOR ERRORS */
	/*     =============== */
	ncar  = next_int(txadd[row_txact][1]);
	if (ncar == 0)          
		goto l_4000;
	if (txi[row_txact] != 1) 
		goto l_4100;
	if (local_TiMe < -eps)  
		goto l_4200;
	/* */
	/*     INITIALIZE */
	/*     ========== */
	beginn = TRUE;
	routnr = next_int(tarma[ncar][5]);
	segm   = next_int(tarma[ncar][6]);
	segmnr = routma[routnr][segm];
	partnr = next_int(tarma[ncar][7]);
	sectnr = segma[segmnr][partnr];
	nterm  = next_int(sectma[sectnr][2]);
	line   = next_int(carma[ncar][2]);
	anzahl = 0.0;
	trace  = ((iprint == 1 || jprint[22] > 0) && jprint[22] != -1);
	/* */
	if (trace) 
		fprintf (nunit2, "bout  :  t=%12.4f  bus%4d is at terminal%4d\n", TiMe, ncar, nterm);
	/* */
	/*     ARE THERE TRANSACTIONS TO BE UNLOADED? */
	/*     ====================================== */
l_1000: 
#ifdef DEBUG
dprint(LABEL, "bout: label l_1000\n"); /* */
#endif
	if (line < 0) 
		goto l_2000;
	/* */
	/*     SCHEDULE PASSENGERS FOR THIS TERMINAL */
	/*     ===================================== */
	if (next_int(txadd[line][2]) == nterm) {
#ifdef DEBUG
dprint(BUS, "bout: ausladen am terminal  %d\n", nterm); /* */
#endif
		anzahl = anzahl + 1.0;
		adTiMe = local_TiMe * anzahl;
		activlist[line].next = TiMe + adTiMe;
		switch (tchain(3, line)) {
		case FEHLER: 
			goto l_99;
		};
		next = activlist[line].blk_link;
		activlist[line].blk_link = 0;
		if (trace) {
			fprintf (nunit2, "                         transaction nr %4d is unloaded    \n", tx_system[line].nr);
			if (adTiMe > eps) 
				fprintf (nunit2, "                         and delayed by %12.4f TiMe units for unloading\n",
				     adTiMe);
		}
		if (kprint == 1) {
			nact = 6;
			fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[line], tx_system[line].nr, nact, nterm);
		}
		/* */
		/*     UPDATE DATA AREA OF BUS  */
		/*     =======================  */
		anford = next_int(txadd[line][4]);
		if (anford == 0)  
			anford = 1;
		carma[ncar][4] = carma[ncar][4] - (double)anford;
		if (beginn) {
			carma[ncar][2] = (double)next;
		} else {
			activlist[last].blk_link = next;
		}
	} else {
		beginn = FALSE;
		last   = line;
		next   = activlist[line].blk_link;
	}
	line = next;
	goto l_1000;
	/* */
	/* */
	/*     DURATION OF UNLOADING */
	/*     ===================== */
l_2000: 
#ifdef DEBUG
dprint(LABEL, "bout: label l_2000\n"); /* */
#endif
	adTiMe = local_TiMe * anzahl;
	if (next_int(anzahl) == 0) {
		if (trace) 
			fprintf (nunit2, "                         no transaction unloaded\n");
	} else {
		if (adTiMe > eps) {
			if (trace) 
				fprintf (nunit2, "                         bus%4d delayed by %12.4f for unloading\n", ncar,
				     adTiMe);
			if (kprint == 1) {
				nact = 14;
				fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[row_txact], ncar, nact, nterm);
			}
			/* */
			/*           UPDATE STATISTICS OF DURATION OF UNLOADING */
			/*           ========================================== */
			statis[ncar][10] = statis[ncar][10] + adTiMe;
		}
	}
	/* */
	/* */
	/*     INSERT IN EVENT CHAIN */
	/*     ===================== */
	carma[ncar][8] = 1.0;
	activlist[row_txact].next = TiMe + adTiMe;
	activlist[row_txact].target = 2;
	tchain(3, row_txact);
	/* */
l_90:  
	return(AUSGANG2);
	/* */
	/*     ERROR EXIT */
	/*     ========== */
l_4000:  
	fprintf (nunit2, "\n\n+++++bout  :  t=%12.4f ERROR  : transaction attemps to unload  \n", TiMe);
	goto l_99;
	/* */
l_4100:  
	fprintf (nunit2, "\n\n+++++ bout  :  t=%12.4f ERROR  : taxi or transporter in bout\n", TiMe);
	goto l_99;
	/* */
l_4200:  
	fprintf (nunit2, "\n\n+++++ bout  :  t=%12.4f ERROR  : negative unloading TiMe  %8.2f\n", TiMe, local_TiMe);
l_99:    
	return(FEHLER);
	/* */
}


