static char *SccsId = "@(#)PEPSY:\tboxexp.c\t1.2\t92/03/27 11:54:33";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	boxexp(rmin, rmax1, rmax2, ratio, irnum, random)
double	*random ;
int	irnum ;
double	ratio ;
double	rmax2 ;
double	rmax1 ;
double	rmin ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call boxexp(rmin,rmax1,rmax2,ratio,irnum, *random)            */
	/*    ***                                                               */
	/*    *** funktion : erzeugen einer zufallszahl aus einer gleichver-    */
	/*    ***            teilung mit exponentiellem anteil                  */
	/*    *** parameter: rmin    = untere intervallgrenze der gleich-       */
	/*    ***                      verteilung                               */
	/*    ***            rmax1   = obere intervallgrenze der gleich-        */
	/*    ***                      verteilung                               */
	/*    ***            rmax2   = obere intervallgrenze der exponential-   */
	/*    ***                      verteilung                               */
	/*    ***            ratio   = wahrscheinlichkeit fuer die              */
	/*    ***                      erzeugung einer zufallszahl nach         */
	/*    ***                      der gleichverteilung                     */
	/*    ***            irnum   = nummer des zufallszahlengenerators       */
	/*    ***             *random  = rueckgabe: zufallszahl im angegebenen  */
	/*    ***                                 intervall                     */
	/*    ***                                                               */
	extern int	unifrm();
	double	z;
	/*                                                                      */
	/*    erzeugen einer zufallszahl aus der gleichverteilung               */
	/*    ===================================================               */
	unifrm(0., 1., irnum, &z);
	if (z >= ratio) 
		goto l_100;
	*random = rmin + ((rmax1 - rmin) / ratio) * z;
	return(NORMAL);
	/*                                                                      */
	/*    erzeugen einer zufallszahl nach der exponentialverteilung         */
	/*    =========================================================         */
l_100:   
	*random = rmax1 - (((1. - ratio) * (rmax1 - rmin)) / ratio) * log((1. - z) / (1. - ratio));
	if ( *random <= rmax2) 
		return(NORMAL);
	unifrm(ratio, 1., irnum, &z);
	goto l_100;
}


