static char *SccsId = "@(#)PEPSY:\tcross.c\t1.2\t92/03/27 11:54:46";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	cross(nset, ncr, nx, ny, cmult, cadd, ldir, tol)
double	tol ;
int	ldir ;
double	cadd ;
double	cmult ;
int	ny ;
int	nx ;
int	ncr ;
int	nset ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call cross(nset,ncr,nx,ny,cmult,cadd,ldir,tol,*977,*9999)     */
	/*    ***                                                               */
	/*    *** funktion : erkennen und lokalisieren von crossings            */
	/*    ***            setzen von iflag und jflag                         */
	/*    *** parameter: nset  = nummer des set in dem crossing gesucht wird  */
	/*    ***            ncr   = nummer des crossing                        */
	/*    ***            nx    = nummer der kreuzenden variablen 'x'        */
	/*    ***                    innerhalb des sets 'nset'                  */
	/*    ***                    nx > 0 : variable ist sv                   */
	/*    ***                    nx < 0 : variable ist dv                   */
	/*    ***            ny    = nummer der gekreuzten variablen 'y'        */
	/*    ***                    ny > 0 : variable ist sv                   */
	/*    ***                    ny < 0 : variable ist dv                   */
	/*    ***                    ny = 0 : variable 'y' = 0                  */
	/*    ***            cmult = multiplikativer term fuer variable 'y'     */
	/*    ***            cadd  = additiver term fuer variable 'y'           */
	/*    ***            ldir  = richtung in der crossing lokalisiert wird  */
	/*    ***                     0 : neutrales crossing                    */
	/*    ***                    +1 : positives crossing                    */
	/*    ***                    -1 : negatives crossing                    */
	/*    ***            tol   = toleranz                                   */
	/*    ***            exit1 = ausgang wenn iflag = 2                     */
	/*    ***            exit2 = fehlerausgang                              */
	/*    ***                                                               */
	double	x, y;

	/*                                                                      */
	/*    vorbereitung zur pruefung der cross-bedingung                     */
	/*    =============================================                     */
	if (nx  >  0) 
		x = sv[nset][ nx];
	if (nx  ==  0) 
		goto l_9999;
	if (nx  <  0) 
		x = dv[nset][-nx];
	/*                                                                      */
	if (ny  >  0) 
		y = sv[nset][ ny] * cmult + cadd;
	if (ny  ==  0) 
		y = cadd ;
	if (ny  <  0) 
		y = dv[nset][-ny] * cmult + cadd;
	/*                                                                      */
	/*    jflag setzen                                                      */
	/*    ============                                                      */
	if (x  >  y) 
		jflag[nset][ncr] = 1;
	if (x  ==  y) 
		jflag[nset][ncr] =  jflagl[nset][ncr];
	if (x  <  y) 
		jflag[nset][ncr] = -1;
	/*                                                                      */
	/*    ruecksprung falls kein crossing vorliegt                          */
	/*    ========================================                          */
	iflag[nset][ncr] = 0;
	if ( jflag[nset][ncr]  ==  jflagl[nset][ncr] ) 
		return(NORMAL);
	if ( jflag[nset][ncr]  ==  -ldir ) 
		return(NORMAL);
	if ( jflagl[nset][ncr]  ==  0 ) 
		return(NORMAL);
	/*                                                                      */
	/*    ruecksprung falls crossing lokalisiert                            */
	/*    ======================================                            */
	iflag[nset][ncr] = 1;
	if ( equatlist[nset].next - equatlist[nset].last  <  eps ) 
		return(NORMAL);
	if ( fabs(x - y)  <  tol ) 
		return(NORMAL);
	/*                                                                      */
	/*    ruecksprung falls crossing ausserhalb des toleranzbereichs        */
	/*    ==========================================================        */
	iflag[nset][ncr] = 2;
	return(AUSGANG2);
	/*                                                                      */
	/*    fehlerbehandlung falls ncr = 0                                    */
	/*    ==============================                                    */
l_9999:
	;
	fprintf(nunit2, "\n\n+++++ cross: TiMe=%12.4f in cross(%3d,%3d,...) nx = 0\n",
	    TiMe, nset, ncr);
	return(FEHLER);
}


