static char *SccsId = "@(#)PEPSY:\tdblock.c\t1.3\t92/03/27 11:54:48";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	dblock(nt, ns, lfam, max)
int	max ;
int	lfam ;
int	ns ;
int	nt ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call dblock(nt,ns,lfam,max)                                   */
	/*    ***                                                               */
	/*    *** funktion : deblockieren der vor der station (nt,ns)           */
	/*    ***            blockierten trs                                    */
	/*    *** parameter: nt   = stationstyp                                 */
	/*    ***            ns   = typnummer                                   */
	/*    ***            lfam = zeilennumer in der fam-matrix fuer stationen  */
	/*    ***                   mit nt = 7,10 oder 11                       */
	/*    ***            max  = anzahl der zu deblockierenden trs           */
	/*    ***                   > 0 : maximale anzahl                       */
	/*    ***                   = 0 : alle trs, die vor der station k       */
	/*    ***                         blockiert sind                        */
	/*    ***                                                               */
	int	tpoint, maxl, ns1, bpoint ;
	struct ACTIVLIST *bpointer;
	int	k, k1, line ;
	int	next_int();

#ifdef DEBUG
dprint(TRANSACTION, "dblock: nt %d, ns %d, lfam %d, max %d\n", nt, ns, lfam, max); /* */
#endif
	/*                                                                      */
	/*    bestimmen der stationsnummer                                      */
	/*    ============================                                      */
	maxl = max;
	ns1 = ns;
	if (nt < 10 && nt != 7 || nt >= 12) 
		goto l_100;
	ns1 = zfam * (ns - 1) + lfam;
l_100:  
	k = *ptr_offset[nt] + ns1 - 1;
	/*                                                                      */
	/*    initialisieren der suche                                          */
	/*    ========================                                          */
	if (bhead[k] == NULL) 
		return(NORMAL);
	bpointer = bhead[k];
	bpoint = bpointer - activlist;
	tpoint = head[3].link;
	if (maxl  ==  0) 
		maxl = ztx;
	if (bpointer->link  !=  0) 
		goto l_400;
	if (head[3].next > TiMe + eps || tpoint < 0) 
		goto l_300;
	if (activlist[tpoint].next > 0.0) 
		goto l_500;
	k1 = abs(next_int(activlist[tpoint].next));
	if (k > k1) 
		goto l_500;
	/*                                                                      */
	/*    einketten am kettenanfang                                         */
	/*    =========================                                         */
l_300:  
	head[3].next = TiMe;
	bpoint = bpointer - activlist;
	head[3].link = bpoint;
	bpointer->link = tpoint;
	if (nt <= 12)  {
		if ((iprint == 1 || jprint[nt] == 1 ) && jprint[nt] != -1)
			fprintf(nunit2, "dblock:  t=%12.4f  tr%6d,%4d   wird deblockiert\n",
			    TiMe, tx_system[bpoint].nr, tx_system[bpoint].dup);
	} else {
		if ((iprint == 1 || jprint[23] == 1 || jprint[23] == 2) && 
		    jprint[23] != -1 && jprint[23] != -2)
			fprintf(nunit2, "dblock:  t=%12.4f vehicle%4d wird deblockiert 1\n",
			    TiMe, next_int(txadd[bpoint][1]));
	}

	maxl = maxl - 1 ;
	if (maxl == 0) 
		return(NORMAL);
	/*                                                                      */
	/*    naechste zu deblockierende tr in der blockkette suchen            */
	/*    ======================================================            */
l_400:  
	line = bpoint ;
	tpoint = activlist[bpoint].link;
	bpoint = activlist[bpoint].blk_link;
	if (bpoint  <  0) 
		return(NORMAL);
	if (activlist[bpoint].link  !=  0) 
		goto l_400;
	tpoint = line ;
	/*                                                                      */
	/*    position in der zeitkette suchen                                  */
	/*    ================================                                  */
l_500:  
	line = tpoint ;
	tpoint = activlist[tpoint].link;
	if (tpoint  <  0) 
		goto l_600;
	if (activlist[tpoint].next  >  TiMe + eps) 
		goto l_600;
	if (activlist[tpoint].next > 0.0  &&  activlist[tpoint].next <= TiMe + eps)
		goto l_500;
	k1 = abs(next_int(activlist[tpoint].next));
	if (k  >  k1) 
		goto l_500;
	/*                                                                      */
	/*    tr deblockieren (in die zeitkette einketten)                      */
	/*    ============================================                      */
l_600:  
	activlist[line].link = bpoint ;
	activlist[bpoint].link = tpoint;
	if (nt <= 12)  {
		if ((iprint == 1 || jprint[nt] == 1 ) && jprint[nt] != -1)
			fprintf(nunit2, "dblock:  t=%12.4f  tr%6d,%4d   wird deblockiert\n",
			    TiMe, tx_system[bpoint].nr, tx_system[bpoint].dup);
	} else {
		if ((iprint == 1 || jprint[23] == 1 || jprint[23] == 2) && 
		    jprint[23] != -1 && jprint[23] != -2)
			fprintf(nunit2, "dblock:  t=%12.4f vehicle%4d  wird deblockiert 2\n",
			    TiMe, next_int(txadd[bpoint][1]));
	}
	maxl = maxl - 1;
	tpoint = bpoint;
	if (maxl  !=  0) 
		goto l_400;
	return(NORMAL);
}


