static char *SccsId = "@(#)PEPSY:\tdelay.c\t1.2\t92/03/27 11:54:51";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


/*    vorgaenger-/nachfolger-operationen "predec"/"succes" definieren   */
/*    ===============================================================   */
#define predec(A) (((A)+zldvar-2)%zldvar+1)
#define succes(A) ((A)%zldvar+1)

int	defill (nset, nvar, x, idim)
int	idim ;
double	x[][3] ;
int	nvar ;
int	nset ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call defill (nset, nvar, x, idim, *9999)                      */
	/*    ***                                                               */
	/*    *** funktion : speicherung der funktionswerte einer               */
	/*    ***            delay-variablen                                    */
	/*    ***                                                               */
	/*    *** parameter : nset  = set-nummer der delay-variablen            */
	/*    ***             nvar  = variablen-nummer der delay-variablen      */
	/*    ***                     > 0 : zustandsvariable                    */
	/*    ***                     < 0 : differentialquotient                */
	/*    ***             x     = matrix, die stuetzwerte der               */
	/*    ***                     delay-variablen enthaelt                  */
	/*    ***             idim  = anzahl der einzutragenden wertepaare      */
	/*    ***             exit1 = fehlerausgang                             */
	/*    ***                                                               */
	extern int	reprt7();
	int	ip, nvabs, i, nd, lp, ip1, ipl, ips ;
	int	ip2, ipbeg, ipend, iplast, iphase, ipfrst ;
	double	trast ;
	char	_sv[3], _dv[3], _svdv[3] ;
	/*                                                                      */
	strcpy(_sv, "sv");
	strcpy(_dv, "dv");

	/*    gewuenschte delay-variable deklariert ?                           */
	/*    =======================================                           */
	nvabs = abs(nvar);
	if (nvar  >=  0) 
		strcpy(_svdv, _sv);
	if (nvar  <  0) 
		strcpy(_svdv, _dv);
	for (i = 1; i <= zndvar; ++i) {
		nd = i;
		if (devar[i].del_set  ==  nset  &&  devar[i].del_var  ==  nvar) 
			goto l_20;
	};
	fprintf(nunit2, "\n\n+++++ defill: TiMe = %12.4g delay-variable %2s(%2d,%3d) nicht deklariert\n",
	    TiMe, _svdv, nset, nvabs);
	return(FEHLER);
	/*                                                                      */
	/*    einzutragende werte in zeitlich aufsteigender reihenfolge ?       */
	/*    ===========================================================       */
l_20:  
	if (idim  ==  1) 
		goto l_25;
	for (i = 2; i <= idim; ++i) {
		if ( x[i][2]  <  x[i-1][2] ) 
			goto l_22;
	};
	goto l_25;
	/*                                                                      */
l_22:  
	fprintf(nunit2, "\n\n+++++ defill: TiMe = %12.4g werte der delay-variable %2s(%2d,%3d) liegen nicht\n",
	    TiMe, _svdv, nset, nvabs);
	fprintf(nunit2, "%30s in zeitlich aufsteigender reihenfolge vor\n", BLANKF);
	return(FEHLER);
	/*                                                                      */
l_25:  
	if ( x[1][2]  >  TiMe - devar[nd].taumax - eps ) 
		goto l_100;
	fprintf(nunit2, "\n\n+++++ defill: TiMe = %12.4g zeitpunkt der delay-variable %2s(%2d,%3d)\n",
	    TiMe, _svdv, nset, nvabs);
	fprintf(nunit2, "%30s x(1,2) = %12.4g kleiner TiMe-taumax\n", BLANKF, x[1][2]);
	return(FEHLER);
	/*                                                                      */
	/*    eintragsentscheid                                                 */
	/*    =================                                                 */
l_100: 
	trast  =  devar[nd].taumax / zldvar;
	for (i = 1; i <= idim; ++i) {
l_110:  
		ip = devar[nd].w_ptr;
		lp = predec(ip);
		if ( x[i][2]  >=  t_devar[nd][ip] ) 
			goto l_120;
		t_devar[nd][ip] = tclear[nd] ;
		devar[nd].w_ptr = lp;
		goto l_110;
l_120:  
		if ( x[i][2] - t_devar[nd][ip]  <  eps ) 
			goto l_130;
		if ( t_devar[nd][lp]  ==  tclear[nd] ) 
			goto l_300;
		if ( t_devar[nd][ip] - t_devar[nd][lp]  <  eps ) 
			goto l_300;
		if ( t_devar[nd][ip]  >  t_devar[nd][lp] + trast ) 
			goto l_300;
		goto l_200;
l_130:  
		if ( t_devar[nd][ip] - t_devar[nd][lp]  <  eps ) 
			goto l_200;
		goto l_300;
		/*                                                                      */
		/*    letzten eintrag ueberschreiben                                    */
		/*    ==============================                                    */
l_200:  
		s_devar[nd][ip] = x[i][1] ;
		t_devar[nd][ip] = x[i][2] ;
		continue;
		/*                                                                      */
		/*    neuer eintrag                                                     */
		/*    =============                                                     */
l_300:  
		ip1 = succes(ip);
		ip2 = succes(ip1);
		if ( t_devar[nd][ip2]  <  TiMe - devar[nd].taumax - eps ) 
			goto l_350;
		if ( t_devar[nd][ip1]  ==  tclear[nd] ) 
			goto l_350;
		ipbeg = ip1;
		ipend = ip;
		goto l_1000;
l_340:  
		ip1 = ipbeg;
l_350:  
		s_devar[nd][ip1] = x[i][1];
		t_devar[nd][ip1] = x[i][2];
		devar[nd].w_ptr = ip1;
		continue;
		/*                                                                      */
		/*    speicherverdichtung durchfuehren                                  */
		/*    ================================                                  */
		/*    bereich zwischen zwei tabu-eintraegen suchen                      */
		/*    ============================================                      */
l_1000:
		if ( jprint[22] == 1  ||  iprint == 1  &&  jprint[22] != -1 ) 
			reprt7();
		ip  = ipbeg;
		ip1 = succes(ip);
		if ( t_devar[nd][ip]  !=  t_devar[nd][ip1] ) 
			goto l_1001;
		ip  = ip1;
		ip1 = succes(ip);
l_1001:
		iplast = ip;
		iphase = 1;
l_1005:
		if ( ip  ==  ipend ) 
			goto l_1200;
		ip  = ip1;
		ip1 = succes(ip);
		switch (iphase) {
		case 1: 
			goto l_1010;
		case 2: 
			goto l_1020;
		};
l_1010:
		if (t_devar[nd][ip] != t_devar[nd][ip1]  &&  ip != ipend) 
			goto l_1005;
		ipfrst = ip;
		goto l_1100;
l_1015:
		ip1 = succes(ipfrst);
		iphase = 2;
		goto l_1005;
l_1020:
		iplast = ip;
		iphase = 1;
		goto l_1005;
		/*                                                                      */
		/*    markieren                                                         */
		/*    =========                                                         */
l_1100:
		ip  = succes(iplast);
		ip1 = succes(ip);
l_1105:
		if ( ip  ==  ipfrst  ||  ip1  ==  ipfrst ) 
			goto l_1015;
		s_devar[nd][ip] = ( s_devar[nd][ip] + s_devar[nd][ip1] ) / 2.;
		t_devar[nd][ip] = ( t_devar[nd][ip] + t_devar[nd][ip1] ) / 2.;
		t_devar[nd][ip1] = tclear[nd];
		ip  = succes(ip1);
		ip1 = succes(ip);
		goto l_1105;
		/*                                                                      */
		/*    aufruecken                                                        */
		/*    ==========                                                        */
l_1200:
		ipl = ipend;
		ips = ipend;
l_1210:
		if ( ipl  ==  ipbeg ) 
			goto l_1300;
		ipl = predec(ipl);
		if ( t_devar[nd][ipl]  ==  tclear[nd] ) 
			goto l_1210;
		ips = predec(ips);
		if ( ips  ==  ipl ) 
			goto l_1210;
		s_devar[nd][ips] = s_devar[nd][ipl] ;
		t_devar[nd][ips] = t_devar[nd][ipl] ;
		t_devar[nd][ipl] = tclear[nd];
		goto l_1210;
		/*                                                                      */
		/*    protokoll und fehlermeldung                                       */
		/*    ===========================                                       */
l_1300:
		devar[nd].ncomp = devar[nd].ncomp + 1;
		if ( jprint[22] == 1  ||  iprint == 1  &&  jprint[22] != -1 ) 
			reprt7();
		if ( ips  !=  ipbeg ) 
			goto l_340;
		/*                                                                      */
		fprintf(nunit2, "\n\n+++++ defill: TiMe = %12.4g delay-variable %2s(%2d,%3d) speicherverdichtung nicht mehr moeglich\n",
		                  TiMe, _svdv, nset, nvabs);
		return(FEHLER);
		/*                                                                      */
		/*    naechster eintrag bzw. ruecksprung                                */
		/*    ==================================                                */
		;
	};
	return(NORMAL);
}





int	delay(nset, nvar, tau, dvalue)
double	*dvalue ;
double	tau ;
int	nvar ;
int	nset ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call delay (nset, nvar, tau,  *dvalue, *9999)                 */
	/*    ***                                                               */
	/*    *** funktion : ermittlung des funktionswertes einer delay-variablen  */
	/*    ***                                                               */
	/*    *** parameter : nset   = set-nummer der delay-variablen           */
	/*    ***             nvar   = variablen-nummer der delay-variable      */
	/*    ***                      > 0 : zustandsvariable                   */
	/*    ***                      < 0 : differentialquotient               */
	/*    ***             tau    = delay-zeit                               */
	/*    ***              *dvalue = rueckgabe: ermittelter wert der delay-   */
	/*    ***                                 variablen                     */
	/*    ***             exit1  = fehlerausgang                            */
	/*    ***                                                               */
	int	nvabs, i, nd, ip1, ip2, istep, ip3, ip0 ;
	double	dTiMe, t1, t2, f1 ;
	double	f12, t3, f23, f123, t0, f20, f21, f120, atdela, stdela ;
	char	nsv[3], ndv[3], nsvdv[3] ;
	/*                                                                      */
	strcpy(nsv, "sv");
	strcpy(ndv, "dv");
	/*                                                                      */
	/*    gewuenschte delay-variable deklariert ?                           */
	/*    =======================================                           */
	nvabs = abs(nvar);
	if (nvar  >=  0) 
		strcpy(nsvdv, nsv);
	if (nvar  <  0) 
		strcpy(nsvdv, ndv);
	for (i = 1; i <= zndvar; ++i) {
		nd = i;
		if (devar[i].del_set  ==  nset  &&  devar[i].del_var  ==  nvar) 
			goto l_20;
	};
	fprintf(nunit2, "\n\n+++++ delay: TiMe = %12.4g delay-variable %2s(%2d,%3d) nicht deklariert\n",
	    TiMe, nsvdv, nset, nvabs);
	return(FEHLER);
	/*                                                                      */
	/*    gewuenschte delay-zeit zulaessig ?                                */
	/*    ==================================                                */
l_20:  
	if (tau  >=  devar[nd].taumax + eps) 
		goto l_21;
	if (tau  <  0.) 
		goto l_22;
	if (tau  <  eps) 
		goto l_30;
	dTiMe  =  TiMe - tau;
	goto l_100;
	/*                                                                      */
l_21:
	fprintf(nunit2, "\n\n+++++ delay: TiMe = %12.4g delay-variable %2s(%2d,%3d)",
	    TiMe, nsvdv, nset, nvabs);
	fprintf(nunit2, " - totzeit (=%12.4g)  groesser maximale totzeit (=%12.4g)\n",
	    tau, devar[nd].taumax);
	return(FEHLER);
	/*                                                                      */
l_22:  
	fprintf(nunit2, "\n\n+++++ delay: TiMe = %12.4g delay-variable %2s(%2d,%3d) - totzeit (=%12.4g) negativ\n",
	    TiMe, nsvdv, nset, nvabs, tau);
	return(FEHLER);
	/*                                                                      */
	/*    tau kleiner eps                                                   */
	/*    ===============                                                   */
l_30:  
	if (nvar  >  0)  
		*dvalue = sv[nset][ nvar];
	if (nvar  <  0)  
		*dvalue = dv[nset][-nvar];
	return(NORMAL);
	/*                                                                      */
	/*    setzen der pointer                                                */
	/*    ==================                                                */
l_100:  
	ip1 = devar[nd].r_ptr;
	ip2 = succes(ip1);
	istep = 1;
	for (i = 1; i <= zldvar; ++i) {
		t1 = t_devar[nd][ip1];
		t2 = t_devar[nd][ip2];
		if ( t1  ==  tclear[nd] ) 
			goto l_110;
		if ( t1  <=  dTiMe - eps ) 
			goto l_120;
		if ( t1  >=  dTiMe + eps ) 
			goto l_190;
		goto l_140;
l_110:  
		if ( t2  <=  dTiMe - eps ) 
			goto l_180;
		if ( t2  >=  dTiMe + eps ) 
			goto l_210;
		goto l_160;
l_120:  
		if ( t2  >=  dTiMe + eps ) 
			goto l_300;
		if ( t2  <  t1 ) 
			goto l_400;
		if ( t2  <=  dTiMe - eps ) 
			goto l_180;
		goto l_160;
l_140:  
		if ( t2  >=  dTiMe + eps ) 
			goto l_170;
		if ( t2  <  t1 ) 
			goto l_170;
		if ( t2 - t1  <  eps ) 
			goto l_700;
		if ( t2 - dTiMe  <  dTiMe - t1 ) 
			goto l_160;
		goto l_170;
l_160:  
		if ( istep  ==  2 ) 
			goto l_500;
		istep = 2;
		goto l_180;
l_170:  
		if ( istep  ==  2 ) 
			goto l_600;
		istep = 2;
		goto l_190;
l_180:  
		ip1 = ip2;
		ip2 = succes(ip1);
		continue;
l_190:  
		ip2 = ip1;
		ip1 = predec(ip2);
	};
	/*                                                                      */
	/*    fehlerhafter delay-zugriff                                        */
	/*    ==========================                                        */
l_210:
	fprintf(nunit2, "\n\n+++++ delay: TiMe = %12.4g delay-variable %2s(%2d,%3d)",
	    TiMe, nsvdv, nset, nvabs);
	fprintf(nunit2, "  zeitpunkt%12.4g nicht gespeichert - fehlerhafte initialisierung\n", dTiMe);
	return(FEHLER);
	/*                                                                      */
	/*    interpolation                                                     */
	/*    =============                                                     */
l_300:  
	f1 = s_devar[nd][ip1];
	f12 = (s_devar[nd][ip2] - s_devar[nd][ip1]) / (t2 - t1);
	*dvalue = f1 + f12 * (dTiMe - t1);
	ip3 = succes(ip2);
	t3 = t_devar[nd][ip3];
	if (t3 - t2 < eps || t3 == tclear[nd]) 
		goto l_310;
	f23 = (s_devar[nd][ip3] - s_devar[nd][ip2]) / (t3 - t2);
	f123 = (f23 - f12) / (t3 - t1);
	*dvalue =  *dvalue + f123 * (dTiMe - t1) * (dTiMe - t2);
	goto l_1000;
l_310: 
	ip0 = predec(ip1);
	t0  = t_devar[nd][ip0];
	if (t1 - t0 < eps || t0 == tclear[nd]) 
		goto l_1000;
	f20 = (s_devar[nd][ip0] - s_devar[nd][ip2]) / (t0 - t2);
	f120 = (f20 - f12) / (t0 - t1);
	*dvalue = *dvalue + f120 * (dTiMe - t1) * (dTiMe - t2);
	goto l_1000;
	/*                                                                      */
	/*    extrapolation                                                     */
	/*    =============                                                     */
l_400:  
	if ( nvar  >=  0 ) 
		goto l_410;
	if ( nvar  <  0 ) 
		goto l_420;
l_410:   
	*dvalue = s_devar[nd][ip1] + 
	    ( sv[nset][nvar] - s_devar[nd][ip1] ) / (TiMe - t1) * 
	    ( dTiMe - t1 ) ;
	goto l_1000;
l_420:  
	ip0 = predec(ip1);
	t0  = t_devar[nd][ip0];
	if ( t0  >  t1 - eps  ||  t0  ==  tclear[nd] ) 
		goto l_425;
	*dvalue = s_devar[nd][ip0] + 
	    ( s_devar[nd][ip1] - s_devar[nd][ip0] ) / (t1 - t0) * 
	    ( dTiMe - t0 ) ;
	goto l_1000;
l_425:   
	*dvalue = dv[nset][-nvar] ;
	goto l_1000;
	/*                                                                      */
	/*    exakter wert bei t2                                               */
	/*    ===================                                               */
l_500:   
	*dvalue = s_devar[nd][ip2];
	goto l_1000;
	/*                                                                      */
	/*    exakter wert bei t1                                               */
	/*    ===================                                               */
l_600:   
	*dvalue = s_devar[nd][ip1];
	goto l_1000;
	/*                                                                      */
	/*    sprungstelle                                                      */
	/*    ============                                                      */
l_700:
	if ( equatlist[nset].last  <=  TiMe - eps)  
		*dvalue = s_devar[nd][ip1];
	if ( equatlist[nset].last  >  TiMe - eps )  
		*dvalue = s_devar[nd][ip2];
	goto l_1000;
	/*                                                                      */
	/*    tdela-vermerk setzen und ruecksprung                              */
	/*    ====================================                              */
l_1000:
	devar[nd].r_ptr = ip1;
	if ( fabs( TiMe - equatlist[nset].next )  >=  eps ) 
		return(NORMAL);
	if ( t2  <  t1 ) 
		return(NORMAL);
l_1010:
	ip1 = ip2;
	ip2 = succes(ip1);
	t1 = t2;
	t2 = t_devar[nd][ip2];
	if ( t2  <  t1 ) 
		return(NORMAL);
	if (t1 + tau  >=  equatlist[nset].next + equatlist[nset].step + eps) 
		return(NORMAL);
	if ( t2 - t1  >=  eps ) 
		goto l_1010;
	/*                                                                      */
	atdela = t1 + tau;
	stdela = 1.0;
	if (s_devar[nd][ip1] == s_devar[nd][ip2]) 
		stdela = -1.0;
	/*                                                                      */
	if ( delay_flag[nset] == 0. ) {
		delay_flag[nset] = stdela * atdela;
		return(NORMAL);
	};
	if ( atdela >= fabs(delay_flag[nset]) + eps) 
		return(NORMAL);
	if ( atdela <= fabs(delay_flag[nset]) - eps) {
		delay_flag[nset] = stdela * atdela;
		return(NORMAL);
	};
	if ( delay_flag[nset] > 0. ) 
		return(NORMAL);
	delay_flag[nset] = stdela * atdela;
	return(NORMAL);
}


