static char *SccsId = "@(#)PEPSY:\tdynval.c\t1.2\t92/03/27 11:55:03";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	dynval(nt, ns, lfam, icount)
int	*icount ;
int	lfam ;
int	ns ;
int	nt ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call dynval(nt,ns,lfam, *icount)                              */
	/*    ***                                                               */
	/*    *** funktion : neubestimmen der prioritaeten fuer alle trs, die   */
	/*    ***            an der angegebenen station blockiert sind          */
	/*    *** parameter: nt     = stationstyp                               */
	/*    ***            ns     = typnummer                                 */
	/*    ***            lfam   = zeilennummer in der fam-matrix fuer       */
	/*    ***                     stationen mit nt = 7, 10 oder 11          */
	/*    ***             *icount = rueckgabe: anzahl der prioritaets-      */
	/*    ***                                neubestimmungen                */
	/*    ***                                                               */
	extern int	block(), dblock(), policy();
	extern double	dynpr();
	extern int	next_int();
	int	ftx, bpoint, tpoint, ns1, k, line, idbloc, k1;
	int	nexttp, ntx, i, np;
	double	pr;
	/*                                                                      */
	/*    bestimmen der stationsnummer                                      */
	/*    ============================                                      */
	ns1 = ns;
	if (nt < 10 && nt != 7 || nt >= 12) 
		goto l_100;
	ns1 = zfam * (ns - 1) + lfam;
l_100:  
	k = *ptr_offset[nt] + ns1 - 1;
	/*                                                                      */
	/*    alle deblockierten trs der zeitkette erneut blockieren            */
	/*    ======================================================            */
	tpoint = head[3].link;
	line = -1;
	idbloc = 0;
	if (tpoint  <  0) 
		goto l_300;
	k1 = next_int(activlist[tpoint].next);
	if (k1  ==  -k) 
		goto l_210;
l_200:  
	line = tpoint ;
	tpoint = activlist[line].link ;
	if (tpoint  <  0) 
		goto l_300;
	k1 = next_int(activlist[tpoint].next);
	if (k1  !=  -k) 
		goto l_200;
l_210:  
	nexttp = activlist[tpoint].link;
	activlist[tpoint].link = 0;
	idbloc = idbloc + 1;

	if (nt <= 12) {
		if ((iprint == 1 || jprint[nt] == 1) && jprint[nt] == -1)
			fprintf(nunit2, " dynval:  TiMe=%12.4f  tr%6d,%4d   wird erneut blockiert\n",
			    TiMe, tx_system[tpoint].nr, tx_system[tpoint].dup);
	} else {
		if ((iprint == 1 || jprint[23] == 1 || jprint[23] == 2) && 
		    jprint[23] != -1 && jprint[23] != -2)
			fprintf(nunit2, " dynval:  TiMe=%12.4f  vehicle%4d   wird erneut blockiert\n",
			    TiMe, next_int(txadd[tpoint][1]));
	}

l_220:  
	tpoint = nexttp;
	if (nexttp  <  0) 
		goto l_250;
	k1 = next_int(activlist[tpoint].next);
	if (k1  ==  -k) 
		goto l_210;
l_250:  
	if (line  <  0) 
		goto l_260;
	activlist[line].link = tpoint ;
	goto l_300;
l_260:  
	head[3].link = tpoint;
	if (tpoint  <  0) 
		goto l_270;
	k1 = next_int(activlist[tpoint].next);
	if (k1  >=  0) 
		head[3].next = activlist[tpoint].next;
	goto l_300;
l_270:  
	head[3].next = 0.0;
	/*                                                                      */
	/*    neufestlegen der prioritaeten                                     */
	/*    =============================                                     */
l_300:  
	ntx = row_txact;
	row_txact = bhead[k] - activlist;
	bhead[k] = NULL ;
	for (i = 1; i <= ztx; ++i) {
		if (row_txact < 0) 
			goto l_400;
		pr = tx_system[row_txact].priority;
		tx_system[row_txact].priority = dynpr(row_txact);

		if (nt <= 12) {
			if ((iprint == 1 || jprint[nt] == 1) && jprint[nt] == -1)
				fprintf(nunit2, " dynval:  TiMe=%12.4f  tr%6d,%4d   alte prioritaet%12.4f wird geaendert in %12.4f\n",
				                  TiMe, tx_system[row_txact].nr, tx_system[row_txact].dup, pr, tx_system[row_txact].priority);
		} else {
			if ((iprint == 1 || jprint[23] == 1 || jprint[23] == 2) && 
			    jprint[23] != -1 && jprint[23] != -2)
				fprintf(nunit2, " dynval:  TiMe=%12.4f  vehicle%4d   alte prioritaet%12.4f wird geaendert in %12.4f\n",
				                  TiMe, next_int(txadd[row_txact][1]), pr, tx_system[row_txact].priority);
		}

		bpoint = activlist[row_txact].blk_link;
		activlist[row_txact].blk_link = 0;
		/*                                                                      */
		/*    neu einketten                                                     */
		/*    =============                                                     */
		policy(nt, ns, lfam, &ftx, &np);
		block(nt, ns, lfam, ftx);
		row_txact = bpoint;
	};
	i = ztx + 1;
l_400:  
	row_txact = ntx;
	*icount = i - 1;
	/*                                                                      */
	/*    anzahl der anfangs blockierten trs wieder deblockieren            */
	/*    ======================================================            */
	if (idbloc  >  0) 
		dblock(nt, ns, lfam, idbloc);
	return(NORMAL);
}


