static char *SccsId = "@(#)PEPSY:\tendtab.c\t1.2\t92/03/27 11:55:09";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	endtab(ntab, igraph, yll, yul)
double	yul ;
double	yll ;
int	igraph ;
int	ntab ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call endtab(ntab,igraph,yll,yul)                              */
	/*    ***                                                               */
	/*    *** funktion : auswerten, drucken und graphische darstellung      */
	/*    ***            einer haeufigkeitstabelle                          */
	/*    *** parameter: ntab   = tabellennummer                            */
	/*    ***                     = 0 alle vorhandenen tabellen auswerten   */
	/*    ***            igraph = modus fuer graph. darstellung             */
	/*    ***                     = 0 keine graph. darstellung              */
	/*    ***                     = 1 absolute haeufigkeiten                */
	/*    ***                     = 2 relative haeufigkeiten                */
	/*    ***                     = 3 absolute haeufigkeiten kumuliert      */
	/*    ***                     = 4 relative haeufigkeiten kumuliert      */
	/*    ***            yll    = untergrenze der histogrammsaeulen         */
	/*    ***                     fuer graph. darstellung                   */
	/*    ***            yul    = obergrenze der histogrammsaeulen          */
	/*    ***                     fuer graph. darstellung                   */
	/*    ***                                                               */
	extern int	graph();
	int	ntabl, igrapl, iu, io, i, idim ;
	int	ng, i1, j, j2, f, sumf;
	double	taby[101], rel[101], valtab[101][3], tabx[101];
	double	xqu, yqu, varx, vary, ylloc, yuloc;
	double	sdvx, sumx, sumy, rhoxy, covxy ;
	double	hilfx, hilfy, gbr ;
	char	dpp, blanc[5], text[33];
	/*                                                                      */
	double	epsx = 1.e-5;
	strcpy(blanc, BLANKF);
	dpp = ':';
	/*                                                                      */
	/*    ueberpruefen der eingabedaten                                     */
	/*    =============================                                     */
	ntabl = ntab;
	igrapl = igraph;
	ylloc = yll;
	yuloc = yul;
	if (ntabl >= 0  &&  ntabl <= zntab) 
		goto l_10;
	fprintf(nunit2, "\n\n endtab: eingabedatenfehler ntab=%2d\n%9sdeshalb auswerten aller tabellen\n", ntabl, BLANKF);
	ntabl = 0;
l_10:  
	if (igrapl >= 0  &&  igrapl <= 4) 
		goto l_12;
	fprintf(nunit2, "\n\n endtab: eingabedatenfehler igraph=%2d\n%9sdeshalb keine graphische darstellung\n",
	    igrapl, BLANKF);
	igrapl = 0;
l_12:  
	if (ylloc < 0.)  
		ylloc = 0.;
	if (yuloc >= ylloc) 
		goto l_15;
	igrapl = 0;
	fprintf(nunit2, "\n\n endtab: grenzwerte falsch: yll=%5.1f yul=%5.1f\n%9sdeshalb keine graphische darstellung\n",
	                   ylloc, yuloc, BLANKF);
	/*                                                                      */
	/*    vorbereitungen                                                    */
	/*    ==============                                                    */
l_15:  
	if (ntabl == 0) 
		goto l_20;
	iu = ntabl;
	io = ntabl;
	goto l_30;
l_20:  
	iu = 1;
	io = zntab;
	/*                                                                      */
l_30:  
	strcpy(text, blanc);
	for (i = 2 ; i <= 8 ; strcat(text, blanc), i++)
		;
	/*                                                                      */
	for (ntabl = iu ; ntabl <= io; ++ntabl) {
		if (fabs(table[1][ntabl].up_bound) < epsx  && 
		    fabs(table[2][ntabl].up_bound) < epsx) 
			continue;
		/*                                                                      */
		/*    initialisieren der variablen                                      */
		/*    ============================                                      */
		xqu = 0.;
		yqu = 0.;
		varx = 0.;
		vary = 0.;
		sdvx = 0.;
		sumf = 0;
		sumx = 0.;
		sumy = 0.;
		rhoxy = 0.;
		covxy = 0.;
		for (i = 1; i <= ztab; ++i) {
			tabx[i] = 0.0;
			taby[i] = 0.0;
			rel[i] = 0.0;
		};
		/*                                                                      */
		/*    1. tabellendurchlauf                                              */
		/*    ====================                                              */
		for (idim = 1; idim <= ztab; ++idim) {
			f = table[idim][ntabl].frequ;
			sumf = sumf + f;
			sumx = sumx + table[idim][ntabl].sum_x;
			sumy = sumy + table[idim][ntabl].sum_y;
			if (idim == ztab) 
				goto l_150;
			if (table[idim+1][ntabl].frequ < 0) 
				goto l_150;
		};
		/*                                                                      */
		/*    berechnen der mittelwerte und der rel. haeufigk. / intervall      */
		/*    ============================================================      */
l_150:  
		if (sumf <= 0) 
			goto l_320;
		for (i = 1; i <= idim; ++i) {
			rel[i] = table[i][ntabl].frequ / (double)sumf;
			if (abs(table[i][ntabl].frequ) == 0) 
				continue;
			taby[i] = table[i][ntabl].sum_y / (double)table[i][ntabl].frequ;
			tabx[i] = table[i][ntabl].sum_x / (double)table[i][ntabl].frequ;
		};
		/*                                                                      */
		/*    berechnen der statistischen groessen                              */
		/*    ====================================                              */
		xqu = sumx / (double)sumf;
		yqu = sumy / (double)sumf;
		/*                                                                      */
		if (sumf - 1 > 0) 
			goto l_250;
		varx = 0.;
		sdvx = 0.;
		rhoxy = 0.;
		goto l_270;
		/*                                                                      */
l_250:
		for (i = 1; i <= idim; ++i) {
			f = table[i][ntabl].frequ;
			hilfx = tabx[i] - xqu ;
			hilfy = taby[i] - yqu ;
			varx  = varx + hilfx * hilfx * (double)f;
			vary  = vary + hilfy * hilfy * (double)f;
			covxy = covxy + hilfx * hilfy * (double)f;
		};
		/*                                                                      */
		if (varx <= epsx || vary <= epsx) 
			goto l_265;
		rhoxy = covxy / ( sqrt(varx) * sqrt(vary) ) ;
l_265:  
		varx  = varx / (double)(sumf - 1);
		sdvx  = sqrt(varx);
		/*                                                                      */
l_270:  
		gbr = table[2][ntabl].up_bound - table[1][ntabl].up_bound;
		/*                                                                      */
		/*    ausgeben der ergebnisse                                           */
		/*    =======================                                           */
		fprintf(nunit2, "\f\n\n\n%10sTiMe =%12.4g     rTiMe =%12.4g\n",
		    BLANKF, TiMe, rTiMe );
		fprintf(nunit2, "\n\n%15stabelle%3d\n%16s==========\n\n",
		    BLANKF, ntabl, BLANKF);
		fprintf(nunit2, "   i%12sx%13sf(x)%10sf/n%11scumx%11scumy%11se(y)\n\n",
		    BLANKF, BLANKF, BLANKF, BLANKF, BLANKF, BLANKF);
		fprintf(nunit2, "   unterlaufbereich     %10d     %10.3f     %10.3e     %10.3e     %10.3f\n",
		    table[1][ntabl].frequ, rel[1], table[1][ntabl].sum_x, table[1][ntabl].sum_y, taby[1]);
		ng = idim - 2 ;
		for (i = 1; i <= ng; ++i) {
			i1 = i + 1;
			fprintf(nunit2, " %3d     %10.3f     %10d     %10.3f     %10.3e     %10.3e     %10.3f\n",
			    i, table[i1][ntabl].up_bound, table[i1][ntabl].frequ,
			    rel[i1], table[i1][ntabl].sum_x, table[i1][ntabl].sum_y, taby[i1]);
		};
		fprintf(nunit2, "   ueberlaufbereich     %10d     %10.3f     %10.3e     %10.3e     %10.3f\n",
		    table[idim][ntabl].frequ, rel[idim], table[idim][ntabl].sum_x, table[idim][ntabl].sum_y, taby[idim]);
		fprintf(nunit2, "\n\n   intervallbreite    =%10.1f\n", gbr);
		/*                                                                      */
l_320:  
		fprintf(nunit2, "\n\n   stichprobenumfang  = %12d   stichprobenmittel  = %12.6g\n\n   stichprobenvarianz = %12.6g",
		                    sumf, xqu, varx);
		fprintf(nunit2, "   standardabweichung = %12.6g\n\n   korrelationskoeffizient zwischen x und y = %10.4g\n\n\n",
		                    sdvx, rhoxy );
		/*                                                                      */
		/*    graphische darstellung                                            */
		/*    ======================                                            */
		if (igrapl == 0) 
			continue;
		sprintf(text, "tabelle %2d%c ", ntabl, dpp);
		if (igrapl != 2  &&  igrapl != 4) 
			goto l_330;
		if (ylloc < 0.) 
			ylloc = 0.;
		if (yuloc > 1.) 
			yuloc = 1.;
		strcat(text, "relativ");
		for (j = 1; j <= idim; ++j) {
			valtab[j][1] = table[j][ntabl].up_bound;
			valtab[j][2] = rel[j];
		};
		goto l_350;
l_330: 
		strcat(text, "absolut");
		for (j2 = 1; j2 <= idim; ++j2) {
			valtab[j2][1] = table[j2][ntabl].up_bound;
			valtab[j2][2] = (double)table[j2][ntabl].frequ;
		};
l_350:  
		if (igrapl <= 2) 
			goto l_370;
		strcat(text, "kumuliert");
		for (j = 2; j <= idim; ++j) {
			valtab[j][2] = valtab[j][2] + valtab[j-1][2];
		};
l_370:  
		graph(valtab, idim, ylloc, yuloc, text);
	};
	return(NORMAL);
}


