static char *SccsId = "@(#)PEPSY:\tequat.c\t1.2\t92/03/27 11:55:13";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	equat(nset)
int	nset ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call equat(nset,*9999)                                        */
	/*    ***                                                               */
	/*    *** funktion : ausfuehren eines integrationsschrittes             */
	/*    ***              fuer set 'nset'                                  */
	/*    ***            anpassung der schrittweite an relativen fehler     */
	/*    ***            lokalisierung eines aufgetretenen crossings        */
	/*    ***            behandlung der anderen sets bei crossing           */
	/*    *** parameter: nset = nummer des zu integrierenden sets           */
	/*    ***                                                               */
	extern int	integ(), detect(), nchain(), tchain(), defill(), state();
	extern double	signum();
	int	tpoint, nsv, ndv, i ;
	int	ipr, icross, niflag, ncr, ns, nv ;
	double	x[2][3], tstep, rerr, tstepx ;
	double	tcross, tkoord, tstep1, help_TiMe, atdela, stdela ;
	/*                                                                      */
	/*    umspeichern von sv, dv und jflag                                  */
	/*    ================================                                  */
	nsv = intma[nset].sv_nr;
	ndv = intma[nset].dv_nr;
	for (i = 1 ; i <= nsv ; svlast[nset][i] = sv[nset][i], i++)
		;
	for (i = 1 ; i <= ndv ; dvlast[nset][i] = dv[nset][i], i++)
		;
	for (i = 1; i <= zncro; ++i) {
		iflagp[nset][i] = 0;
		jflagl[nset][i] = jflag[nset][i];
	};
	/*                                                                      */
	/*    berechnung des naechsten integrationspunktes                      */
	/*    ============================================                      */
	ipr = 6;
	equatlist[nset].last = TiMe;
	equatlist[nset].next = TiMe + equatlist[nset].step;
	for (i = 1; i <= 5; ++i) {
		if (i == 4) 
			continue;
		if (head[i].link  ==  -1) 
			continue;
		if (head[i].next + eps  >  equatlist[nset].next) 
			continue;
		equatlist[nset].next = head[i].next ;
		ipr = i;
	};
	/*                                                                      */
	if ( equatlist[nset].ahead  ==  0.0 ) 
		goto l_320;
	if (fabs(equatlist[nset].ahead - equatlist[nset].next) < eps) 
		goto l_315;
	if ( equatlist[nset].ahead  >  equatlist[nset].next ) 
		goto l_320;
	ipr = 8;
	equatlist[nset].next = equatlist[nset].ahead;
l_315:  
	equatlist[nset].ahead = 0.0;
	/*                                                                      */
l_320:  
	atdela = fabs(delay_flag[nset]);
	stdela = signum(delay_flag[nset]);
	delay_flag[nset] = 0.0;
	if (atdela == 0.0) 
		goto l_350;
	if ( atdela  >  equatlist[nset].next - eps ) 
		goto l_350;
	ipr = 9;
	equatlist[nset].next = atdela;
	/*                                                                      */
	/*    integration bei simulationsende                                   */
	/*    ===============================                                   */
l_350:  
	if (tend + eps  >  equatlist[nset].next) 
		goto l_400;
	equatlist[nset].next = tend;
	ipr = 10;
	/*                                                                      */
	/*    durchfuehrung der integration                                     */
	/*    =============================                                     */
l_400:  
	tstep = equatlist[nset].next - TiMe;
l_410:   
	switch (integ(nset, tstep, &rerr, 0)) {
	case FEHLER : 
		goto l_9999;
	};
	/*                                                                      */
	/*    fehler zu gross                                                   */
	/*    ===============                                                   */
	if (rerr <= intma[nset].rel_error) 
		goto l_600;
	ipr = 11;
	tstep = tstep / 2.;
	equatlist[nset].next = TiMe + tstep;
	equatlist[nset].step = tstep;
	if (tstep >= intma[nset].min_step) 
		goto l_410;
	fprintf(nunit2, "\n\n+++++ equat: TiMe=%12.4f schrittweite kleiner als min fuer set%3d\n",
	    TiMe, nset);
	goto l_9999;
	/*                                                                      */
	/*    fehler zu klein                                                   */
	/*    ===============                                                   */
l_600:  
	if (rerr > (intma[nset].rel_error / 10.)) 
		goto l_700;
	if (ipr != 6  &&  ipr != 11) 
		goto l_700;
	if (ipr ==  6) 
		equatlist[nset].step = tstep * 2.0;
	if (ipr == 11) 
		equatlist[nset].step = tstep * 1.5;
	equatlist[nset].step = MIN(equatlist[nset].step, intma[nset].max_step);
	/*                                                                      */
	/*    suchen von crossings                                              */
	/*    ====================                                              */
l_700:  
	icross = 0;
	niflag = 0;
	tstepx = tstep;
l_710:   
	switch (detect(nset)) {
	case AUSGANG2 : 
		goto l_1000;
	case FEHLER : 
		goto l_9999;
	};
	/*                                                                      */
	/*    zahl der gefundenen crossings bestimmen                           */
	/*    =======================================                           */
	niflag = 0;
	for (i = 1; i <= zncro; ++i) {
		if (iflag[nset][i] == 1) 
			niflag ++;
	};
	if (niflag == 0 && icross == 0) 
		goto l_1500;
	if (niflag > 0) 
		goto l_1300;
	/*                                                                      */
	/*    vorbereitung zur integration in der rechten haelfte               */
	/*    ===================================================               */
	tstepx = tstepx / 2.;
	tstep  = tstep + tstepx ;
	goto l_1100;
	/*                                                                      */
	/*    vorbereitung zur integration in der linken haelfte                */
	/*    ==================================================                */
l_1000:
	icross = 1;
	tstepx = tstepx / 2.;
	tstep  = tstep - tstepx ;
	/*                                                                      */
	/*    angezeigtes crossing nicht lokalisierbar                          */
	/*    ========================================                          */
l_1100:
	if (tstepx > eps) 
		goto l_1200;
	fprintf(nunit2, "\n\n+++++ equat : TiMe = %12.4f vorhandenes crossing nicht lokalisierbar ( cross-toleranz zu klein )\n",
	                  TiMe);
	for (i = 1; i <= zncro; ++i) {
		if (iflag[nset][i]  ==  2)
			fprintf(nunit2, "%32siflag(%2d,%2d) = 2\n", BLANKF, nset, i );
	};
	goto l_9999;
	/*                                                                      */
	/*    integration mit angepasster schrittweite                          */
	/*    ========================================                          */
l_1200:
	equatlist[nset].next = TiMe + tstep;
	switch (integ(nset, tstep, &rerr, 1)) {
	case FEHLER : 
		goto l_9999;
	};
	intsta[nset].find ++;
	goto l_710;
	/*                                                                      */
	/*    crossing lokalisiert                                              */
	/*    ====================                                              */
l_1300:
	tcross = equatlist[nset].next;
	ttest  = tcross;
	if ( icross  ==  1 ) 
		ipr = 7;
	/*                                                                      */
	/*    rueckwirkung des crossing auf die anderen sets                    */
	/*    ==============================================                    */
	tkoord = tcross;
	tpoint = head[6].link;
l_1410:
	if (tpoint < 0) 
		goto l_1500;
	if (tkoord  >=  equatlist[tpoint].next + eps) 
		goto l_1430;
	if (tkoord  <=  equatlist[tpoint].next - eps) 
		goto l_1450;
	goto l_1480;
	/*                                                                      */
	/*    look-ahead-vermerk setzen                                         */
	/*    =========================                                         */
l_1430:
	equatlist[tpoint].ahead = tkoord ;
	goto l_1480;
	/*                                                                      */
	/*    set bis crossing-zeit zurueckholen, korrektur der statistik       */
	/*    ===========================================================       */
l_1450:
	intsta[tpoint].size = intsta[tpoint].size - 
	    (equatlist[tpoint].next - tkoord) / (double)intsta[tpoint].count ;
	equatlist[tpoint].next = tkoord ;
	tstep1 = equatlist[tpoint].next - equatlist[tpoint].last;
	switch (nchain(6, tpoint)) {
	case FEHLER : 
		goto l_9999;
	};
	switch (integ(tpoint, tstep1, &rerr, 1)) {
	case FEHLER : 
		goto l_9999;
	};
	switch (tchain(6, tpoint)) {
	case FEHLER : 
		goto l_9999;
	};
	/*                                                                      */
	switch (detect(tpoint)) {
	case AUSGANG2 : 
		goto l_9999;
	case FEHLER : 
		goto l_9999;
	};
	for (ncr = 1; ncr <= zncro; ++ncr) {
		if (iflagp[tpoint][ncr]  ==  0) 
			continue;
		if (iflag [tpoint][ncr]  ==  1) 
			continue;
		intsta[tpoint].cross --;
		iflagp[tpoint][ncr] = 0;
		if ( iprint == 0  &&  jprint[19] <=  0  &&  jprint[20] <=  0 ) 
			continue;
		if ( iprint == 1  &&  jprint[19] == -1  &&  jprint[20] == -1 ) 
			continue;
		fprintf(nunit2, " equat :  TiMe=%12.4f  crossing zurueckgenommen%35sgeloeschtes flag :  iflag(%2d,%2d)\n",
		                  TiMe, BLANKF, tpoint, ncr);
	};
	/*                                                                      */
	if (idelay  ==  0) 
		goto l_1480;
	for (i = 1; i <= zndvar; ++i) {
		ns  = devar[i].del_set;
		nv  = devar[i].del_var;
		if (ns  !=  tpoint) 
			continue;
		if (nv  >=  0) 
			x[1][1] = sv[tpoint][ nv];
		if (nv  <   0) 
			x[1][1] = dv[tpoint][-nv];
		x[1][2] = tkoord;
		switch (defill(ns, nv, x, 1)) {
		case FEHLER : 
			goto l_9999;
		};
	};
	/*                                                                      */
	/*    zeitkette weiterverfolgen                                         */
	/*    =========================                                         */
l_1480:
	tpoint = equatlist[tpoint].link ;
	goto l_1410;
	/*                                                                      */
	/*    delay-variablen speichern                                         */
	/*    =========================                                         */
l_1500:
	if (idelay  ==  0) 
		goto l_1600;
	for (i = 1; i <= zndvar; ++i) {
		ns = devar[i].del_set;
		nv = devar[i].del_var;
		if (ns  !=  nset) 
			continue;
		if (nv  >=  0) 
			x[1][1] = sv[nset][ nv];
		if (nv  <   0) 
			x[1][1] = dv[nset][-nv];
		x[1][2] = equatlist[nset].next;
		switch (defill(nset, nv, x, 1)) {
		case FEHLER : 
			goto l_9999;
		};
	};
	/*                                                                      */
	/*    naechsten integrationszeitpunkt einketten                         */
	/*    =========================================                         */
l_1600: 
	switch (tchain(6, nset)) {
	case FEHLER : 
		goto l_9999;
	};
	/*                                                                      */
	/*    statistik                                                         */
	/*    =========                                                         */
	intsta[nset].count ++;
	intsta[nset].size = (intsta[nset].size * ((double)intsta[nset].count - 1.)
	     + tstep)  / (double)intsta[nset].count ;
	intsta[nset].cross = intsta[nset].cross + niflag;
	if ( intsta[nset].count  <=  intma[nset].limit ) 
		goto l_2000;
	fprintf(nunit2, "\n\n+++++ equat: TiMe=%12.4f zulaessige anzahl von integr.schr. erreicht\n",
	    TiMe);
	goto l_9999;
	/*                                                                      */
	/*    protokollausdruck                                                 */
	/*    =================                                                 */
l_2000:
	if (iprint == 0 && jprint[20] == 0 || jprint[20] == -1) 
		goto l_2200;
	fprintf(nunit2, "\n TiMe = %12.4e      nset = %2d     tstep = %12.4e", TiMe, nset, tstep);
	switch (ipr) {
	case 1: 
		goto l_2010;
	case 2: 
		goto l_2020;
	case 3: 
		goto l_2030;
	case 4: 
		goto l_2040;
	case 5: 
		goto l_2050;
	case 6: 
		goto l_2060;
	case 7: 
		goto l_2070;
	case 8: 
		goto l_2080;
	case 9: 
		goto l_2090;
	case 10:
		goto l_2100;
	case 11:
		goto l_2060;
	};
	/*                                                                      */
	fprintf(nunit2, "\n\n+++++ equat: TiMe=%12.4f fehler im adressverteiler  ipr=%3d\n",
	    TiMe, ipr);
	goto l_9999;
	/*                                                                      */
l_2010:
	fprintf(nunit2, "  event\n");
	goto l_2200;
l_2020:
	fprintf(nunit2, "  source-start\n");
	goto l_2200;
l_2030:
	fprintf(nunit2, "  tr-aktivierung\n");
	goto l_2200;
l_2040:
	fprintf(nunit2, "  konfidenzintervall\n");
	goto l_2200;
l_2050:
	fprintf(nunit2, "  monitoraufruf\n");
	goto l_2200;
l_2060:
	fprintf(nunit2, "  normale integration\n");
	goto l_2200;
l_2070:
	fprintf(nunit2, "  crossing\n");
	goto l_2200;
l_2080:
	fprintf(nunit2, "  look-ahead-vermerk\n");
	goto l_2200;
l_2090:
	fprintf(nunit2, "  event in delay-variablen\n");
	goto l_2200;
l_2100:
	fprintf(nunit2, "  simulationsende\n");
	goto l_2200;
	/*                                                                      */
	/*                                                                      */
l_2200:
	if (niflag == 0) 
		goto l_3000;
	for (ncr = 1; ncr <= zncro; ++ncr) {
		if (iflag[nset][ncr]  == 0) 
			continue;
		iflagp[nset][ncr] = 1;
		if (iprint == 0  &&     jprint[19] <= 0  &&  jprint[20] <=  0) 
			continue;
		if (iprint == 1  &&     jprint[19] == -1  &&  jprint[20] == -1) 
			continue;
		fprintf(nunit2, " equat :  TiMe=%12.4f  crossing lokalisiert%39sgesetztes flag :    iflag(%2d,%2d)\n",
		    tcross, BLANKF, nset, ncr);
	};
	/*                                                                      */
	/*    aufruf von state nach sprung einer delay-variablen                */
	/*    ==================================================                */
l_3000: 
	if ( stdela == -1.) 
		goto l_9000;
	if ( fabs( atdela - equatlist[nset].next )  >=  eps ) 
		goto l_9000;
	help_TiMe = TiMe;
	TiMe = equatlist[nset].next;
	equatlist[nset].last = equatlist[nset].next;
	switch (state(nset)) {
	case FEHLER : 
		goto l_9999;
	};
	TiMe = help_TiMe;
	equatlist[nset].last = TiMe;
	/*                                                                      */
	/*    crossings auffinden und protokollieren                            */
	/*    ======================================                            */
	switch (detect(nset)) {
	case AUSGANG2 : 
		goto l_9999;
	case FEHLER : 
		goto l_9999;
	};
	for (ncr = 1; ncr <= zncro; ++ncr) {
		if (iflag[nset][ncr] == 0  &&  iflagp[nset][ncr] == 0) 
			continue;
		if (iflag[nset][ncr] == 1  &&  iflagp[nset][ncr] == 1) 
			continue;
		if (iflag[nset][ncr] == 1) 
			ttest = equatlist[nset].next;
		if (iflag[nset][ncr] == 1) 
			intsta[nset].cross ++;
		if (iflag[nset][ncr] == 1) 
			iflagp[nset][ncr] = 1;
		if (iflag[nset][ncr] == 0) 
			iflagp[nset][ncr] = 0;
		if ( iprint == 0  &&  jprint[19] <=  0  &&  jprint[20] <=  0 ) 
			continue;
		if ( iprint == 1  &&  jprint[19] == -1  &&  jprint[20] == -1 ) 
			continue;
		if (iflag[nset][ncr]  ==  1)
			fprintf(nunit2, " equat :  TiMe=%12.4f  crossing lokalisiert%39sgesetztes flag :    iflag(%2d,%2d)\n",
			                 ttest, BLANKF, nset, ncr);
		if (iflag[nset][ncr]  ==  0)
			fprintf(nunit2, " equat :  TiMe=%12.4f  crossing zurueckgenommen%35sgeloeschtes flag :  iflag(%2d,%2d)\n",
			                 ttest, BLANKF, nset, ncr);
	};
	/*                                                                      */
	/*                                                                      */
	/*    delay-variable speichern                                          */
	/*    ========================                                          */
	if (idelay  ==  0) 
		goto l_9000;
	for (i = 1; i <= zndvar; ++i) {
		ns  = devar[i].del_set;
		nv  = devar[i].del_var;
		if (ns  !=  nset) 
			continue;
		if (nv  >=  0) 
			x[1][1] = sv[nset][ nv];
		if (nv  <   0) 
			x[1][1] = dv[nset][-nv];
		x[1][2] = equatlist[nset].next;
		switch (defill(ns, nv, x, 1)) {
		case FEHLER : 
			goto l_9999;
		};
	};
	/*                                                                      */
l_9000:
	return(NORMAL);
	/*                                                                      */
	/*                                                                      */
	/*    fehlerausgang                                                     */
	/*    =============                                                     */
l_9999:
	return(FEHLER);
}


