static char *SccsId = "@(#)PEPSY:\terlang.c\t1.2\t92/03/27 11:55:16";

/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/


#include <ctype.h>
#include <signal.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	erlang(rmean, k, rmin, rmax, irnum, random)
double	*random ;
int	irnum ;
double	rmax ;
double	rmin ;
int	k ;
double	rmean ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call erlang(rmean,k,rmin,rmax,irnum, *random,*9999)           */
	/*    ***                                                               */
	/*    *** funktion : erzeugen einer zufallszahl aus einer               */
	/*    ***            erlang-k-verteilung                                */
	/*    *** parameter: rmean   = mittelwert                               */
	/*    ***            k       = grad                                     */
	/*    ***            rmin    = untere intervallgrenze                   */
	/*    ***            rmax    = obere intervallgrenze                    */
	/*    ***            irnum   = nummer des zufallszahlengenerators       */
	/*    ***             *random  = rueckgabe: zufallszahl im angegebenen  */
	/*    ***                                 intervall                     */
	/*    ***                                                               */
	extern double	rnx();
	register int	i ;
	int count = 0;
	register double	alpha, r;

	/*                                                                      */
	/*    fehlerkontrolle                                                   */
	/*    ================                                                  */
	if (k >= 1) 
		goto l_100;
	fprintf(nunit2, "\n\n+++++ erlang: TiMe=%12.4f k= %2d kleiner 1\n", TiMe, k);
	return(FEHLER);
	/*                                                                      */
	/*    erzeugen einer erlang-verteilten zufallszahl                      */
	/*    ============================================                      */
l_100:  
	alpha =  ((double)k) / rmean;
l_110:  
	r = 1.0;
	for (i = 1 ; i <= k ; r = r *(1.0 - rnx(irnum)), i++)
		;
	if (r == 0.) 
		goto l_110;
	*random = -1.0 / alpha * log(r);
	/*                                                                      */
	/*    intervallkontrolle                                                */
	/*    ==================                                                */
	if ( *random < rmin ||  *random > rmax)  {
		count++;
		fprintf(nunit2, "erlang rejected, mean %g, min %g, max %g, value %g\n",
		    rmean, rmin, rmax, *random);
		if(count > 100)
			kill(getpid(),1);
		goto l_110;
	}
	return(NORMAL);
}


int	erlang2(rmean, k, rmin, rmax, irnum, random)
double	*random ;
int	irnum ;
double	rmax ;
double	rmin ;
int	k ;
double	rmean ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call erlang(rmean,k,rmin,rmax,irnum, *random,*9999)           */
	/*    ***                                                               */
	/*    *** funktion : erzeugen einer zufallszahl aus einer               */
	/*    ***            erlang-k-verteilung                                */
	/*    *** parameter: rmean   = mittelwert                               */
	/*    ***            k       = grad                                     */
	/*    ***            rmin    = untere intervallgrenze                   */
	/*    ***            rmax    = obere intervallgrenze                    */
	/*    ***            irnum   = nummer des zufallszahlengenerators       */
	/*    ***             *random  = rueckgabe: zufallszahl im angegebenen  */
	/*    ***                                 intervall                     */
	/*    ***                                                               */
	extern double	rnx();
	int	i ;
	int count = 0;
	double	alpha, r;

	/*                                                                      */
	/*    fehlerkontrolle                                                   */
	/*    ================                                                  */
	if (k >= 1) 
		goto l_100;
	fprintf(nunit2, "\n\n+++++ erlang: TiMe=%12.4f k= %2d kleiner 1\n", TiMe, k);
	return(FEHLER);
	/*                                                                      */
	/*    erzeugen einer erlang-verteilten zufallszahl                      */
	/*    ============================================                      */
l_100:  
	alpha =  ((double)k) ;
l_110:  
	r = 1.0;
	for (i = 1 ; i <= k ; r = r * rnx(irnum++), i++)
		;
	if (r == 0.) 
		goto l_110;
	*random = -rmean / alpha * log(r);
	/*                                                                      */
	/*    intervallkontrolle                                                */
	/*    ==================                                                */
	if ( *random < rmin ||  *random > rmax) {
		count++;
		fprintf(nunit2, "erlang rejected, mean %g, min %g, max %g, value %g\n",
		    rmean, rmin, rmax, *random);
		if(count > 100)
			kill(getpid(),1);
		goto l_110;
	}
	return(NORMAL);
}


