static char *SccsId = "@(#)PEPSY:\textpol.c\t1.2\t92/03/27 11:55:21";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	extpol(nset, tstep, rerr)
double	*rerr ;
double	tstep ;
int	nset ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call extpol(nset,tstep, *rerr,*9999)                          */
	/*    ***                                                               */
	/*    *** funktion : ausfuehrung eines schrittes der                    */
	/*    ***            numerischen integration mittels                    */
	/*    ***            eines extrapolationsverfahrens                     */
	/*    *** parameter: nset  = nummer des zu integrierenden sets          */
	/*    ***            tstep = anfangsschrittweite                        */
	/*    ***             *rerr  = rueckgabe: relativer integrationsfehler  */
	/*    ***            exit1 = fehlerausgang                              */
	/*    ***                                                               */
	extern int	state();
	int	r, sr, ndv, m ;
	int	j, l, i, k, ind, imax ;
	double	h[11], yl[101], y[101], dt[101][8];
	double	loc_TiMe, g, u, v ;
	double	ta, c, b1, b, err, svmax, rerrx ;
	/*                                                                      */
	double	bound = 1.e-25;
	/*                                                                      */
	if (jprint[20]  ==  2) 
		fprintf(nunit2, "\n\n TiMe =%12.4e      nset = %2d     tstep =%12.4e      integration mit extpol\n",
		    TiMe, nset, tstep);
	/*                                                                      */
	ndv = intma[nset].dv_nr;
	loc_TiMe = TiMe;
	m = 1;
	r = 2;
	sr = 3;
	/*                                                                      */
	/*    integrationsschritt                                               */
	/*    ===================                                               */
	for (j = 1; j <= 6; ++j) {
		*rerr = 0.0;
		l = j - 1;
		m = 2 * m;
		g = tstep / (double)m;
		h[j] = g * 2.;
		/*                                                                      */
		for (i = 1; i <= ndv; ++i) {
			yl[i] = svlast[nset][i];
			sv[nset][i] = svlast[nset][i] + g * dvlast[nset][i];
		};
		m = m - 1;
		for (k = 1; k <= m; ++k) {
			TiMe = loc_TiMe + g * (double)k;
			switch (state(nset)) {
			case FEHLER : 
				goto l_9999;
			};
			for (i = 1; i <= ndv; ++i) {
				u = yl[i] + h[j] * dv[nset][i];
				yl[i] = sv[nset][i];
				sv[nset][i] = u;
			};
		};
		TiMe = loc_TiMe + tstep;
		switch (state(nset)) {
		case FEHLER : 
			goto l_9999;
		};
		/*                                                                      */
		for (i = 1; i <= ndv; ++i) {
			v = dt[i][1];
			ta = (sv[nset][i] + yl[i] + g * dv[nset][i]) / 2.;
			c = ta;
			dt[i][1] = ta;
			if (j == 1) 
				goto l_100;
			for (k = 1; k <= l; ++k) {
				ind = j - k;
				b1 = pow((h[ind] / h[j]), 2.) * v ;
				b = b1 - c;
				u = v;
				if (fabs(b) == 0.0) 
					goto l_60;
				b = (c - v) / b;
				u = c * b;
				c = b1 * b;
l_60:  
				v = dt[i][k+1] ;
				dt[i][k+1] = u ;
				ta = ta + u;
			};
l_100:  
			sv[nset][i] = ta;
			if (j == 5) 
				y[i] = ta;
		};
		m = r;
		r = sr;
		sr = 2 * m;
	};
	TiMe = loc_TiMe + tstep;
	switch (state(nset)) {
	case FEHLER : 
		goto l_9999;
	};
	/*                                                                      */
	/*    fehlerabschaetzung                                                */
	/*    ==================                                                */
	for (i = 1; i <= ndv; ++i) {
		err   = y[i] - sv[nset][i];
		svmax = MAX(fabs(sv[nset][i]), fabs(svlast[nset][i]));
		if (svmax  >=  bound) 
			rerrx = fabs(err) / svmax;
		if (svmax  <   bound) 
			rerrx = fabs(err) / bound;
		/*                                                                      */
		if (jprint[20]  ==  2) 
			fprintf(nunit2, "   sv(%2d,%3d)=%16.8e    dv(%2d,%3d)=%16.8e      err=%16.8e    rerrx=%16.8e\n",
			    nset, i, sv[nset][i], nset, i, dv[nset][i], err, rerrx);
		/*                                                                      */
		if (rerrx  <   *rerr) 
			continue;
		*rerr = rerrx;
		imax = i;
	};
	/*                                                                      */
	if (jprint[20]  ==  2) 
		fprintf(nunit2, "%50s groesster rel. fehler fuer sv(%2d,%3d):  rerr =%16.8e\n",
		    BLANKF, nset, imax,  *rerr);
	/*                                                                      */
	return(NORMAL);
l_9999:
	return(FEHLER);
}


