static char *SccsId = "@(#)PEPSY:\tfind.c\t1.3\t92/03/27 11:55:29";
#include <stdio.h>
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	find(ncar, found)
int	ncar;
short	*found;
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	/*     ***  */
	/*     *** CALL FIND(NCAR,FOUND,*9999) */
	/*     ***  */
	/*     *** PURPOSE : SELECT A TRANSPORT REQUEST FOR A TAXI OR */
	/*     ***           TRANSPORTER ON COMPLETION OF A REQUEST */
	/*     *** PARAMETERS: NCAR  = INDEX OF TAXI OR TRANSPORTER */
	/*     ***             FOUND = BOOLEAN PARAMETER WHICH RETURNS */
	/*     ***                      TRUE  : NEW REQUEST FOUND */
	/*     ***                      FALSE : NO REQUEST FOUND */
	/*     ***             *9999 = ERROR EXIT */
	/*     ***  */
	/*     *** STRATEGIES: STORED IN CARMA(NCAR,9)) */
	/*     ***             = 1: OLD: OLDEST REQUEST */
	/*     ***             = 2: PRI:  REQUEST WITH HIGHEST PRIORITY */
	/*     ***             = 3: SDS:  SHORTEST DISTANCE */
	/*     ***             = 4: LDS:  LONGEST DISTANCE  */
	/*     ***             = 5: TOP:  REQUEST OF CURRENT TERMINAL */
	/*     ***             = 6: BEN:  STRATEGY SUPPLIED BY USER */
	/*     ***  */
	/* */

	int	nstrat;
	extern int	next_int();
	extern int	finold(), finpri(), finsds(), finlds(), fintop(), finben();

#ifdef DEBUG
dprint(TRANSACTION, "find: ncar %d\n", ncar); /* */
#endif

	/*     INITIALIZE */
	/*     ========== */
	*found = FALSE;
	/* */
	/*     STRATEGY FOR TAXI/TRANSPORTER */
	/*     ============================= */
	nstrat = next_int( carma[ncar][9] );
#ifdef DEBUG
dprint(TRANSACTION, "find: nstrat %d\n", nstrat); /* */
#endif
	/* */
	/*     CALL STRATEGY  */
	/*     =============  */
	switch (nstrat) {
	case 1: 
		goto l_100;
	case 2: 
		goto l_200;
	case 3: 
		goto l_300;
	case 4: 
		goto l_400;
	case 5: 
		goto l_500;
	case 6: 
		goto l_600;
	};

	fprintf (nunit2, "\n\n+++++ find  :  t=%12.4f fehler im adressverteiler\n                               strategie nicht vorhanden\n",
	     TiMe);
	return (FEHLER);
	/* */
	/*     OLDEST */
	/*     ====== */
l_100: 
#ifdef DEBUG
dprint(LABEL, "find: label l_100\n"); /* */
#endif
	finold(ncar, found);
	goto l_1000;
	/* */
	/*     PRIORITY */
	/*     ======== */
l_200: 
#ifdef DEBUG
dprint(LABEL, "find: label l_200\n"); /* */
#endif
	finpri(ncar, found);
	goto l_1000;
	/* */
	/*     SHORTEST DISTANCE */
	/*     ================= */
l_300: 
#ifdef DEBUG
dprint(LABEL, "find: label l_300\n"); /* */
#endif
	finsds(ncar, found);
	goto l_1000;
	/* */
	/*     LONGEST DISTANCE */
	/*     ================ */
l_400: 
#ifdef DEBUG
dprint(LABEL, "find: label l_400\n"); /* */
#endif
	finlds(ncar, found);
	goto l_1000;
	/* */
	/*     CURRENT TERMINAL */
	/*     ================ */
l_500: 
#ifdef DEBUG
dprint(LABEL, "find: label l_500\n"); /* */
#endif
	fintop(ncar, found);
	goto l_1000;
	/* */
	/*     STRATEGY SUPPLIED BY USER */
	/*     ========================= */
l_600: 
#ifdef DEBUG
dprint(LABEL, "find: label l_600\n"); /* */
#endif
	finben(ncar, found);
	/* */
l_1000: 
	return(NORMAL);
	/* */
}


