static char *SccsId = "@(#)PEPSY:\tfinlds.c\t1.2\t92/03/27 11:55:31";
#include <stdio.h>
#include <fcntl.h>
#include "xxalloc.h"
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	finlds(ncar, found)
int	ncar;
short	*found;
{
	/*     ***  */
	/*     *** CALL FINLDS(NCAR,FOUND) */
	/*     ***  */
	/*     *** PURPOSE : FIND THE NEXT TRANSPORT REQUESTS FOR A TAXI OR */
	/*     ***           TRANSPORTER ACCORDING TO THE STRATEGY WHICH */
	/*     ***           SELECTS THE REQUEST WITH THE LARGEST DISTANCE */
	/*     *** PARAMETERS: NCAR =  INDEX OF TAXI OR TRANSPORTER */
	/*     ***             FOUND = RETURNS */
	/*     ***                     TRUE: REQUEST FOUND  */
	/*     ***                     FALSE: NO REQUEST FOUND */
	/* */
	/* */

	int	art, gesanf, prior, itargl, line, nr, itargu, last, nterm, i;
	short	beginn, logbeg, trace;
	char	ctype[4][14];
	extern int	next_int(), sort();


	strcpy(ctype[1], "  bus        ");
	strcpy(ctype[2], "  taxi       ");
	strcpy(ctype[3], "  transporter");
	/* */
	/*     INITIALIZE */
	/*     ========== */
	gesanf = next_int( carma[ncar][4] );
	art    = txi[row_txact];
	beginn = TRUE;
	logbeg = TRUE;
	trace  = ((iprint == 1 || jprint[23] > 0) && jprint[23] != -1);
	if (logptr[1] == -1  ||  gesanf == next_int(carma[ncar][3])) 
		goto l_2000;
	/* */
	/*     SORT STATIONS ACCORDING TO DISTANCE */
	/*     =================================== */
	nterm   = next_int( carma[ncar][6] );
	for (i = 1; i <= ansta; i++) {
		dist[i][1] = totlen[nterm][i];
		dist[i][2] = (double)i;
	}
	/* */
	sort(dist, ansta);
	/* */
	/*     INVESTIGATE TRANSPORT REQUESTS FOR DESTINATION */
	/*     ============================================== */
	i     = ansta + 1;
l_900:   
	i     = i - 1;
	logbeg = TRUE;
	if (i <= 0) 
		goto l_2000;
	itargl = next_int(dist[i][2]);
	/* */
	/*     FIND FIRST TRANSPORT REQUEST FOR THIS TERMINAL */
	/*     ============================================== */
	line   = logptr[1];
l_950:   
	if (line == -1) 
		goto l_900;
	/* */
	nr     = next_int(logma[line][3]);
	anford = next_int(txadd[nr][4]);
	if (anford == 0)  
		anford = 1;
	/* */
	/*     IS TRANSPORT REQUEST SUITABLE */
	/*     ============================= */
	if (next_int(logma[line][1]) != itargl || next_int(txadd[nr][3]) != art       || gesanf + anford > next_int(carma[ncar][3])) {
		prior  = line;
		logbeg = TRUE;
		line   = next_int(logma[line][5]);
		goto l_950;
	}
	/* */
	/*     DETERMINE DESTINATION OF FIRST TRANSPORT REQUEST */
	/*     ================================================ */
	itargu = next_int( logma[line][2] );
	/* */
	/*     RECORD REQUIREMENT FOR TAXI/TRANSPORTER */
	/*     ======================================= */
l_1000:  
	if (beginn) {
		carma[ncar][10] = (double)line;
		beginn = TRUE;
		if (trace) {
			if (itargu != -1) {
				fprintf (nunit2, "finlds:  t=%12.4f%13s%4d finds request with starting point%5d\n                                          and destination%5d : tr%6d,%4d\n",
				     TiMe, ctype[art], ncar, itargl, itargu, tx_system[nr].nr, tx_system[nr].dup);
			} else {
				fprintf (nunit2, "finlds:  t=%12.4f%13s%4d finds request with starting point%5d\n                                          and unknown destination : tr%6d,%4d\n",
				     TiMe, ctype[art], ncar, itargl, tx_system[nr].nr, tx_system[nr].dup);
			}
		}
	} else {
		logma[last][5] = (double)line;
		if (trace) 
			fprintf (nunit2, "                                                            and tr%6d,%4d\n", tx_system[nr].nr,
			     tx_system[nr].dup);
	}
	gesanf = gesanf + anford;
	last   = line ;
	*found  = TRUE;
	/* */
	/*     REMOVE REQUIREMENT FROM REQUIREMENT LIST */
	/*     ======================================== */
	if (line == logptr[1]) {
		logptr[1]      = next_int(logma[line][5]);
		logma[line][5]  = -1. ;
		logbeg         = TRUE;
	} else {
		logma[prior][5] = logma[line][5];
		logma[line][5]  = -1.;
	}
	if (line == logptr[2])  
		logptr[2] = prior;
	if (logptr[1] == -1)    
		logptr[2] = -1;
	if (logbeg) {
		line  = logptr[1];
	} else {
		line  = next_int(logma[prior][5]);
	}
	/* */
	if (itargu == -1) 
		goto l_2000;
	/* */
	/*     IS TAXI/TRANSPORTER FULL? */
	/*     ========================= */
	if (gesanf == next_int(carma[ncar][3])) 
		goto l_2000;
	/* */
	/*     ARE FURTHER TRANSPORT REQUESTS RECORDED? */
	/*     ======================================== */
l_1100:  
	if (line == -1) 
		goto l_2000;
	/* */
	nr     = next_int(logma[line][3]);
	anford = next_int(txadd[nr][4]);
	if (anford == 0)  
		anford = 1;
	/* */
	/*     DOES TRANSPORT REQUEST SATISFY THE REQUIREMENTS */
	/*     =============================================== */
	if (next_int(logma[line][1]) != itargl  || 
	    next_int(logma[line][2]) != itargu  || 
	    next_int(txadd[nr][3])   != art     || 
	    gesanf + anford > next_int(carma[ncar][3])) {
		prior  = line;
		logbeg = FALSE;
		line   = next_int(logma[line][5]);
		goto l_1100;
	}
	/* */
	goto l_1000;
	/* */
	/*     RECORD THE STARTING POINT AND DESTINATION OF THE TAXI/TRANSPORTER */
	/*     ================================================================= */
l_2000:  
	if (*found) {
		tarma[ncar][1] = (double)itargl;
		tarma[ncar][2] = (double)itargu;
	} else {
		if (trace) 
			fprintf (nunit2, "finlds:  t=%12.4f%13s%4d does not find a transport request\n", TiMe, ctype[art],
			     ncar);
	}
	/* */
	return(NORMAL);
	/* */
}


