static char *SccsId = "@(#)PEPSY:\tfinold.c\t1.3\t92/03/27 11:55:33";
#include <ctype.h>
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	finold(ncar, found)
int	ncar;
short	*found;
{
	/*     ***  */
	/*     *** CALL FINOLD(NCAR,FOUND) */
	/*     ***  */
	/*     *** PURPOSE : FIND THE NEXT TRANSPORT REQUESTS FOR A TAXI OR */
	/*     ***           TRANSPORTER ACCORDING TO THE STRATEGY WHICH */
	/*     ***           SELECTS THE OLDEST REQUEST */
	/*     *** PARAMETERS: NCAR  = INDEX OF TAXI OR TRANSPORTER */
	/*     ***             FOUND = RETURNS */
	/*     ***                     TRUE  : REQUEST FOUND */
	/*     ***                     FALSE : NO REQUEST FOUND */
	/*     ***  */
	/* */
	/* */

	int	art, gesanf, prior, itargl, itargu, last, line, nr;
	short	beginn, logbeg;
	char	ctype[4][14];
	extern int	next_int();


	strcpy(ctype[1], "  bus        ");
	strcpy(ctype[2], "  taxi       ");
	strcpy(ctype[3], "  transporter");
	/* */


	/*     INITIALIZE */
	/*     ========== */
	gesanf = next_int(carma[ncar][4]);
	art    = txi[row_txact];
	beginn = TRUE;
	logbeg = TRUE;
	if (logptr[1] == -1) {
#ifdef DEBUG
dprint(TRANSACTION, "finold: logptr[1] == -1\n"); /* */
#endif
		goto l_2000;
	}
	itargl  = next_int(logma[logptr[1]][1]);
	itargu  = next_int(logma[logptr[1]][2]);
	/* */
	/*     FIND OLDEST REQUEST AND REMOVE FROM LIST OF REQUESTS */
	/*     ==================================================== */
l_1000: 
#ifdef DEBUG
dprint(LABEL, "finold: label l_1000\n"); /* */
#endif
	if (logbeg) {
		line  = logptr[1];
	} else {
		line  = next_int(logma[prior][5]);
	}
	/* */
	/*     ARE THERE STILL REQUESTS RECORDED? */
	/*     ============================ */
	if (line == -1) 
		goto l_2000;
	/* */
	/*     IS THE TAXI/TRANSPORTER FULL? */
	/*     ============================= */
	if (gesanf == next_int(carma[ncar][3])) 
		goto l_2000;
	/* */
	nr     = next_int(logma[line][3]);
	anford = next_int(txadd[nr][4]);
	if (anford == 0)  
		anford = 1;
	/* */
	/*     IS THE TRANSPORT REQUEST SUITABLE? */
	/*     ================================== */
	if (next_int(logma[line][1]) != itargl || 
	    next_int(logma[line][2]) != itargu || 
	    next_int(txadd[nr][3])   != art    || 
	    gesanf + anford > next_int(carma[ncar][3])) {
		prior  = line;
		logbeg = FALSE;
		goto l_1000;
	}
	/* */
	/*     RECORD TRANSPORT REQUEST AT TAXI/TRANSPORTER */
	/*     ============================================ */
	if (beginn) {
		carma[ncar][10] = (double)line;
		beginn = FALSE;
		if ((iprint == 1 || jprint[23] > 0) && jprint[23] != -1) {
			if (itargu != -1) {
				fprintf (nunit2, "finold:  t=%12.4f%13s%4d finds request with starting point%5d\n                                          and destination%5d : tr%6d,%4d\n",
				     TiMe, ctype[art], ncar, itargl, itargu, tx_system[nr].nr, tx_system[nr].dup);
			} else {
				fprintf (nunit2, "finold:  t=%12.4f%13s%4d finds request with starting point%5d\n                                          and unknown destination : tr%6d,%4d\n",
				     TiMe, ctype[art], ncar, itargl, tx_system[nr].nr, tx_system[nr].dup);
			}
		}
	} else {
		logma[last][5] = (double)line;
		if ((iprint == 1 || jprint[23] > 0) && jprint[23] != -1) {
			fprintf (nunit2, "                                                            and tr%6d,%4d\n", tx_system[nr].nr,
			     tx_system[nr].dup);
		}
	}
	gesanf = gesanf + anford;
	last   = line ;
	*found  = TRUE;
	/* */
	/*     REMOVE TRANSPORT REQUEST FROM LIST */
	/*     ================================== */
	if (line == logptr[1]) {
		logptr[1]      = next_int(logma[line][5]);
		logma[line][5]  = -1.0;
	} else {
		logma[prior][5] = logma[line][5];
		logma[line][5]  = -1.0;
	}
	if (line == logptr[2])  
		logptr[2] = prior;
	if (logptr[1] == -1)    
		logptr[2] = -1;
	/* */
	if (itargu != -1) 
		goto l_1000;

	/* */
	/*     RECORD THE STARTING POINT AND DESTINATION OF THE TAXI/TRANSPORTER */
	/*     ================================================================= */
l_2000: 
#ifdef DEBUG
dprint(LABEL, "finold: label l_2000\n"); /* */
#endif
	if (*found) {
		tarma[ncar][1] = (double)itargl;
		tarma[ncar][2] = (double)itargu;
#ifdef DEBUG
dprint(TRANSACTION, " itargl %d , itargu %d \n", itargl, itargu); /* */
#endif
	} else {
		if ((iprint == 1 || jprint[23] > 0) && jprint[23] != -1) {
			fprintf (nunit2, "finold:  t=%12.4f%13s%4d does not find a transport request\n", TiMe, ctype[art],
			     ncar);
		}
	}
	/* */
	return(NORMAL);
	/* */
}


