static char *SccsId = "@(#)PEPSY:\tfinpri.c\t1.2\t92/03/27 11:55:36";
#include <stdio.h>
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	finpri(ncar, found)
int	ncar;
short	*found;
{
	/*     ***  */
	/*     *** CALL FINPRI(NCAR,FOUND) */
	/*     ***  */
	/*     *** PURPOSE : SELECT THE REQUIREMENT FOR A TAXI OR TRANSPORTER */
	/*     ***           WITH THE HIGHEST PRIORITY OR THE OLDEST REQUIREMENT */
	/*     *** PARAMETERS: NCAR  = INDEX OF TAXI OR TRANSPORTER */
	/*     ***             FOUND = INDICATOR WHETHER SEARCH WAS SUCCESSFUL  */
	/*     ***                     TRUE  : REQUEST FOUND */
	/*     ***                     FALSE : NO REQUEST FOUND */
	/*     ***  */
	/* */
	/* */

	int	art, gesanf, prior, last, linpri, line, itargl, itargu, nr, linold;
	short	logbeg, beginn;
	char	ctype[4][14];
	float	pri, oldpri;
	extern int	finold(), next_int();


	strcpy(ctype[1], "  bus        ");
	strcpy(ctype[2], "  taxi       ");
	strcpy(ctype[3], "  transporter");
	/* */
	/*     INITIALIZE */
	/*     ========== */
	gesanf = next_int(carma[ncar][4]);
	art    = txi[row_txact];
	beginn = TRUE;
	logbeg = TRUE;
	if (logptr[1] == -1) 
		goto l_2000;
	/* */
	/*     SEARCH FOR THE REQUIREMENT WITH THE HIGHEST PRIORITY */
	/*     ==================================================== */
	pri    = 0.0;
	linpri = 0;
	line   = logptr[1];
l_500:   
	if (tx_system[next_int(logma[line][3])].priority > pri) {
		pri    = tx_system[next_int(logma[line][3])].priority;
		linpri = line;
	}
	if (logma[line][5] > 0) {
		line   = next_int(logma[line][5]);
		goto l_500;
	}
	/* */
	/*     PROCESS REQUIREMENT WITH INDEX LINPRI */
	/*     ===================================== */
l_600:   
	if (linpri == 0) 
		goto l_3000;
	itargl  = next_int(logma[linpri][1]);
	itargu  = next_int(logma[linpri][2]);
	nr      = next_int(logma[linpri][3]);
	anford  = next_int(txadd[nr][4]);
	if (anford == 0)  
		anford = 1;
	if (anford == next_int(carma[ncar][3])) 
		goto l_900;
	/* */
	/*     REQUIREMENT CANNOT BE PROCESSED:   */
	/*     SELECT NEXT REQUIREMENT WITH THE SAME PRIORITY */
	/*     ============================================== */
	linold = linpri;
	linpri = 0;
	line   = next_int(logma[linold][5]);
l_700: 
	if (line < 0) 
		goto l_800;
	if (tx_system[next_int(logma[line][3])].priority == pri) {
		linpri = line;
		goto l_600;
	}
	line   = next_int(logma[line][5]);
	goto l_700;
	/* */
	/*     IF THERE IS NO REQUIREMENT WITH THE SAME PRIORITY */
	/*     SELECT A REQUIREMENT WITH A LOWER PRIORITY */
	/*     ================================================= */
l_800:   
	line   = logptr[1];
	oldpri = pri;
	pri    = 0.0;
	linpri = 0;
l_850: 
	if (tx_system[next_int(logma[line][3])].priority > pri && 
	    tx_system[next_int(logma[line][3])].priority < oldpri) {
		pri    = tx_system[next_int(logma[line][3])].priority;
		linpri = line;
	}
	if (logma[line][5] > 0) {
		line   = next_int(logma[line][5]);
		goto l_850;
	}
	goto l_600;
	/* */
	/*     REQUIREMENT CAN BE SATISFIED: REMOVE IT FROM LIST */
	/*     ================================================= */
l_900:   
	carma[ncar][10] = linpri;
	gesanf = gesanf + anford;
	if (linpri == logptr[1]) 
		goto l_960;
	prior  = logptr[1];
l_920:   
	if (next_int(logma[prior][5]) == linpri) 
		goto l_940;
	prior  = next_int(logma[prior][5]);
	goto l_920;
l_940:   
	logma[prior][5]  = logma[linpri][5];
	if (logma[prior][5] < 0)  
		logptr[2]    = prior;
	logma[linpri][5] = -1.0;
	goto l_1000;
l_960:   
	logptr[1]       = next_int(logma[linpri][5]);
	logma[linpri][5] = -1.0;
	/* */
	/*     SELECT THE NEXT REQUIREMENT AND REMOVE IT FROM REQUIREMENT LIST  */
	/*     ===============================================================  */
l_1000:  
	if (logbeg) {
		line  = logptr[1];
	} else {
		line  = next_int(logma[prior][5]);
	}
	/* */
	/*     ARE THERE STILL OUTSTANDING REQUESTS */
	/*     ==================================== */
	if (line == -1) 
		goto l_2000;
	/* */
	/*     IS THE TAXI/TRANSPORTER FULL? */
	/*     ============================= */
	if (gesanf == next_int(carma[ncar][3])) 
		goto l_2000;
	/* */
	nr     = next_int(logma[line][3]);
	anford = next_int(txadd[nr][4]);
	if (anford == 0)  
		anford = 1;
	/* */
	/*     IS THE TRANSPORT REQUEST SUITABLE? */
	/*     ================================== */
	if (next_int(logma[line][1]) != itargl || 
	    next_int(logma[line][2]) != itargu || 
	    next_int(txadd[nr][3])   != art    || 
	    gesanf + anford > next_int(carma[ncar][3])) {
		prior  = line;
		logbeg = FALSE;
		goto l_1000;
	}
	/* */
	/*     RECORD REQUIREMENT FOR TAXI/TRANSPORTER */
	/*     ======================================= */
	if (beginn) {
		carma[ncar][10] = (double)line;
		beginn = FALSE;
		if ((iprint == 1 || jprint[23] > 0) && jprint[23] != -1) {
			if (itargu != -1) {
				fprintf (nunit2, "finpri:  t=%12.4f%13s%4d find request with starting point%5d\n                                          and destination%5d : tr%6d,%4d\n",
				     TiMe, ctype[art], ncar, itargl, itargu, tx_system[nr].nr, tx_system[nr].dup);
			} else {
				fprintf (nunit2, "finpri:  t=%12.4f%13s%4d finds request with starting point%5d\n                                          and unknown destination: tr%6d,%4d\n",
				     TiMe, ctype[art], ncar, itargl, tx_system[nr].nr, tx_system[nr].dup);
			}
		}
	} else {
		logma[last][5] = (double)line;
		if ((iprint == 1 || jprint[23] > 0) && jprint[23] != -1) {
			fprintf (nunit2, "                                                            and tr%6d,%4d\n", tx_system[nr].nr,
			     tx_system[nr].dup);
		}
	}
	gesanf         = gesanf + anford;
	last           = line;
	*found          = TRUE;
	/* */
	/*     REMOVE REQUIREMENT FROM REQUIREMENT LIST */
	/*     ======================================== */
	if (line == logptr[1]) {
		logptr[1]      = next_int(logma[line][5]);
		logma[line][5]  = -1.0;
	} else {
		logma[prior][5] = logma[line][5];
		logma[line][5]  = -1.0;
	}
	if (line == logptr[2])  
		logptr[2] = prior;
	if (logptr[1] == -1)    
		logptr[2] = -1;
	/* */
	if (itargu != -1) 
		goto l_1000;
	/* */
	/*     RECORD THE STARTING POINT AND DESTINATION OF THE TAXI/TRANSPORTER */
	/*     ================================================================= */
l_2000:  
	if (*found) {
		tarma[ncar][1] = (double)itargl;
		tarma[ncar][2] = (double)itargu;
	} else {
		if ((iprint == 1 || jprint[23] > 0) && jprint[23] != -1) {
			fprintf (nunit2, "finpri:  t=%12.4f%13s%4d does not find a transport request\n", TiMe, ctype[art],
			     ncar);
		}
	}
	/* */
	return(NORMAL);
	/* */
	/*     NO REQUIREMENTS PRESENT: SEARCH FOR THE OLDEST TRANSPORT */
	/*     ======================================================== */
l_3000:  
	if ((iprint == 1 || jprint[23] > 0) && jprint[23] != -1)  
		fprintf (nunit2, "finpri: there are no requirements with priotities > 0 : call finold \n");
	finold(ncar, &found);
	return(NORMAL);
	/* */
}


