static char *SccsId = "@(#)PEPSY:\tfinsds.c\t1.2\t92/03/27 11:55:38";
#include <stdio.h>
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	finsds(ncar, found)
int	ncar;
short	*found;
{
	/*     ***  */
	/*     *** CALL FINSDS(NCAR,FOUND) */
	/*     ***  */
	/*     *** PURPOSE : SELECT TRANSACTIONS FOR A TAXI OR TRANSPORTER */
	/*     ***           ACCORDING TO THE STRATEGY WHICH SELECTS THE REQUEST */
	/*     ***           WITH THE SHORTEST DISTANCE */
	/*     *** PARAMETERS: NCAR  =  INDEX OF THE TAXI OR TRANSPORTER */
	/*     ***             FOUND =  RETURNS */
	/*     ***                      TRUE  : REQUEST FOUND */
	/*     ***                      FALSE : NO REQUEST FOUND */
	/*     ***  */
	/* */

	int	art, gesanf, prior, nterm, i;
	short	beginn, logbeg;
	char	ctype[4][14];
	extern int	next_int(), sort();
	int	itargl, line, nr, itargu, last;


	strcpy(ctype[1], "  bus        ");
	strcpy(ctype[2], "  taxi       ");
	strcpy(ctype[3], "  transporter");
	/* */
	/*     INITIALIZE */
	/*     ========== */
	gesanf = next_int(carma[ncar][4]);
	art    = txi[row_txact];
	beginn = TRUE;
	logbeg = TRUE;
	if (logptr[1] == -1 || gesanf == next_int(carma[ncar][3])) 
		goto l_2000;
	/* */
	/*     SORT TERMINALS ACCORDING TO DISTANCE */
	/*     ==================================== */
	nterm   = next_int(carma[ncar][6]);
	for ( i = 1 ; i <=  ansta; i++) {
		dist[i][1] = totlen[nterm][i];
		dist[i][2] = (double)i;
	}
	/* */
	sort(dist, ansta);
	/* */
	/*     EXAMINE REQUESTS FOR DESTINATIONS  */
	/*     =================================  */
	i     = 0;
l_900: 
	i     = i + 1;
	logbeg = TRUE;
	if (i > ansta) 
		goto l_2000;
	itargl = next_int(dist[i][2]);
	/* */
	/*     SEARCH FOR FIRST REQUEST FOR THE TERMINAL */
	/*     ========================================= */
	line   = logptr[1];
l_950: 
	if (line == -1) 
		goto l_900;
	/* */
	nr     = next_int(logma[line][3]);
	anford = next_int(txadd[nr][4]);
	if (anford == 0)  
		anford = 1;
	/* */
	/*     IS THE TRANSPORT REQUEST SUITABLE? */
	/*     ================================== */
	if (next_int(logma[line][1]) != itargl   || 
	    next_int(txadd[nr][3])   != art      || 
	    gesanf + anford > next_int(carma[ncar][3])) {
		prior  = line;
		logbeg = FALSE;
		line   = next_int(logma[line][5]);
		goto l_950;
	}
	/* */
	/*     DETERMINE THE DESTINATION OF THE FIRST TRANSPORT REQUEST */
	/*     ======================================================== */
	itargu = next_int(logma[line][2]);
	/* */
	/*     RECORD TRANSPORT REQUEST AT TAXI/TRANSPORTER */
	/*     ============================================ */
l_1000: 
	if (beginn) {
		carma[ncar][10] = (double)line;
		beginn = FALSE;
		if ((iprint == 1 || jprint[23] > 0) && jprint[23] != -1) {
			if (itargu != -1) {
				fprintf (nunit2, "finsds:  t=%12.4f%13s%4d finds request with starting point%5d\n                                          and destination%5d : tr%6d,%4d\n",
				     TiMe, ctype[art], ncar, itargl, itargu, tx_system[nr].nr, tx_system[nr].dup);
			} else {
				fprintf (nunit2, "finsds:  t=%12.4f%13s%4d finds request with starting point%5d\n                                          and unknowm destination : tr%6d,%4d\n",
				     TiMe, ctype[art], ncar, itargl, tx_system[nr].nr, tx_system[nr].dup);
			}
		}
	} else {
		logma[last][5] = (double)line;
		if ((iprint == 1 || jprint[23] > 0) && jprint[23] != -1) {
			fprintf (nunit2, "                                                            and tr%6d,%4d\n", tx_system[nr].nr,
			     tx_system[nr].dup);
		}
	}
	gesanf         = gesanf + anford;
	last           = line;
	*found          = TRUE;
	/* */
	/*     REMOVE TRANSPORT REQUEST FROM THE LIST OF REQUESTS */
	/*     ================================================== */
	if (line == logptr[1]) {
		logptr[1]      = next_int(logma[line][5]);
		logma[line][5]  = -1.0;
		logbeg         = TRUE;
	} else {
		logma[prior][5] = logma[line][5];
		logma[line][5]  = -1.0;
	}
	if (line == logptr[2])  
		logptr[2] = prior;
	if (logptr[1] == -1)    
		logptr[2] = -1;
	if (logbeg) {
		line  = logptr[1];
	} else {
		line  = next_int(logma[prior][5]);
	}
	/* */
	if (itargu == -1) 
		goto l_2000;
	/* */
	/*     IS TAXI/TRANPORTER FULL? */
	/*     ======================== */
	if (gesanf == next_int(carma[ncar][3])) 
		goto l_2000;
	/* */
	/*     ARE FURTHER TRANSPORT REQUESTS RECORDED? */
	/*     ======================================== */
l_1100: 
	if (line == -1) 
		goto l_2000;
	/* */
	nr     = next_int(logma[line][3]);
	anford = next_int(txadd[nr][3]);
	if (anford == 0)  
		anford = 1;
	/* */
	/*     DOES THE TRANSPORT REQUEST SATISFY THE REQUIREMENTS? */
	/*     ==================================================== */
	if (next_int(logma[line][1]) != itargl || 
	    next_int(logma[line][2]) != itargu || 
	    next_int(txadd[nr][3])  != art    || 
	    gesanf + anford > next_int(carma[ncar][3])) {
		prior  = line;
		logbeg = FALSE;
		line   = next_int(logma[line][5]);
		goto l_1100;
	}
	/* */
	goto l_1000;
	/* */
	/*     RECORD THE STARTING POINT AND DESTINATION OF THE TAXI/TRANSPORTER */
	/*     ================================================================= */
l_2000:  
	if (*found) {
		tarma[ncar][1] = (double)itargl;
		tarma[ncar][2] = (double)itargu;
	} else {
		if ((iprint == 1 || jprint[23] > 0) && jprint[23] != -1) {
			fprintf (nunit2, "finsds:  t=%12.4f%13s%4d does not find a transport request\n", TiMe, ctype[art],
			     ncar);
		}
	}
	/* */
	return(NORMAL);
	/* */
}


