static char *SccsId = "@(#)PEPSY:\tfunct.c\t1.2\t92/03/27 11:55:50";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	funct(vfunct, idim, x, y, ind)
int	ind ;
double	*y ;
double	x ;
int	idim ;
double	vfunct[][3] ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    ***  call funct(vfunct,idim,x, *y,ind,*9999)                      */
	/*    ***                                                               */
	/*    ***  funktion:   lineare interpolation                            */
	/*    ***  parameter:  vfunct  = bezeichnung der stuetz-funktion        */
	/*    ***              idim    = anzahl der stuetzwerte (werte der      */
	/*    ***                        unabh. variablen aufsteigend ordnen)   */
	/*    ***              x       = wert der unabh. variablen x, zu der der  */
	/*    ***                        zugehoerige wert von  *y berechnet wird  */
	/*    ***               *y       = wert von  *y (rueckgabeparameter)    */
	/*    ***              ind     = indikator bei bereichsueberschreitung  */
	/*    ***                        0: keine extrapolation                 */
	/*    ***                        1: lineare extrapolation               */
	/*    ***                        2: fehlermeldung, abbruch der simulation  */
	/*    ***              exit1   = fehlerausgang                          */
	int	k ;
	/*                                                                      */
	/*    suchen des intervalls                                             */
	/*    =====================                                             */
	if (idim < 2) 
		goto l_9996;
	if (x < vfunct[1][1]) 
		goto l_300;
	if (x > vfunct[idim][1]) 
		goto l_500;
	for (k = 1; k <= idim; ++k) {
		if (x > vfunct[k][1]) 
			continue;
		if (x < vfunct[k][1]) 
			goto l_210;
		goto l_200;
		;
	};
	/*                                                                      */
	/*    berechnung von  *y                                                */
	/*    ================                                                  */
l_200:   
	*y = vfunct[k][2];
	return(NORMAL);
	/*                                                                      */
l_210:   
	*y = (x - vfunct[k-1][1]) * (vfunct[k][2] - vfunct[k-1][2]) / (vfunct[k][1] - vfunct[k-1][1]) + vfunct[k-1][2];
	return(NORMAL);
	/*                                                                      */
	/*    ausgaenge bei x-werten unterhalb des intervalls der stuetzwerte   */
	/*    ================================================================  */
l_300:  
	if (ind <= 0) 
		goto l_301;
	if (ind == 1) 
		goto l_302;
	if (ind >= 2) 
		goto l_9998;
	/*                                                                      */
	/*    zuweisung des ersten stuetzwertes                                 */
	/*    ==================================                                */
l_301:   
	*y = vfunct[1][2] ;
	goto l_8888;
	/*                                                                      */
	/*    lineare extrpolation                                              */
	/*    ====================                                              */
l_302:  
	if (vfunct[2][1] == vfunct[1][1]) 
		goto l_9997;
	*y = (x - vfunct[1][1]) * (vfunct[2][2] - vfunct[1][2]) / (vfunct[2][1] - vfunct[1][1]) + vfunct[1][2];
	goto l_8888;
	/*                                                                      */
	/*    ausgaenge bei x-werten oberhalb des intervalls der stuetzwerte    */
	/*    ==============================================================    */
l_500:  
	if (ind <= 0) 
		goto l_501;
	if (ind == 1) 
		goto l_502;
	if (ind >= 2) 
		goto l_9998;
	/*                                                                      */
	/*    zuweisung des letzten stuetzwertes                                */
	/*    ==================================                                */
l_501:   
	*y = vfunct[idim][2];
	goto l_8888;
	/*                                                                      */
	/*    lineare extrapolation                                             */
	/*    =====================                                             */
l_502:  
	if (vfunct[idim][1] == vfunct[idim-1][1]) 
		goto l_9997;
	*y = (x - vfunct[idim-1][1]) * (vfunct[idim][2] - vfunct[idim-1][2]) / (vfunct[idim][1] - vfunct[idim-1][1]) + vfunct[idim-1][2];
	/*                                                                      */
	/*    kommentar zur extrapolation                                       */
	/*    ===========================                                       */
l_8888:
	if (iprint == 0 && jprint[21] == 0 || jprint[21] == -1) 
		goto l_8889;
	fprintf(nunit2, "\n\n+++++ funct: TiMe=%12.4f  bereichsindikator ind=%1d  wert der variablen x%12.4f\n",
	    TiMe, ind, x);
	fprintf(nunit2, "       liegt ausserhalb des intervalls der stuetzwerte:%12.4f %12.4f\n",
	    vfunct[1][1], vfunct[idim][1] );
l_8889:
	return(NORMAL);
	/*                                                                      */
	/*    fehlerausgang                                                     */
	/*    =============                                                     */
l_9996:
	fprintf(nunit2, "\n\n+++++ funct: TiMe=%12.4f idim kleiner 2\n", TiMe);
	goto l_9999;
l_9997:
	fprintf(nunit2, "\n\n+++++ funct: TiMe=%12.4f bereichsindikator ind=%3d\n      keine extrapol. moegl., da stuetzpunkte zusammenfallen\n",
	                   TiMe, ind);
	goto l_9999;
l_9998:
	fprintf(nunit2, "\n\n+++++ funct: TiMe=%12.4f  bereichsindikator ind=%1d  wert der variablen x%12.4f\n",
	    TiMe, ind, x);
	fprintf(nunit2, "       liegt ausserhalb des intervalls der stuetzwerte:%12.4f %12.4f\n",
	    vfunct[1][1], vfunct[idim][1] );
l_9999:
	return(FEHLER);
}


