static char *SccsId = "@(#)PEPSY:\tgather.c\t1.3\t92/03/27 11:55:53";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	gathr1(ng, ntx, id)
int	id ;
int	ntx ;
int	ng ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call gathr1(ng,ntx,id,*9000)                                  */
	/*    ***                                                               */
	/*    *** funktion : erzeugen eines staus von trs                       */
	/*    *** parameter: ng  = nummer der gather-station vom typ 1          */
	/*    ***            ntx = anzahl der zu stauenden trs                  */
	/*    ***            id  = anweisungsnummer des unterprogrammaufrufes   */
	/*    ***                                                               */
	extern int	block(), dblock(), policy();
	extern int	next_int();
	int	ftx, k, np, ntx1 ;

#ifdef DEBUG
dprint(STATION, "gathr1: ng = %d, ntx = %d, id = %d\n", ng, ntx, id); /* */
#endif
	/*                                                                      */
	/*    bestimmen der stationsnummer                                      */
	/*    ============================                                      */
	k = offset.gath + ng - 1;
	/*                                                                      */
	/*    verlassen der gather-station                                      */
	/*    ============================                                      */
	if (next_int(activlist[row_txact].next) != -k) 
		goto l_100;
	tx_system[row_txact].t_block = 0.0;
	if (iprint == 0 && jprint[6] == 0 || jprint[6] == -1) 
		return(NORMAL);
	fprintf(nunit2, " gathr1:  TiMe=%12.4f  tr%6d,%4d   verlaesst die gather1-station nr%3d\n",
	    TiMe, tx_system[row_txact].nr, tx_system[row_txact].dup, ng );
	return(NORMAL);
	/*                                                                      */
	/*    blockieren                                                        */
	/*    ==========                                                        */
l_100:  
	activlist[row_txact].next =  -(double)k;
	activlist[row_txact].target = id;
	tx_system[row_txact].t_block = TiMe ;
	policy(6, ng, 0, &ftx, &np);
	block(6, ng, 0, ftx);
	gath_tx[ng] = gath_tx[ng] + 1 ;
#ifdef DEBUG
dprint(STATION, "gathr1: gath_tx[ng] = %d\n", gath_tx[ng]); /* */
#endif
	if (gath_tx[ng] == ntx) 
		goto l_200;
	if (iprint == 0 && jprint[6] == 0 || jprint[6] == -1) 
		return(AUSGANG2);
	fprintf(nunit2, " gathr1:  TiMe=%12.4f  tr%6d,%4d   wird blockiert an gather1-station nr%3d\n",
	    TiMe, tx_system[row_txact].nr, tx_system[row_txact].dup, ng );
	return(AUSGANG2);
	/*                                                                      */
	/*    aufloesen des staus                                               */
	/*    ===================                                               */
l_200:  
	gath_tx[ng] = 0 ;
	if (iprint == 0 && jprint[6] == 0 || jprint[6] == -1) 
		goto l_250;
	fprintf(nunit2, " gathr1:  TiMe=%12.4f  tr%6d,%4d   beendet den sammlungsvorgang an gather1-station nr%3d\n",
	    TiMe, tx_system[row_txact].nr, tx_system[row_txact].dup, ng );
l_250:  
	ntx1 = ntx;
	dblock(6, ng, 0, ntx1);
	return(AUSGANG2);
}




int	gathr2(ng, ntx, id)
int	id ;
int	ntx ;
int	ng ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call gathr2(ng,ntx,id,*9000)                                  */
	/*    ***                                                               */
	/*    *** funktion : erzeugen eines staus von trs unter                 */
	/*    ***            beruecksichtigung der familiy-zugehoerigkeit       */
	/*    *** parameter: ng  = nummer der gather-station vom typ 2          */
	/*    ***            ntx = anzahl der zu stauenden trs                  */
	/*    ***            id  = anweisungsnummer des unterprogrammaufrufes   */
	/*    ***                                                               */
	extern int	block(), dblock(), policy();
	extern int	next_int();
	int	ftx, lfam, ns, k ;
	int	np, ntx1 ;
	/*                                                                      */
	/*    pruefen der family-zugehoerigkeit                                 */
	/*    =================================                                 */
	if (tx_system[row_txact].dup == 0) 
		return(NORMAL);
	lfam = tx_system[row_txact].family;
	/*                                                                      */
	/*    bestimmen der stationsnummer                                      */
	/*    ============================                                      */
	ns = zfam * (ng - 1) + lfam;
	k = offset.gathf + ns - 1;
	/*                                                                      */
	/*    verlassen der gather-station                                      */
	/*    ============================                                      */
	if (next_int(activlist[row_txact].next) != -k) 
		goto l_100;
	tx_system[row_txact].t_block = 0.0;
	if (iprint == 0 && jprint[7] == 0 || jprint[7] == -1) 
		return(NORMAL);
	fprintf(nunit2, " gathr2:  TiMe=%12.4f  tr%6d,%4d   verlaesst die gather2-station nr%3d\n",
	    TiMe, tx_system[row_txact].nr, tx_system[row_txact].dup, ng );
	return(NORMAL);
	/*                                                                      */
	/*    blockieren                                                        */
	/*    ==========                                                        */
l_100:  
	activlist[row_txact].next =  -(double)k;
	activlist[row_txact].target = id;
	tx_system[row_txact].t_block = TiMe ;
	policy(7, ng, lfam, &ftx, &np);
	block(7, ng, lfam, ftx);
	gath_fam[lfam][ng] = gath_fam[lfam][ng] + 1 ;
	if (gath_fam[lfam][ng] == ntx) 
		goto l_200;
	if (iprint == 0 && jprint[7] == 0 || jprint[7] == -1) 
		return(AUSGANG2);
	fprintf(nunit2, " gathr2:  TiMe=%12.4f  tr%6d,%4d   wird blockiert an gather2-station nr%3d\n",
	    TiMe, tx_system[row_txact].nr, tx_system[row_txact].dup, ng );
	return(AUSGANG2);
	/*                                                                      */
	/*    aufloesen des staus                                               */
	/*    ===================                                               */
l_200:  
	gath_fam[lfam][ng] = 0;
	if (iprint == 0 && jprint[7] == 0 || jprint[7] == -1) 
		goto l_250;
	fprintf(nunit2, " gathr2:  TiMe=%12.4f  tr%6d,%4d   beendet den sammlungsvorgang an gather2-station nr%3d\n",
	    TiMe, tx_system[row_txact].nr, tx_system[row_txact].dup, ng );
l_250:  
	ntx1 = ntx;
	dblock(7, ng, lfam, ntx1);
	return(AUSGANG2);
}


