static char *SccsId = "@(#)PEPSY:\tgauss.c\t1.2\t92/03/27 11:55:56";

/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/


#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	gauss(rmean, sigma, rmin, rmax, irnum, random)
double	*random ;
int	irnum ;
double	rmax ;
double	rmin ;
double	sigma ;
double	rmean ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call gauss(rmean,sigma,rmin,rmax,irnum, *random)              */
	/*    ***                                                               */
	/*    *** funktion : erzeugen einer normal-verteilten zufallszahl       */
	/*    *** parameter: rmean   = mittelwert                               */
	/*    ***            sigma   = standardabweichung                       */
	/*    ***            rmin    = untere intervallgrenze                   */
	/*    ***            rmax    = obere intervallgrenze                    */
	/*    ***            irnum   = nummer des zufallszahlengenerators       */
	/*    ***             *random  = rueckgabe: zufallszahl im angegebenen  */
	/*    ***                                 intervall                     */
	/*    ***                                                               */
	extern double	rnx();
	double	r, v;
	/*                                                                      */
	/*    erzeugen einer gauss-verteilten zufallszahl                       */
	/*    ===========================================                       */
l_100:  
	r = rnx(irnum);
	if (r == 0.) 
		goto l_100;
	v = pow((-2.0 * log(r)), 0.5) * cos(6.2832 * rnx(irnum));
	*random = v * sigma + rmean;
	/*                                                                      */
	/*    intervallkontrolle                                                */
	/*    ==================                                                */
	if ( *random < rmin ||  *random > rmax) 
		goto l_100;
	return(NORMAL);
}


int	gauss2(rmean, sigma, rmin, rmax, irnum, random)
double	*random ;
int	irnum ;
double	rmax ;
double	rmin ;
double	sigma ;
double	rmean ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call gauss(rmean,sigma,rmin,rmax,irnum, *random)              */
	/*    ***                                                               */
	/*    *** funktion : erzeugen einer normal-verteilten zufallszahl       */
	/*    *** parameter: rmean   = mittelwert                               */
	/*    ***            sigma   = standardabweichung                       */
	/*    ***            rmin    = untere intervallgrenze                   */
	/*    ***            rmax    = obere intervallgrenze                    */
	/*    ***            irnum   = nummer des zufallszahlengenerators       */
	/*    ***             *random  = rueckgabe: zufallszahl im angegebenen  */
	/*    ***                                 intervall                     */
	/*    ***                                                               */
	extern double	rnx();
	double	r, v;
	/*                                                                      */
	/*    erzeugen einer gauss-verteilten zufallszahl                       */
	/*    ===========================================                       */
l_100:  
	r = rnx(irnum);
	if (r == 0.) 
		goto l_100;
	v = pow((-2.0 * log(r)), 0.5) * cos(6.2832 * rnx(irnum + 1));
	*random = v * sigma + rmean;
	/*                                                                      */
	/*    intervallkontrolle                                                */
	/*    ==================                                                */
	if ( *random < rmin ||  *random > rmax) 
		goto l_100;
	return(NORMAL);
}


