static char *SccsId = "@(#)PEPSY:\tgetin.c\t1.3\t92/03/27 11:56:02";
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	getin(nterm, itargu, idn, itype, iordr, nstrat)
int	nterm, itargu, idn, itype, iordr, nstrat;
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	/*     ***  */
	/*     *** CALL GETIN(NTERM,ITARGU,IDN,ITYPE,IORDR,NSTRAT,*9000,*9999)  */
	/*     ***  */
	/*     *** PURPOSE : BLOCK A TRANSACTION AT A TERMINAL UNTIL IT */
	/*     ***           CAN BE TRANSPORTED FURTHER AND POSSIBLY ENTER */
	/*     ***           TRANSPORT REQUEST IN LIST OF REQUESTS */
	/*     *** PARAMETERS: NTERM  = INDEX OF TERMINAL AT WHICH TRANSACTION  */
	/*     ***                      ENTERS VEHICLE */
	/*     ***             ITARGU = DESTINATION OF TRANSACTION WHICH ENTERS */
	/*     ***                      VEHICLE */
	/*     ***                      = -1: DESTINATION NOT YET KNOWN */
	/*     ***             IDN    = LABLE OF CORRESPONDING GETOUT STATEMENT */
	/*     ***             ITYPE  = INDICATOR FOR REQUIRED TYPE OF VEHICLE  */
	/*     ***                      = 1: BUS  */
	/*     ***                      = 2: TAXI */
	/*     ***                      = 3: TRANSPORTER */
	/*     ***             IORDR  = TYPE OF CONTROL */
	/*     ***                      (ONLY RELEVANT FOR TRANSPORTER) */
	/*     ***                      = 0: NO TRANSPORT REQUEST HAS BEEN */
	/*     ***                           RECORDED (AS BUS) */
	/*     ***                      = 1: CONTROL BY DISPATCHER (AS TAXI) */
	/*     ***             NSTRAT = STRATEGY FOR SELECTION OF TAXI */
	/*     ***                      OR TRANSPORTER */
	/*     ***             *9000  = EXIT TO FLOW CONTROL */
	/*     ***             *9999  = ERROR EXIT */
	/*     ***  */
	/* */
	/* */

	short	found;
	char	ctype[4][12];
	extern int	next_int(), policy(), block(), order();
	int	line, k, np, nact, i;


	strcpy(ctype[1], "bus        ");
	strcpy(ctype[2], "taxi       ");
	strcpy(ctype[3], "transporter");
#ifdef DEBUG
dprint(TRANSACTION, "getin: nterm %d, itargu %d, idn %d, itype %d, iordr %d, nstrat %d\n", /* */
	    nterm, itargu, idn, itype, iordr, nstrat);
dprint(TRANSACTION, "getin: row_txact %d\n", row_txact); /* */
#endif
	/* */
	/*     TEST FOR ERRORS */
	/*     =============== */
	if (nterm <= 0 || nterm > ansta)                   
		goto l_4000;
	if (itargu < -1 || itargu == 0 || itargu > ansta)  
		goto l_4100;
	if (itype < 1 || itype > 3)                        
		goto l_4200;
	if (itype != 3 && itargu == -1)                    
		goto l_4100;
	if (itype == 3 && (iordr < 0 || iordr > 1))        
		goto l_4300;
	if ( (itype == 2  ||  itype == 3 && iordr == 1) && 
	    (nstrat <= 0 || nstrat > 6)          )       
		goto l_4400;
	if (next_int(txadd[row_txact][1]) != 0)            
		goto l_4500;
	/* */
	/*     DETERMINE INDEX OF STATION */
	/*     ========================== */
	k = offset.station + nterm - 1;
#ifdef DEBUG
dprint(TRANSACTION, "getin: stationsnummer %d\n", k); /* */
#endif
	/* */
	/*     BLOCK TRANSACTION AT TERMINAL */
	/*     ============================= */
	tx_system[row_txact].t_block = TiMe;
	activlist[row_txact].next = -(double)k;
#ifdef DEBUG
dprint(TRANSACTION, "getin: getout aufruf bei label %d\n", idn); /* */
#endif
	activlist[row_txact].target = idn;
	policy(13, nterm, 0, &line, &np);
	block(13, nterm, 0, line);
#ifdef DEBUG
dprint(TRANSACTION, "getin: nterm = %d nach call block\n", nterm); /* */
#endif
	/* */
	/*     COLLECTION OF STATISTICAL DATA: BLOCKED TRANSACTIONS */
	/*     ==================================================== */
#ifdef DEBUG
dprint(TRANSACTION, "getin: sammeln statistischer daten \n"); /* */
#endif
	statst[nterm][1] = statst[nterm][1] + (statst[nterm][2] - statst[nterm][3]) * (TiMe - statst[nterm][4]);
	statst[nterm][2] = statst[nterm][2] + 1;
	statst[nterm][4] = TiMe;
	/* */
	/*     ENTER DESTINATION AND REQUIRED VEHICLETYPE OF TRANSACTION */
	/*     ========================================================= */
	txadd[row_txact][2] = (double)itargu;
	txadd[row_txact][3] = (double)itype;
	if (itype == 3 && iordr == 0) 
		txadd[row_txact][3] = -txadd[row_txact][3];
	/* */
	/*     TRACE */
	/*     ===== */
	if ((iprint == 1 || jprint[23] > 0) && jprint[23] != -1) {
		fprintf (nunit2, "getin :  t=%12.4f  tr%6d,%4d   is blocked at terminal%4d  and waits\n", TiMe, tx_system[row_txact].nr,
		     tx_system[row_txact].dup, nterm);
		if (itargu == -1) {
			fprintf (nunit2, "                         with unknown destination for a %11s\n", ctype[itype]);
		} else {
			fprintf (nunit2, "                                         with destination %4d for a %11s\n", itargu,
			     ctype[itype]);
		}
	}
	if (kprint == 1) {
		nact = 1;
		fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[row_txact], tx_system[row_txact].nr, nact, nterm);
	}
	/* */
	/* */
	/*     GETIN IN REQUEST-MODE */
	/*     ===================== */
	if (itype == 2 || itype == 3 && iordr == 1) {
		/* */
		/*     SEARCH FOR FREE PLACE IN REQUEST MODE */
		/*     ===================================== */
		found =  FALSE;
		for ( i = 1; i <= ztx; i++) {
			if (next_int(logma[i][1]) == 0) 
				goto l_300;
		}
		/* */
		/*     ERROR: THERE IS NO FREE PLACE */
		/*     ============================= */
		fprintf (nunit2, "\n\n+++++ getin :  t=%12.4f ERROR  : overflow logma\n", TiMe);
		goto l_99;
		/* */
		/*     REQUEST TAXI/TRANSPORTER */
		/*     ======================== */
l_300: 
#ifdef DEBUG
dprint(LABEL, "getin: label l_300\n"); /* */
#endif
		switch (order(nterm, itargu, i, nstrat, &found)) {
		case FEHLER:
#ifdef DEBUG
dprint(TRANSACTION, "getin: fehler in order\n"); /* */
#endif
			goto l_99;
		}

		/* */
		/*     ADD TRANSACTION TO CHAIN IF NO TAXI/TRANSPORTER FOUND  */
		/*     =====================================================  */
		if ( !found) {
			if (logptr[1] == -1) {
#ifdef DEBUG
dprint(TRANSACTION, "getin: logptr[1] == -1\n"); /* */
#endif
				logptr[1] = i;
				logptr[2] = i;
#ifdef DEBUG
dprint(TRANSACTION, "getin: logptr[1] = logptr[2] = %d \n", i); /* */
#endif
			} else {
#ifdef DEBUG
dprint(TRANSACTION, "getin: logptr[1] != -1\n"); /* */
#endif
				logma[logptr[2]][5] = i;
				logptr[2] = i;
#ifdef DEBUG
dprint(TRANSACTION, "getin: logma[logptr[2]][5] = logptr[2] = %d \n", i); /* */
#endif
			}
		}
		/* */
		/*     ENTER CHARACTERISTICS OF TRANSACTION IN REQUEST LIST */
		/*     ==================================================== */
		logma[i][1]   = (double)nterm;
		logma[i][2]   = (double)itargu;
		logma[i][3]   = (double)row_txact;
		logma[i][4]   = TiMe;
		logma[i][5]   = -1.0;
	}
	/* */
l_90: 
	return(AUSGANG2);
	/* */
	/*     ERROR EXIT */
	/*     ========== */
l_4000:  
	fprintf (nunit2, "\n\n+++++ getin :  t=%12.4f ERROR  : invalid starting point (%4d)\n", TiMe, nterm);
	goto l_99;
	/* */
l_4100:  
	fprintf (nunit2, "\n\n+++++ getin :  t=%12.4f ERROR : invalid destination%4d\n", TiMe, itargu);
	goto l_99;
	/* */
l_4200:  
	fprintf (nunit2, "\n\n+++++ getin :  t=%12.4f ERROR : invalid vehicle type (%4d)\n", TiMe, itype);
	goto l_99;
	/* */
l_4300:  
	fprintf (nunit2, "\n\n+++++ getin :  t=%12.4f ERROR : invalid type of order (%4d)\n", TiMe, itype);
	goto l_99;
	/* */
l_4400:  
	fprintf (nunit2, "\n\n+++++ getin :  t=%12.4f ERROR : invalid strategy (%3d)\n", TiMe, nstrat);
	goto l_99;
	/* */
l_4500:  
	fprintf (nunit2, "\n\n+++++ getin :  t=%12.4f ERROR : attempts to enter vehicle\n", TiMe);
l_99:    
	return(FEHLER);
	/* */
}


