static char *SccsId = "@(#)PEPSY:\tgload.c\t1.3\t92/03/27 11:56:09";
#include <stdio.h>
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	gload(idn, iordr, local_TiMe)
int	idn;
int	iordr;
float	local_TiMe;
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	/*     ***  */
	/*     *** CALL GLOAD(IDN,IORDR,TIME,*9000,*9999) */
	/*     ***  */
	/*     *** PURPOSE : LOAD A TRANSPORTER */
	/*     *** PARAMETERS: IDN   = REACTIVATION LABEL */
	/*     ***             IORDR = TYPE OF CONTROL */
	/*     ***                     = 0: ONLY TRANSACTIONS WHICH ARE NOT IN  */
	/*     ***                          THE REQUEST LIST (AS FOR BUS) LOADED */
	/*     ***                     = 1: ONLY TRANSACTIONS FROM THE REQUEST  */
	/*     ***                          LIST ARE LOADED (AS TAXI) */
	/*     ***             TIME  = TIME TO LOAD A TRANSACTION */
	/*     ***             *9000 = EXIT TO FLOW CONTROL */
	/*     ***             *9999 = ERROR EXIT */
	/*     ***  */
	/* */

	short	trbeg, beginn, trace;
	extern int	next_int() , tchain();
	double	anzahl, adTiMe;
	int	next, nexttr, lasttr, nact, lognr, i, ncar, nterm, k;


#ifdef DEBUG
dprint(TRANSPORTER, "gload: idn %d, iordr %d, local_time %f\n", /* */
	    idn, iordr, local_TiMe);
#endif

	/*     TEST FOR ERRORS */
	/*     =============== */
	ncar  = next_int(txadd[row_txact][1]);
	if (ncar == 0)                                    
		goto l_4000;
	if (txi[row_txact] != 3)                          
		goto l_4100;
	if (local_TiMe < -eps)                            
		goto l_4200;
	nterm = next_int(carma[ncar][6]);
	if ((next_int(carma[ncar][6] * 10.) - nterm * 10) != 1) 
		goto l_4300;
	if (iordr < 0 || iordr > 1)                       
		goto l_4400;
	/* */
	/*     INITIALIZE */
	/*     ========== */
	k      = offset.station + nterm - 1;
	trbeg  = TRUE;
	beginn = TRUE;
	anzahl = 0.;
	trace  = ((iprint == 1 || jprint[23] > 0) && jprint[23] != -1);
	if (trace) 
		fprintf (nunit2, "gload :  t=%12.4f  transporter%4d is at terminal%4d\n", TiMe, ncar, nterm);
	/* */
	/*     ARE THERE TRANSACTIONS TO BE PROCESSED? IS THE TRANSPORTER FULL? */
	/*     ================================================================ */
	if (iordr == 1) {
		if (next_int(carma[ncar][10]) == -1) 
			goto l_2000;
		if (next_int(carma[ncar][4]) != 0) 
			goto l_4600;
	} else {
		if (next_int(tarma[ncar][2]) != 0) 
			goto l_2000;
		if (next_int(carma[ncar][3]) - next_int(carma[ncar][4]) == 0) 
			goto l_2000;
	}
	/* */
	/*     FIND END OF CHAIN OF THE TRANSPORTER */
	/*     ==================================== */
	if (next_int(carma[ncar][2]) >= 0) {
		beginn =  FALSE;
		next   = next_int(carma[ncar][2]);
		goto l_510;
l_500:   
		next = activlist[next].blk_link;
l_510:   
		if (activlist[next].blk_link > 0) 
			goto l_500;
	}
	/* */
	/*     EXAMINE CHAIN AT TERMINAL */
	/*     ========================= */
l_1000: 
	if (trbeg) {
		nexttr = bhead[k] - activlist;
	} else {
		nexttr = activlist[lasttr].blk_link;
	}
	/* */
	/*     END OF CHAIN AT TERMINAL REACHED?  */
	/*     =================================  */
	if (nexttr < 0) 
		goto l_2000;
	/* */
	/*     SELECT TRANSACTION CHAIN */
	/*     ======================== */
	if (iordr == 1) {
		if (nexttr != next_int(logma[next_int(carma[ncar][10])][3])) {
			lasttr = nexttr;
			trbeg  =  FALSE;
			goto l_1000;
		}
	} else {
		if (next_int(txadd[nexttr][3]) != -3) {
			lasttr = nexttr;
			trbeg  =  FALSE;
			goto l_1000;
		}
	}
	/* */
	/*     LOAD TRANSACTION */
	/*     ================ */
	anford = next_int(txadd[nexttr][4]);
	if (anford == 0)  
		anford = 1;
	/* */
	/*     IS THERE ROOM ? */
	/*     =============== */
	if ((carma[ncar][4] + anford) > carma[ncar][3]) {
		if (iordr == 1) 
			goto l_4600;
		lasttr = nexttr;
		trbeg =  FALSE;
		goto l_1000;
	}
	/* */
	/*     ENTER REQUIREMENT AND ATTACH TRANSACTION TO CHAIN OF TRANSPORTER */
	/*     ================================================================ */
	carma[ncar][4] = carma[ncar][4] + anford;
	if (beginn) {
		carma[ncar][2] = (double)nexttr;
		beginn =  FALSE;
	} else {
		activlist[next].blk_link = nexttr;
	}
	next = nexttr;
	/* */
	/*     REMOVE TRANSACTION FROM CHAIN AT TERMINAL */
	/*     ========================================= */
	if (trbeg) {
		bhead[k] = activlist + activlist[nexttr].blk_link;
	} else {
		lasttr = bhead[k] - activlist;
		goto l_1110;
l_1100:  
		lasttr = activlist[lasttr].blk_link;
l_1110:  
		if (activlist[lasttr].blk_link != nexttr) 
			goto l_1100;
		activlist[lasttr].blk_link = activlist[nexttr].blk_link;
	}
	activlist[nexttr].blk_link = -1;
	anzahl = anzahl + 1.;
	adTiMe = local_TiMe * anzahl;
	if (trace) {
		fprintf (nunit2, "                         transaction%4d loaded\n", tx_system[nexttr].nr);
		if (adTiMe > eps) 
			fprintf (nunit2, "                         this requires%12.4f units of TiMe\n", adTiMe);
	}
	if (kprint == 1) {
		nact = 4;
		fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[nexttr], tx_system[nexttr].nr, nact, nterm);
	}
	/* */
	/* */
	/*     COLLECTION OF STATISTICAL DATA:  */
	/*     NUMBER OF TRANSACTIONS AND UNIT QUANTITIES */
	/*     ========================================== */
	statis[ncar][5] = statis[ncar][5] + 1.;
	statis[ncar][6] = statis[ncar][6] + (double)anford;
	/* */
	statst[nterm][1] = statst[nterm][1] - adTiMe + 
	    (statst[nterm][2] - statst[nterm][3]) * 
	    (TiMe - statst[nterm][4]);
	statst[nterm][3] = statst[nterm][3] + 1.;
	statst[nterm][4] = TiMe;
	/* */
	/*     REMOVE TRANSACTION FROM REQUEST */
	/*     =============================== */
	if (iordr == 1) {
		tarma[ncar][1] = 0.;
		lognr = next_int(carma[ncar][10]);
		carma[ncar][10] = logma[lognr][5];
		for (i = 1; i <= 5; i++)  {
			logma[lognr][i] = 0.;
		}
		/* */
		/*     ARE THERE TRANSACTIONS LEFT? */
		/*     ============================ */
		if (next_int(carma[ncar][10]) != -1) {
			trbeg =  TRUE;
			goto l_1000;
		}
	} else {
		trbeg =  TRUE;
		goto l_1000;
	}
	/* */
	/*     DURATION OF LOADING */
	/*     =================== */
l_2000: 
	adTiMe = local_TiMe * anzahl;
	if (next_int(anzahl) == 0) {
		if (trace) 
			fprintf (nunit2, "                         no transaction loaded\n");
	} else {
		if (kprint == 1) {
			nact = 32;
			fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[row_txact], ncar, nact, nterm);
		}
		if (adTiMe > eps) {
			if (trace) 
				fprintf (nunit2, "                         transporter%4d is delayed for loading\n                          by %12.4f units or TiMe\n",
				     ncar, adTiMe);
			/* */
			/*     DATA COLLECTION: LOADING TIME */
			/*     ============================= */
			statis[ncar][10] = statis[ncar][10] + adTiMe;
		}
		/* */
		carma[ncar][7] = 1.;
	}
	/* */
	/*     SCHEDULE */
	/*     ======== */
	activlist[row_txact].next = TiMe + adTiMe;
	activlist[row_txact].target = idn;
	tchain(3, row_txact);
	/* */
l_90: 
	return(AUSGANG2);
	/* */
	/*     ERROR EXIT */
	/*     ========== */
l_4000:  
	fprintf (nunit2, "\n\n+++++ gload :  t=%12.4f ERROR  : transaction tries to load\n", TiMe);
	goto l_99;
	/* */
l_4100:  
	fprintf (nunit2, "\n\n+++++ gload :  t=%12.4f ERROR  : bus or taxi in gload\n", TiMe);
	goto l_99;
	/* */
l_4200:  
	fprintf (nunit2, "\n\n+++++ gload :  t=%12.4f ERROR  : negative loading TiMe %8.2f specified\n", TiMe, local_TiMe);
	goto l_99;
	/* */
l_4300:  
	fprintf (nunit2, "\n\n+++++ gload :  t=%12.4f ERROR : transporter tries to load at branch %4d\n", TiMe, nterm);
	goto l_99;
	/* */
l_4400:  
	fprintf (nunit2, "\n\n+++++ gload :  t=%12.4f ERROR  : parameter iordr which inicates type of control is wrong\n",
	     TiMe);
	goto l_99;
	/* */
l_4600:  
	fprintf (nunit2, "\n\n+++++ gload :  t=%12.4f ERROR  : transporter %4d cannot load transaction\n", TiMe, ncar);
l_99:    
	return(FEHLER);
	/* */
}


