static char *SccsId = "@(#)PEPSY:\tgpark.c\t1.2\t92/03/27 11:56:14";
#include <stdio.h>
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	gpark(idn, iordr)
int	idn, iordr;
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	/*     ***  */
	/*     *** CALL GPARK(IDN,IORDR,*9000,*9999) */
	/*     ***  */
	/*     *** PURPOSE : PARK A TRANSPORTER AFTER COMPLETION OF THE JOURNEY */
	/*     *** PARAMETERS: IDN   = REACTIVATION LABEL */
	/*     ***             IORDR = CENTRAL CONROL */
	/*     ***                      = 0: OFF  */
	/*     ***                      = 1: ON */
	/*     ***             *9000 = EXIT TO FLOW CONTROL */
	/*     ***             *9999 = ERROR EXIT */
	/*     ***  */
	/* */

	int	blocnr, line, np, nact, nterm, k, ncar;
	short	found, trace;
	extern int	next_int(), find(), tchain(), policy(), block(), dblock();


	/*     TEST FOR ERRORS */
	/*     =============== */
	ncar = next_int(txadd[row_txact][1]);
	if (ncar == 0)                                     
		goto l_4000;
	if (txi[row_txact] != 3)                           
		goto l_4100;
	nterm = next_int(carma[ncar][6]);
	if ((next_int(carma[ncar][6] * 10.0) - nterm * 10) != 1) 
		goto l_4200;
	if (iordr < 0 || iordr > 1)                        
		goto l_4300;
	/* */
	/*     INITIALIZE */
	/*     ========== */
	k     = offset.match + zmatch + zsta + nterm - 1;
	found =  FALSE;
	trace = ((iprint == 1 || jprint[23] > 0) && jprint[23] != -1);
	/* */
	/*     CAN THE TRANSPORTER PARK? */
	/*     ========================= */
	if (next_int(carma[ncar][7]) == 1) {
		if (trace) 
			fprintf (nunit2, "gpark :  t=%12.4f  transporter%4d contains a transaction and therefore proceeds further\n",
			     TiMe, ncar);
	} else if (next_int(carma[ncar][7]) == 2) {
		if (trace) 
			fprintf (nunit2, "gpark : t=%12.4f  transporter%4d has been assigned a journey and therefore proceeds further\n",
			     TiMe, ncar);
	} else if (next_int(carma[ncar][9]) == 0) {
		if (trace) 
			fprintf (nunit2, "gpark :  t=%12.4f  transporter%4d without central control; therefore proceeds\n",
			     TiMe, ncar);
	} else {
		if (iordr == 1)  
			switch (find(ncar, &found)) {
			case FEHLER: 
				goto l_99;
			}
		if (found) {
			/* */
			/*     NEW TASK FOUND */
			/*     ============== */
			carma[ncar][7] = 2.0;
			carma[ncar][8] = 1.0;
			if (trace) 
				fprintf (nunit2, "gpark :  t=%12.4f  transporter%4d proceeds further to a new order \n",
				    TiMe, ncar);
			if (kprint == 1) {
				nact = 31;
				fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[row_txact], ncar, nact, nterm);
			}
		} else {
			goto l_1000;
		}
	}
	/* */
	/*     SCHEDULE TRANSPORTER */
	/*     ==================== */
	activlist[row_txact].next  = TiMe;
	activlist[row_txact].target  = (double)idn;
	tchain(3, row_txact);
	goto l_90;
	/* */
	/*     BLOCK TRANSPORTER */
	/*     ================= */
l_1000: 
	tx_system[row_txact].t_block     = TiMe;
	activlist[row_txact].next = -(double)k;
	activlist[row_txact].target = (double)idn;
	policy(14, nterm, 0, &line, &np);
	block(14, nterm, 0, line);
	if (trace) 
		fprintf (nunit2, "gpark :  t=%12.4f  transporter%4d parks at terminal%4d\n", TiMe, ncar, nterm);
	if (kprint == 1) {
		nact = 36;
		fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[row_txact], ncar, nact, nterm);
	}
	/* */
	/*     COLLECTION OF STATISTICAL DATA: PARKING VEHICLES */
	/*     ================================================ */
	parkst[nterm][1] = parkst[nterm][1] + (parkst[nterm][2] - parkst[nterm][3]) * (TiMe - parkst[nterm][4]);
	parkst[nterm][2] = parkst[nterm][2] + 1;
	parkst[nterm-1][3] = TiMe;
	/* */
	/*     STATE: PARKING */
	/*     ============== */
	carma[ncar][7] = 0.0;
	carma[ncar][8] = 1.0;
	/* */
	/*     HAS THE TRANSPORTER TRAVERSED A BLOCK SECTION: POSSIBLY UNBLOCK  */
	/*     ===============================================================  */
	blocnr = next_int(tarma[ncar][4]);
	if (blocnr > 0) {
		blocve[blocnr][2] = blocve[blocnr][2] + 1;
		if (trace) {
			fprintf (nunit2, "                         and frees block section%4d\n", blocnr);
			dblock(15, blocnr, 0, 1);
		}
	}
	/* */
	/* */
l_90:    
	return(AUSGANG2);
	/* */
	/*     ERROR EXIT */
	/*     ========== */
l_4000:  
	fprintf (nunit2, "\n\n+++++ gpark :  t=%12.4f ERROR : transaction attempts to park\n", TiMe);
	goto l_99;
	/* */
l_4100:  
	fprintf (nunit2, "\n\n+++++ gpark :  t=%12.4f ERROR : bus of taxi in gpark\n", TiMe);
	goto l_99;
	/* */
l_4200:  
	fprintf (nunit2, "\n\n+++++ gpark :  t=%12.4f ERROR : transporter%4d attempts to park at branch %4d\n", TiMe, ncar,
	     nterm);
	goto l_99;
	/* */
l_4300:  
	fprintf (nunit2, "\n\n+++++ gpark :  t=%12.4f ERROR  : iordr is false\n", TiMe);
	/* */
l_99:    
	return(FEHLER);
	/* */
}


