static char *SccsGPSSPrepare_h = "@(#)PEPSY:\tgpss_prepare.h\t1.3\t93/05/17 11:54:50";
/*   header-datei fuer strukturtyp-definitionen, typdef u.a.  */
typedef int	LOGICAL
/*  codierung der adressausgaenge  */
#define NORMAL 0
#define FEHLER 1
#define AUSGANG2 2
/*  FORTRAN-aehnlicher Aufruf der Systemunterprogramme  */
#define CALL(A) reply = A; \
                if (reply == FEHLER || reply == AUSGANG2) break; 
#define DCALL(A) reply = A; \
                if (reply == FEHLER) return(FEHLER); \
				if (reply == AUSGANG2) return(NORMAL) ; 
/*  logische wahrheitswerte  */
#define TRUE 1
#define FALSE 0
/* textkonstanten */
#define BLANKF  "    "
#define BLANKS  "        "
#define UNDERLINE "==============================================="
/* UNDERLINE derzeit 47 zeichen */
#define STARS  "********************"
/* STARS derzeit 20 zeichen */

/* makros  */
#define MAX(A,B)  ((A) > (B) ? (A) : (B))
#define MIN(A,B)  ((A) < (B) ? (A) : (B))
;
/*   einbinden standardbibliotheksfunktionen                  */
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <assert.h>
/*   strukturtyp - definitionen                               */
struct BIN {
	int	act;           /* momentane laenge */

	int	max;           /* maximale  laenge */
	int	access;        /* anzahl zugaenge  */
	int	leave;         /* anzahl abgaenge  */
	int	arrive;        /* anzahl aufrufe up ARRIVE */
	int	depart;        /* anzahl aufrufe up DEPART */
	double	total_wait;    /* gesamtwartezeit */
	double	last_change;   /* letzter aenderungszeitpunkt */
};
struct BINSTA {
	double	wait;           /* mittl. wartezeit */
	double	que_length;     /* mittl. warteschlangenlaenge */
	double	confi;          /* konfidenzintervall in % */
	double	dev;            /* abweichung wegen einschwingphase */
	double	end_osz;        /* ende einschwingphase */
};
struct CONFLIST {
	double	next;        /* zeitpunkt naechster aufruf von CONF */
	int	link;        /* zeiger auf nachfolgenden aufruf */
	double	int_length;      /* intervall - laenge */
	double	total_prev;  /* gesamtwartezeit intervall (i-1) */
	int	index;       /* zeiger auf con */
	int	autom;       /* indikator fuer automatik */
};
struct DELAY {
	int	del_set;       /* set - nummer */
	int	del_var;       /* variablen - nummer */
	int	ncomp;         /* anzahl der komprimierungen */
	double	taumax;        /* maximale delay-zeit */
	int	r_ptr;         /* zeiger auf letzten lesezugriff */
	int	w_ptr;         /* zeiger auf letzten schreibzugriff */
};
struct EQUATLIST {
	double	next;  /* zeitpunkt naechste zustandsbstimmung */
	int	link;  /* zeiger auf nachfolgenden aufruf */
	double	step;  /* schrittweite */
	double	ahead; /* look-ahead vermerk */
	double	last;  /* zeitpunkt letzte zustandsaenderung */
};
struct INTMA {
	int	method;    /* integrationsverfahren */
	double	init_step; /* anfangsschrittweite */

	int	sv_nr;     /* anzahl sv */
	int	dv_nr;     /* anzahl dv */
	double	min_step;  /* step min. */
	double	max_step;  /* step max. */
	double	rel_error; /* zulaessiger relativer fehler */
	int	limit;     /* obergrenze integratinsschritte */
};
struct INTSTA {
	int	count; /* anzahl der ausgefuehrten integrationsschritte */
	double	size;  /* mittlere schrittweite */
	int	cross; /* anzahl der crossings */
	int	find;  /* anz. der schritte zum auffinden der crossings */
};
struct HEADELEM {
	double	next; /* naechster zeitpunkt */
	int	link; /* zeiger auf nachfolgendens element */
};
struct FAC {
	int	occup;      /* belegungsvermerk */
	LOGICAL preemp; /* verdraengungsvermerk */
	int	phase;      /* bearbeitungsphase */
};
struct FAM {
	int	count;    /* anzahl der mitglieder */
	int	last_dup; /* nummer des zuletzt erzeugten duplikats */
};
struct MFAC {
	int	base;   /* zeilennr. des ersten service-elements in service */
	int	in_use; /* anzahl der belegten service-elemente */
	int	cap;    /* kapazitaet */
};
struct PLAN {
	int	in;  /* plan - in */
	int	out; /* plan -out */
};
struct PLOT1 {
	double	plot_begin;    /* zeitpunkt plot-beginn */
	double	plot_end;      /* zeitpunkt plot-ende */
	double	plot_step;     /* zeitintervall zur aufnahme der plot-daten */
	int	file_nr;       /* nummer der datei fuer plot-daten */
	int	setnr[7];      /* set-nummern der plot-variablen */
	int	varnr[7];      /* nummer der plot-variablen */
};
struct PLOT2 {
	double	x_scale; /* plot-schrittweite */
	int	extent;  /* druckindikator */
	int	y_scale; /* skalierung y-achse */
	double	y_min;   /* minimum y-achse */
	double	y_max;   /* maximum y-achse */
};
struct PLOT3 {
	char	symbol;       /* markierungssymbol fuer plot-variable */
	char	pvar_name[9]; /* kennzeichnung der plot-variablen */
};
struct POL {
	int	type;    /* stationstyp */
	int	station; /* typnummer */
	int	policy;  /* nummer der policy */
};
struct POOL {
	int	level;        /* bestand */
	int	pool_cap;     /* kapazitaet */
};
struct SOURCELIST {
	double	next;   /* generierungszeitpunkt */
	int	link;   /* zeiger auf nachfolgenden source-start */
	int	target; /* zieladresse */
	int	remain; /* anzahl der noch zu erzeugenden transactions */
	int	sourci; /* art der transaction der source */
};
struct SBM {
	struct STOR *addr; /* beginn eines abschnittes */
	int	stor_cap;        /* kapazitaet der storage */
};
struct STOR {
	int	length; /* laenge */
	int	mark;   /* kennung */
};
struct TAB {
	double	up_bound; /* obere intervallgrenze */
	int	frequ;    /* absolute haeufigkeit */
	double	sum_x;    /* stichprobensumme */
	double	sum_y;    /* werte der zugeordneten variablen */
};
struct TX_SYST {
	int	nr;       /* nummer der tr */
	int	dup;      /* duplikatsnummer */
	int	family;   /* LFAM */
	double	priority; /* prioritaet */
	int	retour;   /* zieladresse bei verdraengung */
	double	TiMe_left;   /* restzeit */
	int	elem;     /* rueckkehrvermerk */
	double	t_block;  /* blockierungszeitbunkt */
};
struct ACTIVLIST {
	double	next;     /* aktivierungszeitpunkt/ blockiervermerk */
	int	link;     /* zeiger auf nachfolgende aktivierung */
	int	target;   /* zieladresse */
	int	blk_link; /* zeiger auf nachfolger in block-kette */
};
struct OFFSET {
	int	fac;     /* beginn facilities */
	int	mfac;    /* beginn multifacilities */
	int	pool;    /* beginn pools */
	int	stor;    /* beginn storages */
	int	gate;    /* beginn gates */
	int	gath;    /* beginn gather-1 stationen */
	int	gathf;   /* beginn gather-2 stationen */
	int	userch;  /* beginn user-chains 1 */
	int	trig;    /* beginn trigger stationen 1 */
	int	userchf; /* beginn user-chains 2 */
	int	trigf;   /* beginn trigger stationen 2 */
	int	match;   /* beginn match-stationen */
	int	station;	/* beginn des Bahnsteiges */
	int	park;	/* beginn der parkzone */
	int	block;	/* bginn der blockstrecken */
};
struct UCHAIN {
	int	member; /* anzahl der mitglieder der user-chain */
	int	count_gone;  /* zaehler der abgeholten transactions */
};
struct IVAR {
	char	name[9]; /* name */
	int	i_value;   /* wert */
};
struct RVAR {
	char	name[9];  /* name */
	double	r_value;   /* wert */
};
struct PLOTFILE {
	char	fil_name[6];
	FILE * pointer;
};


/* Masken fuer Debug Ausgabe */

#define WARNING       0x000fffff
#define ERROR         0x00ffffff
#define LABEL         0x00000001
#define TRANSACTION   0x00000002
#define POLICY        0x00000004
#define RANDOM        0x00000008
#define CHAIN         0x00000010
#define CONF          0x00000020
#define TRANSPORT     0x00000040
#define STATION       0x00000080
#define BUS           0x00000100
#define TAXI          0x00000200
#define TRANSPORTER   0x00000400
#define FACILITY      0x00000800


