static char *SccsId = "@(#)PEPSY:\tgraph.c\t1.2\t92/03/27 11:56:18";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	graph(vfunc, idim, yll, yul, text)
char	text[];
double	yul ;
double	yll ;
int	idim ;
double	vfunc[][3];
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call graph(vfunc,idim,yll,yul,text)                           */
	/*    ***                                                               */
	/*    *** funktion :  graphische darstellung einer tabelle              */
	/*    *** parameter:  vfunc = datenbereich mit den werten               */
	/*    ***                     die graphisch darzustellen sind           */
	/*    ***             idim  = dimension von vfunc                       */
	/*    ***             yll   = untergrenze der histogrammsaeulen         */
	/*    ***             yul   = obergrenze der histogrammsaeulen          */
	/*    ***             text  = ueberschrift                              */
	/*    ***                                                               */
	extern int	next_int(), for_int();
	int	int0, idim1, i, iauto, int1, i1, j, i2, neg, inm, ind ;
	int	iabmax, iabmin, ipeak, ipart, imm, inty, intyc, jb, intyp, intyn ;
	int	intb, ihelp, iyscal, ixscal, ipl, mult, lim, ipr, ipos , case0;
	double	rm[101], scala[12];
	double	yuloc, rmax, ycorr, help, ymax, cmax, cmin, ylloc;
	double	rmin, abmax, abmin, peak, sclmax, sclmin, ym, v, yvall ;
	double	yscale, xvall, xmult, xabmax, xscale, yout ;
	char	kstern, kblanc, kminus, kplus ;
	char	line[102], lm[102], hilf ;
	double	epsx = 1.e-5;
	double	unendl = 1.e20;
	/*                                                                      */
	line[101] = '\0';
	lm[101] = '\0';
	kstern = '*';
	kblanc = ' ';
	kminus = '-';
	kplus = '+';

	/*                                                                      */
	/*    fehlerkontrolle                                                   */
	/*    ===============                                                   */
	ylloc = yll;
	yuloc = yul;
	idim1 = idim;
	if (idim1 > 100) 
		idim1 = 100;
	if (idim1 >= 5) 
		goto l_200;
	fprintf(nunit2, "\f ----- graph: warnung  keine graphische darstellung, da zu wenige werte vorhanden sind.\n");
	return(NORMAL);
	/*                                                                      */
l_200:  
	if (ylloc <= yuloc) 
		goto l_210;
	ylloc = 0.;
	yuloc = 0.;
	fprintf(nunit2, "\n\n +++++ graph: fehlerhafte grenzwerte, deshalb automatische bestimmung des masstabes.\n");
	/*                                                                      */
l_210:        
	for (i = 2; i <= idim1; ++i) {
		if (vfunc[i-1][1] < vfunc[i][1]) 
			continue;
		fprintf(nunit2, "\f +++++ graph: folge der x-werte nicht streng monoton steigend\n\n\n");
		return(NORMAL);
	};
	/*                                                                      */
	/*    initialisieren der variablen                                      */
	/*    ============================                                      */
	/*                                                                      */
	for (i = 0; i <= 100; ++i) {
		rm[i] = 0.0;
		lm[i] = kblanc;
		line[i] = kblanc;
	};
	/*                                                                      */
	for (i = 1 ; i <= 11 ; scala[i] = 0.0, i++)
		;
	/*                                                                      */
	rmax = 0.;
	rmin = 0.;
	iauto = 1;
	if (fabs(yuloc - ylloc)  >=  epsx) 
		iauto = 0;
	/*                                                                      */
	/*    bestimmen des abstands zweier werte der x-achse                   */
	/*    ===============================================                   */
	int0 = 100 / idim1;
	int1 = 1;
	if (int0 == 1) 
		goto l_310;
	int1 = int0 / 2;
	if (int0 - int1  >  int1) 
		int1 = int1 + 1;
	/*                                                                      */
	/*    bestimmen des werteintervalls der funktion                        */
	/*    ==========================================                        */
l_310:
	for (i = 1; i <= idim1; ++i) {
		if (fabs(vfunc[i][2])  <=  epsx) 
			continue;
		if (vfunc[i][2]  >  rmax) 
			rmax = vfunc[i][2];
		if (vfunc[i][2]  <  rmin) 
			rmin = vfunc[i][2];
		/*                                                                      */
		/*      linksbuendiges besetzen der ausgabeintervalle bis               */
		/*               zur halben intervallbreite                             */
		/*      =================================================               */
		i1 = (i - 1) * int0 + 1;
		for (j = 1; j <= int1; ++j) {
			i2 = j - 1;
			rm[i1+i2] = vfunc[i][2];
		};
	};
	/*                                                                      */
	/*    bestimmen der grenzen der histogrammsaeulen                       */
	/*    ===========================================                       */
	if (iauto == 1) 
		goto l_450;
	if ((yuloc > rmin) && (ylloc < rmax)) 
		goto l_445;
	iauto = 1 ;
	fprintf(nunit2, "\n\n +++++ graph: funktion liegt ausserhalb des angegebenen werteintervalls\n");
	fprintf(nunit2, "         deshalb automatische bestimmung der grenzen.\n");
	goto l_450;
l_445:      
	rmax = yuloc;
	rmin = ylloc;
	/*                                                                      */
	/*    ueberpruefen der randbedingungen                                  */
	/*    ================================                                  */
l_450:  
	if ((fabs(rmin) > epsx) || (fabs(rmax) > epsx)) 
		goto l_452;
	fprintf(nunit2, "\f +++++ graph: fabs(vfunc(i,2)) ist fuer alle i kleiner als epsx =%10.1e\n", epsx);
	fprintf(nunit2, "        deshalb keine graphische ausgabe.\n");
	return(NORMAL);
l_452:  
	if (rmax > -unendl  &&  rmin < unendl) 
		goto l_455;
	fprintf(nunit2, "\f +++++ graph: funktion ausserhalb des darstellbaren bereichs.\n");
	return(NORMAL);
l_455:  
	if (rmin < -unendl) 
		rmin = -unendl;
	if (rmax > unendl) 
		rmax = unendl;
	/*                                                                      */
	/*    initialisierungen                                                 */
	/*    =================                                                 */
	abmax = MAX(fabs(rmax), fabs(rmin));
	abmin = MIN(fabs(rmax), fabs(rmin));
	/*                                                                      */
	neg = 0;
	if (fabs(fabs(rmin) - abmax) <= epsx) 
		neg = 1;
	peak = abmax;
	if (iauto == 0  &&  (rmin > 0.  ||  rmax < 0.))   
		peak = abmax - abmin ;
	/*                                                                      */
	/*      bestimmung der oberen und unteren schranke und                  */
	/*              abbildung auf normintervall                             */
	/*      ==============================================                  */
	inm = 0;
	ind = 0;
	if (peak > 1.  &&  peak <= 10.) 
		goto l_525;
	/*                                                                      */
	if (peak  >  10.) 
		goto l_500;
	/*                                                                      */
	/*      abs. maximum wird groesser als 1                                */
	/*      ================================                                */
	for (inm = 1; inm <= 5; ++inm) {
		peak = peak * 10.;
		if (peak  >  1.) 
			goto l_470;
	};
l_470:  
	abmax = abmax * pow(10., (double)inm) ;
	abmin = abmin * pow(10., (double)inm) ;
	goto l_525;
	/*                                                                      */
	/*      abs. maximum wird kleiner gleich 10                             */
	/*      ===================================                             */
l_500:        
	for (ind = 1; ind <= 20; ++ind) {
		peak = peak / 10.;
		if (peak  <=  10.) 
			goto l_520;
	};
l_520:    
	abmax = abmax / pow(10., (double)ind);
	abmin =  abmin / pow(10., (double)ind);
	/*                                                                      */
	/*      bereichsueberschreitung                                         */
	/*      =======================                                         */
l_525:    
	if (abmin  <  1.e9) 
		goto l_530;
	fprintf(nunit2, "\f +++++ graph: geforderte genauigkeit fuer angegebenen bereich nicht darstellbar\n\n");
	return(NORMAL);
	/*                                                                      */
	/*      festlegen der schranken im normintervall                        */
	/*      ========================================                        */
l_530:    
	iabmax = for_int(abmax);
	iabmin = for_int(abmin);
	/*                                                                      */
	if (abmax -  (double)iabmax  >  epsx) 
		iabmax = iabmax + 1;
	if ((rmin > 0. || rmax < 0.) && iabmin != 0) 
		goto l_535;
	if (abmin - (double)iabmin  >  epsx) 
		iabmin = iabmin + 1;
	/*                                                                      */
	/*      bestimmen der oberen und unteren schranke der funktionswerte    */
	/*      ============================================================    */
l_535:      
	sclmax =  (double)iabmax / pow(10., (double)inm);
	sclmin =  (double)iabmin / pow(10., (double)inm);
	if (ind  ==  0) 
		goto l_540;
	sclmax =  (double)iabmax * pow(10., (double)ind);
	sclmin =  (double)iabmin * pow(10., (double)ind);
l_540:    
	if (iauto  ==  0) 
		goto l_545;
	abmax = sclmax;
	abmin = sclmin;
	goto l_550;
l_545:      
	abmax = MAX(fabs(rmax), fabs(rmin));
	abmin = MIN(fabs(rmax), fabs(rmin));
	/*                                                                      */
	/*    skalieren der y - achse                                           */
	/*    =======================                                           */
l_550:  
	ipeak = for_int (peak);
	if (peak - (double)ipeak  >  epsx) 
		ipeak = ipeak + 1;
	ipart = ipeak;
	if (ipart  <  4) 
		ipart = ipart * 2;
	if (rmin > 0.  ||  rmax < 0.) 
		goto l_575;
	/*                                                                      */
	/*      fuer positive und negative funktionserwerte                     */
	/*      ===========================================                     */
	/*        initialisierungen                                             */
	/*        =================                                             */
	imm = iabmax + iabmin;
	ym  = sclmax;
	v   =  (double)ipeak /  (double)imm;
	/*                                                                      */
	/*        verteilung der 50 zeilen                                      */
	/*        ========================                                      */
	inty  = for_int( v * 50. );
	intyc = 50 - inty;
	/*                                                                      */
	/*        reduktion auf notwendige zeilen                               */
	/*            und skalierungsabstand                                    */
	/*        ===============================                               */
	inty  = inty - inty % ipart;
	yvall = ym /  (double)inty;
	for (jb = 1; jb <= ipeak; ++jb) {
		if ( (intyc - jb) * yvall  <  abmin) 
			goto l_565;
	};
	/*                                                                      */
l_565:      
	if (neg  ==  1) 
		goto l_570;
	intyp = inty;
	intyn = intyc - (jb - 1);
	goto l_590;
l_570:        
	intyp = intyc - (jb - 1);
	intyn = inty;
	goto l_590;
	/*                                                                      */
	/*      fuer funktionswerte nur auf einer seite der x-achse             */
	/*      ===================================================             */
l_575:    
	ym = sclmax - sclmin;
	/*                                                                      */
	/*        verteilung der 50 zeilen und skalierungsabstand               */
	/*        ===============================================               */
	inty  = 50 - 50 % ipart;
	yvall = ym /  (double)inty;
	/*                                                                      */
	if (neg  ==  1) 
		goto l_580;
	intyp = inty;
	intyn = 0;
	goto l_590;
l_580:        
	intyp = 0;
	intyn = inty;
	/*                                                                      */
	/*      korrekturfaktor und abstand der auszugebenden                   */
	/*                     skalenwerte                                      */
	/*      =============================================                   */
l_590:      
	ycorr = yvall / 1000.;
	intb = inty / ipeak ;
	if (inty  <  6 * ipeak) 
		goto l_592;
	for (i = 2; i <= 5; i += 3) {
		ihelp = intb / i;
		help  =  (double)intb / (double)i;
		if ( (double)ihelp  ==  help) 
			intb = ihelp;
	};
l_592:    
	if (intb  ==  1) 
		intb = 5;
	if (intb  <=  3) 
		intb = intb * 2;
	/*                                                                      */
	/*       schranken des ausgabeintervalls                                */
	/*        ===============================                               */
	if (neg  ==  1) 
		goto l_593;
	ymax = sclmax;
	cmax = abmax;
	cmin = abmin;
	goto l_597;
l_593:      
	ymax = sclmin;
	cmax = abmin;
	cmin = abmax;
	/*                                                                      */
	/*    ueberschrift der graphischen darstellung                          */
	/*    ========================================                          */
l_597:  
	fprintf(nunit2, "\f%15s%-32s%\n", BLANKF, text);
	/*                                                                      */
	/*    bestimmen des massstabes der achsen                               */
	/*    ===================================                               */
	/*      y - achse                                                       */
	/*      =========                                                       */
	if (rmax >= 0.  &&  rmin <= 0.) 
		goto l_600;
	iyscal = for_int(log10(sclmin));
	help   = yvall / pow(10., (double)iyscal);
	goto l_610;
l_600:    
	iyscal = 0;
	help = yvall;
	/*                                                                      */
	/*        bestimmen des skalenfaktors                                   */
	/*        ===========================                                   */
l_610:        
	for (i = 1; i <= 8; ++i) {
		if (help  >=  0.2) 
			goto l_615;
		iyscal = iyscal - 1;
		help = help * 10.;
	};
l_615:  
	if (sclmax / pow(10., (double)iyscal) >= 1.e9) 
		iyscal = 0;
	yscale = pow(10., (double)iyscal);
	/*                                                                      */
	/*      x - achse                                                       */
	/*      =========                                                       */
	xvall  = fabs(vfunc[2][1] - vfunc[1][1]);
	ixscal = 0;
	if (vfunc[1][1] > 0.) 
		ixscal = for_int (log10(vfunc[1][1]));
	if (vfunc[idim1][1] < 0.) 
		ixscal = for_int(log10(fabs(vfunc[idim1][1])));
	xmult = 1;
	if (int0 == 1) 
		xmult = 10;
	if (int0 >= 7  &&  int0 <= 10) 
		xmult = 5;
	if (int0 >= 2  &&  int0 <=  6) 
		xmult = 3;
	help = (vfunc[1][1] + xmult * xvall) / pow(10., (double)ixscal);
	xabmax = MAX(fabs(vfunc[1][1]), fabs(vfunc[idim1][1])) ;
	xabmax = xabmax / pow(10., (double)ixscal);
	/*                                                                      */
	/*        bestimmen des skalenfaktors                                   */
	/*        ===========================                                   */
	for (i = 1; i <= 8; ++i) {
		if (xabmax  >=  1000.) 
			goto l_625;
		ihelp = for_int (help);
		if (fabs(help - (double)ihelp)  <=  epsx) 
			goto l_625;
		ixscal = ixscal - 1;
		xabmax = xabmax * 10.;
		help   = help * 10.;
	};
	/*                                                                      */
l_625:    
	if (xabmax  >=  10000.) 
		ixscal = 0;
	xscale = pow(10., (double)ixscal);
	/*                                                                      */
	/*    graphische darstellung der histogrammsaeulen                      */
	/*    ============================================                      */
	if (intyp == 0) 
		goto l_700;
	/*                                                                      */
	/*      teil oberhalb der x - achse                                     */
	/*      ===========================                                     */
	j = 0;
	if ((intyp % intb) != 0) 
		j = intb - intyp % intb;
	for (i = 1; i <= intyp; ++i) {
		/*                                                                      */
		/*        angegebene grenzen verlassen                                  */
		/*        ============================                                  */
		if ((rmin <= 0. || ymax >= cmin) && ymax <= cmax) 
			goto l_635;
		for (i1 = 1 ; i1 <= 100 ; line[i1] = ' ', i1++)
			;
		goto l_645;
l_635:    
		for (i1 = 1; i1 <= 100; ++i1) {
			/*                                                                      */
			/*          bearbeiten einer zeile                                      */
			/*          ======================                                      */
			if (line[i1] == kplus) 
				line[i1] = kstern;
			if (line[i1] != kblanc) 
				continue;
			if (rm[i1] - ycorr  >=  ymax - yvall) 
				line[i1] = kstern;
			if (ymax  <=  cmax - yvall) 
				continue;
			if (rm[i1] - ycorr  >=  cmax) 
				line[i1] = kplus;
		};
		/*                                                                      */
		/*          ausgabe der zeile                                           */
		/*          =================                                           */
l_645:        
		j = j + 1 ;
		if (j > 1 ) 
			goto l_650;
		yout = ymax / yscale;
		fprintf(nunit2, " %10.0f I%s\n", yout, line);
		goto l_655;
l_650:          
		fprintf(nunit2, "            I%s\n", line);
l_655:        
		ymax = ymax - yvall ;
		if (j == intb) 
			j = 0;
		/*                                                                      */
	};
	/*                                                                      */
	/*      ausgeben der x-achse                                            */
	/*      ====================                                            */
	/*          festlegen der skalierung (mult: abst. zweier werte)         */
	/*          ===================================================         */
l_700:        
	ipl  = int1;
	mult = 1;
	if (int0  ==  1) 
		mult = 10;
	if (int0 >= 2  &&  int0 <= 6) 
		mult = 5;
	if (int0 >= 7  &&  int0 <= 10) 
		mult = 3;
	/*                                                                      */
	/*          festlegen der druckpositionen                               */
	/*          =============================                               */
	lim = idim1 * int0 ;
	for (i = 1; i <= lim; ++i) {
		if (i == ipl) 
			goto l_710;
		lm[i] = kminus;
		continue;
l_710:            
		lm[i] = kplus ;
		ipl   = ipl + mult * int0;
	};
	if ( (idim1 % mult) == 0  &&  mult != 1 ) 
		lm[lim] = kplus ;
	/*                                                                      */
	/*        bestimmung des skalierungsformates                            */
	/*        ==================================                            */
	ipr = 16 - int0;
	if (ipr == 2) 
		ipr = 3;
	if (ipr == 0) 
		ipr = 2;
	if (ipr == -4) 
		ipr = 1;
	/*                                                                      */
	/*        besetzen der skalierung                                       */
	/*        =======================                                       */
	ipos = 0;
	for (i = 1; i <= idim1; i += mult) {
		ipos = ipos + 1;
		scala[ipos] = vfunc[i][1] / xscale;
	};
	if ( (idim1 % mult) != 0  ||  mult == 1) 
		goto l_740;
	ipos = ipos + 1;
	scala[ipos] = vfunc[idim1][1] / xscale ;
	/*                                                                      */
	/*      koordinierung des weiteren programmflusses durch                */
	/*           simulation von unterprogrammaufrufen                       */
	/*      ================================================                */
l_740:    
	if (intyp  !=  0) 
		goto l_760;
	/*                                                                      */
	/*        keine positiven werte vorhanden                               */
	/*        ===============================                               */
	case0 = 0;
	/*                                                                      */
	/*        call skalierung                                               */
	/*        ===============                                               */
	goto l_860;
	/*                                                                      */
	/*        achsenausgabe                                                 */
	/*        =============                                                 */
l_750:      
	hilf = lm[lim+1];
	lm[lim+1] = '\0';
	fprintf(nunit2, "            I%s\n", lm);
	lm[lim+1] = hilf;
	/*                                                                      */
	/*        call ausgabe des negativen teils des histogramms              */
	/*        ================================================              */
	goto l_800;
	/*                                                                      */
	/*        ende von graph                                                   */
	/*        ==============                                                */
l_752:      
	fprintf(nunit2, "\n\n mass-stab x-achse:%10.2e\n  mass-stab y-achse:%10.2e\n",
	    xscale, yscale);
	return(NORMAL);
	/*                                                                      */
	/*                                                                      */
	/*        positive werte vorhanden                                      */
	/*        ========================                                      */
l_760:      
	case0 = 1;
	if (intyn  ==  0) 
		goto l_770;
	/*                                                                      */
	/*          negative werte vorhanden                                    */
	/*          ========================                                    */
	yout = 0.;
	/*                                                                      */
	/*          achsenausgabe                                               */
	/*          =============                                               */
	hilf = lm[lim+1];
	lm[lim+1] = '\0';
	fprintf(nunit2, " %10.0f I%s\n", yout, &lm[1]);
	lm[lim+1] = hilf;
	/*                                                                      */
	/*          call ausgabe des negativen teils des histogramms            */
	/*          ================================================            */
	goto l_800;
	/*                                                                      */
	/*        abschliessende arbeiten                                       */
	/*        =======================                                       */
	/*          achsenausgabe                                               */
	/*          =============                                               */
l_770:        
	hilf = lm[lim+1];
	lm[lim+1] = '\0';
	fprintf(nunit2, "            I%s\n", lm);
	/*                                                                      */
	/*          call skalierung                                             */
	/*          ===============                                             */
	goto l_860;
	/*                                                                      */
	/*        ende von graph                                                   */
	/*        ==============                                                */
l_771:      
	fprintf(nunit2, "\n\n mass-stab x-achse:%10.2e\n  mass-stab y-achse:%10.2e\n",
	    xscale, yscale);
	return(NORMAL);
	/*                                                                      */
	/*    unterprogramm darstellung des negativen teils                     */
	/*                   des histogramms                                    */
	/*    =============================================                     */
	/*      vorbereitungen                                                  */
	/*      ==============                                                  */
l_800:        
	for (i1 = 1; i1 <= 100; ++i1) {
		line[i1] = kblanc;
		if (rm[i1] < 0.) 
			line[i1] = kstern;
	};
	j = 0;
	if (case0  ==  1) 
		ymax = 0.;
	ymax = ymax + yvall;
	for (i = 1; i <= intyn; ++i) {
		/*                                                                      */
		/*        angegebene grenzen verlassen                                  */
		/*        ============================                                  */
		if (-ymax >= -cmin && (-ymax <= -cmax || rmax >= 0.)) 
			goto l_830;
		for (i1 = 1 ; i1 <= 100 ; line[i1] = ' ', i1++)
			;
		goto l_838;
		/*                                                                      */
		/*          bearbeiten einer zeile                                      */
		/*          ======================                                      */
l_830:        
		for (i1 = 1; i1 <= idim1; ++i1) {
			if (rm[i1] + ycorr  <=  -ymax + yvall) 
				line[i1] = kstern;
			if (line[i1]  ==  kblanc) 
				continue;
			if (rm[i1] + ycorr  >  -ymax + yvall) 
				line[i1] = kblanc;
			if (-ymax  >=  -cmin + yvall) 
				continue;
			if (rm[i1] + ycorr  <=  -cmin) 
				line[i1] = kplus;
		};
l_838:      
		j = j + 1;
		if (j != intb ) 
			goto l_840;
		yout = -ymax / yscale;
		fprintf(nunit2, " %10.0f I%s\n", yout, line);
		goto l_845;
l_840:          
		fprintf(nunit2, "            I%s\n", line);
l_845:      
		ymax = ymax + yvall ;
		if (j == intb) 
			j = 0 ;
	};
	/*                                                                      */
	/*      bestimmen der rueckkehradresse                                  */
	/*      ==============================                                  */
	if (case0  ==  0) 
		goto l_752;
	if (case0  ==  1) 
		goto l_770;
	/*                                                                      */
	/*     ende unterprogramm                                                 */
	/*                                                                      */
	/*    unterprogramm skalierung der x-achse                              */
	/*    ====================================                              */
	/*                                                                      */
l_860: 
	switch (ipr) {
	case 1: 
		goto l_861;
	case 2: 
		goto l_862;
	case 3: 
		goto l_863;
	case 4: 
		goto l_864;
	case 5: 
		goto l_865;
	case 6: 
		goto l_866;
	case 7: 
		goto l_867;
	case 8: 
		goto l_868;
	case 9: 
		goto l_869;
	case 10: 
		goto l_870;
	case 11: 
		goto l_871;
	case 12: 
		goto l_872;
	case 13: 
		goto l_873;
	case 14: 
		goto l_874;
	case 15: 
		goto l_875;
	}
	/*                                                                      */
	fprintf(nunit2, "\n\n+++++ graph: fehler im adressverteiler  ipr=%3d\n",
	    ipr);
	return(NORMAL);
	/*                                                                      */
l_861:  
	fprintf(nunit2, "    ");
	for (i = 1; i <= ipos; i = i + 1)
		fprintf(nunit2, "              %6.0f", scala[i]);
	fprintf(nunit2, "\n");
	goto l_880;
l_862:  
	fprintf(nunit2, "     ");
	for (i = 1; i <= ipos; i = i + 1)
		fprintf(nunit2, "          %6.0f", scala[i]);
	fprintf(nunit2, "\n");
	goto l_880;
l_863:  
	fprintf(nunit2, "       ");
	for (i = 1; i <= ipos; i = i + 1)
		fprintf(nunit2, "        %6.0f", scala[i]);
	fprintf(nunit2, "\n");
	goto l_880;
l_864:  
	fprintf(nunit2, "         ");
	for (i = 1; i <= ipos; i = i + 1)
		fprintf(nunit2, "      %6.0f", scala[i]);
	fprintf(nunit2, "\n");
	goto l_880;
l_865:  
	fprintf(nunit2, "         ");
	for (i = 1; i <= ipos; i = i + 1)
		fprintf(nunit2, "     %6.0f", scala[i]);
	fprintf(nunit2, "\n");
	goto l_880;
l_866:
	for (i = 1; i <= ipos; i = i + 1)
		fprintf(nunit2, "             %6.0f           ", scala[i]);
	fprintf(nunit2, "\n");
	goto l_880;
l_867:
	for (i = 1; i <= ipos; i = i + 1)
		fprintf(nunit2, "             %6.0f        ", scala[i]);
	fprintf(nunit2, "\n");
	goto l_880;
l_868:
	for (i = 1; i <= ipos; i = i + 1)
		fprintf(nunit2, "            %6.0f      ", scala[i]);
	fprintf(nunit2, "\n");
	goto l_880;
l_869:
	for (i = 1; i <= ipos; i = i + 1)
		fprintf(nunit2, "            %6.0f   ", scala[i]);
	fprintf(nunit2, "\n");
	goto l_880;
l_870:
	for (i = 1; i <= ipos; i = i + 1)
		fprintf(nunit2, "           %6.0f             ", scala[i]);
	fprintf(nunit2, "\n");
	goto l_880;
l_871:
	for (i = 1; i <= ipos; i = i + 1)
		fprintf(nunit2, "           %6.0f       ", scala[i]);
	fprintf(nunit2, "\n");
	goto l_880;
l_872:
	for (i = 1; i < ipos; i = i + 1)
		fprintf(nunit2, "          %6.0f    ", scala[i]);
	fprintf(nunit2, "      %6.0f\n", scala[i+1]);
	goto l_880;
l_873:  
	fprintf(nunit2, " ");
	for (i = 1; i <= ipos; i = i + 1)
		fprintf(nunit2, "         %6.0f", scala[i]);
	fprintf(nunit2, "\n");
	goto l_880;
l_874:  
	fprintf(nunit2, "     ");
	for (i = 1; i < ipos; i = i + 1)
		fprintf(nunit2, "    %6.0f", scala[i]);
	fprintf(nunit2, "  %6.0f\n", scala[i+1]);
	goto l_880;
l_875:  
	fprintf(nunit2, "     ");
	for (i = 1; i < ipos; i = i + 1)
		fprintf(nunit2, "    %6.0f", scala[i]);
	fprintf(nunit2, "   %6.0f\n", scala[i+1]);
	/*                                                                      */
	/*                                                                      */
	/*    bestimmen der rueckkehradresse                                    */
	/*    ==============================                                    */
l_880:  
	if (case0  ==  0) 
		goto l_750;
	if (case0  ==  1) 
		goto l_771;
	/*                                                                      */
}


