static char *SccsId = "@(#)PEPSY:\tgride.c\t1.4\t93/10/20 14:52:59";
#include <stdio.h>
#include <fcntl.h>
#include "xxalloc.h"
#include "gpss_prepare.h"
#include "gpss_decl.h"
#include <math.h>
#include <string.h>

static double	**caradd;

FILE *fopen ();

int	gride(cstart, istart, id, ctarg, itarg, idn)
char	cstart[];
int	istart;
int	id;
char	ctarg[];
int	itarg;
int	idn;
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	/*     ***  */
	/*     *** CALL GRIDE(CSTART,ISTART,ID,CTARG,ITARG,IDN,*9000,*9999) */
	/*     ***  */
	/*     *** PURPOSE : JOURNEY OF A TRANSPORTER FROM ISTART */
	/*     ***           TO ITARG WITHOUT FIXED ROUTING AND WEIGHTED */
	/*     ***           ACCORDING TO "GESGEW" */
	/*     *** PARAMETERS: CSTART = TYPE OF STARTING POINT */
	/*     ***                      = 'T': TERMINAL */
	/*     ***                      = 'B': BRANCH */
	/*     ***             ISTART = STARTINGPOINT OF THE TRANSPORTER */
	/*     ***             ID     = LABEL OF SUBROUTINE CALL */
	/*     ***             CTARG  = TYPE OF DESTINATION */
	/*     ***                      = 'T': TERMINAL */
	/*     ***                      = 'B': BRANCH */
	/*     ***             ITARG  = DESTINATION OF JOURNEY */
	/*     ***             IDN    = REACTIVATION LABEL  */
	/*     ***             *9000  = EXIT TO FLOW CONTROL */
	/*     ***             *9999  = ERROR EXIT */
	/*     ***  */
	/* */

	int	art, blocnr, bloc2, from, i, ncar, partnr, zart, routnr, sectnr, segmnr, to;
	int	k, lastbl, line, nact, nnode, np;
	short	printf;
	char	cf[2];
	double	fnode, local_TiMe;
	double	help1, help2;

	extern int	tchain(), policy(), block(), dblock(), lotse(), next_int();

#ifdef DEBUG
dprint(TRANSPORTER, "gride: cstart %s, istart %d, id %d, ctarg %s, itarg %d, idn %d\n", cstart, istart, id, ctarg, /* */
	     itarg, idn);
#endif

	if (caradd == (double **) 0)
		caradd = d2_alloc(0, ZCAR + 1, 0, 3);

	/*     INITIALIZE AND TEST FOR ERRORS */
	/*     ============================== */
	ncar   = next_int(txadd[row_txact][1]);
	if (ncar == 0)                        
		goto l_4000;
	if (txi[row_txact] != 3)              
		goto l_4100;
	if ( (strcmp(cstart, "t") != 0)  && 
	    (strcmp(cstart, "b") != 0 ))        
		goto l_4500;
	if (strcmp(ctarg, "t") == 0 ) {
		if (itarg < 1 || itarg > ansta) {
#ifdef DEBUG
dprint(TRANSPORTER, "gride: ansta == %d\n", ansta); /* */
#endif
			goto l_4400;
		}
	} else if (strcmp(ctarg, "b") == 0) {
		if (itarg < 1 || itarg > anverz)  {
#ifdef DEBUG
dprint(TRANSPORTER, "gride: anverz == %d\n", anverz); /* */
#endif
			goto l_4400;
		}
	} else {
		goto l_4500;
	}
	printf =  FALSE;
	/* */
	zart = 1;
	if (strcmp(ctarg, "b") == 0) 
		zart = 2;
	segmnr = next_int(tarma[ncar][6]);
	if (segmnr == 0) {
		caradd[ncar][1] = (double) itarg + zart * 0.1;
		caradd[ncar][2] = (double) idn ;
		from = next_int(carma[ncar][6]);
		art  = next_int(carma[ncar][6] * 10.0) - from * 10;
		if (art == 3) 
			goto l_4200;
		strcpy(cf, "t");
		if (art == 2) 
			strcpy(cf, "b");
		if (from == istart && strcmp(cf, cstart) == 0) 
			goto l_200;
		goto l_4600;
	} else {
#ifdef DEBUG
dprint(TRANSPORTER, "gride: 2 caradd[%d][1] %f, caradd[%d][2] %f \n",  /* */
		    ncar, caradd[ncar][1], ncar, caradd[ncar][2]);
#endif
		if ( next_int(caradd[ncar][1]) != next_int((double)itarg + zart * 0.1)
		     ||   next_int(caradd[ncar][2]) != idn ) 
			goto l_4700;
	}
	/* */
	/*     PROCESS SEGMENT */
	/*     =============== */
	partnr = next_int(tarma[ncar][7]);
	if ( partnr != 0 && tarma[ncar][4] >= 0.0  && (iprint == 1 || jprint[23] == 1) && jprint[23] > -1 ) {
		fprintf (nunit2, "gride :  t=%12.4f  trnsporter%4d leaves section%4d\n", TiMe, ncar, segma[segmnr][partnr]);
		printf =  TRUE;
	}
l_100: 
	partnr = partnr + 1;
	if (partnr <= zsegm1 && segma[segmnr][partnr] != 0) 
		goto l_500;
	/* */
	/*     END OF SECTION REACHED?  */
	/*     =======================  */
l_200: 
	from = next_int(carma[ncar][6]);
	art  = next_int(carma[ncar][6] * 10.) - from * 10;
	if (art == 3) 
		goto l_4200;
	if (art == 2) 
		from = from + ansta;
	to = itarg;
	if (strcmp(ctarg, "b") == 0) 
		to = to + ansta;
	if (from == to) 
		goto l_2000;
	/* */
	/*     DETERMINE NEW SEGMENT */
	/*     ===================== */
	switch (lotse(from, to, &segmnr))  {
	case FEHLER: 
		goto l_99;
	}
	tarma[ncar][7] = 0.0;
	partnr        = 0;
	/* */
	/*     STATISTICS: OCCUPATION OF NETWORK  */
	/*     =================================  */
	netsta[segmnr][5] = netsta[segmnr][5] + 1.0;
	/* */
	/*     OUTPUT */
	/*     ====== */
	if ((iprint == 1 || jprint[23] == 1 || jprint[23] == 2) && jprint[23] != -1 && jprint[23] != -2) {
		i = 0 ;
l_900:   
		i = i + 1;
		if (i <= zsegm1  &&  segma[segmnr][i] != 0) 
			goto l_900;
		fnode = sectma[segma[segmnr][i-1]][2];
		nnode = next_int(fnode);
		if ((next_int(fnode * 10.0) - nnode * 10) == 1) {
			strcpy(cf, "t");
		} else {
			strcpy(cf, "b");
		}
		if (itarg == nnode && strcmp(ctarg, cf) == 0) {
			if (printf) {
				fprintf (nunit2, "                         and traverses segment%4d to %1s%4d\n", segmnr,
				     ctarg, itarg);
			} else {
				fprintf (nunit2, "gride :  t=%12.4f  transporter%4d traverses segment%4d to %1s%4d\n", TiMe,
				     ncar, segmnr, ctarg, itarg);
			}
		} else {
			if (printf) {
				fprintf (nunit2, "                         and traverses segment%4d to %1s%4d via %1s%4d\n",
				     segmnr, ctarg, itarg, cf, nnode);
			} else {
				fprintf (nunit2, "gride :  t=%12.4f  transporter%4d traverses segment%4d to %1s%4d\n                                          via %1s%4d\n",
				     TiMe, ncar, segmnr, ctarg, itarg, cf, nnode);
			}
		}
		printf =  TRUE;
	}
	/* */
	goto l_100;
	/* */
l_500: 
	sectnr        = segma[segmnr][partnr];
	blocnr        = next_int(sectma[sectnr][4]);
	tarma[ncar][6] = (double)segmnr;
	/* */
	/*     COLLECTION OF STATISTICAL DATA: WAS BLOCKED AT BLOCKING SECTION  */
	/*     ===============================================================  */
	if (tarma[ncar][4] < 0) {
		tarma[ncar][4]  = fabs(tarma[ncar][4]);
		statis[ncar][4] = statis[ncar][4] + TiMe - 
		    tx_system[row_txact].t_block;
		if (next_int(carma[ncar][4]) == 0) {
			statis[ncar][1] = statis[ncar][1] + TiMe - 
			    tx_system[row_txact].t_block;
		} else {
			statis[ncar][2] = statis[ncar][2] + TiMe - 
			    tx_system[row_txact].t_block;
			statis[ncar][7] = statis[ncar][7] + carma[ncar][4] * 
			    (TiMe - tx_system[row_txact].t_block);
		}
		/* */
		netsta[segmnr][6] = netsta[segmnr][6] + TiMe - 
		    tx_system[row_txact].t_block;
		/* */
		blocst[sectnr][1] = blocst[sectnr][1] + 
		    (blocst[sectnr][2] - blocst[sectnr][3]) * 
		    (TiMe - blocst[sectnr][4]);
		blocst[sectnr][3] = blocst[sectnr][3] + 1;
		blocst[sectnr][4] = TiMe;
		/* */
	}
	/* */
	/*     IS THE NEXT SECTION A BLOCKING SECTION? */
	/*     ======================================= */
	lastbl = next_int(tarma[ncar][4]);
	tarma[ncar][4] = 0.0;
	/* */
	/*     OCCUPY BLOCKING SECTION  */
	/*     =======================  */
	if (blocnr != 0) {
		tarma[ncar][4] = (double)blocnr;
		if (lastbl != blocnr) {
			if (blocve[blocnr][1] == 0 && blocve[blocnr][2] != 0) {
				blocve[blocnr][2] = blocve[blocnr][2] - 1;
				if ((iprint == 1 || jprint[23] == 1 || 
				    jprint[23] == 2) && jprint[23] != -1 && jprint[23] != -2) {
					bloc2 = blocve[blocnr][2];
					if (bloc2 == 0) {
						if (printf) {
							fprintf (nunit2, "                         and blocks blocking section%4d\n",
							     blocnr);
						} else {
							fprintf (nunit2, "gride :  t=%12.4f  transporter%4d blocks blocking section%4d\n",
							     TiMe, ncar, blocnr);
						}
					} else {
						if (printf) {
							fprintf (nunit2, "                         and blocks blocking section%4d ( remaining unused capacity :%4d )\n",
							     blocnr, bloc2);
						} else {
							fprintf (nunit2, "gride :  t=%12.4f  transporter%4d blocks blocking section%4d\n                                          ( remaining unused capacity:%4d )\n",
							     TiMe, ncar, blocnr, bloc2);
						}
					}
					printf =  TRUE;
				}
			} else {
				goto l_1000;
			}
		}
	}
	/* */
	/*     HAS A BLOCKING SECTION BEEN TRAVERSED: POSSIBLY UNBLOCK */
	/*     ======================================================= */
	if (lastbl != 0 && lastbl != blocnr) {
		blocve[lastbl][2] = blocve[lastbl][2] + 1;
		bloc2 = blocve[lastbl][2];
		if ((iprint == 1 || jprint[23] == 1 || 
		    jprint[23]  == 2) && jprint[23] != -1 && jprint[23] != -2) {
			if (bloc2 == 1) {
				if (printf) {
					fprintf (nunit2, "                         and frees blocking section%4d\n", lastbl);
				} else {
					fprintf (nunit2, "gride :  t=%12.4f  transporter%4d frees blocking section %4d\n",
					     TiMe, ncar, lastbl);
				}
			} else {
				if (printf) {
					fprintf (nunit2, "                         and frees blocking section%4d (unused capacity:%4d )\n",
					     lastbl, bloc2);
				} else {
					fprintf (nunit2, "gride :  t=%12.4f  transporter%4d fress blocking section%4d\n                                          ( unused capacity: %4d )\n",
					     TiMe, ncar, lastbl, bloc2);
				}
			}
		}
		if (blocve[lastbl][1] == 0 && bloc2 == 1) 
			dblock(15, lastbl, 0, 1);
	}
	/* */
	/*     TRAVERSE SECTION */
	/*     ================ */
	tarma[ncar][7] = (double)partnr;
	local_TiMe = fabs(sectma[sectnr][3]) / ((carma[ncar][5] * sectma[sectnr][5]));
	carma[ncar][6] = sectma[sectnr][2];
	if (kprint == 1) {
		nact = 33;
		fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[row_txact], ncar, nact, sectnr);
		fprintf (nunit23, "%4d%12.4f\n", next_int(carma[ncar][4]), local_TiMe);
	}
	/* */
	/* */
	/*     COLLECTION OF STATISTICAL DATA:  */
	/*     DURATION OF JOURNEY AND OCCUPATION OF NETWORK */
	/*     ============================================= */
	if (next_int(carma[ncar][4]) > 0) {
		statis[ncar][2] = statis[ncar][2] + local_TiMe;
		statis[ncar][7] = statis[ncar][7] + carma[ncar][4] * local_TiMe;
		statis[ncar][9] = statis[ncar][9] + fabs(sectma[sectnr][3]);
	} else {
		statis[ncar][1] = statis[ncar][1] + local_TiMe;
		statis[ncar][8] = statis[ncar][8] + fabs(sectma[sectnr][3]);
	}
	/* */
	netsta[segmnr][6] = netsta[segmnr][6] + local_TiMe;
	/* */
	/*     ACTUAL JOURNEY */
	/*     ============== */
	activlist[row_txact].next = TiMe + local_TiMe;
	activlist[row_txact].target = (double)id;
	tchain(3, row_txact);
	goto l_90;
	/* */
	/*     BLOCKING SECTION IS OCCUPIED: BLOCK TRANSPORTER */
	/*     =============================================== */
l_1000: 
	tarma[ncar][4] = -(double)lastbl - 0.1;
	tx_system[row_txact].t_block = TiMe;
	k = offset.match + zmatch + zsta + zsta + blocnr - 1;
	activlist[row_txact].next = -(double)k;
	activlist[row_txact].target = (double)id;
	policy(15, blocnr, 0, &line, &np);
	block(15, blocnr, 0, line);
	if ((iprint == 1 || jprint[23] == 1 || jprint[23] == 2) && 
	    jprint[23] != -1 && jprint[23] != -2) {
		if (printf) {
			fprintf (nunit2, "                         and is blocked at blocking section%4d\n", blocnr);
		} else {
			fprintf (nunit2, "gride :  t=%12.4f  transporter%4d is blocked at blocking section%4d\n", TiMe, ncar,
			     blocnr);
		}
	}
	/* */
	if (kprint == 1) {
		nact = 37;
		fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[row_txact], ncar, nact, sectnr);
	}
	/* */
	/*     COLLECTION OF STATISTICAL DATA: BLOCKING SECTIONS */
	/*     ================================================= */
	blocst[sectnr][1] = blocst[sectnr][1] + 
	    (blocst[sectnr][2] - blocst[sectnr][3]) * 
	    (TiMe - blocst[sectnr][4]);
	blocst[sectnr][2] = blocst[sectnr][2] + 1;
	blocst[sectnr][4] = TiMe;
	/* */
	goto l_90;
	/* */
	/*     END OF TRANSPORT */
	/*     ================ */
l_2000: 
	caradd[ncar][1] = 0.0;
	caradd[ncar][2] = 0.0;
	tarma[ncar][5] = 0.0;
	tarma[ncar][6] = 0.0;
	tarma[ncar][7] = 0.0;
	activlist[row_txact].next = TiMe;
	activlist[row_txact].target = (double)idn;
	switch (tchain(3, row_txact))  {
	case FEHLER: 
		goto l_90;
	}
	if (kprint == 1) {
		nact = 38;
		fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[row_txact], ncar, nact, itarg);
		fprintf (nunit23, "%1s\n", ctarg);
	}
	/* */
l_90: 
	return(AUSGANG2);
	/* */
	/*     ERROR EXIT */
	/*     ========== */
l_4000:  
	fprintf (nunit2, "\n\n+++++ gride :  t=%12.4f ERROR  : transation attempts to move  \n", TiMe);
	goto l_99;
	/* */
l_4100:  
	fprintf (nunit2, "\n\n+++++ gride :  t=%12.4f ERROR  : bus or taxi in gride\n", TiMe);
	goto l_99;
	/* */
l_4200:  
	fprintf (nunit2, "\n\n+++++ gride :  t=%12.4f ERROR  : transporter stops at point %4d\n", TiMe, from);
	goto l_99;
	/* */
l_4400:  
	fprintf (nunit2, "\n\n+++++ gride :  t=%12.4f ERROR  : invalid index of destination node \n", TiMe);
	goto l_99;
	/* */
l_4500:  
	fprintf (nunit2, "\n\n+++++ gride :  t=%12.4f ERROR  : type of starting or destination node is not specified by 't' or 'b'  \n",
	     TiMe);
	goto l_99;
	/* */
l_4600:  
	fprintf (nunit2, "\n\n+++++ gride :  t=%12.4f ERROR  : starting node %1s%4d not same as actual\n                                        position %1s%4d\n",
	     TiMe, cstart, istart, cf, from);
	goto l_99;
	/* */
l_4700:  
	fprintf (nunit2, "\n\n+++++ gride :  t=%12.4f ERROR  : parameter of destination node has been changed meanTiMe\n",
	     TiMe);
	goto l_99;
	/* */
l_99: 
	return(FEHLER);
	/* */
}


