static char *SccsId = "@(#)PEPSY:\tinfo1.c\t1.2\t92/03/27 11:56:24";
#include <stdio.h>
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	info1(ncar, itarg, istate, iordr)
int	ncar, itarg, istate, iordr;
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	/*     ***  */
	/*     *** CALL INFO1(NCAR,ITARG,ISTATE,IORDR,*9999) */
	/*     ***  */
	/*     *** PURPOSE : DETERMINE CHARACTERISTICS OF ACTIVE VEHICLE */
	/*     *** PARAMETERS: NCAR   = NUMBER OF ACTIVE VEHICLE */
	/*     ***             ITARG  = DESTINATION */
	/*     ***             ISTATE = STATE OF VEHICLE */
	/*     ***             IORDR  = TYPE OF CONTROL */
	/*     ***                      = 0: NOT CENTRAL CONTROL (AS BUS) */
	/*     ***                      = 1: CENTRAL CONTROL (AS TAXI) */
	/*     ***             *9999  = ERROR EXIT */
	/*     ***  */

	extern int	next_int();


	/*     TEST FOR ERRORS */
	/*     =============== */
	if (row_txact == 0) {
		fprintf (nunit2, "\n\n+++++ info1 :  t=%12.4f ERROR  : ltx = 0 ; INFO1 cannot be called because no active vehicle\n",
		     TiMe);
		return(FEHLER);
	}
	/* */
	/*     DETERMINE INDEX OF VEHICLE */
	/*     ========================== */
	ncar = next_int(txadd[row_txact][1]);
	if (ncar == 0) {
		fprintf (nunit2, "\n\n+++++ info1 :  t=%12.4f ERROR  : ncar = 0 ; INFO1 cannot be called because no active vehicle\n",
		     TiMe);
		return(FEHLER);
	}
	/* */
	/*     DETERMINE RETURNED PARAMETERS */
	/*     ============================= */
	itarg  = 0;
	istate = next_int(carma[ncar][7]);
	if (istate == 2) 
		itarg = next_int(tarma[ncar][1]);
	if (istate == 1) 
		itarg = next_int(tarma[ncar][2]);
	if (istate == 3) 
		itarg = next_int(tarma[ncar][3]);
	if (next_int(carma[ncar][9]) == 0) {
		iordr = 0;
	} else {
		iordr = 1;
	}
	/* */
	return(NORMAL);
}


