static char *SccsId = "@(#)PEPSY:\tinfo2.c\t1.3\t92/03/27 11:56:26";
#include <stdio.h>
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	info2(ipass, itx2, value, lflag)
int	ipass;
int	itx2;
double	*value;
int	lflag;
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	/*     ***  */
	/*     *** CALL INFO2(IPASS,ITX2,VALUE,LFLAG,*9999) */
	/*     ***  */
	/*     *** PURPOSE : DETERMINE THE CHARACTERISTIC OF A TRANSACTION */
	/*     ***           IN THE ACTIVE VEHICLE */
	/*     *** PARAMETERS: IPASS = INDEX OF SEQUENCE OF TRANSACTION IN THE  */
	/*     ***                     ACTIVE VEHICLE */
	/*     ***             ITX2  = COLUMN INDEX */
	/*     ***                     > 0: TRANSACTION ARRAY */
	/*     ***                     < 0: TXADD ARRAY  (ONLY COLUMNS 2-4) */
	/*     ***             VALUE = RETURNS REQUESTED VALUE */
	/*     ***             LFLAG = INDICATES WHETHER THERE IS A TRANSACTION */
	/*     ***                     WITH THE REQUIRED SEQUENCE NUMBER */
	/*     ***                     = 0: NO TRANSACTION  */
	/*     ***                     = 1: TRANSACTION FOUND */
	/*     ***             *9999 = ERROR EXIT */
	/*     ***  */
	/* */

	extern int	next_int();
	int	lpass, i, ncar, itxh;


#ifdef DEBUG
dprint(TRANSPORTER, "info2: ipass %d,  itx2 %d\n", ipass, itx2); /* */
#endif

	/*     TEST FOR ERRORS */
	/*     =============== */
	if (ipass <= 0)                                          
		goto l_4000;
	if (itx2 < -4 || itx2 == -1 || itx2 == 0 || itx2 > ztx2) 
		goto l_4100;
	if (row_txact == 0)                                      
		goto l_4200;
	ncar = next_int(txadd[row_txact][1]);
	if (ncar == 0)                                           
		goto l_4200;
	/* */
	*value = 0.;
	lflag = 1;
	/* */
	/*     SELECT FIRST TRANSACTION */
	/*     ======================== */
	lpass = next_int(carma[ncar][2]);
	if (ipass > 1) {
		for (i = 2; i <= ipass; i++)  {
			if (lpass <= 0) 
				goto l_200;
			lpass = activlist[lpass].blk_link;
		}
	}
l_200: 
	if (lpass <= 0) {
		lflag = 0;
#ifdef DEBUG
dprint(TRANSPORTER, "info2: (0)  itx2 %d\n", itx2); /* */
#endif
	} else {
		if (itx2 < 0) {
			*value = txadd[lpass][-itx2];
#ifdef DEBUG
dprint(TRANSPORTER, "info2: (1)  itx2 %d\n", itx2); /* */
#endif
		} else {
			if (itx2 > 8 && itx2 <= 8 + ztxip) {
				itx2 = 9;
				itxh = itx2 - ztxip;
#ifdef DEBUG
dprint(TRANSPORTER, "info2: (2)  itx2 %d\n", itx2); /* */
#endif
			} else if (itx2 > (8 + ztxip) && itx2 <= 8 + ztxip + ztxfp)  {
				itx2 = 10;
				itxh = itx2 - ztxip - ztxfp;
#ifdef DEBUG
dprint(TRANSPORTER, "info2: (3)  itx2 %d\n", itx2); /* */
#endif
			} else if (itx2 <= (8 + ztxip + ztxfp + ztxsp) && itx2 > 8 + ztxip + ztxfp) {
				itx2 = 11;
				itxh = itx2 - ztxip - ztxfp - ztxsp;
#ifdef DEBUG
dprint(TRANSPORTER, "info2: (4)  itx2 %d\n", itx2); /* */
#endif
			}
#ifdef DEBUG
dprint(TRANSPORTER, "info2: (5)  itx2 %d\n", itx2); /* */
#endif
			switch (itx2) {
			case 1: 
				*value = tx_system[lpass].nr;
				break;
			case 2: 
				*value = tx_system[lpass].dup;
				break;
			case 3: 
				*value = tx_system[lpass].family;
				break;
			case 4: 
				*value = tx_system[lpass].priority;
				break;
			case 5: 
				*value = tx_system[lpass].retour;
				break;
			case 6: 
				*value = tx_system[lpass].TiMe_left;
				break;
			case 7: 
				*value = tx_system[lpass].elem;
				break;
			case 8: 
				*value = tx_system[lpass].t_block;
				break;
			case 9: 
				*value = i_tx_priv[lpass][itxh];
				break;
			case 10: 
				*value = f_tx_priv[lpass][itxh];
				break;
			case 11: 
				*value = *s_tx_priv[lpass][itxh];
				break;
			default: 
				fprintf(stderr, "info2: fehler in switch\n");
				break;
			}
		}
	}
	return(NORMAL);
	/* */
	/*     ERROR MESSAGES */
	/*     ============== */
l_4000:  
	fprintf (nunit2, "\n\n+++++ info2 :  t=%12.4f ERROR  : sequence index of transaction <1\n", TiMe);
	goto l_99;
	/* */
l_4100:  
	fprintf (nunit2, "\n\n+++++ info2 :  t=%12.4f ERROR  : erroneous column index %3d\n", TiMe, itx2);
	goto l_99;
	/* */
l_4200:  
	fprintf (nunit2, "\n\n+++++ info2 :  t=%12.4f ERROR  : vehicle cannot be identified\n", TiMe);
	fprintf (nunit2, "                                      'info2' cannot be called here\n", TiMe);
l_99:    
	return(FEHLER);
}


