static char *SccsId = "@(#)PEPSY:\tininet.c\t1.4\t93/10/20 14:53:01";
#include <stdio.h>
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"
#include "xxalloc.h"
#include <math.h>
#include <string.h>

static int	*seglas, *smark;
static int	*netmk;
static double	*weight,  *y;

int	ininet()
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	/*     ***  */
	/*     *** CALL ININET(*9999) */
	/*     ***  */
	/*     *** PURPOSE : INITIALIZE AND CHECK VEHICLE NETWORK */
	/*     *** PARAMETER:  *9999  = ERROR EXIT */
	/*     ***  */

	int	art, arte, error, p, pa, pe,  ncour, k;
	int	i, nterm,  nverz, nsect, nsegm, nrout, nbloc, j, npkt, kmax;
	float	length, x[3],  cfakt, help;
	extern int	initab(), initts(), next_int();
	extern double gesgew();
	double	gesgew();


	if (netmk == (int *)0)
		netmk = i1_alloc(0, ZNODE + 1);
	if (smark == (int *)0)
		smark = i1_alloc(0, ZSECT + 1);
	if (seglas == (int *)0)
		seglas = i1_alloc(0, ZSEGM + 1);
	if (weight == (double *)0)
		weight = d1_alloc(0, ZSEGM + 1);
	if (y == (double *)0)
		y = d1_alloc(0, ZNV + 1);

#ifdef DEBUG
dprint(TRANSACTION, "ininet: start\n"); /* */
#endif

	/*     NO NETWORK DATA AVAILABLE */
	/*     ========================= */
	if (ansta == 0 && anverz == 0 && ansect == 0 && 
	    ansegm == 0 && anrout == 0) 
		return(NORMAL);

	error = 0;
	/* */
	/*     CHECK TERMINALS */
	/*     =============== */
	for (i = zsta; i >= 1; i--) {
		if (coords[i][1] > -eps) 
			goto l_1010;
	}
	fprintf (nunit2, "    *** ininet: no terminals available\n");
	error = 1;
l_1010: 
#ifdef DEBUG
dprint(LABEL, "ininet: label l_1010\n"); /* */
#endif
	if (i != ansta) {
		for (nterm = 1; nterm <= ansta; nterm++)  {
			if (coords[nterm][1] < -eps) {
				fprintf (nunit2, "    *** ininet: terminal%4d not defined, gap in 'coords'\n", nterm);
				error = 1;
			}
		}
		for (nterm = ansta + 1; nterm <= i; nterm++)  {
			if (coords[nterm][1] > -eps) {
				fprintf (nunit2, "    *** ininet: terminal%4d has too high an index\n", nterm);
				error = 1;
			}
		}
	}
	/* */
	/* */
	/*     TEST BRANCHES  */
	/*     =============  */
	for (i = zverz; i >= 1; i--)  {
		if (coordv[i][1] > -eps) 
			goto l_1050;
	}
	fprintf (nunit2, "    +++ ininet: warning: no branches present\n");
l_1050: 
#ifdef DEBUG
dprint(LABEL, "ininet: label l_1050\n"); /* */
#endif
	if (i != anverz) {
		for (nverz = 1; nverz <= anverz; nverz++)  {
			if (coordv[nverz][1] < -eps) {
				fprintf (nunit2, "    *** ininet: branch%4d not defined, gap in 'coordv'\n", nverz);
				error = 1;
			}
		}
		for (nverz = anverz + 1; nverz <= i; nverz++)  {
			if (coordv[nverz][1] > -eps) {
				fprintf (nunit2, "    *** ininet: branch%4d has too high an index\n", nverz);
				error = 1;
			}
		}
	}
	/* */
	/* */
	/*     CHECK SECTION ARRAY */
	/*     =================== */
	for (i = zsect; i >= 1; i--)  {
		if (next_int(sectma[i][1]) > 0) 
			goto l_1090;
	}
	fprintf (nunit2, "    *** ininet: no sections present\n");
	error = 1;
l_1090: 
#ifdef DEBUG
dprint(LABEL, "ininet: label l_1090\n"); /* */
#endif
	if (i != ansect) {
		for (nsect = 1; nsect <= ansect; nsect++)  {
			if (next_int(sectma[nsect][1]) == 0) {
				fprintf (nunit2, "    *** ininet: section%4d is not defined, gap in 'sectma'\n", nsect);
				error = 1;
			}
		}
		for (nsect = ansect + 1; nsect <= i; nsect++)  {
			if (next_int(sectma[nsect][1]) == 0) {
				fprintf (nunit2, "    *** ininet: section%4d has too high an index\n", nsect);
				error = 1;
			}
		}
	}
	/* */
	/* */
	/*     CHECK SEGMENT ARRAY */
	/*     =================== */
	for (i = zsegm; i >= 1; i--)  {
		if (segma[i][1] > 0) 
			goto l_1130;
	}
	fprintf (nunit2, "    *** ininet: no segments present\n");
	error = 1;
l_1130: 
#ifdef DEBUG
dprint(LABEL, "ininet: label l_1130\n"); /* */
#endif
	if (i != ansegm) {
		for (nsegm = 1; nsegm <= ansegm; nsegm++)  {
			if (segma[nsegm][1] == 0) {
				fprintf (nunit2, "    *** ininet: segment%4d is not defined, gap in 'segma'\n", nsegm);
				error = 1;
			}
		}
		for (nsegm = ansegm + 1; nsegm <= i; nsegm++)  {
			if (segma[nsegm][1] > 0) {
				fprintf (nunit2, "    *** ininet: segment%4d has too high an index\n", nsegm);
				error = 1;
			}
		}
	}
	/* */
	/* */
	/*     CHECK ROUTE TABLE */
	/*     ================= */
	for (i = zrout; i >= 1; i--)  {
		if (routma[i][1] > 0) 
			goto l_1170;
	}
	fprintf (nunit2, "    +++ ininet: warning: no routes present\n");
l_1170: 
#ifdef DEBUG
dprint(LABEL, "ininet: label l_1170\n"); /* */
#endif
	if (i != anrout) {
		for (nrout = 1; nrout <= anrout; nrout++)  {
			if (routma[nrout][1] == 0) {
				fprintf (nunit2, "    *** ininet: route %4d is not defined, gap in 'routma'\n", nrout);
				error = 1;
			}
		}
		for (nrout = anrout + 1; nrout <= i; nrout++)  {
			if (routma[nrout][1] > 0) {
				fprintf (nunit2, "    *** ininet: route %4d has too high an index\n", nrout);
				error = 1;
			}
		}
	}
	/* */
	/* */
	if (error == 1) {
		fprintf(stderr, "ininet: point 1\n");
		goto l_990;
	}
	/* */
	/*     ARE THERE INTERMEDIATE POINTS OF THE SECTION DEFINED?  */
	/*     =====================================================  */
	for (nbloc = 1; nbloc <= zsect; nbloc++)  {
		smark[nbloc] = 0;
	}
	for (nsect = 1; nsect <= ansect; nsect++)  {
		nbloc = next_int(sectma[nsect][4]);
		if (nbloc != 0) 
			smark[nbloc] = 1;
		for (j = 1; j <= 2; j++) {
			npkt = next_int(sectma[nsect][j]);
			art  = next_int(sectma[nsect][j] * 10.0) - npkt * 10;
			if (art == 1) {
				if (npkt > ansta) {
					fprintf (nunit2, "    *** ininet: terminal%4d of section%4d not defined\n", npkt,
					     nsect);
					error = 1;
				}
			} else if (art == 2) {
				if (npkt > anverz) {
					fprintf (nunit2, "    *** ininet: branch%4d of section%4d not defined\n", npkt, nsect);
					error = 1;
				}
			} else {
				if (npkt > anpkt) {
					fprintf (nunit2, "    *** ininet: intermediate point%4d of section%4d not defined\n",
					     npkt, nsect);
					error = 1;
				}
			}
		}
	}
	/* */
	/*     ARE THE BLOCK INDICES OF THE BLOCK DATA RECORDS DEFINED? */
	/*     ======================================================== */
	for (nbloc = 1; nbloc <= zsect; nbloc++)  {
		if (blocve[nbloc][2] > 1 && smark[nbloc] == 0)
			fprintf (nunit2, "    *** ininet: warning:  block index%4d of a block data record is not defined \n",
			     nbloc);
	}
	/* */
	/*     ARE THE SECTIONS OF THE SEGMENTS DEFINED? */
	/*     ========================================= */
	for (nsect = 1; nsect <= zsect; nsect++)  {
		smark[nsect] = 0;
	}
	for (nsegm = 1; nsegm <= ansegm; nsegm++) {
		seglas[nsegm] = 1;
		for (j = 1; j <= zsegm1; j++)  {
			nsect = segma[nsegm][j];
			if (nsect == 0) 
				goto l_1250;
			if (nsect > ansect) {
				fprintf (nunit2, "    *** ininet: section index%4d of segment%4d s too high\n", nsect, nsegm);
				error = 1;
			}
			smark[nsect] = smark[nsect] + 1;
		}
		j = j + 1;
l_1250: 
#ifdef DEBUG
dprint(LABEL, "ininet: label l_1250\n"); /* */
#endif
		seglas[nsegm] = j - 1;
	}
	/* */
	/*     ARE THERE SEGMENTS OF THE ROUTES DEFINED? */
	/*     ========================================= */
	for (nrout = 1; nrout <= anrout; nrout++)  {
		for (j = 1; j <= zrout1; j++)  {
			nsegm = routma[nrout][j];
			if (nsegm == 0) 
				break;
			if (nsegm > ansegm) {
				fprintf (nunit2, "    *** ininet: section index%4d of route %4d is too high\n", nsegm, nrout);
				error = 1;
			}
		}
	}
	/* */
	/*     ARE THE ROUTES AND TERMINALS OF THE FIXED CONNECTIONS DEFINED? */
	/*     ============================================================== */
	for (ncour = 1; ncour <= zrout; ncour++)  {
		if (courma[ncour][3] == 0) 
			break;
		if (courma[ncour][3] > anrout) {
			fprintf (nunit2, "    *** ininet: route of fixed connection%4d s not defined \n", ncour);
			error = 1;
		}
		for (j = 1; j <= 2; j++)  {
			if (courma[ncour][j] > ansta) {
				fprintf (nunit2, "    +++ ininet: warning:  terminal%4d of fixed connection %4d not defined\n",
				     courma[ncour][j], ncour);
			}
		}
	}
	/* */
	if (error == 1) {
		fprintf(stderr, "ininet: point 2\n");
		goto l_990;
	}
	/* */
	/*     CHECK SECTIONS */
	/*     ============== */
	for (nsect = 1; nsect <= ansect; nsect++)  {
		if (smark[nsect] == 0) {
			fprintf (nunit2, "    *** ininet: section%4d does not occur in any segment\n", nsect);
			error = 1;
		} else {
			if (smark[nsect] > 1) {
				fprintf (nunit2, "    *** ininet: section%4d occurs in several segments\n", nsect);
				error = 1;
			}
		}
	}
	/* */
	/*     CHECK SEGMENTS */
	/*     ============== */
	for (i = 1; i <= ansta + anverz; i++)  {
		netmk[i] = 3;
	}
	for (nsegm = 1; nsegm <= ansegm; nsegm++)  {
		nsect = segma[nsegm][1];
		pa  = next_int(sectma[nsect][1]);
		art = next_int(sectma[nsect][1] * 100.) - pa * 10;
		if (art == 3) {
			fprintf (nunit2, "    *** ininet: segment%4d does not begin with a node\n", nsegm);
			error = 1;
		} else {
			if (art == 2) 
				pa = pa + ansta;
			if (netmk[pa] >= 2) {
				netmk[pa] = 2;
			} else {
				netmk[pa] = 0;
			}
		}
		pe   = next_int(sectma[nsect][2]);
		arte = next_int(sectma[nsect][2] * 10.0) - pe * 10;
		for (j = 2; j <= zsegm1; j++)  {
			nsect = segma[nsegm][j];
			if (nsect == 0) 
				goto l_1340;
			if (arte != 3) {
				fprintf (nunit2, "    *** ininet: segment%4d contains inner nodes\n", nsegm);
				error = 1;
			}
			p   = next_int(sectma[nsect][1]);
			art = next_int(sectma[nsect][1] * 10.0) - p * 10;
			if (p != pe || art != arte) {
				fprintf (nunit2, "    *** ininet : in segment%4d no connection beetween \n                 the sections %4d and %4d\n",
				     nsegm, segma[nsegm][j-1], nsect);
				error = 1;
			}
			pe   = sectma[nsect][2];
			arte = next_int(sectma[nsect][2] * 10.0) - pe * 10;
		}
l_1340: 
#ifdef DEBUG
dprint(LABEL, "ininet: label l_1340 \n"); /* */
#endif
		if (arte == 3) {
			fprintf (nunit2, "    *** ininet: segment%4d does not end with a node\n", nsegm);
			error = 1;
		} else {
			if (arte == 2) 
				pe = pe + ansta;
			if (pa == pe) {
				fprintf (nunit2, "    *** ininet: segment%4d has identical first and last nodes\n", nsegm);
				error = 1;
			}
			if (netmk[pe] == 1 || netmk[pe] == 3) {
				netmk[pe] = 1;
			} else {
				netmk[pe] = 0;
			}
		}
	}
	/* */
	if (error == 1) {
		fprintf(stderr, "ininet: point 3\n");
		goto l_990;
	}
	/* */
	/*     CHECK ROUTES */
	/*     ============ */
	for (nrout = 1; nrout <= anrout; nrout++)  {
		nsegm = routma[nrout][1];
		pa    = next_int(sectma[segma[nsegm][1]][1]);
		art   = next_int(sectma[segma[nsegm][1]][1] * 10.0) - pa * 10;
		if (art == 2) {
			fprintf (nunit2, "    *** ininet: route %4d does not begin with a terminal\n", nrout);
			pa = pa + ansta;
			error = 1;
		}
		pe   = next_int(sectma[segma[nsegm][seglas[nsegm]]][2]);
		arte = next_int(sectma[segma[nsegm][seglas[nsegm]]][2] * 10.0) - pe * 10;
		for (j = 2; j <= zrout1; j++)  {
			nsegm = routma[nrout][j];
			if (nsegm == 0) 
				goto l_1420;
			p   = next_int(sectma[segma[nsegm][1]][1]);
			art = next_int(sectma[segma[nsegm][1]][1] * 10.0) - p * 10;
			if (p != pe || art != arte) {
				fprintf (nunit2, "    *** ininet: route %4d  not connected\n                                break at segment%4d\n",
				     nrout, nsegm);
				error = 1;
			}
			pe   = next_int(sectma[segma[nsegm][seglas[nsegm]]][2]);
			arte = next_int(sectma[segma[nsegm][seglas[nsegm]]][2] * 10.0) - pe * 10;
		}
l_1420: 
#ifdef DEBUG
dprint(LABEL, "ininet: label l_1420 \n"); /* */
#endif
		if (arte == 2) 
			pe = pe + ansta;
		for (ncour = 1; ncour <= zrout; ncour++)  {
			if (courma[ncour][3] == nrout) 
				goto l_1440;
		}
		if (pa != pe) {
			fprintf (nunit2, "    *** ininet: route %4d not connected\n                                start and finish do not agree\n",
			     nrout);
			error = 1;
		}
		continue;
l_1440: 
#ifdef DEBUG
dprint(LABEL, "ininet: label l_1440 \n"); /* */
#endif
		if (courma[ncour][1] != pa || courma[ncour][2] != pe) {
			fprintf (nunit2, "    *** initnet: route %4d does not agree with corresponding fixed connection\n",
			     k);
			error = 1;
		}
	}
	/* */
	/*     CHECK NETWORK  */
	/*     =============  */
	for (nterm = 1; nterm <= ansta; nterm++)  {
		if (netmk[nterm] == 1) {
			fprintf (nunit2, "    *** ininet: terminal%4d without segment leaving it\n", nterm);
			error = 1;
		} else if (netmk[nterm] == 2) {
			fprintf (nunit2, "    *** ininet: terminal%4d without segment leading to it\n", nterm);
			error = 1;
		} else if (netmk[nterm] == 3) {
			fprintf (nunit2, "    *** ininet: terminal%4d isolated\n", nterm);
			error = 1;
		}
	}
	for (nverz = 1; nverz <= ansta; nverz++)  {
		if (netmk[nverz] == 1) {
			fprintf (nunit2, "    *** ininet: branch%4d without segment leaving it\n", nverz);
			error = 1;
		} else if (netmk[nverz] == 2) {
			fprintf (nunit2, "    *** ininet: branch%4d without segment leading to it\n", nverz);
			error = 1;
		} else if (netmk[nverz] == 3) {
			fprintf (nunit2, "    *** ininet: branch%4d isolated\n", nverz);
			error = 1;
		}
	}
	/* */
	/* */
	if (error == 1) {
		fprintf(stderr, "ininet: point 4\n");
		goto l_990;
	}
	/* */
	/*     DETERMINE LENGTHS OF SECTIONS AND WEIGHTING OF SEGMENTS */
	/*     ======================================================= */
	cfakt = -acos(0.) / (sqrt(2.));
	for (nsegm = 1; nsegm <= ansegm; nsegm++)  {
		pa = next_int(sectma[segma[nsegm][1]][1]);
		art = next_int(sectma[segma[nsegm][1]][1] * 10.0) - pa * 10;
		if (art == 2)  
			pa = pa + ansta;
		weight[nsegm] = 0.0;
		for (j = 1; j <= zsegm1; j++)  {
			if (segma[nsegm][j] == 0) 
				goto l_222;
			nsect = segma[nsegm][j];
			pe = j;
			for (k = 1; k <= 2; k++)  {
				p = next_int(sectma[nsect][k]);
				art = next_int(sectma[nsect][k] * 10.0) - p * 10;
				if (art == 1) {
					x[k] = coords[p][1];
					y[k] = coords[p][2];
				} else if (art == 2) {
					x[k] = coordv[p][1];
					y[k] = coordv[p][2];
				} else {
					x[k] = coordp[p][1];
					y[k] = coordp[p][2];
				}
			}
			length = sqrt(pow((x[2] - x[1]), 2.) + pow((y[2] - y[1]), 2.));
			if (sectma[nsect][3] < 0.0) {
				sectma[nsect][3] = length * cfakt;
			} else {
				sectma[nsect][3] = length;
			}
			weight[nsegm] = weight[nsegm] + gesgew(nsect);
		}
l_222:  
#ifdef DEBUG
dprint(LABEL, "ininet: label l_222 \n"); /* */
#endif
		help = sectma[segma[nsegm][pe]][2];
		pe   = next_int(help);
		art = next_int(help * 10.0) - pe * 10;
		if (art == 2) {
			pe = pe + ansta;
		}
		/* */
		/*     ASSIGN NEIGHBOURHOOD TABLES */
		/*     =========================== */
		for (j = 1; j <= zvon; j++)  {
			if (fromto[pa][j][1] == 0) {
				fromto[pa][j][1] = pe;
				fromto[pa][j][2] = nsegm;
				goto l_333;
			}
		}
		fprintf (nunit2, "    *** ininet: too many neighbourhood nodes\n");
		goto l_999;
l_333:  
#ifdef DEBUG
dprint(LABEL, "ininet: label l_333 \n"); /* */
#endif
		for (j = 1; j <=  znach; j++)  {
			if (tofrom[pe][j][1] == 0) {
				tofrom[pe][j][1] = pa;
				tofrom[pe][j][2] = nsegm;
				goto l_444;
			}
		}
		fprintf (nunit2, "    *** ininet: too many neighbourhood nodes\n");
		goto l_999;
l_444: 
		continue;
	}
	/* */
	/*     CALL INITAB TO ASSIGN ROUTING TABLES */
	/*     ==================================== */
	kmax = ansta + anverz;
	for (i = 1; i <=  kmax; i++) {
		for (j = 1; j <=  kmax; j++)  {
			totlen[i][j] = 1.0e30;
		}
	}
	for (i = 1; i <=  kmax; i++) {
		totlen[i][i] = 0.0;
		initab(i, weight);
	}
	/* */
	/*     WRITE TRANSPORT SYSTEM DATA ON "CARDAT" */
	/*     ======================================= */
	if (kprint == 1)  
		initts();
	/* */
	fprintf (nunit2, "\n\n\n\n\n\n");
	return(NORMAL);
	/* */
l_990: 
	fprintf (xunit4, "    *** ininet: ERROR in transport data records\n");
l_999: 
	fprintf (nunit2, "\n\n\n\n\n\n");
	return(FEHLER);
	/* */
}


