static char *SccsId = "@(#)PEPSY:\tinteg.c\t1.2\t92/03/27 11:56:47";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	integ(nset, tstep, rerr, ierr)
int	ierr ;
double	*rerr ;
double	tstep ;
int	nset ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call integ(nset,tstep,rerr,ierr,*9999)                        */
	/*    ***                                                               */
	/*    *** funktion : auswahl des fuer set nset bestimmten               */
	/*    ***            integrationsverfahrens                             */
	/*    *** parameter: nset  = nummer des zu integrierenden set           */
	/*    ***            tstep = schrittweite                               */
	/*    ***            *rerr  = relativer integrationsfehler (Rueckgabe)  */
	/*    ***            ierr  = indikator fuer fehlerbestimmung            */
	/*    ***            exit1 = fehlerausgang                              */
	/*    ***                                                               */
	extern int	state(), rkf(), rkimp(), extpol(), rowa();
	extern int	inte5();
	int	methd;
	double	loc_TiMe, loc_rerr ;
	int	reply = NORMAL;
	/*                                                                      */
	loc_TiMe = TiMe;
	loc_rerr = 0.0;
	/*                                                                      */
	/*    auswahl des integrationsverfahrens                                */
	/*    ==================================                                */
	if (intma[nset].dv_nr == 0) 
		goto l_100;
	methd = intma[nset].method;
	/*                                                                      */
	/*    aufruf des unterprogramms zur integration                         */
	/*    =========================================                         */
	switch (methd) {
	case 1: 
		reply = rkf(nset, tstep, &loc_rerr, ierr);
		break;

	case 2: 
		reply = rkimp(nset, tstep, &loc_rerr, ierr);
		break;

	case 3: 
		reply = extpol(nset, tstep, &loc_rerr);
		break;

	case 4: 
		reply = rowa(nset, tstep, &loc_rerr, ierr);
		break;

	case 5: 
		inte5();
		break;

	default: 
		reply = FEHLER;
		fprintf(nunit2, "\n\n+++++ integ : TiMe = %12.4f fehler ", TiMe);
		fprintf(nunit2, "im adressverteiler  methd = %3d\n", methd);
	};
	/*                                                                      */
	/*                                                                      */
	/*    behandeln von reinen zeitfunktionen                               */
	/*    ===================================                               */
l_100:  
	TiMe = loc_TiMe + tstep;
	reply = state(nset);
	/*                                                                      */
	TiMe = loc_TiMe;
	*rerr = loc_rerr;
	return(reply);
}


