static char *SccsId = "@(#)PEPSY:\tlognor.c\t1.2\t92/03/27 11:57:00";

/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/


#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"

#  define PI_2		6.28318530717958647692

int	lognor(rmean, sigma, rmin, rmax, irnum, random)
double	*random ;
int	irnum ;
double	rmax ;
double	rmin ;
register double	sigma ;
register double	rmean ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call lognor(rmean,sigma,rmin,rmax,irnum, *random)             */
	/*    ***                                                               */
	/*    *** funktion : erzeugen einer log-normal-verteilten               */
	/*    ***            zufallszahl                                        */
	/*    *** parameter: rmean   = mittelwert                               */
	/*    ***            sigma   = standardabweichung                       */
	/*    ***            rmin    = untere intervallgrenze                   */
	/*    ***            rmax    = obere intervallgrenze                    */
	/*    ***            irnum   = nummer des zufallszahlengenerators       */
	/*    ***             *random  = rueckgabe: zufallszahl im angegebenen  */
	/*    ***                                 intervall                     */
	/*    ***                                                               */
	extern double	rnx();
	register double	sigmx2, rmeanx, sigmx, r, v ;
	/*                                                                      */
	/*    erzeugen einer log-normal-verteilten zufallszahl                  */
	/*    ================================================                  */
	sigmx2 = log(sigma * sigma / rmean / rmean + 1.);
	rmeanx = log(rmean) - 0.5 * sigmx2;
	sigmx = sqrt(sigmx2);
l_100:  
	r = 1.0 - rnx(irnum);
	if (r == 0.) {
		fprintf(stderr, "lognor uniform liefert 0.0 %g\n", r);
		goto l_100;
	}
	v = pow((-2.0 * log(r)), 0.5) * cos(PI_2 * rnx(irnum));
	*random = exp(v * sigmx + rmeanx);
	/*                                                                      */
	/*    intervallkontrolle                                                */
	/*    ==================                                                */
	if ( *random < rmin ||  *random > rmax) 
	{
		fprintf(nunit2,"lognor rejected, rmin %lg, rmax %lg, value %lg\n",rmin,rmax,*random);
		goto l_100;
	}
	return(NORMAL);
}


int	lognor2(rmean, sigma, rmin, rmax, irnum, random)
double	*random ;
int	irnum ;
double	rmax ;
double	rmin ;
double	sigma ;
double	rmean ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call lognor(rmean,sigma,rmin,rmax,irnum, *random)             */
	/*    ***                                                               */
	/*    *** funktion : erzeugen einer log-normal-verteilten               */
	/*    ***            zufallszahl                                        */
	/*    *** parameter: rmean   = mittelwert                               */
	/*    ***            sigma   = standardabweichung                       */
	/*    ***            rmin    = untere intervallgrenze                   */
	/*    ***            rmax    = obere intervallgrenze                    */
	/*    ***            irnum   = nummer des zufallszahlengenerators       */
	/*    ***             *random  = rueckgabe: zufallszahl im angegebenen  */
	/*    ***                                 intervall                     */
	/*    ***                                                               */
	extern double	rnx();
	double	sigmx2, rmeanx, sigmx, r, v ;
	/*                                                                      */
	/*    erzeugen einer log-normal-verteilten zufallszahl                  */
	/*    ================================================                  */
	sigmx2 = log(pow(sigma, 2.) / pow(rmean, 2.) + 1.);
	rmeanx = log(rmean) - 0.5 * sigmx2;
	sigmx = sqrt(sigmx2);
l_100:  
	r = rnx(irnum);
	if (r == 0.) {
		fprintf(stderr, "lognor uniform liefert 0.0 %g\n", r);
		goto l_100;
	}
	v = pow((-2.0 * log(r)), 0.5) * cos(2.0 * M_PI * rnx(irnum + 1));
	*random = exp(v * sigmx + rmeanx);
	/*                                                                      */
	/*    intervallkontrolle                                                */
	/*    ==================                                                */
	if ( *random < rmin ||  *random > rmax) {
		fprintf(nunit2, "lognor rejected, mean %g, min %g, max %g, value %g\n",
		    rmean, rmin, rmax, *random);
		goto l_100;
	}
	return(NORMAL);
}


