static char *SccsId = "@(#)PEPSY:\tnchain.c\t1.2\t92/03/27 11:57:21";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


      int nchain(list,line)
      int line ;
      int list ;
/*                                                                      */
     {
/*    ***                                                               */
/*    ***      call nchain(list,line,exit1)                             */
/*    ***                                                               */
/*    *** funktion : ausketten einer zeile aus der liste list           */
/*    *** parameter: list  = nummer der liste                           */
/*    ***                    = 1: ereignisliste                         */
/*    ***                    = 2: sourceliste                           */
/*    ***                    = 3: aktivierungsliste                     */
/*    ***                    = 4: konfidenzliste                        */
/*    ***                    = 5: monitorliste                          */
/*    ***                    = 6: equationliste                         */
/*    ***            line  = auszukettende zeile                        */
/*    ***            exit1 = fehlerausgang                              */
/*    ***                                                               */
   extern int next_int();
      int nptr,bpoint,lptr,k ;
#ifdef DEBUG
	dprint(CHAIN,"nchain: list %d, line %d\n",list,line);
#endif
/*                                                                      */
/*    fehlerkontrolle                                                   */
/*    ===============                                                   */
      nptr = head[list].link;
      switch(list){
        case 1: goto l_100;
        case 2: goto l_200;
        case 3: goto l_300;
        case 4: goto l_400;
        case 5: goto l_500;
        case 6: goto l_600;
      };
   fprintf(nunit2,"\n\n+++++ nchain: TiMe=%12.4f fehlerhafte listennummer%3d\n",
              TiMe,list);
      return(FEHLER);
/*                                                                      */
/*    ausketten aus der ereignisliste                                   */
/*    ===============================                                   */
l_100: 
	if(eventlist[line].link == 0) return(NORMAL);
      if(nptr < 0) return(NORMAL);
      if(nptr != line) goto l_110;
      nptr = eventlist[line].link;
      if(nptr > 0) head[1].next = eventlist[nptr].next;
      if(nptr < 0) head[1].next = 0.0;
      head[1].link = nptr;
      goto l_120;
l_110:  
	lptr = nptr;
      nptr = eventlist[lptr].link;
      if(nptr != line) goto l_110;
      eventlist[lptr].link = eventlist[line].link;
l_120:  
	eventlist[line].link = 0;
      return(NORMAL);
/*                                                                      */
/*    ausketten aus der sourceliste                                     */
/*    =============================                                     */
l_200:  
	if(sourcelist[line].link == 0) return(NORMAL);
      if(nptr < 0) return(NORMAL);
      if(nptr != line) goto l_210;
      nptr = sourcelist[line].link;
      if(nptr > 0) head[2].next = sourcelist[nptr].next;
      if(nptr < 0) head[2].next = 0.0;
      head[2].link = nptr;
      goto l_220;
l_210:  
	lptr = nptr;
      nptr = sourcelist[lptr].link;
      if(nptr != line) goto l_210;
      sourcelist[lptr].link = sourcelist[line].link;
l_220:  
	sourcelist[line].link = 0;
      return(NORMAL);
/*                                                                      */
/*    ausketten aus der aktivierungsliste                               */
/*    ===================================                               */
l_300:  
	if(activlist[line].link == 0 && activlist[line].blk_link == 0) return(NORMAL);
      if(nptr < 0) return(NORMAL);
      if(activlist[line].link == 0) goto l_330;
      if(nptr != line) goto l_320;
      nptr = activlist[line].link;
      if(nptr < 0) goto l_310;
      head[3].next = activlist[nptr].next;
      if(activlist[nptr].next < 0.0) head[3].next = TiMe;
l_310: 
	if(nptr < 0) head[3].next = 0.0;
      head[3].link = nptr;
      goto l_330;
l_320:
	lptr = nptr;
      nptr = activlist[lptr].link;
      if(nptr != line) goto l_320;
      activlist[lptr].link = activlist[line].link;
l_330:
	if(activlist[line].blk_link == 0) goto l_350;
      k = abs(next_int(activlist[line].next));
      bpoint = bhead[k] - activlist;
      if(bpoint != line) goto l_340;
      if (activlist[line].blk_link < 0) {
        bhead[k] = NULL;
      }
      else {
        bhead[k] = activlist + activlist[line].blk_link;
      }
      goto l_350;
l_340:
	lptr = bpoint ;

      /********** (lptr >= 0) goto l_350; *********/
      if (lptr <= 0) goto l_350;
      bpoint =  activlist[lptr].blk_link ;
      if(bpoint != line) goto l_340;
      activlist[lptr].blk_link = activlist[line].blk_link;
l_350: 
	activlist[line].link = 0;
      activlist[line].blk_link = 0;
      return(NORMAL);
/*                                                                      */
/*    ausketten aus der konfidenzliste                                  */
/*    ================================                                  */
l_400:  
	if(conflist[line].link == 0) return(NORMAL);
      if(nptr < 0) return(NORMAL);
      if(nptr != line) goto l_410;
      nptr = conflist[line].link;
      if(nptr > 0) head[4].next = conflist[nptr].next;
      if(nptr < 0) head[4].next = 0.0;
      head[4].link = nptr;
      goto l_420;
l_410:  
	lptr = nptr;
      nptr = conflist[lptr].link;
      if(nptr != line) goto l_410;
      conflist[lptr].link = conflist[line].link;
l_420:  
	conflist[line].link = 0;
      return(NORMAL);
/*                                                                      */
/*    ausketten aus der monitorliste                                    */
/*    ==============================                                    */
l_500:  
	if(monitlist[line].link == 0) return(NORMAL);
      if(nptr < 0) return(NORMAL);
      if(nptr != line) goto l_510;
      nptr = monitlist[line].link;
      if(nptr > 0) head[5].next = monitlist[nptr].next;
      if(nptr < 0) head[5].next = 0;
      head[5].link = nptr;
      goto l_520;
l_510:  
	lptr = nptr;
      nptr = monitlist[lptr].link;
      if(nptr != line) goto l_510;
      monitlist[lptr].link = monitlist[line].link;
l_520:  
	monitlist[line].link = 0;
      return(NORMAL);
/*                                                                      */
/*    ausketten aus der equationliste                                   */
/*    ===============================                                   */
l_600:  
	if(equatlist[line].link == 0) return(NORMAL);
      if(nptr < 0) return(NORMAL);
      if(nptr != line) goto l_610;
      nptr = equatlist[line].link;
      if(nptr > 0) head[6].next = equatlist[nptr].next;
      if(nptr < 0) head[6].next = 0.0;
      head[6].link = nptr;
      goto l_620;
l_610:   
	lptr = nptr;
      nptr = equatlist[lptr].link;
      if(nptr != line) goto l_610;
      equatlist[lptr].link = equatlist[line].link;
l_620:  
	equatlist[line].link = 0;
      return(NORMAL);
     }
