static char *SccsId = "@(#)PEPSY:\torder.c\t1.3\t92/03/27 11:57:26";
#include <stdio.h>
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	order(itargl, itargu, loglin, nstrat, found)
int	itargl;
int	itargu;
int	loglin;
int	nstrat;
short	*found;
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	/*     ***  */
	/*     *** CALL ORDER(ITARGL,ITARGU,LOGLIN,NSTRAT,FOUND,*9999) */
	/*     ***  */
	/*     *** PURPOSE : ORDER A TAXI OR TRANSPORTER */
	/*     *** PARAMETERS: ITARGL = INDEX OF STARTING POINT */
	/*     ***             ITARGU = INDEX OF DESTINATION */
	/*     ***             LOGLIN = INDEX OF THE TRANSACTION TO BE */
	/*     ***                      TRANSPORTED IN LOGMA */
	/*     ***             NSTRAT = STRATEGY FOR TAXI/TRANSPORTER SELECTION */
	/*     ***                      = 1: RAN:  RANDOM */
	/*     ***                      = 2: POR:  VEHICLE WITH SMALLEST INDEX  */
	/*     ***                      = 3: SDS:  NEAREST VEHICLE */
	/*     ***                      = 4: LDS:  FURTHEST AWAY VEHICLE */
	/*     ***                      = 5: TOP:  VEHICLE AT PRESENT TERMINAL  */
	/*     ***                      = 6: BEN:  STRATEGY SUPPLIED BY USER */
	/*     ***             FOUND  = BOOLEAN PARAMETER WHICH RETURNS */
	/*     ***                      WHETHER TAXI/TRANSPORTER WAS FOUND */
	/*     ***             *9999  = ERROR EXIT */
	/*     ***  */

	int	ncar;
	extern int	ordran(), ordpor(), ordsds(), ordlds(), ordtop(), ordben();
	extern int	tchain(), next_int();
	int	k, line, last, nterm;


	/*     INITIALIZATION */
	/*     ============== */
	*found  =  FALSE;
	ncar = 0;
#ifdef DEBUG
dprint(TRANSACTION, "order: itragl %d, itragu %d, loglin %d, nstrat %d\n", /* */
	    itargl, itargu, loglin, nstrat);
#endif
	/* */
	/*     LABEL SELECTOR FOR THE STRATEGY */
	/*     =============================== */
	switch (nstrat) {
	case 1: 
		goto l_100;
	case 2: 
		goto l_200;
	case 3: 
		goto l_300;
	case 4: 
		goto l_400;
	case 5: 
		goto l_500;
	case 6: 
		goto l_600;
	}
	/* */
	fprintf (nunit2, "\n\n+++++ order :  t=%12.4f ERROR in label selector \n                               strategy not found\n",
	     TiMe);
	goto l_99;
	/* */
	/*     RAN : RANDOM */
	/*     ============ */
l_100: 
	ordran(&ncar);
	goto l_1000;
	/* */
	/*     POR : TAXI/TRANSPORTER WITH LOWEST INDEX */
	/*     ======================================== */
l_200: 
	ordpor(&ncar);
	goto l_1000;
	/* */
	/*     SDS : SHORTEST DISTANCE  */
	/*     =======================  */
l_300: 
	ordsds(itargl, &ncar);
	goto l_1000;
	/* */
	/*     LDS : LARGEST DISTANCE */
	/*     ====================== */
l_400: 
	ordlds(itargl, &ncar);
	goto l_1000;
	/* */
	/*     TOP : PRESENT TERMINAL */
	/*     ====================== */
l_500: 
	ordtop(itargl, &ncar);
	goto l_1000;
	/* */
	/*     STRATEGY SUPPLIED BY USER */
	/*     ========================= */
l_600: 
	ordben(itargl, itargu, &ncar);
	/* */
	/*     WAS TAXI/TRANSPORTER FOUND? */
	/*     =========================== */
l_1000: 
	if (ncar != 0) {
		/* */
		/*     REGISTER REQUIREMENT WITH TAXI/TRANSPORTER */
		/*     ========================================== */
		carma[ncar][10] = (double)loglin;
		*found =  TRUE;
		/* */
		/*     COLLECTION OF STATISTICAL DATA: PARKING TIME */
		/*     ============================================ */
		statis[ncar][3] = statis[ncar][3] + 
		    TiMe - tx_system[next_int(carma[ncar][1])].t_block;
		/*     REMOVE TAXI/TRANSPORTER FROM STATION */
		/*     ==================================== */
		line = next_int(carma[ncar][1]);
#ifdef DEBUG
dprint(TRANSACTION, "order: line == %d, offset.park %d, carma[%d][6] %d\n", line, offset.park, ncar, next_int(carma[ncar][6])); /* */
#endif
		k    = offset.park + next_int(carma[ncar][6]) - 1;
		last = bhead[k] - activlist;
#ifdef DEBUG
dprint(TRANSACTION, "order: last %d\n", last); /* */
#endif
		if (last == line) {
			bhead[k]       = activlist + activlist[line].blk_link;
			activlist[line].blk_link = 0;
		} else {
l_1100:       
			if (activlist[last].blk_link != line) {
				last = activlist[last].blk_link;
				if (last != -1) 
					goto l_1100;
				goto l_2000;
			}
			activlist[last].blk_link = activlist[line].blk_link;
			activlist[line].blk_link = 0;
		}
		/* */
		/*     SCHEDULE TAXI/TRANSPORTER */
		/*     ========================= */
		activlist[line].next  = TiMe;
		carma[ncar][7] = 2.0;
		carma[ncar][8] = 1.0;
		tarma[ncar][1] = (double)itargl;
		tarma[ncar][2] = (double)itargu;
		switch (tchain(3, line))  {
		case FEHLER: 
			goto l_99;
		}
		/* */
		/*     COLLECTION OF STATISTICAL DATA: PARKING VEHICLES */
		/*     ================================================ */
		nterm = next_int(carma[ncar][6]);
		parkst[nterm][1] = parkst[nterm][1] + 
		    (parkst[nterm][2] - parkst[nterm][3]) * 
		    (TiMe - parkst[nterm][4]);
		parkst[nterm][3] = parkst[nterm][3] + 1;
		parkst[nterm][4] = TiMe;
	}
	/* */
#ifdef DEBUG
dprint(TRANSACTION, "order: return (NORMAL) \n"); /* */
#endif
	return(NORMAL);
	/* */
	/*     ERROR EXIT */
	/*     ========== */
l_2000:  
	fprintf (nunit2, "\n\n+++++ order :  t=%12.4f ERROR : vehicle %4d not found at parking station %4d\n", TiMe, ncar,
	     next_int(carma[ncar][6]));
l_99:    
	return(FEHLER);
	/* */
}


