static char *SccsId = "@(#)PEPSY:\tpolicy.c\t1.2\t92/03/27 11:57:46";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	policy(nt, ns, lfam, iftx, np)
int	*np ;
int	*iftx ;
int	lfam ;
int	ns ;
int	nt ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call policy(nt,ns,lfam, *iftx, *np)                           */
	/*    ***                                                               */
	/*    *** funktion : ermittlung der policy, nach der eine tr in die     */
	/*    ***            warteschlange vor der station k eingekettet        */
	/*    ***            werden soll                                        */
	/*    *** parameter: nt   = stationstyp                                 */
	/*    ***            ns   = typnummer                                   */
	/*    ***            lfam = zeilennumer in der fam-matrix fuer          */
	/*    ***                   stationen mit nt = 7,10 oder 11             */
	/*    ***             *iftx = rueckgabe: zeilennummer der tr,nach der die  */
	/*    ***                   laufende tr eingekettet werden soll         */
	/*    ***             *np   = rueckgabe: platznummer                    */
	/*    ***                                                               */
	extern int	pfifo(), fifo(), poli3(), poli4(), poli5();
	int	iaddr, i, ns1, k ;

	/*                                                                      */
	/*    policy suchen                                                     */
	/*    =============                                                     */
	iaddr = 1;
	for (i = 1; i <= zpol; ++i) {
		if (pol[i].type == nt && pol[i].station == ns) 
			iaddr = pol[i].policy;
	};
	/*                                                                      */
	/*    bestimmen der stationsnummer                                      */
	/*    ===========================                                       */
	ns1 = ns;
	if (nt < 10 && nt != 7 || nt >= 12) 
		goto l_200;
	ns1 = zfam * (ns - 1) + lfam;
l_200:  
	k = *ptr_offset[nt] + ns1 - 1;
	switch (iaddr) {
	case 1: 
		goto l_1;
	case 2: 
		goto l_2;
	case 3: 
		goto l_3;
	case 4: 
		goto l_4;
	case 5: 
		goto l_5;
	}
	/*                                                                      */
	fprintf(nunit2, "\n\n+++++ policy: TiMe=%12.4f fehler im adressverteiler  iaddr=%3d\n", TiMe, iaddr);
	return(NORMAL);
	/*                                                                      */
	/*    aufrufen des unterprogrammes poli                                 */
	/*    =================================                                 */
l_1:  
	pfifo(k, iftx, np);
	return(NORMAL);
l_2:  
	fifo(k, iftx, np);
	return(NORMAL);
l_3:  
	lifo(k, iftx, np);
	return(NORMAL);
l_4:  
	lifo(k, iftx, np);
	return(NORMAL);
l_5:  
	poli5();
	return(NORMAL);
}


