static char *SccsId = "@(#)PEPSY:\traster.c\t1.2\t92/03/27 11:57:55";
#include <stdio.h>
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"
#include <math.h>
#include <string.h>



int	raster(nras, drt, rstart, idn)
int	nras, idn;
float	rstart, drt;
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	/*     ***  */
	/*     *** CALL raster(nras,drt,rstart,idn,*9000,*9999) */
	/*     ***  */
	/*     *** purpose : delay a transaction by an interval number */
	/*     ***           of TiMe slices defending on the transactions */
	/*     ***           already waiting */
	/*     *** parameters: nras   = index of TiMe slice */
	/*     ***             DRT    = LENGTH OF TIME SLICE */
	/*     ***             RSTART = FIXED TIME SLICE */
	/*     ***                      >= 0: WITH INITIAL TIME RSTART */
	/*     ***                      = -1: VARIABLE TIME SLICE */
	/*     ***             IDN    = REACTIVATION LABEL  */
	/*     ***             EXIT1  = EXIT TO FLOW CONTROL */
	/*     ***             EXIT2  = ERROR EXIT */
	/*     ***  */
	/* */

	float	lTiMe, aTiMe;
	extern int	tchain();
	extern int	next_int();


	/*     TEST FOR ERRORS */
	/*     =============== */
	if (nras < 1 || nras > zras) 
		goto l_4000;
	if (drt < eps)               
		goto l_4100;
	/* */
	/*     DELAY */
	/*     ===== */
	lTiMe = rastl[nras];
	if (TiMe > lTiMe) {
		if (rstart < 0) {
			aTiMe = TiMe;
		} else {
			if (fmod((TiMe - rstart), drt) > 0) {
				aTiMe = ((float)next_int((TiMe - rstart) / drt) + 1) * drt + rstart;
			} else {
				aTiMe = ((float)next_int((TiMe - rstart) / drt)) * drt + rstart;
			}
		}
	} else {
		aTiMe = lTiMe;
	}
	rastl[nras]   = aTiMe + drt;
	activlist[row_txact].next = aTiMe;
	activlist[row_txact].target = (double)idn;
	tchain(3, row_txact) ;
l_200: 
	if ((iprint == 1 || jprint[24] == 1) && jprint[24] != -1) {
		if (TiMe + eps >= aTiMe) {
			fprintf (nunit2, "raster:  t=%12.4f  tr%6.0f,%4.0f   leaves rasterstation\n", TiMe, tx_system[row_txact].nr,
			     tx_system[row_txact].dup);
		} else {
			fprintf (nunit2, "raster:  t=%12.4f  tr%6.0f,%4.0f   is held in queue waiting for end of TiMe slice until t=%12.4f\n",
			     TiMe, tx_system[row_txact].nr, tx_system[row_txact].dup, aTiMe);
		}
	}
	/* */
	return(FEHLER);
	/* */
	/*     ERROR MESSAGES */
	/*     ============== */
l_4000:  
	fprintf (nunit2, "\n\n+++++ raster:  t=%12.4f  ERROR: invalid index of TiMe slice\n", TiMe);
	goto l_99;
	/* */
l_4100:  
	fprintf (nunit2, "\n\n+++++ raster:  t=%12.4f  ERROR: invalid length of TiMe slice\n", TiMe);
l_99:    
	return(AUSGANG2);
	/* */
}


