static char *SccsId = "@(#)PEPSY:\trblock.c\t1.2\t92/03/27 11:57:57";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	rblock(nt, ns, lfam, max)
int	max ;
int	lfam ;
int	ns ;
int	nt ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call rblock(nt,ns,lfam,max)                                   */
	/*    ***                                                               */
	/*    *** funktion : wiederblockieren von bereits deblockierten trs     */
	/*    *** parameter: nt   = stationstyp                                 */
	/*    ***            ns   = typnummer                                   */
	/*    ***            lfam = zeilennumer in der fam-matrix fuer stationen  */
	/*    ***                   mit nt = 7,10 oder 11                       */
	/*    ***            max  = anzahl der zu blockierenden trs             */
	/*    ***                   = 1: wiederblockieren einer tr              */
	/*    ***                   = 0: wiederblockieren aller trs             */
	/*    ***                                                               */
	extern next_int();
	int	tpoint, bpoint, ns1, k ;
	int	line, i, nextbp, lastbp ;
	/*                                                                      */
	/*    bestimmen der stationsnummer                                      */
	/*    ============================                                      */
	ns1 = ns;
	if (nt < 10 && nt != 7 || nt >= 12) 
		goto l_100;
	ns1 = zfam * (ns - 1) + lfam;
l_100:  
	k = *ptr_offset[nt] + ns1 - 1;
	/*                                                                      */
	/*    initialisieren der zeiger                                         */
	/*    =========================                                         */
	bpoint = bhead[k] - activlist;
	tpoint = head[3].link;
	line = 0;
	if (tpoint  <  0  ||  bpoint  <  0) 
		return(NORMAL);
	/*                                                                      */
	/*    erste deblockierte tr in der blockkette suchen                    */
	/*    ==============================================                    */
	if (activlist[bpoint].link  !=  0) 
		goto l_300;
l_200:  
	bpoint = activlist[bpoint].blk_link;
	if (bpoint  <  0) 
		return(NORMAL);
	if (activlist[bpoint].link  ==  0) 
		goto l_200;
	/*                                                                      */
	/*    erste deblockierte tr in der zeitkette suchen                     */
	/*    =============================================                     */
l_300:  
	if (activlist[tpoint].blk_link  !=  0) 
		goto l_320;
l_310:  
	line = tpoint ;
	tpoint = activlist[line].link ;
	if (tpoint  <  0) 
		return(NORMAL);
	if (activlist[tpoint].next  >  TiMe + eps) 
		return(NORMAL);
l_320:  
	if (tpoint  !=  bpoint) 
		goto l_310;
	/*                                                                      */
	/*    wiederblockieren von (max-1) deblockierten trs in der kette       */
	/*    ===========================================================       */
	for (i = 1; i <= ztx; ++i) {
		nextbp = bpoint;
		if (activlist[bpoint].link  <  0) 
			goto l_500;
		if (activlist[bpoint].link  ==  activlist[bpoint].blk_link) 
			goto l_420;
l_410:  
		nextbp = activlist[nextbp].blk_link;
		if (nextbp  <  0) 
			goto l_500;
		if (activlist[bpoint].link  !=  activlist[nextbp].blk_link) 
			goto l_410;
l_420:  
		if (max  ==  1) 
			goto l_430;
		activlist[bpoint].link = 0;

		if (nt <= 12) {
			if ((iprint == 1 || jprint[nt] == 1) && jprint[nt] != -1)
				fprintf(nunit2, " rblock:  TiMe=%12.4f  tr%6d,%4d   wird erneut blockiert\n",
				    TiMe, tx_system[bpoint].nr, tx_system[bpoint].dup);
		} else {
			if ((iprint == 1 || jprint[23] > 2) && 
			    jprint[23] != -1 && jprint[23] != -2)
				fprintf(nunit2, " rblock:  TiMe=%12.4f  vehicle%4d   wird erneut blockiert\n",
				    TiMe, next_int(txadd[bpoint][1]));
		}
l_430:  
		lastbp = bpoint;
		bpoint = activlist[nextbp].blk_link;
	};
	/*                                                                      */
	/*    wiederblockieren der letzten deblockierten tr in der kette        */
	/*    ==========================================================        */
l_500:  
	tpoint = activlist[bpoint].link;
	activlist[bpoint].link = 0;

	if (nt <= 12) {
		if ((iprint == 1 || jprint[nt] == 1) && jprint[nt] != -1)
			fprintf(nunit2, " rblock:  TiMe=%12.4f  tr%6d,%4d   wird erneut blockiert\n",
			    TiMe, tx_system[bpoint].nr, tx_system[bpoint].dup);
	} else {
		if ((iprint == 1 || jprint[23] > 2) && 
		    jprint[23] != -1 && jprint[23] != -2)
			fprintf(nunit2, " rblock:  TiMe=%12.4f  vehicle%4d   wird erneut blockiert\n",
			    TiMe, next_int(txadd[bpoint][1]));
	}
	/*                                                                      */
	/*    fallunterscheidung fuer schliessen der zeitkette                  */
	/*    ================================================                  */
l_600:  
	if (max  ==  1  &&  i  >  1) 
		goto l_610;
	if (line  !=  0) 
		goto l_620;
	head[3].link = tpoint;
	if (tpoint  <  0) 
		goto l_630;
	if (activlist[tpoint].next  >  head[3].next + eps) 
		head[3].next = activlist[tpoint].next;
	return(NORMAL);
l_610:  
	activlist[lastbp].link = tpoint;
	return(NORMAL);
l_620:  
	activlist[line].link = tpoint ;
	return(NORMAL);
l_630:  
	head[3].next = 0.0 ;
	return(NORMAL);
}


