static char *SccsId = "@(#)PEPSY:\trkf.c\t1.2\t92/03/27 11:58:22";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	rkf(nset, tstep, rerr, ierr)
int	ierr ;
double	*rerr ;
double	tstep ;
int	nset ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call rkf(nset,tstep, *rerr,ierr,*9999)                        */
	/*    ***                                                               */
	/*    *** funktion : ausfuehrung eines schrittes der                    */
	/*    ***            numerischen integration mit dem                    */
	/*    ***            'runge-kutta-fehlberg' verfahren                   */
	/*    *** parameter: nset  = nummer des zu integrierenden               */
	/*    ***                    sets                                       */
	/*    ***            tstep = schrittweite der numerischen               */
	/*    ***                    integration                                */
	/*    ***             *rerr  = rueckgabe: relativer integrationsfehler  */
	/*    ***            ierr  = indikator fuer fehlerbestimmung            */
	/*    ***            exit1 = fehlerausgang                              */
	/*    ***                                                               */
	extern int	state();
	int	ndv, i, imax ;
	double	a1[101], a2[101], a3[101], a4[101], a5[101] ;
	double	a6[101], loc_TiMe, err, svmax, rerrx ;
	/*                                                                      */
	double	bound = 1.e-25;
	/*                                                                      */
	if (jprint[20]  ==  2) 
		fprintf(nunit2, "\n\n TiMe = %12.4e     nset = %2d     tstep = %12.4e     integration mit rkf\n",
		    TiMe, nset, tstep);
	/*                                                                      */
	ndv  = intma[nset].dv_nr;
	loc_TiMe = TiMe;
	/*                                                                      */
	/*    berechnung der a1 bis a5                                          */
	/*    ========================                                          */
	for (i = 1; i <= ndv; ++i) {
		a1[i] = tstep * dvlast[nset][i];
		sv[nset][i] = svlast[nset][i] + a1[i] / 4.;
	};
	TiMe = loc_TiMe + tstep / 4.;
	switch (state(nset)) {
	case FEHLER : 
		goto l_9999;
	};
	for (i = 1; i <= ndv; ++i) {
		a2[i] = tstep * dv[nset][i];
		sv[nset][i] = svlast[nset][i] + (3. * a1[i] + 9. * a2[i]) / 32.;
	};
	TiMe = loc_TiMe + 3. * tstep / 8.;
	switch (state(nset)) {
	case FEHLER : 
		goto l_9999;
	};
	for (i = 1; i <= ndv; ++i) {
		a3[i] = tstep * dv[nset][i];
		sv[nset][i] = svlast[nset][i]
		     + ( 1932. * a1[i] - 7200. * a2[i] + 7296. * a3[i] ) / 2197.;
	};
	TiMe = loc_TiMe + 12. * tstep / 13.;
	switch (state(nset)) {
	case FEHLER : 
		goto l_9999;
	};
	for (i = 1; i <= ndv; ++i) {
		a4[i] = tstep * dv[nset][i];
		sv[nset][i] = svlast[nset][i] +  439. * a1[i] / 216. -   8. * a2[i]                            + 3680. *
		    a3[i] / 513. - 845. * a4[i] / 4104.;
	};
	TiMe = loc_TiMe + tstep;
	switch (state(nset)) {
	case FEHLER : 
		goto l_9999;
	};
	for (i = 1; i <= ndv; ++i) {
		a5[i] = tstep * dv[nset][i];
	};
	/*                                                                      */
	/*    berechnung der a6                                                 */
	/*    =================                                                 */
	if (ierr == 1) 
		goto l_100;
	for (i = 1; i <= ndv; ++i) {
		sv[nset][i] = svlast[nset][i] 
		    -   8. * a1[i] / 27.   +  2. * a2[i] - 3544. * a3[i] / 2565.
		     + 1859. * a4[i] / 4104. - 11. * a5[i] / 40.;
	};
	TiMe = loc_TiMe + tstep / 2.;
	switch (state(nset)) {
	case FEHLER : 
		goto l_9999;
	};
	for (i = 1; i <= ndv; ++i) {
		a6[i] = tstep * dv[nset][i];
	};
	/*                                                                      */
	/*    berechnung der sv und dv an der stelle t+tstep                    */
	/*    ==============================================                    */
l_100:        
	for (i = 1; i <= ndv; ++i) {
		sv[nset][i] = svlast[nset][i] + 25. * a1[i] / 216. + 1408. * a3[i] / 2565.
		     + 2197. * a4[i] / 4104. - a5[i] / 5. ;
	};
	TiMe = loc_TiMe + tstep;
	switch (state(nset)) {
	case FEHLER : 
		goto l_9999;
	};
	/*                                                                      */
	/*    fehlerabschaetzung                                                */
	/*    ==================                                                */
	if (ierr  ==  1) 
		goto l_9000;
	/*                                                                      */
	for (i = 1; i <= ndv; ++i) {
		err =  a1[i] / 360. - 128. * a3[i] / 4275.
		    -2197. * a4[i] / 75240. + a5[i] / 50. +   2. * a6[i] / 55.;
		svmax = MAX(fabs(sv[nset][i]), fabs(svlast[nset][i]));
		if (svmax  >=  bound) 
			rerrx = fabs(err) / svmax;
		if (svmax  <  bound) 
			rerrx = fabs(err) / bound;
		/*                                                                      */
		if (jprint[20]  ==  2) 
			fprintf(nunit2, "   sv(%2d,%3d)=%16.8e    dv(%2d,%3d)=%16.8e      err=%16.8e    rerrx=%16.8e\n",
			    nset, i, sv[nset][i], nset, i, dv[nset][i], err, rerrx);
		/*                                                                      */
		if (rerrx  <   *rerr) 
			continue;
		*rerr = rerrx;
		imax = i;
	};
	/*                                                                      */
	if (jprint[20]  ==  2) 
		fprintf(nunit2, "%51sgroesster rel. fehler fuer sv(%2d,%3d):  rerr =%16.8e\n",
		    BLANKF, nset, imax,  *rerr);
	/*                                                                      */
l_9000:
	return(NORMAL);
l_9999:
	return(FEHLER);
}


