static char *SccsId = "@(#)PEPSY:\trkimp.c\t1.2\t92/03/27 11:58:25";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	rkimp(nset, tstep, rerr, ierr)
int	ierr ;
double	*rerr ;
double	tstep ;
int	nset ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call rkimp(nset,tstep, *rerr,ierr,*9999)                      */
	/*    ***                                                               */
	/*    *** funktion  : ausfuehrung eines schrittes der                   */
	/*    ***             numerischen integration mit einem                 */
	/*    ***             impliziten runge-kutta verfahren                  */
	/*    ***             vom gauss-typ                                     */
	/*    *** parameter : nset  = nummer des zu integrierenden              */
	/*    ***                     sets                                      */
	/*    ***             tstep = schrittweite der numerischen              */
	/*    ***                     integration                               */
	/*    ***              *rerr  = rueckgabe: relativer integrationsfehler   */
	/*    ***             ierr  = indikator fuer fehlerberechnung           */
	/*    ***             exit1 = fehlerausgang                             */
	/*    ***                                                               */
	extern int	state();
	int	nsv, ndv, iph, i, j, l, imax ;
	double	k[4][101], kn[4][101], km, svm[101], svml[101] ;
	double	dvml[101], TiMex, tstepl, loc_TiMe ;
	double	err, svmax, rerrx ;
	/*                                                                      */
	double	bound = 1.e-25;
	/*                                                                      */
	if (jprint[20]  ==  2) 
		fprintf(nunit2, "\n\n TiMe = %12.4e     nset = %2d     tstep = %12.4e     integration mit rkimp\n",
		    TiMe, nset, tstep);
	/*                                                                      */
	TiMex = TiMe;
	tstepl = tstep;
	nsv = intma[nset].sv_nr;
	ndv = intma[nset].dv_nr;
	iph = 1;
	if (ierr == 1) 
		goto l_100;
	/*                                                                      */
	/*    vorbesetzung entsprechend der rechenphase                         */
	/*    =========================================                         */
l_1:  
	switch (iph) {
	case 1: 
		goto l_10;
	case 2: 
		goto l_20;
	case 3: 
		goto l_30;
	};
l_10:        
	for (i = 1; i <= nsv; ++i) {
		svml[i] = svlast[nset][i];
	};
	for (i = 1; i <= ndv; ++i) {
		dvml[i] = dvlast[nset][i];
	};
	tstepl = tstepl / 2.;
	goto l_100;
l_20:        
	for (i = 1; i <= nsv; ++i) {
		svlast[nset][i] = sv[nset][i];
	};
	for (i = 1; i <= ndv; ++i) {
		dvlast[nset][i] = dv[nset][i];
	};
	goto l_100;
l_30:        
	for (i = 1; i <= nsv; ++i) {
		svm[i] = sv[nset][i];
		sv[nset][i] = svml[i];
		svlast[nset][i] = svml[i];
	};
	for (i = 1; i <= ndv; ++i) {
		dv[nset][i] = dvml[i];
		dvlast[nset][i] = dvml[i];
	};
	tstepl = 2. * tstepl;
	TiMe = TiMex;
	goto l_100;
	/*                                                                      */
	/*    durchfuehrung der integration                                     */
	/*    =============================                                     */
	/*    vorbesetzen der k1, k2, k3                                        */
	/*    --------------------------                                        */
l_100:  
	loc_TiMe = TiMe;
	for (j = 1; j <= ndv; ++j) {
		km = tstepl * dvlast[nset][j];
		for (i = 1; i <= 3; ++i) {
			k[i][j] = km;
		};
	};
	/*                                                                      */
	/*    ausfuehren von 6 iterationsschritten                              */
	/*    ------------------------------------                              */
	for (l = 1; l <= 6; ++l) {
		for (j = 1; j <= ndv; ++j) {
			sv[nset][j] = svlast[nset][j] + 5. * k[1][j] / 36. + (2. / 9. - 1. / sqrt(15.)) * k[2][j] + (5. /
			    36. - 1. / (2. * sqrt(15.))) * k[3][j];
		};
		TiMe = loc_TiMe + (1. - sqrt(3. / 5.)) * tstepl / 2.;
		switch (state(nset)) {
		case FEHLER : 
			goto l_9999;
		};
		for (j = 1; j <= ndv; ++j) {
			kn[1][j] = tstepl * dv[nset][j];
			sv[nset][j] = svlast[nset][j] + (5. / 36. + sqrt(15.) / 24.) * k[1][j] + 2. * k[2][j] / 9. + (5.
			    / 36. - sqrt(15.) / 24.) * k[3][j];
		};
		TiMe = loc_TiMe + tstepl / 2.;
		switch (state(nset)) {
		case FEHLER : 
			goto l_9999;
		};
		for (j = 1; j <= ndv; ++j) {
			kn[2][j] = tstepl * dv[nset][j];
			sv[nset][j] = svlast[nset][j] + (5. / 36. + 1. / (2. * sqrt(15.))) * k[1][j] + (2. / 9. + 1. / sqrt(15.))
			    *k[2][j] + 5. * k[3][j] / 36.;
		};
		TiMe = loc_TiMe + (1. + sqrt(3. / 5.)) * tstepl / 2.;
		switch (state(nset)) {
		case FEHLER : 
			goto l_9999;
		};
		for (j = 1; j <= ndv; ++j) {
			kn[3][j] = tstepl * dv[nset][j];
			for (i = 1; i <= 3; ++i) {
				k[i][j] = kn[i][j];
			};
		};
	};
	/*                                                                      */
	/*    berechnung der sv und dv an der stelle t+tstep                    */
	/*    ----------------------------------------------                    */
	for (i = 1; i <= ndv; ++i) {
		sv[nset][i] = svlast[nset][i] + 5. * k[1][i] / 18. + 4. * k[2][i] / 9. + 5. * k[3][i] / 18. ;
	};
	TiMe = loc_TiMe + tstepl;
	switch (state(nset)) {
	case FEHLER : 
		goto l_9999;
	};
	if (ierr == 1) 
		goto l_9000;
	iph = iph + 1;
	if (iph <= 3) 
		goto l_1;
	/*                                                                      */
	/*    fehlerabschaetzung                                                */
	/*    ==================                                                */
	for (i = 1; i <= ndv; ++i) {
		err = (svm[i] - sv[nset][i]) / (pow(0.5, 6.) - 1.);
		svmax = MAX(fabs(sv[nset][i]), fabs(svlast[nset][i]));
		if (svmax  >=  bound) 
			rerrx = fabs(err) / svmax;
		if (svmax  <  bound) 
			rerrx = fabs(err) / bound;
		/*                                                                      */
		if (jprint[20]  ==  2) 
			fprintf(nunit2, "   sv(%2d,%3d)=%16.8e    dv(%2d,%3d)=%16.8e      err=%16.8e    rerrx=%16.8e\n",
			    nset, i, sv[nset][i], nset, i, dv[nset][i], err, rerrx);
		/*                                                                      */
		if (rerrx  <   *rerr) 
			continue;
		*rerr = rerrx;
		imax = i;
		;
	};
	/*                                                                      */
	if (jprint[20]  ==  2) 
		fprintf(nunit2, "%51sgroesster rel. fehler fuer sv(%2d,%3d):  rerr =%16.8e\n",
		    nset, imax,  *rerr);
	/*                                                                      */
l_9000:
	return(NORMAL);
l_9999:
	return(FEHLER);
}


