static char *SccsId = "@(#)PEPSY:\trnx.c\t1.3\t92/03/27 11:58:29";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


double	rnx(irnum)
register int	irnum ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** funktion : erzeugen einer pseudo-zufallszahl im intervall     */
	/*    ***            (0,1)                                              */
	/*    *** parameter: irnum = nummer des zufallszahlgenerators           */
	/*    ***                                                               */
	int	drnh, drnl, dprodh, dprodl;
	double	local_rnx;
#ifdef DEBUG
dprint(RANDOM, "rnx: irnum %d\n", irnum); /* */
#endif
	if (irnum > 30) {
#ifdef DEBUG
dprint(WARNING, "rnx: irnum set from %d to %d\n", irnum, irnum % 30 + 1); /* */
#endif
		irnum = irnum % 30 + 1;
	}
	/*                                                                      */
	/*    aufteilen von drn                                                 */
	/*    =================                                                 */
	drnl = drn[irnum] % dmodul[2];
	drnh = (drn[irnum] - drnl) / dmodul[2];
	/*                                                                      */
	/*    erzeugen der beiden teilprodukte                                  */
	/*    ================================                                  */
	dprodl = drnl * dfact[irnum][2] + dconst[irnum][2];
	dprodh = drnl * dfact[irnum][1] + drnh * dfact[irnum][2] + dconst[irnum][1];
	/*                                                                      */
	/*    erzeugen der neuen zufallszahl                                    */
	/*    ==============================                                    */
	dprodh = dprodh % dmodul[2];
	drn[irnum] = (dprodh * dmodul[2] + dprodl) % dmodul[1];
	local_rnx =  (double)drn[irnum] / (double)(dmodul[1] - 1);
	/*                                                                      */
#ifdef DEBUG
dprint(RANDOM, "rnx: random %lf\n", local_rnx); /* */
#endif
	return(local_rnx);
}


