static char *SccsId = "@(#)PEPSY:\trowa.c\t1.2\t92/03/27 11:58:31";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	rowa (nset, tstep, rerr, ierr)
int	ierr ;
double	*rerr ;
double	tstep ;
int	nset ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call rowa (nset,tstep, *rerr,ierr,*9999)                      */
	/*    ***                                                               */
	/*    *** funktion : ausfuehrung eines schrittes der                    */
	/*    ***            numerischen integration mittels                    */
	/*    ***            eines rosenbrock-wanner-integrators                */
	/*    *** parameter: nset  = nummer des zu integrierenden sets          */
	/*    ***            tstep = anfangsschrittweite                        */
	/*    ***             *rerr  = rueckgabe: relativer integrationsfehler  */
	/*    ***            ierr  = indikator fuer fehlerbestimmung            */
	/*    ***            exit1 = fehlerausgang                              */
	/*    ***                                                               */
#define n 10
	/*    ***            n     = maximal moegliche anzahl von               */
	/*    ***                    differentialgleichungen                    */
	/*                                                                      */
	extern int	state();
	int	ip[n], ndv, i ;
	int	j, nm1, k, kp1, m, kb, km1, imax ;
	double	jakobi[n][n], k1[n], k2[n], k3[n], k4[n];
	double	TiMe1, TiMe2, loc_TiMe, epsi;
	double	v, err, svmax, rerrx ;
	/*                                                                      */
	double	a21 = 0.438;
	double	a31 = 0.93894867848343;
	double	a32 = 0.073079542061538;
	double	b1 = 0.72904487996031;
	double	b2 = 0.054106977327241;
	double	b3 = 0.28159936244002;
	double	b4 = 0.25;
	double	c21 = -1.9434744189471;
	double	c31 = 0.41695753098919;
	double	c32 = 1.3239678207292;
	double	c41 = 1.5195132577845;
	double	c42 = 1.3537081503009;
	double	c43 = -0.85415149525754;
	double	e1 = -0.019085887199947;
	double	e2 = 0.25560879171646;
	double	e3 = -0.086381628089759;
	double	e4 = 0.25;
	double	bound = 1.e-25;
	/*                                                                      */
	if (jprint[20]  ==  2) 
		fprintf(nunit2, "\n\n TiMe = %12.4e     nset = %2d     tstep = %12.4e     integration mit rowa\n",
		    TiMe, nset, tstep);
	/*                                                                      */
	/*    zahl der gleichungen groesser n ?                                 */
	/*    =================================                                 */
	ndv = intma[nset].dv_nr;
	if (ndv <= n) 
		goto l_10;
	fprintf(nunit2, "\n\n+++++ rowa: TiMe= %12.4f\n%12sanzahl derdifferentialgleichungen groesser%4d\n",
	    TiMe, BLANKF, n);
	goto l_9999;
	/*                                                                      */
l_10:  
	TiMe1 = 0.438 ;
	TiMe2 = 0.907376081;
	loc_TiMe = TiMe;
	/*                                                                      */
	/*    berechnung der jakobi-matrix und umwandlung in matrix e           */
	/*    =======================================================           */
	for (k = 1; k <= ndv; ++k) {
		epsi = 1.e-3 * fabs(sv[nset][k]);
		epsi = MAX(epsi, bound);
		sv[nset][k] = sv[nset][k] + epsi;
		switch (state(nset)) {
		case FEHLER : 
			goto l_9999;
		};
		for (i = 1; i <= ndv; ++i) {
			jakobi[i][k] = (dv[nset][i] - dvlast[nset][i]) / epsi;
			jakobi[i][k] = -jakobi[i][k] * tstep * 0.395;
		};
		jakobi[k][k] = jakobi[k][k] + 1.;
		sv[nset][k] = svlast[nset][k];
		;
	};
	/*                                                                      */
	/*    decomposition der jakobi matrix                                   */
	/*    ===============================                                   */
	ip[ndv] = 1;
	nm1 = ndv - 1;
	if (ndv == 1) 
		goto l_100;
	for (k = 1; k <= nm1; ++k) {
		kp1 = k + 1;
		m = k;
		for (i = kp1; i <= nm1; ++i) {
			if (fabs(jakobi[i][k]) > fabs(jakobi[m][k]))
				m = i ;
		};
		ip[k] = m;
		v = jakobi[m][k];
		if (m == k)
			goto l_55;
		ip[ndv] = -ip[ndv];
		jakobi[m][k] = jakobi[k][k];
		jakobi[k][k] = v;
l_55:  
		if (v == 0.) 
			goto l_90;
		v = 1. / v;
		for (i = kp1; i <= ndv; ++i) {
			jakobi[i][k] = -jakobi[i][k] * v;
		};
		for (j = kp1; j <= ndv; ++j) {
			v = jakobi[m][j];
			jakobi[m][j] = jakobi[k][j];
			jakobi[k][j] = v;
			if (v == 0.) 
				continue ;
			for (i = kp1; i <= ndv; ++i) {
				jakobi[i][j] = jakobi[i][j] + jakobi[i][k] * v;
			};
		};
	};
	goto l_100;
	/*                                                                      */
	/*    ausgang falls jakobi-matrix nicht invertierbar                    */
	/*    ----------------------------------------------                    */
l_90:   
	*rerr = 1.0;
	goto l_9000;
	/*                                                                      */
	/*    berechnen der k1                                                  */
	/*    ================                                                  */
l_100:  
	for (i = 1; i <= ndv; ++i) {
		k1[i] = tstep * dvlast[nset][i];
	};
	if (ndv == 1) 
		goto l_140;
	for (k = 1; k <= nm1; ++k) {
		m = ip[k];
		v = k1[m] ;
		k1[m] = k1[k];
		k1[k] = v ;
		kp1 = k + 1;
		for (i = kp1; i <= ndv; ++i) {
			k1[i] = k1[i] + jakobi[i][k] * v;
		};
	};
	for (kb = 1; kb <= nm1; ++kb) {
		km1 = ndv - kb;
		k = km1 + 1;
		k1[k] = k1[k] / jakobi[k][k] ;
		v = -k1[k];
		for (i = 1; i <= km1; ++i) {
			k1[i] = k1[i] + jakobi[i][k] * v;
		};
	};
l_140:  
	k1[1] = k1[1] / jakobi[1][1] ;
	/*                                                                      */
	/*    berechnen der sv zum zeitpunkt loc_TiMe + tstep*TiMe1                 */
	/*    -------------------------------------------------                 */
	for (i = 1; i <= ndv; ++i) {
		sv[nset][i] = svlast[nset][i] + a21 * k1[i];
	};
	TiMe = loc_TiMe + tstep * TiMe1;
	switch (state(nset)) {
	case FEHLER : 
		goto l_9999;
	};
	/*                                                                      */
	/*    berechnung der k2                                                 */
	/*    =================                                                 */
	for (i = 1; i <= ndv; ++i) {
		k2[i] = dv[nset][i] * tstep + c21 * k1[i] ;
	};
	if (ndv == 1) 
		goto l_240;
	for (k = 1; k <= nm1; ++k) {
		m = ip[k];
		v = k2[m] ;
		k2[m] = k2[k];
		k2[k] = v ;
		kp1 = k + 1;
		for (i = kp1; i <= ndv; ++i) {
			k2[i] = k2[i] + jakobi[i][k] * v;
		};
	};
	for (kb = 1; kb <= nm1; ++kb) {
		km1 = ndv - kb;
		k = km1 + 1;
		k2[k] = k2[k] / jakobi[k][k] ;
		v = -k2[k];
		for (i = 1; i <= km1; ++i) {
			k2[i] = k2[i] + jakobi[i][k] * v;
		};
	};
l_240:  
	k2[1] = k2[1] / jakobi[1][1] ;
	/*                                                                      */
	/*    berechnung der sv zum zeitpunkt loc_TiMe + tstep*TiMe2                */
	/*    --------------------------------------------------                */
	for (i = 1; i <= ndv; ++i) {
		sv[nset][i] = svlast[nset][i] + a31 * k1[i] + a32 * k2[i];
	};
	TiMe = loc_TiMe + tstep * TiMe2;
	switch (state(nset)) {
	case FEHLER : 
		goto l_9999;
	};
	/*                                                                      */
	/*    berechnung der k3                                                 */
	/*    =================                                                 */
	for (i = 1; i <= ndv; ++i) {
		k3[i] = dv[nset][i] * tstep + c31 * k1[i] + c32 * k2[i];
	};
	if (ndv == 1) 
		goto l_340;
	for (k = 1; k <= nm1; ++k) {
		m = ip[k];
		v = k3[m] ;
		k3[m] = k3[k];
		k3[k] = v ;
		kp1 = k + 1;
		for (i = kp1; i <= ndv; ++i) {
			k3[i] = k3[i] + jakobi[i][k] * v;
		};
	};
	for (kb = 1; kb <= nm1; ++kb) {
		km1 = ndv - kb;
		k = km1 + 1;
		k3[k] = k3[k] / jakobi[k][k] ;
		v = -k3[k];
		for (i = 1; i <= km1; ++i) {
			k3[i] = k3[i] + jakobi[i][k] * v;
		};
	};
l_340:  
	k3[1] = k3[1] / jakobi[1][1] ;
	/*                                                                      */
	/*    berchnung der k4                                                  */
	/*    ================                                                  */
	for (i = 1; i <= ndv; ++i) {
		k4[i] = dv[nset][i] * tstep + c41 * k1[i] + c42 * k2[i] + c43 * k3[i];
	};
	if (ndv == 1) 
		goto l_440;
	for (k = 1; k <= nm1; ++k) {
		m = ip[k];
		v = k4[m] ;
		k4[m] = k4[k];
		k4[k] = v ;
		kp1 = k + 1;
		for (i = kp1; i <= ndv; ++i) {
			k4[i] = k4[i] + jakobi[i][k] * v;
		};
	};
	for (kb = 1; kb <= nm1; ++kb) {
		km1 = ndv - kb;
		k = km1 + 1;
		k4[k] = k4[k] / jakobi[k][k] ;
		v = -k4[k];
		for (i = 1; i <= km1; ++i) {
			k4[i] = k4[i] + jakobi[i][k] * v;
		};
	};
l_440:  
	k4[1] = k4[1] / jakobi[1][1] ;
	/*                                                                      */
	/*    berechnung der sv und dv zum zeitpunkt loc_TiMe + tstep               */
	/*    ===================================================               */
	for (i = 1; i <= ndv; ++i) {
		sv[nset][i] = svlast[nset][i] + b1 * k1[i] + b2 * k2[i] + b3 * k3[i] + b4 * k4[i];
	};
	TiMe = loc_TiMe + tstep;
	switch (state(nset)) {
	case FEHLER : 
		goto l_9999;
	};
	/*                                                                      */
	/*    fehlerabschaetzung                                                */
	/*    ==================                                                */
	if (ierr == 1) 
		goto l_9000;
	/*                                                                      */
	for (i = 1; i <= ndv; ++i) {
		err = e1 * k1[i] + e2 * k2[i] + e3 * k3[i] + e4 * k4[i];
		svmax = MAX(fabs(sv[nset][i]), fabs(svlast[nset][i]));
		if (svmax  >=  bound) 
			rerrx = fabs(err) / svmax;
		if (svmax  <  bound) 
			rerrx = fabs(err) / bound;
		/*                                                                      */
		if (jprint[20]  ==  2) 
			fprintf(nunit2, "   sv(%2d,%3d)=%16.8e    dv(%2d,%3d)=%16.8e      err=%16.8e    rerrx=%16.8e\n",
			    nset, i, sv[nset][i], nset, i, dv[nset][i], err, rerrx);
		/*                                                                      */
		if (rerrx  <   *rerr) 
			continue;
		*rerr = rerrx;
		imax = i;
		;
	};
	/*                                                                      */
	if (jprint[20]  ==  2) 
		fprintf(nunit2, "%51sgroesster rel. fehler fuer sv(%2d,%3d):  rerr =%16.8e\n",
		    BLANKF, nset, imax,  *rerr);
	/*                                                                      */
l_9000:
	return(NORMAL);
l_9999:
	return(FEHLER);
}


