static char *SccsId = "@(#)PEPSY:\tsavin.c\t1.2\t92/03/27 11:58:36";
#include <stdio.h>
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"
#include <math.h>
#include <string.h>


FILE *fopen ();

int	savin()
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	/*     ***  */
	/*     *** CALL SAVIN (*9999) */
	/*     ***  */
	/*     *** PURPOSE  : INPUT VARIABLES REPRESENTING THE STATE OF THE MODEL */
	/*     ***            FROM FILE WITH LOGICAL DEVICE NUMBER "UNIT7" */
	/*     *** PARAMETERS:EXIT1 = ERROR EXIT  */
	/*     ***  */
	/* */
	/*     NONCONTINUOUS VERSION OF GPSS3 */
	/*     ARRAY BOUNDS CHANGED */
	/* */

	char	dimpa[41][7];
	int	sm;
	int	ksys[41];
	int	zsys[41];
	int	kasm, kbin, kcar, kevt, kfac, kfam, kgate, kgatf, kgatt, kmatch;
	int	kmfac, knach, kncond, knplo, knset, kntab, knv, kpol, kpool, kpunkt, kras;
	int	krout, krout1, kse, ksect, ksegm, ksegm1, ksm, ksrc, ksta, kstat;
	int	ksto, ktab, ktx1, ktx2, kuchf, kucht, kvar, kverz, kvon;
	int	i, j;
	int	lsm, lse, lsl;
	extern int	nchain(), next_int(), tchain();
	float	a;

	/*     NONCONTINUOUS VERSION OF GPSS3 */
	/*     "LDVAR","NCRO","NDVAR" DELETED */
	/* */

	strcpy(dimpa[1], "asm   "); 
	strcpy(dimpa[2], "bin   ");
	strcpy(dimpa[3], "car   "); 
	strcpy(dimpa[4], "evt   ");
	strcpy(dimpa[5], "fac   "); 
	strcpy(dimpa[6], "fam   ");
	strcpy(dimpa[7], "gate  "); 
	strcpy(dimpa[8], "gatf  ");
	strcpy(dimpa[9], "gatt  "); 
	strcpy(dimpa[10], "match ");
	strcpy(dimpa[11], "mfac  "); 
	strcpy(dimpa[12], "nach  ");
	strcpy(dimpa[13], "ncond "); 
	strcpy(dimpa[14], "nplo  ");
	strcpy(dimpa[15], "nset  "); 
	strcpy(dimpa[16], "ntab  ");
	strcpy(dimpa[17], "nv    "); 
	strcpy(dimpa[18], "pol   ");
	strcpy(dimpa[19], "pool  "); 
	strcpy(dimpa[20], "punkt ");
	strcpy(dimpa[21], "ras   "); 
	strcpy(dimpa[22], "rout  ");
	strcpy(dimpa[23], "rout1 "); 
	strcpy(dimpa[24], "se    ");
	strcpy(dimpa[25], "sect  "); 
	strcpy(dimpa[26], "segm  ");
	strcpy(dimpa[27], "segm1 "); 
	strcpy(dimpa[28], "sm    ");
	strcpy(dimpa[29], "src   "); 
	strcpy(dimpa[30], "sta   ");
	strcpy(dimpa[31], "stat  "); 
	strcpy(dimpa[32], "sto   ");
	strcpy(dimpa[33], "tab   "); 
	strcpy(dimpa[34], "tx1   ");
	strcpy(dimpa[35], "tx2   "); 
	strcpy(dimpa[36], "uchf  ");
	strcpy(dimpa[37], "ucht  "); 
	strcpy(dimpa[38], "var   ");
	strcpy(dimpa[39], "verz  "); 
	strcpy(dimpa[40], "von   ");


	/*     INPUT AND CHECK ARRAY BOUNDS */
	/*     ============================ */
	/*     NONCONTINUOUS VERSION OF GPSS3 */
	/*     KLDVAR,KNDVAR,KNCRO DELETED */
	/* */
	rewind (unit7);
	fscanf (unit7, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
	                  &kasm,  &kbin,   &kcar,  &kevt,   &kfac,   &kfam,  &kgate, &kgatf,
	    &kgatt, &kmatch, &kmfac, &knach,  &kncond, &knplo, &knset, &kntab,
	    &knv,   &kpol,   &kpool, &kpunkt, &kras,   &krout, &krout1, &kse,
	    &ksect, &ksegm,  &ksegm1, &ksm,   &ksrc,   &ksta,  &kstat, &ksto,
	    &ktab,  &ktx1,  &ktx2,  &kuchf,  &kucht,  &kvar,  &kverz, &kvon);

	/*     NONCONTINOUS VERSION OF GPSS3 */
	/*     KSYS(10),KSYS(15),KSYS(16) DELETED */
	/* */
	ksys[1] = kasm;
	ksys[2] = kbin;
	ksys[3] = kcar;
	ksys[4] = kevt;
	ksys[5] = kfac;
	ksys[6] = kfam;
	ksys[7] = kgate;
	ksys[8] = kgatf;
	ksys[9] = kgatt;
	ksys[10] = kmatch;
	ksys[11] = kmfac;
	ksys[12] = knach;
	ksys[13] = kncond;
	ksys[14] = knplo;
	ksys[15] = knset;
	ksys[16] = kntab;
	ksys[17] = knv;
	ksys[18] = kpol;
	ksys[19] = kpool;
	ksys[20] = kpunkt;
	ksys[21] = kras;
	ksys[22] = krout;
	ksys[23] = krout1;
	ksys[24] = kse;
	ksys[25] = ksect;
	ksys[26] = ksegm;
	ksys[27] = ksegm1;
	ksys[28] = ksm;
	ksys[29] = ksrc;
	ksys[30] = ksta;
	ksys[31] = kstat;
	ksys[32] = ksto;
	ksys[33] = ktab;
	ksys[34] = ktx1;
	ksys[35] = ktx2;
	ksys[36] = kuchf;
	ksys[37] = kucht;
	ksys[38] = kvar;
	ksys[39] = kverz;
	ksys[40] = kvon;
	/* */
	/*     NONCONTINUOUS VERSION OF GPSS3 */
	/*     ZSYS(10),ZSYS(15),ZSYS(16) DELETED */
	/* */
	zsys[1] = zasm;
	zsys[2] = zbin;
	zsys[3] = zcar;
	zsys[4] = zevt;
	zsys[5] = zfac;
	zsys[6] = zfam;
	zsys[7] = zgate;
	zsys[8] = zgatf;
	zsys[9] = zgatt;
	zsys[10] = zmatch;
	zsys[11] = zmfac;
	zsys[12] = znach;
	zsys[13] = zncond;
	zsys[14] = znplo;
	zsys[15] = znset;
	zsys[16] = zntab;
	zsys[17] = znv;
	zsys[18] = zpol;
	zsys[19] = zpool;
	zsys[20] = zpunkt;
	zsys[21] = zras;
	zsys[22] = zrout;
	zsys[23] = zrout1;
	zsys[24] = zse;
	zsys[25] = zsect;
	zsys[26] = zsegm;
	zsys[27] = zsegm1;
	zsys[28] = zsm;
	zsys[29] = zsrc;
	zsys[30] = zsta;
	zsys[31] = zstat;
	zsys[32] = zsto;
	zsys[33] = ztab;
	zsys[34] = ztx;
	zsys[35] = ztx2;
	zsys[36] = zuchf;
	zsys[37] = zucht;
	zsys[38] = zvar;
	zsys[39] = zverz;
	zsys[40] = zvon;
	/* */
	for (i = 1; i <=  40; i++)  {
		if (ksys[i]  >  zsys[i]) 
			goto l_9900;
	}
	/* */



	/*     COMMON /BI);  */
	/*     ============ */
	for (i = 1; i <= zbin; i++)  {
		fscanf  (unit7, "%d", &bin[i].act);
		fscanf  (unit7, "%d", &bin[i].max);
		fscanf  (unit7, "%d", &bin[i].access);
		fscanf  (unit7, "%d", &bin[i].leave);
		fscanf  (unit7, "%d", &bin[i].arrive);
		fscanf  (unit7, "%d", &bin[i].depart);
		fscanf  (unit7, "%f", &bin[i].total_wait);
		fscanf  (unit7, "%f", &bin[i].last_change);
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zbin; i++)  {
		fscanf  (unit7, "%f", &binsta[i].wait);
		fscanf  (unit7, "%f", &binsta[i].que_length);
		fscanf  (unit7, "%f", &binsta[i].confi);
		fscanf  (unit7, "%f", &binsta[i].dev);
		fscanf  (unit7, "%f", &binsta[i].end_osz);
	}
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /CON/ */
	/*     ============ */
	for (i = 1; i <= zbin; i++)  {
		fscanf  (unit7, "%f", &conflist[i].next);
		fscanf  (unit7, "%f", &conflist[i].int_length);
		fscanf  (unit7, "%f", &conflist[i].total_prev);
		fscanf  (unit7, "%d", &conflist[i].index);
		fscanf  (unit7, "%d", &conflist[i].autom);
		fscanf  (unit7, "%d", &conflist[i].link);
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zbin; i++)  {
		for (j = 1; j <= zconf; j++)  {
			fscanf  (unit7, "%f", &con[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	fscanf  (unit7, "%f", &conf_level);
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /DEL/ */
	/*     ============ */
	/*     NONCONTINUOUS VERSION OF GPSS3 */
	/*     ORIGINAL PART DELETED */
	/* */
	/*     COMMON /DRN/ */
	/*     ============ */
	for (i = 1; i <= 30; i++)  {
		fscanf  (unit7, "%d", &drn[i]);
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= 30; i++)  {
		fscanf  (unit7, "%d", &dfact[i][1]);
		fscanf  (unit7, "%d", &dfact[i][2]);
	}
	fscanf  (unit7, "\n");
	fscanf  (unit7, "%d", &dmodul[1]);
	fscanf  (unit7, "\n");
	for (i = 1; i <= 30; i++)  {
		fscanf  (unit7, "%d", &dconst[i][1]);
		fscanf  (unit7, "%d", &dconst[i][2]);
	}
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /EQU/ */
	/*     ============ */
	/*     NONCONTINUOUS VERSION OF GPSS3 */
	/*     CHANGES: NO RESPECT TO OMITTED ORIGINAL VARIABLES */
	for (i = 1; i <= znset; i++)  {
		fscanf  (unit7, "%f", &equatlist[i].next);
		fscanf  (unit7, "%f", &equatlist[i].step);
		fscanf  (unit7, "%f", &equatlist[i].ahead);
		fscanf  (unit7, "%f", &equatlist[i].last);
		fscanf  (unit7, "%f", &equatlist[i].link);
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= znset; i++)  {
		for (j = 1; j <= znv; j++)  {
			fscanf  (unit7, "%f", &sv[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= znset; i++)  {
		for (j = 1; j <= znv; j++)  {
			fscanf  (unit7, "%f", &dv[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	fscanf  (unit7, "%d", &icont);
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /EVT/ */
	/*     ============ */
	for (i = 1; i <= zevt; i++)  {
		fscanf  (unit7, "%f", &eventlist[i].next);
		fscanf  (unit7, "%f", &eventlist[i].link);
	}
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /FAC/ */
	/*     ============ */
	for (i = 1; i <= zfac; i++)  {
		fscanf  (unit7, "%d", &fac[i].occup);
		fscanf  (unit7, "%d", &fac[i].preemp);
		fscanf  (unit7, "%d", &fac[i].phase);
	}
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /FAM/ */
	/*     ============ */
	for (i = 1; i <= zfac; i++)  {
		fscanf  (unit7, "%d", &fam[i].count);
		fscanf  (unit7, "%d", &fam[i].last_dup);
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zfam; i++)  {
		for (j = 1; j <= zfam; j++)  {
			fscanf  (unit7, "%d", &assem_ma[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /GAT/ */
	/*     ============ */
	for (i = 1; i <= zgatt; i++)  {
		fscanf  (unit7, "%d", &gath_tx[i]);
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zfam; i++)  {
		for (j = 1; j <= zgatf; j++)  {
			fscanf  (unit7, "%d", &gath_fam[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /INP/ */
	/*     ============ */
	fscanf  (unit7, "%d", &ndelay);
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /MFA/ */
	/*     ============ */
	for (i = 1; i <= zmfac; i++)  {
		fscanf  (unit7, "%d", &mfac[i].in_use);
		fscanf  (unit7, "%d", &mfac[i].cap);
		fscanf  (unit7, "%d", &mfac[i].base);
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zse; i++)  {
		fscanf  (unit7, "%d", &service[i].occup);
		fscanf  (unit7, "%d", &service[i].preemp);
		fscanf  (unit7, "%d", &service[i].phase);
	}
	fscanf  (unit7, "\n");
	/*    SCHELIFE  ???????????!!!!!!!!!!!!!???????????!!!!!!!!!!!!!   */
	fscanf  (unit7, "%d", &lse);
	row_serv = lse + service;
	fscanf  (unit7, "\n");

	/* */
	/*     COMMON /NET/ */
	/*     ============ */
	fscanf  (unit7, "%d", &anrout);
	fscanf  (unit7, "\n");
	fscanf  (unit7, "%d", &ansect);
	fscanf  (unit7, "\n");
	fscanf  (unit7, "%d", &ansegm);
	fscanf  (unit7, "\n");
	fscanf  (unit7, "%d", &ansta);
	fscanf  (unit7, "\n");
	fscanf  (unit7, "%d", &anverz);
	fscanf  (unit7, "\n");
	for (i = 1; i <= zsect; i++)  {
		fscanf  (unit7, "%d", &blocve[i][1]);
		fscanf  (unit7, "%d", &blocve[i][2]);
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zsta; i++)  {
		fscanf  (unit7, "%f", &coords[i][1]);
		fscanf  (unit7, "%f", &coords[i][2]);
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zverz; i++)  {
		fscanf  (unit7, "%f", &coordv[i][1]);
		fscanf  (unit7, "%f", &coordv[i][2]);
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zpunkt; i++)  {
		fscanf  (unit7, "%f", &coordp[i][1]);
		fscanf  (unit7, "%f", &coordp[i][2]);
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zrout; i++)  {
		fscanf  (unit7, "%d", &courma[i][1]);
		fscanf  (unit7, "%d", &courma[i][2]);
		fscanf  (unit7, "%d", &courma[i][3]);
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= znode; i++)  {
		for (j = 1; j <= znode; j++)  {
			fscanf  (unit7, "%d", &direct[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zvon; i++)  {
		for (j = 1; j <= zvon; j++)  {
			fscanf  (unit7, "%d", &fromto[i][j][1]);
			fscanf  (unit7, "%d", &fromto[i][j][2]);
		}
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zsegm; i++)  {
		for (j = 1; j <= 6; j++)  {
			fscanf  (unit7, "%f", &netsta[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zrout; i++)  {
		for (j = 1; j <= zrout1; j++)  {
			fscanf  (unit7, "%d", &routma[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zsect; i++)  {
		for (j = 1; j <= 6; j++)  {
			fscanf  (unit7, "%f", &sectma[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zsegm; i++)  {
		for (j = 1; j <= zsegm1; j++)  {
			fscanf  (unit7, "%d", &segma[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= znode; i++)  {
		for (j = 1; j <= znach; j++)  {
			fscanf  (unit7, "%d", &tofrom[i][j][1]);
			fscanf  (unit7, "%d", &tofrom[i][j][2]);
		}
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= znode; i++)  {
		for (j = 1; j <= znode; j++)  {
			fscanf  (unit7, "%f", &totlen[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /PLA/ */
	/*     ============ */
	for (i = 1; i <= zmfac; i++)  {
		fscanf  (unit7, "%d", &plan[i].in);
		fscanf  (unit7, "%d", &plan[i].out);
	}
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /POL/ */
	/*     ============ */
	for (i = 1; i <= zpol; i++)  {
		fscanf  (unit7, "%d", &pol[i].type);
		fscanf  (unit7, "%d", &pol[i].station);
		fscanf  (unit7, "%d", &pol[i].policy);
	}
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /POO/ */
	/*     ============ */
	for (i = 1; i <= zpool; i++)  {
		fscanf  (unit7, "%d", &pool[i].level);
		fscanf  (unit7, "%d", &pool[i].pool_cap);
	}
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /RAS/ */
	/*     ============ */
	for (i = 1; i <= zras; i++)  {
		fscanf  (unit7, "%f", &rastl[i]);
	}
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /SRC/ */
	/*     ============ */
	for (i = 1; i <= zsrc; i++)  {
		fscanf  (unit7, "%f", &sourcelist[i].next);
		fscanf  (unit7, "%f", &sourcelist[i].target);
		fscanf  (unit7, "%f", &sourcelist[i].remain);
		fscanf  (unit7, "%f", &sourcelist[i].link);
		fscanf  (unit7, "%d", &sourcelist[i].sourci);
	}
	fscanf  (unit7, "\n");
	fscanf  (unit7, "%d", &tx_ctr);
	fscanf  (unit7, "\n");
	fscanf  (unit7, "%d", &lsl);
	row_source = lsl + sourcelist;
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /STO/ */
	/*     ============ */
	for (i = 1; i <= zsto; i++)  {
		fscanf  (unit7, "%d", &sto_base[i].stor_cap);
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zsm; i++)  {
		fscanf  (unit7, "%d", &sto_matrix[i].length);
		fscanf  (unit7, "%d", &sto_matrix[i].mark);
	}
	fscanf  (unit7, "\n");

	fscanf  (unit7, "%d", &lsm);
	row_stor = lsm + sto_matrix;
	fscanf  (unit7, "\n");

	/* */
	/*     COMMON /STR/ */
	/*     ============ */
	for (i = 1; i <= zsto; i++)  {
		fscanf  (unit7, "%d", &strategy[i].in);
		fscanf  (unit7, "%d", &strategy[i].out);
	}
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /SYM/ */
	/*     ============ */
	for (i = 1; i <= zvar; i++)  {
		fscanf  (unit7, "%s", iv[i].name);
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zvar; i++)  {
		fscanf  (unit7, "%s", rv[i].name);
	}
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /TAB/ */
	/*     =========== */
	for (i = 1; i <= ztab; i++)  {
		for (j = 1; j <= zntab; j++)  {
			fscanf  (unit7, "%f", &table[i][j].up_bound);
			fscanf  (unit7, "%d", &table[i][j].frequ);
			fscanf  (unit7, "%f", &table[i][j].sum_x);
			fscanf  (unit7, "%f", &table[i][j].sum_y);
		}
	}
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /TIM/ */
	/*     ============ */
	fscanf  (unit7, "%f %f %f", &TiMe, &rTiMe, &tbusy);
	fscanf  (unit7, "\n");
	for (i = 1; i <= zncond; i++)  {
		fscanf  (unit7, "%f", &tcond[i]);
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= 25; i++)  {
		fscanf  (unit7, "%d",   &jprint[i]);
	}
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /TRA/ */
	/*     ============ */
	for (i = 1; i <= ztx; i++)  {
		for (j = 1; j <= 4; j++)  {
			fscanf  (unit7, "%f", &txadd[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zcar; i++)  {
		for (j = 1; j <= 10; j++)  {
			fscanf  (unit7, "%f", &carma[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zcar; i++)  {
		for (j = 1; j <= 7; j++)  {
			fscanf  (unit7, "%f", &tarma[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= ztx; i++)  {
		for (j = 1; j <= 5; j++)  {
			fscanf  (unit7, "%f", &logma[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= 2; i++)  {
		fscanf  (unit7, "%d", &logptr[i]);
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zcar; i++)  {
		for (j = 1; j <= 10; j++)  {
			fscanf  (unit7, "%f", &statis[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zsta; i++)  {
		for (j = 1; j <= 4; j++)  {
			fscanf  (unit7, "%f", &statst[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zsta; i++)  {
		for (j = 1; j <= 4; j++)  {
			fscanf  (unit7, "%f", &parkst[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zsect; i++)  {
		for (j = 1; j <= 4; j++)  {
			fscanf  (unit7, "%f", &blocst[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /TXS/ */
	/*     ============ */
	for (i = 1; i <= ztx; i++)  {
		fscanf  (unit7, "%d", &tx_system[i].nr);
		fscanf  (unit7, "%d", &tx_system[i].dup);
		fscanf  (unit7, "%d", &tx_system[i].family);
		fscanf  (unit7, "%f", &tx_system[i].priority);
		fscanf  (unit7, "%d", &tx_system[i].retour);
		fscanf  (unit7, "%f", &tx_system[i].TiMe_left);
		fscanf  (unit7, "%d", &tx_system[i].elem);
		fscanf  (unit7, "%f", &tx_system[i].t_block);
		for (j = 1; j <= ztxip; j++)  {
			fscanf  (unit7, "%d", &i_tx_priv[i][j]);
		}
		for (j = 1; j <= ztxfp; j++)  {
			fscanf  (unit7, "%f", &f_tx_priv[i][j]);
		}
		for (j = 1; j <= ztxsp; j++)  {
			fscanf  (unit7, "%s", s_tx_priv[i][j]);
		}
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= ztx; i++)  {
		fscanf  (unit7, "%d", &txi[i]);
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= ztx; i++)  {
		fscanf  (unit7, "%f", &activlist[i].next);
		fscanf  (unit7, "%d", &activlist[i].target);
		fscanf  (unit7, "%d", &activlist[i].link);
	}
	fscanf  (unit7, "\n");

	fscanf  (unit7, "%d", &row_txact);
	fscanf  (unit7, "\n");

	/* */
	/*     COMMON /TYP/ */
	/*     ============ */
	fscanf  (unit7, "%d", &offset.fac);
	fscanf  (unit7, "%d", &offset.mfac);
	fscanf  (unit7, "%d", &offset.pool);
	fscanf  (unit7, "%d", &offset.stor);
	fscanf  (unit7, "%d", &offset.gate);
	fscanf  (unit7, "%d", &offset.gath);
	fscanf  (unit7, "%d", &offset.gathf);
	fscanf  (unit7, "%d", &offset.userch);
	fscanf  (unit7, "%d", &offset.trig);
	fscanf  (unit7, "%d", &offset.userchf);
	fscanf  (unit7, "%d", &offset.trigf);
	fscanf  (unit7, "%d", &offset.match);
	fscanf  (unit7, "\n");
	/*
      fscanf  (unit7, "%d", bhead);
      fscanf  (unit7, "\n");
*/
	for (i = 1; i <= 6; i++)  {
		fscanf  (unit7, "%f", &head[i].next);
		fscanf  (unit7, "%d", &head[i].link);
	}
	fscanf  (unit7, "\n");
	fscanf  (unit7, "%f", &ttest);
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /UCH/ */
	/*     ============ */
	for (i = 1; i <= zucht; i++)  {
		fscanf  (unit7, "%d", &userct[i].member);
		fscanf  (unit7, "%d", &userct[i].count_gone);
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zfam; i++)  {
		for (j = 1; j <= zuchf; j++)  {
			fscanf  (unit7, "%d", &usercf[i][j].member);
			fscanf  (unit7, "%d", &usercf[i][j].count_gone);
		}
	}
	fscanf  (unit7, "\n");
	/* */
	/*     COMMON /VAR/ */
	/*     ============ */
	for (i = 1; i <= zvar; i++)  {
		fscanf  (unit7, "%d", &iv[i].i_value);
	}
	fscanf  (unit7, "\n");
	for (i = 1; i <= zvar; i++)  {
		fscanf  (unit7, "%f", &rv[i].r_value);
	}
	fscanf  (unit7, "\n");
	/* */
	/* */

	/*     INSERT MONITOR CALL IN CHAIN */
	/*     ============================ */
	for (i = 1; i <= znplo; i++)  {
		switch (nchain (5, i) )  {
		case FEHLER: 
			goto l_9999;
		}
		if ( ploma1[i].file_nr  !=  0 )  {
			if ( ploma1[i].plot_begin  >  TiMe - eps ) {
				monitlist[i].next = ploma1[i].plot_begin;
			} else {
				a = (float)next_int ( (TiMe - ploma1[i].plot_begin - eps) / 
				    ploma1[i].plot_step )  + 1.;
				monitlist[i].next = ploma1[i].plot_begin +  a * ploma1[i].plot_step;
			}
			switch (tchain (5, i)  )  {
			case FEHLER: 
				goto l_9999;
			}
		}
	}
	/* */
	/* */
	/*     TRACE OUTPUT */
	/*     ============ */
	fprintf  (nunit2, "\n\n\n savin :  model variables were input form file 'saved'\n\n\n\n");
	rewind (unit7);
	return(NORMAL);
	/* */
	/* */
	/*     ERROR MESSAGE IF SIZE OF ARRAYS TOO SMALL */
	/*     ========================================= */
l_9900:  
	fprintf  (nunit2, "\f+++++ savin :  size of arrays is too small\n\n");
	fprintf  (nunit2, "                 array bounds            required         actual \n\n");
	for (i = 1; i <=  40; i++)  {
		if (ksys[i]  >  zsys[i]) {
			fprintf  (nunit2, "                        *  %7s       %5d          %5d\n", dimpa[i], ksys[i], zsys[i]);
		} else {
			fprintf  (nunit2, "                           %7s       %5d          %5d\n", dimpa[i], ksys[i], zsys[i]);
		}
	}
	/* */
	/* */
	rewind (unit7);
l_9999:  
	return(FEHLER);
}


