static char *SccsId = "@(#)PEPSY:\tsimend.c\t1.3\t92/03/27 11:58:51";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	simend(nbn, ndp, p)
double	p ;
int	ndp ;
int	nbn ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call simend(nbn,ndp,p)                                        */
	/*    ***                                                               */
	/*    *** funktion : bestimmen des simulationsendes mit hilfe der       */
	/*    ***            mittleren wartezeit der bin nbn                    */
	/*    *** parameter: nbn   = nummer der zu ueberpruefenden bin          */
	/*    ***            ndp   = anzahl der aufrufe von depart zwischen     */
	/*    ***                    zwei ueberpruefungen                       */
	/*    ***            p     = zugelassene abweichung vom mittelwert      */
	/*    ***                    in prozent                                 */
	/*    ***                                                               */
	static int	pm = 0, na = 0;
	static double	mean[21] = {
		0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0	};
	int	i, nt, mu, mo, im ;
	double	pr ;
#ifdef DEBUG
dprint(TRANSACTION, "simdend: nbn = %d, ndp = %d, p = %f\n", nbn, ndp, p); /* */
#endif
	/*                                                                      */
	/*    bestimmen des ueberpruefungszeitpunktes                           */
	/*    =======================================                           */
	nt = na + ndp ;
	if (bin[nbn].depart <  nt) {
#ifdef DEBUG
dprint(LABEL, "simend: return (1)\n"); /* */
#endif
		return(NORMAL);
	}
	/*                                                                      */
	/*    eintragen der mittleren wartezeit                                 */
	/*    =================================                                 */
	na = nt;
	pm = pm % 20 + 1;
	mean[pm] = bin[nbn].total_wait / 
	    (((double)(bin[nbn].access + bin[nbn].leave)) / 2.);
	/*                                                                      */
	/*    bestimmen des zulaessigen intervalls                              */
	/*    ====================================                              */
	pr = mean[pm] * p / 100.;
	mu = mean[pm] - pr;
	mo = mean[pm] + pr;
	/*                                                                      */
	/*    ueberpuefen des abbruchkriteriums                                 */
	/*    =================================                                 */
	im = pm;
l_100:
#ifdef DEBUG
dprint(LABEL, "simend: label l_100\n"); /* */
#endif
	im = im % 20 + 1;
	if (mean[im] <= 0.0 || 
	    mean[im] < (double)mu || mean[im] > (double)mo) {
#ifdef DEBUG
dprint(LABEL, "simend: return (2)\n"); /* */
#endif
		return(NORMAL);
	}
	if (im != pm) 
		goto l_100;
	fprintf(nunit2, "\f\n\n\n%20s****** s i m u l a t i o n s e n d e ******\n\n", BLANKF);
	fprintf(nunit2, "\n%27sTiMe     %12.4f\n%27stx_ctr =%12d\n\n%20smittlere wartezeit fuer bin%3d",
	    BLANKF, TiMe, BLANKF, tx_ctr, BLANKF, nbn);
	fprintf(nunit2, " betraegt%12.4f bei%10d abgaengen\n", mean[pm], bin[nbn].depart);
	tend = TiMe;
#ifdef DEBUG
dprint(LABEL, "simend: return (3)\n"); /* */
#endif
	return(NORMAL);
}


