static char *SccsId = "@(#)PEPSY:\ttabula.c\t1.2\t92/03/27 11:59:05";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	tabula(ntab, ng, x, y, og1, gbr)
double	gbr ;
double	og1 ;
double	y ;
double	x ;
int	ng ;
int	ntab ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call tabula(ntab,ng,x,y,og1,gbr)                              */
	/*    ***                                                               */
	/*    *** funktion : einsortieren der auspraegung einer variablen x     */
	/*    ***            in eine haeufigkeitstabelle und falls y # 0 -      */
	/*    ***            einsortieren der variablen y in abhaengigkeit      */
	/*    ***            von der auspraegung der variablen x                */
	/*    *** parameter: ntab = nummer der haeufigkeitstabelle              */
	/*    ***            ng   = anzahl der intervalle                       */
	/*    ***            x    = name der variablen                          */
	/*    ***            y    = zugeordnete variable                        */
	/*    ***            og1  = obergrenze des ersten werteintervalls       */
	/*    ***            gbr  = intervallbreite                             */
	/*    ***                                                               */
	extern int	for_int();
	int	ngl, ng2, j;
	double	ug1, g ;

	/*                                                                      */
	double	epsx = 1.e-5;
	/*                                                                      */
	/*    kontrolle der eingabedaten                                        */
	/*    ==========================                                        */
	ngl = ng;
	if (ntab < 1 || ntab > zntab) 
		goto l_300;
	if (ngl < 0) 
		goto l_300;
	if (gbr <= epsx) 
		goto l_300;
	/*                                                                      */
	/*    anlegen der haeufigkeitstabelle                                   */
	/*    ===============================                                   */
	if (ngl > ztab - 2) 
		ngl = ztab - 2;
	ug1 = og1 - gbr;
	if (fabs(table[1][ntab].up_bound) > epsx || 
	    fabs(table[2][ntab].up_bound) > epsx)
		goto l_200;
	g = ug1;
	ng2 = ngl + 2 ;
	for (j = 1; j <= ng2; ++j) {
		table[j][ntab].up_bound = g;
		g = g + gbr;
	};
	if (ng2 < ztab) 
		table[ng2+1][ntab].frequ = -1;
	/*                                                                      */
	/*    einsortieren                                                      */
	/*    ============                                                      */
l_200:  
	j = for_int((x - ug1 + gbr) / gbr) + 1;
	if (j <= 1  ||  j > (ngl + 2)) 
		goto l_250;
	if ((x - table[j-1][ntab].up_bound) <= epsx) 
		j = j - 1 ;
l_250:  
	if (j < 1) 
		j = 1;
	if (j > ngl + 2) 
		j = ngl + 2;
	table[j][ntab].frequ = table[j][ntab].frequ + 1;
	table[j][ntab].sum_x = table[j][ntab].sum_x + x;
	table[j][ntab].sum_y = table[j][ntab].sum_y + y;
	return(NORMAL);
	/*                                                                      */
	/*    fehlerhafte eingabe                                               */
	/*    ===================                                               */
l_300:  
	fprintf(nunit2, "\n\n tabula: fehlerhafte eingabedaten: ntab =%4d   ng =%5d   gbr =%7.2f\n",
	    ntab, ng, gbr);
	return(NORMAL);
}


