static char *SccsId = "@(#)PEPSY:\ttchain.c\t1.3\t92/03/27 11:59:07";
#include <ctype.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	tchain(list, line)
int	line ;
int	list ;
/*                                                                      */
{
	/*    ***                                                               */
	/*    *** call tchain(list,line,exit1)                                  */
	/*    ***                                                               */
	/*    *** funktion : einketten einer zeile in die liste list            */
	/*    ***            in abhaengigkeit vom aktivierungszeitpunkt         */
	/*    *** parameter: list  = nummer der liste                           */
	/*    ***                    = 1: ereignisliste                         */
	/*    ***                    = 2: sourceliste                           */
	/*    ***                    = 3: aktivierungsliste                     */
	/*    ***                    = 4: konfidenzliste                        */
	/*    ***                    = 5: monitorliste                          */
	/*    ***                    = 6: equationliste                         */
	/*    ***            line  = einzukettende zeile                        */
	/*    ***            exit1 = fehlerausgang                              */
	/*    ***                                                               */
	int	nptr , lptr  ;
	double	tevt, tsrc, tconf, tmtr, tequ ;
#ifdef DEBUG
dprint(CHAIN, "tchain: list %d, line %d\n", list, line); /* */
#endif
	/*                                                                      */
	/*    fehlerkontrolle                                                   */
	/*    ===============                                                   */
	nptr = head[list].link;
	switch (list) {
	case 1: 
		goto l_100;
	case 2: 
		goto l_200;
	case 3: 
		goto l_300;
	case 4: 
		goto l_400;
	case 5: 
		goto l_500;
	case 6: 
		goto l_600;
	};
	fprintf(nunit2, "\n +++++ tchain: TiMe=%12.4f fehlerhafte listennummer%3d\n",
	    TiMe, list);
	return(FEHLER);
	/*                                                                      */
	/*    einketten in die ereignisliste                                    */
	/*    ==============================                                    */
l_100: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_100\n"); /* */
#endif
	if (dbg & CHAIN) {
		int	dbg_ptr;
		dbg_ptr = line;
		while (dbg_ptr > 0) {
			fprintf(stderr, "%d -> ", dbg_ptr);
			dbg_ptr = eventlist[dbg_ptr].link;
		}
		fprintf(stderr, "%d \n", dbg_ptr);
	}
	if (nptr < 0) 
		goto l_110;
	tevt = eventlist[line].next;
	if (tevt  >=  head[1].next + eps) 
		goto l_120;
	if (tevt  <=  head[1].next - eps) 
		goto l_110;
	if (line  >  nptr) 
		goto l_120;
l_110: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_110\n"); /* */
#endif
	head[1].next = eventlist[line].next ;
	head[1].link = line;
	eventlist[line].link = nptr;
	if (dbg & CHAIN) {
		int	dbg_ptr;
		dbg_ptr = line;
		while (dbg_ptr > 0) {
			fprintf(stderr, "%d -> ", dbg_ptr);
			dbg_ptr = eventlist[dbg_ptr].link;
		}
		fprintf(stderr, "%d \n", dbg_ptr);
	}
	return(NORMAL);
l_120: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_120\n"); /* */
#endif
	lptr = nptr;
	nptr = eventlist[lptr].link;
	assert(nptr <= zevt);
	if (nptr < 0) 
		goto l_130;
	if (tevt  >=  eventlist[nptr].next + eps) 
		goto l_120;
	if (tevt  <=  eventlist[nptr].next - eps) 
		goto l_130;
	if (line  >  nptr) 
		goto l_120;
l_130: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_130\n"); /* */
#endif
	eventlist[line].link = eventlist[lptr].link;
	eventlist[lptr].link = line;
	if (dbg & CHAIN) {
		int	dbg_ptr;
		dbg_ptr = line;
		while (dbg_ptr > 0) {
			fprintf(stderr, "%d -> ", dbg_ptr);
			dbg_ptr = eventlist[dbg_ptr].link;
		}
		fprintf(stderr, "%d \n", dbg_ptr);
	}
	assert(nptr <= zevt);
	return(NORMAL);
	/*                                                                      */
	/*    einketten in die sourceliste                                      */
	/*    ============================                                      */
l_200: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_200\n"); /* */
#endif
	if (dbg & CHAIN) {
		int	dbg_ptr;
		dbg_ptr = line;
		while (dbg_ptr > 0) {
			fprintf(stderr, "%d -> ", dbg_ptr);
			dbg_ptr = sourcelist[dbg_ptr].link;
		}
		fprintf(stderr, "%d \n", dbg_ptr);
	}
	if (nptr < 0) 
		goto l_210;
	tsrc = sourcelist[line].next;
	if (tsrc  >=  head[2].next + eps) 
		goto l_220;
	if (tsrc  <=  head[2].next - eps) 
		goto l_210;
	if (line  >  nptr) 
		goto l_220;
l_210: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_210\n"); /* */
#endif
	head[2].next = sourcelist[line].next;
	head[2].link = line;
	sourcelist[line].link = nptr;
	if (dbg & CHAIN) {
		int	dbg_ptr;
		dbg_ptr = line;
		while (dbg_ptr > 0) {
			fprintf(stderr, "%d -> ", dbg_ptr);
			dbg_ptr = sourcelist[dbg_ptr].link;
		}
		fprintf(stderr, "%d \n", dbg_ptr);
	}
	assert(nptr <= zsrc);
	return(NORMAL);
l_220: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_220\n"); /* */
#endif
	lptr = nptr;
	nptr = sourcelist[lptr].link;
	assert(nptr <= zsrc);
	if (nptr < 0) 
		goto l_230;
	if (tsrc  >=  sourcelist[nptr].next + eps) 
		goto l_220;
	if (tsrc  <=  sourcelist[nptr].next - eps) 
		goto l_230;
	if (line  >  nptr) 
		goto l_220;
l_230: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_230\n"); /* */
#endif
	sourcelist[line].link = sourcelist[lptr].link;
	sourcelist[lptr].link = line;
	if (dbg & CHAIN) {
		int	dbg_ptr;
		dbg_ptr = line;
		while (dbg_ptr > 0) {
			fprintf(stderr, "%d -> ", dbg_ptr);
			dbg_ptr = sourcelist[dbg_ptr].link;
		}
		fprintf(stderr, "%d \n", dbg_ptr);
	}
	assert(nptr <= zsrc);
	return(NORMAL);
	/*                                                                      */
	/*    einketten in die aktivierungsliste                                */
	/*    ==================================                                */
l_300: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_300\n"); /* */
#endif
	if (dbg & CHAIN) {
		int	dbg_ptr;
		dbg_ptr = line;
		while (dbg_ptr > 0) {
			fprintf(stderr, "%d -> ", dbg_ptr);
			dbg_ptr = activlist[dbg_ptr].link;
		}
		fprintf(stderr, "%d \n", dbg_ptr);
	}
	if (head[3].next < activlist[line].next + eps && nptr > 0) 
		goto l_320;
	head[3].next = activlist[line].next;
l_310: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_310\n"); /* */
#endif
	head[3].link = line;
	activlist[line].link = nptr;
	if (dbg & CHAIN) {
		int	dbg_ptr;
		dbg_ptr = line;
		while (dbg_ptr > 0) {
			fprintf(stderr, "%d -> ", dbg_ptr);
			dbg_ptr = activlist[dbg_ptr].link;
		}
		fprintf(stderr, "%d \n", dbg_ptr);
	}
#ifdef DEBUG
dprint(LABEL, "tchain: testschleife verlassen\n"); /* */
#endif
	assert(nptr <= ztx);
	return(NORMAL);
l_320: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_320\n"); /* */
#endif
	if (activlist[line].next >= TiMe + eps) 
		goto l_330;
	if (activlist[nptr].next < 0.0) 
		goto l_310;
l_330: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_330\n"); /* */
#endif
	lptr = nptr;
	nptr = activlist[lptr].link;
	assert(nptr <= ztx);
	if (nptr < 0) 
		goto l_350;
	if (activlist[line].next >= TiMe + eps) 
		goto l_340;
	if (activlist[nptr].next < 0.0) 
		goto l_350;
l_340: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_340\n"); /* */
#endif
	if (activlist[nptr].next >= activlist[line].next + eps) 
		goto l_350;
	goto l_330;
l_350: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_350\n"); /* */
#endif
	activlist[line].link = activlist[lptr].link;
	activlist[lptr].link = line;
	if (dbg & CHAIN) {
		int	dbg_ptr;
		dbg_ptr = line;
		while (dbg_ptr > 0) {
			fprintf(stderr, "%d -> ", dbg_ptr);
			dbg_ptr = activlist[dbg_ptr].link;
		}
		fprintf(stderr, "%d \n", dbg_ptr);
	}
	assert(nptr <= ztx);
	return(NORMAL);
	/*                                                                      */
	/*    einketten in die konfidenzliste                                   */
	/*    ===============================                                   */
l_400: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_400\n"); /* */
#endif
	if (dbg & CHAIN) {
		int	dbg_ptr;
		dbg_ptr = line;
		while (dbg_ptr > 0) {
			fprintf(stderr, "%d -> ", dbg_ptr);
			dbg_ptr = conflist[dbg_ptr].link;
		}
		fprintf(stderr, "%d \n", dbg_ptr);
	}
	if (nptr < 0) 
		goto l_410;
	tconf = conflist[line].next;
	if (tconf  >=  head[4].next + eps) 
		goto l_420;
	if (tconf  <=  head[4].next - eps) 
		goto l_410;
	if (line  >  nptr) 
		goto l_420;
l_410: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_410\n"); /* */
#endif
	head[4].next = conflist[line].next;
	head[4].link = line;
	conflist[line].link = nptr;
	if (dbg & CHAIN) {
		int	dbg_ptr;
		dbg_ptr = line;
		while (dbg_ptr > 0) {
			fprintf(stderr, "%d -> ", dbg_ptr);
			dbg_ptr = conflist[dbg_ptr].link;
		}
		fprintf(stderr, "%d \n", dbg_ptr);
	}
	assert(nptr <= zbin);
	return(NORMAL);
l_420: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_420\n"); /* */
#endif
	lptr = nptr;
	nptr = conflist[lptr].link;
	assert(nptr <= zbin);
#ifdef DEBUG
dprint(LABEL, "tchain: conflist[1].link %d\n", conflist[1].link); /* */
#endif
#ifdef DEBUG
dprint(LABEL, "tchain: conflist[2].link %d\n", conflist[2].link); /* */
#endif
#ifdef DEBUG
dprint(LABEL, "tchain: lptr %d, nptr %d\n", lptr, nptr); /* */
#endif
	if (nptr < 0) 
		goto l_430;
	if (tconf  >=  conflist[nptr].next + eps) 
		goto l_420;
	if (tconf  <=  conflist[nptr].next - eps) 
		goto l_430;
	if (line  >  nptr) 
		goto l_420;
l_430: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_430\n"); /* */
#endif
	conflist[line].link = conflist[lptr].link;
	conflist[lptr].link = line;
	if (dbg & CHAIN) {
		int	dbg_ptr;
		dbg_ptr = line;
		while (dbg_ptr > 0) {
			fprintf(stderr, "%d -> ", dbg_ptr);
			dbg_ptr = conflist[dbg_ptr].link;
		}
		fprintf(stderr, "%d \n", dbg_ptr);
	}
	assert(nptr <= zbin);
	return(NORMAL);
	/*                                                                      */
	/*    einketten in die monitorliste                                     */
	/*    =============================                                     */
l_500: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_500\n"); /* */
#endif
	if (nptr < 0) 
		goto l_510;
	tmtr = monitlist[line].next;
	if (tmtr  >=  head[5].next + eps) 
		goto l_520;
	if (tmtr  <=  head[5].next - eps) 
		goto l_510;
	if (line  >  nptr) 
		goto l_520;
l_510: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_510\n"); /* */
#endif
	head[5].next = monitlist[line].next ;
	head[5].link = line;
	monitlist[line].link = nptr;
	assert(nptr <= znplo);
	return(NORMAL);
l_520: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_520\n"); /* */
#endif
	lptr = nptr;
	nptr = monitlist[lptr].link;
	assert(nptr <= znplo);
	if (nptr < 0) 
		goto l_530;
	if (tmtr  >=  monitlist[nptr].next + eps) 
		goto l_520;
	if (tmtr  <=  monitlist[nptr].next - eps) 
		goto l_530;
	if (line  >  nptr) 
		goto l_520;
l_530: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_530\n"); /* */
#endif
	monitlist[line].link = monitlist[lptr].link;
	monitlist[lptr].link = line;
	assert(nptr <= znplo);
	return(NORMAL);
	/*                                                                      */
	/*    einketten in die equationliste                                    */
	/*    ==============================                                    */
l_600: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_600\n"); /* */
#endif
	if (nptr < 0) 
		goto l_610;
	tequ = equatlist[line].next;
	if (tequ  >=  head[6].next + eps) 
		goto l_620;
	if (tequ  <=  head[6].next - eps) 
		goto l_610;
	if (line  >  nptr) 
		goto l_620;
l_610: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_610\n"); /* */
#endif
	head[6].next = equatlist[line].next ;
	head[6].link = line;
	equatlist[line].link = nptr;
	assert(nptr <= znset);
	return(NORMAL);
l_620: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_620\n"); /* */
#endif
	lptr = nptr;
	nptr = equatlist[lptr].link;
	assert(nptr <= znset);
	if (nptr < 0) 
		goto l_630;
	if (tequ  >=  equatlist[nptr].next + eps) 
		goto l_620;
	if (tequ  <=  equatlist[nptr].next - eps) 
		goto l_630;
	if (line  >  nptr) 
		goto l_620;
l_630: 
#ifdef DEBUG
dprint(LABEL, "tchain: label l_630\n"); /* */
#endif
	equatlist[line].link = equatlist[lptr].link;
	equatlist[lptr].link = line;
	assert(nptr <= znset);
	return(NORMAL);
}


