static char *SccsId = "@(#)PEPSY:\ttgen.c\t1.3\t92/03/27 11:59:15";
#include <stdio.h>
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	tgen(et, pr, kap, vel, nterm, itargp, nstrat)
float	et;
float	pr;
int	kap;
float	vel;
int	nterm;
int	itargp;
int	nstrat;
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	/*     ***  */
	/*     *** CALL TGEN(ET,PR,KAP,VEL,NTERM,ITARGP,NSTRAT,*9999) */
	/*     ***  */
	/*     *** PURPOSE : GENERATE A TRANSACTION REPRESENTING A TAXI */
	/*     *** PARAMETERS: ET     = TIME BETWEEN SUCCESSIVE GENERATIONS */
	/*     ***             PR     = PRIORITY OF GENERATED TAXI */
	/*     ***             KAP    = CAPACITY OF TAXI */
	/*     ***             VEL    = SPEED OF TAXI */
	/*     ***             NTERM  = TERMINAL AT WHICH THE TAXI IS GENERATED */
	/*     ***             ITARGP = PARKING STATION FOR THE TAXI  */
	/*     ***                      IF ITARGP = 0 , THEN THE TAXI PARKS */
	/*     ***                      AT THE STATION AT WHICH ITS LAST */
	/*     ***                      JOURNEY ENDS */
	/*     ***             NSTRAT = STRATEGY ACCORDING TO WHICH THE TAXI */
	/*     ***                      SELECTS ITS NEXT TASK */
	/*     ***                      = 1: OLD:  OLDEST TASK */
	/*     ***                      = 2: PRI:  TASK WITH HIGEST PRIORITY */
	/*     ***                      = 3: SDS:  NEAREST TASK */
	/*     ***                                 (SHORTEST DISTANCE) */
	/*     ***                      = 4: LDS:  FURTHEST AWAY TASK */
	/*     ***                                 (LONGEST DISTANCE) */
	/*     ***                      = 5: TOP:  TASK AT PRESENT TERMINAL */
	/*     ***                                 (PRESENT TERMINAL) */
	/*     ***                      = 6: BEN:  STRATEGY SUPPLIED BY USER */
	/*     ***             *9999  = ERROR EXIT */
	/*     ***  */
	/* */

	int	ctx, nact;
	short	found, trace;
	extern int	next_int(), find(), tchain();


#ifdef DEBUG
dprint(TRANSACTION, "tgen: et %f, pr %f, kap %d, vel %f, nterm %d, itargp %d, nstrat %d\n", /* */
	    et, pr, kap, vel, nterm, itargp, nstrat);
#endif

	/*     TEST FOR ERRORS */
	/*     =============== */
	if (et < -eps)                    
		goto l_4000;
	if (kap < 0)                      
		goto l_4100;
	if (vel <= eps)                   
		goto l_4200;
	if (nterm <= 0 || nterm > ansta)  
		goto l_4300;
	if (itargp < 0 || itargp > ansta) 
		goto l_4400;
	if (nstrat <= 0 || nstrat > 6)    
		goto l_4500;
	if (row_source == NULL)           
		goto l_4600;
	if (tx_ctr >= txmax || row_source->remain == 0) 
		goto l_4700;
	if (row_source->sourci != 2)      
		goto l_4800;
	/* */
	/*     UPDATE COUNTER */
	/*     ============== */
	tx_ctr = tx_ctr + 1;
	row_source->remain = row_source->remain - 1;
	/* */
	/*     GENERATE */
	/*     ======== */
	for (row_txact = ztx; row_txact >= 1; row_txact--)  {
		if (tx_system[row_txact].nr == 0) 
			goto l_200;
	}
	fprintf (nunit2, "\n\n+++++ tgen  :  t=%12.4f ERROR  : overflow of tx-array\n", TiMe);
	goto l_99;
	/* */
l_200: 
#ifdef DEBUG
dprint(LABEL, "tgen: label l_200\n"); /* */
#endif
	tx_system[row_txact].nr = tx_ctr;
	tx_system[row_txact].priority = pr;
	txi[row_txact]  = 2;
	for (ctx = 1; ctx <= zcar; ctx++)  {
		if (next_int(carma[ctx][1]) == 0) 
			goto l_400;
	}
	fprintf (nunit2, "\n\n+++++ tgen  :  t=%12.4f ERROR  : overflow in carma array\n", TiMe);
	goto l_99;
	/* */
	/*     ASSIGN TXADD */
	/*     ============ */
l_400: 
#ifdef DEBUG
dprint(LABEL, "tgen: label l_400\n"); /* */
#endif
	txadd[row_txact][1] = (double)ctx;
	/* */
	/*     INITIALIZE CARMA ARRAY */
	/*     ====================== */
	carma[ctx][1]  = (double)row_txact;
	carma[ctx][2]  = -1.;
	carma[ctx][3]  = (double)kap;
	carma[ctx][4]  = 0.;
	carma[ctx][5]  = vel;
	carma[ctx][6]  = (double)nterm + 0.1;
	carma[ctx][9]  = (double)nstrat;
	carma[ctx][10] = -1.;
	/* */
	/*     INITIALIZE TARMA ARRAY */
	/*     ====================== */
	tarma[ctx][1] = 0.;
	tarma[ctx][2] = 0.;
	tarma[ctx][3] = (double)itargp;
	tarma[ctx][4] = 0.;
	tarma[ctx][5] = 0.;
	tarma[ctx][6] = 0.;
	tarma[ctx][7] = 0.;
	/* */
	trace = ((iprint == 1 || jprint[23] > 0) && jprint[23] != -1);
	/* */
	if (trace) 
		fprintf (nunit2, "tgen  :  t=%12.4f  taxi%4d is generated by source%3d at terminal %4d\n",
		    TiMe, next_int(txadd[row_txact][1]), row_source - sourcelist, nterm);
	/*     SCHEDULE NEXT GENERATION */
	/*     ======================== */
	if (tx_ctr != txmax)  {
		if (row_source->remain != 0) {
			row_source->next = TiMe + et; 
            if (row_source->link != 0) goto l_4900;
            tchain(2,row_source - sourcelist);
#ifdef DEBUG
dprint(LABEL,"tgen: label l_500\n"); /* */
#endif
            if (trace) fprintf (nunit2, "                         next activation of source at t=%12.4f\n", row_source->next);
/* */
			/*     LAST TRANSACTION GENERATED BY SOURCE LSL */
			/*     ---------------------------------------- */
		} else {
			if (trace) 
				fprintf (nunit2, "                         source %3d is closed down\n", row_source - sourcelist);
		}
		/* */
		/*     TOTAL NUMBER OF TRANSACTIONS EXCEEDED */
		/*     ------------------------------------- */
	} else {
		head[1].next = 0.;
		head[1].link = -1;
		if (trace) 
			fprintf (nunit2, "                         all sources are closed down\n");
	}
	/* */
	if (kprint == 1) {
		nact = 20;
		fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n",
		    TiMe, txi[row_txact], ctx, nact, nterm);
	}
	/* */
	/*     SEARCH FOR FIRST TASK */
	/*     ===================== */
#ifdef DEBUG
dprint(TRANSACTION, "tgen: call find\n"); /* */
#endif
	switch (find(ctx, &found))  {
	case FEHLER: 
		goto l_99;
	}
	/* */
	/*     SEND TRANSPORTER TO FIRST TASK OR PARK */
	/*     ====================================== */
	if (found) {
		carma[ctx][7] = 2.;
		carma[ctx][8] = 1.;
		if (kprint == 1) {
			nact = 21;
			fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n",
			    TiMe, txi[row_txact], ctx, nact, nterm);
		}
	} else {
		carma[ctx][7] = 3.;
		carma[ctx][8] = 5.;
		if (kprint == 1) {
			nact = 25;
			fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[row_txact], ctx, nact, nterm);
		}
	}
	/* */
	return(NORMAL);
	/* */
	/*     ERROR MESSAGES */
	/*     ============== */
l_4000:  
	fprintf (nunit2, "\n\n+++++ tgen  :  t=%12.4f ERROR  : negative TiMe between successive generations (%8.4f)\n", TiMe,
	     et);
	goto l_99;
	/* */
l_4100:  
	fprintf (nunit2, "\n\n+++++ tgen  :  t=%12.4f ERROR : negative capacity (%3d) of taxi to be generated \n", TiMe,
	    kap);
	goto l_99;
	/* */
l_4200:  
	fprintf (nunit2, "\n\n+++++ tgen  :  t=%12.4f ERROR  : negative speed  (%8.4f) of taxi to be generated \n", TiMe,
	     vel);
	goto l_99;
	/* */
l_4300:  
	fprintf (nunit2, "\n\n+++++ tgen  :  t=%12.4f ERROR  : invalid terminal (%3d) of taxi to be generated \n", TiMe,
	    nterm);
	goto l_99;
	/* */
l_4400:  
	fprintf (nunit2, "\n\n+++++ tgen  :  t=%12.4f ERROR  : invalid parking station (%3d) of taxi to be generated\n",
	    TiMe, itargp);
	goto l_99;
	/* */
l_4500:  
	fprintf (nunit2, "\n\n+++++ tgen  :  t=%12.4f ERROR  : invalid strategy (%3d) of taxi to be generated\n", TiMe, nstrat);
	goto l_99;
	/* */
l_4600:  
	fprintf (nunit2, "\n\n+++++ tgen  :  t=%12.4f ERROR  : index of sourceE = 0\n                                        check label selector\n",
	     TiMe);
	goto l_99;
	/* */
l_4700:  
	fprintf (nunit2, "\n\n+++++ tgen  :  t=%12.4f ERROR  : source %3d exceeded tx-limit\n", TiMe, row_source - sourcelist);
	goto l_99;
	/* */
l_4800:  
	fprintf (nunit2, "\n\n+++++ tgen  :  t=%12.4f ERROR  : source with index%5d attempts to generated a taxi\n", TiMe,
	     row_source - sourcelist);
	goto l_99;
	/* */
l_4900:  
	fprintf (nunit2, "\n\n+++++ tgen  :  t=%12.4f ERROR  : source with index%5d already scheduled\n", TiMe, row_source -
	    sourcelist);
	/* */
l_99: 
	return(FEHLER);
}


