static char *SccsId = "@(#)PEPSY:\ttload.c\t1.3\t92/03/27 11:59:17";
#include <stdio.h>
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	tload(local_TiMe)
float	local_TiMe;
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	/*     ***  */
	/*     *** CALL TLOAD(TIME,*9000,*9999) */
	/*     ***  */
	/*     *** PURPOSE : LOAD A TAXI */
	/*     *** PARAMETERS: TIME  = TIME REQUIRED TO LOAD A TRANSACTION */
	/*     ***             *9000 = EXIT TO FLOW CONTROL */
	/*     ***             *9999 = ERROR EXIT */
	/*     ***  */
	/* */

	int	ncar, nexttr, lasttr, next, nact, lognr, i, nterm, k;
	short	beginn, trbeg,  trace;
	extern int	next_int(), tchain();
	float	anzahl, adTiMe ;


#ifdef DEBUG
dprint(TRANSACTION, "tload: local_time %f\n", local_TiMe); /* */
#endif

	/*     TEST FOR ERRORS */
	/*     =============== */
	ncar = next_int(txadd[row_txact][1]);
	if (ncar == 0)           
		goto l_4200;
	if (txi[row_txact] != 2) 
		goto l_4300;
	if (local_TiMe < -eps)   
		goto l_4400;
	/* */
	/*     DETERMINE THE INDEX OF THE TERMINAL AND INITIALIZE */
	/*     ================================================== */
	nterm  = next_int(tarma[ncar][1]);
	k      = offset.match + zmatch + nterm - 1;
	trbeg  =  TRUE;
	beginn =  TRUE;
	anzahl = 0.0;
	trace  = ((iprint == 1 || jprint[23] > 0) && jprint[23] != -1);
	if (trace) 
		fprintf (nunit2, "tload :  t=%12.4f  taxi%4d is at terminal%4d\n", TiMe, ncar, nterm);
	/* */
	/* */
	/*     ARE THERE TASKS TO BE PROCESSED? */
	/*     ================================ */
	if (next_int(carma[ncar][10]) == -1) 
		goto l_4100;
	/* */
	/*     EXAMINE CHAIN OF TRANSACTIONS AT TERMINAL */
	/*     ========================================= */
l_1000: 
#ifdef DEBUG
dprint(TRANSACTION, "tload: local_time %f\n", local_TiMe); /* */
#endif
	if (trbeg) {
		nexttr = bhead[k] - activlist;
	} else {
		nexttr = activlist[lasttr].blk_link;
	}
	/* */
	/*     END OF CHAIN REACHED? */
	/*     ===================== */
	if (nexttr < 0) 
		goto l_2000;
	/* */
	/*     SELECT THE TRANSACTIONS  */
	/*     =======================  */
	if (nexttr != next_int(logma[next_int(carma[ncar][10])][3])) {
		lasttr = nexttr;
		trbeg  =  FALSE;
		goto l_1000;
	}
	/* */
	/*     LOAD THE TRANSACTION */
	/*     ==================== */
	anford = next_int(txadd[nexttr][4]);
	if (anford == 0)  
		anford = 1;
	/* */
	/*     IS THERE ROOM LEFT? */
	/*     =================== */
	if ((carma[ncar][4] + anford) > carma[ncar][3]) 
		goto l_4000;
	/* */
	/*     ENTER REQUIREMENT AND CONNECT TRANSACTION TO TAXI */
	/*     ================================================= */
	carma[ncar][4] = carma[ncar][4] + anford;
	if (beginn) {
		carma[ncar][2] = (double)nexttr;
		beginn =  FALSE;
	} else {
		activlist[next].blk_link = nexttr;
	}
	next = nexttr;
	/* */
	/*     DISCONNECT TRANSACTION FROM TERMINAL */
	/*     ==================================== */
	if (trbeg) {
		bhead[k] = activlist + activlist[nexttr].blk_link;
	} else {
		lasttr = bhead[k] - activlist;
		goto l_1110;
l_1100:  
#ifdef DEBUG
dprint(TRANSACTION, "tload: label l_1100\n"); /* */
#endif
		lasttr = activlist[lasttr].blk_link;
l_1110:  
#ifdef DEBUG
dprint(TRANSACTION, "tload: label l_1100\n"); /* */
#endif
		if (activlist[lasttr].blk_link != nexttr) 
			goto l_1100;
		activlist[lasttr].blk_link = activlist[nexttr].blk_link;
	}
	activlist[nexttr].blk_link = -1;
	anzahl = anzahl + 1.0;
	adTiMe = local_TiMe * anzahl;
	if (trace) {
		fprintf (nunit2, "                         transaction%4d is loaded\n", tx_system[nexttr].nr);
		if (adTiMe > eps) 
			fprintf (nunit2, "                         and delayed by %12.4f units of TiMe\n", adTiMe);
	}
	/* */
	/* */
	if (kprint == 1) {
		nact = 4;
		fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n",
		    TiMe, txi[nexttr], tx_system[nexttr].nr, nact, nterm);
	}
	/* */
	/*     REMOVE TASK FROM LIST OF TASKS */
	/*     ============================== */
	tarma[ncar][1] = 0.0;
	lognr = next_int( carma[ncar][10] );
	carma[ncar][10] = logma[lognr][5];
	for ( i = 1; i <=  5; i++) {
		logma[lognr][i] = 0.0;
	}

	/* */
	/*     COLLECTION OF STATISTICAL DATA:  */
	/*     NUMBER OF TASKS AND QUANTITIES TRANSPORTED */
	/*     ========================================== */
	statis[ncar][5] = statis[ncar][5] + 1.0;
	statis[ncar][6] = statis[ncar][6] + (double)anford;
	/* */
	statst[nterm][1] = statst[nterm][1] - adTiMe + (statst[nterm][2] - statst[nterm][3]) * (TiMe - statst[nterm][4]);
	statst[nterm][3] = statst[nterm][3] + 1.0;
	statst[nterm][4] = TiMe;
	/* */
	/*     ARE THERE TASKS LEFT? */
	/*     ===================== */
	if (next_int(carma[ncar][10]) != -1) {
		trbeg =  TRUE;
		goto l_1000;
	}
	/* */
	/*     END OF LOADING */
	/*     ============== */
l_2000: 
#ifdef DEBUG
dprint(TRANSACTION, "tload: label l_2000\n"); /* */
#endif
	if (next_int(carma[ncar][10]) != -1) 
		goto l_4000;
	/* */
	/*     TIME REQUIRED TO LOAD */
	/*     ===================== */
	adTiMe = local_TiMe * anzahl;
	if (adTiMe > eps) {
		if (trace) 
			fprintf (nunit2, "                         taxi%4d is delayed by %12.4f units of TiMe\n", ncar, adTiMe);
		/* */
		/*     COLLECTION OF STATISTICAL DATA: TIME OF LOADING */
		/*     =============================================== */
		statis[ncar][10] = statis[ncar][10] + adTiMe;
	}
	/* */
	if (kprint == 1  &&  anzahl > 0) {
		nact = 22;
		fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[row_txact], ncar, nact, nterm);
	}
	/* */
	/*     SCHEDULE */
	/*     ======== */
	carma[ncar][7] = 1.0;
	carma[ncar][8] = 3.0;
	activlist[row_txact].next  = TiMe + adTiMe;
	activlist[row_txact].target  = 2.0;
	tchain(3, row_txact);
	/* */
l_90: 
	return(AUSGANG2);
	/* */
	/*     ERROR EXIT */
	/*     ========== */
l_4000:  
	fprintf (nunit2, "\n\n+++++ tload :  t=%12.4f ERROR  : taxi %4d cannot load passengers\n", TiMe, ncar);
	goto l_99;
	/* */
l_4100:  
	fprintf (nunit2, "\n\n+++++ tload :  t=%12.4f ERROR  : no tasks for taxi %4d\n", TiMe, ncar);
	goto l_99;
	/* */
l_4200:  
	fprintf (nunit2, "\n\n+++++ tload :  t=%12.4f ERROR  : passenger attempts to load   \n", TiMe);
	goto l_99;
	/* */
l_4300:  
	fprintf (nunit2, "\n\n+++++ tload :  t=%12.4f ERROR  : bus or transporter in tload\n", TiMe);
	goto l_99;
	/* */
l_4400:  
	fprintf (nunit2, "\n\n+++++ tload :  t=%12.4f ERROR  : negative loading TiMe %8.2f\n", TiMe, local_TiMe);
l_99:    
	return(FEHLER);
	/* */
}


