static char *SccsId = "@(#)PEPSY:\ttpark.c\t1.3\t92/03/27 11:59:24";
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	tpark()
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	/*     ***  */
	/*     *** CALL TPARK(*9000,*9999) */
	/*     ***  */
	/*     *** PURPOSE : PARK A TAXI ON COMPLETION OF A TASK */
	/*     *** PARAMETERS: *9000 = EXIT TO FLOW CONTROL */
	/*     ***             *9999 = ERROR EXIT */
	/*     ***  */
	/* */

	int	nterm, itargp, k,  nact, line, np, ncar, blocnr;
	extern int	block(), dblock(), tchain(), find(), policy(), next_int();
	short	found, trace;


#ifdef DEBUG
dprint(TRANSACTION, "tpark: keine prameter\n"); /* */
#endif

	/*     TEST FOR ERRORS */
	/*     =============== */
	ncar = next_int(txadd[row_txact][1]);
	if (ncar == 0)                         
		goto l_4000;
	if (txi[row_txact] != 2)               
		goto l_4100;
	nterm  = next_int(carma[ncar][6]);
	itargp = next_int(tarma[ncar][3]);
	if (itargp != 0 && itargp != nterm)    
		goto l_4200;
	/* */
	/*     INITIALIZE */
	/*     ========== */
	k     = offset.park + nterm - 1;
	trace = ((iprint == 1 || jprint[23] > 0) && jprint[23] != -1);
	/* */
	/*     ARE THERE TASKS TO BE PERFORMED? */
	/*     ================================ */
#ifdef DEBUG
dprint(TRANSACTION, "tpark: call find\n"); /* */
#endif
	switch (find(ncar, &found)) {
	case FEHLER: 
		goto l_99;
	}
	if ( !found) {
		/* */
		/*     BLOCK TAXI */
		/*     ========== */
		tx_system[row_txact].t_block     = TiMe;
		activlist[row_txact].next = -(double)k;
		activlist[row_txact].target = 2.0;
		policy(14, nterm, 0, &line, &np);
		block(14, nterm, 0, line);
		if (trace) 
			fprintf (nunit2, "tpark :  t=%12.4f  taxi%4d parks at terminal%4d\n", TiMe, ncar, nterm);
		/* */
		if (kprint == 1) {
			nact = 26;
			fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[row_txact], ncar, nact, nterm);
		}
		/* */
		/*     COLLECTION OF STATISTICAL DATA: PARKING VEHICLES */
		/*     ================================================ */
		parkst[nterm][1] = parkst[nterm][1] + (parkst[nterm][2] - parkst[nterm][3]) * (TiMe - parkst[nterm][4]);
		parkst[nterm][2] = parkst[nterm][2] + 1;
		parkst[nterm][4] = TiMe;
		/* */
		/*     STATE: PARKING */
		/*     ============== */
		carma[ncar][7] = 0.0;
		/* */
		/*     HAS A BLOCKABLE SECTION BEEN TRAVERSED: POSSIBLY UNBLOCKED */
		/*     ========================================================== */
		blocnr = next_int(tarma[ncar][4]);
		if (blocnr > 0) {
			blocve[blocnr][2] = blocve[blocnr][2] + 1;
			if (trace) 
				fprintf (nunit2, "                         and frees blockable section%3d\n", blocnr);
			dblock(15, blocnr, 0, 1);
		}
	} /* */
	/* */
	else {
		/* */
		/*     NEW TASK FOUND */
		/*     ============== */
		carma[ncar][7]  = 2.0;
		carma[ncar][8]  = 1.0;
		activlist[row_txact].next  = TiMe;
		activlist[row_txact].target  = 2.0;
		switch ( tchain(3, row_txact) ) {
		case FEHLER: 
			goto l_99;
		}
		if (trace) 
			fprintf (nunit2, "tpark :  t=%12.4f  taxi%4d travels to new task\n", TiMe, ncar);
		if (kprint == 1) {
			nact = 21;
			fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[row_txact], ncar, nact, nterm);
		}
	}
	/* */
	/* */
l_90: 
	return(AUSGANG2);
	/* */
	/*     ERROR EXIT */
	/*     ========== */
l_4000:  
	fprintf (nunit2, "\n\n+++++ tpark :  t=%12.4f ERROR  : transaction attempts to park  \n", TiMe);
	goto l_99;
	/* */
l_4100:  
	fprintf (nunit2, "\n\n+++++ tpark :  t=%12.4f ERROR  : bus or transporter in tpark\n", TiMe);
	goto l_99;
	/* */
l_4200:  
	fprintf (nunit2, "\n\n+++++ tpark :  t=%12.4f ERROR  : at terminal%4d instead of required terminal%4d\n", TiMe, nterm,
	     itargp);
l_99:    
	return(FEHLER);
	/* */
}


