static char *SccsId = "@(#)PEPSY:\ttride.c\t1.8\t93/10/20 14:53:03";
#include <stdio.h>
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"
#include <math.h>
#include <string.h>


int	tride(istart, itarg)
int	istart;
int	itarg;
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	/*     ***  */
	/*     *** CALL TRIDE(ISTART,ITARG,*9000,*9999) */
	/*     ***  */
	/*     *** PURPOSE : DRIVE A TAXI FROM ISTART TO ITARG WITHOUT */
	/*     ***           A FIXED ROUTE USING WEIGTHED DISTANCES */
	/*     ***           FROM "GESGEW" OR ALONG A GIVEN ROUTE */
	/*     *** PARAMETERS: ISTART = STARTING POINT OF THE TAXI */
	/*     ***             ITARG  = DESTINATION OF THE TAXI */
	/*     ***             *9000  = EXIT TO FLOW CONTROL */
	/*     ***             *9999  = ERROR EXIT */
	/*     ***  */
	/* */
	int	art, blocnr, bloc2, from, i, ncar, partnr, routnr, sectnr, segm, segmnr;
	int	k, lastbl, line, nact, np, nnode, nsegm;
	short	printf;
	char	cf;
	float	local_TiMe, fnode;
	extern int	lotse(), block(), dblock(), next_int(), tchain(), policy();


#ifdef DEBUG
dprint(TRANSACTION, "tride: istart %d, itarg %d\n", istart, itarg); /* */
#endif

	/*     TEST FOR ERRORS */
	/*     =============== */
	ncar  = next_int(txadd[row_txact][1]);
	if (ncar == 0)                      
		goto l_4000;
	if (txi[row_txact] != 2)            
		goto l_4100;
	if (itarg < 1 || itarg > ansta)     
		goto l_4300;
	/* */
	/*     INITIALIZE */
	/*     ========== */
	printf =  FALSE;
	routnr = next_int(tarma[ncar][5]);
	/* */
	/*     INITIALIZE FOR FIXED ROUTE */
	/*     ========================== */
	if (routnr != 0) {
		segm   = next_int(tarma[ncar][6]);
		segmnr = routma[routnr][segm];
	} else {
		/* */
		/*     INITIALIZE FOR VARIABLE ROUTE */
		/*     ============================= */
		segmnr = next_int(tarma[ncar][6]);
	}
	partnr = next_int(tarma[ncar][7]);
	if ( partnr != 0 && tarma[ncar][4] >= 0.0 && 
	    (iprint == 1 || jprint[23] == 1) && jprint[23] > -1 ) {
		fprintf (nunit2, "tride :  t=%12.4f  taxi%4d leaves section%4d\n", TiMe, ncar, segma[segmnr][partnr]);
		printf =  TRUE;
	}
	if (routnr != 0) 
		goto l_400;
	if (segmnr != 0) 
		goto l_100;
	/* */
	/*     BEGINNING OF A TRANSPORT : IS THE ROUTE FIXED ? */
	/*     =============================================== */
	routnr = 0;
	for (i = 1; i <= zrout; i++)  {
		if (courma[i][1] == istart && courma[i][2]  == itarg) {
			routnr = courma[i][3];
		}
	}
	if (routnr == 0) {
		if (istart != next_int(carma[ncar][6])) 
			goto l_4400;
		goto l_200;
	}
	/* */
	/*     PREPARE FOR FIXED ROUTE  */
	/*     =======================  */
	tarma[ncar][5] = (double)routnr;
	segm          = 0;
	partnr        = 0;
	/* */
	goto l_400;
	/* */
	/*     PROCESS SEGMENT : VARIABLE ROUTE */
	/*     =================================== */
l_100: 
#ifdef DEBUG
dprint(LABEL, "tride: label l_100\n"); /* */
#endif
	partnr = partnr + 1;
	if (partnr <= zsegm1 && segma[segmnr][partnr] != 0) 
		goto l_500;
	/* */
	/*     END OF SECTION REACHED?  */
	/*     =======================  */
l_200: 
#ifdef DEBUG
dprint(LABEL, "tride: label l_200\n"); /* */
#endif
	from = next_int(carma[ncar][6]);
	art  = next_int(carma[ncar][6] * 10.) - from * 10;
	if (art == 1) {
		if (from == itarg) 
			goto l_2000;
	} else if (art == 2) {
		from = from + ansta;
	} else {
		goto l_4200;
	}
	/* */
	/*     FIND NEW SEGMENT : VARIABLE ROUTE  */
	/*     =================================  */
	switch (lotse(from, itarg, &segmnr))  {
	case FEHLER: 
		goto l_99;
	}
	tarma[ncar][7] = 0.;
	partnr        = 0;
	/* */
	/*     COLLECTION OF STATISTICAL DATA: OCCUPATION OF NETWORK  */
	/*     =====================================================  */
	netsta[segmnr][3] = netsta[segmnr][3] + 1.;
	/* */
	/*     OUTPUT */
	/*     ====== */
	if ((iprint == 1 || jprint[23] == 1 || jprint[23] == 2) && 
	    jprint[23] != -1 && jprint[23] != -2) {
		i = 0;
l_900: 
#ifdef DEBUG
dprint(LABEL, "tride: label l_200\n"); /* */
#endif
		i = i + 1;
		if (i <= zsegm1 && segma[segmnr][i] != 0) 
			goto l_900;
		fnode = sectma[segma[segmnr][i-1]][2];
		nnode = next_int(fnode);
		cf = 'b';
		if ((next_int(fnode * 10.) - nnode * 10) == 1)  
			cf = 't';
		if (itarg == nnode && 't' == cf) {
			if (printf) {
				fprintf (nunit2, "                         and traverses segment%4d to terminal%4d\n", segmnr,
				     itarg);
			} else {
				fprintf (nunit2, "tride :  t=%12.4f  taxi%4d traverses segment%4d to termianl%4d\n", TiMe,
				     ncar, segmnr, itarg);
			}
		} else {
			if (printf) {
				fprintf (nunit2, "                         and traverses segment%4d to terminal%4d via  %1s%4d\n",
				     segmnr, itarg, cf, nnode);
			} else {
				fprintf (nunit2, "tride :  t=%12.4f  taxi%4d traverses segment%4d to terminal%4d\n                                   via  %1s%4d\n",
				     TiMe, ncar, segmnr, itarg, cf, nnode);
			}
		}
		printf =  TRUE;
	}
	/* */
	goto l_100;
	/* */
	/*     FIND NEXT SECTION FOR FIXED ROUTE  */
	/*     =================================  */
l_400: 
#ifdef DEBUG
dprint(LABEL, "tride: label l_200\n"); /* */
#endif
	partnr = partnr + 1;
	if (segm != 0   && partnr <= zsegm1 && segma[segmnr][partnr] != 0) 
		goto l_500;
	/*     PROCESS SEGMENT */
	/*     =============== */
	partnr = 1;
	segm = segm + 1;
	tarma[ncar][7] = 0.;
	/* */
	/*     IS JOURNEY COMPLETE? */
	/*     ==================== */
	if (segm > zrout1 || routma[routnr][segm] == 0) 
		goto l_2000;
	/* */
	/*     COLLECTION OF STATISTICAL DATA: OCCUPATION OF NETWORK  */
	/*     =====================================================  */
	segmnr = routma[routnr][segm];
	netsta[segmnr][3] = netsta[segmnr][3] + 1.;
	/* */
	/*     OUTPUT */
	/*     ====== */
	if ((iprint == 1 || jprint[23] == 1 || jprint[23] == 2) && 
	    jprint[23] != -1 && jprint[23] != -2) {
		nsegm = routma[routnr][segm+1];
		if (segm + 1 <= zrout1 && nsegm != 0) {
			fnode = sectma[segma[nsegm][0]][1];
			nnode = next_int(fnode);
			cf='b';
			if ((next_int(fnode * 10.) - nnode * 10) == 1)  
				cf='t';
			if (itarg == nnode && cf=='t') {
				if (printf) {
					fprintf (nunit2, "                         and traverses segment%4d to terminal%4d\n",
					     segmnr, itarg);
				} else {
					fprintf (nunit2, "tride :  t=%12.4f  taxi%4d traverses segment%4d to terminal%4d\n",
					     TiMe, ncar, segmnr, itarg);
				}
			} else {
				if (printf) {
					fprintf (nunit2, "                         and traverses segment%4d to terminal%4d via  %1s%4d\n",
					     segmnr, itarg, cf, nnode);
				} else {
					fprintf (nunit2, "tride :  t=%12.4f  taxi%4d traverses segment%4d to terminal%4d\n                                   via  %1s%4d\n",
					     TiMe, ncar, segmnr, itarg, cf, nnode);
				}
			}
		} else {
			if (printf) {
				fprintf (nunit2, "                         and traverses segment%4d to terminal%4d\n", segmnr,
				     itarg);
			} else {
				fprintf (nunit2, "tride :  t=%12.4f  taxi%4d traverses segment%4d to terminal%4d\n", TiMe,
				     ncar, segmnr, itarg);
			}
		}
		printf =  TRUE;
	}
	/* */
l_500: 
#ifdef DEBUG
dprint(TRANSACTION, "tride: label l_500\n"); /* */
#endif
	sectnr = segma[segmnr][partnr];
	blocnr = next_int(sectma[sectnr][4]);
	if (routnr != 0) {
		tarma[ncar][6] = (double)segm;
	} else {
		tarma[ncar][6] = (double)segmnr;
	}
	/* */
	/*     COLLECTION OF STATISTICAL DATA: WAS TAXI BLOCKED AT A SECTION */
	/*     ============================================================= */
	if (tarma[ncar][4] < 0) {
		tarma[ncar][4]  = fabs(tarma[ncar][4]);
		statis[ncar][4] = statis[ncar][4] + TiMe - tx_system[row_txact].t_block;
		if (next_int(carma[ncar][4]) == 0) {
			statis[ncar][1] = statis[ncar][1] + 
			    TiMe - tx_system[row_txact].t_block;
		} else {
			statis[ncar][2] = statis[ncar][2] + 
			    TiMe - tx_system[row_txact].t_block;
			statis[ncar][7] = statis[ncar][7] + carma[ncar][4] * 
			    (TiMe - tx_system[row_txact].t_block);
		}
		/* */
		netsta[segmnr][4] = netsta[segmnr][4] + TiMe - 
		    tx_system[row_txact].t_block;
		/* */
		blocst[sectnr][1] = blocst[sectnr][1] + 
		    (blocst[sectnr][2] - blocst[sectnr][3]) * 
		    (TiMe - blocst[sectnr][4]);
		blocst[sectnr][3] = blocst[sectnr][3] + 1;
		blocst[sectnr][4] = TiMe;
		/* */
	}
	/* */
	/*     IS THE NEXT SECTION TO BE TRAVERSED BLOCKABLE ? */
	/*     =============================================== */
	lastbl = next_int(tarma[ncar][4]);
	tarma[ncar][4] = 0.;
	/* */
	/*     OCCUPY BLOCKABLE SECTION */
	/*     ======================== */
	if (blocnr != 0) {
		tarma[ncar][4] = (double)blocnr;
		if (lastbl != blocnr) {
			if (blocve[blocnr][1] == 0 && blocve[blocnr][2] != 0) {
				blocve[blocnr][2] = blocve[blocnr][2] - 1;
				if ((iprint == 1 || jprint[23] == 1 || jprint[23] == 2) && 
				    jprint[23] != -1 && jprint[23] != -2) {
					bloc2 = blocve[blocnr][2];
					if (bloc2 == 0) {
						if (printf) {
							fprintf (nunit2, "                         and blocks blockable section%4d\n",
							     blocnr);
						} else {
							fprintf (nunit2, "tride :  t=%12.4f  taxi%4d blocks blockable section%4d\n",
							     TiMe, ncar, blocnr);
						}
					} else {
						if (printf) {
							fprintf (nunit2, "                         and blocks blockable section%4d ( remaining free capacity :%4d )\n",
							     blocnr, bloc2);
						} else {
							fprintf (nunit2, "tride :  t=%12.4f  taxi%4d blocks blockable section%4d\n                                   ( remaining free capacity:%4d )\n",
							     TiMe, ncar, blocnr, bloc2);
						}
					}
					printf =  TRUE;
				}
			} else {
				goto l_1000;
			}
		}
	}
	/* */
	/*     HAS A BLOCKABLE SECTION BEEN TRAVERSED: POSSIBLY UNBLOCK */
	/*     ======================================================== */
	if (lastbl != 0 && lastbl != blocnr) {
		blocve[lastbl][2] = blocve[lastbl][2] + 1;
		bloc2 = blocve[lastbl][2];
		if ((iprint == 1 || jprint[23] == 1 || jprint[23] == 2) && 
		    jprint[23] != -1 && jprint[23] != -2) {
			if (bloc2 == 1) {
				if (printf) {
					fprintf (nunit2, "                         and frees blockable section%4d\n", lastbl);
				} else {
					fprintf (nunit2, "tride :  t=%12.4f  taxi%4d frees blockable section%4d\n", TiMe,
					     ncar, lastbl);
				}
			} else {
				if (printf) {
					fprintf (nunit2, "                         and frees blockable section%4d ( unused capacity :%4d )\n",
					     lastbl, bloc2);
				} else {
					fprintf (nunit2, "tride :  t=%12.4f  taxi%4d frees blockable section%4d\n                                   ( unused capacity :%4d )\n",
					     TiMe, ncar, lastbl, bloc2);
				}
			}
		}
		if (blocve[lastbl][1] == 0 && bloc2 == 1) 
			dblock(15, lastbl, 0, 1);
	}
	/* */
	/*     TRAVERSE SECTION */
	/*     ================ */
	tarma[ncar][7] = (double)partnr;
	local_TiMe = fabs(sectma[sectnr][3]) / ((carma[ncar][5] * sectma[sectnr][5]));
	carma[ncar][6] = sectma[sectnr][2];
	if (kprint == 1) {
		nact = 23;
		fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[row_txact], ncar, nact, sectnr);
		fprintf (nunit23, "%4d%12.4f\n", next_int(carma[ncar][4]), local_TiMe);
	}
	/* */
	/*     COLLECTION OF STATISTICAL DATA:  */
	/*     =============================== */
	/*     DURATION OF JOURNEY AND OCCUPATION OF NETWORK */
	/*     ============================================= */
	if (next_int(carma[ncar][4]) > 0) {
		statis[ncar][2] = statis[ncar][2] + local_TiMe;
		statis[ncar][7] = statis[ncar][7] + carma[ncar][4] * local_TiMe;
		statis[ncar][9] = statis[ncar][9] + fabs(sectma[sectnr][3]);
	} else {
		statis[ncar][1] = statis[ncar][1] + local_TiMe ;
		statis[ncar][8] = statis[ncar][8] + fabs(sectma[sectnr][3]);
	}
	/* */
	netsta[segmnr][4] = netsta[segmnr][4] + local_TiMe;
	/* */
	/*     ACTUAL MOTION  */
	/*     =============  */
	activlist[row_txact].next = TiMe + local_TiMe;
	activlist[row_txact].target = 2.;
	tchain(3, row_txact);
	goto l_90;
	/* */
	/*     BLOCKABLE SECTION IS BLOCKED: BLOCK THE TAXI */
	/*     ============================================ */
l_1000: 
#ifdef DEBUG
dprint(TRANSACTION, "tride: label l_1000\n"); /* */
#endif
	tarma[ncar][4] = -(double)lastbl - 0.1;
	tx_system[row_txact].t_block = local_TiMe;
	k = offset.match + zmatch + zsta + zsta + blocnr - 1;
	activlist[row_txact].next = -(double)k;
	activlist[row_txact].target = 2. ;
	policy(15, blocnr, 0, &line, &np);
	block(15, blocnr, 0, line);
	if ((iprint == 1 || jprint[23] == 1 || jprint[23] == 2) && 
	    jprint[23] != -1 && jprint[23] != -2) {
		if (printf) {
			fprintf (nunit2, "                         and is blocked at blockable section%4d\n", blocnr);
		} else {
			fprintf (nunit2, "tride :  t=%12.4f  taxi%4d is blocked at section%4d\n", TiMe, ncar, blocnr);
		}
	}
	/* */
	if (kprint == 1) {
		nact = 27;
		fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[row_txact], ncar, nact, sectnr);
	}
	/* */
	/*     COLLECTION OF STATISTICAL DATA: BLOCKABLE SECTIONS */
	/*     ================================================== */
	blocst[sectnr][1] = blocst[sectnr][1] + 
	    (blocst[sectnr][2] - blocst[sectnr][2]) * 
	    (TiMe - blocst[sectnr][4]);
	blocst[sectnr][2] = blocst[sectnr][2] + 1;
	blocst[sectnr][4] = TiMe;
	/* */
	goto l_90;
	/* */
	/*     END OF A TRANSPORT: SCHEDULE TAXI  */
	/*     =================================  */
l_2000: 
#ifdef DEBUG
dprint(LABEL, "tride: label l_2000\n"); /* */
#endif
	carma[ncar][8] = carma[ncar][8] + 1.;
	tarma[ncar][5] = 0.;
	tarma[ncar][6] = 0.;
	tarma[ncar][7] = 0.;
	activlist[row_txact].next = TiMe;
	activlist[row_txact].target = 2.;
	switch ( tchain(3, row_txact) )  {
	case FEHLER: 
		goto l_99;
	}
	if (kprint == 1) {
		nact = 28;
		fprintf (nunit23, "%12.4f%4d%4d%4d%4d\n", TiMe, txi[row_txact], ncar, nact, itarg);
	}
	/* */
l_90: 
	return(AUSGANG2);
	/* */
	/*     ERROR EXIT */
	/*     ========== */
l_4000:  
	fprintf (nunit2, "\n\n+++++ tride :  t=%12.4f ERROR  : transaction which is no vehicle to travel\n", TiMe);
	goto l_99;
	/* */
l_4100:  
	fprintf (nunit2, "\n\n+++++ tride :  t=%12.4f ERROR  : bus or transporter in tride\n", TiMe);
	goto l_99;
	/* */
l_4200:  
	fprintf (nunit2, "\n\n+++++ tride :  t=%12.4f ERROR  : taxi stops at point%4d\n", TiMe, from);
	goto l_99;
	/* */
l_4300:  
	fprintf (nunit2, "\n\n+++++ tride :  t=%12.4f ERROR  : invalid destination %4d\n", TiMe, itarg);
	goto l_99;
	/* */
l_4400:  
	fprintf (nunit2, "\n\n+++++ tride :  t=%12.4f ERROR  : starting point does not agree with actual position\n", TiMe);
l_99: 
	return(FEHLER);
	/* */
}


