static char *SccsId = "@(#)PEPSY:\ttstart.c\t1.2\t92/03/27 11:59:34";
#include <stdio.h>
#include <fcntl.h>
#include "gpss_prepare.h"
#include "gpss_decl.h"


int	tstart(nsc, tsc, idg, itype)
int	nsc, idg, itype;
float	tsc;
/* Hier ist mindestens ein alternativer Ruecksprung zu beruecksichtigen */
{
	/*     ***  */
	/*     *** CALL TSTART(NSC,TSC,IDG,ITYPE,EXIT1) */
	/*     ***  */
	/*     *** PURPOSE : SCHEDULE, ALTER, OR CLOSE DOWN A SOURCE  */
	/*     ***           GENERATING VEHICLES  */
	/*     *** PARAMETERS: NSC   = INDEX OF SOURCE */
	/*     ***             TSC   = START TIME */
	/*     ***                     >= 0: SCHEDULE OR ALTER */
	/*     ***                     <  0: CLOSE DOWN */
	/*     ***             IDG   = LABEL OF CORRESPONDING CALL OF */
	/*     ***                     THE SUBROUTINE BGEN, TGEN OR GGEN */
	/*     ***             ITYPE = TYPE OF VEHICLE */
	/*     ***                      1 : BUS */
	/*     ***                      2 : TAXI  */
	/*     ***                      3 : TRANSPORTER */
	/*     ***             EXIT1 = ERROR EXIT */
	/*     ***  */
	/* */

	char	ctype[4][13];
	extern int	nchain(), tchain();

	strcpy(ctype[1], "    bus     ");
	strcpy(ctype[2], "   taxi     ");
	strcpy(ctype[3], "transporter ");
	/* */
	/*     ERROR CHECKING */
	/*     ============== */
	if (itype < 1 || itype > 3)  
		goto l_4000;
	if (nsc > zsrc)              
		goto l_4100;
	/* */
	/*     SCHEDULE ACTIVATION OF TSOURCE */
	/*     ============================== */
	nchain(2, nsc);
	if (tsc > -eps) {
		sourcelist[nsc].next   = tsc;
		sourcelist[nsc].target   = idg;
		sourcelist[nsc].sourci = itype;
		tchain(2, nsc);
		if ((iprint == 1 || jprint[13] == 1) && jprint[13] != -1)
			fprintf (nunit2, "tstart:  source %3d is scheduled for t=%12.4f   ( %11s )\n",  nsc, tsc, ctype[itype]);
		/*     CLOSE DOWN TSOURCE */
		/*     ================= */
	} else {
		if ((iprint == 1 || jprint[13] == 1) && jprint[13] != -1)
			fprintf (nunit2, "tstart:  source %3d is closed down   ( %11s )\n",  nsc, ctype[itype]);
	}
	/* */
	/* */
	return(NORMAL);
	/* */
	/*     ERROR MASSAGES */
	/*     ============== */
l_4000:  
	fprintf (nunit2, "\n\n+++++ tstart: T=%12.4f erroneous source mode %3d\n", TiMe, nsc);
	goto l_99;
	/* */
l_4100:  
	fprintf (nunit2, "\n\n+++++ tstart: t=%12.4f erroneous source number %3d\n", TiMe, nsc);
	/* */
l_99:    
	return(FEHLER);
}


