static char *SccsId = "@(#)PEPSY:\tintschacht.c\t1.2\t92/03/27 12:01:47";
/*

	                     P E P S Y 

		  Performance and Evaluation Prediction System

	Copyright 1987, 1988
	
			  Universitaet Erlangen-Nuernberg,
			  Lehrstuhl fuer Betriebssysteme
			  Martensstrasse 1

			  8520 Erlangen

	Alle Rechte, einschliesslich Verfilmung und Vertonung, vorbehalten.
	PEPSY darf ohne Erlaubnis der Verfasser nicht in Lesezirkeln
	gefuehrt werden.

*/


# define LOCAL
# include "initsave.h"

# define PO  ((pow(util,(double)bedeinh)+util)/2.0) 
# define PI  (pow(util,(((double)bedeinh+1)/2.0)))   

# define A   ((cb*cb+1.0)/2.0)

# define TYP1  /* M/M/m-FCFS */ \
	( util / ( 1.0 - util + util / ((double)auftr - bedeinh) ))
# define TYP2 /* M/M/1-FCFS */\
	(util/(1.0-(((double)auftr-1.0)/(double)auftr)*util))
# define TYP3 /* M/G/0-IS */\
	(util*bedeinh)
# define TYP4 /* M/G/1-LCFS */ \
	TYP2
# define TYP5 /* M/G/1-FCFS */ \
	(util + (util / (1.0 - util + A / (double)auftr * util)) * A)
# define TYP6 /* M/G/m-FCFS */ \
	( (util / (1.0 - util + A / ((double)auftr - (double)bedeinh) * util)) * A)


/* Funktion: bestimmen des Minimums in einem Feld  */
min (feld,laenge)  
float feld[];
int laenge;

{ 
	int i;
	int c;

	c = 0;	
	for ( i = 1 ; i < laenge  ; i++ ) {
		c = (feld[c] < feld[i] ? c : i );
	}
	return(c);
}

/* Funktion: Berechnung der Anzahl der Benutzer in einem
             knoten (vom TYP 1,2,3  oder 4) aus der Zahl
		     der Bedieneinheiten und und der Auslastung */
             	
double 
funkt(util,knoten,bedeinh,cb)
float util, cb;
int knoten, bedeinh;

{
	double lambda , nenner ;
	extern int auftr;

	switch (knoten) {
		case 1  : if (util > 0.7 )
				lambda = (double)bedeinh*util + TYP1 * PO ;
			  else  
				lambda = (double)bedeinh*util + TYP1 * PI ;
			  break;
		case 2  : lambda = TYP2 ; 
			  break;
		case 3  : lambda = TYP3 ;
			  break;
		case 4  : lambda = TYP4 ;
			  break;
		case 5  : lambda = TYP5 ;
			  break;
		case 6  : if (util > 0.7 )
				lambda = (double)bedeinh*util + TYP6 * PO ;
			  else  
				lambda = (double)bedeinh*util + TYP6 * PI ;
			  break;
	}
	return(lambda);
}

void abbruch(sig)
int sig;
{
        printf("sum_signal_%d\n 0 0 0 \n", sig);
        exit(1);
}
 
main(argc,argv)
int argc;
char *argv[];

{
	/*		Sccs support from SccsLogging.c			*/	
	extern int SccsRelease;
	extern int SccsLevel;

	int  i;
	extern int einlesen(),ausgeben();
	double funkt();
	char zeile[80], junk;
	double low, high;
	float rho[ANZKN] ;
 	float lamup[ANZKN];
	float lambold;

  {
        int i;
        void abbruch();

        for (i=1; i<12; i++)
                signal (i, abbruch);
  }
		if ((argc > 1) && (!strcmp(argv[1], "-V")))    /* kirschni 22.11.1991 */
		{
			fprintf(stdout, "%s Version %d.%d\n", argv[0], SccsRelease, SccsLevel);
			exit(0);
		}


einlesen(argc,argv);


/* Intervallschachtelung zur Bestimmung von Lambda */

	for (i = 0; i < kn ; i++)
		lamup[i] = node[i].servers * node[i].sevrate /
		           node[i].visits;
	zaehler = 1;
	low = 0;
	high = lamup [min(lamup,kn)];	
	lambda = (low + high)/2;

	for (i = 0; i < kn ; i++ ) {
		rho[i] = lambda * node[i].visits /
			(node[i].servers * node[i].sevrate);
	}

	k = 0 ;
	for (i = 0; i < kn ; i++)
		k = k + funkt(rho[i],node[i].typ,node[i].servers,node[i].cb);

	while ( k < (1 - EPSILON)*auftr || k > (1 + EPSILON)*auftr ) {
		for (i = 0; i < kn ; i++ )
		if ( rho[i] == 1 )
			goto endwhile;
		zaehler = zaehler + 1;
		if ( k > auftr )
			high = lambda;
		else
			low = lambda;
		lambold = lambda;
		lambda = (low + high)/2;
		if (lambda == lambold) goto endwhile;
		for (i = 0; i < kn ; i++ ) {
			rho[i] = lambda * node[i].visits /
				(node[i].servers * node[i].sevrate);
		}
		k = 0;
		for (i = 0; i < kn ; i++ )
         k = k + funkt(rho[i],node[i].typ,node[i].servers,node[i].cb);
	}
	endwhile:
	

/* Berechnung der restlichen Leistungsgroessen */
	for (i = 0; i < kn ; i++ ) {
		leistung[i].durchsatz = lambda * node[i].visits;
		leistung[i].auslast = leistung[i].durchsatz / 
			      (node[i].servers * node[i].sevrate);
		leistung[i].users = funkt(leistung[i].auslast
		 ,node[i].typ,node[i].servers,node[i].cb);
		leistung[i].response = leistung[i].users /
				       leistung[i].durchsatz ;
	}
ausgeben();
exit(0);
}
